/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/base/common/errors","vs/base/common/lifecycle","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/event","vs/base/common/assert","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/types","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/editor/common/diff/linesDiffComputers","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],x=function(q){for(var n=[],R=0,t=q.length;R<t;R++)n[R]=J[q[R]];return n},Ue=this,Oe=typeof global=="object"?global:{},le;(function(q){q.global=Ue;var n=function(){function R(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(R.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),R.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=R._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof q.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},R._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},R}();q.Environment=n})(le||(le={}));var le;(function(q){var n=function(){function F(l,y,m){this.type=l,this.detail=y,this.timestamp=m}return F}();q.LoaderEvent=n;var R=function(){function F(l){this._events=[new n(1,"",l)]}return F.prototype.record=function(l,y){this._events.push(new n(l,y,q.Utilities.getHighPerformanceTimestamp()))},F.prototype.getEvents=function(){return this._events},F}();q.LoaderEventRecorder=R;var t=function(){function F(){}return F.prototype.record=function(l,y){},F.prototype.getEvents=function(){return[]},F.INSTANCE=new F,F}();q.NullLoaderEventRecorder=t})(le||(le={}));var le;(function(q){var n=function(){function R(){}return R.fileUriToFilePath=function(t,F){if(F=decodeURI(F).replace(/%23/g,"#"),t){if(/^file:\/\/\//.test(F))return F.substr(8);if(/^file:\/\//.test(F))return F.substr(5)}else if(/^file:\/\//.test(F))return F.substr(7);return F},R.startsWith=function(t,F){return t.length>=F.length&&t.substr(0,F.length)===F},R.endsWith=function(t,F){return t.length>=F.length&&t.substr(t.length-F.length)===F},R.containsQueryString=function(t){return/^[^\#]*\?/gi.test(t)},R.isAbsolutePath=function(t){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(t)},R.forEachProperty=function(t,F){if(t){var l=void 0;for(l in t)t.hasOwnProperty(l)&&F(l,t[l])}},R.isEmpty=function(t){var F=!0;return R.forEachProperty(t,function(){F=!1}),F},R.recursiveClone=function(t){if(!t||typeof t!="object"||t instanceof RegExp||!Array.isArray(t)&&Object.getPrototypeOf(t)!==Object.prototype)return t;var F=Array.isArray(t)?[]:{};return R.forEachProperty(t,function(l,y){y&&typeof y=="object"?F[l]=R.recursiveClone(y):F[l]=y}),F},R.generateAnonymousModule=function(){return"===anonymous"+R.NEXT_ANONYMOUS_ID+++"==="},R.isAnonymousModule=function(t){return R.startsWith(t,"===anonymous")},R.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=q.global.performance&&typeof q.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?q.global.performance.now():Date.now()},R.NEXT_ANONYMOUS_ID=1,R.PERFORMANCE_NOW_PROBED=!1,R.HAS_PERFORMANCE_NOW=!1,R}();q.Utilities=n})(le||(le={}));var le;(function(q){function n(F){if(F instanceof Error)return F;var l=new Error(F.message||String(F)||"Unknown Error");return F.stack&&(l.stack=F.stack),l}q.ensureError=n;var R=function(){function F(){}return F.validateConfigurationOptions=function(l){function y(a){if(a.phase==="loading"){console.error('Loading "'+a.moduleId+'" failed'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}if(a.phase==="factory"){console.error('The factory function of "'+a.moduleId+'" has thrown an exception'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError>"u"&&(l.catchError=!1),typeof l.recordStats>"u"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=y),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(q.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags>"u"&&(l.preferScriptTags=!1),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var m=n(new Error("INVALID cached data configuration, 'path' MUST be set"));m.phase="configuration",l.onError(m),l.nodeCachedData=void 0}return l},F.mergeConfigurationOptions=function(l,y){l===void 0&&(l=null),y===void 0&&(y=null);var m=q.Utilities.recursiveClone(y||{});return q.Utilities.forEachProperty(l,function(a,h){a==="ignoreDuplicateModules"&&typeof m.ignoreDuplicateModules<"u"?m.ignoreDuplicateModules=m.ignoreDuplicateModules.concat(h):a==="paths"&&typeof m.paths<"u"?q.Utilities.forEachProperty(h,function(A,_){return m.paths[A]=_}):a==="config"&&typeof m.config<"u"?q.Utilities.forEachProperty(h,function(A,_){return m.config[A]=_}):m[a]=q.Utilities.recursiveClone(h)}),F.validateConfigurationOptions(m)},F}();q.ConfigurationOptionsUtil=R;var t=function(){function F(l,y){if(this._env=l,this.options=R.mergeConfigurationOptions(y),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var m=this.options.nodeRequire.main.filename,a=Math.max(m.lastIndexOf("/"),m.lastIndexOf("\\"));this.options.baseUrl=m.substring(0,a+1)}}return F.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},F.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],q.Utilities.forEachProperty(this.options.paths,function(y,m){Array.isArray(m)?l.sortedPathsRules.push({from:y,to:m}):l.sortedPathsRules.push({from:y,to:[m]})}),this.sortedPathsRules.sort(function(y,m){return m.from.length-y.from.length})},F.prototype.cloneAndMerge=function(l){return new F(this._env,R.mergeConfigurationOptions(l,this.options))},F.prototype.getOptionsLiteral=function(){return this.options},F.prototype._applyPaths=function(l){for(var y,m=0,a=this.sortedPathsRules.length;m<a;m++)if(y=this.sortedPathsRules[m],q.Utilities.startsWith(l,y.from)){for(var h=[],A=0,_=y.to.length;A<_;A++)h.push(y.to[A]+l.substr(y.from.length));return h}return[l]},F.prototype._addUrlArgsToUrl=function(l){return q.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},F.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},F.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var y=0,m=l.length;y<m;y++)l[y]=this._addUrlArgsToUrl(l[y]);return l},F.prototype.moduleIdToPaths=function(l){if(this._env.isNode){var y=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(y)return this.isBuild()?["empty:"]:["node|"+l]}var m=l,a;if(!q.Utilities.endsWith(m,".js")&&!q.Utilities.isAbsolutePath(m)){a=this._applyPaths(m);for(var h=0,A=a.length;h<A;h++)this.isBuild()&&a[h]==="empty:"||(q.Utilities.isAbsolutePath(a[h])||(a[h]=this.options.baseUrl+a[h]),!q.Utilities.endsWith(a[h],".js")&&!q.Utilities.containsQueryString(a[h])&&(a[h]=a[h]+".js"))}else!q.Utilities.endsWith(m,".js")&&!q.Utilities.containsQueryString(m)&&(m=m+".js"),a=[m];return this._addUrlArgsIfNecessaryToUrls(a)},F.prototype.requireToUrl=function(l){var y=l;return q.Utilities.isAbsolutePath(y)||(y=this._applyPaths(y)[0],q.Utilities.isAbsolutePath(y)||(y=this.options.baseUrl+y)),this._addUrlArgsIfNecessaryToUrl(y)},F.prototype.isBuild=function(){return this.options.isBuild},F.prototype.shouldInvokeFactory=function(l){return!!(!this.options.isBuild||q.Utilities.isAnonymousModule(l)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[l])},F.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},F.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},F.prototype.shouldCatchError=function(){return this.options.catchError},F.prototype.shouldRecordStats=function(){return this.options.recordStats},F.prototype.onError=function(l){this.options.onError(l)},F}();q.Configuration=t})(le||(le={}));var le;(function(q){var n=function(){function a(h){this._env=h,this._scriptLoader=null,this._callbackMap={}}return a.prototype.load=function(h,A,_,N){var v=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new F;else if(this._env.isElectronRenderer){var e=h.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new R:this._scriptLoader=new l(this._env)}else this._env.isNode?this._scriptLoader=new l(this._env):this._scriptLoader=new R;var C={callback:_,errorback:N};if(this._callbackMap.hasOwnProperty(A)){this._callbackMap[A].push(C);return}this._callbackMap[A]=[C],this._scriptLoader.load(h,A,function(){return v.triggerCallback(A)},function(D){return v.triggerErrorback(A,D)})},a.prototype.triggerCallback=function(h){var A=this._callbackMap[h];delete this._callbackMap[h];for(var _=0;_<A.length;_++)A[_].callback()},a.prototype.triggerErrorback=function(h,A){var _=this._callbackMap[h];delete this._callbackMap[h];for(var N=0;N<_.length;N++)_[N].errorback(A)},a}(),R=function(){function a(){}return a.prototype.attachListeners=function(h,A,_){var N=function(){h.removeEventListener("load",v),h.removeEventListener("error",e)},v=function(C){N(),A()},e=function(C){N(),_(C)};h.addEventListener("load",v),h.addEventListener("error",e)},a.prototype.load=function(h,A,_,N){if(/^node\|/.test(A)){var v=h.getConfig().getOptionsLiteral(),e=y(h.getRecorder(),v.nodeRequire||q.global.nodeRequire),C=A.split("|"),D=null;try{D=e(C[1])}catch(b){N(b);return}h.enqueueDefineAnonymousModule([],function(){return D}),_()}else{var E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript"),this.attachListeners(E,_,N);var L=h.getConfig().getOptionsLiteral().trustedTypesPolicy;L&&(A=L.createScriptURL(A)),E.setAttribute("src",A);var d=h.getConfig().getOptionsLiteral().cspNonce;d&&E.setAttribute("nonce",d),document.getElementsByTagName("head")[0].appendChild(E)}},a}();function t(a){var h=a.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var A=h?self.eval(h.createScript("","true")):new Function("true");return A.call(self),!0}catch{return!1}}var F=function(){function a(){this._cachedCanUseEval=null}return a.prototype._canUseEval=function(h){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=t(h)),this._cachedCanUseEval},a.prototype.load=function(h,A,_,N){if(/^node\|/.test(A)){var v=h.getConfig().getOptionsLiteral(),e=y(h.getRecorder(),v.nodeRequire||q.global.nodeRequire),C=A.split("|"),D=null;try{D=e(C[1])}catch(d){N(d);return}h.enqueueDefineAnonymousModule([],function(){return D}),_()}else{var E=h.getConfig().getOptionsLiteral().trustedTypesPolicy,L=/^((http:)|(https:)|(file:))/.test(A)&&A.substring(0,self.origin.length)!==self.origin;if(!L&&this._canUseEval(h)){fetch(A).then(function(d){if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(function(d){d=d+`
//# sourceURL=`+A;var b=E?self.eval(E.createScript("",d)):new Function(d);b.call(self),_()}).then(void 0,N);return}try{E&&(A=E.createScriptURL(A)),importScripts(A),_()}catch(d){N(d)}}},a}(),l=function(){function a(h){this._env=h,this._didInitialize=!1,this._didPatchNodeRequire=!1}return a.prototype._init=function(h){this._didInitialize||(this._didInitialize=!0,this._fs=h("fs"),this._vm=h("vm"),this._path=h("path"),this._crypto=h("crypto"))},a.prototype._initNodeRequire=function(h,A){var _=A.getConfig().getOptionsLiteral().nodeCachedData;if(!_||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var N=this,v=h("module");function e(C){var D=C.constructor,E=function(d){try{return C.require(d)}finally{}};return E.resolve=function(d,b){return D._resolveFilename(d,C,!1,b)},E.resolve.paths=function(d){return D._resolveLookupPaths(d,C)},E.main=process.mainModule,E.extensions=D._extensions,E.cache=D._cache,E}v.prototype._compile=function(C,D){var E=v.wrap(C.replace(/^#!.*/,"")),L=A.getRecorder(),d=N._getCachedDataPath(_,D),b={filename:D},o;try{var i=N._fs.readFileSync(d);o=i.slice(0,16),b.cachedData=i.slice(16),L.record(60,d)}catch{L.record(61,d)}var s=new N._vm.Script(E,b),g=s.runInThisContext(b),c=N._path.dirname(D),p=e(this),w=[this.exports,p,this,D,c,process,Oe,Buffer],f=g.apply(this.exports,w);return N._handleCachedData(s,E,d,!b.cachedData,A),N._verifyCachedData(s,E,d,o,A),f}},a.prototype.load=function(h,A,_,N){var v=this,e=h.getConfig().getOptionsLiteral(),C=y(h.getRecorder(),e.nodeRequire||q.global.nodeRequire),D=e.nodeInstrumenter||function(g){return g};this._init(C),this._initNodeRequire(C,h);var E=h.getRecorder();if(/^node\|/.test(A)){var L=A.split("|"),d=null;try{d=C(L[1])}catch(g){N(g);return}h.enqueueDefineAnonymousModule([],function(){return d}),_()}else{A=q.Utilities.fileUriToFilePath(this._env.isWindows,A);var b=this._path.normalize(A),o=this._getElectronRendererScriptPathOrUri(b),i=Boolean(e.nodeCachedData),s=i?this._getCachedDataPath(e.nodeCachedData,A):void 0;this._readSourceAndCachedData(b,s,E,function(g,c,p,w){if(g){N(g);return}var f;c.charCodeAt(0)===a._BOM?f=a._PREFIX+c.substring(1)+a._SUFFIX:f=a._PREFIX+c+a._SUFFIX,f=D(f,b);var u={filename:o,cachedData:p},M=v._createAndEvalScript(h,f,u,_,N);v._handleCachedData(M,f,s,i&&!p,h),v._verifyCachedData(M,f,s,w,h)})}},a.prototype._createAndEvalScript=function(h,A,_,N,v){var e=h.getRecorder();e.record(31,_.filename);var C=new this._vm.Script(A,_),D=C.runInThisContext(_),E=h.getGlobalAMDDefineFunc(),L=!1,d=function(){return L=!0,E.apply(null,arguments)};return d.amd=E.amd,D.call(q.global,h.getGlobalAMDRequireFunc(),d,_.filename,this._path.dirname(_.filename)),e.record(32,_.filename),L?N():v(new Error("Didn't receive define call in "+_.filename+"!")),C},a.prototype._getElectronRendererScriptPathOrUri=function(h){if(!this._env.isElectronRenderer)return h;var A=h.match(/^([a-z])\:(.*)/i);return A?"file:///"+(A[1].toUpperCase()+":"+A[2]).replace(/\\/g,"/"):"file://"+h},a.prototype._getCachedDataPath=function(h,A){var _=this._crypto.createHash("md5").update(A,"utf8").update(h.seed,"utf8").update(process.arch,"").digest("hex"),N=this._path.basename(A).replace(/\.js$/,"");return this._path.join(h.path,N+"-"+_+".code")},a.prototype._handleCachedData=function(h,A,_,N,v){var e=this;h.cachedDataRejected?this._fs.unlink(_,function(C){v.getRecorder().record(62,_),e._createAndWriteCachedData(h,A,_,v),C&&v.getConfig().onError(C)}):N&&this._createAndWriteCachedData(h,A,_,v)},a.prototype._createAndWriteCachedData=function(h,A,_,N){var v=this,e=Math.ceil(N.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),C=-1,D=0,E=void 0,L=function(){setTimeout(function(){E||(E=v._crypto.createHash("md5").update(A,"utf8").digest());var d=h.createCachedData();if(!(d.length===0||d.length===C||D>=5)){if(d.length<C){L();return}C=d.length,v._fs.writeFile(_,Buffer.concat([E,d]),function(b){b&&N.getConfig().onError(b),N.getRecorder().record(63,_),L()})}},e*Math.pow(4,D++))};L()},a.prototype._readSourceAndCachedData=function(h,A,_,N){if(!A)this._fs.readFile(h,{encoding:"utf8"},N);else{var v=void 0,e=void 0,C=void 0,D=2,E=function(L){L?N(L):--D===0&&N(void 0,v,e,C)};this._fs.readFile(h,{encoding:"utf8"},function(L,d){v=d,E(L)}),this._fs.readFile(A,function(L,d){!L&&d&&d.length>0?(C=d.slice(0,16),e=d.slice(16),_.record(60,A)):_.record(61,A),E()})}},a.prototype._verifyCachedData=function(h,A,_,N,v){var e=this;!N||h.cachedDataRejected||setTimeout(function(){var C=e._crypto.createHash("md5").update(A,"utf8").digest();N.equals(C)||(v.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+_+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(_,function(D){D&&v.getConfig().onError(D)}))},Math.ceil(5e3*(1+Math.random())))},a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`,a}();function y(a,h){if(h.__$__isRecorded)return h;var A=function(N){a.record(33,N);try{return h(N)}finally{a.record(34,N)}};return A.__$__isRecorded=!0,A}q.ensureRecordedNodeRequire=y;function m(a){return new n(a)}q.createScriptLoader=m})(le||(le={}));var le;(function(q){var n=function(){function m(a){var h=a.lastIndexOf("/");h!==-1?this.fromModulePath=a.substr(0,h+1):this.fromModulePath=""}return m._normalizeModuleId=function(a){var h=a,A;for(A=/\/\.\//;A.test(h);)h=h.replace(A,"/");for(h=h.replace(/^\.\//g,""),A=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;A.test(h);)h=h.replace(A,"/");return h=h.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),h},m.prototype.resolveModule=function(a){var h=a;return q.Utilities.isAbsolutePath(h)||(q.Utilities.startsWith(h,"./")||q.Utilities.startsWith(h,"../"))&&(h=m._normalizeModuleId(this.fromModulePath+h)),h},m.ROOT=new m(""),m}();q.ModuleIdResolver=n;var R=function(){function m(a,h,A,_,N,v){this.id=a,this.strId=h,this.dependencies=A,this._callback=_,this._errorback=N,this.moduleIdResolver=v,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return m._safeInvokeFunction=function(a,h){try{return{returnedValue:a.apply(q.global,h),producedError:null}}catch(A){return{returnedValue:null,producedError:A}}},m._invokeFactory=function(a,h,A,_){return a.shouldInvokeFactory(h)?a.shouldCatchError()?this._safeInvokeFunction(A,_):{returnedValue:A.apply(q.global,_),producedError:null}:{returnedValue:null,producedError:null}},m.prototype.complete=function(a,h,A,_){this._isComplete=!0;var N=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);var v=m._invokeFactory(h,this.strId,this._callback,A);N=v.producedError,a.record(22,this.strId),!N&&typeof v.returnedValue<"u"&&(!this.exportsPassedIn||q.Utilities.isEmpty(this.exports))&&(this.exports=v.returnedValue)}else this.exports=this._callback;if(N){var e=q.ensureError(N);e.phase="factory",e.moduleId=this.strId,e.neededBy=_(this.id),this.error=e,h.onError(e)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},m.prototype.onDependencyError=function(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1},m.prototype.isComplete=function(){return this._isComplete},m}();q.Module=R;var t=function(){function m(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return m.prototype.getMaxModuleId=function(){return this._nextId},m.prototype.getModuleId=function(a){var h=this._strModuleIdToIntModuleId.get(a);return typeof h>"u"&&(h=this._nextId++,this._strModuleIdToIntModuleId.set(a,h),this._intModuleIdToStrModuleId[h]=a),h},m.prototype.getStrModuleId=function(a){return this._intModuleIdToStrModuleId[a]},m}(),F=function(){function m(a){this.id=a}return m.EXPORTS=new m(0),m.MODULE=new m(1),m.REQUIRE=new m(2),m}();q.RegularDependency=F;var l=function(){function m(a,h,A){this.id=a,this.pluginId=h,this.pluginParam=A}return m}();q.PluginDependency=l;var y=function(){function m(a,h,A,_,N){N===void 0&&(N=0),this._env=a,this._scriptLoader=h,this._loaderAvailableTimestamp=N,this._defineFunc=A,this._requireFunc=_,this._moduleIdProvider=new t,this._config=new q.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return m.prototype.reset=function(){return new m(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},m.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},m.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},m._findRelevantLocationInStack=function(a,h){for(var A=function(b){return b.replace(/\\/g,"/")},_=A(a),N=h.split(/\n/),v=0;v<N.length;v++){var e=N[v].match(/(.*):(\d+):(\d+)\)?$/);if(e){var C=e[1],D=e[2],E=e[3],L=Math.max(C.lastIndexOf(" ")+1,C.lastIndexOf("(")+1);if(C=C.substr(L),C=A(C),C===_){var d={line:parseInt(D,10),col:parseInt(E,10)};return d.line===1&&(d.col-=53),d}}}throw new Error("Could not correlate define call site for needle "+a)},m.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var a=[],h=0,A=0,_=this._modules2.length;A<_;A++){var N=this._modules2[A];if(!!N){var v=this._buildInfoPath[N.id]||null,e=this._buildInfoDefineStack[N.id]||null,C=this._buildInfoDependencies[N.id];a[h++]={id:N.strId,path:v,defineLocation:v&&e?m._findRelevantLocationInStack(v,e):null,dependencies:C,shim:null,exports:N.exports}}}return a},m.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new q.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=q.NullLoaderEventRecorder.INSTANCE),this._recorder},m.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},m.prototype.enqueueDefineAnonymousModule=function(a,h){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var A=null;this._config.isBuild()&&(A=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:A,dependencies:a,callback:h}},m.prototype.defineModule=function(a,h,A,_,N,v){var e=this;v===void 0&&(v=new n(a));var C=this._moduleIdProvider.getModuleId(a);if(this._modules2[C]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}var D=new R(C,a,this._normalizeDependencies(h,v),A,_,v);this._modules2[C]=D,this._config.isBuild()&&(this._buildInfoDefineStack[C]=N,this._buildInfoDependencies[C]=(D.dependencies||[]).map(function(E){return e._moduleIdProvider.getStrModuleId(E.id)})),this._resolve(D)},m.prototype._normalizeDependency=function(a,h){if(a==="exports")return F.EXPORTS;if(a==="module")return F.MODULE;if(a==="require")return F.REQUIRE;var A=a.indexOf("!");if(A>=0){var _=h.resolveModule(a.substr(0,A)),N=h.resolveModule(a.substr(A+1)),v=this._moduleIdProvider.getModuleId(_+"!"+N),e=this._moduleIdProvider.getModuleId(_);return new l(v,e,N)}return new F(this._moduleIdProvider.getModuleId(h.resolveModule(a)))},m.prototype._normalizeDependencies=function(a,h){for(var A=[],_=0,N=0,v=a.length;N<v;N++)A[_++]=this._normalizeDependency(a[N],h);return A},m.prototype._relativeRequire=function(a,h,A,_){if(typeof h=="string")return this.synchronousRequire(h,a);this.defineModule(q.Utilities.generateAnonymousModule(),h,A,_,null,a)},m.prototype.synchronousRequire=function(a,h){h===void 0&&(h=new n(a));var A=this._normalizeDependency(a,h),_=this._modules2[A.id];if(!_)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!_.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(_.error)throw _.error;return _.exports},m.prototype.configure=function(a,h){var A=this._config.shouldRecordStats();h?this._config=new q.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!A&&(this._recorder=null)},m.prototype.getConfig=function(){return this._config},m.prototype._onLoad=function(a){if(this._currentAnonymousDefineCall!==null){var h=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),h.dependencies,h.callback,null,h.stack)}},m.prototype._createLoadError=function(a,h){var A=this,_=this._moduleIdProvider.getStrModuleId(a),N=(this._inverseDependencies2[a]||[]).map(function(e){return A._moduleIdProvider.getStrModuleId(e)}),v=q.ensureError(h);return v.phase="loading",v.moduleId=_,v.neededBy=N,v},m.prototype._onLoadError=function(a,h){var A=this._createLoadError(a,h);this._modules2[a]||(this._modules2[a]=new R(a,this._moduleIdProvider.getStrModuleId(a),[],function(){},null,null));for(var _=[],N=0,v=this._moduleIdProvider.getMaxModuleId();N<v;N++)_[N]=!1;var e=!1,C=[];for(C.push(a),_[a]=!0;C.length>0;){var D=C.shift(),E=this._modules2[D];E&&(e=E.onDependencyError(A)||e);var L=this._inverseDependencies2[D];if(L)for(var N=0,v=L.length;N<v;N++){var d=L[N];_[d]||(C.push(d),_[d]=!0)}}e||this._config.onError(A)},m.prototype._hasDependencyPath=function(a,h){var A=this._modules2[a];if(!A)return!1;for(var _=[],N=0,v=this._moduleIdProvider.getMaxModuleId();N<v;N++)_[N]=!1;var e=[];for(e.push(A),_[a]=!0;e.length>0;){var C=e.shift(),D=C.dependencies;if(D)for(var N=0,v=D.length;N<v;N++){var E=D[N];if(E.id===h)return!0;var L=this._modules2[E.id];L&&!_[E.id]&&(_[E.id]=!0,e.push(L))}}return!1},m.prototype._findCyclePath=function(a,h,A){if(a===h||A===50)return[a];var _=this._modules2[a];if(!_)return null;var N=_.dependencies;if(N)for(var v=0,e=N.length;v<e;v++){var C=this._findCyclePath(N[v].id,h,A+1);if(C!==null)return C.push(a),C}return null},m.prototype._createRequire=function(a){var h=this,A=function(_,N,v){return h._relativeRequire(a,_,N,v)};return A.toUrl=function(_){return h._config.requireToUrl(a.resolveModule(_))},A.getStats=function(){return h.getLoaderEvents()},A.hasDependencyCycle=function(){return h._hasDependencyCycle},A.config=function(_,N){N===void 0&&(N=!1),h.configure(_,N)},A.__$__nodeRequire=q.global.nodeRequire,A},m.prototype._loadModule=function(a){var h=this;if(!(this._modules2[a]||this._knownModules2[a])){this._knownModules2[a]=!0;var A=this._moduleIdProvider.getStrModuleId(a),_=this._config.moduleIdToPaths(A),N=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(A.indexOf("/")===-1||N.test(A))&&_.push("node|"+A);var v=-1,e=function(C){if(v++,v>=_.length)h._onLoadError(a,C);else{var D=_[v],E=h.getRecorder();if(h._config.isBuild()&&D==="empty:"){h._buildInfoPath[a]=D,h.defineModule(h._moduleIdProvider.getStrModuleId(a),[],null,null,null),h._onLoad(a);return}E.record(10,D),h._scriptLoader.load(h,D,function(){h._config.isBuild()&&(h._buildInfoPath[a]=D),E.record(11,D),h._onLoad(a)},function(L){E.record(12,D),e(L)})}};e(null)}},m.prototype._loadPluginDependency=function(a,h){var A=this;if(!(this._modules2[h.id]||this._knownModules2[h.id])){this._knownModules2[h.id]=!0;var _=function(N){A.defineModule(A._moduleIdProvider.getStrModuleId(h.id),[],N,null,null)};_.error=function(N){A._config.onError(A._createLoadError(h.id,N))},a.load(h.pluginParam,this._createRequire(n.ROOT),_,this._config.getOptionsLiteral())}},m.prototype._resolve=function(a){var h=this,A=a.dependencies;if(A)for(var _=0,N=A.length;_<N;_++){var v=A[_];if(v===F.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(v===F.MODULE){a.unresolvedDependenciesCount--;continue}if(v===F.REQUIRE){a.unresolvedDependenciesCount--;continue}var e=this._modules2[v.id];if(e&&e.isComplete()){if(e.error){a.onDependencyError(e.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(v.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(v.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");var C=this._findCyclePath(v.id,a.id,0)||[];C.reverse(),C.push(v.id),console.warn(C.map(function(L){return h._moduleIdProvider.getStrModuleId(L)}).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[v.id]=this._inverseDependencies2[v.id]||[],this._inverseDependencies2[v.id].push(a.id),v instanceof l){var D=this._modules2[v.pluginId];if(D&&D.isComplete()){this._loadPluginDependency(D.exports,v);continue}var E=this._inversePluginDependencies2.get(v.pluginId);E||(E=[],this._inversePluginDependencies2.set(v.pluginId,E)),E.push(v),this._loadModule(v.pluginId);continue}this._loadModule(v.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)},m.prototype._onModuleComplete=function(a){var h=this,A=this.getRecorder();if(!a.isComplete()){var _=a.dependencies,N=[];if(_)for(var v=0,e=_.length;v<e;v++){var C=_[v];if(C===F.EXPORTS){N[v]=a.exports;continue}if(C===F.MODULE){N[v]={id:a.strId,config:function(){return h._config.getConfigForModule(a.strId)}};continue}if(C===F.REQUIRE){N[v]=this._createRequire(a.moduleIdResolver);continue}var D=this._modules2[C.id];if(D){N[v]=D.exports;continue}N[v]=null}var E=function(i){return(h._inverseDependencies2[i]||[]).map(function(s){return h._moduleIdProvider.getStrModuleId(s)})};a.complete(A,this._config,N,E);var L=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,L)for(var v=0,e=L.length;v<e;v++){var d=L[v],b=this._modules2[d];b.unresolvedDependenciesCount--,b.unresolvedDependenciesCount===0&&this._onModuleComplete(b)}var o=this._inversePluginDependencies2.get(a.id);if(o){this._inversePluginDependencies2.delete(a.id);for(var v=0,e=o.length;v<e;v++)this._loadPluginDependency(a.exports,o[v])}}},m}();q.ModuleManager=y})(le||(le={}));var Z,le;(function(q){var n=new q.Environment,R=null,t=function(m,a,h){typeof m!="string"&&(h=a,a=m,m=null),(typeof a!="object"||!Array.isArray(a))&&(h=a,a=null),a||(a=["require","exports","module"]),m?R.defineModule(m,a,h,null,null):R.enqueueDefineAnonymousModule(a,h)};t.amd={jQuery:!0};var F=function(m,a){a===void 0&&(a=!1),R.configure(m,a)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){F(arguments[0]);return}if(typeof arguments[0]=="string")return R.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){R.defineModule(q.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=F,l.getConfig=function(){return R.getConfig().getOptionsLiteral()},l.reset=function(){R=R.reset()},l.getBuildInfo=function(){return R.getBuildInfo()},l.getStats=function(){return R.getLoaderEvents()},l.define=t;function y(){if(typeof q.global.require<"u"||typeof require<"u"){var m=q.global.require||require;if(typeof m=="function"&&typeof m.resolve=="function"){var a=q.ensureRecordedNodeRequire(R.getRecorder(),m);q.global.nodeRequire=a,l.nodeRequire=a,l.__$__nodeRequire=a}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=l:(n.isElectronRenderer||(q.global.define=t),q.global.require=l)}q.init=y,(typeof q.global.define!="function"||!q.global.define.amd)&&(R=new q.ModuleManager(n,q.createScriptLoader(n),t,l,q.Utilities.getHighPerformanceTimestamp()),typeof q.global.require<"u"&&typeof q.global.require!="function"&&l.config(q.global.require),Z=function(){return t.apply(null,arguments)},Z.amd=t.amd,typeof doNotInitLoader>"u"&&y())})(le||(le={})),Z(J[54],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=void 0;function R(m,a,h,A){if(A=A||{},(A["vs/css"]||{}).disabled){h({});return}const N=a.toUrl(m+".css");t(m,N,()=>{h({})},v=>{typeof h.error=="function"&&h.error("Could not find "+N+".")})}n.load=R;function t(m,a,h,A){if(F(m,a)){h();return}l(m,a,h,A)}function F(m,a){const h=document.getElementsByTagName("link");for(let A=0,_=h.length;A<_;A++){const N=h[A].getAttribute("data-name"),v=h[A].getAttribute("href");if(N===m||v===a)return!0}return!1}function l(m,a,h,A){const _=document.createElement("link");_.setAttribute("rel","stylesheet"),_.setAttribute("type","text/css"),_.setAttribute("data-name",m),y(m,_,h,A),_.setAttribute("href",a),(document.head||document.getElementsByTagName("head")[0]).appendChild(_)}function y(m,a,h,A){const _=()=>{a.removeEventListener("load",N),a.removeEventListener("error",v)},N=e=>{_(),h()},v=e=>{_(),A(e)};a.addEventListener("load",N),a.addEventListener("error",v)}}),Z("vs/nls",["require","exports"],function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let R=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const t="i-default";function F(e,C){let D;return C.length===0?D=e:D=e.replace(/\{(\d+)\}/g,(E,L)=>{const d=L[0],b=C[d];let o=E;return typeof b=="string"?o=b:(typeof b=="number"||typeof b=="boolean"||b===void 0||b===null)&&(o=String(b)),o}),R&&(D="\uFF3B"+D.replace(/[aouei]/g,"$&$&")+"\uFF3D"),D}function l(e,C){let D=e[C];return D||(D=e["*"],D)?D:null}function y(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function m(e,C,D){const E=y(e)+y(C)+"vscode/"+y(D),L=await fetch(E);if(L.ok)return await L.json();throw new Error(`${L.status} - ${L.statusText}`)}function a(e){return function(C,D){const E=Array.prototype.slice.call(arguments,2);return F(e[C],E)}}function h(e,C,...D){return F(C,D)}n.localize=h;function A(e){}n.getConfiguredDefaultLocale=A;function _(e){R=e}n.setPseudoTranslation=_;function N(e,C){return{localize:a(C[e]),getConfiguredDefaultLocale:C.getConfiguredDefaultLocale??(D=>{})}}n.create=N;function v(e,C,D,E){const L=E["vs/nls"]??{};if(!e||e.length===0)return D({localize:h,getConfiguredDefaultLocale:()=>L.availableLanguages?.["*"]});const d=L.availableLanguages?l(L.availableLanguages,e):null,b=d===null||d===t;let o=".nls";b||(o=o+"."+d);const i=s=>{Array.isArray(s)?s.localize=a(s):s.localize=a(s[e]),s.getConfiguredDefaultLocale=()=>L.availableLanguages?.["*"],D(s)};typeof L.loadBundle=="function"?L.loadBundle(e,d,(s,g)=>{s?C([e+".nls"],i):i(g)}):L.translationServiceUrl&&!b?(async()=>{try{const s=await m(L.translationServiceUrl,d,e);return i(s)}catch(s){if(!d.includes("-"))return console.error(s),C([e+".nls"],i);try{const g=d.split("-")[0],c=await m(L.translationServiceUrl,g,e);return L.availableLanguages??={},L.availableLanguages["*"]=g,i(c)}catch(g){return console.error(g),C([e+".nls"],i)}}})():C([e+o],i,s=>{if(o===".nls"){console.error("Failed trying to load default language strings",s);return}console.error(`Failed to load message bundle for language ${d}. Falling back to the default language:`,s),C([e+".nls"],i)})}n.load=v}),function(){const q=self.MonacoEnvironment,n=q&&q.baseUrl?q.baseUrl:"../../../",R=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:h=>h,createScript:(h,...A)=>{const _=A.slice(0,-1).join(","),N=A.pop().toString();return`(function anonymous(${_}) { ${N}
})`}}):void 0;function t(){try{return(R?self.eval(R.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function F(){return new Promise((h,A)=>{if(typeof self.define=="function"&&self.define.amd)return h();const _=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(_)&&_.substring(0,self.origin.length)!==self.origin)&&t()){fetch(_).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${_}`,(R?self.eval(R.createScript("",v)):new Function(v)).call(self),h()}).then(void 0,A);return}R?importScripts(R.createScriptURL(_)):importScripts(_),h()})}function l(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:R,amdModulesPattern:/^vs\//})}function y(h){F().then(()=>{l(),require([h],function(A){setTimeout(function(){const _=A.create((N,v)=>{self.postMessage(N,v)},null);for(self.onmessage=N=>_.onmessage(N.data,N.ports);a.length>0;)self.onmessage(a.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&l();let m=!0;const a=[];self.onmessage=h=>{if(!m){a.push(h);return}m=!1,y(h.data)}}(),Z(J[24],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CSSIcon=n.Codicon=n.getCodiconAriaLabel=void 0;function R(l){return l?l.replace(/\$\((.*?)\)/g,(y,m)=>` ${m} `).trim():""}n.getCodiconAriaLabel=R;class t{constructor(y,m,a){this.id=y,this.definition=m,this.description=a,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}n.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var F;(function(l){l.iconNameSegment="[A-Za-z0-9]+",l.iconNameExpression="[A-Za-z0-9-]+",l.iconModifierExpression="~[A-Za-z]+",l.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${l.iconNameExpression})(${l.iconModifierExpression})?$`);function m(A){if(A instanceof t)return["codicon","codicon-"+A.id];const _=y.exec(A.id);if(!_)return m(t.error);const[,N,v]=_,e=["codicon","codicon-"+N];return v&&e.push("codicon-modifier-"+v.substring(1)),e}l.asClassNameArray=m;function a(A){return m(A).join(" ")}l.asClassName=a;function h(A){return"."+m(A).join(".")}l.asCSSSelector=h})(F=n.CSSIcon||(n.CSSIcon={}))}),Z(J[25],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class R{constructor(F,l,y,m){this.originalStart=F,this.originalLength=l,this.modifiedStart=y,this.modifiedLength=m}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=R}),Z(J[6],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class R{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?d.isErrorNoTelemetry(i)?new d(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(s=>{s(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}n.ErrorHandler=R,n.errorHandler=new R;function t(o){n.errorHandler.setUnexpectedErrorHandler(o)}n.setUnexpectedErrorHandler=t;function F(o){a(o)||n.errorHandler.onUnexpectedError(o)}n.onUnexpectedError=F;function l(o){a(o)||n.errorHandler.onUnexpectedExternalError(o)}n.onUnexpectedExternalError=l;function y(o){if(o instanceof Error){const{name:i,message:s}=o,g=o.stacktrace||o.stack;return{$isError:!0,name:i,message:s,stack:g,noTelemetry:d.isErrorNoTelemetry(o)}}return o}n.transformErrorForSerialization=y;const m="Canceled";function a(o){return o instanceof h?!0:o instanceof Error&&o.name===m&&o.message===m}n.isCancellationError=a;class h extends Error{constructor(){super(m),this.name=this.message}}n.CancellationError=h;function A(){const o=new Error(m);return o.name=o.message,o}n.canceled=A;function _(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}n.illegalArgument=_;function N(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}n.illegalState=N;function v(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=v;function e(o){const i=new Error(`${o} has been disposed`);return i.name="DISPOSED",i}n.disposed=e;function C(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}n.getErrorMessage=C;class D extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}n.NotImplementedError=D;class E extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}n.NotSupportedError=E;class L extends Error{constructor(){super(...arguments),this.isExpected=!0}}n.ExpectedError=L;class d extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof d)return i;const s=new d;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}n.ErrorNoTelemetry=d;class b extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype);debugger}}n.BugIndicatingError=b}),Z(J[26],x([0,1,6]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushMany=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.lastOrDefault=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function t(k,T=0){return k[k.length-(1+T)]}n.tail=t;function F(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}n.tail2=F;function l(k,T,I=(W,j)=>W===j){if(k===T)return!0;if(!k||!T||k.length!==T.length)return!1;for(let W=0,j=k.length;W<j;W++)if(!I(k[W],T[W]))return!1;return!0}n.equals=l;function y(k,T){const I=k.length-1;T<I&&(k[T]=k[I]),k.pop()}n.removeFastWithoutKeepingOrder=y;function m(k,T,I){return a(k.length,W=>I(k[W],T))}n.binarySearch=m;function a(k,T){let I=0,W=k-1;for(;I<=W;){const j=(I+W)/2|0,re=T(j);if(re<0)I=j+1;else if(re>0)W=j-1;else return j}return-(I+1)}n.binarySearch2=a;function h(k,T){let I=0,W=k.length;if(W===0)return 0;for(;I<W;){const j=Math.floor((I+W)/2);T(k[j])?W=j:I=j+1}return I}n.findFirstInSorted=h;function A(k,T,I){if(k=k|0,k>=T.length)throw new TypeError("invalid index");const W=T[Math.floor(T.length*Math.random())],j=[],re=[],ie=[];for(const ue of T){const ae=I(ue,W);ae<0?j.push(ue):ae>0?re.push(ue):ie.push(ue)}return k<j.length?A(k,j,I):k<j.length+ie.length?ie[0]:A(k-(j.length+ie.length),re,I)}n.quickSelect=A;function _(k,T){const I=[];let W;for(const j of k.slice(0).sort(T))!W||T(W[0],j)!==0?(W=[j],I.push(W)):W.push(j);return I}n.groupBy=_;function N(k,T,I){const W=[];function j(ue,ae,fe){if(ae===0&&fe.length===0)return;const he=W[W.length-1];he&&he.start+he.deleteCount===ue?(he.deleteCount+=ae,he.toInsert.push(...fe)):W.push({start:ue,deleteCount:ae,toInsert:fe})}let re=0,ie=0;for(;;){if(re===k.length){j(re,0,T.slice(ie));break}if(ie===T.length){j(re,k.length-re,[]);break}const ue=k[re],ae=T[ie],fe=I(ue,ae);fe===0?(re+=1,ie+=1):fe<0?(j(re,1,[]),re+=1):fe>0&&(j(re,0,[ae]),ie+=1)}return W}n.sortedDiff=N;function v(k,T,I){const W=N(k,T,I),j=[],re=[];for(const ie of W)j.push(...k.slice(ie.start,ie.start+ie.deleteCount)),re.push(...ie.toInsert);return{removed:j,added:re}}n.delta=v;function e(k,T,I){if(I===0)return[];const W=k.slice(0,I).sort(T);return D(k,T,W,I,k.length),W}n.top=e;function C(k,T,I,W,j){return I===0?Promise.resolve([]):new Promise((re,ie)=>{(async()=>{const ue=k.length,ae=k.slice(0,I).sort(T);for(let fe=I,he=Math.min(I+W,ue);fe<ue;fe=he,he=Math.min(he+W,ue)){if(fe>I&&await new Promise(ke=>setTimeout(ke)),j&&j.isCancellationRequested)throw new R.CancellationError;D(k,T,ae,fe,he)}return ae})().then(re,ie)})}n.topAsync=C;function D(k,T,I,W,j){for(const re=I.length;W<j;W++){const ie=k[W];if(T(ie,I[re-1])<0){I.pop();const ue=h(I,ae=>T(ie,ae)<0);I.splice(ue,0,ie)}}}function E(k){return k.filter(T=>!!T)}n.coalesce=E;function L(k){let T=0;for(let I=0;I<k.length;I++)k[I]&&(k[T]=k[I],T+=1);k.length=T}n.coalesceInPlace=L;function d(k,T,I){k.splice(I,0,k.splice(T,1)[0])}n.move=d;function b(k){return!Array.isArray(k)||k.length===0}n.isFalsyOrEmpty=b;function o(k){return Array.isArray(k)&&k.length>0}n.isNonEmptyArray=o;function i(k,T=I=>I){const I=new Set;return k.filter(W=>{const j=T(W);return I.has(j)?!1:(I.add(j),!0)})}n.distinct=i;function s(k){const T=new Set;return I=>{const W=k(I);return T.has(W)?!1:(T.add(W),!0)}}n.uniqueFilter=s;function g(k,T){const I=c(k,T);if(I!==-1)return k[I]}n.findLast=g;function c(k,T){for(let I=k.length-1;I>=0;I--){const W=k[I];if(T(W))return I}return-1}n.lastIndex=c;function p(k,T){return k.length>0?k[0]:T}n.firstOrDefault=p;function w(k,T){return k.length>0?k[k.length-1]:T}n.lastOrDefault=w;function f(k,T,I=(W,j)=>W===j){let W=0;for(let j=0,re=Math.min(k.length,T.length);j<re&&I(k[j],T[j]);j++)W++;return W}n.commonPrefixLength=f;function u(k){return[].concat(...k)}n.flatten=u;function M(k,T){let I=typeof T=="number"?k:0;typeof T=="number"?I=k:(I=0,T=k);const W=[];if(I<=T)for(let j=I;j<T;j++)W.push(j);else for(let j=I;j>T;j--)W.push(j);return W}n.range=M;function S(k,T,I){return k.reduce((W,j)=>(W[T(j)]=I?I(j):j,W),Object.create(null))}n.index=S;function O(k,T){return k.push(T),()=>U(k,T)}n.insert=O;function U(k,T){const I=k.indexOf(T);if(I>-1)return k.splice(I,1),T}n.remove=U;function H(k,T,I){const W=k.slice(0,T),j=k.slice(T);return W.concat(I,j)}n.arrayInsert=H;function z(k,T){let I;if(typeof T=="number"){let W=T;I=()=>{const j=Math.sin(W++)*179426549;return j-Math.floor(j)}}else I=Math.random;for(let W=k.length-1;W>0;W-=1){const j=Math.floor(I()*(W+1)),re=k[W];k[W]=k[j],k[j]=re}}n.shuffle=z;function ee(k,T){const I=k.indexOf(T);I>-1&&(k.splice(I,1),k.unshift(T))}n.pushToStart=ee;function ne(k,T){const I=k.indexOf(T);I>-1&&(k.splice(I,1),k.push(T))}n.pushToEnd=ne;function Q(k,T){for(const I of T)k.push(I)}n.pushMany=Q;function K(k,T){return Array.isArray(k)?k.map(T):T(k)}n.mapArrayOrNot=K;function r(k){return Array.isArray(k)?k:[k]}n.asArray=r;function ve(k){return k[Math.floor(Math.random()*k.length)]}n.getRandomElement=ve;function Ae(k,T){for(const I of k){const W=T(I);if(W!==void 0)return W}}n.mapFind=Ae;function de(k,T,I){const W=Le(k,T),j=k.length,re=I.length;k.length=j+re;for(let ie=j-1;ie>=W;ie--)k[ie+re]=k[ie];for(let ie=0;ie<re;ie++)k[ie+W]=I[ie]}n.insertInto=de;function Ce(k,T,I,W){const j=Le(k,T),re=k.splice(j,I);return de(k,j,W),re}n.splice=Ce;function Le(k,T){return T<0?Math.max(T+k.length,0):Math.min(T,k.length)}var Ne;(function(k){function T(j){return j<0}k.isLessThan=T;function I(j){return j>0}k.isGreaterThan=I;function W(j){return j===0}k.isNeitherLessOrGreaterThan=W,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(Ne=n.CompareResult||(n.CompareResult={}));function _e(k,T){return(I,W)=>T(k(I),k(W))}n.compareBy=_e;function Me(...k){return(T,I)=>{for(const W of k){const j=W(T,I);if(!Ne.isNeitherLessOrGreaterThan(j))return j}return Ne.neitherLessOrGreaterThan}}n.tieBreakComparators=Me;const De=(k,T)=>k-T;n.numberComparator=De;function Ee(k,T){if(k.length===0)return;let I=k[0];for(let W=1;W<k.length;W++){const j=k[W];T(j,I)>0&&(I=j)}return I}n.findMaxBy=Ee;function Fe(k,T){if(k.length===0)return;let I=k[0];for(let W=1;W<k.length;W++){const j=k[W];T(j,I)>=0&&(I=j)}return I}n.findLastMaxBy=Fe;function te(k,T){return Ee(k,(I,W)=>-T(I,W))}n.findMinBy=te;class G{constructor(T){this.f=T,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(T){let I=this.c;for(;I<this.f.length&&T(this.f[I]);)I++;const W=I===this.c?null:this.f.slice(this.c,I);return this.c=I,W}takeFromEndWhile(T){let I=this.d;for(;I>=0&&T(this.f[I]);)I--;const W=I===this.d?null:this.f.slice(I+1,this.d+1);return this.d=I,W}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const T=this.f[this.c];return this.c++,T}removeLast(){const T=this.f[this.d];return this.d--,T}takeCount(T){const I=this.f.slice(this.c,this.c+T);return this.c+=T,I}}n.ArrayQueue=G;class Y{constructor(T){this.iterate=T}forEach(T){this.iterate(I=>(T(I),!0))}toArray(){const T=[];return this.iterate(I=>(T.push(I),!0)),T}filter(T){return new Y(I=>this.iterate(W=>T(W)?I(W):!0))}map(T){return new Y(I=>this.iterate(W=>I(T(W))))}some(T){let I=!1;return this.iterate(W=>(I=T(W),!I)),I}findFirst(T){let I;return this.iterate(W=>T(W)?(I=W,!1):!0),I}findLast(T){let I;return this.iterate(W=>(T(W)&&(I=W),!0)),I}findLastMaxBy(T){let I,W=!0;return this.iterate(j=>((W||Ne.isGreaterThan(T(j,I)))&&(W=!1,I=j),!0)),I}}n.CallbackIterable=Y,Y.empty=new Y(k=>{})}),Z(J[10],x([0,1,6]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assert=n.assertNever=n.ok=void 0;function t(a,h){if(!a)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}n.ok=t;function F(a,h="Unreachable"){throw new Error(h)}n.assertNever=F;function l(a){if(!a)throw new R.BugIndicatingError("Assertion Failed")}n.assert=l;function y(a){if(!a()){debugger;a(),(0,R.onUnexpectedError)(new R.BugIndicatingError("Assertion Failed"))}}n.assertFn=y;function m(a,h){let A=0;for(;A<a.length-1;){const _=a[A],N=a[A+1];if(!h(_,N))return!1;A++}return!0}n.checkAdjacentItems=m}),Z(J[13],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function R(t){const F=this;let l=!1,y;return function(){return l||(l=!0,y=t.apply(F,arguments)),y}}n.once=R}),Z(J[14],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var R;(function(t){function F(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}t.is=F;const l=Object.freeze([]);function y(){return l}t.empty=y;function*m(b){yield b}t.single=m;function a(b){return F(b)?b:m(b)}t.wrap=a;function h(b){return b||l}t.from=h;function A(b){return!b||b[Symbol.iterator]().next().done===!0}t.isEmpty=A;function _(b){return b[Symbol.iterator]().next().value}t.first=_;function N(b,o){for(const i of b)if(o(i))return!0;return!1}t.some=N;function v(b,o){for(const i of b)if(o(i))return i}t.find=v;function*e(b,o){for(const i of b)o(i)&&(yield i)}t.filter=e;function*C(b,o){let i=0;for(const s of b)yield o(s,i++)}t.map=C;function*D(...b){for(const o of b)for(const i of o)yield i}t.concat=D;function E(b,o,i){let s=i;for(const g of b)s=o(s,g);return s}t.reduce=E;function*L(b,o,i=b.length){for(o<0&&(o+=b.length),i<0?i+=b.length:i>b.length&&(i=b.length);o<i;o++)yield b[o]}t.slice=L;function d(b,o=Number.POSITIVE_INFINITY){const i=[];if(o===0)return[i,b];const s=b[Symbol.iterator]();for(let g=0;g<o;g++){const c=s.next();if(c.done)return[i,t.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=d})(R=n.Iterable||(n.Iterable={}))}),Z(J[27],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var R;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(R=n.KeyCode||(n.KeyCode={}));var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(t=n.ScanCode||(n.ScanCode={}));class F{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(C,D){this._keyCodeToStr[C]=D,this._strToKeyCode[D.toLowerCase()]=C}keyCodeToStr(C){return this._keyCodeToStr[C]}strToKeyCode(C){return this._strToKeyCode[C.toLowerCase()]||0}}const l=new F,y=new F,m=new F;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const a=[],h=Object.create(null),A=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>A[e]||0,toEnum:e=>h[e]||0,toString:e=>a[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",C=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],D=[],E=[];for(const L of C){const[d,b,o,i,s,g,c,p,w,f]=L;if(E[o]||(E[o]=!0,a[o]=i,h[i]=o,A[i.toLowerCase()]=o,b&&(n.IMMUTABLE_CODE_TO_KEY_CODE[o]=s,s!==0&&s!==3&&s!==5&&s!==4&&s!==6&&s!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[s]=o))),!D[s]){if(D[s]=!0,!g)throw new Error(`String representation missing for key code ${s} around scan code ${i}`);l.define(s,g),y.define(s,w||g),m.define(s,f||w||g)}c&&(n.EVENT_KEY_CODE_MAP[c]=s),p&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[p]=s)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var _;(function(e){function C(o){return l.keyCodeToStr(o)}e.toString=C;function D(o){return l.strToKeyCode(o)}e.fromString=D;function E(o){return y.keyCodeToStr(o)}e.toUserSettingsUS=E;function L(o){return m.keyCodeToStr(o)}e.toUserSettingsGeneral=L;function d(o){return y.strToKeyCode(o)||m.strToKeyCode(o)}e.fromUserSettings=d;function b(o){if(o>=93&&o<=108)return null;switch(o){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return l.keyCodeToStr(o)}e.toElectronAccelerator=b})(_=n.KeyCodeUtils||(n.KeyCodeUtils={}));var N;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(N=n.KeyMod||(n.KeyMod={}));function v(e,C){const D=(C&65535)<<16>>>0;return(e|D)>>>0}n.KeyChord=v}),Z(J[28],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class R{constructor(F){this.d=F,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(F){this.c=F}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(F){return new R(()=>F(this.getValue()))}}n.Lazy=R}),Z(J[7],x([0,1,13,14]),function(q,n,R,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.disposeIfDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const F=!1;let l=null;function y(w){l=w}if(n.setDisposableTracker=y,F){const w="__is_disposable_tracked__";y(new class{trackDisposable(f){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[w]||console.log(u)},3e3)}setParent(f,u){if(f&&f!==L.None)try{f[w]=!0}catch{}}markAsDisposed(f){if(f&&f!==L.None)try{f[w]=!0}catch{}}markAsSingleton(f){}})}function m(w){return l?.trackDisposable(w),w}function a(w){l?.markAsDisposed(w)}function h(w,f){l?.setParent(w,f)}function A(w,f){if(!!l)for(const u of w)l.setParent(u,f)}function _(w){return l?.markAsSingleton(w),w}n.markAsSingleton=_;function N(w){return typeof w.dispose=="function"&&w.dispose.length===0}n.isDisposable=N;function v(w){if(t.Iterable.is(w)){const f=[];for(const u of w)if(u)try{u.dispose()}catch(M){f.push(M)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(w)?[]:w}else if(w)return w.dispose(),w}n.dispose=v;function e(w){for(const f of w)N(f)&&f.dispose();return[]}n.disposeIfDisposable=e;function C(...w){const f=D(()=>v(w));return A(w,f),f}n.combinedDisposable=C;function D(w){const f=m({dispose:(0,R.once)(()=>{a(f),w()})});return f}n.toDisposable=D;class E{constructor(){this.c=new Set,this.f=!1,m(this)}dispose(){this.f||(a(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{v(this.c)}finally{this.c.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return h(f,this),this.f?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(f),f}}n.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class L{constructor(){this.q=new E,m(this),h(this.q,this)}dispose(){a(this),this.q.dispose()}B(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(f)}}n.Disposable=L,L.None=Object.freeze({dispose(){}});class d{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(f){this.b||f===this.a||(this.a?.dispose(),f&&h(f,this),this.a=f)}clear(){this.value=void 0}dispose(){this.b=!0,a(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const f=this.a;return this.a=void 0,f&&h(f,null),f}}n.MutableDisposable=d;class b{constructor(f){this.b=f,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}n.RefCountedDisposable=b;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(f){let u=f;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,a(this))},this}}n.SafeDisposable=o;class i{constructor(){this.a=new Map}acquire(f,...u){let M=this.a.get(f);M||(M={counter:0,object:this.b(f,...u)},this.a.set(f,M));const{object:S}=M,O=(0,R.once)(()=>{--M.counter===0&&(this.c(f,M.object),this.a.delete(f))});return M.counter++,{object:S,dispose:O}}}n.ReferenceCollection=i;class s{constructor(f){this.a=f}async acquire(f,...u){const M=this.a.acquire(f,...u);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(S){throw M.dispose(),S}}}n.AsyncReferenceCollection=s;class g{constructor(f){this.object=f}dispose(){}}n.ImmortalReference=g;function c(w){const f=new E;try{w(f)}finally{f.dispose()}}n.disposeOnReturn=c;class p{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){a(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{v(this.a.values())}finally{this.a.clear()}}has(f){return this.a.has(f)}get(f){return this.a.get(f)}set(f,u,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(f)?.dispose(),this.a.set(f,u)}deleteAndDispose(f){this.a.get(f)?.dispose(),this.a.delete(f)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}n.DisposableMap=p}),Z(J[15],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class R{constructor(l){this.element=l,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class t{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let l=this.a;for(;l!==R.Undefined;){const y=l.next;l.prev=R.Undefined,l.next=R.Undefined,l=y}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(l){return this.d(l,!1)}push(l){return this.d(l,!0)}d(l,y){const m=new R(l);if(this.a===R.Undefined)this.a=m,this.b=m;else if(y){const h=this.b;this.b=m,m.prev=h,h.next=m}else{const h=this.a;this.a=m,m.next=h,h.prev=m}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(m))}}shift(){if(this.a!==R.Undefined){const l=this.a.element;return this.e(this.a),l}}pop(){if(this.b!==R.Undefined){const l=this.b.element;return this.e(this.b),l}}e(l){if(l.prev!==R.Undefined&&l.next!==R.Undefined){const y=l.prev;y.next=l.next,l.next.prev=y}else l.prev===R.Undefined&&l.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):l.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):l.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let l=this.a;for(;l!==R.Undefined;)yield l.element,l=l.next}}n.LinkedList=t}),Z(J[29],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withUndefinedAsNull=n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isStringArray=n.isString=void 0;function R(s){return typeof s=="string"}n.isString=R;function t(s){return Array.isArray(s)&&s.every(g=>R(g))}n.isStringArray=t;function F(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}n.isObject=F;function l(s){const g=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof g}n.isTypedArray=l;function y(s){return typeof s=="number"&&!isNaN(s)}n.isNumber=y;function m(s){return!!s&&typeof s[Symbol.iterator]=="function"}n.isIterable=m;function a(s){return s===!0||s===!1}n.isBoolean=a;function h(s){return typeof s>"u"}n.isUndefined=h;function A(s){return!_(s)}n.isDefined=A;function _(s){return h(s)||s===null}n.isUndefinedOrNull=_;function N(s,g){if(!s)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}n.assertType=N;function v(s){if(_(s))throw new Error("Assertion Failed: argument is undefined or null");return s}n.assertIsDefined=v;function e(...s){const g=[];for(let c=0;c<s.length;c++){const p=s[c];if(_(p))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);g.push(p)}return g}n.assertAllDefined=e;const C=Object.prototype.hasOwnProperty;function D(s){if(!F(s))return!1;for(const g in s)if(C.call(s,g))return!1;return!0}n.isEmptyObject=D;function E(s){return typeof s=="function"}n.isFunction=E;function L(...s){return s.length>0&&s.every(E)}n.areFunctions=L;function d(s,g){const c=Math.min(s.length,g.length);for(let p=0;p<c;p++)b(s[p],g[p])}n.validateConstraints=d;function b(s,g){if(R(g)){if(typeof s!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(E(g)){try{if(s instanceof g)return}catch{}if(!_(s)&&s.constructor===g||g.length===1&&g.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=b;function o(s){return s===null?void 0:s}n.withNullAsUndefined=o;function i(s){return typeof s>"u"?null:s}n.withUndefinedAsNull=i}),Z(J[11],x([0,1,29]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.filter=n.getCaseInsensitive=n.distinct=n.safeStringify=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function t(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const L=Array.isArray(E)?[]:{};return Object.entries(E).forEach(([d,b])=>{L[d]=b&&typeof b=="object"?t(b):b}),L}n.deepClone=t;function F(E){if(!E||typeof E!="object")return E;const L=[E];for(;L.length>0;){const d=L.shift();Object.freeze(d);for(const b in d)if(l.call(d,b)){const o=d[b];typeof o=="object"&&!Object.isFrozen(o)&&!(0,R.isTypedArray)(o)&&L.push(o)}}return E}n.deepFreeze=F;const l=Object.prototype.hasOwnProperty;function y(E,L){return m(E,L,new Set)}n.cloneAndChange=y;function m(E,L,d){if((0,R.isUndefinedOrNull)(E))return E;const b=L(E);if(typeof b<"u")return b;if(Array.isArray(E)){const o=[];for(const i of E)o.push(m(i,L,d));return o}if((0,R.isObject)(E)){if(d.has(E))throw new Error("Cannot clone recursive data-structure");d.add(E);const o={};for(const i in E)l.call(E,i)&&(o[i]=m(E[i],L,d));return d.delete(E),o}return E}function a(E,L,d=!0){return(0,R.isObject)(E)?((0,R.isObject)(L)&&Object.keys(L).forEach(b=>{b in E?d&&((0,R.isObject)(E[b])&&(0,R.isObject)(L[b])?a(E[b],L[b],d):E[b]=L[b]):E[b]=L[b]}),E):L}n.mixin=a;function h(E,L){if(E===L)return!0;if(E==null||L===null||L===void 0||typeof E!=typeof L||typeof E!="object"||Array.isArray(E)!==Array.isArray(L))return!1;let d,b;if(Array.isArray(E)){if(E.length!==L.length)return!1;for(d=0;d<E.length;d++)if(!h(E[d],L[d]))return!1}else{const o=[];for(b in E)o.push(b);o.sort();const i=[];for(b in L)i.push(b);if(i.sort(),!h(o,i))return!1;for(d=0;d<o.length;d++)if(!h(E[o[d]],L[o[d]]))return!1}return!0}n.equals=h;function A(E){const L=new Set;return JSON.stringify(E,(d,b)=>{if((0,R.isObject)(b)||Array.isArray(b)){if(L.has(b))return"[Circular]";L.add(b)}return b})}n.safeStringify=A;function _(E,L){const d=Object.create(null);return!E||!L||Object.keys(L).forEach(o=>{const i=E[o],s=L[o];h(i,s)||(d[o]=s)}),d}n.distinct=_;function N(E,L){const d=L.toLowerCase(),b=Object.keys(E).find(o=>o.toLowerCase()===d);return b?E[b]:E[L]}n.getCaseInsensitive=N;function v(E,L){const d=Object.create(null);for(const[b,o]of Object.entries(E))L(b,o)&&(d[b]=o);return d}n.filter=v;function e(E){let L=[],d=Object.getPrototypeOf(E);for(;Object.prototype!==d;)L=L.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return L}n.getAllPropertyNames=e;function C(E){const L=[];for(const d of e(E))typeof E[d]=="function"&&L.push(d);return L}n.getAllMethodNames=C;function D(E,L){const d=o=>function(){const i=Array.prototype.slice.call(arguments,0);return L(o,i)},b={};for(const o of E)b[o]=d(o);return b}n.createProxyObject=D}),Z(J[16],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var R;(function(l){l[l.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",l[l.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",l[l.MAX_UINT_8=255]="MAX_UINT_8",l[l.MAX_UINT_16=65535]="MAX_UINT_16",l[l.MAX_UINT_32=4294967295]="MAX_UINT_32",l[l.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(R=n.Constants||(n.Constants={}));function t(l){return l<0?0:l>255?255:l|0}n.toUint8=t;function F(l){return l<0?0:l>4294967295?4294967295:l|0}n.toUint32=F}),Z(J[17],x([0,1,16]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class t{constructor(m){const a=(0,R.toUint8)(m);this.c=a,this.a=t.d(a),this.b=new Map}static d(m){const a=new Uint8Array(256);return a.fill(m),a}set(m,a){const h=(0,R.toUint8)(a);m>=0&&m<256?this.a[m]=h:this.b.set(m,h)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}n.CharacterClassifier=t;var F;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(F||(F={}));class l{constructor(){this.a=new t(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}n.CharacterSet=l}),Z(J[3],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class R{constructor(F,l){this.lineNumber=F,this.column=l}with(F=this.lineNumber,l=this.column){return F===this.lineNumber&&l===this.column?this:new R(F,l)}delta(F=0,l=0){return this.with(this.lineNumber+F,this.column+l)}equals(F){return R.equals(this,F)}static equals(F,l){return!F&&!l?!0:!!F&&!!l&&F.lineNumber===l.lineNumber&&F.column===l.column}isBefore(F){return R.isBefore(this,F)}static isBefore(F,l){return F.lineNumber<l.lineNumber?!0:l.lineNumber<F.lineNumber?!1:F.column<l.column}isBeforeOrEqual(F){return R.isBeforeOrEqual(this,F)}static isBeforeOrEqual(F,l){return F.lineNumber<l.lineNumber?!0:l.lineNumber<F.lineNumber?!1:F.column<=l.column}static compare(F,l){const y=F.lineNumber|0,m=l.lineNumber|0;if(y===m){const a=F.column|0,h=l.column|0;return a-h}return y-m}clone(){return new R(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(F){return new R(F.lineNumber,F.column)}static isIPosition(F){return F&&typeof F.lineNumber=="number"&&typeof F.column=="number"}}n.Position=R}),Z(J[2],x([0,1,3]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class t{constructor(l,y,m,a){l>m||l===m&&y>a?(this.startLineNumber=m,this.startColumn=a,this.endLineNumber=l,this.endColumn=y):(this.startLineNumber=l,this.startColumn=y,this.endLineNumber=m,this.endColumn=a)}isEmpty(){return t.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return t.containsPosition(this,l)}static containsPosition(l,y){return!(y.lineNumber<l.startLineNumber||y.lineNumber>l.endLineNumber||y.lineNumber===l.startLineNumber&&y.column<l.startColumn||y.lineNumber===l.endLineNumber&&y.column>l.endColumn)}static strictContainsPosition(l,y){return!(y.lineNumber<l.startLineNumber||y.lineNumber>l.endLineNumber||y.lineNumber===l.startLineNumber&&y.column<=l.startColumn||y.lineNumber===l.endLineNumber&&y.column>=l.endColumn)}containsRange(l){return t.containsRange(this,l)}static containsRange(l,y){return!(y.startLineNumber<l.startLineNumber||y.endLineNumber<l.startLineNumber||y.startLineNumber>l.endLineNumber||y.endLineNumber>l.endLineNumber||y.startLineNumber===l.startLineNumber&&y.startColumn<l.startColumn||y.endLineNumber===l.endLineNumber&&y.endColumn>l.endColumn)}strictContainsRange(l){return t.strictContainsRange(this,l)}static strictContainsRange(l,y){return!(y.startLineNumber<l.startLineNumber||y.endLineNumber<l.startLineNumber||y.startLineNumber>l.endLineNumber||y.endLineNumber>l.endLineNumber||y.startLineNumber===l.startLineNumber&&y.startColumn<=l.startColumn||y.endLineNumber===l.endLineNumber&&y.endColumn>=l.endColumn)}plusRange(l){return t.plusRange(this,l)}static plusRange(l,y){let m,a,h,A;return y.startLineNumber<l.startLineNumber?(m=y.startLineNumber,a=y.startColumn):y.startLineNumber===l.startLineNumber?(m=y.startLineNumber,a=Math.min(y.startColumn,l.startColumn)):(m=l.startLineNumber,a=l.startColumn),y.endLineNumber>l.endLineNumber?(h=y.endLineNumber,A=y.endColumn):y.endLineNumber===l.endLineNumber?(h=y.endLineNumber,A=Math.max(y.endColumn,l.endColumn)):(h=l.endLineNumber,A=l.endColumn),new t(m,a,h,A)}intersectRanges(l){return t.intersectRanges(this,l)}static intersectRanges(l,y){let m=l.startLineNumber,a=l.startColumn,h=l.endLineNumber,A=l.endColumn;const _=y.startLineNumber,N=y.startColumn,v=y.endLineNumber,e=y.endColumn;return m<_?(m=_,a=N):m===_&&(a=Math.max(a,N)),h>v?(h=v,A=e):h===v&&(A=Math.min(A,e)),m>h||m===h&&a>A?null:new t(m,a,h,A)}equalsRange(l){return t.equalsRange(this,l)}static equalsRange(l,y){return!l&&!y?!0:!!l&&!!y&&l.startLineNumber===y.startLineNumber&&l.startColumn===y.startColumn&&l.endLineNumber===y.endLineNumber&&l.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(l){return new R.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(l){return new R.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,y){return new t(this.startLineNumber,this.startColumn,l,y)}setStartPosition(l,y){return new t(l,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(l){return new t(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}collapseToEnd(){return t.collapseToEnd(this)}static collapseToEnd(l){return new t(l.endLineNumber,l.endColumn,l.endLineNumber,l.endColumn)}delta(l){return new t(this.startLineNumber+l,this.startColumn,this.endLineNumber+l,this.endColumn)}static fromPositions(l,y=l){return new t(l.lineNumber,l.column,y.lineNumber,y.column)}static lift(l){return l?new t(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,y){return!(l.endLineNumber<y.startLineNumber||l.endLineNumber===y.startLineNumber&&l.endColumn<y.startColumn||y.endLineNumber<l.startLineNumber||y.endLineNumber===l.startLineNumber&&y.endColumn<l.startColumn)}static areIntersecting(l,y){return!(l.endLineNumber<y.startLineNumber||l.endLineNumber===y.startLineNumber&&l.endColumn<=y.startColumn||y.endLineNumber<l.startLineNumber||y.endLineNumber===l.startLineNumber&&y.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,y){if(l&&y){const h=l.startLineNumber|0,A=y.startLineNumber|0;if(h===A){const _=l.startColumn|0,N=y.startColumn|0;if(_===N){const v=l.endLineNumber|0,e=y.endLineNumber|0;if(v===e){const C=l.endColumn|0,D=y.endColumn|0;return C-D}return v-e}return _-N}return h-A}return(l?1:0)-(y?1:0)}static compareRangesUsingEnds(l,y){return l.endLineNumber===y.endLineNumber?l.endColumn===y.endColumn?l.startLineNumber===y.startLineNumber?l.startColumn-y.startColumn:l.startLineNumber-y.startLineNumber:l.endColumn-y.endColumn:l.endLineNumber-y.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}toJSON(){return this}}n.Range=t}),Z(J[30],x([0,1,3,2]),function(q,n,R,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var F;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(F=n.SelectionDirection||(n.SelectionDirection={}));class l extends t.Range{constructor(m,a,h,A){super(m,a,h,A),this.selectionStartLineNumber=m,this.selectionStartColumn=a,this.positionLineNumber=h,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return l.selectionsEqual(this,m)}static selectionsEqual(m,a){return m.selectionStartLineNumber===a.selectionStartLineNumber&&m.selectionStartColumn===a.selectionStartColumn&&m.positionLineNumber===a.positionLineNumber&&m.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,a){return this.getDirection()===0?new l(this.startLineNumber,this.startColumn,m,a):new l(m,a,this.startLineNumber,this.startColumn)}getPosition(){return new R.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new R.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,a){return this.getDirection()===0?new l(m,a,this.endLineNumber,this.endColumn):new l(this.endLineNumber,this.endColumn,m,a)}static fromPositions(m,a=m){return new l(m.lineNumber,m.column,a.lineNumber,a.column)}static fromRange(m,a){return a===0?new l(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new l(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new l(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,a){if(m&&!a||!m&&a)return!1;if(!m&&!a)return!0;if(m.length!==a.length)return!1;for(let h=0,A=m.length;h<A;h++)if(!this.selectionsEqual(m[h],a[h]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,a,h,A,_){return _===0?new l(m,a,h,A):new l(h,A,m,a)}}n.Selection=l}),Z(J[31],x([0,1,17]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=n.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=n.WordCharacterClass||(n.WordCharacterClass={}));class F extends R.CharacterClassifier{constructor(m){super(0);for(let a=0,h=m.length;a<h;a++)this.set(m.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=F;function l(y){const m={};return a=>(m.hasOwnProperty(a)||(m[a]=y(a)),m[a])}n.getMapForWordSeparators=l(y=>new F(y))}),Z(J[18],x([0,1,14,7,15]),function(q,n,R,t,F){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.setDefaultGetWordAtTextConfig=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function l(_=""){let N="(-?\\d*\\.\\d\\w*)|([^";for(const v of n.USUAL_WORD_SEPARATORS)_.indexOf(v)>=0||(N+="\\"+v);return N+="\\s]+)",new RegExp(N,"g")}n.DEFAULT_WORD_REGEXP=l();function y(_){let N=n.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)N=_;else{let v="g";_.ignoreCase&&(v+="i"),_.multiline&&(v+="m"),_.unicode&&(v+="u"),N=new RegExp(_.source,v)}return N.lastIndex=0,N}n.ensureValidWordDefinition=y;const m=new F.LinkedList;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(_){const N=m.unshift(_);return(0,t.toDisposable)(N)}n.setDefaultGetWordAtTextConfig=a;function h(_,N,v,e,C){if(C||(C=R.Iterable.first(m)),v.length>C.maxLen){let b=_-C.maxLen/2;return b<0?b=0:e+=b,v=v.substring(b,_+C.maxLen/2),h(_,N,v,e,C)}const D=Date.now(),E=_-1-e;let L=-1,d=null;for(let b=1;!(Date.now()-D>=C.timeBudget);b++){const o=E-C.windowSize*b;N.lastIndex=Math.max(0,o);const i=A(N,v,E,L);if(!i&&d||(d=i,o<=0))break;L=o}if(d){const b={word:d[0],startColumn:e+1+d.index,endColumn:e+1+d.index+d[0].length};return N.lastIndex=0,b}return null}n.getWordAtText=h;function A(_,N,v,e){let C;for(;C=_.exec(N);){const D=C.index||0;if(D<=v&&_.lastIndex>=v)return C;if(e>0&&D>e)return null}return null}}),Z(J[8],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRange=n.SequenceDiff=void 0;class R{constructor(l,y){this.seq1Range=l,this.seq2Range=y}reverse(){return new R(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}n.SequenceDiff=R;class t{constructor(l,y){this.start=l,this.endExclusive=y}get isEmpty(){return this.start===this.endExclusive}delta(l){return new t(this.start+l,this.endExclusive+l)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(l){return new t(Math.min(this.start,l.start),Math.max(this.endExclusive,l.endExclusive))}}n.OffsetRange=t}),Z(J[32],x([0,1,8]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function t(a,h,A){let _=A;return _=l(a,h,_),_=y(a,h,_),_}n.optimizeSequenceDiffs=t;function F(a,h,A){const _=[];for(const N of A){const v=_[_.length-1];if(!v){_.push(N);continue}N.seq1Range.start-v.seq1Range.endExclusive<=2||N.seq2Range.start-v.seq2Range.endExclusive<=2?_[_.length-1]=new R.SequenceDiff(v.seq1Range.join(N.seq1Range),v.seq2Range.join(N.seq2Range)):_.push(N)}return _}n.smoothenSequenceDiffs=F;function l(a,h,A){const _=[];A.length>0&&_.push(A[0]);for(let N=1;N<A.length;N++){const v=_[_.length-1],e=A[N];if(e.seq1Range.isEmpty){let C=!0;const D=e.seq1Range.start-v.seq1Range.endExclusive;for(let E=1;E<=D;E++)if(h.getElement(e.seq2Range.start-E)!==h.getElement(e.seq2Range.endExclusive-E)){C=!1;break}if(C){_[_.length-1]=new R.SequenceDiff(v.seq1Range,new R.OffsetRange(v.seq2Range.start,e.seq2Range.endExclusive-D));continue}}_.push(e)}return _}n.joinSequenceDiffs=l;function y(a,h,A){if(!a.getBoundaryScore||!h.getBoundaryScore)return A;for(let _=0;_<A.length;_++){const N=A[_];if(N.seq1Range.isEmpty){const v=_>0?A[_-1].seq2Range.endExclusive:-1,e=_+1<A.length?A[_+1].seq2Range.start:h.length;A[_]=m(N,a,h,e,v)}else if(N.seq2Range.isEmpty){const v=_>0?A[_-1].seq1Range.endExclusive:-1,e=_+1<A.length?A[_+1].seq1Range.start:a.length;A[_]=m(N.reverse(),h,a,e,v).reverse()}}return A}n.shiftSequenceDiffs=y;function m(a,h,A,_,N){let e=1;for(;a.seq2Range.start-e>N&&A.getElement(a.seq2Range.start-e)===A.getElement(a.seq2Range.endExclusive-e)&&e<20;)e++;e--;let C=0;for(;a.seq2Range.start+C<_&&A.getElement(a.seq2Range.start+C)===A.getElement(a.seq2Range.endExclusive+C)&&C<20;)C++;if(e===0&&C===0)return a;let D=0,E=-1;for(let L=-e;L<=C;L++){const d=a.seq2Range.start+L,b=a.seq2Range.endExclusive+L,o=a.seq1Range.start+L,i=h.getBoundaryScore(o)+A.getBoundaryScore(d)+A.getBoundaryScore(b);i>E&&(E=i,D=L)}return D!==0?new R.SequenceDiff(a.seq1Range.delta(D),a.seq2Range.delta(D)):a}}),Z(J[33],x([0,1,8]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class t{compute(a,h){if(a.length===0)return[new R.SequenceDiff(new R.OffsetRange(0,0),new R.OffsetRange(0,h.length))];if(h.length===0)return[new R.SequenceDiff(new R.OffsetRange(0,a.length),new R.OffsetRange(0,0))];function A(d,b){for(;d<a.length&&b<h.length&&a.getElement(d)===h.getElement(b);)d++,b++;return d}let _=0;const N=new l;N.set(0,A(0,0));const v=new y;v.set(0,N.get(0)===0?null:new F(null,0,0,N.get(0)));let e=0;e:for(;;)for(_++,e=-_;e<=_;e+=2){const d=e===_?-1:N.get(e+1),b=e===-_?-1:N.get(e-1)+1,o=Math.min(Math.max(d,b),a.length),i=o-e,s=A(o,i);N.set(e,s);const g=o===d?v.get(e+1):v.get(e-1);if(v.set(e,s!==o?new F(g,o,i,s-o):g),N.get(e)===a.length&&N.get(e)-e===h.length)break e}let C=v.get(e);const D=[];let E=a.length,L=h.length;for(;;){const d=C?C.x+C.length:0,b=C?C.y+C.length:0;if((d!==E||b!==L)&&D.push(new R.SequenceDiff(new R.OffsetRange(d,E),new R.OffsetRange(b,L))),!C)break;E=C.x,L=C.y,C=C.prev}return D.reverse(),D}}n.MyersDiffAlgorithm=t;class F{constructor(a,h,A,_){this.prev=a,this.x=h,this.y=A,this.length=_}}class l{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,h){if(a<0){if(a=-a-1,a>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[a]=h}else{if(a>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[a]=h}}}class y{constructor(){this.a=[],this.b=[]}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,h){a<0?(a=-a-1,this.b[a]=h):this.a[a]=h}}}),Z(J[34],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class R{constructor(F,l){this.width=F,this.height=l,this.a=[],this.a=new Array(F*l)}get(F,l){return this.a[F+l*this.width]}set(F,l,y){this.a[F+l*this.width]=y}}n.Array2D=R}),Z(J[35],x([0,1,8,34]),function(q,n,R,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class F{compute(y,m,a){const h=new t.Array2D(y.length,m.length),A=new t.Array2D(y.length,m.length),_=new t.Array2D(y.length,m.length);for(let L=0;L<y.length;L++)for(let d=0;d<m.length;d++){const b=L===0?0:h.get(L-1,d),o=d===0?0:h.get(L,d-1);let i;y.getElement(L)===m.getElement(d)?(L===0||d===0?i=0:i=h.get(L-1,d-1),L>0&&d>0&&A.get(L-1,d-1)===3&&(i+=_.get(L-1,d-1)),i+=a?a(L,d):1):i=-1;const s=Math.max(b,o,i);if(s===i){const g=L>0&&d>0?_.get(L-1,d-1):0;_.set(L,d,g+1),A.set(L,d,3)}else s===b?(_.set(L,d,0),A.set(L,d,1)):s===o&&(_.set(L,d,0),A.set(L,d,2));h.set(L,d,s)}const N=[];let v=y.length,e=m.length;function C(L,d){(L+1!==v||d+1!==e)&&N.push(new R.SequenceDiff(new R.OffsetRange(L+1,v),new R.OffsetRange(d+1,e))),v=L,e=d}let D=y.length-1,E=m.length-1;for(;D>=0&&E>=0;)A.get(D,E)===3?(C(D,E),D--,E--):A.get(D,E)===1?D--:E--;return C(-1,-1),N.reverse(),N}}n.DynamicProgrammingDiffing=F}),Z(J[19],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=n.RangeMapping=n.LineRangeMapping=void 0;class R{constructor(y,m,a){this.originalRange=y,this.modifiedRange=m,this.innerChanges=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.LineRangeMapping=R;class t{constructor(y,m){this.originalRange=y,this.modifiedRange=m}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.RangeMapping=t;class F{constructor(y,m){this.startLineNumber=y,this.endLineNumberExclusive=m}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(y){return new F(this.startLineNumber+y,this.endLineNumberExclusive+y)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(y){return new F(Math.min(this.startLineNumber,y.startLineNumber),Math.max(this.endLineNumberExclusive,y.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}n.LineRange=F}),Z(J[36],x([0,1,10,3,2,8,35,32,33,19]),function(q,n,R,t,F,l,y,m,a,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class A{constructor(){this.b=new y.DynamicProgrammingDiffing,this.c=new a.MyersDiffAlgorithm}computeDiff(i,s,g){const c=new Map;function p(ne){let Q=c.get(ne);return Q===void 0&&(Q=c.size,c.set(ne,Q)),Q}const w=i.map(ne=>p(ne.trim())),f=s.map(ne=>p(ne.trim())),u=new v(w,i),M=new v(f,s);let S=(()=>u.length+M.length<1500?this.b.compute(u,M,(ne,Q)=>i[ne]===s[Q]?s[Q].length===0?.1:1+Math.log(1+s[Q].length):.99):this.c.compute(u,M))();S=(0,m.optimizeSequenceDiffs)(u,M,S);const O=[],U=ne=>{for(let Q=0;Q<ne;Q++){const K=H+Q,r=z+Q;if(i[K]!==s[r]){const ve=this.f(i,s,new l.SequenceDiff(new l.OffsetRange(K,K+1),new l.OffsetRange(r,r+1)));for(const Ae of ve)O.push(Ae)}}};let H=0,z=0;for(const ne of S){(0,R.assertFn)(()=>ne.seq1Range.start-H===ne.seq2Range.start-z);const Q=ne.seq1Range.start-H;U(Q),H=ne.seq1Range.endExclusive,z=ne.seq2Range.endExclusive;const K=this.f(i,s,ne);for(const r of K)O.push(r)}U(i.length-H);const ee=_(O);return{quitEarly:!1,changes:ee}}f(i,s,g){const c=new C(i,g.seq1Range),p=new C(s,g.seq2Range),w=c.length+p.length<500?this.b.compute(c,p):this.c.compute(c,p);let f=(0,m.optimizeSequenceDiffs)(c,p,w);return f=(0,m.smoothenSequenceDiffs)(c,p,f),f.map(M=>new h.RangeMapping(c.translateRange(M.seq1Range).delta(g.seq1Range.start),p.translateRange(M.seq2Range).delta(g.seq2Range.start)))}}n.StandardLinesDiffComputer=A;function _(o){const i=[];for(const s of N(o,(g,c)=>c.originalRange.startLineNumber-(g.originalRange.endLineNumber-(g.originalRange.endColumn>1?0:1))<=1||c.modifiedRange.startLineNumber-(g.modifiedRange.endLineNumber-(g.modifiedRange.endColumn>1?0:1))<=1)){const g=s[0],c=s[s.length-1];i.push(new h.LineRangeMapping(new h.LineRange(g.originalRange.startLineNumber,c.originalRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),new h.LineRange(g.modifiedRange.startLineNumber,c.modifiedRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),s))}return(0,R.assertFn)(()=>(0,R.checkAdjacentItems)(i,(s,g)=>g.originalRange.startLineNumber-s.originalRange.endLineNumberExclusive===g.modifiedRange.startLineNumber-s.modifiedRange.endLineNumberExclusive&&s.originalRange.endLineNumberExclusive<g.originalRange.startLineNumber&&s.modifiedRange.endLineNumberExclusive<g.modifiedRange.startLineNumber)),i}n.lineRangeMappingFromRangeMappings=_;function*N(o,i){let s,g;for(const c of o)g!==void 0&&i(g,c)?s.push(c):(s&&(yield s),s=[c]),g=c;s&&(yield s)}class v{constructor(i,s){this.b=i,this.c=s}getElement(i){return this.b[i]}get length(){return this.b.length}getBoundaryScore(i){const s=i===0?0:e(this.c[i-1]),g=i===this.c.length?0:e(this.c[i]);return 1e3-(s+g)}}n.LineSequence=v;function e(o){let i=0;for(;i<o.length&&(o.charCodeAt(i)===32||o.charCodeAt(i)===9);)i++;return i}class C{constructor(i,s){this.lines=i,this.lineRange=s;let g=0;this.c=new Int32Array(s.length);for(let p=s.start;p<s.endExclusive;p++)g+=i[p].length,this.c[p-s.start]=g+1,g++;this.b=new Int32Array(g);let c=0;for(let p=s.start;p<s.endExclusive;p++){const w=i[p];for(let f=0;f<w.length;f++)this.b[c+f]=w.charCodeAt(f);c+=w.length,p<i.length-1&&(this.b[c]=`
`.charCodeAt(0),c+=1)}}get text(){return[...this.b].map(i=>String.fromCharCode(i)).join("")}getElement(i){return this.b[i]}get length(){return this.b.length}getBoundaryScore(i){const s=d(i>0?this.b[i-1]:-1),g=d(i<this.b.length?this.b[i]:-1);if(s===6&&g===7)return 0;let c=0;return s!==g&&(c+=10,g===1&&(c+=1)),c+=L(s),c+=L(g),c}translateOffset(i){let s=0,g=this.c.length;for(;s<g;){const p=Math.floor((s+g)/2);this.c[p]>i?g=p:s=p+1}const c=s===0?0:this.c[s-1];return new t.Position(s+1,i-c+1)}translateRange(i){return F.Range.fromPositions(this.translateOffset(i.start),this.translateOffset(i.endExclusive))}}var D;(function(o){o[o.WordLower=0]="WordLower",o[o.WordUpper=1]="WordUpper",o[o.WordNumber=2]="WordNumber",o[o.End=3]="End",o[o.Other=4]="Other",o[o.Space=5]="Space",o[o.LineBreakCR=6]="LineBreakCR",o[o.LineBreakLF=7]="LineBreakLF"})(D||(D={}));const E={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function L(o){return E[o]}function d(o){return o===10?7:o===13?6:b(o)?5:o>=97&&o<=122?0:o>=65&&o<=90?1:o>=48&&o<=57?2:o===-1?3:4}function b(o){return o===32||o===9}}),Z(J[37],x([0,1,17]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.State=void 0;var t;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(t=n.State||(n.State={}));class F{constructor(e,C,D){const E=new Uint8Array(e*C);for(let L=0,d=e*C;L<d;L++)E[L]=D;this.a=E,this.rows=e,this.cols=C}get(e,C){return this.a[e*this.cols+C]}set(e,C,D){this.a[e*this.cols+C]=D}}class l{constructor(e){let C=0,D=0;for(let L=0,d=e.length;L<d;L++){const[b,o,i]=e[L];o>C&&(C=o),b>D&&(D=b),i>D&&(D=i)}C++,D++;const E=new F(D,C,0);for(let L=0,d=e.length;L<d;L++){const[b,o,i]=e[L];E.set(b,o,i)}this.a=E,this.b=C}nextState(e,C){return C<0||C>=this.b?0:this.a.get(e,C)}}n.StateMachine=l;let y=null;function m(){return y===null&&(y=new l([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var a;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let h=null;function A(){if(h===null){h=new R.CharacterClassifier(0);const v=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let C=0;C<v.length;C++)h.set(v.charCodeAt(C),1);const e=".;:";for(let C=0;C<e.length;C++)h.set(e.charCodeAt(C),2)}return h}class _{static a(e,C,D,E,L){let d=L-1;do{const b=C.charCodeAt(d);if(e.get(b)!==2)break;d--}while(d>E);if(E>0){const b=C.charCodeAt(E-1),o=C.charCodeAt(d);(b===40&&o===41||b===91&&o===93||b===123&&o===125)&&d--}return{range:{startLineNumber:D,startColumn:E+1,endLineNumber:D,endColumn:d+2},url:C.substring(E,d+1)}}static computeLinks(e,C=m()){const D=A(),E=[];for(let L=1,d=e.getLineCount();L<=d;L++){const b=e.getLineContent(L),o=b.length;let i=0,s=0,g=0,c=1,p=!1,w=!1,f=!1,u=!1;for(;i<o;){let M=!1;const S=b.charCodeAt(i);if(c===13){let O;switch(S){case 40:p=!0,O=0;break;case 41:O=p?0:1;break;case 91:f=!0,w=!0,O=0;break;case 93:f=!1,O=w?0:1;break;case 123:u=!0,O=0;break;case 125:O=u?0:1;break;case 39:case 34:case 96:g===S?O=1:g===39||g===34||g===96?O=0:O=1;break;case 42:O=g===42?1:0;break;case 124:O=g===124?1:0;break;case 32:O=f?0:1;break;default:O=D.get(S)}O===1&&(E.push(_.a(D,b,L,s,i)),M=!0)}else if(c===12){let O;S===91?(w=!0,O=0):O=D.get(S),O===1?M=!0:c=13}else c=C.nextState(c,S),c===0&&(M=!0);M&&(c=1,p=!1,w=!1,u=!1,s=i+1,g=S),i++}c===13&&E.push(_.a(D,b,L,s,o))}return E}}n.LinkComputer=_;function N(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:_.computeLinks(v)}n.computeLinks=N}),Z(J[38],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class R{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(F,l,y,m,a){if(F&&l){const h=this.a(l,a);if(h)return{range:F,value:h}}if(y&&m){const h=this.a(m,a);if(h)return{range:y,value:h}}return null}a(F,l){const y=this.b(F,l);return y!==null?y:this.d(F,l)}b(F,l){const y=Math.pow(10,F.length-(F.lastIndexOf(".")+1));let m=Number(F);const a=parseFloat(F);return!isNaN(m)&&!isNaN(a)&&m===a?m===0&&!l?null:(m=Math.floor(m*y),m+=l?y:-y,String(m/y)):null}d(F,l){return this.e(this.c,F,l)}e(F,l,y){let m=null;for(let a=0,h=F.length;m===null&&a<h;a++)m=this.f(F[a],l,y);return m}f(F,l,y){let m=F.indexOf(l);return m>=0?(m+=y?1:-1,m<0?m=F.length-1:m%=F.length,F[m]):null}}n.BasicInplaceReplace=R,R.INSTANCE=new R}),Z(J[39],x([0,1,11]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.ModelConstants=n.PositionAffinity=n.isITextSnapshot=n.TrackedRangeStickiness=n.FindMatch=n.TextModelResolvedOptions=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var t;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(t=n.OverviewRulerLane||(n.OverviewRulerLane={}));var F;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(F=n.MinimapPosition||(n.MinimapPosition={}));var l;(function(d){d[d.Both=0]="Both",d[d.Right=1]="Right",d[d.Left=2]="Left",d[d.None=3]="None"})(l=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var y;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(y=n.EndOfLinePreference||(n.EndOfLinePreference={}));var m;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(m=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var a;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(a=n.EndOfLineSequence||(n.EndOfLineSequence={}));class h{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(b){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,b.tabSize|0),b.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,b.indentSize|0),this.a=!1),this.insertSpaces=Boolean(b.insertSpaces),this.defaultEOL=b.defaultEOL|0,this.trimAutoWhitespace=Boolean(b.trimAutoWhitespace),this.bracketPairColorizationOptions=b.bracketPairColorizationOptions}equals(b){return this.tabSize===b.tabSize&&this.a===b.a&&this.indentSize===b.indentSize&&this.insertSpaces===b.insertSpaces&&this.defaultEOL===b.defaultEOL&&this.trimAutoWhitespace===b.trimAutoWhitespace&&(0,R.equals)(this.bracketPairColorizationOptions,b.bracketPairColorizationOptions)}createChangeEvent(b){return{tabSize:this.tabSize!==b.tabSize,indentSize:this.indentSize!==b.indentSize,insertSpaces:this.insertSpaces!==b.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==b.trimAutoWhitespace}}}n.TextModelResolvedOptions=h;class A{constructor(b,o){this._findMatchBrand=void 0,this.range=b,this.matches=o}}n.FindMatch=A;var _;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(_=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));function N(d){return d&&typeof d.read=="function"}n.isITextSnapshot=N;var v;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right",d[d.None=2]="None",d[d.LeftOfInjectedText=3]="LeftOfInjectedText",d[d.RightOfInjectedText=4]="RightOfInjectedText"})(v=n.PositionAffinity||(n.PositionAffinity={}));var e;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=n.ModelConstants||(n.ModelConstants={}));class C{constructor(b,o,i,s,g,c){this.identifier=b,this.range=o,this.text=i,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=g,this._isTracked=c}}n.ValidAnnotatedEditOperation=C;class D{constructor(b,o,i){this.regex=b,this.wordSeparators=o,this.simpleSearch=i}}n.SearchData=D;class E{constructor(b,o,i){this.reverseEdits=b,this.changes=o,this.trimAutoWhitespaceLineNumbers=i}}n.ApplyEditsResult=E;function L(d){return!d.isTooLargeForSyncing()&&!d.isForSimpleWidget}n.shouldSynchronizeModel=L}),Z(J[40],x([0,1,26,16]),function(q,n,R,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class F{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,h){a=(0,t.toUint32)(a);const A=this.a,_=this.b,N=h.length;return N===0?!1:(this.a=new Uint32Array(A.length+N),this.a.set(A.subarray(0,a),0),this.a.set(A.subarray(a),a+N),this.a.set(h,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(_.subarray(0,this.c[0]+1)),!0)}setValue(a,h){return a=(0,t.toUint32)(a),h=(0,t.toUint32)(h),this.a[a]===h?!1:(this.a[a]=h,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,h){a=(0,t.toUint32)(a),h=(0,t.toUint32)(h);const A=this.a,_=this.b;if(a>=A.length)return!1;const N=A.length-a;return h>=N&&(h=N),h===0?!1:(this.a=new Uint32Array(A.length-h),this.a.set(A.subarray(0,a),0),this.a.set(A.subarray(a+h),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(_.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,t.toUint32)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let h=this.c[0]+1;h===0&&(this.b[0]=this.a[0],h++),a>=this.a.length&&(a=this.a.length-1);for(let A=h;A<=a;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let h=0,A=this.a.length-1,_=0,N=0,v=0;for(;h<=A;)if(_=h+(A-h)/2|0,N=this.b[_],v=N-this.a[_],a<v)A=_-1;else if(a>=N)h=_+1;else break;return new y(_,a-v)}}n.PrefixSumComputer=F;class l{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const h=this.e[a],A=h>0?this.d[h-1]:0;return new y(h,a-A)}removeValues(a,h){this.a.splice(a,h),this.f(a)}insertValues(a,h){this.a=(0,R.arrayInsert)(this.a,a,h),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,h=this.a.length;a<h;a++){const A=this.a[a],_=a>0?this.d[a-1]:0;this.d[a]=_+A;for(let N=0;N<A;N++)this.e[_+N]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,h){this.a[a]!==h&&(this.a[a]=h,this.f(a))}}n.ConstantTimePrefixSumComputer=l;class y{constructor(a,h){this.index=a,this.remainder=h,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=h}}n.PrefixSumIndexOfResult=y}),Z(J[41],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var R;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(R=n.AccessibilitySupport||(n.AccessibilitySupport={}));var t;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(t=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var F;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(F=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var l;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(l=n.CompletionItemKind||(n.CompletionItemKind={}));var y;(function(r){r[r.Deprecated=1]="Deprecated"})(y=n.CompletionItemTag||(n.CompletionItemTag={}));var m;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var a;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(a=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var h;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(h=n.CursorChangeReason||(n.CursorChangeReason={}));var A;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(A=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var _;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(_=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var N;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(N=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var v;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.autoClosingBrackets=5]="autoClosingBrackets",r[r.autoClosingDelete=6]="autoClosingDelete",r[r.autoClosingOvertype=7]="autoClosingOvertype",r[r.autoClosingQuotes=8]="autoClosingQuotes",r[r.autoIndent=9]="autoIndent",r[r.automaticLayout=10]="automaticLayout",r[r.autoSurround=11]="autoSurround",r[r.bracketPairColorization=12]="bracketPairColorization",r[r.guides=13]="guides",r[r.codeLens=14]="codeLens",r[r.codeLensFontFamily=15]="codeLensFontFamily",r[r.codeLensFontSize=16]="codeLensFontSize",r[r.colorDecorators=17]="colorDecorators",r[r.colorDecoratorsLimit=18]="colorDecoratorsLimit",r[r.columnSelection=19]="columnSelection",r[r.comments=20]="comments",r[r.contextmenu=21]="contextmenu",r[r.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",r[r.cursorBlinking=23]="cursorBlinking",r[r.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",r[r.cursorStyle=25]="cursorStyle",r[r.cursorSurroundingLines=26]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",r[r.cursorWidth=28]="cursorWidth",r[r.disableLayerHinting=29]="disableLayerHinting",r[r.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",r[r.domReadOnly=31]="domReadOnly",r[r.dragAndDrop=32]="dragAndDrop",r[r.dropIntoEditor=33]="dropIntoEditor",r[r.emptySelectionClipboard=34]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",r[r.extraEditorClassName=36]="extraEditorClassName",r[r.fastScrollSensitivity=37]="fastScrollSensitivity",r[r.find=38]="find",r[r.fixedOverflowWidgets=39]="fixedOverflowWidgets",r[r.folding=40]="folding",r[r.foldingStrategy=41]="foldingStrategy",r[r.foldingHighlight=42]="foldingHighlight",r[r.foldingImportsByDefault=43]="foldingImportsByDefault",r[r.foldingMaximumRegions=44]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=46]="fontFamily",r[r.fontInfo=47]="fontInfo",r[r.fontLigatures=48]="fontLigatures",r[r.fontSize=49]="fontSize",r[r.fontWeight=50]="fontWeight",r[r.fontVariations=51]="fontVariations",r[r.formatOnPaste=52]="formatOnPaste",r[r.formatOnType=53]="formatOnType",r[r.glyphMargin=54]="glyphMargin",r[r.gotoLocation=55]="gotoLocation",r[r.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",r[r.hover=57]="hover",r[r.inDiffEditor=58]="inDiffEditor",r[r.inlineSuggest=59]="inlineSuggest",r[r.letterSpacing=60]="letterSpacing",r[r.lightbulb=61]="lightbulb",r[r.lineDecorationsWidth=62]="lineDecorationsWidth",r[r.lineHeight=63]="lineHeight",r[r.lineNumbers=64]="lineNumbers",r[r.lineNumbersMinChars=65]="lineNumbersMinChars",r[r.linkedEditing=66]="linkedEditing",r[r.links=67]="links",r[r.matchBrackets=68]="matchBrackets",r[r.minimap=69]="minimap",r[r.mouseStyle=70]="mouseStyle",r[r.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=72]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",r[r.multiCursorModifier=74]="multiCursorModifier",r[r.multiCursorPaste=75]="multiCursorPaste",r[r.multiCursorLimit=76]="multiCursorLimit",r[r.occurrencesHighlight=77]="occurrencesHighlight",r[r.overviewRulerBorder=78]="overviewRulerBorder",r[r.overviewRulerLanes=79]="overviewRulerLanes",r[r.padding=80]="padding",r[r.parameterHints=81]="parameterHints",r[r.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",r[r.quickSuggestions=84]="quickSuggestions",r[r.quickSuggestionsDelay=85]="quickSuggestionsDelay",r[r.readOnly=86]="readOnly",r[r.renameOnType=87]="renameOnType",r[r.renderControlCharacters=88]="renderControlCharacters",r[r.renderFinalNewline=89]="renderFinalNewline",r[r.renderLineHighlight=90]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=92]="renderValidationDecorations",r[r.renderWhitespace=93]="renderWhitespace",r[r.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",r[r.roundedSelection=95]="roundedSelection",r[r.rulers=96]="rulers",r[r.scrollbar=97]="scrollbar",r[r.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=99]="scrollBeyondLastLine",r[r.scrollPredominantAxis=100]="scrollPredominantAxis",r[r.selectionClipboard=101]="selectionClipboard",r[r.selectionHighlight=102]="selectionHighlight",r[r.selectOnLineNumbers=103]="selectOnLineNumbers",r[r.showFoldingControls=104]="showFoldingControls",r[r.showUnused=105]="showUnused",r[r.snippetSuggestions=106]="snippetSuggestions",r[r.smartSelect=107]="smartSelect",r[r.smoothScrolling=108]="smoothScrolling",r[r.stickyScroll=109]="stickyScroll",r[r.stickyTabStops=110]="stickyTabStops",r[r.stopRenderingLineAfter=111]="stopRenderingLineAfter",r[r.suggest=112]="suggest",r[r.suggestFontSize=113]="suggestFontSize",r[r.suggestLineHeight=114]="suggestLineHeight",r[r.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",r[r.suggestSelection=116]="suggestSelection",r[r.tabCompletion=117]="tabCompletion",r[r.tabIndex=118]="tabIndex",r[r.unicodeHighlighting=119]="unicodeHighlighting",r[r.unusualLineTerminators=120]="unusualLineTerminators",r[r.useShadowDOM=121]="useShadowDOM",r[r.useTabStops=122]="useTabStops",r[r.wordBreak=123]="wordBreak",r[r.wordSeparators=124]="wordSeparators",r[r.wordWrap=125]="wordWrap",r[r.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=128]="wordWrapColumn",r[r.wordWrapOverride1=129]="wordWrapOverride1",r[r.wordWrapOverride2=130]="wordWrapOverride2",r[r.wrappingIndent=131]="wrappingIndent",r[r.wrappingStrategy=132]="wrappingStrategy",r[r.showDeprecated=133]="showDeprecated",r[r.inlayHints=134]="inlayHints",r[r.editorClassName=135]="editorClassName",r[r.pixelRatio=136]="pixelRatio",r[r.tabFocusMode=137]="tabFocusMode",r[r.layoutInfo=138]="layoutInfo",r[r.wrappingInfo=139]="wrappingInfo"})(v=n.EditorOption||(n.EditorOption={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e=n.EndOfLinePreference||(n.EndOfLinePreference={}));var C;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(C=n.EndOfLineSequence||(n.EndOfLineSequence={}));var D;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(D=n.IndentAction||(n.IndentAction={}));var E;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(E=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var L;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(L=n.InlayHintKind||(n.InlayHintKind={}));var d;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(d=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var b;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.NumLock=78]="NumLock",r[r.ScrollLock=79]="ScrollLock",r[r.Semicolon=80]="Semicolon",r[r.Equal=81]="Equal",r[r.Comma=82]="Comma",r[r.Minus=83]="Minus",r[r.Period=84]="Period",r[r.Slash=85]="Slash",r[r.Backquote=86]="Backquote",r[r.BracketLeft=87]="BracketLeft",r[r.Backslash=88]="Backslash",r[r.BracketRight=89]="BracketRight",r[r.Quote=90]="Quote",r[r.OEM_8=91]="OEM_8",r[r.IntlBackslash=92]="IntlBackslash",r[r.Numpad0=93]="Numpad0",r[r.Numpad1=94]="Numpad1",r[r.Numpad2=95]="Numpad2",r[r.Numpad3=96]="Numpad3",r[r.Numpad4=97]="Numpad4",r[r.Numpad5=98]="Numpad5",r[r.Numpad6=99]="Numpad6",r[r.Numpad7=100]="Numpad7",r[r.Numpad8=101]="Numpad8",r[r.Numpad9=102]="Numpad9",r[r.NumpadMultiply=103]="NumpadMultiply",r[r.NumpadAdd=104]="NumpadAdd",r[r.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=106]="NumpadSubtract",r[r.NumpadDecimal=107]="NumpadDecimal",r[r.NumpadDivide=108]="NumpadDivide",r[r.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",r[r.ABNT_C1=110]="ABNT_C1",r[r.ABNT_C2=111]="ABNT_C2",r[r.AudioVolumeMute=112]="AudioVolumeMute",r[r.AudioVolumeUp=113]="AudioVolumeUp",r[r.AudioVolumeDown=114]="AudioVolumeDown",r[r.BrowserSearch=115]="BrowserSearch",r[r.BrowserHome=116]="BrowserHome",r[r.BrowserBack=117]="BrowserBack",r[r.BrowserForward=118]="BrowserForward",r[r.MediaTrackNext=119]="MediaTrackNext",r[r.MediaTrackPrevious=120]="MediaTrackPrevious",r[r.MediaStop=121]="MediaStop",r[r.MediaPlayPause=122]="MediaPlayPause",r[r.LaunchMediaPlayer=123]="LaunchMediaPlayer",r[r.LaunchMail=124]="LaunchMail",r[r.LaunchApp2=125]="LaunchApp2",r[r.Clear=126]="Clear",r[r.MAX_VALUE=127]="MAX_VALUE"})(b=n.KeyCode||(n.KeyCode={}));var o;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(o=n.MarkerSeverity||(n.MarkerSeverity={}));var i;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(i=n.MarkerTag||(n.MarkerTag={}));var s;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(s=n.MinimapPosition||(n.MinimapPosition={}));var g;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(g=n.MouseTargetType||(n.MouseTargetType={}));var c;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(c=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var p;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(p=n.OverviewRulerLane||(n.OverviewRulerLane={}));var w;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(w=n.PositionAffinity||(n.PositionAffinity={}));var f;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(f=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var u;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(u=n.RenderMinimap||(n.RenderMinimap={}));var M;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(M=n.ScrollType||(n.ScrollType={}));var S;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(S=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var O;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(O=n.SelectionDirection||(n.SelectionDirection={}));var U;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(U=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var H;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(H=n.SymbolKind||(n.SymbolKind={}));var z;(function(r){r[r.Deprecated=1]="Deprecated"})(z=n.SymbolTag||(n.SymbolTag={}));var ee;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(ee=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var ne;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(ne=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var Q;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Q=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var K;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(K=n.WrappingIndent||(n.WrappingIndent={}))}),Z(J[42],x([55,56]),function(q,n){return q.create("vs/base/common/platform",n)}),Z(J[5],x([0,1,42]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.OperatingSystem=n.setTimeout0=n.setTimeout0IsFaster=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isCI=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isElectron=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let t=!1,F=!1,l=!1,y=!1,m=!1,a=!1,h=!1,A=!1,_=!1,N=!1,v,e=n.LANGUAGE_DEFAULT,C,D;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let E;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?E=n.globals.vscode.process:typeof process<"u"&&(E=process);const L=typeof E?.versions?.electron=="string",d=L&&E?.type==="renderer";if(typeof navigator=="object"&&!d)D=navigator.userAgent,t=D.indexOf("Windows")>=0,F=D.indexOf("Macintosh")>=0,A=(D.indexOf("Macintosh")>=0||D.indexOf("iPad")>=0||D.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,l=D.indexOf("Linux")>=0,N=D?.indexOf("Mobi")>=0,a=!0,v=R.getConfiguredDefaultLocale(R.localize(0,null))||n.LANGUAGE_DEFAULT,e=v;else if(typeof E=="object"){t=E.platform==="win32",F=E.platform==="darwin",l=E.platform==="linux",y=l&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,h=L,_=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=n.LANGUAGE_DEFAULT,e=n.LANGUAGE_DEFAULT;const f=E.env.VSCODE_NLS_CONFIG;if(f)try{const u=JSON.parse(f),M=u.availableLanguages["*"];v=u.locale,e=M||n.LANGUAGE_DEFAULT,C=u._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var b;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(b=n.Platform||(n.Platform={}));function o(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=o;let i=0;F?i=1:t?i=3:l&&(i=2),n.isWindows=t,n.isMacintosh=F,n.isLinux=l,n.isLinuxSnap=y,n.isNative=m,n.isElectron=h,n.isWeb=a,n.isWebWorker=a&&typeof n.globals.importScripts=="function",n.isIOS=A,n.isMobile=N,n.isCI=_,n.platform=i,n.userAgent=D,n.language=e;var s;(function(f){function u(){return n.language}f.value=u;function M(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}f.isDefaultVariant=M;function S(){return n.language==="en"}f.isDefault=S})(s=n.Language||(n.Language={})),n.locale=v,n.translationsConfigFile=C,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const f=[];n.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let S=0,O=f.length;S<O;S++){const U=f[S];if(U.id===M.data.vscodeScheduleAsyncWork){f.splice(S,1),U.callback();return}}});let u=0;return M=>{const S=++u;f.push({id:S,callback:M}),n.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return f=>setTimeout(f)})();var g;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(g=n.OperatingSystem||(n.OperatingSystem={})),n.OS=F||A?2:t?1:3;let c=!0,p=!1;function w(){if(!p){p=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,c=new Uint16Array(f.buffer)[0]===(2<<8)+1}return c}n.isLittleEndian=w,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Z(J[43],x([0,1,5]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.platform=n.env=n.cwd=void 0;let t;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.process<"u"){const F=R.globals.vscode.process;t={get platform(){return F.platform},get arch(){return F.arch},get env(){return F.env},cwd(){return F.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=t.cwd,n.env=t.env,n.platform=t.platform,n.arch=t.arch}),Z(J[44],x([0,1,43]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const t=65,F=97,l=90,y=122,m=46,a=47,h=92,A=58,_=63;class N extends Error{constructor(s,g,c){let p;typeof g=="string"&&g.indexOf("not ")===0?(p="must not be",g=g.replace(/^not /,"")):p="must be";const w=s.indexOf(".")!==-1?"property":"argument";let f=`The "${s}" ${w} ${p} of type ${g}`;f+=`. Received type ${typeof c}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function v(i,s){if(i===null||typeof i!="object")throw new N(s,"Object",i)}function e(i,s){if(typeof i!="string")throw new N(s,"string",i)}const C=R.platform==="win32";function D(i){return i===a||i===h}function E(i){return i===a}function L(i){return i>=t&&i<=l||i>=F&&i<=y}function d(i,s,g,c){let p="",w=0,f=-1,u=0,M=0;for(let S=0;S<=i.length;++S){if(S<i.length)M=i.charCodeAt(S);else{if(c(M))break;M=a}if(c(M)){if(!(f===S-1||u===1))if(u===2){if(p.length<2||w!==2||p.charCodeAt(p.length-1)!==m||p.charCodeAt(p.length-2)!==m){if(p.length>2){const O=p.lastIndexOf(g);O===-1?(p="",w=0):(p=p.slice(0,O),w=p.length-1-p.lastIndexOf(g)),f=S,u=0;continue}else if(p.length!==0){p="",w=0,f=S,u=0;continue}}s&&(p+=p.length>0?`${g}..`:"..",w=2)}else p.length>0?p+=`${g}${i.slice(f+1,S)}`:p=i.slice(f+1,S),w=S-f-1;f=S,u=0}else M===m&&u!==-1?++u:u=-1}return p}function b(i,s){v(s,"pathObject");const g=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return g?g===s.root?`${g}${c}`:`${g}${i}${c}`:c}n.win32={resolve(...i){let s="",g="",c=!1;for(let p=i.length-1;p>=-1;p--){let w;if(p>=0){if(w=i[p],e(w,"path"),w.length===0)continue}else s.length===0?w=R.cwd():(w=R.env[`=${s}`]||R.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==s.toLowerCase()&&w.charCodeAt(2)===h)&&(w=`${s}\\`));const f=w.length;let u=0,M="",S=!1;const O=w.charCodeAt(0);if(f===1)D(O)&&(u=1,S=!0);else if(D(O))if(S=!0,D(w.charCodeAt(1))){let U=2,H=U;for(;U<f&&!D(w.charCodeAt(U));)U++;if(U<f&&U!==H){const z=w.slice(H,U);for(H=U;U<f&&D(w.charCodeAt(U));)U++;if(U<f&&U!==H){for(H=U;U<f&&!D(w.charCodeAt(U));)U++;(U===f||U!==H)&&(M=`\\\\${z}\\${w.slice(H,U)}`,u=U)}}}else u=1;else L(O)&&w.charCodeAt(1)===A&&(M=w.slice(0,2),u=2,f>2&&D(w.charCodeAt(2))&&(S=!0,u=3));if(M.length>0)if(s.length>0){if(M.toLowerCase()!==s.toLowerCase())continue}else s=M;if(c){if(s.length>0)break}else if(g=`${w.slice(u)}\\${g}`,c=S,S&&s.length>0)break}return g=d(g,!c,"\\",D),c?`${s}\\${g}`:`${s}${g}`||"."},normalize(i){e(i,"path");const s=i.length;if(s===0)return".";let g=0,c,p=!1;const w=i.charCodeAt(0);if(s===1)return E(w)?"\\":i;if(D(w))if(p=!0,D(i.charCodeAt(1))){let u=2,M=u;for(;u<s&&!D(i.charCodeAt(u));)u++;if(u<s&&u!==M){const S=i.slice(M,u);for(M=u;u<s&&D(i.charCodeAt(u));)u++;if(u<s&&u!==M){for(M=u;u<s&&!D(i.charCodeAt(u));)u++;if(u===s)return`\\\\${S}\\${i.slice(M)}\\`;u!==M&&(c=`\\\\${S}\\${i.slice(M,u)}`,g=u)}}}else g=1;else L(w)&&i.charCodeAt(1)===A&&(c=i.slice(0,2),g=2,s>2&&D(i.charCodeAt(2))&&(p=!0,g=3));let f=g<s?d(i.slice(g),!p,"\\",D):"";return f.length===0&&!p&&(f="."),f.length>0&&D(i.charCodeAt(s-1))&&(f+="\\"),c===void 0?p?`\\${f}`:f:p?`${c}\\${f}`:`${c}${f}`},isAbsolute(i){e(i,"path");const s=i.length;if(s===0)return!1;const g=i.charCodeAt(0);return D(g)||s>2&&L(g)&&i.charCodeAt(1)===A&&D(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,g;for(let w=0;w<i.length;++w){const f=i[w];e(f,"path"),f.length>0&&(s===void 0?s=g=f:s+=`\\${f}`)}if(s===void 0)return".";let c=!0,p=0;if(typeof g=="string"&&D(g.charCodeAt(0))){++p;const w=g.length;w>1&&D(g.charCodeAt(1))&&(++p,w>2&&(D(g.charCodeAt(2))?++p:c=!1))}if(c){for(;p<s.length&&D(s.charCodeAt(p));)p++;p>=2&&(s=`\\${s.slice(p)}`)}return n.win32.normalize(s)},relative(i,s){if(e(i,"from"),e(s,"to"),i===s)return"";const g=n.win32.resolve(i),c=n.win32.resolve(s);if(g===c||(i=g.toLowerCase(),s=c.toLowerCase(),i===s))return"";let p=0;for(;p<i.length&&i.charCodeAt(p)===h;)p++;let w=i.length;for(;w-1>p&&i.charCodeAt(w-1)===h;)w--;const f=w-p;let u=0;for(;u<s.length&&s.charCodeAt(u)===h;)u++;let M=s.length;for(;M-1>u&&s.charCodeAt(M-1)===h;)M--;const S=M-u,O=f<S?f:S;let U=-1,H=0;for(;H<O;H++){const ee=i.charCodeAt(p+H);if(ee!==s.charCodeAt(u+H))break;ee===h&&(U=H)}if(H!==O){if(U===-1)return c}else{if(S>O){if(s.charCodeAt(u+H)===h)return c.slice(u+H+1);if(H===2)return c.slice(u+H)}f>O&&(i.charCodeAt(p+H)===h?U=H:H===2&&(U=3)),U===-1&&(U=0)}let z="";for(H=p+U+1;H<=w;++H)(H===w||i.charCodeAt(H)===h)&&(z+=z.length===0?"..":"\\..");return u+=U,z.length>0?`${z}${c.slice(u,M)}`:(c.charCodeAt(u)===h&&++u,c.slice(u,M))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=n.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===h){if(s.charCodeAt(1)===h){const g=s.charCodeAt(2);if(g!==_&&g!==m)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(L(s.charCodeAt(0))&&s.charCodeAt(1)===A&&s.charCodeAt(2)===h)return`\\\\?\\${s}`;return i},dirname(i){e(i,"path");const s=i.length;if(s===0)return".";let g=-1,c=0;const p=i.charCodeAt(0);if(s===1)return D(p)?i:".";if(D(p)){if(g=c=1,D(i.charCodeAt(1))){let u=2,M=u;for(;u<s&&!D(i.charCodeAt(u));)u++;if(u<s&&u!==M){for(M=u;u<s&&D(i.charCodeAt(u));)u++;if(u<s&&u!==M){for(M=u;u<s&&!D(i.charCodeAt(u));)u++;if(u===s)return i;u!==M&&(g=c=u+1)}}}}else L(p)&&i.charCodeAt(1)===A&&(g=s>2&&D(i.charCodeAt(2))?3:2,c=g);let w=-1,f=!0;for(let u=s-1;u>=c;--u)if(D(i.charCodeAt(u))){if(!f){w=u;break}}else f=!1;if(w===-1){if(g===-1)return".";w=g}return i.slice(0,w)},basename(i,s){s!==void 0&&e(s,"ext"),e(i,"path");let g=0,c=-1,p=!0,w;if(i.length>=2&&L(i.charCodeAt(0))&&i.charCodeAt(1)===A&&(g=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let f=s.length-1,u=-1;for(w=i.length-1;w>=g;--w){const M=i.charCodeAt(w);if(D(M)){if(!p){g=w+1;break}}else u===-1&&(p=!1,u=w+1),f>=0&&(M===s.charCodeAt(f)?--f===-1&&(c=w):(f=-1,c=u))}return g===c?c=u:c===-1&&(c=i.length),i.slice(g,c)}for(w=i.length-1;w>=g;--w)if(D(i.charCodeAt(w))){if(!p){g=w+1;break}}else c===-1&&(p=!1,c=w+1);return c===-1?"":i.slice(g,c)},extname(i){e(i,"path");let s=0,g=-1,c=0,p=-1,w=!0,f=0;i.length>=2&&i.charCodeAt(1)===A&&L(i.charCodeAt(0))&&(s=c=2);for(let u=i.length-1;u>=s;--u){const M=i.charCodeAt(u);if(D(M)){if(!w){c=u+1;break}continue}p===-1&&(w=!1,p=u+1),M===m?g===-1?g=u:f!==1&&(f=1):g!==-1&&(f=-1)}return g===-1||p===-1||f===0||f===1&&g===p-1&&g===c+1?"":i.slice(g,p)},format:b.bind(null,"\\"),parse(i){e(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const g=i.length;let c=0,p=i.charCodeAt(0);if(g===1)return D(p)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(D(p)){if(c=1,D(i.charCodeAt(1))){let U=2,H=U;for(;U<g&&!D(i.charCodeAt(U));)U++;if(U<g&&U!==H){for(H=U;U<g&&D(i.charCodeAt(U));)U++;if(U<g&&U!==H){for(H=U;U<g&&!D(i.charCodeAt(U));)U++;U===g?c=U:U!==H&&(c=U+1)}}}}else if(L(p)&&i.charCodeAt(1)===A){if(g<=2)return s.root=s.dir=i,s;if(c=2,D(i.charCodeAt(2))){if(g===3)return s.root=s.dir=i,s;c=3}}c>0&&(s.root=i.slice(0,c));let w=-1,f=c,u=-1,M=!0,S=i.length-1,O=0;for(;S>=c;--S){if(p=i.charCodeAt(S),D(p)){if(!M){f=S+1;break}continue}u===-1&&(M=!1,u=S+1),p===m?w===-1?w=S:O!==1&&(O=1):w!==-1&&(O=-1)}return u!==-1&&(w===-1||O===0||O===1&&w===u-1&&w===f+1?s.base=s.name=i.slice(f,u):(s.name=i.slice(f,w),s.base=i.slice(f,u),s.ext=i.slice(w,u))),f>0&&f!==c?s.dir=i.slice(0,f-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(C){const i=/\\/g;return()=>{const s=R.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>R.cwd()})();n.posix={resolve(...i){let s="",g=!1;for(let c=i.length-1;c>=-1&&!g;c--){const p=c>=0?i[c]:o();e(p,"path"),p.length!==0&&(s=`${p}/${s}`,g=p.charCodeAt(0)===a)}return s=d(s,!g,"/",E),g?`/${s}`:s.length>0?s:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===a,g=i.charCodeAt(i.length-1)===a;return i=d(i,!s,"/",E),i.length===0?s?"/":g?"./":".":(g&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===a},join(...i){if(i.length===0)return".";let s;for(let g=0;g<i.length;++g){const c=i[g];e(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":n.posix.normalize(s)},relative(i,s){if(e(i,"from"),e(s,"to"),i===s||(i=n.posix.resolve(i),s=n.posix.resolve(s),i===s))return"";const g=1,c=i.length,p=c-g,w=1,f=s.length-w,u=p<f?p:f;let M=-1,S=0;for(;S<u;S++){const U=i.charCodeAt(g+S);if(U!==s.charCodeAt(w+S))break;U===a&&(M=S)}if(S===u)if(f>u){if(s.charCodeAt(w+S)===a)return s.slice(w+S+1);if(S===0)return s.slice(w+S)}else p>u&&(i.charCodeAt(g+S)===a?M=S:S===0&&(M=0));let O="";for(S=g+M+1;S<=c;++S)(S===c||i.charCodeAt(S)===a)&&(O+=O.length===0?"..":"/..");return`${O}${s.slice(w+M)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===a;let g=-1,c=!0;for(let p=i.length-1;p>=1;--p)if(i.charCodeAt(p)===a){if(!c){g=p;break}}else c=!1;return g===-1?s?"/":".":s&&g===1?"//":i.slice(0,g)},basename(i,s){s!==void 0&&e(s,"ext"),e(i,"path");let g=0,c=-1,p=!0,w;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let f=s.length-1,u=-1;for(w=i.length-1;w>=0;--w){const M=i.charCodeAt(w);if(M===a){if(!p){g=w+1;break}}else u===-1&&(p=!1,u=w+1),f>=0&&(M===s.charCodeAt(f)?--f===-1&&(c=w):(f=-1,c=u))}return g===c?c=u:c===-1&&(c=i.length),i.slice(g,c)}for(w=i.length-1;w>=0;--w)if(i.charCodeAt(w)===a){if(!p){g=w+1;break}}else c===-1&&(p=!1,c=w+1);return c===-1?"":i.slice(g,c)},extname(i){e(i,"path");let s=-1,g=0,c=-1,p=!0,w=0;for(let f=i.length-1;f>=0;--f){const u=i.charCodeAt(f);if(u===a){if(!p){g=f+1;break}continue}c===-1&&(p=!1,c=f+1),u===m?s===-1?s=f:w!==1&&(w=1):s!==-1&&(w=-1)}return s===-1||c===-1||w===0||w===1&&s===c-1&&s===g+1?"":i.slice(s,c)},format:b.bind(null,"/"),parse(i){e(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const g=i.charCodeAt(0)===a;let c;g?(s.root="/",c=1):c=0;let p=-1,w=0,f=-1,u=!0,M=i.length-1,S=0;for(;M>=c;--M){const O=i.charCodeAt(M);if(O===a){if(!u){w=M+1;break}continue}f===-1&&(u=!1,f=M+1),O===m?p===-1?p=M:S!==1&&(S=1):p!==-1&&(S=-1)}if(f!==-1){const O=w===0&&g?1:w;p===-1||S===0||S===1&&p===f-1&&p===w+1?s.base=s.name=i.slice(O,f):(s.name=i.slice(O,p),s.base=i.slice(O,f),s.ext=i.slice(p,f))}return w>0?s.dir=i.slice(0,w-1):g&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=C?n.win32.normalize:n.posix.normalize,n.isAbsolute=C?n.win32.isAbsolute:n.posix.isAbsolute,n.join=C?n.win32.join:n.posix.join,n.resolve=C?n.win32.resolve:n.posix.resolve,n.relative=C?n.win32.relative:n.posix.relative,n.dirname=C?n.win32.dirname:n.posix.dirname,n.basename=C?n.win32.basename:n.posix.basename,n.extname=C?n.win32.extname:n.posix.extname,n.format=C?n.win32.format:n.posix.format,n.parse=C?n.win32.parse:n.posix.parse,n.toNamespacedPath=C?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=C?n.win32.sep:n.posix.sep,n.delimiter=C?n.win32.delimiter:n.posix.delimiter}),Z(J[20],x([0,1,5]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const t=R.globals.performance&&typeof R.globals.performance.now=="function";class F{static create(y=!0){return new F(y)}constructor(y){this.a=t&&y,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?R.globals.performance.now():Date.now()}}n.StopWatch=F}),Z(J[9],x([0,1,6,13,7,15,20]),function(q,n,R,t,F,l,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.EventDeliveryQueue=n.Emitter=n.setGlobalLeakWarningThreshold=n.EventProfiling=n.Event=void 0;const m=!1,a=!1;var h;(function(w){w.None=()=>F.Disposable.None;function f(te){if(a){const{onDidAddListener:G}=te,Y=e.create();let k=0;te.onDidAddListener=()=>{++k===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),G?.()}}}function u(te,G){return Q(te,()=>{},0,void 0,void 0,G)}w.defer=u;function M(te){return(G,Y=null,k)=>{let T=!1,I;return I=te(W=>{if(!T)return I?I.dispose():T=!0,G.call(Y,W)},null,k),T&&I.dispose(),I}}w.once=M;function S(te,G,Y){return ne((k,T=null,I)=>te(W=>k.call(T,G(W)),null,I),Y)}w.map=S;function O(te,G,Y){return ne((k,T=null,I)=>te(W=>{G(W),k.call(T,W)},null,I),Y)}w.forEach=O;function U(te,G,Y){return ne((k,T=null,I)=>te(W=>G(W)&&k.call(T,W),null,I),Y)}w.filter=U;function H(te){return te}w.signal=H;function z(...te){return(G,Y=null,k)=>(0,F.combinedDisposable)(...te.map(T=>T(I=>G.call(Y,I),null,k)))}w.any=z;function ee(te,G,Y,k){let T=Y;return S(te,I=>(T=G(T,I),T),k)}w.reduce=ee;function ne(te,G){let Y;const k={onWillAddFirstListener(){Y=te(T.fire,T)},onDidRemoveLastListener(){Y?.dispose()}};G||f(k);const T=new D(k);return G?.add(T),T.event}function Q(te,G,Y=100,k=!1,T,I){let W,j,re,ie=0;const ue={leakWarningThreshold:T,onWillAddFirstListener(){W=te(fe=>{ie++,j=G(j,fe),k&&!re&&(ae.fire(j),j=void 0),clearTimeout(re),re=setTimeout(()=>{const he=j;j=void 0,re=void 0,(!k||ie>1)&&ae.fire(he),ie=0},Y)})},onDidRemoveLastListener(){W.dispose()}};I||f(ue);const ae=new D(ue);return I?.add(ae),ae.event}w.debounce=Q;function K(te,G=0,Y){return w.debounce(te,(k,T)=>k?(k.push(T),k):[T],G,void 0,void 0,Y)}w.accumulate=K;function r(te,G=(k,T)=>k===T,Y){let k=!0,T;return U(te,I=>{const W=k||!G(I,T);return k=!1,T=I,W},Y)}w.latch=r;function ve(te,G,Y){return[w.filter(te,G,Y),w.filter(te,k=>!G(k),Y)]}w.split=ve;function Ae(te,G=!1,Y=[]){let k=Y.slice(),T=te(j=>{k?k.push(j):W.fire(j)});const I=()=>{k?.forEach(j=>W.fire(j)),k=null},W=new D({onWillAddFirstListener(){T||(T=te(j=>W.fire(j)))},onDidAddFirstListener(){k&&(G?setTimeout(I):I())},onDidRemoveLastListener(){T&&T.dispose(),T=null}});return W.event}w.buffer=Ae;class de{constructor(G){this.event=G,this.c=new F.DisposableStore}map(G){return new de(S(this.event,G,this.c))}forEach(G){return new de(O(this.event,G,this.c))}filter(G){return new de(U(this.event,G,this.c))}reduce(G,Y){return new de(ee(this.event,G,Y,this.c))}latch(){return new de(r(this.event,void 0,this.c))}debounce(G,Y=100,k=!1,T){return new de(Q(this.event,G,Y,k,T,this.c))}on(G,Y,k){return this.event(G,Y,k)}once(G,Y,k){return M(this.event)(G,Y,k)}dispose(){this.c.dispose()}}function Ce(te){return new de(te)}w.chain=Ce;function Le(te,G,Y=k=>k){const k=(...j)=>W.fire(Y(...j)),T=()=>te.on(G,k),I=()=>te.removeListener(G,k),W=new D({onWillAddFirstListener:T,onDidRemoveLastListener:I});return W.event}w.fromNodeEventEmitter=Le;function Ne(te,G,Y=k=>k){const k=(...j)=>W.fire(Y(...j)),T=()=>te.addEventListener(G,k),I=()=>te.removeEventListener(G,k),W=new D({onWillAddFirstListener:T,onDidRemoveLastListener:I});return W.event}w.fromDOMEventEmitter=Ne;function _e(te){return new Promise(G=>M(te)(G))}w.toPromise=_e;function Me(te,G){return G(void 0),te(Y=>G(Y))}w.runAndSubscribe=Me;function De(te,G){let Y=null;function k(I){Y?.dispose(),Y=new F.DisposableStore,G(I,Y)}k(void 0);const T=te(I=>k(I));return(0,F.toDisposable)(()=>{T.dispose(),Y?.dispose()})}w.runAndSubscribeWithStore=De;class Ee{constructor(G,Y){this.obs=G,this.c=0,this.d=!1;const k={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Y||f(k),this.emitter=new D(k),Y&&Y.add(this.emitter)}beginUpdate(G){this.c++}handleChange(G,Y){this.d=!0}endUpdate(G){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function Fe(te,G){return new Ee(te,G).emitter.event}w.fromObservable=Fe})(h=n.Event||(n.Event={}));class A{constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${A.c++}`,A.all.add(this)}start(f){this.d=new y.StopWatch(!0),this.listenerCount=f}stop(){if(this.d){const f=this.d.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.d=void 0}}}n.EventProfiling=A,A.all=new Set,A.c=0;let _=-1;function N(w){const f=_;return _=w,{dispose(){_=f}}}n.setGlobalLeakWarningThreshold=N;class v{constructor(f,u=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=u,this.d=0}dispose(){this.c?.clear()}check(f,u){const M=this.threshold;if(M<=0||u<M)return;this.c||(this.c=new Map);const S=this.c.get(f.value)||0;if(this.c.set(f.value,S+1),this.d-=1,this.d<=0){this.d=M*.5;let O,U=0;for(const[H,z]of this.c)(!O||U<z)&&(O=H,U=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${U}):`),console.warn(O)}return()=>{const O=this.c.get(f.value)||0;this.c.set(f.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class C{constructor(f,u,M){this.callback=f,this.callbackThis=u,this.stack=M,this.subscription=new F.SafeDisposable}invoke(f){this.callback.call(this.callbackThis,f)}}class D{constructor(f){this.j=!1,this.d=f,this.f=_>0||this.d?.leakWarningThreshold?new v(this.d?.leakWarningThreshold??_):void 0,this.g=this.d?._profName?new A(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(m){const f=Array.from(this.q);queueMicrotask(()=>{for(const u of f)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(f,u,M)=>{if(this.q||(this.q=new l.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),F.Disposable.None;const S=this.q.isEmpty();S&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,U;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(U=e.create(),O=this.f.check(U,this.q.size+1)),m&&(U=U??e.create());const H=new C(f,u,U),z=this.q.push(H);S&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,f,u);const ee=H.subscription.set(()=>{O?.(),this.j||(z(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return M instanceof F.DisposableStore?M.add(ee):Array.isArray(M)&&M.push(ee),ee}),this.l}fire(f){if(this.q){this.m||(this.m=new L);for(const u of this.q)this.m.push(this,u,f);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}n.Emitter=D;class E{constructor(){this.c=new l.LinkedList}get size(){return this.c.size}push(f,u,M){this.c.push(new d(f,u,M))}clear(f){const u=new l.LinkedList;for(const M of this.c)M.emitter!==f&&u.push(M);this.c=u}deliver(){for(;this.c.size>0;){const f=this.c.shift();try{f.listener.invoke(f.event)}catch(u){(0,R.onUnexpectedError)(u)}}}}n.EventDeliveryQueue=E;class L extends E{clear(f){this.c.clear()}}class d{constructor(f,u,M){this.emitter=f,this.listener=u,this.event=M}}class b extends D{async fireAsync(f,u,M){if(!!this.q){this.c||(this.c=new l.LinkedList);for(const S of this.q)this.c.push([S,f]);for(;this.c.size>0&&!u.isCancellationRequested;){const[S,O]=this.c.shift(),U=[],H={...O,token:u,waitUntil:z=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");M&&(z=M(z,S.callback)),U.push(z)}};try{S.invoke(H)}catch(z){(0,R.onUnexpectedError)(z);continue}Object.freeze(U),await Promise.allSettled(U).then(z=>{for(const ee of z)ee.status==="rejected"&&(0,R.onUnexpectedError)(ee.reason)})}}}}n.AsyncEmitter=b;class o extends D{constructor(f){super(f),this.h=0,this.s=new l.LinkedList,this.t=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.t(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.q&&(this.h!==0?this.s.push(f):super.fire(f))}}n.PauseableEmitter=o;class i extends o{constructor(f){super(f),this.c=f.delay??100}fire(f){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(f)}}n.DebounceEmitter=i;class s extends D{constructor(f){super(f),this.c=[],this.h=f?.merge}fire(f){!this.hasListeners()||(this.c.push(f),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}n.MicrotaskEmitter=s;class g{constructor(){this.d=!1,this.f=[],this.c=new D({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(f){const u={event:f,listener:null};this.f.push(u),this.d&&this.j(u);const M=()=>{this.d&&this.k(u);const S=this.f.indexOf(u);this.f.splice(S,1)};return(0,F.toDisposable)((0,t.once)(M))}g(){this.d=!0,this.f.forEach(f=>this.j(f))}h(){this.d=!1,this.f.forEach(f=>this.k(f))}j(f){f.listener=f.event(u=>this.c.fire(u))}k(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.c.dispose()}}n.EventMultiplexer=g;class c{constructor(){this.c=[]}wrapEvent(f){return(u,M,S)=>f(O=>{const U=this.c[this.c.length-1];U?U.push(()=>u.call(M,O)):u.call(M,O)},void 0,S)}bufferEvents(f){const u=[];this.c.push(u);const M=f();return this.c.pop(),u.forEach(S=>S()),M}}n.EventBufferer=c;class p{constructor(){this.c=!1,this.d=h.None,this.f=F.Disposable.None,this.g=new D({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(f){this.d=f,this.c&&(this.f.dispose(),this.f=f(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}n.Relay=p}),Z(J[21],x([0,1,9]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const t=Object.freeze(function(m,a){const h=setTimeout(m.bind(a),0);return{dispose(){clearTimeout(h)}}});var F;(function(m){function a(h){return h===m.None||h===m.Cancelled||h instanceof l?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}m.isCancellationToken=a,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(F=n.CancellationToken||(n.CancellationToken={}));class l{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new R.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class y{constructor(a){this.a=void 0,this.b=void 0,this.b=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new l),this.a}cancel(){this.a?this.a instanceof l&&this.a.cancel():this.a=F.Cancelled}dispose(a=!1){a&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof l&&this.a.dispose():this.a=F.None}}n.CancellationTokenSource=y}),Z(J[45],x([0,1,21]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=n.Cache=void 0;class t{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new R.CancellationTokenSource,a=this.b(m.token);return this.a={promise:a,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}n.Cache=t;class F{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const a=JSON.stringify(m);return this.b!==a&&(this.b=a,this.a=this.c(m)),this.a}}n.LRUCachedFunction=F;class l{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const a=this.b(m);return this.a.set(m,a),a}}n.CachedFunction=l}),Z(J[4],x([0,1,45,28]),function(q,n,R,t){"use strict";var F;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.charCount=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.replaceAsync=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function l(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=l;const y=/{(\d+)}/g;function m(P,...B){return B.length===0?P:P.replace(y,function(V,$){const X=parseInt($,10);return isNaN(X)||X<0||X>=B.length?V:B[X]})}n.format=m;const a=/{([^}]+)}/g;function h(P,B){return P.replace(a,(V,$)=>B[$]??V)}n.format2=h;function A(P){return P.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}n.escape=A;function _(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=_;function N(P,B){let V=0;const $=B.charCodeAt(0);for(let X=P.length-1;X>=0;X--)P.charCodeAt(X)===$&&V++;return V}n.count=N;function v(P,B,V="\u2026"){return P.length<=B?P:`${P.substr(0,B)}${V}`}n.truncate=v;function e(P,B=" "){const V=C(P,B);return D(V,B)}n.trim=e;function C(P,B){if(!P||!B)return P;const V=B.length;if(V===0||P.length===0)return P;let $=0;for(;P.indexOf(B,$)===$;)$=$+V;return P.substring($)}n.ltrim=C;function D(P,B){if(!P||!B)return P;const V=B.length,$=P.length;if(V===0||$===0)return P;let X=$,se=-1;for(;se=P.lastIndexOf(B,X-1),!(se===-1||se+V!==X);){if(se===0)return"";X=se}return P.substring(0,X)}n.rtrim=D;function E(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=E;function L(P){return P.replace(/\*/g,"")}n.stripWildcards=L;function d(P,B,V={}){if(!P)throw new Error("Cannot create regex from empty string");B||(P=_(P)),V.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let $="";return V.global&&($+="g"),V.matchCase||($+="i"),V.multiline&&($+="m"),V.unicode&&($+="u"),new RegExp(P,$)}n.createRegExp=d;function b(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=b;function o(P){return!!P.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=o;function i(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}n.regExpFlags=i;function s(P){return P.split(/\r\n|\r|\n/)}n.splitLines=s;function g(P){for(let B=0,V=P.length;B<V;B++){const $=P.charCodeAt(B);if($!==32&&$!==9)return B}return-1}n.firstNonWhitespaceIndex=g;function c(P,B=0,V=P.length){for(let $=B;$<V;$++){const X=P.charCodeAt($);if(X!==32&&X!==9)return P.substring(B,$)}return P.substring(B,V)}n.getLeadingWhitespace=c;function p(P,B=P.length-1){for(let V=B;V>=0;V--){const $=P.charCodeAt(V);if($!==32&&$!==9)return V}return-1}n.lastNonWhitespaceIndex=p;function w(P,B,V){const $=[];let X=0;for(const se of P.matchAll(B)){if($.push(P.slice(X,se.index)),se.index===void 0)throw new Error("match.index should be defined");X=se.index+se[0].length,$.push(V(se[0],...se.slice(1),se.index,P,se.groups))}return $.push(P.slice(X)),Promise.all($).then(se=>se.join(""))}n.replaceAsync=w;function f(P,B){return P<B?-1:P>B?1:0}n.compare=f;function u(P,B,V=0,$=P.length,X=0,se=B.length){for(;V<$&&X<se;V++,X++){const be=P.charCodeAt(V),oe=B.charCodeAt(X);if(be<oe)return-1;if(be>oe)return 1}const ce=$-V,ye=se-X;return ce<ye?-1:ce>ye?1:0}n.compareSubstring=u;function M(P,B){return S(P,B,0,P.length,0,B.length)}n.compareIgnoreCase=M;function S(P,B,V=0,$=P.length,X=0,se=B.length){for(;V<$&&X<se;V++,X++){let be=P.charCodeAt(V),oe=B.charCodeAt(X);if(be===oe)continue;if(be>=128||oe>=128)return u(P.toLowerCase(),B.toLowerCase(),V,$,X,se);U(be)&&(be-=32),U(oe)&&(oe-=32);const ge=be-oe;if(ge!==0)return ge}const ce=$-V,ye=se-X;return ce<ye?-1:ce>ye?1:0}n.compareSubstringIgnoreCase=S;function O(P){return P>=48&&P<=57}n.isAsciiDigit=O;function U(P){return P>=97&&P<=122}n.isLowerAsciiLetter=U;function H(P){return P>=65&&P<=90}n.isUpperAsciiLetter=H;function z(P,B){return P.length===B.length&&S(P,B)===0}n.equalsIgnoreCase=z;function ee(P,B){const V=B.length;return B.length>P.length?!1:S(P,B,0,V)===0}n.startsWithIgnoreCase=ee;function ne(P,B){const V=Math.min(P.length,B.length);let $;for($=0;$<V;$++)if(P.charCodeAt($)!==B.charCodeAt($))return $;return V}n.commonPrefixLength=ne;function Q(P,B){const V=Math.min(P.length,B.length);let $;const X=P.length-1,se=B.length-1;for($=0;$<V;$++)if(P.charCodeAt(X-$)!==B.charCodeAt(se-$))return $;return V}n.commonSuffixLength=Q;function K(P){return 55296<=P&&P<=56319}n.isHighSurrogate=K;function r(P){return 56320<=P&&P<=57343}n.isLowSurrogate=r;function ve(P,B){return(P-55296<<10)+(B-56320)+65536}n.computeCodePoint=ve;function Ae(P,B,V){const $=P.charCodeAt(V);if(K($)&&V+1<B){const X=P.charCodeAt(V+1);if(r(X))return ve($,X)}return $}n.getNextCodePoint=Ae;function de(P,B){const V=P.charCodeAt(B-1);if(r(V)&&B>1){const $=P.charCodeAt(B-2);if(K($))return ve($,V)}return V}class Ce{get offset(){return this.e}constructor(B,V=0){this.c=B,this.d=B.length,this.e=V}setOffset(B){this.e=B}prevCodePoint(){const B=de(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=Ae(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}n.CodePointIterator=Ce;class Le{get offset(){return this.c.offset}constructor(B,V=0){this.c=new Ce(B,V)}nextGraphemeLength(){const B=pe.getInstance(),V=this.c,$=V.offset;let X=B.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const se=V.offset,ce=B.getGraphemeBreakType(V.nextCodePoint());if(Te(X,ce)){V.setOffset(se);break}X=ce}return V.offset-$}prevGraphemeLength(){const B=pe.getInstance(),V=this.c,$=V.offset;let X=B.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const se=V.offset,ce=B.getGraphemeBreakType(V.prevCodePoint());if(Te(ce,X)){V.setOffset(se);break}X=ce}return $-V.offset}eol(){return this.c.eol()}}n.GraphemeIterator=Le;function Ne(P,B){return new Le(P,B).nextGraphemeLength()}n.nextCharLength=Ne;function _e(P,B){return new Le(P,B).prevGraphemeLength()}n.prevCharLength=_e;function Me(P,B){B>0&&r(P.charCodeAt(B))&&B--;const V=B+Ne(P,B);return[V-_e(P,V),V]}n.getCharContainingOffset=Me;function De(P){const B=new Le(P);let V=0;for(;!B.eol();)V++,B.nextGraphemeLength();return V}n.charCount=De;let Ee;function Fe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function te(P){return Ee||(Ee=Fe()),Ee.test(P)}n.containsRTL=te;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(P){return G.test(P)}n.isBasicASCII=Y,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function k(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=k;function T(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=T;function I(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=I;function W(P,B){if(P.length<B)return P;const V=/\b/g;let $=0;for(;V.test(P)&&!(P.length-V.lastIndex<B);)$=V.lastIndex,V.lastIndex+=1;return P.substring($).replace(/^\s/,"")}n.lcut=W;const j=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ue(P){return P&&(P=P.replace(j,""),P=P.replace(re,""),P=P.replace(ie,"")),P}n.removeAnsiEscapeCodes=ue,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ae;function fe(P){return ae(P)?P.substr(1):P}n.stripUTF8BOM=fe;function he(P,B){if(!P||!B||P.length<B.length)return!1;const V=B.length,$=P.toLowerCase();let X=0,se=-1;for(;X<V;){const ce=$.indexOf(B[X],se+1);if(ce<0)return!1;se=ce,X++}return!0}n.fuzzyContains=he;function ke(P,B=!1){return P?(B&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=ke;function Be(P){return P.charAt(0).toUpperCase()+P.slice(1)}n.uppercaseFirstLetter=Be;function qe(P,B=1){if(B===0)return"";let V=-1;do V=P.indexOf(`
`,V+1),B--;while(B>0&&V>=0);return V===-1?P:(P[V-1]==="\r"&&V--,P.substr(0,V))}n.getNLines=qe;function We(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}n.singleLetterHash=We;function Ve(P){return pe.getInstance().getGraphemeBreakType(P)}n.getGraphemeBreakType=Ve;function Te(P,B){return P===0?B!==5&&B!==7:P===2&&B===3?!1:P===4||P===2||P===3||B===4||B===2||B===3?!0:!(P===8&&(B===8||B===9||B===11||B===12)||(P===11||P===9)&&(B===9||B===10)||(P===12||P===10)&&B===10||B===5||B===13||B===7||P===1||P===13&&B===14||P===6&&B===6)}var He;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(He=n.GraphemeBreakType||(n.GraphemeBreakType={}));class pe{static getInstance(){return pe.c||(pe.c=new pe),pe.c}constructor(){this.d=je()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const V=this.d,$=V.length/3;let X=1;for(;X<=$;)if(B<V[3*X])X=2*X;else if(B>V[3*X+1])X=2*X+1;else return V[3*X+2];return 0}}pe.c=null;function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(P,B){if(P===0)return 0;const V=$e(P,B);if(V!==void 0)return V;const $=new Ce(B,P);return $.prevCodePoint(),$.offset}n.getLeftDeleteOffset=ze;function $e(P,B){const V=new Ce(B,P);let $=V.prevCodePoint();for(;Ge($)||$===65039||$===8419;){if(V.offset===0)return;$=V.prevCodePoint()}if(!I($))return;let X=V.offset;return X>0&&V.prevCodePoint()===8205&&(X=V.offset),X}function Ge(P){return 127995<=P&&P<=127999}var Ie;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(Ie||(Ie={})),n.noBreakWhitespace="\xA0";class me{static getInstance(B){return me.d.get(Array.from(B))}static getLocales(){return me.e.getValue()}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}n.AmbiguousCharacters=me,F=me,me.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),me.d=new R.LRUCachedFunction(P=>{function B(oe){const ge=new Map;for(let we=0;we<oe.length;we+=2)ge.set(oe[we],oe[we+1]);return ge}function V(oe,ge){const we=new Map(oe);for(const[Pe,Se]of ge)we.set(Pe,Se);return we}function $(oe,ge){if(!oe)return ge;const we=new Map;for(const[Pe,Se]of oe)ge.has(Pe)&&we.set(Pe,Se);return we}const X=F.c.getValue();let se=P.filter(oe=>!oe.startsWith("_")&&oe in X);se.length===0&&(se=["_default"]);let ce;for(const oe of se){const ge=B(X[oe]);ce=$(ce,ge)}const ye=B(X._common),be=V(ye,ce);return new me(be)}),me.e=new t.Lazy(()=>Object.keys(me.c.getValue()).filter(P=>!P.startsWith("_")));class Re{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Re.c())),this.d}static isInvisibleCharacter(B){return Re.e().has(B)}static get codePoints(){return Re.e()}}n.InvisibleCharacters=Re,Re.d=void 0}),Z(J[46],x([0,1,4]),function(q,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function t(E){return F(E,0)}n.hash=t;function F(E,L){switch(typeof E){case"object":return E===null?l(349,L):Array.isArray(E)?a(E,L):h(E,L);case"string":return m(E,L);case"boolean":return y(E,L);case"number":return l(E,L);case"undefined":return l(937,L);default:return l(617,L)}}n.doHash=F;function l(E,L){return(L<<5)-L+E|0}n.numberHash=l;function y(E,L){return l(E?433:863,L)}function m(E,L){L=l(149417,L);for(let d=0,b=E.length;d<b;d++)L=l(E.charCodeAt(d),L);return L}n.stringHash=m;function a(E,L){return L=l(104579,L),E.reduce((d,b)=>F(b,d),L)}function h(E,L){return L=l(181387,L),Object.keys(E).sort().reduce((d,b)=>(d=m(b,d),F(E[b],d)),L)}class A{constructor(){this.g=0}get value(){return this.g}hash(L){return this.g=F(L,this.g),this.g}}n.Hasher=A;var _;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(_||(_={}));function N(E,L,d=32){const b=d-L,o=~((1<<b)-1);return(E<<L|(o&E)>>>b)>>>0}function v(E,L=0,d=E.byteLength,b=0){for(let o=0;o<d;o++)E[L+o]=b}function e(E,L,d="0"){for(;E.length<L;)E=d+E;return E}function C(E,L=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(d=>d.toString(16).padStart(2,"0")).join(""):e((E>>>0).toString(16),L/4)}n.toHexString=C;class D{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(L){const d=L.length;if(d===0)return;const b=this.p;let o=this.r,i=this.u,s,g;for(i!==0?(s=i,g=-1,i=0):(s=L.charCodeAt(0),g=0);;){let c=s;if(R.isHighSurrogate(s))if(g+1<d){const p=L.charCodeAt(g+1);R.isLowSurrogate(p)?(g++,c=R.computeCodePoint(s,p)):c=65533}else{i=s;break}else R.isLowSurrogate(s)&&(c=65533);if(o=this.w(b,o,c),g++,g<d)s=L.charCodeAt(g);else break}this.r=o,this.u=i}w(L,d,b){return b<128?L[d++]=b:b<2048?(L[d++]=192|(b&1984)>>>6,L[d++]=128|(b&63)>>>0):b<65536?(L[d++]=224|(b&61440)>>>12,L[d++]=128|(b&4032)>>>6,L[d++]=128|(b&63)>>>0):(L[d++]=240|(b&1835008)>>>18,L[d++]=128|(b&258048)>>>12,L[d++]=128|(b&4032)>>>6,L[d++]=128|(b&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,L[0]=L[64+0],L[1]=L[64+1],L[2]=L[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),C(this.h)+C(this.l)+C(this.m)+C(this.n)+C(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const L=8*this.t;this.q.setUint32(56,Math.floor(L/4294967296),!1),this.q.setUint32(60,L%4294967296,!1),this.y()}y(){const L=D.g,d=this.q;for(let f=0;f<64;f+=4)L.setUint32(f,d.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)L.setUint32(f,N(L.getUint32(f-12,!1)^L.getUint32(f-32,!1)^L.getUint32(f-56,!1)^L.getUint32(f-64,!1),1),!1);let b=this.h,o=this.l,i=this.m,s=this.n,g=this.o,c,p,w;for(let f=0;f<80;f++)f<20?(c=o&i|~o&s,p=1518500249):f<40?(c=o^i^s,p=1859775393):f<60?(c=o&i|o&s|i&s,p=2400959708):(c=o^i^s,p=3395469782),w=N(b,5)+c+g+p+L.getUint32(f*4,!1)&4294967295,g=s,s=i,i=N(o,30),o=b,b=w;this.h=this.h+b&4294967295,this.l=this.l+o&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+g&4294967295}}n.StringSHA1=D,D.g=new DataView(new ArrayBuffer(320))}),Z(J[22],x([0,1,25,46]),function(q,n,R,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class F{constructor(N){this.a=N}getElements(){const N=this.a,v=new Int32Array(N.length);for(let e=0,C=N.length;e<C;e++)v[e]=N.charCodeAt(e);return v}}n.StringDiffSequence=F;function l(_,N,v){return new A(new F(_),new F(N)).ComputeDiff(v).changes}n.stringDiff=l;class y{static Assert(N,v){if(!N)throw new Error(v)}}class m{static Copy(N,v,e,C,D){for(let E=0;E<D;E++)e[C+E]=N[v+E]}static Copy2(N,v,e,C,D){for(let E=0;E<D;E++)e[C+E]=N[v+E]}}var a;(function(_){_[_.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class h{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new R.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(N,v){this.b=Math.min(this.b,N),this.c=Math.min(this.c,v),this.d++}AddModifiedElement(N,v){this.b=Math.min(this.b,N),this.c=Math.min(this.c,v),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class A{constructor(N,v,e=null){this.a=e,this.b=N,this.c=v;const[C,D,E]=A.o(N),[L,d,b]=A.o(v);this.d=E&&b,this.e=C,this.f=D,this.g=L,this.h=d,this.k=[],this.m=[]}static n(N){return N.length>0&&typeof N[0]=="string"}static o(N){const v=N.getElements();if(A.n(v)){const e=new Int32Array(v.length);for(let C=0,D=v.length;C<D;C++)e[C]=(0,t.stringHash)(v[C],0);return[v,e,!0]}return v instanceof Int32Array?[[],v,!1]:[[],new Int32Array(v),!1]}p(N,v){return this.f[N]!==this.h[v]?!1:this.d?this.e[N]===this.g[v]:!0}q(N,v){if(!this.p(N,v))return!1;const e=A.r(this.b,N),C=A.r(this.c,v);return e===C}static r(N,v){return typeof N.getStrictElement=="function"?N.getStrictElement(v):null}s(N,v){return this.f[N]!==this.f[v]?!1:this.d?this.e[N]===this.e[v]:!0}u(N,v){return this.h[N]!==this.h[v]?!1:this.d?this.g[N]===this.g[v]:!0}ComputeDiff(N){return this.v(0,this.f.length-1,0,this.h.length-1,N)}v(N,v,e,C,D){const E=[!1];let L=this.w(N,v,e,C,E);return D&&(L=this.z(L)),{quitEarly:E[0],changes:L}}w(N,v,e,C,D){for(D[0]=!1;N<=v&&e<=C&&this.p(N,e);)N++,e++;for(;v>=N&&C>=e&&this.p(v,C);)v--,C--;if(N>v||e>C){let i;return e<=C?(y.Assert(N===v+1,"originalStart should only be one more than originalEnd"),i=[new R.DiffChange(N,0,e,C-e+1)]):N<=v?(y.Assert(e===C+1,"modifiedStart should only be one more than modifiedEnd"),i=[new R.DiffChange(N,v-N+1,e,0)]):(y.Assert(N===v+1,"originalStart should only be one more than originalEnd"),y.Assert(e===C+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const E=[0],L=[0],d=this.y(N,v,e,C,E,L,D),b=E[0],o=L[0];if(d!==null)return d;if(!D[0]){const i=this.w(N,b,e,o,D);let s=[];return D[0]?s=[new R.DiffChange(b+1,v-(b+1)+1,o+1,C-(o+1)+1)]:s=this.w(b+1,v,o+1,C,D),this.H(i,s)}return[new R.DiffChange(N,v-N+1,e,C-e+1)]}x(N,v,e,C,D,E,L,d,b,o,i,s,g,c,p,w,f,u){let M=null,S=null,O=new h,U=v,H=e,z=g[0]-w[0]-C,ee=-1073741824,ne=this.k.length-1;do{const Q=z+N;Q===U||Q<H&&b[Q-1]<b[Q+1]?(i=b[Q+1],c=i-z-C,i<ee&&O.MarkNextChange(),ee=i,O.AddModifiedElement(i+1,c),z=Q+1-N):(i=b[Q-1]+1,c=i-z-C,i<ee&&O.MarkNextChange(),ee=i-1,O.AddOriginalElement(i,c+1),z=Q-1-N),ne>=0&&(b=this.k[ne],N=b[0],U=1,H=b.length-1)}while(--ne>=-1);if(M=O.getReverseChanges(),u[0]){let Q=g[0]+1,K=w[0]+1;if(M!==null&&M.length>0){const r=M[M.length-1];Q=Math.max(Q,r.getOriginalEnd()),K=Math.max(K,r.getModifiedEnd())}S=[new R.DiffChange(Q,s-Q+1,K,p-K+1)]}else{O=new h,U=E,H=L,z=g[0]-w[0]-d,ee=1073741824,ne=f?this.m.length-1:this.m.length-2;do{const Q=z+D;Q===U||Q<H&&o[Q-1]>=o[Q+1]?(i=o[Q+1]-1,c=i-z-d,i>ee&&O.MarkNextChange(),ee=i+1,O.AddOriginalElement(i+1,c+1),z=Q+1-D):(i=o[Q-1],c=i-z-d,i>ee&&O.MarkNextChange(),ee=i,O.AddModifiedElement(i+1,c+1),z=Q-1-D),ne>=0&&(o=this.m[ne],D=o[0],U=1,H=o.length-1)}while(--ne>=-1);S=O.getChanges()}return this.H(M,S)}y(N,v,e,C,D,E,L){let d=0,b=0,o=0,i=0,s=0,g=0;N--,e--,D[0]=0,E[0]=0,this.k=[],this.m=[];const c=v-N+(C-e),p=c+1,w=new Int32Array(p),f=new Int32Array(p),u=C-e,M=v-N,S=N-e,O=v-C,H=(M-u)%2===0;w[u]=N,f[M]=v,L[0]=!1;for(let z=1;z<=c/2+1;z++){let ee=0,ne=0;o=this.J(u-z,z,u,p),i=this.J(u+z,z,u,p);for(let K=o;K<=i;K+=2){K===o||K<i&&w[K-1]<w[K+1]?d=w[K+1]:d=w[K-1]+1,b=d-(K-u)-S;const r=d;for(;d<v&&b<C&&this.p(d+1,b+1);)d++,b++;if(w[K]=d,d+b>ee+ne&&(ee=d,ne=b),!H&&Math.abs(K-M)<=z-1&&d>=f[K])return D[0]=d,E[0]=b,r<=f[K]&&1447>0&&z<=1447+1?this.x(u,o,i,S,M,s,g,O,w,f,d,v,D,b,C,E,H,L):null}const Q=(ee-N+(ne-e)-z)/2;if(this.a!==null&&!this.a(ee,Q))return L[0]=!0,D[0]=ee,E[0]=ne,Q>0&&1447>0&&z<=1447+1?this.x(u,o,i,S,M,s,g,O,w,f,d,v,D,b,C,E,H,L):(N++,e++,[new R.DiffChange(N,v-N+1,e,C-e+1)]);s=this.J(M-z,z,M,p),g=this.J(M+z,z,M,p);for(let K=s;K<=g;K+=2){K===s||K<g&&f[K-1]>=f[K+1]?d=f[K+1]-1:d=f[K-1],b=d-(K-M)-O;const r=d;for(;d>N&&b>e&&this.p(d,b);)d--,b--;if(f[K]=d,H&&Math.abs(K-u)<=z&&d<=w[K])return D[0]=d,E[0]=b,r>=w[K]&&1447>0&&z<=1447+1?this.x(u,o,i,S,M,s,g,O,w,f,d,v,D,b,C,E,H,L):null}if(z<=1447){let K=new Int32Array(i-o+2);K[0]=u-o+1,m.Copy2(w,o,K,1,i-o+1),this.k.push(K),K=new Int32Array(g-s+2),K[0]=M-s+1,m.Copy2(f,s,K,1,g-s+1),this.m.push(K)}}return this.x(u,o,i,S,M,s,g,O,w,f,d,v,D,b,C,E,H,L)}z(N){for(let v=0;v<N.length;v++){const e=N[v],C=v<N.length-1?N[v+1].originalStart:this.f.length,D=v<N.length-1?N[v+1].modifiedStart:this.h.length,E=e.originalLength>0,L=e.modifiedLength>0;for(;e.originalStart+e.originalLength<C&&e.modifiedStart+e.modifiedLength<D&&(!E||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!L||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const d=[null];if(v<N.length-1&&this.I(N[v],N[v+1],d)){N[v]=d[0],N.splice(v+1,1),v--;continue}}for(let v=N.length-1;v>=0;v--){const e=N[v];let C=0,D=0;if(v>0){const i=N[v-1];C=i.originalStart+i.originalLength,D=i.modifiedStart+i.modifiedLength}const E=e.originalLength>0,L=e.modifiedLength>0;let d=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const s=e.originalStart-i,g=e.modifiedStart-i;if(s<C||g<D||E&&!this.s(s,s+e.originalLength)||L&&!this.u(g,g+e.modifiedLength))break;const p=(s===C&&g===D?5:0)+this.G(s,e.originalLength,g,e.modifiedLength);p>b&&(b=p,d=i)}e.originalStart-=d,e.modifiedStart-=d;const o=[null];if(v>0&&this.I(N[v-1],N[v],o)){N[v-1]=o[0],N.splice(v,1),v++;continue}}if(this.d)for(let v=1,e=N.length;v<e;v++){const C=N[v-1],D=N[v],E=D.originalStart-C.originalStart-C.originalLength,L=C.originalStart,d=D.originalStart+D.originalLength,b=d-L,o=C.modifiedStart,i=D.modifiedStart+D.modifiedLength,s=i-o;if(E<5&&b<20&&s<20){const g=this.A(L,b,o,s,E);if(g){const[c,p]=g;(c!==C.originalStart+C.originalLength||p!==C.modifiedStart+C.modifiedLength)&&(C.originalLength=c-C.originalStart,C.modifiedLength=p-C.modifiedStart,D.originalStart=c+E,D.modifiedStart=p+E,D.originalLength=d-D.originalStart,D.modifiedLength=i-D.modifiedStart)}}}return N}A(N,v,e,C,D){if(v<D||C<D)return null;const E=N+v-D+1,L=e+C-D+1;let d=0,b=0,o=0;for(let i=N;i<E;i++)for(let s=e;s<L;s++){const g=this.B(i,s,D);g>0&&g>d&&(d=g,b=i,o=s)}return d>0?[b,o]:null}B(N,v,e){let C=0;for(let D=0;D<e;D++){if(!this.p(N+D,v+D))return 0;C+=this.e[N+D].length}return C}C(N){return N<=0||N>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[N])}D(N,v){if(this.C(N)||this.C(N-1))return!0;if(v>0){const e=N+v;if(this.C(e-1)||this.C(e))return!0}return!1}E(N){return N<=0||N>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[N])}F(N,v){if(this.E(N)||this.E(N-1))return!0;if(v>0){const e=N+v;if(this.E(e-1)||this.E(e))return!0}return!1}G(N,v,e,C){const D=this.D(N,v)?1:0,E=this.F(e,C)?1:0;return D+E}H(N,v){const e=[];if(N.length===0||v.length===0)return v.length>0?v:N;if(this.I(N[N.length-1],v[0],e)){const C=new Array(N.length+v.length-1);return m.Copy(N,0,C,0,N.length-1),C[N.length-1]=e[0],m.Copy(v,1,C,N.length,v.length-1),C}else{const C=new Array(N.length+v.length);return m.Copy(N,0,C,0,N.length),m.Copy(v,0,C,N.length,v.length),C}}I(N,v,e){if(y.Assert(N.originalStart<=v.originalStart,"Left change is not less than or equal to right change"),y.Assert(N.modifiedStart<=v.modifiedStart,"Left change is not less than or equal to right change"),N.originalStart+N.originalLength>=v.originalStart||N.modifiedStart+N.modifiedLength>=v.modifiedStart){const C=N.originalStart;let D=N.originalLength;const E=N.modifiedStart;let L=N.modifiedLength;return N.originalStart+N.originalLength>=v.originalStart&&(D=v.originalStart+v.originalLength-N.originalStart),N.modifiedStart+N.modifiedLength>=v.modifiedStart&&(L=v.modifiedStart+v.modifiedLength-N.modifiedStart),e[0]=new R.DiffChange(C,D,E,L),!0}else return e[0]=null,!1}J(N,v,e,C){if(N>=0&&N<C)return N;const D=e,E=C-e-1,L=v%2===0;if(N<0){const d=D%2===0;return L===d?0:1}else{const d=E%2===0;return L===d?C-1:C-2}}}n.LcsDiff=A}),Z(J[12],x([0,1,44,5]),function(q,n,R,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const F=/^\w[\w\d+.-]*$/,l=/^\//,y=/^\/\//;function m(g,c){if(!g.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!F.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!l.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(g,c){return!g&&!c?"file":g}function h(g,c){switch(g){case"https":case"http":case"file":c?c[0]!==_&&(c=_+c):c=_;break}return c}const A="",_="/",N=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(c){return c instanceof v?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,p,w,f,u,M=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=a(c,M),this.authority=p||A,this.path=h(this.scheme,w||A),this.query=f||A,this.fragment=u||A,m(this,M))}get fsPath(){return d(this,!1)}with(c){if(!c)return this;let{scheme:p,authority:w,path:f,query:u,fragment:M}=c;return p===void 0?p=this.scheme:p===null&&(p=A),w===void 0?w=this.authority:w===null&&(w=A),f===void 0?f=this.path:f===null&&(f=A),u===void 0?u=this.query:u===null&&(u=A),M===void 0?M=this.fragment:M===null&&(M=A),p===this.scheme&&w===this.authority&&f===this.path&&u===this.query&&M===this.fragment?this:new C(p,w,f,u,M)}static parse(c,p=!1){const w=N.exec(c);return w?new C(w[2]||A,s(w[4]||A),s(w[5]||A),s(w[7]||A),s(w[9]||A),p):new C(A,A,A,A,A)}static file(c){let p=A;if(t.isWindows&&(c=c.replace(/\\/g,_)),c[0]===_&&c[1]===_){const w=c.indexOf(_,2);w===-1?(p=c.substring(2),c=_):(p=c.substring(2,w),c=c.substring(w)||_)}return new C("file",p,c,A,A)}static from(c){const p=new C(c.scheme,c.authority,c.path,c.query,c.fragment);return m(p,!0),p}static joinPath(c,...p){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return t.isWindows&&c.scheme==="file"?w=v.file(R.win32.join(d(c,!0),...p)).path:w=R.posix.join(c.path,...p),c.with({path:w})}toString(c=!1){return b(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof v)return c;{const p=new C(c);return p._formatted=c.external,p._fsPath=c._sep===e?c.fsPath:null,p}}else return c}}n.URI=v;const e=t.isWindows?1:void 0;class C extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(c=!1){return c?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=e),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(g,c,p){let w,f=-1;for(let u=0;u<g.length;u++){const M=g.charCodeAt(u);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||c&&M===47||p&&M===91||p&&M===93||p&&M===58)f!==-1&&(w+=encodeURIComponent(g.substring(f,u)),f=-1),w!==void 0&&(w+=g.charAt(u));else{w===void 0&&(w=g.substr(0,u));const S=D[M];S!==void 0?(f!==-1&&(w+=encodeURIComponent(g.substring(f,u)),f=-1),w+=S):f===-1&&(f=u)}}return f!==-1&&(w+=encodeURIComponent(g.substring(f))),w!==void 0?w:g}function L(g){let c;for(let p=0;p<g.length;p++){const w=g.charCodeAt(p);w===35||w===63?(c===void 0&&(c=g.substr(0,p)),c+=D[w]):c!==void 0&&(c+=g[p])}return c!==void 0?c:g}function d(g,c){let p;return g.authority&&g.path.length>1&&g.scheme==="file"?p=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?c?p=g.path.substr(1):p=g.path[1].toLowerCase()+g.path.substr(2):p=g.path,t.isWindows&&(p=p.replace(/\//g,"\\")),p}n.uriToFsPath=d;function b(g,c){const p=c?L:E;let w="",{scheme:f,authority:u,path:M,query:S,fragment:O}=g;if(f&&(w+=f,w+=":"),(u||f==="file")&&(w+=_,w+=_),u){let U=u.indexOf("@");if(U!==-1){const H=u.substr(0,U);u=u.substr(U+1),U=H.lastIndexOf(":"),U===-1?w+=p(H,!1,!1):(w+=p(H.substr(0,U),!1,!1),w+=":",w+=p(H.substr(U+1),!1,!0)),w+="@"}u=u.toLowerCase(),U=u.lastIndexOf(":"),U===-1?w+=p(u,!1,!0):(w+=p(u.substr(0,U),!1,!0),w+=u.substr(U))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const U=M.charCodeAt(1);U>=65&&U<=90&&(M=`/${String.fromCharCode(U+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const U=M.charCodeAt(0);U>=65&&U<=90&&(M=`${String.fromCharCode(U+32)}:${M.substr(2)}`)}w+=p(M,!0,!1)}return S&&(w+="?",w+=p(S,!1,!1)),O&&(w+="#",w+=c?O:E(O,!1,!1)),w}function o(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+o(g.substr(3)):g}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(g){return g.match(i)?g.replace(i,c=>o(c)):g}}),Z(J[57],x([0,1,6,9,7,11,5,4]),function(q,n,R,t,F,l,y,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const a="$initialize";let h=!1;function A(g){!y.isWeb||(h||(h=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(g.message))}n.logOnceWebWorkerWarning=A;var _;(function(g){g[g.Request=0]="Request",g[g.Reply=1]="Reply",g[g.SubscribeEvent=2]="SubscribeEvent",g[g.Event=3]="Event",g[g.UnsubscribeEvent=4]="UnsubscribeEvent"})(_||(_={}));class N{constructor(c,p,w,f){this.vsWorker=c,this.req=p,this.method=w,this.args=f,this.type=0}}class v{constructor(c,p,w,f){this.vsWorker=c,this.seq=p,this.res=w,this.err=f,this.type=1}}class e{constructor(c,p,w,f){this.vsWorker=c,this.req=p,this.eventName=w,this.arg=f,this.type=2}}class C{constructor(c,p,w){this.vsWorker=c,this.req=p,this.event=w,this.type=3}}class D{constructor(c,p){this.vsWorker=c,this.req=p,this.type=4}}class E{constructor(c){this.a=-1,this.g=c,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(c){this.a=c}sendMessage(c,p){const w=String(++this.b);return new Promise((f,u)=>{this.c[w]={resolve:f,reject:u},this.o(new N(this.a,w,c,p))})}listen(c,p){let w=null;const f=new t.Emitter({onWillAddFirstListener:()=>{w=String(++this.b),this.d.set(w,f),this.o(new e(this.a,w,c,p))},onDidRemoveLastListener:()=>{this.d.delete(w),this.o(new D(this.a,w)),w=null}});return f.event}handleMessage(c){!c||!c.vsWorker||this.a!==-1&&c.vsWorker!==this.a||this.h(c)}h(c){switch(c.type){case 1:return this.j(c);case 0:return this.k(c);case 2:return this.l(c);case 3:return this.m(c);case 4:return this.n(c)}}j(c){if(!this.c[c.seq]){console.warn("Got reply to unknown seq");return}const p=this.c[c.seq];if(delete this.c[c.seq],c.err){let w=c.err;c.err.$isError&&(w=new Error,w.name=c.err.name,w.message=c.err.message,w.stack=c.err.stack),p.reject(w);return}p.resolve(c.res)}k(c){const p=c.req;this.g.handleMessage(c.method,c.args).then(f=>{this.o(new v(this.a,p,f,void 0))},f=>{f.detail instanceof Error&&(f.detail=(0,R.transformErrorForSerialization)(f.detail)),this.o(new v(this.a,p,void 0,(0,R.transformErrorForSerialization)(f)))})}l(c){const p=c.req,w=this.g.handleEvent(c.eventName,c.arg)(f=>{this.o(new C(this.a,p,f))});this.f.set(p,w)}m(c){if(!this.d.has(c.req)){console.warn("Got event for unknown req");return}this.d.get(c.req).fire(c.event)}n(c){if(!this.f.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(c.req).dispose(),this.f.delete(c.req)}o(c){const p=[];if(c.type===0)for(let w=0;w<c.args.length;w++)c.args[w]instanceof ArrayBuffer&&p.push(c.args[w]);else c.type===1&&c.res instanceof ArrayBuffer&&p.push(c.res);this.g.sendMessage(c,p)}}class L extends F.Disposable{constructor(c,p,w){super();let f=null;this.a=this.B(c.create("vs/base/common/worker/simpleWorker",U=>{this.c.handleMessage(U)},U=>{f?.(U)})),this.c=new E({sendMessage:(U,H)=>{this.a.postMessage(U,H)},handleMessage:(U,H)=>{if(typeof w[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(w[U].apply(w,H))}catch(z){return Promise.reject(z)}},handleEvent:(U,H)=>{if(b(U)){const z=w[U].call(w,H);if(typeof z!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return z}if(d(U)){const z=w[U];if(typeof z!="function")throw new Error(`Missing event ${U} on main thread host.`);return z}throw new Error(`Malformed event name ${U}`)}}),this.c.setWorkerId(this.a.getId());let u=null;typeof y.globals.require<"u"&&typeof y.globals.require.getConfig=="function"?u=y.globals.require.getConfig():typeof y.globals.requirejs<"u"&&(u=y.globals.requirejs.s.contexts._.config);const M=(0,l.getAllMethodNames)(w);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(u)),p,M]);const S=(U,H)=>this.g(U,H),O=(U,H)=>this.c.listen(U,H);this.f=new Promise((U,H)=>{f=H,this.b.then(z=>{U(o(z,S,O))},z=>{H(z),this.h("Worker failed to load "+p,z)})})}getProxyObject(){return this.f}g(c,p){return new Promise((w,f)=>{this.b.then(()=>{this.c.sendMessage(c,p).then(w,f)},f)})}h(c,p){console.error(c),console.info(p)}}n.SimpleWorkerClient=L;function d(g){return g[0]==="o"&&g[1]==="n"&&m.isUpperAsciiLetter(g.charCodeAt(2))}function b(g){return/^onDynamic/.test(g)&&m.isUpperAsciiLetter(g.charCodeAt(9))}function o(g,c,p){const w=M=>function(){const S=Array.prototype.slice.call(arguments,0);return c(M,S)},f=M=>function(S){return p(M,S)},u={};for(const M of g){if(b(M)){u[M]=f(M);continue}if(d(M)){u[M]=p(M,void 0);continue}u[M]=w(M)}return u}class i{constructor(c,p){this.a=p,this.b=null,this.c=new E({sendMessage:(w,f)=>{c(w,f)},handleMessage:(w,f)=>this.d(w,f),handleEvent:(w,f)=>this.f(w,f)})}onmessage(c){this.c.handleMessage(c)}d(c,p){if(c===a)return this.g(p[0],p[1],p[2],p[3]);if(!this.b||typeof this.b[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this.b[c].apply(this.b,p))}catch(w){return Promise.reject(w)}}f(c,p){if(!this.b)throw new Error("Missing requestHandler");if(b(c)){const w=this.b[c].call(this.b,p);if(typeof w!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return w}if(d(c)){const w=this.b[c];if(typeof w!="function")throw new Error(`Missing event ${c} on request handler.`);return w}throw new Error(`Malformed event name ${c}`)}g(c,p,w,f){this.c.setWorkerId(c);const S=o(f,(O,U)=>this.c.sendMessage(O,U),(O,U)=>this.c.listen(O,U));return this.a?(this.b=this.a(S),Promise.resolve((0,l.getAllMethodNames)(this.b))):(p&&(typeof p.baseUrl<"u"&&delete p.baseUrl,typeof p.paths<"u"&&typeof p.paths.vs<"u"&&delete p.paths.vs,typeof p.trustedTypesPolicy!==void 0&&delete p.trustedTypesPolicy,p.catchError=!0,y.globals.require.config(p)),new Promise((O,U)=>{(y.globals.require||q)([w],z=>{if(this.b=z.create(S),!this.b){U(new Error("No RequestHandler!"));return}O((0,l.getAllMethodNames)(this.b))},U)}))}}n.SimpleWorkerServer=i;function s(g){return new i(g,null)}n.create=s}),Z(J[23],x([0,1,22,19,4,2,10]),function(q,n,R,t,F,l,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const m=3;class a{computeDiff(b,o,i){const g=new C(b,o,{maxComputationTime:i.maxComputationTimeMs,shouldIgnoreTrimWhitespace:i.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),c=[];let p=null;for(const w of g.changes){let f;w.originalEndLineNumber===0?f=new t.LineRange(w.originalStartLineNumber+1,w.originalStartLineNumber+1):f=new t.LineRange(w.originalStartLineNumber,w.originalEndLineNumber+1);let u;w.modifiedEndLineNumber===0?u=new t.LineRange(w.modifiedStartLineNumber+1,w.modifiedStartLineNumber+1):u=new t.LineRange(w.modifiedStartLineNumber,w.modifiedEndLineNumber+1);let M=new t.LineRangeMapping(f,u,w.charChanges?.map(S=>new t.RangeMapping(new l.Range(S.originalStartLineNumber,S.originalStartColumn,S.originalEndLineNumber,S.originalEndColumn),new l.Range(S.modifiedStartLineNumber,S.modifiedStartColumn,S.modifiedEndLineNumber,S.modifiedEndColumn))));p&&(p.modifiedRange.endLineNumberExclusive===M.modifiedRange.startLineNumber||p.originalRange.endLineNumberExclusive===M.originalRange.startLineNumber)&&(M=new t.LineRangeMapping(p.originalRange.join(M.originalRange),p.modifiedRange.join(M.modifiedRange),p.innerChanges&&M.innerChanges?p.innerChanges.concat(M.innerChanges):void 0),c.pop()),c.push(M),p=M}return(0,y.assertFn)(()=>(0,y.checkAdjacentItems)(c,(w,f)=>f.originalRange.startLineNumber-w.originalRange.endLineNumberExclusive===f.modifiedRange.startLineNumber-w.modifiedRange.endLineNumberExclusive&&w.originalRange.endLineNumberExclusive<f.originalRange.startLineNumber&&w.modifiedRange.endLineNumberExclusive<f.modifiedRange.startLineNumber)),{quitEarly:g.quitEarly,changes:c}}}n.SmartLinesDiffComputer=a;function h(d,b,o,i){return new R.LcsDiff(d,b,o).ComputeDiff(i)}class A{constructor(b){const o=[],i=[];for(let s=0,g=b.length;s<g;s++)o[s]=D(b[s],1),i[s]=E(b[s],1);this.lines=b,this.a=o,this.b=i}getElements(){const b=[];for(let o=0,i=this.lines.length;o<i;o++)b[o]=this.lines[o].substring(this.a[o]-1,this.b[o]-1);return b}getStrictElement(b){return this.lines[b]}getStartLineNumber(b){return b+1}getEndLineNumber(b){return b+1}createCharSequence(b,o,i){const s=[],g=[],c=[];let p=0;for(let w=o;w<=i;w++){const f=this.lines[w],u=b?this.a[w]:1,M=b?this.b[w]:f.length+1;for(let S=u;S<M;S++)s[p]=f.charCodeAt(S-1),g[p]=w+1,c[p]=S,p++;!b&&w<i&&(s[p]=10,g[p]=w+1,c[p]=f.length+1,p++)}return new _(s,g,c)}}class _{constructor(b,o,i){this.a=b,this.b=o,this.d=i}toString(){return"["+this.a.map((b,o)=>(b===10?"\\n":String.fromCharCode(b))+`-(${this.b[o]},${this.d[o]})`).join(", ")+"]"}e(b,o){if(b<0||b>=o.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(b){return b>0&&b===this.b.length?this.getEndLineNumber(b-1):(this.e(b,this.b),this.b[b])}getEndLineNumber(b){return b===-1?this.getStartLineNumber(b+1):(this.e(b,this.b),this.a[b]===10?this.b[b]+1:this.b[b])}getStartColumn(b){return b>0&&b===this.d.length?this.getEndColumn(b-1):(this.e(b,this.d),this.d[b])}getEndColumn(b){return b===-1?this.getStartColumn(b+1):(this.e(b,this.d),this.a[b]===10?1:this.d[b]+1)}}class N{constructor(b,o,i,s,g,c,p,w){this.originalStartLineNumber=b,this.originalStartColumn=o,this.originalEndLineNumber=i,this.originalEndColumn=s,this.modifiedStartLineNumber=g,this.modifiedStartColumn=c,this.modifiedEndLineNumber=p,this.modifiedEndColumn=w}static createFromDiffChange(b,o,i){const s=o.getStartLineNumber(b.originalStart),g=o.getStartColumn(b.originalStart),c=o.getEndLineNumber(b.originalStart+b.originalLength-1),p=o.getEndColumn(b.originalStart+b.originalLength-1),w=i.getStartLineNumber(b.modifiedStart),f=i.getStartColumn(b.modifiedStart),u=i.getEndLineNumber(b.modifiedStart+b.modifiedLength-1),M=i.getEndColumn(b.modifiedStart+b.modifiedLength-1);return new N(s,g,c,p,w,f,u,M)}}function v(d){if(d.length<=1)return d;const b=[d[0]];let o=b[0];for(let i=1,s=d.length;i<s;i++){const g=d[i],c=g.originalStart-(o.originalStart+o.originalLength),p=g.modifiedStart-(o.modifiedStart+o.modifiedLength);Math.min(c,p)<m?(o.originalLength=g.originalStart+g.originalLength-o.originalStart,o.modifiedLength=g.modifiedStart+g.modifiedLength-o.modifiedStart):(b.push(g),o=g)}return b}class e{constructor(b,o,i,s,g){this.originalStartLineNumber=b,this.originalEndLineNumber=o,this.modifiedStartLineNumber=i,this.modifiedEndLineNumber=s,this.charChanges=g}static createFromDiffResult(b,o,i,s,g,c,p){let w,f,u,M,S;if(o.originalLength===0?(w=i.getStartLineNumber(o.originalStart)-1,f=0):(w=i.getStartLineNumber(o.originalStart),f=i.getEndLineNumber(o.originalStart+o.originalLength-1)),o.modifiedLength===0?(u=s.getStartLineNumber(o.modifiedStart)-1,M=0):(u=s.getStartLineNumber(o.modifiedStart),M=s.getEndLineNumber(o.modifiedStart+o.modifiedLength-1)),c&&o.originalLength>0&&o.originalLength<20&&o.modifiedLength>0&&o.modifiedLength<20&&g()){const O=i.createCharSequence(b,o.originalStart,o.originalStart+o.originalLength-1),U=s.createCharSequence(b,o.modifiedStart,o.modifiedStart+o.modifiedLength-1);if(O.getElements().length>0&&U.getElements().length>0){let H=h(O,U,g,!0).changes;p&&(H=v(H)),S=[];for(let z=0,ee=H.length;z<ee;z++)S.push(N.createFromDiffChange(H[z],O,U))}}return new e(w,f,u,M,S)}}class C{constructor(b,o,i){this.a=i.shouldComputeCharChanges,this.b=i.shouldPostProcessCharChanges,this.d=i.shouldIgnoreTrimWhitespace,this.e=i.shouldMakePrettyDiff,this.f=b,this.g=o,this.h=new A(b),this.j=new A(o),this.k=L(i.maxComputationTime),this.l=L(i.maxComputationTime===0?0:Math.min(i.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const b=h(this.h,this.j,this.k,this.e),o=b.changes,i=b.quitEarly;if(this.d){const p=[];for(let w=0,f=o.length;w<f;w++)p.push(e.createFromDiffResult(this.d,o[w],this.h,this.j,this.l,this.a,this.b));return{quitEarly:i,changes:p}}const s=[];let g=0,c=0;for(let p=-1,w=o.length;p<w;p++){const f=p+1<w?o[p+1]:null,u=f?f.originalStart:this.f.length,M=f?f.modifiedStart:this.g.length;for(;g<u&&c<M;){const S=this.f[g],O=this.g[c];if(S!==O){{let U=D(S,1),H=D(O,1);for(;U>1&&H>1;){const z=S.charCodeAt(U-2),ee=O.charCodeAt(H-2);if(z!==ee)break;U--,H--}(U>1||H>1)&&this.m(s,g+1,1,U,c+1,1,H)}{let U=E(S,1),H=E(O,1);const z=S.length+1,ee=O.length+1;for(;U<z&&H<ee;){const ne=S.charCodeAt(U-1),Q=S.charCodeAt(H-1);if(ne!==Q)break;U++,H++}(U<z||H<ee)&&this.m(s,g+1,U,z,c+1,H,ee)}}g++,c++}f&&(s.push(e.createFromDiffResult(this.d,f,this.h,this.j,this.l,this.a,this.b)),g+=f.originalLength,c+=f.modifiedLength)}return{quitEarly:i,changes:s}}m(b,o,i,s,g,c,p){if(this.n(b,o,i,s,g,c,p))return;let w;this.a&&(w=[new N(o,i,o,s,g,c,g,p)]),b.push(new e(o,o,g,g,w))}n(b,o,i,s,g,c,p){const w=b.length;if(w===0)return!1;const f=b[w-1];return f.originalEndLineNumber===0||f.modifiedEndLineNumber===0?!1:f.originalEndLineNumber===o&&f.modifiedEndLineNumber===g?(this.a&&f.charChanges&&f.charChanges.push(new N(o,i,o,s,g,c,g,p)),!0):f.originalEndLineNumber+1===o&&f.modifiedEndLineNumber+1===g?(f.originalEndLineNumber=o,f.modifiedEndLineNumber=g,this.a&&f.charChanges&&f.charChanges.push(new N(o,i,o,s,g,c,g,p)),!0):!1}}n.DiffComputer=C;function D(d,b){const o=F.firstNonWhitespaceIndex(d);return o===-1?b:o+1}function E(d,b){const o=F.lastNonWhitespaceIndex(d);return o===-1?b:o+2}function L(d){if(d===0)return()=>!0;const b=Date.now();return()=>Date.now()-b<d}}),Z(J[47],x([0,1,23,36]),function(q,n,R,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={smart:new R.SmartLinesDiffComputer,experimental:new t.StandardLinesDiffComputer}}),Z(J[48],x([0,1,4,3,40]),function(q,n,R,t,F){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class l{constructor(m,a,h,A){this.c=m,this.d=a,this.f=h,this.g=A,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(m){m.eol&&m.eol!==this.f&&(this.f=m.eol,this.h=null);const a=m.changes;for(const h of a)this.n(h.range),this.o(new t.Position(h.range.startLineNumber,h.range.startColumn),h.text);this.g=m.versionId,this.j=null}k(){if(!this.h){const m=this.f.length,a=this.d.length,h=new Uint32Array(a);for(let A=0;A<a;A++)h[A]=this.d[A].length+m;this.h=new F.PrefixSumComputer(h)}}l(m,a){this.d[m]=a,this.h&&this.h.setValue(m,this.d[m].length+this.f.length)}n(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.l(m.startLineNumber-1,this.d[m.startLineNumber-1].substring(0,m.startColumn-1)+this.d[m.startLineNumber-1].substring(m.endColumn-1));return}this.l(m.startLineNumber-1,this.d[m.startLineNumber-1].substring(0,m.startColumn-1)+this.d[m.endLineNumber-1].substring(m.endColumn-1)),this.d.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.h&&this.h.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}o(m,a){if(a.length===0)return;const h=(0,R.splitLines)(a);if(h.length===1){this.l(m.lineNumber-1,this.d[m.lineNumber-1].substring(0,m.column-1)+h[0]+this.d[m.lineNumber-1].substring(m.column-1));return}h[h.length-1]+=this.d[m.lineNumber-1].substring(m.column-1),this.l(m.lineNumber-1,this.d[m.lineNumber-1].substring(0,m.column-1)+h[0]);const A=new Uint32Array(h.length-1);for(let _=1;_<h.length;_++)this.d.splice(m.lineNumber+_-1,0,h[_]),A[_-1]=h[_].length+this.f.length;this.h&&this.h.insertValues(m.lineNumber,A)}}n.MirrorTextModel=l}),Z(J[49],x([0,1,4,31,3,2,39]),function(q,n,R,t,F,l,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const m=999;class a{constructor(L,d,b,o){this.searchString=L,this.isRegex=d,this.matchCase=b,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let L;this.isRegex?L=h(this.searchString):L=this.searchString.indexOf(`
`)>=0;let d=null;try{d=R.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:L,global:!0,unicode:!0})}catch{return null}if(!d)return null;let b=!this.isRegex&&!L;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new y.SearchData(d,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,b?this.searchString:null)}}n.SearchParams=a;function h(E){if(!E||E.length===0)return!1;for(let L=0,d=E.length;L<d;L++){const b=E.charCodeAt(L);if(b===10)return!0;if(b===92){if(L++,L>=d)break;const o=E.charCodeAt(L);if(o===110||o===114||o===87)return!0}}return!1}n.isMultilineRegexSource=h;function A(E,L,d){if(!d)return new y.FindMatch(E,null);const b=[];for(let o=0,i=L.length;o<i;o++)b[o]=L[o];return new y.FindMatch(E,b)}n.createFindMatch=A;class _{constructor(L){const d=[];let b=0;for(let o=0,i=L.length;o<i;o++)L.charCodeAt(o)===10&&(d[b++]=o);this.a=d}findLineFeedCountBeforeOffset(L){const d=this.a;let b=0,o=d.length-1;if(o===-1||L<=d[0])return 0;for(;b<o;){const i=b+((o-b)/2>>0);d[i]>=L?o=i-1:d[i+1]>=L?(b=i,o=i):b=i+1}return b+1}}class N{static findMatches(L,d,b,o,i){const s=d.parseSearchRequest();return s?s.regex.multiline?this.b(L,b,new D(s.wordSeparators,s.regex),o,i):this.c(L,b,s,o,i):[]}static a(L,d,b,o,i,s){let g,c=0;o?(c=o.findLineFeedCountBeforeOffset(i),g=d+i+c):g=d+i;let p;if(o){const M=o.findLineFeedCountBeforeOffset(i+s.length)-c;p=g+s.length+M}else p=g+s.length;const w=L.getPositionAt(g),f=L.getPositionAt(p);return new l.Range(w.lineNumber,w.column,f.lineNumber,f.column)}static b(L,d,b,o,i){const s=L.getOffsetAt(d.getStartPosition()),g=L.getValueInRange(d,1),c=L.getEOL()===`\r
`?new _(g):null,p=[];let w=0,f;for(b.reset(0);f=b.next(g);)if(p[w++]=A(this.a(L,s,g,c,f.index,f[0]),f,o),w>=i)return p;return p}static c(L,d,b,o,i){const s=[];let g=0;if(d.startLineNumber===d.endLineNumber){const p=L.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return g=this.d(b,p,d.startLineNumber,d.startColumn-1,g,s,o,i),s}const c=L.getLineContent(d.startLineNumber).substring(d.startColumn-1);g=this.d(b,c,d.startLineNumber,d.startColumn-1,g,s,o,i);for(let p=d.startLineNumber+1;p<d.endLineNumber&&g<i;p++)g=this.d(b,L.getLineContent(p),p,0,g,s,o,i);if(g<i){const p=L.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);g=this.d(b,p,d.endLineNumber,0,g,s,o,i)}return s}static d(L,d,b,o,i,s,g,c){const p=L.wordSeparators;if(!g&&L.simpleSearch){const u=L.simpleSearch,M=u.length,S=d.length;let O=-M;for(;(O=d.indexOf(u,O+M))!==-1;)if((!p||C(p,d,S,O,M))&&(s[i++]=new y.FindMatch(new l.Range(b,O+1+o,b,O+1+M+o),null),i>=c))return i;return i}const w=new D(L.wordSeparators,L.regex);let f;w.reset(0);do if(f=w.next(d),f&&(s[i++]=A(new l.Range(b,f.index+1+o,b,f.index+1+f[0].length+o),f,g),i>=c))return i;while(f);return i}static findNextMatch(L,d,b,o){const i=d.parseSearchRequest();if(!i)return null;const s=new D(i.wordSeparators,i.regex);return i.regex.multiline?this.e(L,b,s,o):this.f(L,b,s,o)}static e(L,d,b,o){const i=new F.Position(d.lineNumber,1),s=L.getOffsetAt(i),g=L.getLineCount(),c=L.getValueInRange(new l.Range(i.lineNumber,i.column,g,L.getLineMaxColumn(g)),1),p=L.getEOL()===`\r
`?new _(c):null;b.reset(d.column-1);const w=b.next(c);return w?A(this.a(L,s,c,p,w.index,w[0]),w,o):d.lineNumber!==1||d.column!==1?this.e(L,new F.Position(1,1),b,o):null}static f(L,d,b,o){const i=L.getLineCount(),s=d.lineNumber,g=L.getLineContent(s),c=this.g(b,g,s,d.column,o);if(c)return c;for(let p=1;p<=i;p++){const w=(s+p-1)%i,f=L.getLineContent(w+1),u=this.g(b,f,w+1,1,o);if(u)return u}return null}static g(L,d,b,o,i){L.reset(o-1);const s=L.next(d);return s?A(new l.Range(b,s.index+1,b,s.index+1+s[0].length),s,i):null}static findPreviousMatch(L,d,b,o){const i=d.parseSearchRequest();if(!i)return null;const s=new D(i.wordSeparators,i.regex);return i.regex.multiline?this.h(L,b,s,o):this.j(L,b,s,o)}static h(L,d,b,o){const i=this.b(L,new l.Range(1,1,d.lineNumber,d.column),b,o,10*m);if(i.length>0)return i[i.length-1];const s=L.getLineCount();return d.lineNumber!==s||d.column!==L.getLineMaxColumn(s)?this.h(L,new F.Position(s,L.getLineMaxColumn(s)),b,o):null}static j(L,d,b,o){const i=L.getLineCount(),s=d.lineNumber,g=L.getLineContent(s).substring(0,d.column-1),c=this.k(b,g,s,o);if(c)return c;for(let p=1;p<=i;p++){const w=(i+s-p-1)%i,f=L.getLineContent(w+1),u=this.k(b,f,w+1,o);if(u)return u}return null}static k(L,d,b,o){let i=null,s;for(L.reset(0);s=L.next(d);)i=A(new l.Range(b,s.index+1,b,s.index+1+s[0].length),s,o);return i}}n.TextModelSearch=N;function v(E,L,d,b,o){if(b===0)return!0;const i=L.charCodeAt(b-1);if(E.get(i)!==0||i===13||i===10)return!0;if(o>0){const s=L.charCodeAt(b);if(E.get(s)!==0)return!0}return!1}function e(E,L,d,b,o){if(b+o===d)return!0;const i=L.charCodeAt(b+o);if(E.get(i)!==0||i===13||i===10)return!0;if(o>0){const s=L.charCodeAt(b+o-1);if(E.get(s)!==0)return!0}return!1}function C(E,L,d,b,o){return v(E,L,d,b,o)&&e(E,L,d,b,o)}n.isValidMatch=C;class D{constructor(L,d){this._wordSeparators=L,this.a=d,this.b=-1,this.c=0}reset(L){this.a.lastIndex=L,this.b=-1,this.c=0}next(L){const d=L.length;let b;do{if(this.b+this.c===d||(b=this.a.exec(L),!b))return null;const o=b.index,i=b[0].length;if(o===this.b&&i===this.c){if(i===0){R.getNextCodePoint(L,d,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=i,!this._wordSeparators||C(this._wordSeparators,L,d,o,i))return b}while(b);return null}}n.Searcher=D}),Z(J[50],x([0,1,2,49,4,10,18]),function(q,n,R,t,F,l,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeHighlighterReasonKind=n.UnicodeTextModelHighlighter=void 0;class m{static computeUnicodeHighlights(e,C,D){const E=D?D.startLineNumber:1,L=D?D.endLineNumber:e.getLineCount(),d=new A(C),b=d.getCandidateCodePoints();let o;b==="allNonBasicAscii"?o=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):o=new RegExp(`${a(Array.from(b))}`,"g");const i=new t.Searcher(null,o),s=[];let g=!1,c,p=0,w=0,f=0;e:for(let u=E,M=L;u<=M;u++){const S=e.getLineContent(u),O=S.length;i.reset(0);do if(c=i.next(S),c){let U=c.index,H=c.index+c[0].length;if(U>0){const Q=S.charCodeAt(U-1);F.isHighSurrogate(Q)&&U--}if(H+1<O){const Q=S.charCodeAt(H-1);F.isHighSurrogate(Q)&&H++}const z=S.substring(U,H);let ee=(0,y.getWordAtText)(U+1,y.DEFAULT_WORD_REGEXP,S,0);ee&&ee.endColumn<=U+1&&(ee=null);const ne=d.shouldHighlightNonBasicASCII(z,ee?ee.word:null);if(ne!==0){ne===3?p++:ne===2?w++:ne===1?f++:(0,l.assertNever)(ne);const Q=1e3;if(s.length>=Q){g=!0;break e}s.push(new R.Range(u,U+1,u,H+1))}}while(c)}return{ranges:s,hasMore:g,ambiguousCharacterCount:p,invisibleCharacterCount:w,nonBasicAsciiCharacterCount:f}}static computeUnicodeHighlightReason(e,C){const D=new A(C);switch(D.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const L=e.codePointAt(0),d=D.ambiguousCharacters.getPrimaryConfusable(L),b=F.AmbiguousCharacters.getLocales().filter(o=>!F.AmbiguousCharacters.getInstance(new Set([...C.allowedLocales,o])).isAmbiguous(L));return{kind:0,confusableWith:String.fromCodePoint(d),notAmbiguousInLocales:b}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=m;function a(v,e){return`[${F.escapeRegExpCharacters(v.map(D=>String.fromCodePoint(D)).join(""))}]`}var h;(function(v){v[v.Ambiguous=0]="Ambiguous",v[v.Invisible=1]="Invisible",v[v.NonBasicAscii=2]="NonBasicAscii"})(h=n.UnicodeHighlighterReasonKind||(n.UnicodeHighlighterReasonKind={}));class A{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=F.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const C of F.InvisibleCharacters.codePoints)_(String.fromCodePoint(C))||e.add(C);if(this.b.ambiguousCharacters)for(const C of this.ambiguousCharacters.getConfusableCodePoints())e.add(C);for(const C of this.a)e.delete(C);return e}shouldHighlightNonBasicASCII(e,C){const D=e.codePointAt(0);if(this.a.has(D))return 0;if(this.b.nonBasicASCII)return 1;let E=!1,L=!1;if(C)for(const d of C){const b=d.codePointAt(0),o=F.isBasicASCII(d);E=E||o,!o&&!this.ambiguousCharacters.isAmbiguous(b)&&!F.InvisibleCharacters.isInvisibleCharacter(b)&&(L=!0)}return!E&&L?0:this.b.invisibleCharacters&&!_(e)&&F.InvisibleCharacters.isInvisibleCharacter(D)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(D)?3:0}}function _(v){return v===" "||v===`
`||v==="	"}var N;(function(v){v[v.None=0]="None",v[v.NonBasicASCII=1]="NonBasicASCII",v[v.Invisible=2]="Invisible",v[v.Ambiguous=3]="Ambiguous"})(N||(N={}))}),Z(J[51],x([0,1,9,7]),function(q,n,R,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class F{constructor(){this.a=new Map,this.b=new Map,this.c=new R.Emitter,this.onDidChange=this.c.event,this.d=null}fire(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,a){return this.a.set(m,a),this.fire([m]),(0,t.toDisposable)(()=>{this.a.get(m)===a&&(this.a.delete(m),this.fire([m]))})}registerFactory(m,a){this.b.get(m)?.dispose();const h=new l(this,m,a);return this.b.set(m,h),(0,t.toDisposable)(()=>{const A=this.b.get(m);!A||A!==h||(this.b.delete(m),A.dispose())})}async getOrCreate(m){const a=this.get(m);if(a)return a;const h=this.b.get(m);return!h||h.isResolved?null:(await h.resolve(),this.get(m))}get(m){return this.a.get(m)||null}isResolved(m){if(this.get(m))return!0;const h=this.b.get(m);return!!(!h||h.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}n.TokenizationRegistry=F;class l extends t.Disposable{get isResolved(){return this.c}constructor(m,a,h){super(),this.f=m,this.g=a,this.h=h,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const m=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),Z(J[52],x([0,1,24,12,2,51]),function(q,n,R,t,F,l){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExternalUriOpenerPriority=n.TokenizationRegistry=n.InlayHintKind=n.CommentMode=n.CommentThreadState=n.CommentThreadCollapsibleState=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.SymbolTag=n.SymbolKind=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CodeActionTriggerType=n.InlineCompletionTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemTag=n.CompletionItemKinds=n.CompletionItemKind=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class y{constructor(M,S,O){this._tokenBrand=void 0,this.offset=M,this.type=S,this.language=O}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=y;class m{constructor(M,S){this._tokenizationResultBrand=void 0,this.tokens=M,this.endState=S}}n.TokenizationResult=m;class a{constructor(M,S){this._encodedTokenizationResultBrand=void 0,this.tokens=M,this.endState=S}}n.EncodedTokenizationResult=a;var h;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(h=n.CompletionItemKind||(n.CompletionItemKind={}));var A;(function(u){const M=new Map;M.set(0,R.Codicon.symbolMethod),M.set(1,R.Codicon.symbolFunction),M.set(2,R.Codicon.symbolConstructor),M.set(3,R.Codicon.symbolField),M.set(4,R.Codicon.symbolVariable),M.set(5,R.Codicon.symbolClass),M.set(6,R.Codicon.symbolStruct),M.set(7,R.Codicon.symbolInterface),M.set(8,R.Codicon.symbolModule),M.set(9,R.Codicon.symbolProperty),M.set(10,R.Codicon.symbolEvent),M.set(11,R.Codicon.symbolOperator),M.set(12,R.Codicon.symbolUnit),M.set(13,R.Codicon.symbolValue),M.set(15,R.Codicon.symbolEnum),M.set(14,R.Codicon.symbolConstant),M.set(15,R.Codicon.symbolEnum),M.set(16,R.Codicon.symbolEnumMember),M.set(17,R.Codicon.symbolKeyword),M.set(27,R.Codicon.symbolSnippet),M.set(18,R.Codicon.symbolText),M.set(19,R.Codicon.symbolColor),M.set(20,R.Codicon.symbolFile),M.set(21,R.Codicon.symbolReference),M.set(22,R.Codicon.symbolCustomColor),M.set(23,R.Codicon.symbolFolder),M.set(24,R.Codicon.symbolTypeParameter),M.set(25,R.Codicon.account),M.set(26,R.Codicon.issues);function S(H){let z=M.get(H);return z||(console.info("No codicon found for CompletionItemKind "+H),z=R.Codicon.symbolProperty),z}u.toIcon=S;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function U(H,z){let ee=O.get(H);return typeof ee>"u"&&!z&&(ee=9),ee}u.fromString=U})(A=n.CompletionItemKinds||(n.CompletionItemKinds={}));var _;(function(u){u[u.Deprecated=1]="Deprecated"})(_=n.CompletionItemTag||(n.CompletionItemTag={}));var N;(function(u){u[u.None=0]="None",u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(N=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var v;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var e;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(e=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var C;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(C=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var D;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(D=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var E;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(E=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function L(u){return u&&t.URI.isUri(u.uri)&&F.Range.isIRange(u.range)&&(F.Range.isIRange(u.originSelectionRange)||F.Range.isIRange(u.targetSelectionRange))}n.isLocationLink=L;var d;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(d=n.SymbolKind||(n.SymbolKind={}));var b;(function(u){u[u.Deprecated=1]="Deprecated"})(b=n.SymbolTag||(n.SymbolTag={}));var o;(function(u){const M=new Map;M.set(0,R.Codicon.symbolFile),M.set(1,R.Codicon.symbolModule),M.set(2,R.Codicon.symbolNamespace),M.set(3,R.Codicon.symbolPackage),M.set(4,R.Codicon.symbolClass),M.set(5,R.Codicon.symbolMethod),M.set(6,R.Codicon.symbolProperty),M.set(7,R.Codicon.symbolField),M.set(8,R.Codicon.symbolConstructor),M.set(9,R.Codicon.symbolEnum),M.set(10,R.Codicon.symbolInterface),M.set(11,R.Codicon.symbolFunction),M.set(12,R.Codicon.symbolVariable),M.set(13,R.Codicon.symbolConstant),M.set(14,R.Codicon.symbolString),M.set(15,R.Codicon.symbolNumber),M.set(16,R.Codicon.symbolBoolean),M.set(17,R.Codicon.symbolArray),M.set(18,R.Codicon.symbolObject),M.set(19,R.Codicon.symbolKey),M.set(20,R.Codicon.symbolNull),M.set(21,R.Codicon.symbolEnumMember),M.set(22,R.Codicon.symbolStruct),M.set(23,R.Codicon.symbolEvent),M.set(24,R.Codicon.symbolOperator),M.set(25,R.Codicon.symbolTypeParameter);function S(O){let U=M.get(O);return U||(console.info("No codicon found for SymbolKind "+O),U=R.Codicon.symbolProperty),U}u.toIcon=S})(o=n.SymbolKinds||(n.SymbolKinds={}));class i{constructor(M){this.value=M}}n.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var s;(function(u){function M(S){return!S||typeof S!="object"?!1:typeof S.id=="string"&&typeof S.title=="string"}u.is=M})(s=n.Command||(n.Command={}));var g;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(g=n.CommentThreadCollapsibleState||(n.CommentThreadCollapsibleState={}));var c;(function(u){u[u.Unresolved=0]="Unresolved",u[u.Resolved=1]="Resolved"})(c=n.CommentThreadState||(n.CommentThreadState={}));var p;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(p=n.CommentMode||(n.CommentMode={}));var w;(function(u){u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(w=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new l.TokenizationRegistry;var f;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(f=n.ExternalUriOpenerPriority||(n.ExternalUriOpenerPriority={}))}),Z(J[53],x([0,1,21,9,27,12,3,2,30,52,41]),function(q,n,R,t,F,l,y,m,a,h,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class _{static chord(e,C){return(0,F.KeyChord)(e,C)}}n.KeyMod=_,_.CtrlCmd=2048,_.Shift=1024,_.Alt=512,_.WinCtrl=256;function N(){return{editor:void 0,languages:void 0,CancellationTokenSource:R.CancellationTokenSource,Emitter:t.Emitter,KeyCode:A.KeyCode,KeyMod:_,Position:y.Position,Range:m.Range,Selection:a.Selection,SelectionDirection:A.SelectionDirection,MarkerSeverity:A.MarkerSeverity,MarkerTag:A.MarkerTag,Uri:l.URI,Token:h.Token}}n.createMonacoBaseAPI=N}),Z(J[58],x([0,1,22,5,12,3,2,48,18,37,38,53,20,50,23,47,11]),function(q,n,R,t,F,l,y,m,a,h,A,_,N,v,e,C,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class E extends m.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(o){return this.d[o-1]}getWordAtPosition(o,i){const s=(0,a.getWordAtText)(o.column,(0,a.ensureValidWordDefinition)(i),this.d[o.lineNumber-1],0);return s?new y.Range(o.lineNumber,s.startColumn,o.lineNumber,s.endColumn):null}getWordUntilPosition(o,i){const s=this.getWordAtPosition(o,i);return s?{word:this.d[o.lineNumber-1].substring(s.startColumn-1,o.column-1),startColumn:s.startColumn,endColumn:o.column}:{word:"",startColumn:o.column,endColumn:o.column}}words(o){const i=this.d,s=this.p.bind(this);let g=0,c="",p=0,w=[];return{*[Symbol.iterator](){for(;;)if(p<w.length){const f=c.substring(w[p].start,w[p].end);p+=1,yield f}else if(g<i.length)c=i[g],w=s(c,o),p=0,g+=1;else break}}}getLineWords(o,i){const s=this.d[o-1],g=this.p(s,i),c=[];for(const p of g)c.push({word:s.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return c}p(o,i){const s=[];let g;for(i.lastIndex=0;(g=i.exec(o))&&g[0].length!==0;)s.push({start:g.index,end:g.index+g[0].length});return s}getValueInRange(o){if(o=this.q(o),o.startLineNumber===o.endLineNumber)return this.d[o.startLineNumber-1].substring(o.startColumn-1,o.endColumn-1);const i=this.f,s=o.startLineNumber-1,g=o.endLineNumber-1,c=[];c.push(this.d[s].substring(o.startColumn-1));for(let p=s+1;p<g;p++)c.push(this.d[p]);return c.push(this.d[g].substring(0,o.endColumn-1)),c.join(i)}offsetAt(o){return o=this.r(o),this.k(),this.h.getPrefixSum(o.lineNumber-2)+(o.column-1)}positionAt(o){o=Math.floor(o),o=Math.max(0,o),this.k();const i=this.h.getIndexOf(o),s=this.d[i.index].length;return{lineNumber:1+i.index,column:1+Math.min(i.remainder,s)}}q(o){const i=this.r({lineNumber:o.startLineNumber,column:o.startColumn}),s=this.r({lineNumber:o.endLineNumber,column:o.endColumn});return i.lineNumber!==o.startLineNumber||i.column!==o.startColumn||s.lineNumber!==o.endLineNumber||s.column!==o.endColumn?{startLineNumber:i.lineNumber,startColumn:i.column,endLineNumber:s.lineNumber,endColumn:s.column}:o}r(o){if(!l.Position.isIPosition(o))throw new Error("bad position");let{lineNumber:i,column:s}=o,g=!1;if(i<1)i=1,s=1,g=!0;else if(i>this.d.length)i=this.d.length,s=this.d[i-1].length+1,g=!0;else{const c=this.d[i-1].length+1;s<1?(s=1,g=!0):s>c&&(s=c,g=!0)}return g?{lineNumber:i,column:s}:o}}class L{constructor(o,i){this.c=o,this.d=Object.create(null),this.f=i,this.g=null}dispose(){this.d=Object.create(null)}h(o){return this.d[o]}j(){const o=[];return Object.keys(this.d).forEach(i=>o.push(this.d[i])),o}acceptNewModel(o){this.d[o.url]=new E(F.URI.parse(o.url),o.lines,o.EOL,o.versionId)}acceptModelChanged(o,i){if(!this.d[o])return;this.d[o].onEvents(i)}acceptRemovedModel(o){!this.d[o]||delete this.d[o]}async computeUnicodeHighlights(o,i,s){const g=this.h(o);return g?v.UnicodeTextModelHighlighter.computeUnicodeHighlights(g,i,s):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(o,i,s,g){const c=this.h(o),p=this.h(i);return!c||!p?null:L.k(c,p,s,g)}static k(o,i,s,g){const c=g==="experimental"?C.linesDiffComputers.experimental:C.linesDiffComputers.smart,p=o.getLinesContent(),w=i.getLinesContent(),f=c.computeDiff(p,w,s);return{identical:f.changes.length>0?!1:this.l(o,i),quitEarly:f.quitEarly,changes:f.changes.map(M=>[M.originalRange.startLineNumber,M.originalRange.endLineNumberExclusive,M.modifiedRange.startLineNumber,M.modifiedRange.endLineNumberExclusive,M.innerChanges?.map(S=>[S.originalRange.startLineNumber,S.originalRange.startColumn,S.originalRange.endLineNumber,S.originalRange.endColumn,S.modifiedRange.startLineNumber,S.modifiedRange.startColumn,S.modifiedRange.endLineNumber,S.modifiedRange.endColumn])])}}static l(o,i){const s=o.getLineCount(),g=i.getLineCount();if(s!==g)return!1;for(let c=1;c<=s;c++){const p=o.getLineContent(c),w=i.getLineContent(c);if(p!==w)return!1}return!0}async computeDirtyDiff(o,i,s){const g=this.h(o),c=this.h(i);if(!g||!c)return null;const p=g.getLinesContent(),w=c.getLinesContent();return new e.DiffComputer(p,w,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(o,i){const s=this.h(o);if(!s)return i;const g=[];let c;i=i.slice(0).sort((p,w)=>{if(p.range&&w.range)return y.Range.compareRangesUsingStarts(p.range,w.range);const f=p.range?0:1,u=w.range?0:1;return f-u});for(let{range:p,text:w,eol:f}of i){if(typeof f=="number"&&(c=f),y.Range.isEmpty(p)&&!w)continue;const u=s.getValueInRange(p);if(w=w.replace(/\r\n|\n|\r/g,s.eol),u===w)continue;if(Math.max(w.length,u.length)>L.n){g.push({range:p,text:w});continue}const M=(0,R.stringDiff)(u,w,!1),S=s.offsetAt(y.Range.lift(p).getStartPosition());for(const O of M){const U=s.positionAt(S+O.originalStart),H=s.positionAt(S+O.originalStart+O.originalLength),z={text:w.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:U.lineNumber,startColumn:U.column,endLineNumber:H.lineNumber,endColumn:H.column}};s.getValueInRange(z.range)!==z.text&&g.push(z)}}return typeof c=="number"&&g.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),g}async computeLinks(o){const i=this.h(o);return i?(0,h.computeLinks)(i):null}async textualSuggest(o,i,s,g){const c=new N.StopWatch(!0),p=new RegExp(s,g),w=new Set;e:for(const f of o){const u=this.h(f);if(!!u){for(const M of u.words(p))if(!(M===i||!isNaN(Number(M)))&&(w.add(M),w.size>L.o))break e}}return{words:Array.from(w),duration:c.elapsed()}}async computeWordRanges(o,i,s,g){const c=this.h(o);if(!c)return Object.create(null);const p=new RegExp(s,g),w=Object.create(null);for(let f=i.startLineNumber;f<i.endLineNumber;f++){const u=c.getLineWords(f,p);for(const M of u){if(!isNaN(Number(M.word)))continue;let S=w[M.word];S||(S=[],w[M.word]=S),S.push({startLineNumber:f,startColumn:M.startColumn,endLineNumber:f,endColumn:M.endColumn})}}return w}async navigateValueSet(o,i,s,g,c){const p=this.h(o);if(!p)return null;const w=new RegExp(g,c);i.startColumn===i.endColumn&&(i={startLineNumber:i.startLineNumber,startColumn:i.startColumn,endLineNumber:i.endLineNumber,endColumn:i.endColumn+1});const f=p.getValueInRange(i),u=p.getWordAtPosition({lineNumber:i.startLineNumber,column:i.startColumn},w);if(!u)return null;const M=p.getValueInRange(u);return A.BasicInplaceReplace.INSTANCE.navigateValueSet(i,f,u,M,s)}loadForeignModule(o,i,s){const g=(w,f)=>this.c.fhr(w,f),p={host:(0,D.createProxyObject)(s,g),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(p,i),Promise.resolve((0,D.getAllMethodNames)(this.g))):new Promise((w,f)=>{q([o],u=>{this.g=u.create(p,i),w((0,D.getAllMethodNames)(this.g))},f)})}fmr(o,i){if(!this.g||typeof this.g[o]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+o));try{return Promise.resolve(this.g[o].apply(this.g,i))}catch(s){return Promise.reject(s)}}}n.EditorSimpleWorker=L,L.n=1e5,L.o=1e4;function d(b){return new L(b,null)}n.create=d,typeof importScripts=="function"&&(t.globals.monaco=(0,_.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c437ec2497ccd6b5ff5b2f6da86a8042e1ed951a/core/vs/base/worker/workerMain.js.map
