/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(ne){for(var e=[],c=0,t=ne.length;c<t;c++)e[c]=ye[ne[c]];return e};define(ye[80],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function c(A){return A?A.replace(/\$\((.*?)\)/g,(C,T)=>` ${T} `).trim():""}e.getCodiconAriaLabel=c;class t{constructor(C,T,S){this.id=C,this.definition=T,this.description=S,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var k;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function T(L){if(L instanceof t)return["codicon","codicon-"+L.id];const P=C.exec(L.id);if(!P)return T(t.error);const[,v,D]=P,E=["codicon","codicon-"+v];return D&&E.push("codicon-modifier-"+D.substring(1)),E}A.asClassNameArray=T;function S(L){return T(L).join(" ")}A.asClassName=S;function y(L){return"."+T(L).join(".")}A.asCSSSelector=y})(k=e.CSSIcon||(e.CSSIcon={}))}),define(ye[81],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(C,T){const S=Object.create(null);for(const y of C){const L=T(y);let P=S[L];P||(P=S[L]=[]),P.push(y)}return S}e.groupBy=c;function t(C,T){const S=[],y=[];for(const L of C)T.has(L)||S.push(L);for(const L of T)C.has(L)||y.push(L);return{removed:S,added:y}}e.diffSets=t;function k(C,T){const S=[],y=[];for(const[L,P]of C)T.has(L)||S.push(P);for(const[L,P]of T)C.has(L)||y.push(P);return{removed:S,added:y}}e.diffMaps=k;class A{constructor(){this.a=new Map}add(T,S){let y=this.a.get(T);y||(y=new Set,this.a.set(T,y)),y.add(S)}delete(T,S){const y=this.a.get(T);!y||(y.delete(S),y.size===0&&this.a.delete(T))}forEach(T,S){const y=this.a.get(T);!y||y.forEach(S)}}e.SetMap=A}),define(ye[60],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(C){return(T,S,y)=>{let L=null,P=null;if(typeof y.value=="function"?(L="value",P=y.value):typeof y.get=="function"&&(L="get",P=y.get),!P)throw new Error("not supported");y[L]=C(P,S)}}function t(C,T,S){let y=null,L=null;if(typeof S.value=="function"?(y="value",L=S.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(y="get",L=S.get),!L)throw new Error("not supported");const P=`$memoize$${T}`;S[y]=function(...v){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[P]}}e.memoize=t;function k(C,T,S){return c((y,L)=>{const P=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...D){this[v]||(this[v]=S?S():void 0),clearTimeout(this[P]),T&&(this[v]=T(this[v],...D),D=[this[v]]),this[P]=setTimeout(()=>{y.apply(this,D),this[v]=S?S():void 0},C)}})}e.debounce=k;function A(C,T,S){return c((y,L)=>{const P=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,D=`$throttle$lastRun$${L}`,E=`$throttle$pending$${L}`;return function(...d){if(this[v]||(this[v]=S?S():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),T&&(this[v]=T(this[v],...d)),this[E])return;const m=this[D]+C;m<=Date.now()?(this[D]=Date.now(),y.apply(this,[this[v]]),this[v]=S?S():void 0):(this[E]=!0,this[P]=setTimeout(()=>{this[E]=!1,this[D]=Date.now(),y.apply(this,[this[v]]),this[v]=S?S():void 0},m-Date.now()))}})}e.throttle=A}),define(ye[10],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?p.isErrorNoTelemetry(i)?new p(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=c,e.errorHandler=new c;function t(w){e.errorHandler.setUnexpectedErrorHandler(w)}e.setUnexpectedErrorHandler=t;function k(w){S(w)||e.errorHandler.onUnexpectedError(w)}e.onUnexpectedError=k;function A(w){S(w)||e.errorHandler.onUnexpectedExternalError(w)}e.onUnexpectedExternalError=A;function C(w){if(w instanceof Error){const{name:i,message:o}=w,u=w.stacktrace||w.stack;return{$isError:!0,name:i,message:o,stack:u,noTelemetry:p.isErrorNoTelemetry(w)}}return w}e.transformErrorForSerialization=C;const T="Canceled";function S(w){return w instanceof y?!0:w instanceof Error&&w.name===T&&w.message===T}e.isCancellationError=S;class y extends Error{constructor(){super(T),this.name=this.message}}e.CancellationError=y;function L(){const w=new Error(T);return w.name=w.message,w}e.canceled=L;function P(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}e.illegalArgument=P;function v(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}e.illegalState=v;function D(w){return w?new Error(`readonly property '${w} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=D;function E(w){const i=new Error(`${w} has been disposed`);return i.name="DISPOSED",i}e.disposed=E;function d(w){return w?w.message?w.message:w.stack?w.stack.split(`
`)[0]:String(w):"Error"}e.getErrorMessage=d;class m extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=m;class h extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=h;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class p extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof p)return i;const o=new p;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class g extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(ye[17],Ce([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(se,le=0){return se[se.length-(1+le)]}e.tail=t;function k(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=k;function A(se,le,ue=(ee,ae)=>ee===ae){if(se===le)return!0;if(!se||!le||se.length!==le.length)return!1;for(let ee=0,ae=se.length;ee<ae;ee++)if(!ue(se[ee],le[ee]))return!1;return!0}e.equals=A;function C(se,le){const ue=se.length-1;le<ue&&(se[le]=se[ue]),se.pop()}e.removeFastWithoutKeepingOrder=C;function T(se,le,ue){return S(se.length,ee=>ue(se[ee],le))}e.binarySearch=T;function S(se,le){let ue=0,ee=se-1;for(;ue<=ee;){const ae=(ue+ee)/2|0,ie=le(ae);if(ie<0)ue=ae+1;else if(ie>0)ee=ae-1;else return ae}return-(ue+1)}e.binarySearch2=S;function y(se,le){let ue=0,ee=se.length;if(ee===0)return 0;for(;ue<ee;){const ae=Math.floor((ue+ee)/2);le(se[ae])?ee=ae:ue=ae+1}return ue}e.findFirstInSorted=y;function L(se,le,ue){if(se=se|0,se>=le.length)throw new TypeError("invalid index");const ee=le[Math.floor(le.length*Math.random())],ae=[],ie=[],O=[];for(const W of le){const K=ue(W,ee);K<0?ae.push(W):K>0?ie.push(W):O.push(W)}return se<ae.length?L(se,ae,ue):se<ae.length+O.length?O[0]:L(se-(ae.length+O.length),ie,ue)}e.quickSelect=L;function P(se,le){const ue=[];let ee;for(const ae of se.slice(0).sort(le))!ee||le(ee[0],ae)!==0?(ee=[ae],ue.push(ee)):ee.push(ae);return ue}e.groupBy=P;function v(se,le,ue){const ee=[];function ae(W,K,Y){if(K===0&&Y.length===0)return;const de=ee[ee.length-1];de&&de.start+de.deleteCount===W?(de.deleteCount+=K,de.toInsert.push(...Y)):ee.push({start:W,deleteCount:K,toInsert:Y})}let ie=0,O=0;for(;;){if(ie===se.length){ae(ie,0,le.slice(O));break}if(O===le.length){ae(ie,se.length-ie,[]);break}const W=se[ie],K=le[O],Y=ue(W,K);Y===0?(ie+=1,O+=1):Y<0?(ae(ie,1,[]),ie+=1):Y>0&&(ae(ie,0,[K]),O+=1)}return ee}e.sortedDiff=v;function D(se,le,ue){const ee=v(se,le,ue),ae=[],ie=[];for(const O of ee)ae.push(...se.slice(O.start,O.start+O.deleteCount)),ie.push(...O.toInsert);return{removed:ae,added:ie}}e.delta=D;function E(se,le,ue){if(ue===0)return[];const ee=se.slice(0,ue).sort(le);return m(se,le,ee,ue,se.length),ee}e.top=E;function d(se,le,ue,ee,ae){return ue===0?Promise.resolve([]):new Promise((ie,O)=>{(async()=>{const W=se.length,K=se.slice(0,ue).sort(le);for(let Y=ue,de=Math.min(ue+ee,W);Y<W;Y=de,de=Math.min(de+ee,W)){if(Y>ue&&await new Promise(be=>setTimeout(be)),ae&&ae.isCancellationRequested)throw new c.CancellationError;m(se,le,K,Y,de)}return K})().then(ie,O)})}e.topAsync=d;function m(se,le,ue,ee,ae){for(const ie=ue.length;ee<ae;ee++){const O=se[ee];if(le(O,ue[ie-1])<0){ue.pop();const W=y(ue,K=>le(O,K)<0);ue.splice(W,0,O)}}}function h(se){return se.filter(le=>!!le)}e.coalesce=h;function b(se){let le=0;for(let ue=0;ue<se.length;ue++)se[ue]&&(se[le]=se[ue],le+=1);se.length=le}e.coalesceInPlace=b;function p(se,le,ue){se.splice(ue,0,se.splice(le,1)[0])}e.move=p;function g(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=g;function w(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=w;function i(se,le=ue=>ue){const ue=new Set;return se.filter(ee=>{const ae=le(ee);return ue.has(ae)?!1:(ue.add(ae),!0)})}e.distinct=i;function o(se){const le=new Set;return ue=>{const ee=se(ue);return le.has(ee)?!1:(le.add(ee),!0)}}e.uniqueFilter=o;function u(se,le){const ue=l(se,le);if(ue!==-1)return se[ue]}e.findLast=u;function l(se,le){for(let ue=se.length-1;ue>=0;ue--){const ee=se[ue];if(le(ee))return ue}return-1}e.lastIndex=l;function s(se,le){return se.length>0?se[0]:le}e.firstOrDefault=s;function a(se,le){return se.length>0?se[se.length-1]:le}e.lastOrDefault=a;function n(se,le,ue=(ee,ae)=>ee===ae){let ee=0;for(let ae=0,ie=Math.min(se.length,le.length);ae<ie&&ue(se[ae],le[ae]);ae++)ee++;return ee}e.commonPrefixLength=n;function r(se){return[].concat(...se)}e.flatten=r;function f(se,le){let ue=typeof le=="number"?se:0;typeof le=="number"?ue=se:(ue=0,le=se);const ee=[];if(ue<=le)for(let ae=ue;ae<le;ae++)ee.push(ae);else for(let ae=ue;ae>le;ae--)ee.push(ae);return ee}e.range=f;function I(se,le,ue){return se.reduce((ee,ae)=>(ee[le(ae)]=ue?ue(ae):ae,ee),Object.create(null))}e.index=I;function R(se,le){return se.push(le),()=>B(se,le)}e.insert=R;function B(se,le){const ue=se.indexOf(le);if(ue>-1)return se.splice(ue,1),le}e.remove=B;function X(se,le,ue){const ee=se.slice(0,le),ae=se.slice(le);return ee.concat(ue,ae)}e.arrayInsert=X;function q(se,le){let ue;if(typeof le=="number"){let ee=le;ue=()=>{const ae=Math.sin(ee++)*179426549;return ae-Math.floor(ae)}}else ue=Math.random;for(let ee=se.length-1;ee>0;ee-=1){const ae=Math.floor(ue()*(ee+1)),ie=se[ee];se[ee]=se[ae],se[ae]=ie}}e.shuffle=q;function N(se,le){const ue=se.indexOf(le);ue>-1&&(se.splice(ue,1),se.unshift(le))}e.pushToStart=N;function M(se,le){const ue=se.indexOf(le);ue>-1&&(se.splice(ue,1),se.push(le))}e.pushToEnd=M;function F(se,le){for(const ue of le)se.push(ue)}e.pushMany=F;function z(se,le){return Array.isArray(se)?se.map(le):le(se)}e.mapArrayOrNot=z;function U(se){return Array.isArray(se)?se:[se]}e.asArray=U;function H(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=H;function x(se,le){for(const ue of se){const ee=le(ue);if(ee!==void 0)return ee}}e.mapFind=x;function V(se,le,ue){const ee=Q(se,le),ae=se.length,ie=ue.length;se.length=ae+ie;for(let O=ae-1;O>=ee;O--)se[O+ie]=se[O];for(let O=0;O<ie;O++)se[O+ee]=ue[O]}e.insertInto=V;function _(se,le,ue,ee){const ae=Q(se,le),ie=se.splice(ae,ue);return V(se,ae,ee),ie}e.splice=_;function Q(se,le){return le<0?Math.max(le+se.length,0):Math.min(le,se.length)}var Z;(function(se){function le(ae){return ae<0}se.isLessThan=le;function ue(ae){return ae>0}se.isGreaterThan=ue;function ee(ae){return ae===0}se.isNeitherLessOrGreaterThan=ee,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(Z=e.CompareResult||(e.CompareResult={}));function ge(se,le){return(ue,ee)=>le(se(ue),se(ee))}e.compareBy=ge;function te(...se){return(le,ue)=>{for(const ee of se){const ae=ee(le,ue);if(!Z.isNeitherLessOrGreaterThan(ae))return ae}return Z.neitherLessOrGreaterThan}}e.tieBreakComparators=te;const J=(se,le)=>se-le;e.numberComparator=J;function fe(se,le){if(se.length===0)return;let ue=se[0];for(let ee=1;ee<se.length;ee++){const ae=se[ee];le(ae,ue)>0&&(ue=ae)}return ue}e.findMaxBy=fe;function ve(se,le){if(se.length===0)return;let ue=se[0];for(let ee=1;ee<se.length;ee++){const ae=se[ee];le(ae,ue)>=0&&(ue=ae)}return ue}e.findLastMaxBy=ve;function Ee(se,le){return fe(se,(ue,ee)=>-le(ue,ee))}e.findMinBy=Ee;class Ae{constructor(le){this.f=le,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(le){let ue=this.c;for(;ue<this.f.length&&le(this.f[ue]);)ue++;const ee=ue===this.c?null:this.f.slice(this.c,ue);return this.c=ue,ee}takeFromEndWhile(le){let ue=this.d;for(;ue>=0&&le(this.f[ue]);)ue--;const ee=ue===this.d?null:this.f.slice(ue+1,this.d+1);return this.d=ue,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const le=this.f[this.c];return this.c++,le}removeLast(){const le=this.f[this.d];return this.d--,le}takeCount(le){const ue=this.f.slice(this.c,this.c+le);return this.c+=le,ue}}e.ArrayQueue=Ae;class Fe{constructor(le){this.iterate=le}forEach(le){this.iterate(ue=>(le(ue),!0))}toArray(){const le=[];return this.iterate(ue=>(le.push(ue),!0)),le}filter(le){return new Fe(ue=>this.iterate(ee=>le(ee)?ue(ee):!0))}map(le){return new Fe(ue=>this.iterate(ee=>ue(le(ee))))}some(le){let ue=!1;return this.iterate(ee=>(ue=le(ee),!ue)),ue}findFirst(le){let ue;return this.iterate(ee=>le(ee)?(ue=ee,!1):!0),ue}findLast(le){let ue;return this.iterate(ee=>(le(ee)&&(ue=ee),!0)),ue}findLastMaxBy(le){let ue,ee=!0;return this.iterate(ae=>((ee||Z.isGreaterThan(le(ae,ue)))&&(ee=!1,ue=ae),!0)),ue}}e.CallbackIterable=Fe,Fe.empty=new Fe(se=>{})}),define(ye[49],Ce([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,y){if(!S)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=t;function k(S,y="Unreachable"){throw new Error(y)}e.assertNever=k;function A(S){if(!S)throw new c.BugIndicatingError("Assertion Failed")}e.assert=A;function C(S){if(!S()){debugger;S(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function T(S,y){let L=0;for(;L<S.length-1;){const P=S[L],v=S[L+1];if(!y(P,v))return!1;L++}return!0}e.checkAdjacentItems=T}),define(ye[61],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(t){const k=this;let A=!1,C;return function(){return A||(A=!0,C=t.apply(k,arguments)),C}}e.once=c}),define(ye[100],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(k){this.a=k,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(ye[62],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(t){function k(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}t.is=k;const A=Object.freeze([]);function C(){return A}t.empty=C;function*T(g){yield g}t.single=T;function S(g){return k(g)?g:T(g)}t.wrap=S;function y(g){return g||A}t.from=y;function L(g){return!g||g[Symbol.iterator]().next().done===!0}t.isEmpty=L;function P(g){return g[Symbol.iterator]().next().value}t.first=P;function v(g,w){for(const i of g)if(w(i))return!0;return!1}t.some=v;function D(g,w){for(const i of g)if(w(i))return i}t.find=D;function*E(g,w){for(const i of g)w(i)&&(yield i)}t.filter=E;function*d(g,w){let i=0;for(const o of g)yield w(o,i++)}t.map=d;function*m(...g){for(const w of g)for(const i of w)yield i}t.concat=m;function h(g,w,i){let o=i;for(const u of g)o=w(o,u);return o}t.reduce=h;function*b(g,w,i=g.length){for(w<0&&(w+=g.length),i<0?i+=g.length:i>g.length&&(i=g.length);w<i;w++)yield g[w]}t.slice=b;function p(g,w=Number.POSITIVE_INFINITY){const i=[];if(w===0)return[i,g];const o=g[Symbol.iterator]();for(let u=0;u<w;u++){const l=o.next();if(l.done)return[i,t.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return o}}]}t.consume=p})(c=e.Iterable||(e.Iterable={}))}),define(ye[146],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function C(i,o=!1){let u=0;const l=i.length;let s="",a=0,n=16,r=0;function f(M){let F=0,z=0;for(;F<M;){const U=i.charCodeAt(u);if(U>=48&&U<=57)z=z*16+U-48;else if(U>=65&&U<=70)z=z*16+U-65+10;else if(U>=97&&U<=102)z=z*16+U-97+10;else break;u++,F++}return F<M&&(z=-1),z}function I(M){u=M,s="",a=0,n=16,r=0}function R(){const M=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&y(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&y(i.charCodeAt(u)))for(u++;u<i.length&&y(i.charCodeAt(u));)u++;else return r=3,i.substring(M,u);let F=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&y(i.charCodeAt(u))){for(u++;u<i.length&&y(i.charCodeAt(u));)u++;F=u}else r=3;return i.substring(M,F)}function B(){let M="",F=u;for(;;){if(u>=l){M+=i.substring(F,u),r=2;break}const z=i.charCodeAt(u);if(z===34){M+=i.substring(F,u),u++;break}if(z===92){if(M+=i.substring(F,u),u++,u>=l){r=2;break}switch(i.charCodeAt(u++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const H=f(4);H>=0?M+=String.fromCharCode(H):r=4;break}default:r=5}F=u;continue}if(z>=0&&z<=31)if(S(z)){M+=i.substring(F,u),r=2;break}else r=6;u++}return M}function X(){if(s="",r=0,a=u,u>=l)return a=l,n=17;let M=i.charCodeAt(u);if(T(M)){do u++,s+=String.fromCharCode(M),M=i.charCodeAt(u);while(T(M));return n=15}if(S(M))return u++,s+=String.fromCharCode(M),M===13&&i.charCodeAt(u)===10&&(u++,s+=`
`),n=14;switch(M){case 123:return u++,n=1;case 125:return u++,n=2;case 91:return u++,n=3;case 93:return u++,n=4;case 58:return u++,n=6;case 44:return u++,n=5;case 34:return u++,s=B(),n=10;case 47:{const F=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<l&&!S(i.charCodeAt(u));)u++;return s=i.substring(F,u),n=12}if(i.charCodeAt(u+1)===42){u+=2;const z=l-1;let U=!1;for(;u<z;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,U=!0;break}u++}return U||(u++,r=1),s=i.substring(F,u),n=13}return s+=String.fromCharCode(M),u++,n=16}case 45:if(s+=String.fromCharCode(M),u++,u===l||!y(i.charCodeAt(u)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=R(),n=11;default:for(;u<l&&q(M);)u++,M=i.charCodeAt(u);if(a!==u){switch(s=i.substring(a,u),s){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return s+=String.fromCharCode(M),u++,n=16}}function q(M){if(T(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let M;do M=X();while(M>=12&&M<=15);return M}return{setPosition:I,getPosition:()=>u,scan:o?N:X,getToken:()=>n,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>u-a,getTokenError:()=>r}}e.createScanner=C;function T(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function y(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function P(i,o){const u=[],l=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function r(f,I,R,B){a.value=f,a.offset=I,a.length=R,a.type=B,a.colonOffset=void 0,s=a}try{p(i,{onObjectBegin:(f,I)=>{if(o<=f)throw l;s=void 0,n=o>f,u.push("")},onObjectProperty:(f,I,R)=>{if(o<I||(r(f,I,R,"property"),u[u.length-1]=f,o<=I+R))throw l},onObjectEnd:(f,I)=>{if(o<=f)throw l;s=void 0,u.pop()},onArrayBegin:(f,I)=>{if(o<=f)throw l;s=void 0,u.push(0)},onArrayEnd:(f,I)=>{if(o<=f)throw l;s=void 0,u.pop()},onLiteralValue:(f,I,R)=>{if(o<I||(r(f,I,R,w(f)),o<=I+R))throw l},onSeparator:(f,I,R)=>{if(o<=I)throw l;if(f===":"&&s&&s.type==="property")s.colonOffset=I,n=!1,s=void 0;else if(f===","){const B=u[u.length-1];typeof B=="number"?u[u.length-1]=B+1:(n=!0,u[u.length-1]=""),s=void 0}}})}catch(f){if(f!==l)throw f}return{path:u,previousNode:s,isAtPropertyKey:n,matches:f=>{let I=0;for(let R=0;I<f.length&&R<u.length;R++)if(f[I]===u[R]||f[I]==="*")I++;else if(f[I]!=="**")return!1;return I===f.length}}}e.getLocation=P;function v(i,o=[],u=A.DEFAULT){let l=null,s=[];const a=[];function n(f){Array.isArray(s)?s.push(f):l!==null&&(s[l]=f)}return p(i,{onObjectBegin:()=>{const f={};n(f),a.push(s),s=f,l=null},onObjectProperty:f=>{l=f},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const f=[];n(f),a.push(s),s=f,l=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:n,onError:(f,I,R)=>{o.push({error:f,offset:I,length:R})}},u),s[0]}e.parse=v;function D(i,o=[],u=A.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(f){l.type==="property"&&(l.length=f-l.offset,l=l.parent)}function a(f){return l.children.push(f),f}p(i,{onObjectBegin:f=>{l=a({type:"object",offset:f,length:-1,parent:l,children:[]})},onObjectProperty:(f,I,R)=>{l=a({type:"property",offset:I,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:f,offset:I,length:R,parent:l})},onObjectEnd:(f,I)=>{l.length=f+I-l.offset,l=l.parent,s(f+I)},onArrayBegin:(f,I)=>{l=a({type:"array",offset:f,length:-1,parent:l,children:[]})},onArrayEnd:(f,I)=>{l.length=f+I-l.offset,l=l.parent,s(f+I)},onLiteralValue:(f,I,R)=>{a({type:w(f),offset:I,length:R,parent:l,value:f}),s(I+R)},onSeparator:(f,I,R)=>{l.type==="property"&&(f===":"?l.colonOffset=I:f===","&&s(I))},onError:(f,I,R)=>{o.push({error:f,offset:I,length:R})}},u);const r=l.children[0];return r&&delete r.parent,r}e.parseTree=D;function E(i,o){if(!i)return;let u=i;for(const l of o)if(typeof l=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let s=!1;for(const a of u.children)if(Array.isArray(a.children)&&a.children[0].value===l){u=a.children[1],s=!0;break}if(!s)return}else{const s=l;if(u.type!=="array"||s<0||!Array.isArray(u.children)||s>=u.children.length)return;u=u.children[s]}return u}e.findNodeAtLocation=E;function d(i){if(!i.parent||!i.parent.children)return[];const o=d(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;o.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&o.push(u)}return o}e.getNodePath=d;function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const o=Object.create(null);for(const u of i.children){const l=u.children[1];l&&(o[u.children[0].value]=m(l))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=m;function h(i,o,u=!1){return o>=i.offset&&o<i.offset+i.length||u&&o===i.offset+i.length}e.contains=h;function b(i,o,u=!1){if(h(i,o,u)){const l=i.children;if(Array.isArray(l))for(let s=0;s<l.length&&l[s].offset<=o;s++){const a=b(l[s],o,u);if(a)return a}return i}}e.findNodeAtOffset=b;function p(i,o,u=A.DEFAULT){const l=C(i,!1);function s(ge){return ge?()=>ge(l.getTokenOffset(),l.getTokenLength()):()=>!0}function a(ge){return ge?te=>ge(te,l.getTokenOffset(),l.getTokenLength()):()=>!0}const n=s(o.onObjectBegin),r=a(o.onObjectProperty),f=s(o.onObjectEnd),I=s(o.onArrayBegin),R=s(o.onArrayEnd),B=a(o.onLiteralValue),X=a(o.onSeparator),q=s(o.onComment),N=a(o.onError),M=u&&u.disallowComments,F=u&&u.allowTrailingComma;function z(){for(;;){const ge=l.scan();switch(l.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:M||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ge){case 12:case 13:M?U(10):q();break;case 16:U(1);break;case 15:case 14:break;default:return ge}}}function U(ge,te=[],J=[]){if(N(ge),te.length+J.length>0){let fe=l.getToken();for(;fe!==17;){if(te.indexOf(fe)!==-1){z();break}else if(J.indexOf(fe)!==-1)break;fe=z()}}}function H(ge){const te=l.getTokenValue();return ge?B(te):r(te),z(),!0}function x(){switch(l.getToken()){case 11:{let ge=0;try{ge=JSON.parse(l.getTokenValue()),typeof ge!="number"&&(U(2),ge=0)}catch{U(2)}B(ge);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return z(),!0}function V(){return l.getToken()!==10?(U(3,[],[2,5]),!1):(H(!1),l.getToken()===6?(X(":"),z(),Z()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function _(){n(),z();let ge=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ge||U(4,[],[]),X(","),z(),l.getToken()===2&&F)break}else ge&&U(6,[],[]);V()||U(4,[],[2,5]),ge=!0}return f(),l.getToken()!==2?U(7,[2],[]):z(),!0}function Q(){I(),z();let ge=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ge||U(4,[],[]),X(","),z(),l.getToken()===4&&F)break}else ge&&U(6,[],[]);Z()||U(4,[],[4,5]),ge=!0}return R(),l.getToken()!==4?U(8,[4],[]):z(),!0}function Z(){switch(l.getToken()){case 3:return Q();case 1:return _();case 10:return H(!0);default:return x()}}return z(),l.getToken()===17?u.allowEmptyContent?!0:(U(4,[],[]),!1):Z()?(l.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=p;function g(i,o){const u=C(i),l=[];let s,a=0,n;do switch(n=u.getPosition(),s=u.scan(),s){case 12:case 13:case 17:a!==n&&l.push(i.substring(a,n)),o!==void 0&&l.push(u.getTokenValue().replace(/[^\r\n]/g,o)),a=u.getPosition();break}while(s!==17);return l.join("")}e.stripComments=g;function w(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(ye[82],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(k){this.d=k,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(k){return new c(()=>k(this.getValue()))}}e.Lazy=c}),define(ye[6],Ce([1,0,61,62]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let A=null;function C(a){A=a}if(e.setDisposableTracker=C,k){const a="__is_disposable_tracked__";C(new class{trackDisposable(n){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[a]||console.log(r)},3e3)}setParent(n,r){if(n&&n!==b.None)try{n[a]=!0}catch{}}markAsDisposed(n){if(n&&n!==b.None)try{n[a]=!0}catch{}}markAsSingleton(n){}})}function T(a){return A?.trackDisposable(a),a}function S(a){A?.markAsDisposed(a)}function y(a,n){A?.setParent(a,n)}function L(a,n){if(!!A)for(const r of a)A.setParent(r,n)}function P(a){return A?.markAsSingleton(a),a}e.markAsSingleton=P;function v(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=v;function D(a){if(t.Iterable.is(a)){const n=[];for(const r of a)if(r)try{r.dispose()}catch(f){n.push(f)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=D;function E(a){for(const n of a)v(n)&&n.dispose();return[]}e.disposeIfDisposable=E;function d(...a){const n=m(()=>D(a));return L(a,n),n}e.combinedDisposable=d;function m(a){const n=T({dispose:(0,c.once)(()=>{S(n),a()})});return n}e.toDisposable=m;class h{constructor(){this.c=new Set,this.f=!1,T(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{D(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return y(n,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this.q=new h,T(this),y(this.q,this)}dispose(){S(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class p{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&y(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&y(n,null),n}}e.MutableDisposable=p;class g{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=g;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(n){let r=n;return this.unset=()=>r=void 0,this.isset=()=>r!==void 0,this.dispose=()=>{r&&(r(),r=void 0,S(this))},this}}e.SafeDisposable=w;class i{constructor(){this.a=new Map}acquire(n,...r){let f=this.a.get(n);f||(f={counter:0,object:this.b(n,...r)},this.a.set(n,f));const{object:I}=f,R=(0,c.once)(()=>{--f.counter===0&&(this.c(n,f.object),this.a.delete(n))});return f.counter++,{object:I,dispose:R}}}e.ReferenceCollection=i;class o{constructor(n){this.a=n}async acquire(n,...r){const f=this.a.acquire(n,...r);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(I){throw f.dispose(),I}}}e.AsyncReferenceCollection=o;class u{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=u;function l(a){const n=new h;try{a(n)}finally{n.dispose()}}e.disposeOnReturn=l;class s{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{D(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,r,f=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),f||this.a.get(n)?.dispose(),this.a.set(n,r)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(ye[63],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(A){this.element=A,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class t{constructor(){this.a=c.Undefined,this.b=c.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===c.Undefined}clear(){let A=this.a;for(;A!==c.Undefined;){const C=A.next;A.prev=c.Undefined,A.next=c.Undefined,A=C}this.a=c.Undefined,this.b=c.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,C){const T=new c(A);if(this.a===c.Undefined)this.a=T,this.b=T;else if(C){const y=this.b;this.b=T,T.prev=y,y.next=T}else{const y=this.a;this.a=T,T.next=y,y.prev=T}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(T))}}shift(){if(this.a!==c.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==c.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==c.Undefined&&A.next!==c.Undefined){const C=A.prev;C.next=A.next,A.next.prev=C}else A.prev===c.Undefined&&A.next===c.Undefined?(this.a=c.Undefined,this.b=c.Undefined):A.next===c.Undefined?(this.b=this.b.prev,this.b.next=c.Undefined):A.prev===c.Undefined&&(this.a=this.a.next,this.a.prev=c.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==c.Undefined;)yield A.element,A=A.next}}e.LinkedList=t}),define(ye[28],Ce([1,0]),function(ne,e){"use strict";var c,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(E,d,m){let h=E.get(d);return h===void 0&&(h=m,E.set(d,h)),h}e.getOrSet=A;function C(E){const d=[];return E.forEach((m,h)=>{d.push(`${h} => ${m}`)}),`Map(${E.size}) {${d.join(", ")}}`}e.mapToString=C;function T(E){const d=[];return E.forEach(m=>{d.push(m)}),`Set(${E.size}) {${d.join(", ")}}`}e.setToString=T;class S{constructor(d,m){this.uri=d,this.value=m}}class y{constructor(d,m){this[c]="ResourceMap",d instanceof y?(this.b=new Map(d.b),this.c=m??y.a):(this.b=new Map,this.c=d??y.a)}set(d,m){return this.b.set(this.c(d),new S(d,m)),this}get(d){return this.b.get(this.c(d))?.value}has(d){return this.b.has(this.c(d))}get size(){return this.b.size}clear(){this.b.clear()}delete(d){return this.b.delete(this.c(d))}forEach(d,m){typeof m<"u"&&(d=d.bind(m));for(const[h,b]of this.b)d(b.value,b.uri,this)}*values(){for(const d of this.b.values())yield d.value}*keys(){for(const d of this.b.values())yield d.uri}*entries(){for(const d of this.b.values())yield[d.uri,d.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.b)yield[d.uri,d.value]}}e.ResourceMap=y,y.a=E=>E.toString();class L{constructor(d,m){this[t]="ResourceSet",!d||typeof d=="function"?this.a=new y(d):(this.a=new y(m),d.forEach(this.add,this))}get size(){return this.a.size}add(d){return this.a.set(d,d),this}clear(){this.a.clear()}delete(d){return this.a.delete(d)}forEach(d,m){this.a.forEach((h,b)=>d.call(m,b,b,this))}has(d){return this.a.has(d)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var P;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class v{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(d){return this.a.has(d)}get(d,m=0){const h=this.a.get(d);if(!!h)return m!==0&&this.j(h,m),h.value}set(d,m,h=0){let b=this.a.get(d);if(b)b.value=m,h!==0&&this.j(b,h);else{switch(b={key:d,value:m,next:void 0,previous:void 0},h){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(d,b),this.d++}return this}delete(d){return!!this.remove(d)}remove(d){const m=this.a.get(d);if(!!m)return this.a.delete(d),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const d=this.b;return this.a.delete(d.key),this.i(d),this.d--,d.value}forEach(d,m){const h=this.e;let b=this.b;for(;b;){if(m?d.bind(m)(b.value,b.key,this):d(b.value,b.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const d=this,m=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(d.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:h.key,done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return b}values(){const d=this,m=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(d.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:h.value,done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return b}entries(){const d=this,m=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(d.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:[h.key,h.value],done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return b}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(d){if(d>=this.size)return;if(d===0){this.clear();return}let m=this.b,h=this.size;for(;m&&h>d;)this.a.delete(m.key),m=m.next,h--;this.b=m,this.d=h,m&&(m.previous=void 0),this.e++}g(d){if(!this.b&&!this.c)this.c=d;else if(this.b)d.next=this.b,this.b.previous=d;else throw new Error("Invalid list");this.b=d,this.e++}h(d){if(!this.b&&!this.c)this.b=d;else if(this.c)d.previous=this.c,this.c.next=d;else throw new Error("Invalid list");this.c=d,this.e++}i(d){if(d===this.b&&d===this.c)this.b=void 0,this.c=void 0;else if(d===this.b){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.b=d.next}else if(d===this.c){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.c=d.previous}else{const m=d.next,h=d.previous;if(!m||!h)throw new Error("Invalid list");m.previous=h,h.next=m}d.next=void 0,d.previous=void 0,this.e++}j(d,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(d===this.b)return;const h=d.next,b=d.previous;d===this.c?(b.next=void 0,this.c=b):(h.previous=b,b.next=h),d.previous=void 0,d.next=this.b,this.b.previous=d,this.b=d,this.e++}else if(m===2){if(d===this.c)return;const h=d.next,b=d.previous;d===this.b?(h.previous=void 0,this.b=h):(h.previous=b,b.next=h),d.next=void 0,d.previous=this.c,this.c.next=d,this.c=d,this.e++}}}toJSON(){const d=[];return this.forEach((m,h)=>{d.push([h,m])}),d}fromJSON(d){this.clear();for(const[m,h]of d)this.set(m,h)}}e.LinkedMap=v;class D extends v{constructor(d,m=1){super(),this.k=d,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(d){this.k=d,this.m()}get ratio(){return this.l}set ratio(d){this.l=Math.min(Math.max(0,d),1),this.m()}get(d,m=2){return super.get(d,m)}peek(d){return super.get(d,0)}set(d,m){return super.set(d,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=D}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],Ce([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(se,le){for(var ue=0;ue<le.length;ue++){var ee=le[ue];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(se,ee.key,ee)}}function c(se,le,ue){return le&&e(se.prototype,le),ue&&e(se,ue),Object.defineProperty(se,"prototype",{writable:!1}),se}function t(se,le){if(!!se){if(typeof se=="string")return k(se,le);var ue=Object.prototype.toString.call(se).slice(8,-1);if(ue==="Object"&&se.constructor&&(ue=se.constructor.name),ue==="Map"||ue==="Set")return Array.from(se);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return k(se,le)}}function k(se,le){(le==null||le>se.length)&&(le=se.length);for(var ue=0,ee=new Array(le);ue<le;ue++)ee[ue]=se[ue];return ee}function A(se,le){var ue=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(ue)return(ue=ue.call(se)).next.bind(ue);if(Array.isArray(se)||(ue=t(se))||le&&se&&typeof se.length=="number"){ue&&(se=ue);var ee=0;return function(){return ee>=se.length?{done:!0}:{done:!1,value:se[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=C();function T(se){ne.defaults=se}var S=/[&<>"']/,y=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(le){return v[le]};function E(se,le){if(le){if(S.test(se))return se.replace(y,D)}else if(L.test(se))return se.replace(P,D);return se}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(se){return se.replace(d,function(le,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var h=/(^|[^\[])\^/g;function b(se,le){se=typeof se=="string"?se:se.source,le=le||"";var ue={replace:function(ae,ie){return ie=ie.source||ie,ie=ie.replace(h,"$1"),se=se.replace(ae,ie),ue},getRegex:function(){return new RegExp(se,le)}};return ue}var p=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(se,le,ue){if(se){var ee;try{ee=decodeURIComponent(m(ue)).replace(p,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}le&&!g.test(ue)&&(ue=s(le,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var i={},o=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(se,le){i[" "+se]||(o.test(se)?i[" "+se]=se+"/":i[" "+se]=f(se,"/",!0)),se=i[" "+se];var ue=se.indexOf(":")===-1;return le.substring(0,2)==="//"?ue?le:se.replace(u,"$1")+le:le.charAt(0)==="/"?ue?le:se.replace(l,"$1")+le:se+le}var a={exec:function(){}};function n(se){for(var le=1,ue,ee;le<arguments.length;le++){ue=arguments[le];for(ee in ue)Object.prototype.hasOwnProperty.call(ue,ee)&&(se[ee]=ue[ee])}return se}function r(se,le){var ue=se.replace(/\|/g,function(ie,O,W){for(var K=!1,Y=O;--Y>=0&&W[Y]==="\\";)K=!K;return K?"|":" |"}),ee=ue.split(/ \|/),ae=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>le)ee.splice(le);else for(;ee.length<le;)ee.push("");for(;ae<ee.length;ae++)ee[ae]=ee[ae].trim().replace(/\\\|/g,"|");return ee}function f(se,le,ue){var ee=se.length;if(ee===0)return"";for(var ae=0;ae<ee;){var ie=se.charAt(ee-ae-1);if(ie===le&&!ue)ae++;else if(ie!==le&&ue)ae++;else break}return se.slice(0,ee-ae)}function I(se,le){if(se.indexOf(le[1])===-1)return-1;for(var ue=se.length,ee=0,ae=0;ae<ue;ae++)if(se[ae]==="\\")ae++;else if(se[ae]===le[0])ee++;else if(se[ae]===le[1]&&(ee--,ee<0))return ae;return-1}function R(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(se,le){if(le<1)return"";for(var ue="";le>1;)le&1&&(ue+=se),le>>=1,se+=se;return ue+se}function X(se,le,ue,ee){var ae=le.href,ie=le.title?E(le.title):null,O=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){ee.state.inLink=!0;var W={type:"link",raw:ue,href:ae,title:ie,text:O,tokens:ee.inlineTokens(O)};return ee.state.inLink=!1,W}return{type:"image",raw:ue,href:ae,title:ie,text:E(O)}}function q(se,le){var ue=se.match(/^(\s+)(?:```)/);if(ue===null)return le;var ee=ue[1];return le.split(`
`).map(function(ae){var ie=ae.match(/^\s+/);if(ie===null)return ae;var O=ie[0];return O.length>=ee.length?ae.slice(ee.length):ae}).join(`
`)}var N=function(){function se(ue){this.options=ue||ne.defaults}var le=se.prototype;return le.space=function(ee){var ae=this.rules.block.newline.exec(ee);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(ee){var ae=this.rules.block.code.exec(ee);if(ae){var ie=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:f(ie,`
`)}}},le.fences=function(ee){var ae=this.rules.block.fences.exec(ee);if(ae){var ie=ae[0],O=q(ie,ae[3]||"");return{type:"code",raw:ie,lang:ae[2]?ae[2].trim():ae[2],text:O}}},le.heading=function(ee){var ae=this.rules.block.heading.exec(ee);if(ae){var ie=ae[2].trim();if(/#$/.test(ie)){var O=f(ie,"#");(this.options.pedantic||!O||/ $/.test(O))&&(ie=O.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ie,tokens:this.lexer.inline(ie)}}},le.hr=function(ee){var ae=this.rules.block.hr.exec(ee);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(ee){var ae=this.rules.block.blockquote.exec(ee);if(ae){var ie=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},le.list=function(ee){var ae=this.rules.block.list.exec(ee);if(ae){var ie,O,W,K,Y,de,be,Pe,pe,De,ke,je,Ge=ae[1].trim(),et=Ge.length>1,_e={type:"list",raw:"",ordered:et,start:et?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=et?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=et?Ge:"[*+-]");for(var nt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(je=!1,!(!(ae=nt.exec(ee))||this.rules.block.hr.test(ee)));){if(ie=ae[0],ee=ee.substring(ie.length),Pe=ae[2].split(`
`,1)[0],pe=ee.split(`
`,1)[0],this.options.pedantic?(K=2,ke=Pe.trimLeft()):(K=ae[2].search(/[^ ]/),K=K>4?1:K,ke=Pe.slice(K),K+=ae[1].length),de=!1,!Pe&&/^ *$/.test(pe)&&(ie+=pe+`
`,ee=ee.substring(pe.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");ee&&(De=ee.split(`
`,1)[0],Pe=De,this.options.pedantic&&(Pe=Pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(Pe)||it.test(Pe)||st.test(Pe)||ht.test(ee)));){if(Pe.search(/[^ ]/)>=K||!Pe.trim())ke+=`
`+Pe.slice(K);else if(!de)ke+=`
`+Pe;else break;!de&&!Pe.trim()&&(de=!0),ie+=De+`
`,ee=ee.substring(De.length+1)}_e.loose||(be?_e.loose=!0:/\n *\n *$/.test(ie)&&(be=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(ke),O&&(W=O[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),_e.items.push({type:"list_item",raw:ie,task:!!O,checked:W,loose:!1,text:ke}),_e.raw+=ie}_e.items[_e.items.length-1].raw=ie.trimRight(),_e.items[_e.items.length-1].text=ke.trimRight(),_e.raw=_e.raw.trimRight();var oe=_e.items.length;for(Y=0;Y<oe;Y++){this.lexer.state.top=!1,_e.items[Y].tokens=this.lexer.blockTokens(_e.items[Y].text,[]);var $=_e.items[Y].tokens.filter(function(Ie){return Ie.type==="space"}),ce=$.every(function(Ie){for(var Le=Ie.raw.split(""),Be=0,xe=A(Le),Ze;!(Ze=xe()).done;){var gt=Ze.value;if(gt===`
`&&(Be+=1),Be>1)return!0}return!1});!_e.loose&&$.length&&ce&&(_e.loose=!0,_e.items[Y].loose=!0)}return _e}},le.html=function(ee){var ae=this.rules.block.html.exec(ee);if(ae){var ie={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(ae[0]):E(ae[0]);ie.type="paragraph",ie.text=O,ie.tokens=this.lexer.inline(O)}return ie}},le.def=function(ee){var ae=this.rules.block.def.exec(ee);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ie=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(ee){var ae=this.rules.block.table.exec(ee);if(ae){var ie={type:"table",header:r(ae[1]).map(function(be){return{text:be}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=ae[0];var O=ie.align.length,W,K,Y,de;for(W=0;W<O;W++)/^ *-+: *$/.test(ie.align[W])?ie.align[W]="right":/^ *:-+: *$/.test(ie.align[W])?ie.align[W]="center":/^ *:-+ *$/.test(ie.align[W])?ie.align[W]="left":ie.align[W]=null;for(O=ie.rows.length,W=0;W<O;W++)ie.rows[W]=r(ie.rows[W],ie.header.length).map(function(be){return{text:be}});for(O=ie.header.length,K=0;K<O;K++)ie.header[K].tokens=this.lexer.inline(ie.header[K].text);for(O=ie.rows.length,K=0;K<O;K++)for(de=ie.rows[K],Y=0;Y<de.length;Y++)de[Y].tokens=this.lexer.inline(de[Y].text);return ie}}},le.lheading=function(ee){var ae=this.rules.block.lheading.exec(ee);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(ee){var ae=this.rules.block.paragraph.exec(ee);if(ae){var ie=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ie,tokens:this.lexer.inline(ie)}}},le.text=function(ee){var ae=this.rules.block.text.exec(ee);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(ee){var ae=this.rules.inline.escape.exec(ee);if(ae)return{type:"escape",raw:ae[0],text:E(ae[1])}},le.tag=function(ee){var ae=this.rules.inline.tag.exec(ee);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):E(ae[0]):ae[0]}},le.link=function(ee){var ae=this.rules.inline.link.exec(ee);if(ae){var ie=ae[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var O=f(ie.slice(0,-1),"\\");if((ie.length-O.length)%2===0)return}else{var W=I(ae[2],"()");if(W>-1){var K=ae[0].indexOf("!")===0?5:4,Y=K+ae[1].length+W;ae[2]=ae[2].substring(0,W),ae[0]=ae[0].substring(0,Y).trim(),ae[3]=""}}var de=ae[2],be="";if(this.options.pedantic){var Pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Pe&&(de=Pe[1],be=Pe[3])}else be=ae[3]?ae[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(ie)?de=de.slice(1):de=de.slice(1,-1)),X(ae,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(ee,ae){var ie;if((ie=this.rules.inline.reflink.exec(ee))||(ie=this.rules.inline.nolink.exec(ee))){var O=(ie[2]||ie[1]).replace(/\s+/g," ");if(O=ae[O.toLowerCase()],!O||!O.href){var W=ie[0].charAt(0);return{type:"text",raw:W,text:W}}return X(ie,O,ie[0],this.lexer)}},le.emStrong=function(ee,ae,ie){ie===void 0&&(ie="");var O=this.rules.inline.emStrong.lDelim.exec(ee);if(!!O&&!(O[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=O[1]||O[2]||"";if(!W||W&&(ie===""||this.rules.inline.punctuation.exec(ie))){var K=O[0].length-1,Y,de,be=K,Pe=0,pe=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ae=ae.slice(-1*ee.length+K);(O=pe.exec(ae))!=null;)if(Y=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!Y){if(de=Y.length,O[3]||O[4]){be+=de;continue}else if((O[5]||O[6])&&K%3&&!((K+de)%3)){Pe+=de;continue}if(be-=de,!(be>0)){if(de=Math.min(de,de+be+Pe),Math.min(K,de)%2){var De=ee.slice(1,K+O.index+de);return{type:"em",raw:ee.slice(0,K+O.index+de+1),text:De,tokens:this.lexer.inlineTokens(De)}}var ke=ee.slice(2,K+O.index+de-1);return{type:"strong",raw:ee.slice(0,K+O.index+de+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},le.codespan=function(ee){var ae=this.rules.inline.code.exec(ee);if(ae){var ie=ae[2].replace(/\n/g," "),O=/[^ ]/.test(ie),W=/^ /.test(ie)&&/ $/.test(ie);return O&&W&&(ie=ie.substring(1,ie.length-1)),ie=E(ie,!0),{type:"codespan",raw:ae[0],text:ie}}},le.br=function(ee){var ae=this.rules.inline.br.exec(ee);if(ae)return{type:"br",raw:ae[0]}},le.del=function(ee){var ae=this.rules.inline.del.exec(ee);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(ee,ae){var ie=this.rules.inline.autolink.exec(ee);if(ie){var O,W;return ie[2]==="@"?(O=E(this.options.mangle?ae(ie[1]):ie[1]),W="mailto:"+O):(O=E(ie[1]),W=O),{type:"link",raw:ie[0],text:O,href:W,tokens:[{type:"text",raw:O,text:O}]}}},le.url=function(ee,ae){var ie;if(ie=this.rules.inline.url.exec(ee)){var O,W;if(ie[2]==="@")O=E(this.options.mangle?ae(ie[0]):ie[0]),W="mailto:"+O;else{var K;do K=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(K!==ie[0]);O=E(ie[0]),ie[1]==="www."?W="http://"+O:W=O}return{type:"link",raw:ie[0],text:O,href:W,tokens:[{type:"text",raw:O,text:O}]}}},le.inlineText=function(ee,ae){var ie=this.rules.inline.text.exec(ee);if(ie){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):E(ie[0]):ie[0]:O=E(this.options.smartypants?ae(ie[0]):ie[0]),{type:"text",raw:ie[0],text:O}}},se}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=b(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=b(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=b(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=b(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=b(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=b(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=n({},M),M.gfm=n({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=b(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=b(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=n({},M.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:b(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=b(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=b(M._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=b(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=b(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=b(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=b(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=b(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=b(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=b(F.reflink).replace("label",F._label).replace("ref",M._label).getRegex(),F.nolink=b(F.nolink).replace("ref",M._label).getRegex(),F.reflinkSearch=b(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:b(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=b(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:b(F.br).replace("{2,}","*").getRegex(),text:b(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(se){var le="",ue,ee,ae=se.length;for(ue=0;ue<ae;ue++)ee=se.charCodeAt(ue),Math.random()>.5&&(ee="x"+ee.toString(16)),le+="&#"+ee+";";return le}var H=function(){function se(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||ne.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:M.normal,inline:F.normal};this.options.pedantic?(ee.block=M.pedantic,ee.inline=F.pedantic):this.options.gfm&&(ee.block=M.gfm,this.options.breaks?ee.inline=F.breaks:ee.inline=F.gfm),this.tokenizer.rules=ee}se.lex=function(ee,ae){var ie=new se(ae);return ie.lex(ee)},se.lexInline=function(ee,ae){var ie=new se(ae);return ie.inlineTokens(ee)};var le=se.prototype;return le.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(ee,ae){var ie=this;ae===void 0&&(ae=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(be,Pe,pe){return Pe+"    ".repeat(pe.length)});for(var O,W,K,Y;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(be){return(O=be.call({lexer:ie},ee,ae))?(ee=ee.substring(O.raw.length),ae.push(O),!0):!1}))){if(O=this.tokenizer.space(ee)){ee=ee.substring(O.raw.length),O.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(O);continue}if(O=this.tokenizer.code(ee)){ee=ee.substring(O.raw.length),W=ae[ae.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):ae.push(O);continue}if(O=this.tokenizer.fences(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.heading(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.hr(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.blockquote(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.list(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.html(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.def(ee)){ee=ee.substring(O.raw.length),W=ae[ae.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+O.raw,W.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.lheading(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(K=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var be=1/0,Pe=ee.slice(1),pe=void 0;ie.options.extensions.startBlock.forEach(function(De){pe=De.call({lexer:this},Pe),typeof pe=="number"&&pe>=0&&(be=Math.min(be,pe))}),be<1/0&&be>=0&&(K=ee.substring(0,be+1))}(),this.state.top&&(O=this.tokenizer.paragraph(K))){W=ae[ae.length-1],Y&&W.type==="paragraph"?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):ae.push(O),Y=K.length!==ee.length,ee=ee.substring(O.raw.length);continue}if(O=this.tokenizer.text(ee)){ee=ee.substring(O.raw.length),W=ae[ae.length-1],W&&W.type==="text"?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):ae.push(O);continue}if(ee){var de="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,ae},le.inline=function(ee,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:ee,tokens:ae}),ae},le.inlineTokens=function(ee,ae){var ie=this;ae===void 0&&(ae=[]);var O,W,K,Y=ee,de,be,Pe;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)pe.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,de.index)+"["+B("a",de[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,de.index)+"["+B("a",de[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,de.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(be||(Pe=""),be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(O=ke.call({lexer:ie},ee,ae))?(ee=ee.substring(O.raw.length),ae.push(O),!0):!1}))){if(O=this.tokenizer.escape(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.tag(ee)){ee=ee.substring(O.raw.length),W=ae[ae.length-1],W&&O.type==="text"&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):ae.push(O);continue}if(O=this.tokenizer.link(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(O.raw.length),W=ae[ae.length-1],W&&O.type==="text"&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):ae.push(O);continue}if(O=this.tokenizer.emStrong(ee,Y,Pe)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.codespan(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.br(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.del(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.autolink(ee,U)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(ee,U))){ee=ee.substring(O.raw.length),ae.push(O);continue}if(K=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=ee.slice(1),Ge=void 0;ie.options.extensions.startInline.forEach(function(et){Ge=et.call({lexer:this},je),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(K=ee.substring(0,ke+1))}(),O=this.tokenizer.inlineText(K,z)){ee=ee.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Pe=O.raw.slice(-1)),be=!0,W=ae[ae.length-1],W&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):ae.push(O);continue}if(ee){var De="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return ae},c(se,null,[{key:"rules",get:function(){return{block:M,inline:F}}}]),se}(),x=function(){function se(ue){this.options=ue||ne.defaults}var le=se.prototype;return le.code=function(ee,ae,ie){var O=(ae||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(ee,O);W!=null&&W!==ee&&(ie=!0,ee=W)}return ee=ee.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+E(O,!0)+'">'+(ie?ee:E(ee,!0))+`</code></pre>
`:"<pre><code>"+(ie?ee:E(ee,!0))+`</code></pre>
`},le.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},le.html=function(ee){return ee},le.heading=function(ee,ae,ie,O){if(this.options.headerIds){var W=this.options.headerPrefix+O.slug(ie);return"<h"+ae+' id="'+W+'">'+ee+"</h"+ae+`>
`}return"<h"+ae+">"+ee+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(ee,ae,ie){var O=ae?"ol":"ul",W=ae&&ie!==1?' start="'+ie+'"':"";return"<"+O+W+`>
`+ee+"</"+O+`>
`},le.listitem=function(ee){return"<li>"+ee+`</li>
`},le.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(ee){return"<p>"+ee+`</p>
`},le.table=function(ee,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ae+`</table>
`},le.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},le.tablecell=function(ee,ae){var ie=ae.header?"th":"td",O=ae.align?"<"+ie+' align="'+ae.align+'">':"<"+ie+">";return O+ee+("</"+ie+`>
`)},le.strong=function(ee){return"<strong>"+ee+"</strong>"},le.em=function(ee){return"<em>"+ee+"</em>"},le.codespan=function(ee){return"<code>"+ee+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(ee){return"<del>"+ee+"</del>"},le.link=function(ee,ae,ie){if(ee=w(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var O='<a href="'+E(ee)+'"';return ae&&(O+=' title="'+ae+'"'),O+=">"+ie+"</a>",O},le.image=function(ee,ae,ie){if(ee=w(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var O='<img src="'+ee+'" alt="'+ie+'"';return ae&&(O+=' title="'+ae+'"'),O+=this.options.xhtml?"/>":">",O},le.text=function(ee){return ee},se}(),V=function(){function se(){}var le=se.prototype;return le.strong=function(ee){return ee},le.em=function(ee){return ee},le.codespan=function(ee){return ee},le.del=function(ee){return ee},le.html=function(ee){return ee},le.text=function(ee){return ee},le.link=function(ee,ae,ie){return""+ie},le.image=function(ee,ae,ie){return""+ie},le.br=function(){return""},se}(),_=function(){function se(){this.seen={}}var le=se.prototype;return le.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(ee,ae){var ie=ee,O=0;if(this.seen.hasOwnProperty(ie)){O=this.seen[ee];do O++,ie=ee+"-"+O;while(this.seen.hasOwnProperty(ie))}return ae||(this.seen[ee]=O,this.seen[ie]=0),ie},le.slug=function(ee,ae){ae===void 0&&(ae={});var ie=this.serialize(ee);return this.getNextSafeSlug(ie,ae.dryrun)},se}(),Q=function(){function se(ue){this.options=ue||ne.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new _}se.parse=function(ee,ae){var ie=new se(ae);return ie.parse(ee)},se.parseInline=function(ee,ae){var ie=new se(ae);return ie.parseInline(ee)};var le=se.prototype;return le.parse=function(ee,ae){ae===void 0&&(ae=!0);var ie="",O,W,K,Y,de,be,Pe,pe,De,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe=ee.length;for(O=0;O<oe;O++){if(ke=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(it=this.options.extensions.renderers[ke.type].call({parser:this},ke),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ie+=it||"";continue}switch(ke.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,m(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(pe="",Pe="",Y=ke.header.length,W=0;W<Y;W++)Pe+=this.renderer.tablecell(this.parseInline(ke.header[W].tokens),{header:!0,align:ke.align[W]});for(pe+=this.renderer.tablerow(Pe),De="",Y=ke.rows.length,W=0;W<Y;W++){for(be=ke.rows[W],Pe="",de=be.length,K=0;K<de;K++)Pe+=this.renderer.tablecell(this.parseInline(be[K].tokens),{header:!1,align:ke.align[K]});De+=this.renderer.tablerow(Pe)}ie+=this.renderer.table(pe,De);continue}case"blockquote":{De=this.parse(ke.tokens),ie+=this.renderer.blockquote(De);continue}case"list":{for(je=ke.ordered,Ge=ke.start,et=ke.loose,Y=ke.items.length,De="",W=0;W<Y;W++)nt=ke.items[W],st=nt.checked,ht=nt.task,_e="",nt.task&&(Me=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Me+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Me+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Me}):_e+=Me),_e+=this.parse(nt.tokens,et),De+=this.renderer.listitem(_e,ht,st);ie+=this.renderer.list(De,je,Ge);continue}case"html":{ie+=this.renderer.html(ke.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(De=ke.tokens?this.parseInline(ke.tokens):ke.text;O+1<oe&&ee[O+1].type==="text";)ke=ee[++O],De+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ie+=ae?this.renderer.paragraph(De):De;continue}default:{var $='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}}return ie},le.parseInline=function(ee,ae){ae=ae||this.renderer;var ie="",O,W,K,Y=ee.length;for(O=0;O<Y;O++){if(W=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(K=this.options.extensions.renderers[W.type].call({parser:this},W),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){ie+=K||"";continue}switch(W.type){case"escape":{ie+=ae.text(W.text);break}case"html":{ie+=ae.html(W.text);break}case"link":{ie+=ae.link(W.href,W.title,this.parseInline(W.tokens,ae));break}case"image":{ie+=ae.image(W.href,W.title,W.text);break}case"strong":{ie+=ae.strong(this.parseInline(W.tokens,ae));break}case"em":{ie+=ae.em(this.parseInline(W.tokens,ae));break}case"codespan":{ie+=ae.codespan(W.text);break}case"br":{ie+=ae.br();break}case"del":{ie+=ae.del(this.parseInline(W.tokens,ae));break}case"text":{ie+=ae.text(W.text);break}default:{var de='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return ie},se}();function Z(se,le,ue){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof le=="function"&&(ue=le,le=null),le=n({},Z.defaults,le||{}),R(le),ue){var ee=le.highlight,ae;try{ae=H.lex(se,le)}catch(Y){return ue(Y)}var ie=function(de){var be;if(!de)try{le.walkTokens&&Z.walkTokens(ae,le.walkTokens),be=Q.parse(ae,le)}catch(Pe){de=Pe}return le.highlight=ee,de?ue(de):ue(null,be)};if(!ee||ee.length<3||(delete le.highlight,!ae.length))return ie();var O=0;Z.walkTokens(ae,function(Y){Y.type==="code"&&(O++,setTimeout(function(){ee(Y.text,Y.lang,function(de,be){if(de)return ie(de);be!=null&&be!==Y.text&&(Y.text=be,Y.escaped=!0),O--,O===0&&ie()})},0))}),O===0&&ie();return}function W(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(Y.message+"",!0)+"</pre>";throw Y}try{var K=H.lex(se,le);if(le.walkTokens){if(le.async)return Promise.all(Z.walkTokens(K,le.walkTokens)).then(function(){return Q.parse(K,le)}).catch(W);Z.walkTokens(K,le.walkTokens)}return Q.parse(K,le)}catch(Y){W(Y)}}Z.options=Z.setOptions=function(se){return n(Z.defaults,se),T(Z.defaults),Z},Z.getDefaults=C,Z.defaults=ne.defaults,Z.use=function(){for(var se=arguments.length,le=new Array(se),ue=0;ue<se;ue++)le[ue]=arguments[ue];var ee=n.apply(void 0,[{}].concat(le)),ae=Z.defaults.extensions||{renderers:{},childTokens:{}},ie;le.forEach(function(O){if(O.extensions&&(ie=!0,O.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var Y=ae.renderers?ae.renderers[K.name]:null;Y?ae.renderers[K.name]=function(){for(var de=arguments.length,be=new Array(de),Pe=0;Pe<de;Pe++)be[Pe]=arguments[Pe];var pe=K.renderer.apply(this,be);return pe===!1&&(pe=Y.apply(this,be)),pe}:ae.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[K.level]?ae[K.level].unshift(K.tokenizer):ae[K.level]=[K.tokenizer],K.start&&(K.level==="block"?ae.startBlock?ae.startBlock.push(K.start):ae.startBlock=[K.start]:K.level==="inline"&&(ae.startInline?ae.startInline.push(K.start):ae.startInline=[K.start]))}K.childTokens&&(ae.childTokens[K.name]=K.childTokens)})),O.renderer&&function(){var K=Z.defaults.renderer||new x,Y=function(Pe){var pe=K[Pe];K[Pe]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=O.renderer[Pe].apply(K,ke);return Ge===!1&&(Ge=pe.apply(K,ke)),Ge}};for(var de in O.renderer)Y(de);ee.renderer=K}(),O.tokenizer&&function(){var K=Z.defaults.tokenizer||new N,Y=function(Pe){var pe=K[Pe];K[Pe]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=O.tokenizer[Pe].apply(K,ke);return Ge===!1&&(Ge=pe.apply(K,ke)),Ge}};for(var de in O.tokenizer)Y(de);ee.tokenizer=K}(),O.walkTokens){var W=Z.defaults.walkTokens;ee.walkTokens=function(K){var Y=[];return Y.push(O.walkTokens.call(this,K)),W&&(Y=Y.concat(W.call(this,K))),Y}}ie&&(ee.extensions=ae),Z.setOptions(ee)})},Z.walkTokens=function(se,le){for(var ue=[],ee=function(){var W=ie.value;switch(ue=ue.concat(le.call(Z,W)),W.type){case"table":{for(var K=A(W.header),Y;!(Y=K()).done;){var de=Y.value;ue=ue.concat(Z.walkTokens(de.tokens,le))}for(var be=A(W.rows),Pe;!(Pe=be()).done;)for(var pe=Pe.value,De=A(pe),ke;!(ke=De()).done;){var je=ke.value;ue=ue.concat(Z.walkTokens(je.tokens,le))}break}case"list":{ue=ue.concat(Z.walkTokens(W.items,le));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[W.type]?Z.defaults.extensions.childTokens[W.type].forEach(function(Ge){ue=ue.concat(Z.walkTokens(W[Ge],le))}):W.tokens&&(ue=ue.concat(Z.walkTokens(W.tokens,le)))}},ae=A(se),ie;!(ie=ae()).done;)ee();return ue},Z.parseInline=function(se,le){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");le=n({},Z.defaults,le||{}),R(le);try{var ue=H.lexInline(se,le);return le.walkTokens&&Z.walkTokens(ue,le.walkTokens),Q.parseInline(ue,le)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(ee.message+"",!0)+"</pre>";throw ee}},Z.Parser=Q,Z.parser=Q.parse,Z.Renderer=x,Z.TextRenderer=V,Z.Lexer=H,Z.lexer=H.lex,Z.Tokenizer=N,Z.Slugger=_,Z.parse=Z;var ge=Z.options,te=Z.setOptions,J=Z.use,fe=Z.walkTokens,ve=Z.parseInline,Ee=Z,Ae=Q.parse,Fe=H.lex;ne.Lexer=H,ne.Parser=Q,ne.Renderer=x,ne.Slugger=_,ne.TextRenderer=V,ne.Tokenizer=N,ne.getDefaults=C,ne.lexer=Fe,ne.marked=Z,ne.options=ge,ne.parse=Ee,ne.parseInline=ve,ne.parser=Ae,ne.setOptions=te,ne.use=J,ne.walkTokens=fe,Object.defineProperty(ne,"__esModule",{value:!0})}),define(ye[83],Ce([1,0,28]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new c.LRUCache(1e4);function k(y){return S(y,"NFC",t)}e.normalizeNFC=k;const A=new c.LRUCache(1e4);function C(y){return S(y,"NFD",A)}e.normalizeNFD=C;const T=/[^\u0000-\u0080]/;function S(y,L,P){if(!y)return y;const v=P.get(y);if(v)return v;let D;return T.test(y)?D=y.normalize(L):D=y,P.set(y,D),D}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(L){return C(L).replace(y,"")}}()}),define(ye[101],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(T,S,y){return Math.min(Math.max(T,S),y)}e.clamp=c;function t(T,S){return(S+T%S)%S}e.rot=t;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class A{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const y=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ne(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function C(S){A.push(S,Date.now())}function T(){const S=[];for(let y=0;y<A.length;y+=2)S.push({name:A[y],startTime:A[y+1]});return S}return{mark:C,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const C of performance.getEntriesByType("mark"))A.push({name:C.name,startTime:Math.round(k+C.startTime)});return A}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function c(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=c(t))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var t in c)(typeof exports=="object"?exports:ne)[t]=c[t]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function c(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return ne[t].call(k.exports,k,k.exports,c),k.l=!0,k.exports}return c.m=ne,c.c=e,c.d=function(t,k,A){c.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:A})},c.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},c.t=function(t,k){if(1&k&&(t=c(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var A=Object.create(null);if(c.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var C in t)c.d(A,C,function(T){return t[T]}.bind(null,C));return A},c.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return c.d(k,"a",k),k},c.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},c.p="",c(c.s=0)}([function(ne,e,c){(function(t){var k;e=ne.exports=J,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],S=e.src=[],y=0,L=y++;S[L]="0|[1-9]\\d*";var P=y++;S[P]="[0-9]+";var v=y++;S[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=y++;S[D]="("+S[L]+")\\.("+S[L]+")\\.("+S[L]+")";var E=y++;S[E]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var d=y++;S[d]="(?:"+S[L]+"|"+S[v]+")";var m=y++;S[m]="(?:"+S[P]+"|"+S[v]+")";var h=y++;S[h]="(?:-("+S[d]+"(?:\\."+S[d]+")*))";var b=y++;S[b]="(?:-?("+S[m]+"(?:\\."+S[m]+")*))";var p=y++;S[p]="[0-9A-Za-z-]+";var g=y++;S[g]="(?:\\+("+S[p]+"(?:\\."+S[p]+")*))";var w=y++,i="v?"+S[D]+S[h]+"?"+S[g]+"?";S[w]="^"+i+"$";var o="[v=\\s]*"+S[E]+S[b]+"?"+S[g]+"?",u=y++;S[u]="^"+o+"$";var l=y++;S[l]="((?:<|>)?=?)";var s=y++;S[s]=S[P]+"|x|X|\\*";var a=y++;S[a]=S[L]+"|x|X|\\*";var n=y++;S[n]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[h]+")?"+S[g]+"?)?)?";var r=y++;S[r]="[v=\\s]*("+S[s]+")(?:\\.("+S[s]+")(?:\\.("+S[s]+")(?:"+S[b]+")?"+S[g]+"?)?)?";var f=y++;S[f]="^"+S[l]+"\\s*"+S[n]+"$";var I=y++;S[I]="^"+S[l]+"\\s*"+S[r]+"$";var R=y++;S[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=y++;S[B]="(?:~>?)";var X=y++;S[X]="(\\s*)"+S[B]+"\\s+",T[X]=new RegExp(S[X],"g");var q=y++;S[q]="^"+S[B]+S[n]+"$";var N=y++;S[N]="^"+S[B]+S[r]+"$";var M=y++;S[M]="(?:\\^)";var F=y++;S[F]="(\\s*)"+S[M]+"\\s+",T[F]=new RegExp(S[F],"g");var z=y++;S[z]="^"+S[M]+S[n]+"$";var U=y++;S[U]="^"+S[M]+S[r]+"$";var H=y++;S[H]="^"+S[l]+"\\s*("+o+")$|^$";var x=y++;S[x]="^"+S[l]+"\\s*("+i+")$|^$";var V=y++;S[V]="(\\s*)"+S[l]+"\\s*("+o+"|"+S[n]+")",T[V]=new RegExp(S[V],"g");var _=y++;S[_]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var Q=y++;S[Q]="^\\s*("+S[r]+")\\s+-\\s+("+S[r]+")\\s*$";var Z=y++;S[Z]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)k(ge,S[ge]),T[ge]||(T[ge]=new RegExp(S[ge]));function te(pe,De){if(pe instanceof J)return pe;if(typeof pe!="string"||pe.length>A||!(De?T[u]:T[w]).test(pe))return null;try{return new J(pe,De)}catch{return null}}function J(pe,De){if(pe instanceof J){if(pe.loose===De)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof J))return new J(pe,De);k("SemVer",pe,De),this.loose=De;var ke=pe.trim().match(De?T[u]:T[w]);if(!ke)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Ge=+je;if(Ge>=0&&Ge<C)return Ge}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=te,e.valid=function(pe,De){var ke=te(pe,De);return ke?ke.version:null},e.clean=function(pe,De){var ke=te(pe.trim().replace(/^[=v]+/,""),De);return ke?ke.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(pe){return k("SemVer.compare",this.version,this.loose,pe),pe instanceof J||(pe=new J(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},J.prototype.compareMain=function(pe){return pe instanceof J||(pe=new J(pe,this.loose)),ve(this.major,pe.major)||ve(this.minor,pe.minor)||ve(this.patch,pe.patch)},J.prototype.comparePre=function(pe){if(pe instanceof J||(pe=new J(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var De=0;do{var ke=this.prerelease[De],je=pe.prerelease[De];if(k("prerelease compare",De,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return ve(ke,je)}while(++De)},J.prototype.inc=function(pe,De){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,De,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new J(pe,ke).inc(De,je).version}catch{return null}},e.diff=function(pe,De){if(se(pe,De))return null;var ke=te(pe),je=te(De);if(ke.prerelease.length||je.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return Ge},e.compareIdentifiers=ve;var fe=/^[0-9]+$/;function ve(pe,De){var ke=fe.test(pe),je=fe.test(De);return ke&&je&&(pe=+pe,De=+De),ke&&!je?-1:je&&!ke?1:pe<De?-1:pe>De?1:0}function Ee(pe,De,ke){return new J(pe,ke).compare(new J(De,ke))}function Ae(pe,De,ke){return Ee(pe,De,ke)>0}function Fe(pe,De,ke){return Ee(pe,De,ke)<0}function se(pe,De,ke){return Ee(pe,De,ke)===0}function le(pe,De,ke){return Ee(pe,De,ke)!==0}function ue(pe,De,ke){return Ee(pe,De,ke)>=0}function ee(pe,De,ke){return Ee(pe,De,ke)<=0}function ae(pe,De,ke,je){var Ge;switch(De){case"===":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe===ke;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe!==ke;break;case"":case"=":case"==":Ge=se(pe,ke,je);break;case"!=":Ge=le(pe,ke,je);break;case">":Ge=Ae(pe,ke,je);break;case">=":Ge=ue(pe,ke,je);break;case"<":Ge=Fe(pe,ke,je);break;case"<=":Ge=ee(pe,ke,je);break;default:throw new TypeError("Invalid operator: "+De)}return Ge}function ie(pe,De){if(pe instanceof ie){if(pe.loose===De)return pe;pe=pe.value}if(!(this instanceof ie))return new ie(pe,De);k("comparator",pe,De),this.loose=De,this.parse(pe),this.semver===O?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(pe,De){return ve(De,pe)},e.major=function(pe,De){return new J(pe,De).major},e.minor=function(pe,De){return new J(pe,De).minor},e.patch=function(pe,De){return new J(pe,De).patch},e.compare=Ee,e.compareLoose=function(pe,De){return Ee(pe,De,!0)},e.rcompare=function(pe,De,ke){return Ee(De,pe,ke)},e.sort=function(pe,De){return pe.sort(function(ke,je){return e.compare(ke,je,De)})},e.rsort=function(pe,De){return pe.sort(function(ke,je){return e.rcompare(ke,je,De)})},e.gt=Ae,e.lt=Fe,e.eq=se,e.neq=le,e.gte=ue,e.lte=ee,e.cmp=ae,e.Comparator=ie;var O={};function W(pe,De){if(pe instanceof W)return pe.loose===De?pe:new W(pe.raw,De);if(pe instanceof ie)return new W(pe.value,De);if(!(this instanceof W))return new W(pe,De);if(this.loose=De,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function K(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function Y(pe,De,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe){return((De=K(ke)?"":K(je)?">="+ke+".0.0":K(Ge)?">="+ke+"."+je+".0":">="+De)+" "+(nt=K(st)?"":K(ht)?"<"+(+st+1)+".0.0":K(Me)?"<"+st+"."+(+ht+1)+".0":it?"<="+st+"."+ht+"."+Me+"-"+it:"<="+nt)).trim()}function de(pe,De){for(var ke=0;ke<pe.length;ke++)if(!pe[ke].test(De))return!1;if(De.prerelease.length){for(ke=0;ke<pe.length;ke++)if(k(pe[ke].semver),pe[ke].semver!==O&&pe[ke].semver.prerelease.length>0){var je=pe[ke].semver;if(je.major===De.major&&je.minor===De.minor&&je.patch===De.patch)return!0}return!1}return!0}function be(pe,De,ke){try{De=new W(De,ke)}catch{return!1}return De.test(pe)}function Pe(pe,De,ke,je){var Ge,et,_e,nt,st;switch(pe=new J(pe,je),De=new W(De,je),ke){case">":Ge=Ae,et=ee,_e=Fe,nt=">",st=">=";break;case"<":Ge=Fe,et=ue,_e=Ae,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(pe,De,je))return!1;for(var ht=0;ht<De.set.length;++ht){var Me=De.set[ht],it=null,oe=null;if(Me.forEach(function($){$.semver===O&&($=new ie(">=0.0.0")),it=it||$,oe=oe||$,Ge($.semver,it.semver,je)?it=$:_e($.semver,oe.semver,je)&&(oe=$)}),it.operator===nt||it.operator===st||(!oe.operator||oe.operator===nt)&&et(pe,oe.semver)||oe.operator===st&&_e(pe,oe.semver))return!1}return!0}ie.prototype.parse=function(pe){var De=this.loose?T[H]:T[x],ke=pe.match(De);if(!ke)throw new TypeError("Invalid comparator: "+pe);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new J(ke[2],this.loose):this.semver=O},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(pe){return k("Comparator.test",pe,this.loose),this.semver===O||(typeof pe=="string"&&(pe=new J(pe,this.loose)),ae(pe,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(pe,De){if(!(pe instanceof ie))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new W(pe.value,De),be(this.value,ke,De);if(pe.operator==="")return ke=new W(this.value,De),be(pe.semver,ke,De);var je=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),et=this.semver.version===pe.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),nt=ae(this.semver,"<",pe.semver,De)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),st=ae(this.semver,">",pe.semver,De)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return je||Ge||et&&_e||nt||st},e.Range=W,W.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},W.prototype.toString=function(){return this.range},W.prototype.parseRange=function(pe){var De=this.loose;pe=pe.trim(),k("range",pe,De);var ke=De?T[Q]:T[_];pe=pe.replace(ke,Y),k("hyphen replace",pe),pe=pe.replace(T[V],"$1$2$3"),k("comparator trim",pe,T[V]),pe=(pe=(pe=pe.replace(T[X],"$1~")).replace(T[F],"$1^")).split(/\s+/).join(" ");var je=De?T[H]:T[x],Ge=pe.split(" ").map(function(et){return function(_e,nt){return k("comp",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,oe){k("caret",it,oe);var $=oe?T[U]:T[z];return it.replace($,function(ce,Ie,Le,Be,xe){var Ze;return k("caret",it,ce,Ie,Le,Be,xe),K(Ie)?Ze="":K(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":K(Be)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":xe?(k("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+xe+" <"+(+Ie+1)+".0.0"):(k("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+" <"+(+Ie+1)+".0.0"),k("caret return",Ze),Ze})}(Me,ht)}).join(" ")}(_e,nt),k("caret",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,oe){var $=oe?T[N]:T[q];return it.replace($,function(ce,Ie,Le,Be,xe){var Ze;return k("tilde",it,ce,Ie,Le,Be,xe),K(Ie)?Ze="":K(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":K(Be)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":xe?(k("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0",k("tilde return",Ze),Ze})}(Me,ht)}).join(" ")}(_e,nt),k("tildes",_e),_e=function(st,ht){return k("replaceXRanges",st,ht),st.split(/\s+/).map(function(Me){return function(it,oe){it=it.trim();var $=oe?T[I]:T[f];return it.replace($,function(ce,Ie,Le,Be,xe,Ze){k("xRange",it,ce,Ie,Le,Be,xe,Ze);var gt=K(Le),mt=gt||K(Be),lt=mt||K(xe);return Ie==="="&&lt&&(Ie=""),gt?ce=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&lt?(mt&&(Be=0),lt&&(xe=0),Ie===">"?(Ie=">=",mt?(Le=+Le+1,Be=0,xe=0):lt&&(Be=+Be+1,xe=0)):Ie==="<="&&(Ie="<",mt?Le=+Le+1:Be=+Be+1),ce=Ie+Le+"."+Be+"."+xe):mt?ce=">="+Le+".0.0 <"+(+Le+1)+".0.0":lt&&(ce=">="+Le+"."+Be+".0 <"+Le+"."+(+Be+1)+".0"),k("xRange return",ce),ce})}(Me,ht)}).join(" ")}(_e,nt),k("xrange",_e),_e=function(st,ht){return k("replaceStars",st,ht),st.trim().replace(T[Z],"")}(_e,nt),k("stars",_e),_e}(et,De)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(et){return!!et.match(je)})),Ge=Ge.map(function(et){return new ie(et,De)})},W.prototype.intersects=function(pe,De){if(!(pe instanceof W))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return pe.set.some(function(Ge){return Ge.every(function(et){return je.intersects(et,De)})})})})},e.toComparators=function(pe,De){return new W(pe,De).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},W.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new J(pe,this.loose));for(var De=0;De<this.set.length;De++)if(de(this.set[De],pe))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new W(De,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==-1||(Ge=new J(je=_e,ke)))}),je},e.minSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new W(De,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==1||(Ge=new J(je=_e,ke)))}),je},e.validRange=function(pe,De){try{return new W(pe,De).range||"*"}catch{return null}},e.ltr=function(pe,De,ke){return Pe(pe,De,"<",ke)},e.gtr=function(pe,De,ke){return Pe(pe,De,">",ke)},e.outside=Pe,e.prerelease=function(pe,De){var ke=te(pe,De);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(pe,De,ke){return pe=new W(pe,ke),De=new W(De,ke),pe.intersects(De)},e.coerce=function(pe){if(pe instanceof J)return pe;if(typeof pe!="string")return null;var De=pe.match(T[R]);return De==null?null:te((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,c(1))},function(ne,e){var c,t,k=ne.exports={};function A(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function T(m){if(c===setTimeout)return setTimeout(m,0);if((c===A||!c)&&setTimeout)return c=setTimeout,setTimeout(m,0);try{return c(m,0)}catch{try{return c.call(null,m,0)}catch{return c.call(this,m,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:A}catch{c=A}try{t=typeof clearTimeout=="function"?clearTimeout:C}catch{t=C}})();var S,y=[],L=!1,P=-1;function v(){L&&S&&(L=!1,S.length?y=S.concat(y):P=-1,y.length&&D())}function D(){if(!L){var m=T(v);L=!0;for(var h=y.length;h;){for(S=y,y=[];++P<h;)S&&S[P].run();P=-1,h=y.length}S=null,L=!1,function(b){if(t===clearTimeout)return clearTimeout(b);if((t===C||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(b);try{t(b)}catch{try{return t.call(null,b)}catch{return t.call(this,b)}}}(m)}}function E(m,h){this.fun=m,this.array=h}function d(){}k.nextTick=function(m){var h=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)h[b-1]=arguments[b];y.push(new E(m,h)),y.length!==1||L||T(D)},E.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=d,k.addListener=d,k.once=d,k.off=d,k.removeListener=d,k.removeAllListeners=d,k.emit=d,k.prependListener=d,k.prependOnceListener=d,k.listeners=function(m){return[]},k.binding=function(m){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(m){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ye[102],Ce([1,0,10,6]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(g){const w=g;return w?typeof w.read=="function":!1}e.isReadable=k;function A(g){const w=g;return w?[w.on,w.pause,w.resume,w.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=A;function C(g){const w=g;return w?A(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=C;function T(g,w){return new S(g,w)}e.newWriteableStream=T;class S{constructor(w,i){this.e=w,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(i=>i(w))}h(w){this.c.error.length===0?(0,c.onUnexpectedError)(w):this.c.error.slice(0).forEach(i=>i(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,i){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(w,i){if(this.a.destroyed)return;let o;switch(w){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const u=o.indexOf(i);u>=0&&o.splice(u,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(g,w){const i=[];let o;for(;(o=g.read())!==null;)i.push(o);return w(i)}e.consumeReadable=y;function L(g,w,i){const o=[];let u;for(;(u=g.read())!==null&&o.length<i;)o.push(u);return u===null&&o.length>0?w(o):{read:()=>{if(o.length>0)return o.shift();if(typeof u<"u"){const l=u;return u=void 0,l}return g.read()}}}e.peekReadable=L;function P(g,w){return new Promise((i,o)=>{const u=[];v(g,{onData:l=>{w&&u.push(l)},onError:l=>{w?o(l):i(void 0)},onEnd:()=>{i(w?w(u):void 0)}})})}e.consumeStream=P;function v(g,w){let i=!1;return g.on("error",o=>{i||w.onError(o)}),g.on("end",()=>{i||w.onEnd()}),g.on("data",o=>{i||w.onData(o)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=v;function D(g,w){return new Promise((i,o)=>{const u=new t.DisposableStore,l=[],s=r=>{if(l.push(r),l.length>w)return u.dispose(),g.pause(),i({stream:g,buffer:l,ended:!1})},a=r=>o(r),n=()=>i({stream:g,buffer:l,ended:!0});u.add((0,t.toDisposable)(()=>g.removeListener("error",a))),g.on("error",a),u.add((0,t.toDisposable)(()=>g.removeListener("end",n))),g.on("end",n),u.add((0,t.toDisposable)(()=>g.removeListener("data",s))),g.on("data",s)})}e.peekStream=D;function E(g,w){const i=T(w);return i.end(g),i}e.toStream=E;function d(){const g=T(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=d;function m(g){let w=!1;return{read:()=>w?null:(w=!0,g)}}e.toReadable=m;function h(g,w,i){const o=T(i);return v(g,{onData:u=>o.write(w.data(u)),onError:u=>o.error(w.error?w.error(u):u),onEnd:()=>o.end()}),o}e.transform=h;function b(g,w,i){let o=!1;return{read:()=>{const u=w.read();return o?u:(o=!0,u!==null?i([g,u]):g)}}}e.prefixedReadable=b;function p(g,w,i){let o=!1;const u=T(i);return v(w,{onData:l=>o?u.write(l):(o=!0,u.write(i([g,l]))),onError:l=>u.error(l),onEnd:()=>{o||(o=!0,u.write(g)),u.end()}}),u}e.prefixedStream=p}),define(ye[22],Ce([1,0,102]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,A;class C{static alloc(r){return t?new C(Buffer.allocUnsafe(r)):new C(new Uint8Array(r))}static wrap(r){return t&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new C(r)}static fromString(r,f){return!(f?.dontUseNodeBuffer||!1)&&t?new C(Buffer.from(r)):(k||(k=new TextEncoder),new C(k.encode(r)))}static fromByteArray(r){const f=C.alloc(r.length);for(let I=0,R=r.length;I<R;I++)f.buffer[I]=r[I];return f}static concat(r,f){if(typeof f>"u"){f=0;for(let B=0,X=r.length;B<X;B++)f+=r[B].byteLength}const I=C.alloc(f);let R=0;for(let B=0,X=r.length;B<X;B++){const q=r[B];I.set(q,R),R+=q.byteLength}return I}constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}clone(){const r=C.alloc(this.byteLength);return r.set(this),r}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,f){return new C(this.buffer.subarray(r,f))}set(r,f){if(r instanceof C)this.buffer.set(r.buffer,f);else if(r instanceof Uint8Array)this.buffer.set(r,f);else if(r instanceof ArrayBuffer)this.buffer.set(new Uint8Array(r),f);else if(ArrayBuffer.isView(r))this.buffer.set(new Uint8Array(r.buffer,r.byteOffset,r.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(r){return y(this.buffer,r)}writeUInt32BE(r,f){L(this.buffer,r,f)}readUInt32LE(r){return P(this.buffer,r)}writeUInt32LE(r,f){v(this.buffer,r,f)}readUInt8(r){return D(this.buffer,r)}writeUInt8(r,f){E(this.buffer,r,f)}}e.VSBuffer=C;function T(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=T;function S(n,r,f){n[f+0]=r&255,r=r>>>8,n[f+1]=r&255}e.writeUInt16LE=S;function y(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=y;function L(n,r,f){n[f+3]=r,r=r>>>8,n[f+2]=r,r=r>>>8,n[f+1]=r,r=r>>>8,n[f]=r}e.writeUInt32BE=L;function P(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=P;function v(n,r,f){n[f+0]=r&255,r=r>>>8,n[f+1]=r&255,r=r>>>8,n[f+2]=r&255,r=r>>>8,n[f+3]=r&255}e.writeUInt32LE=v;function D(n,r){return n[r]}e.readUInt8=D;function E(n,r,f){n[f]=r}e.writeUInt8=E;function d(n){return c.consumeReadable(n,r=>C.concat(r))}e.readableToBuffer=d;function m(n){return c.toReadable(n)}e.bufferToReadable=m;function h(n){return c.consumeStream(n,r=>C.concat(r))}e.streamToBuffer=h;async function b(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await h(n.stream)])}e.bufferedStreamToBuffer=b;function p(n){return c.toStream(n,r=>C.concat(r))}e.bufferToStream=p;function g(n){return c.transform(n,{data:r=>typeof r=="string"?C.fromString(r):C.wrap(r)},r=>C.concat(r))}e.streamToBufferReadableStream=g;function w(n){return c.newWriteableStream(r=>C.concat(r),n)}e.newWriteableBufferStream=w;function i(n,r){return c.prefixedReadable(n,r,f=>C.concat(f))}e.prefixedBufferReadable=i;function o(n,r){return c.prefixedStream(n,r,f=>C.concat(f))}e.prefixedBufferStream=o;function u(n){let r=0,f=0,I=0;const R=new Uint8Array(Math.floor(n.length/4*3)),B=q=>{switch(f){case 3:R[I++]=r|q,f=0;break;case 2:R[I++]=r|q>>>2,r=q<<6,f=3;break;case 1:R[I++]=r|q>>>4,r=q<<4,f=2;break;default:r=q<<2,f=1}};for(let q=0;q<n.length;q++){const N=n.charCodeAt(q);if(N>=65&&N<=90)B(N-65);else if(N>=97&&N<=122)B(N-97+26);else if(N>=48&&N<=57)B(N-48+52);else if(N===43||N===45)B(62);else if(N===47||N===95)B(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${n[q]}`)}}const X=I;for(;f>0;)B(0);return C.wrap(R).slice(0,X)}e.decodeBase64=u;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:n},r=!0,f=!1){const I=f?s:l;let R="";const B=n.byteLength%3;let X=0;for(;X<n.byteLength-B;X+=3){const q=n[X+0],N=n[X+1],M=n[X+2];R+=I[q>>>2],R+=I[(q<<4|N>>>4)&63],R+=I[(N<<2|M>>>6)&63],R+=I[M&63]}if(B===1){const q=n[X+0];R+=I[q>>>2],R+=I[q<<4&63],r&&(R+="==")}else if(B===2){const q=n[X+0],N=n[X+1];R+=I[q>>>2],R+=I[(q<<4|N>>>4)&63],R+=I[N<<2&63],r&&(R+="=")}return R}e.encodeBase64=a}),define(ye[11],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(o){return typeof o=="string"}e.isString=c;function t(o){return Array.isArray(o)&&o.every(u=>c(u))}e.isStringArray=t;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function A(o){const u=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof u}e.isTypedArray=A;function C(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=C;function T(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=T;function S(o){return o===!0||o===!1}e.isBoolean=S;function y(o){return typeof o>"u"}e.isUndefined=y;function L(o){return!P(o)}e.isDefined=L;function P(o){return y(o)||o===null}e.isUndefinedOrNull=P;function v(o,u){if(!o)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=v;function D(o){if(P(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=D;function E(...o){const u=[];for(let l=0;l<o.length;l++){const s=o[l];if(P(s))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);u.push(s)}return u}e.assertAllDefined=E;const d=Object.prototype.hasOwnProperty;function m(o){if(!k(o))return!1;for(const u in o)if(d.call(o,u))return!1;return!0}e.isEmptyObject=m;function h(o){return typeof o=="function"}e.isFunction=h;function b(...o){return o.length>0&&o.every(h)}e.areFunctions=b;function p(o,u){const l=Math.min(o.length,u.length);for(let s=0;s<l;s++)g(o[s],u[s])}e.validateConstraints=p;function g(o,u){if(c(u)){if(typeof o!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(h(u)){try{if(o instanceof u)return}catch{}if(!P(o)&&o.constructor===u||u.length===1&&u.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g;function w(o){return o===null?void 0:o}e.withNullAsUndefined=w;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(ye[23],Ce([1,0,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const b=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([p,g])=>{b[p]=g&&typeof g=="object"?t(g):g}),b}e.deepClone=t;function k(h){if(!h||typeof h!="object")return h;const b=[h];for(;b.length>0;){const p=b.shift();Object.freeze(p);for(const g in p)if(A.call(p,g)){const w=p[g];typeof w=="object"&&!Object.isFrozen(w)&&!(0,c.isTypedArray)(w)&&b.push(w)}}return h}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function C(h,b){return T(h,b,new Set)}e.cloneAndChange=C;function T(h,b,p){if((0,c.isUndefinedOrNull)(h))return h;const g=b(h);if(typeof g<"u")return g;if(Array.isArray(h)){const w=[];for(const i of h)w.push(T(i,b,p));return w}if((0,c.isObject)(h)){if(p.has(h))throw new Error("Cannot clone recursive data-structure");p.add(h);const w={};for(const i in h)A.call(h,i)&&(w[i]=T(h[i],b,p));return p.delete(h),w}return h}function S(h,b,p=!0){return(0,c.isObject)(h)?((0,c.isObject)(b)&&Object.keys(b).forEach(g=>{g in h?p&&((0,c.isObject)(h[g])&&(0,c.isObject)(b[g])?S(h[g],b[g],p):h[g]=b[g]):h[g]=b[g]}),h):b}e.mixin=S;function y(h,b){if(h===b)return!0;if(h==null||b===null||b===void 0||typeof h!=typeof b||typeof h!="object"||Array.isArray(h)!==Array.isArray(b))return!1;let p,g;if(Array.isArray(h)){if(h.length!==b.length)return!1;for(p=0;p<h.length;p++)if(!y(h[p],b[p]))return!1}else{const w=[];for(g in h)w.push(g);w.sort();const i=[];for(g in b)i.push(g);if(i.sort(),!y(w,i))return!1;for(p=0;p<w.length;p++)if(!y(h[w[p]],b[w[p]]))return!1}return!0}e.equals=y;function L(h){const b=new Set;return JSON.stringify(h,(p,g)=>{if((0,c.isObject)(g)||Array.isArray(g)){if(b.has(g))return"[Circular]";b.add(g)}return g})}e.safeStringify=L;function P(h,b){const p=Object.create(null);return!h||!b||Object.keys(b).forEach(w=>{const i=h[w],o=b[w];y(i,o)||(p[w]=o)}),p}e.distinct=P;function v(h,b){const p=b.toLowerCase(),g=Object.keys(h).find(w=>w.toLowerCase()===p);return g?h[g]:h[b]}e.getCaseInsensitive=v;function D(h,b){const p=Object.create(null);for(const[g,w]of Object.entries(h))b(g,w)&&(p[g]=w);return p}e.filter=D;function E(h){let b=[],p=Object.getPrototypeOf(h);for(;Object.prototype!==p;)b=b.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return b}e.getAllPropertyNames=E;function d(h){const b=[];for(const p of E(h))typeof h[p]=="function"&&b.push(p);return b}e.getAllMethodNames=d;function m(h,b){const p=w=>function(){const i=Array.prototype.slice.call(arguments,0);return b(w,i)},g={};for(const w of h)g[w]=p(w);return g}e.createProxyObject=m}),define(ye[103],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function t(A){return A<0?0:A>255?255:A|0}e.toUint8=t;function k(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=k}),define(ye[30],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return c.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(T){for(let S=0;S<T.length;S++)T[S]=Math.floor(Math.random()*256);return T};const A=new Uint8Array(16),C=[];for(let T=0;T<256;T++)C.push(T.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,y="";return y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y+="-",y+=C[A[S++]],y+=C[A[S++]],y+="-",y+=C[A[S++]],y+=C[A[S++]],y+="-",y+=C[A[S++]],y+=C[A[S++]],y+="-",y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y}}()}),define(ye[148],Ce([1,0,17,30]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function k(T){return{id:(0,t.generateUuid)(),asString:async()=>T,asFile:()=>{},value:typeof T=="string"?T:void 0}}e.createStringDataTransferItem=k;function A(T,S,y){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:T,uri:S,data:y}),value:void 0}}e.createFileDataTransferItem=A;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,y){const L=this.a.get(S);L?L.push(y):this.a.set(this.b(S),[y])}replace(S,y){this.a.set(this.b(S),[y])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,y]of this.a.entries())for(const L of y)yield[S,L]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[y,L]of this.entries())S(L,y)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:T=>(0,c.distinct)(T.map(S=>S.toString())).join(`\r
`),split:T=>T.split(`\r
`),parse:T=>e.UriList.split(T).filter(S=>!S.startsWith("#"))})}),define(ye[104],Ce([1,0,103]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(T){const S=(0,c.toUint8)(T);this.c=S,this.a=t.d(S),this.b=new Map}static d(T){const S=new Uint8Array(256);return S.fill(T),S}set(T,S){const y=(0,c.toUint8)(S);T>=0&&T<256?this.a[T]=y:this.b.set(T,y)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var k;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(k||(k={}));class A{constructor(){this.a=new t(0)}add(T){this.a.set(T,1)}has(T){return this.a.get(T)===1}clear(){return this.a.clear()}}e.CharacterSet=A}),define(ye[50],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(k,A){this.lineNumber=k,this.column=A}with(k=this.lineNumber,A=this.column){return k===this.lineNumber&&A===this.column?this:new c(k,A)}delta(k=0,A=0){return this.with(this.lineNumber+k,this.column+A)}equals(k){return c.equals(this,k)}static equals(k,A){return!k&&!A?!0:!!k&&!!A&&k.lineNumber===A.lineNumber&&k.column===A.column}isBefore(k){return c.isBefore(this,k)}static isBefore(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<A.column}isBeforeOrEqual(k){return c.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<=A.column}static compare(k,A){const C=k.lineNumber|0,T=A.lineNumber|0;if(C===T){const S=k.column|0,y=A.column|0;return S-y}return C-T}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new c(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=c}),define(ye[35],Ce([1,0,50]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(A,C,T,S){A>T||A===T&&C>S?(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=A,this.endColumn=C):(this.startLineNumber=A,this.startColumn=C,this.endLineNumber=T,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return t.containsPosition(this,A)}static containsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<A.startColumn||C.lineNumber===A.endLineNumber&&C.column>A.endColumn)}static strictContainsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<=A.startColumn||C.lineNumber===A.endLineNumber&&C.column>=A.endColumn)}containsRange(A){return t.containsRange(this,A)}static containsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>A.endColumn)}strictContainsRange(A){return t.strictContainsRange(this,A)}static strictContainsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<=A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>=A.endColumn)}plusRange(A){return t.plusRange(this,A)}static plusRange(A,C){let T,S,y,L;return C.startLineNumber<A.startLineNumber?(T=C.startLineNumber,S=C.startColumn):C.startLineNumber===A.startLineNumber?(T=C.startLineNumber,S=Math.min(C.startColumn,A.startColumn)):(T=A.startLineNumber,S=A.startColumn),C.endLineNumber>A.endLineNumber?(y=C.endLineNumber,L=C.endColumn):C.endLineNumber===A.endLineNumber?(y=C.endLineNumber,L=Math.max(C.endColumn,A.endColumn)):(y=A.endLineNumber,L=A.endColumn),new t(T,S,y,L)}intersectRanges(A){return t.intersectRanges(this,A)}static intersectRanges(A,C){let T=A.startLineNumber,S=A.startColumn,y=A.endLineNumber,L=A.endColumn;const P=C.startLineNumber,v=C.startColumn,D=C.endLineNumber,E=C.endColumn;return T<P?(T=P,S=v):T===P&&(S=Math.max(S,v)),y>D?(y=D,L=E):y===D&&(L=Math.min(L,E)),T>y||T===y&&S>L?null:new t(T,S,y,L)}equalsRange(A){return t.equalsRange(this,A)}static equalsRange(A,C){return!A&&!C?!0:!!A&&!!C&&A.startLineNumber===C.startLineNumber&&A.startColumn===C.startColumn&&A.endLineNumber===C.endLineNumber&&A.endColumn===C.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(A){return new c.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(A){return new c.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,C){return new t(this.startLineNumber,this.startColumn,A,C)}setStartPosition(A,C){return new t(A,C,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(A){return new t(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return t.collapseToEnd(this)}static collapseToEnd(A){return new t(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new t(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,C=A){return new t(A.lineNumber,A.column,C.lineNumber,C.column)}static lift(A){return A?new t(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<A.startColumn)}static areIntersecting(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<=C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,C){if(A&&C){const y=A.startLineNumber|0,L=C.startLineNumber|0;if(y===L){const P=A.startColumn|0,v=C.startColumn|0;if(P===v){const D=A.endLineNumber|0,E=C.endLineNumber|0;if(D===E){const d=A.endColumn|0,m=C.endColumn|0;return d-m}return D-E}return P-v}return y-L}return(A?1:0)-(C?1:0)}static compareRangesUsingEnds(A,C){return A.endLineNumber===C.endLineNumber?A.endColumn===C.endColumn?A.startLineNumber===C.startLineNumber?A.startColumn-C.startColumn:A.startLineNumber-C.startLineNumber:A.endColumn-C.endColumn:A.endLineNumber-C.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=t}),define(ye[149],Ce([1,0,50,35]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class A extends t.Range{constructor(T,S,y,L){super(T,S,y,L),this.selectionStartLineNumber=T,this.selectionStartColumn=S,this.positionLineNumber=y,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return A.selectionsEqual(this,T)}static selectionsEqual(T,S){return T.selectionStartLineNumber===S.selectionStartLineNumber&&T.selectionStartColumn===S.selectionStartColumn&&T.positionLineNumber===S.positionLineNumber&&T.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,T,S):new A(T,S,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,S){return this.getDirection()===0?new A(T,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,T,S)}static fromPositions(T,S=T){return new A(T.lineNumber,T.column,S.lineNumber,S.column)}static fromRange(T,S){return S===0?new A(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new A(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new A(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,S){if(T&&!S||!T&&S)return!1;if(!T&&!S)return!0;if(T.length!==S.length)return!1;for(let y=0,L=T.length;y<L;y++)if(!this.selectionsEqual(T[y],S[y]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,S,y,L,P){return P===0?new A(T,S,y,L):new A(y,L,T,S)}}e.Selection=A}),define(ye[150],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[151],Ce([1,0,104]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends c.CharacterClassifier{constructor(T){super(0);for(let S=0,y=T.length;S<y;S++)this.set(T.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function A(C){const T={};return S=>(T.hasOwnProperty(S)||(T[S]=C(S)),T[S])}e.getMapForWordSeparators=A(C=>new k(C))}),define(ye[105],Ce([1,0,62,6,63]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(P=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)P.indexOf(D)>=0||(v+="\\"+D);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=A();function C(P){let v=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)v=P;else{let D="g";P.ignoreCase&&(D+="i"),P.multiline&&(D+="m"),P.unicode&&(D+="u"),v=new RegExp(P.source,D)}return v.lastIndex=0,v}e.ensureValidWordDefinition=C;const T=new k.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(P){const v=T.unshift(P);return(0,t.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=S;function y(P,v,D,E,d){if(d||(d=c.Iterable.first(T)),D.length>d.maxLen){let g=P-d.maxLen/2;return g<0?g=0:E+=g,D=D.substring(g,P+d.maxLen/2),y(P,v,D,E,d)}const m=Date.now(),h=P-1-E;let b=-1,p=null;for(let g=1;!(Date.now()-m>=d.timeBudget);g++){const w=h-d.windowSize*g;v.lastIndex=Math.max(0,w);const i=L(v,D,h,b);if(!i&&p||(p=i,w<=0))break;b=w}if(p){const g={word:p[0],startColumn:E+1+p.index,endColumn:E+1+p.index+p[0].length};return v.lastIndex=0,g}return null}e.getWordAtText=y;function L(P,v,D,E){let d;for(;d=P.exec(v);){const m=d.index||0;if(m<=D&&P.lastIndex>=D)return d;if(E>0&&m>E)return null}return null}}),define(ye[152],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class t{constructor(T){if(this.e=null,this.f=!1,this.open=T.open,this.close=T.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(T.notIn))for(let S=0,y=T.notIn.length;S<y;S++)switch(T.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const y=T.findTokenIndexAtOffset(S-2),L=T.getStandardTokenType(y);return this.isOK(L)}g(T,S){for(let y=T;y<=S;y++){const L=String.fromCharCode(y);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class k{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=k;function A(C,T,S){C.has(T)?C.get(T).push(S):C.set(T,[S])}}),define(ye[153],Ce([1,0,104]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(D){D[D.Invalid=0]="Invalid",D[D.Start=1]="Start",D[D.H=2]="H",D[D.HT=3]="HT",D[D.HTT=4]="HTT",D[D.HTTP=5]="HTTP",D[D.F=6]="F",D[D.FI=7]="FI",D[D.FIL=8]="FIL",D[D.BeforeColon=9]="BeforeColon",D[D.AfterColon=10]="AfterColon",D[D.AlmostThere=11]="AlmostThere",D[D.End=12]="End",D[D.Accept=13]="Accept",D[D.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class k{constructor(E,d,m){const h=new Uint8Array(E*d);for(let b=0,p=E*d;b<p;b++)h[b]=m;this.a=h,this.rows=E,this.cols=d}get(E,d){return this.a[E*this.cols+d]}set(E,d,m){this.a[E*this.cols+d]=m}}class A{constructor(E){let d=0,m=0;for(let b=0,p=E.length;b<p;b++){const[g,w,i]=E[b];w>d&&(d=w),g>m&&(m=g),i>m&&(m=i)}d++,m++;const h=new k(m,d,0);for(let b=0,p=E.length;b<p;b++){const[g,w,i]=E[b];h.set(g,w,i)}this.a=h,this.b=d}nextState(E,d){return d<0||d>=this.b?0:this.a.get(E,d)}}e.StateMachine=A;let C=null;function T(){return C===null&&(C=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var S;(function(D){D[D.None=0]="None",D[D.ForceTermination=1]="ForceTermination",D[D.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let y=null;function L(){if(y===null){y=new c.CharacterClassifier(0);const D=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<D.length;d++)y.set(D.charCodeAt(d),1);const E=".;:";for(let d=0;d<E.length;d++)y.set(E.charCodeAt(d),2)}return y}class P{static a(E,d,m,h,b){let p=b-1;do{const g=d.charCodeAt(p);if(E.get(g)!==2)break;p--}while(p>h);if(h>0){const g=d.charCodeAt(h-1),w=d.charCodeAt(p);(g===40&&w===41||g===91&&w===93||g===123&&w===125)&&p--}return{range:{startLineNumber:m,startColumn:h+1,endLineNumber:m,endColumn:p+2},url:d.substring(h,p+1)}}static computeLinks(E,d=T()){const m=L(),h=[];for(let b=1,p=E.getLineCount();b<=p;b++){const g=E.getLineContent(b),w=g.length;let i=0,o=0,u=0,l=1,s=!1,a=!1,n=!1,r=!1;for(;i<w;){let f=!1;const I=g.charCodeAt(i);if(l===13){let R;switch(I){case 40:s=!0,R=0;break;case 41:R=s?0:1;break;case 91:n=!0,a=!0,R=0;break;case 93:n=!1,R=a?0:1;break;case 123:r=!0,R=0;break;case 125:R=r?0:1;break;case 39:case 34:case 96:u===I?R=1:u===39||u===34||u===96?R=0:R=1;break;case 42:R=u===42?1:0;break;case 124:R=u===124?1:0;break;case 32:R=n?0:1;break;default:R=m.get(I)}R===1&&(h.push(P.a(m,g,b,o,i)),f=!0)}else if(l===12){let R;I===91?(a=!0,R=0):R=m.get(I),R===1?f=!0:l=13}else l=d.nextState(l,I),l===0&&(f=!0);f&&(l=1,s=!1,a=!1,r=!1,o=i+1,u=I),i++}l===13&&h.push(P.a(m,g,b,o,w))}return h}}e.LinkComputer=P;function v(D){return!D||typeof D.getLineCount!="function"||typeof D.getLineContent!="function"?[]:P.computeLinks(D)}e.computeLinks=v}),define(ye[106],Ce([1,0,23]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(p){p[p.Both=0]="Both",p[p.Right=1]="Right",p[p.Left=2]="Left",p[p.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),g.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,g.indentSize|0),this.a=!1),this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace),this.bracketPairColorizationOptions=g.bracketPairColorizationOptions}equals(g){return this.tabSize===g.tabSize&&this.a===g.a&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,g.bracketPairColorizationOptions)}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class L{constructor(g,w){this._findMatchBrand=void 0,this.range=g,this.matches=w}}e.FindMatch=L;var P;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(p){return p&&typeof p.read=="function"}e.isITextSnapshot=v;var D;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None",p[p.LeftOfInjectedText=3]="LeftOfInjectedText",p[p.RightOfInjectedText=4]="RightOfInjectedText"})(D=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class d{constructor(g,w,i,o,u,l){this.identifier=g,this.range=w,this.text=i,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=u,this._isTracked=l}}e.ValidAnnotatedEditOperation=d;class m{constructor(g,w,i){this.regex=g,this.wordSeparators=w,this.simpleSearch=i}}e.SearchData=m;class h{constructor(g,w,i){this.reverseEdits=g,this.changes=w,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=h;function b(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.shouldSynchronizeModel=b}),define(ye[154],Ce([1,0,17,103]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,y){S=(0,t.toUint32)(S);const L=this.a,P=this.b,v=y.length;return v===0?!1:(this.a=new Uint32Array(L.length+v),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S),S+v),this.a.set(y,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(S,y){return S=(0,t.toUint32)(S),y=(0,t.toUint32)(y),this.a[S]===y?!1:(this.a[S]=y,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,y){S=(0,t.toUint32)(S),y=(0,t.toUint32)(y);const L=this.a,P=this.b;if(S>=L.length)return!1;const v=L.length-S;return y>=v&&(y=v),y===0?!1:(this.a=new Uint32Array(L.length-y),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S+y),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),S>=this.a.length&&(S=this.a.length-1);for(let L=y;L<=S;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let y=0,L=this.a.length-1,P=0,v=0,D=0;for(;y<=L;)if(P=y+(L-y)/2|0,v=this.b[P],D=v-this.a[P],S<D)L=P-1;else if(S>=v)y=P+1;else break;return new C(P,S-D)}}e.PrefixSumComputer=k;class A{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const y=this.e[S],L=y>0?this.d[y-1]:0;return new C(y,S-L)}removeValues(S,y){this.a.splice(S,y),this.f(S)}insertValues(S,y){this.a=(0,c.arrayInsert)(this.a,S,y),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,y=this.a.length;S<y;S++){const L=this.a[S],P=S>0?this.d[S-1]:0;this.d[S]=P+L;for(let v=0;v<L;v++)this.e[P+v]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,y){this.a[S]!==y&&(this.a[S]=y,this.f(S))}}e.ConstantTimePrefixSumComputer=A;class C{constructor(S,y){this.index=S,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=y}}e.PrefixSumIndexOfResult=C}),define(ye[155],Ce([19,20]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ye[156],Ce([1,0,155]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,A=k*24,C=A*7,T=A*30,S=A*365;function y(P,v,D){typeof P!="number"&&(P=P.getTime());const E=Math.round((new Date().getTime()-P)/1e3);if(E<-30)return(0,c.localize)(0,null,y(new Date().getTime()+E*1e3,!1));if(E<30)return(0,c.localize)(1,null);let d;return E<t?(d=E,v?d===1?D?(0,c.localize)(2,null,d):(0,c.localize)(3,null,d):D?(0,c.localize)(4,null,d):(0,c.localize)(5,null,d):d===1?D?(0,c.localize)(6,null,d):(0,c.localize)(7,null,d):D?(0,c.localize)(8,null,d):(0,c.localize)(9,null,d)):E<k?(d=Math.floor(E/t),v?d===1?D?(0,c.localize)(10,null,d):(0,c.localize)(11,null,d):D?(0,c.localize)(12,null,d):(0,c.localize)(13,null,d):d===1?D?(0,c.localize)(14,null,d):(0,c.localize)(15,null,d):D?(0,c.localize)(16,null,d):(0,c.localize)(17,null,d)):E<A?(d=Math.floor(E/k),v?d===1?D?(0,c.localize)(18,null,d):(0,c.localize)(19,null,d):D?(0,c.localize)(20,null,d):(0,c.localize)(21,null,d):d===1?D?(0,c.localize)(22,null,d):(0,c.localize)(23,null,d):D?(0,c.localize)(24,null,d):(0,c.localize)(25,null,d)):E<C?(d=Math.floor(E/A),v?d===1?(0,c.localize)(26,null,d):(0,c.localize)(27,null,d):d===1?(0,c.localize)(28,null,d):(0,c.localize)(29,null,d)):E<T?(d=Math.floor(E/C),v?d===1?D?(0,c.localize)(30,null,d):(0,c.localize)(31,null,d):D?(0,c.localize)(32,null,d):(0,c.localize)(33,null,d):d===1?D?(0,c.localize)(34,null,d):(0,c.localize)(35,null,d):D?(0,c.localize)(36,null,d):(0,c.localize)(37,null,d)):E<S?(d=Math.floor(E/T),v?d===1?D?(0,c.localize)(38,null,d):(0,c.localize)(39,null,d):D?(0,c.localize)(40,null,d):(0,c.localize)(41,null,d):d===1?D?(0,c.localize)(42,null,d):(0,c.localize)(43,null,d):D?(0,c.localize)(44,null,d):(0,c.localize)(45,null,d)):(d=Math.floor(E/S),v?d===1?D?(0,c.localize)(46,null,d):(0,c.localize)(47,null,d):D?(0,c.localize)(48,null,d):(0,c.localize)(49,null,d):d===1?D?(0,c.localize)(50,null,d):(0,c.localize)(51,null,d):D?(0,c.localize)(52,null,d):(0,c.localize)(53,null,d))}e.fromNow=y;function L(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[157],Ce([19,20]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ye[51],Ce([1,0,17,11,157]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(P,v){return v&&(P.stack||P.stacktrace)?k.localize(0,null,T(P),C(P.stack)||C(P.stacktrace)):T(P)}function C(P){return Array.isArray(P)?P.join(`
`):P}function T(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function S(P=null,v=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const D=c.coalesce(P),E=S(D[0],v);return D.length>1?k.localize(4,null,E,D.length):E}if(t.isString(P))return P;if(P.detail){const D=P.detail;if(D.error)return A(D.error,v);if(D.exception)return A(D.exception,v)}return P.stack?A(P,v):P.message?P.message:k.localize(5,null)}e.toErrorMessage=S;function y(P){const v=P;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=y;function L(P,v){let D;return typeof P=="string"?D=new Error(P):D=P,D.actions=v,D}e.createErrorWithActions=L}),define(ye[158],Ce([19,20]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ye[12],Ce([1,0,158]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,A=!1,C=!1,T=!1,S=!1,y=!1,L=!1,P=!1,v=!1,D,E=e.LANGUAGE_DEFAULT,d,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const b=typeof h?.versions?.electron=="string",p=b&&h?.type==="renderer";if(typeof navigator=="object"&&!p)m=navigator.userAgent,t=m.indexOf("Windows")>=0,k=m.indexOf("Macintosh")>=0,L=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=m.indexOf("Linux")>=0,v=m?.indexOf("Mobi")>=0,S=!0,D=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,E=D;else if(typeof h=="object"){t=h.platform==="win32",k=h.platform==="darwin",A=h.platform==="linux",C=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,y=b,P=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,D=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),f=r.availableLanguages["*"];D=r.locale,E=f||e.LANGUAGE_DEFAULT,d=r._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var g;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function w(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let i=0;k?i=1:t?i=3:A&&(i=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=A,e.isLinuxSnap=C,e.isNative=T,e.isElectron=y,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=v,e.isCI=P,e.platform=i,e.userAgent=m,e.language=E;var o;(function(n){function r(){return e.language}n.value=r;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=f;function I(){return e.language==="en"}n.isDefault=I})(o=e.Language||(e.Language={})),e.locale=D,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let I=0,R=n.length;I<R;I++){const B=n[I];if(B.id===f.data.vscodeScheduleAsyncWork){n.splice(I,1),B.callback();return}}});let r=0;return f=>{const I=++r;n.push({id:I,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return n=>setTimeout(n)})();var u;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(u=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||L?2:t?1:3;let l=!0,s=!1;function a(){if(!s){s=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,l=new Uint16Array(n.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[36],Ce([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const k=c.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ye[9],Ce([1,0,36]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,A=90,C=122,T=46,S=47,y=92,L=58,P=63;class v extends Error{constructor(o,u,l){let s;typeof u=="string"&&u.indexOf("not ")===0?(s="must not be",u=u.replace(/^not /,"")):s="must be";const a=o.indexOf(".")!==-1?"property":"argument";let n=`The "${o}" ${a} ${s} of type ${u}`;n+=`. Received type ${typeof l}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function D(i,o){if(i===null||typeof i!="object")throw new v(o,"Object",i)}function E(i,o){if(typeof i!="string")throw new v(o,"string",i)}const d=c.platform==="win32";function m(i){return i===S||i===y}function h(i){return i===S}function b(i){return i>=t&&i<=A||i>=k&&i<=C}function p(i,o,u,l){let s="",a=0,n=-1,r=0,f=0;for(let I=0;I<=i.length;++I){if(I<i.length)f=i.charCodeAt(I);else{if(l(f))break;f=S}if(l(f)){if(!(n===I-1||r===1))if(r===2){if(s.length<2||a!==2||s.charCodeAt(s.length-1)!==T||s.charCodeAt(s.length-2)!==T){if(s.length>2){const R=s.lastIndexOf(u);R===-1?(s="",a=0):(s=s.slice(0,R),a=s.length-1-s.lastIndexOf(u)),n=I,r=0;continue}else if(s.length!==0){s="",a=0,n=I,r=0;continue}}o&&(s+=s.length>0?`${u}..`:"..",a=2)}else s.length>0?s+=`${u}${i.slice(n+1,I)}`:s=i.slice(n+1,I),a=I-n-1;n=I,r=0}else f===T&&r!==-1?++r:r=-1}return s}function g(i,o){D(o,"pathObject");const u=o.dir||o.root,l=o.base||`${o.name||""}${o.ext||""}`;return u?u===o.root?`${u}${l}`:`${u}${i}${l}`:l}e.win32={resolve(...i){let o="",u="",l=!1;for(let s=i.length-1;s>=-1;s--){let a;if(s>=0){if(a=i[s],E(a,"path"),a.length===0)continue}else o.length===0?a=c.cwd():(a=c.env[`=${o}`]||c.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===y)&&(a=`${o}\\`));const n=a.length;let r=0,f="",I=!1;const R=a.charCodeAt(0);if(n===1)m(R)&&(r=1,I=!0);else if(m(R))if(I=!0,m(a.charCodeAt(1))){let B=2,X=B;for(;B<n&&!m(a.charCodeAt(B));)B++;if(B<n&&B!==X){const q=a.slice(X,B);for(X=B;B<n&&m(a.charCodeAt(B));)B++;if(B<n&&B!==X){for(X=B;B<n&&!m(a.charCodeAt(B));)B++;(B===n||B!==X)&&(f=`\\\\${q}\\${a.slice(X,B)}`,r=B)}}}else r=1;else b(R)&&a.charCodeAt(1)===L&&(f=a.slice(0,2),r=2,n>2&&m(a.charCodeAt(2))&&(I=!0,r=3));if(f.length>0)if(o.length>0){if(f.toLowerCase()!==o.toLowerCase())continue}else o=f;if(l){if(o.length>0)break}else if(u=`${a.slice(r)}\\${u}`,l=I,I&&o.length>0)break}return u=p(u,!l,"\\",m),l?`${o}\\${u}`:`${o}${u}`||"."},normalize(i){E(i,"path");const o=i.length;if(o===0)return".";let u=0,l,s=!1;const a=i.charCodeAt(0);if(o===1)return h(a)?"\\":i;if(m(a))if(s=!0,m(i.charCodeAt(1))){let r=2,f=r;for(;r<o&&!m(i.charCodeAt(r));)r++;if(r<o&&r!==f){const I=i.slice(f,r);for(f=r;r<o&&m(i.charCodeAt(r));)r++;if(r<o&&r!==f){for(f=r;r<o&&!m(i.charCodeAt(r));)r++;if(r===o)return`\\\\${I}\\${i.slice(f)}\\`;r!==f&&(l=`\\\\${I}\\${i.slice(f,r)}`,u=r)}}}else u=1;else b(a)&&i.charCodeAt(1)===L&&(l=i.slice(0,2),u=2,o>2&&m(i.charCodeAt(2))&&(s=!0,u=3));let n=u<o?p(i.slice(u),!s,"\\",m):"";return n.length===0&&!s&&(n="."),n.length>0&&m(i.charCodeAt(o-1))&&(n+="\\"),l===void 0?s?`\\${n}`:n:s?`${l}\\${n}`:`${l}${n}`},isAbsolute(i){E(i,"path");const o=i.length;if(o===0)return!1;const u=i.charCodeAt(0);return m(u)||o>2&&b(u)&&i.charCodeAt(1)===L&&m(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,u;for(let a=0;a<i.length;++a){const n=i[a];E(n,"path"),n.length>0&&(o===void 0?o=u=n:o+=`\\${n}`)}if(o===void 0)return".";let l=!0,s=0;if(typeof u=="string"&&m(u.charCodeAt(0))){++s;const a=u.length;a>1&&m(u.charCodeAt(1))&&(++s,a>2&&(m(u.charCodeAt(2))?++s:l=!1))}if(l){for(;s<o.length&&m(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(i,o){if(E(i,"from"),E(o,"to"),i===o)return"";const u=e.win32.resolve(i),l=e.win32.resolve(o);if(u===l||(i=u.toLowerCase(),o=l.toLowerCase(),i===o))return"";let s=0;for(;s<i.length&&i.charCodeAt(s)===y;)s++;let a=i.length;for(;a-1>s&&i.charCodeAt(a-1)===y;)a--;const n=a-s;let r=0;for(;r<o.length&&o.charCodeAt(r)===y;)r++;let f=o.length;for(;f-1>r&&o.charCodeAt(f-1)===y;)f--;const I=f-r,R=n<I?n:I;let B=-1,X=0;for(;X<R;X++){const N=i.charCodeAt(s+X);if(N!==o.charCodeAt(r+X))break;N===y&&(B=X)}if(X!==R){if(B===-1)return l}else{if(I>R){if(o.charCodeAt(r+X)===y)return l.slice(r+X+1);if(X===2)return l.slice(r+X)}n>R&&(i.charCodeAt(s+X)===y?B=X:X===2&&(B=3)),B===-1&&(B=0)}let q="";for(X=s+B+1;X<=a;++X)(X===a||i.charCodeAt(X)===y)&&(q+=q.length===0?"..":"\\..");return r+=B,q.length>0?`${q}${l.slice(r,f)}`:(l.charCodeAt(r)===y&&++r,l.slice(r,f))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===y){if(o.charCodeAt(1)===y){const u=o.charCodeAt(2);if(u!==P&&u!==T)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(b(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===y)return`\\\\?\\${o}`;return i},dirname(i){E(i,"path");const o=i.length;if(o===0)return".";let u=-1,l=0;const s=i.charCodeAt(0);if(o===1)return m(s)?i:".";if(m(s)){if(u=l=1,m(i.charCodeAt(1))){let r=2,f=r;for(;r<o&&!m(i.charCodeAt(r));)r++;if(r<o&&r!==f){for(f=r;r<o&&m(i.charCodeAt(r));)r++;if(r<o&&r!==f){for(f=r;r<o&&!m(i.charCodeAt(r));)r++;if(r===o)return i;r!==f&&(u=l=r+1)}}}}else b(s)&&i.charCodeAt(1)===L&&(u=o>2&&m(i.charCodeAt(2))?3:2,l=u);let a=-1,n=!0;for(let r=o-1;r>=l;--r)if(m(i.charCodeAt(r))){if(!n){a=r;break}}else n=!1;if(a===-1){if(u===-1)return".";a=u}return i.slice(0,a)},basename(i,o){o!==void 0&&E(o,"ext"),E(i,"path");let u=0,l=-1,s=!0,a;if(i.length>=2&&b(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(u=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,r=-1;for(a=i.length-1;a>=u;--a){const f=i.charCodeAt(a);if(m(f)){if(!s){u=a+1;break}}else r===-1&&(s=!1,r=a+1),n>=0&&(f===o.charCodeAt(n)?--n===-1&&(l=a):(n=-1,l=r))}return u===l?l=r:l===-1&&(l=i.length),i.slice(u,l)}for(a=i.length-1;a>=u;--a)if(m(i.charCodeAt(a))){if(!s){u=a+1;break}}else l===-1&&(s=!1,l=a+1);return l===-1?"":i.slice(u,l)},extname(i){E(i,"path");let o=0,u=-1,l=0,s=-1,a=!0,n=0;i.length>=2&&i.charCodeAt(1)===L&&b(i.charCodeAt(0))&&(o=l=2);for(let r=i.length-1;r>=o;--r){const f=i.charCodeAt(r);if(m(f)){if(!a){l=r+1;break}continue}s===-1&&(a=!1,s=r+1),f===T?u===-1?u=r:n!==1&&(n=1):u!==-1&&(n=-1)}return u===-1||s===-1||n===0||n===1&&u===s-1&&u===l+1?"":i.slice(u,s)},format:g.bind(null,"\\"),parse(i){E(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const u=i.length;let l=0,s=i.charCodeAt(0);if(u===1)return m(s)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(m(s)){if(l=1,m(i.charCodeAt(1))){let B=2,X=B;for(;B<u&&!m(i.charCodeAt(B));)B++;if(B<u&&B!==X){for(X=B;B<u&&m(i.charCodeAt(B));)B++;if(B<u&&B!==X){for(X=B;B<u&&!m(i.charCodeAt(B));)B++;B===u?l=B:B!==X&&(l=B+1)}}}}else if(b(s)&&i.charCodeAt(1)===L){if(u<=2)return o.root=o.dir=i,o;if(l=2,m(i.charCodeAt(2))){if(u===3)return o.root=o.dir=i,o;l=3}}l>0&&(o.root=i.slice(0,l));let a=-1,n=l,r=-1,f=!0,I=i.length-1,R=0;for(;I>=l;--I){if(s=i.charCodeAt(I),m(s)){if(!f){n=I+1;break}continue}r===-1&&(f=!1,r=I+1),s===T?a===-1?a=I:R!==1&&(R=1):a!==-1&&(R=-1)}return r!==-1&&(a===-1||R===0||R===1&&a===r-1&&a===n+1?o.base=o.name=i.slice(n,r):(o.name=i.slice(n,a),o.base=i.slice(n,r),o.ext=i.slice(a,r))),n>0&&n!==l?o.dir=i.slice(0,n-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(d){const i=/\\/g;return()=>{const o=c.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...i){let o="",u=!1;for(let l=i.length-1;l>=-1&&!u;l--){const s=l>=0?i[l]:w();E(s,"path"),s.length!==0&&(o=`${s}/${o}`,u=s.charCodeAt(0)===S)}return o=p(o,!u,"/",h),u?`/${o}`:o.length>0?o:"."},normalize(i){if(E(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S,u=i.charCodeAt(i.length-1)===S;return i=p(i,!o,"/",h),i.length===0?o?"/":u?"./":".":(u&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return E(i,"path"),i.length>0&&i.charCodeAt(0)===S},join(...i){if(i.length===0)return".";let o;for(let u=0;u<i.length;++u){const l=i[u];E(l,"path"),l.length>0&&(o===void 0?o=l:o+=`/${l}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(E(i,"from"),E(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const u=1,l=i.length,s=l-u,a=1,n=o.length-a,r=s<n?s:n;let f=-1,I=0;for(;I<r;I++){const B=i.charCodeAt(u+I);if(B!==o.charCodeAt(a+I))break;B===S&&(f=I)}if(I===r)if(n>r){if(o.charCodeAt(a+I)===S)return o.slice(a+I+1);if(I===0)return o.slice(a+I)}else s>r&&(i.charCodeAt(u+I)===S?f=I:I===0&&(f=0));let R="";for(I=u+f+1;I<=l;++I)(I===l||i.charCodeAt(I)===S)&&(R+=R.length===0?"..":"/..");return`${R}${o.slice(a+f)}`},toNamespacedPath(i){return i},dirname(i){if(E(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S;let u=-1,l=!0;for(let s=i.length-1;s>=1;--s)if(i.charCodeAt(s)===S){if(!l){u=s;break}}else l=!1;return u===-1?o?"/":".":o&&u===1?"//":i.slice(0,u)},basename(i,o){o!==void 0&&E(o,"ext"),E(i,"path");let u=0,l=-1,s=!0,a;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,r=-1;for(a=i.length-1;a>=0;--a){const f=i.charCodeAt(a);if(f===S){if(!s){u=a+1;break}}else r===-1&&(s=!1,r=a+1),n>=0&&(f===o.charCodeAt(n)?--n===-1&&(l=a):(n=-1,l=r))}return u===l?l=r:l===-1&&(l=i.length),i.slice(u,l)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===S){if(!s){u=a+1;break}}else l===-1&&(s=!1,l=a+1);return l===-1?"":i.slice(u,l)},extname(i){E(i,"path");let o=-1,u=0,l=-1,s=!0,a=0;for(let n=i.length-1;n>=0;--n){const r=i.charCodeAt(n);if(r===S){if(!s){u=n+1;break}continue}l===-1&&(s=!1,l=n+1),r===T?o===-1?o=n:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||l===-1||a===0||a===1&&o===l-1&&o===u+1?"":i.slice(o,l)},format:g.bind(null,"/"),parse(i){E(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const u=i.charCodeAt(0)===S;let l;u?(o.root="/",l=1):l=0;let s=-1,a=0,n=-1,r=!0,f=i.length-1,I=0;for(;f>=l;--f){const R=i.charCodeAt(f);if(R===S){if(!r){a=f+1;break}continue}n===-1&&(r=!1,n=f+1),R===T?s===-1?s=f:I!==1&&(I=1):s!==-1&&(I=-1)}if(n!==-1){const R=a===0&&u?1:a;s===-1||I===0||I===1&&s===n-1&&s===a+1?o.base=o.name=i.slice(R,n):(o.name=i.slice(R,s),o.base=i.slice(R,n),o.ext=i.slice(s,n))}return a>0?o.dir=i.slice(0,a-1):u&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=d?e.win32.normalize:e.posix.normalize,e.isAbsolute=d?e.win32.isAbsolute:e.posix.isAbsolute,e.join=d?e.win32.join:e.posix.join,e.resolve=d?e.win32.resolve:e.posix.resolve,e.relative=d?e.win32.relative:e.posix.relative,e.dirname=d?e.win32.dirname:e.posix.dirname,e.basename=d?e.win32.basename:e.posix.basename,e.extname=d?e.win32.extname:e.posix.extname,e.format=d?e.win32.format:e.posix.format,e.parse=d?e.win32.parse:e.posix.parse,e.toNamespacedPath=d?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=d?e.win32.sep:e.posix.sep,e.delimiter=d?e.win32.delimiter:e.posix.delimiter}),define(ye[84],Ce([1,0,9]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(L){const P=(0,c.extname)(L),v=t[P.toLowerCase()];return v!==void 0?v:C(L)}e.getMediaOrTextMime=A;function C(L){const P=(0,c.extname)(L);return k[P.toLowerCase()]}e.getMediaMime=C;function T(L){for(const P in k)if(k[P]===L)return P}e.getExtensionForMimeType=T;const S=/^(.+)\/(.+?)(;.+)?$/;function y(L,P){const v=S.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:P?void 0:L}e.normalizeMimeType=y}),define(ye[107],Ce([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(T,...S){const y=S.reduce((v,D)=>(v[D]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(v=>!y[v]).forEach(v=>{for(let D=0;D<L.length;D++)if(v.search(L[D])!==-1){delete T[v];break}})}e.sanitizeProcessEnvironment=A;function C(T){!T||(delete T.DEBUG,c.isMacintosh&&delete T.DYLD_LIBRARY_PATH,c.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(ye[42],Ce([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=c.globals.performance&&typeof c.globals.performance.now=="function";class k{static create(C=!0){return new k(C)}constructor(C){this.a=t&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?c.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ye[4],Ce([1,0,10,61,6,63,42]),function(ne,e,c,t,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,S=!1;var y;(function(a){a.None=()=>k.Disposable.None;function n(Ee){if(S){const{onDidAddListener:Ae}=Ee,Fe=E.create();let se=0;Ee.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Fe.print()),Ae?.()}}}function r(Ee,Ae){return F(Ee,()=>{},0,void 0,void 0,Ae)}a.defer=r;function f(Ee){return(Ae,Fe=null,se)=>{let le=!1,ue;return ue=Ee(ee=>{if(!le)return ue?ue.dispose():le=!0,Ae.call(Fe,ee)},null,se),le&&ue.dispose(),ue}}a.once=f;function I(Ee,Ae,Fe){return M((se,le=null,ue)=>Ee(ee=>se.call(le,Ae(ee)),null,ue),Fe)}a.map=I;function R(Ee,Ae,Fe){return M((se,le=null,ue)=>Ee(ee=>{Ae(ee),se.call(le,ee)},null,ue),Fe)}a.forEach=R;function B(Ee,Ae,Fe){return M((se,le=null,ue)=>Ee(ee=>Ae(ee)&&se.call(le,ee),null,ue),Fe)}a.filter=B;function X(Ee){return Ee}a.signal=X;function q(...Ee){return(Ae,Fe=null,se)=>(0,k.combinedDisposable)(...Ee.map(le=>le(ue=>Ae.call(Fe,ue),null,se)))}a.any=q;function N(Ee,Ae,Fe,se){let le=Fe;return I(Ee,ue=>(le=Ae(le,ue),le),se)}a.reduce=N;function M(Ee,Ae){let Fe;const se={onWillAddFirstListener(){Fe=Ee(le.fire,le)},onDidRemoveLastListener(){Fe?.dispose()}};Ae||n(se);const le=new m(se);return Ae?.add(le),le.event}function F(Ee,Ae,Fe=100,se=!1,le,ue){let ee,ae,ie,O=0;const W={leakWarningThreshold:le,onWillAddFirstListener(){ee=Ee(Y=>{O++,ae=Ae(ae,Y),se&&!ie&&(K.fire(ae),ae=void 0),clearTimeout(ie),ie=setTimeout(()=>{const de=ae;ae=void 0,ie=void 0,(!se||O>1)&&K.fire(de),O=0},Fe)})},onDidRemoveLastListener(){ee.dispose()}};ue||n(W);const K=new m(W);return ue?.add(K),K.event}a.debounce=F;function z(Ee,Ae=0,Fe){return a.debounce(Ee,(se,le)=>se?(se.push(le),se):[le],Ae,void 0,void 0,Fe)}a.accumulate=z;function U(Ee,Ae=(se,le)=>se===le,Fe){let se=!0,le;return B(Ee,ue=>{const ee=se||!Ae(ue,le);return se=!1,le=ue,ee},Fe)}a.latch=U;function H(Ee,Ae,Fe){return[a.filter(Ee,Ae,Fe),a.filter(Ee,se=>!Ae(se),Fe)]}a.split=H;function x(Ee,Ae=!1,Fe=[]){let se=Fe.slice(),le=Ee(ae=>{se?se.push(ae):ee.fire(ae)});const ue=()=>{se?.forEach(ae=>ee.fire(ae)),se=null},ee=new m({onWillAddFirstListener(){le||(le=Ee(ae=>ee.fire(ae)))},onDidAddFirstListener(){se&&(Ae?setTimeout(ue):ue())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return ee.event}a.buffer=x;class V{constructor(Ae){this.event=Ae,this.c=new k.DisposableStore}map(Ae){return new V(I(this.event,Ae,this.c))}forEach(Ae){return new V(R(this.event,Ae,this.c))}filter(Ae){return new V(B(this.event,Ae,this.c))}reduce(Ae,Fe){return new V(N(this.event,Ae,Fe,this.c))}latch(){return new V(U(this.event,void 0,this.c))}debounce(Ae,Fe=100,se=!1,le){return new V(F(this.event,Ae,Fe,se,le,this.c))}on(Ae,Fe,se){return this.event(Ae,Fe,se)}once(Ae,Fe,se){return f(this.event)(Ae,Fe,se)}dispose(){this.c.dispose()}}function _(Ee){return new V(Ee)}a.chain=_;function Q(Ee,Ae,Fe=se=>se){const se=(...ae)=>ee.fire(Fe(...ae)),le=()=>Ee.on(Ae,se),ue=()=>Ee.removeListener(Ae,se),ee=new m({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return ee.event}a.fromNodeEventEmitter=Q;function Z(Ee,Ae,Fe=se=>se){const se=(...ae)=>ee.fire(Fe(...ae)),le=()=>Ee.addEventListener(Ae,se),ue=()=>Ee.removeEventListener(Ae,se),ee=new m({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return ee.event}a.fromDOMEventEmitter=Z;function ge(Ee){return new Promise(Ae=>f(Ee)(Ae))}a.toPromise=ge;function te(Ee,Ae){return Ae(void 0),Ee(Fe=>Ae(Fe))}a.runAndSubscribe=te;function J(Ee,Ae){let Fe=null;function se(ue){Fe?.dispose(),Fe=new k.DisposableStore,Ae(ue,Fe)}se(void 0);const le=Ee(ue=>se(ue));return(0,k.toDisposable)(()=>{le.dispose(),Fe?.dispose()})}a.runAndSubscribeWithStore=J;class fe{constructor(Ae,Fe){this.obs=Ae,this.c=0,this.d=!1;const se={onWillAddFirstListener:()=>{Ae.addObserver(this)},onDidRemoveLastListener:()=>{Ae.removeObserver(this)}};Fe||n(se),this.emitter=new m(se),Fe&&Fe.add(this.emitter)}beginUpdate(Ae){this.c++}handleChange(Ae,Fe){this.d=!0}endUpdate(Ae){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function ve(Ee,Ae){return new fe(Ee,Ae).emitter.event}a.fromObservable=ve})(y=e.Event||(e.Event={}));class L{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${L.c++}`,L.all.add(this)}start(n){this.d=new C.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=L,L.all=new Set,L.c=0;let P=-1;function v(a){const n=P;return P=a,{dispose(){P=n}}}e.setGlobalLeakWarningThreshold=v;class D{constructor(n,r=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=r,this.d=0}dispose(){this.c?.clear()}check(n,r){const f=this.threshold;if(f<=0||r<f)return;this.c||(this.c=new Map);const I=this.c.get(n.value)||0;if(this.c.set(n.value,I+1),this.d-=1,this.d<=0){this.d=f*.5;let R,B=0;for(const[X,q]of this.c)(!R||B<q)&&(R=X,B=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${B}):`),console.warn(R)}return()=>{const R=this.c.get(n.value)||0;this.c.set(n.value,R-1)}}}class E{static create(){return new E(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(n,r,f){this.callback=n,this.callbackThis=r,this.stack=f,this.subscription=new k.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class m{constructor(n){this.j=!1,this.d=n,this.f=P>0||this.d?.leakWarningThreshold?new D(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(T){const n=Array.from(this.q);queueMicrotask(()=>{for(const r of n)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,r,f)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const I=this.q.isEmpty();I&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let R,B;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(B=E.create(),R=this.f.check(B,this.q.size+1)),T&&(B=B??E.create());const X=new d(n,r,B),q=this.q.push(X);I&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,r);const N=X.subscription.set(()=>{R?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return f instanceof k.DisposableStore?f.add(N):Array.isArray(f)&&f.push(N),N}),this.l}fire(n){if(this.q){this.m||(this.m=new b);for(const r of this.q)this.m.push(this,r,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=m;class h{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(n,r,f){this.c.push(new p(n,r,f))}clear(n){const r=new A.LinkedList;for(const f of this.c)f.emitter!==n&&r.push(f);this.c=r}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(r){(0,c.onUnexpectedError)(r)}}}}e.EventDeliveryQueue=h;class b extends h{clear(n){this.c.clear()}}class p{constructor(n,r,f){this.emitter=n,this.listener=r,this.event=f}}class g extends m{async fireAsync(n,r,f){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const I of this.q)this.c.push([I,n]);for(;this.c.size>0&&!r.isCancellationRequested;){const[I,R]=this.c.shift(),B=[],X={...R,token:r,waitUntil:q=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");f&&(q=f(q,I.callback)),B.push(q)}};try{I.invoke(X)}catch(q){(0,c.onUnexpectedError)(q);continue}Object.freeze(B),await Promise.allSettled(B).then(q=>{for(const N of q)N.status==="rejected"&&(0,c.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=g;class w extends m{constructor(n){super(n),this.h=0,this.s=new A.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=w;class i extends w{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=i;class o extends m{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(r=>super.fire(r)),this.c=[]}))}}e.MicrotaskEmitter=o;class u{constructor(){this.d=!1,this.f=[],this.c=new m({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const r={event:n,listener:null};this.f.push(r),this.d&&this.j(r);const f=()=>{this.d&&this.k(r);const I=this.f.indexOf(r);this.f.splice(I,1)};return(0,k.toDisposable)((0,t.once)(f))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(r=>this.c.fire(r))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=u;class l{constructor(){this.c=[]}wrapEvent(n){return(r,f,I)=>n(R=>{const B=this.c[this.c.length-1];B?B.push(()=>r.call(f,R)):r.call(f,R)},void 0,I)}bufferEvents(n){const r=[];this.c.push(r);const f=n();return this.c.pop(),r.forEach(I=>I()),f}}e.EventBufferer=l;class s{constructor(){this.c=!1,this.d=y.None,this.f=k.Disposable.None,this.g=new m({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(ye[21],Ce([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(T,S){const y=setTimeout(T.bind(S),0);return{dispose(){clearTimeout(y)}}});var k;(function(T){function S(y){return y===T.None||y===T.Cancelled||y instanceof A?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}T.isCancellationToken=S,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new c.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=k.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=k.None}}e.CancellationTokenSource=C}),define(ye[159],Ce([1,0,21]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(T){this.b=T,this.a=null}get(){if(this.a)return this.a;const T=new c.CancellationTokenSource,S=this.b(T.token);return this.a={promise:S,dispose:()=>{this.a=null,T.cancel(),T.dispose()}},this.a}}e.Cache=t;class k{constructor(T){this.c=T,this.a=void 0,this.b=void 0}get(T){const S=JSON.stringify(T);return this.b!==S&&(this.b=S,this.a=this.c(T)),this.a}}e.LRUCachedFunction=k;class A{get cachedValues(){return this.a}constructor(T){this.b=T,this.a=new Map}get(T){if(this.a.has(T))return this.a.get(T);const S=this.b(T);return this.a.set(T,S),S}}e.CachedFunction=A}),define(ye[8],Ce([1,0,159,82]),function(ne,e,c,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=A;const C=/{(\d+)}/g;function T($,...ce){return ce.length===0?$:$.replace(C,function(Ie,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=ce.length?Ie:ce[Be]})}e.format=T;const S=/{([^}]+)}/g;function y($,ce){return $.replace(S,(Ie,Le)=>ce[Le]??Ie)}e.format2=y;function L($){return $.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=L;function P($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function v($,ce){let Ie=0;const Le=ce.charCodeAt(0);for(let Be=$.length-1;Be>=0;Be--)$.charCodeAt(Be)===Le&&Ie++;return Ie}e.count=v;function D($,ce,Ie="\u2026"){return $.length<=ce?$:`${$.substr(0,ce)}${Ie}`}e.truncate=D;function E($,ce=" "){const Ie=d($,ce);return m(Ie,ce)}e.trim=E;function d($,ce){if(!$||!ce)return $;const Ie=ce.length;if(Ie===0||$.length===0)return $;let Le=0;for(;$.indexOf(ce,Le)===Le;)Le=Le+Ie;return $.substring(Le)}e.ltrim=d;function m($,ce){if(!$||!ce)return $;const Ie=ce.length,Le=$.length;if(Ie===0||Le===0)return $;let Be=Le,xe=-1;for(;xe=$.lastIndexOf(ce,Be-1),!(xe===-1||xe+Ie!==Be);){if(xe===0)return"";Be=xe}return $.substring(0,Be)}e.rtrim=m;function h($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function b($){return $.replace(/\*/g,"")}e.stripWildcards=b;function p($,ce,Ie={}){if(!$)throw new Error("Cannot create regex from empty string");ce||($=P($)),Ie.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=p;function g($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function w($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function i($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=i;function o($){return $.split(/\r\n|\r|\n/)}e.splitLines=o;function u($){for(let ce=0,Ie=$.length;ce<Ie;ce++){const Le=$.charCodeAt(ce);if(Le!==32&&Le!==9)return ce}return-1}e.firstNonWhitespaceIndex=u;function l($,ce=0,Ie=$.length){for(let Le=ce;Le<Ie;Le++){const Be=$.charCodeAt(Le);if(Be!==32&&Be!==9)return $.substring(ce,Le)}return $.substring(ce,Ie)}e.getLeadingWhitespace=l;function s($,ce=$.length-1){for(let Ie=ce;Ie>=0;Ie--){const Le=$.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=s;function a($,ce,Ie){const Le=[];let Be=0;for(const xe of $.matchAll(ce)){if(Le.push($.slice(Be,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Be=xe.index+xe[0].length,Le.push(Ie(xe[0],...xe.slice(1),xe.index,$,xe.groups))}return Le.push($.slice(Be)),Promise.all(Le).then(xe=>xe.join(""))}e.replaceAsync=a;function n($,ce){return $<ce?-1:$>ce?1:0}e.compare=n;function r($,ce,Ie=0,Le=$.length,Be=0,xe=ce.length){for(;Ie<Le&&Be<xe;Ie++,Be++){const mt=$.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(mt<lt)return-1;if(mt>lt)return 1}const Ze=Le-Ie,gt=xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstring=r;function f($,ce){return I($,ce,0,$.length,0,ce.length)}e.compareIgnoreCase=f;function I($,ce,Ie=0,Le=$.length,Be=0,xe=ce.length){for(;Ie<Le&&Be<xe;Ie++,Be++){let mt=$.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(mt===lt)continue;if(mt>=128||lt>=128)return r($.toLowerCase(),ce.toLowerCase(),Ie,Le,Be,xe);B(mt)&&(mt-=32),B(lt)&&(lt-=32);const ot=mt-lt;if(ot!==0)return ot}const Ze=Le-Ie,gt=xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstringIgnoreCase=I;function R($){return $>=48&&$<=57}e.isAsciiDigit=R;function B($){return $>=97&&$<=122}e.isLowerAsciiLetter=B;function X($){return $>=65&&$<=90}e.isUpperAsciiLetter=X;function q($,ce){return $.length===ce.length&&I($,ce)===0}e.equalsIgnoreCase=q;function N($,ce){const Ie=ce.length;return ce.length>$.length?!1:I($,ce,0,Ie)===0}e.startsWithIgnoreCase=N;function M($,ce){const Ie=Math.min($.length,ce.length);let Le;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Le)!==ce.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=M;function F($,ce){const Ie=Math.min($.length,ce.length);let Le;const Be=$.length-1,xe=ce.length-1;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Be-Le)!==ce.charCodeAt(xe-Le))return Le;return Ie}e.commonSuffixLength=F;function z($){return 55296<=$&&$<=56319}e.isHighSurrogate=z;function U($){return 56320<=$&&$<=57343}e.isLowSurrogate=U;function H($,ce){return($-55296<<10)+(ce-56320)+65536}e.computeCodePoint=H;function x($,ce,Ie){const Le=$.charCodeAt(Ie);if(z(Le)&&Ie+1<ce){const Be=$.charCodeAt(Ie+1);if(U(Be))return H(Le,Be)}return Le}e.getNextCodePoint=x;function V($,ce){const Ie=$.charCodeAt(ce-1);if(U(Ie)&&ce>1){const Le=$.charCodeAt(ce-2);if(z(Le))return H(Le,Ie)}return Ie}class _{get offset(){return this.e}constructor(ce,Ie=0){this.c=ce,this.d=ce.length,this.e=Ie}setOffset(ce){this.e=ce}prevCodePoint(){const ce=V(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=x(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=_;class Q{get offset(){return this.c.offset}constructor(ce,Ie=0){this.c=new _(ce,Ie)}nextGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.nextCodePoint());if(je(Be,Ze)){Ie.setOffset(xe);break}Be=Ze}return Ie.offset-Le}prevGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.prevCodePoint());if(je(Ze,Be)){Ie.setOffset(xe);break}Be=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Q;function Z($,ce){return new Q($,ce).nextGraphemeLength()}e.nextCharLength=Z;function ge($,ce){return new Q($,ce).prevGraphemeLength()}e.prevCharLength=ge;function te($,ce){ce>0&&U($.charCodeAt(ce))&&ce--;const Ie=ce+Z($,ce);return[Ie-ge($,Ie),Ie]}e.getCharContainingOffset=te;function J($){const ce=new Q($);let Ie=0;for(;!ce.eol();)Ie++,ce.nextGraphemeLength();return Ie}e.charCount=J;let fe;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ee($){return fe||(fe=ve()),fe.test($)}e.containsRTL=Ee;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Fe($){return Ae.test($)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=se;function le($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=le;function ue($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=ue;function ee($,ce){if($.length<ce)return $;const Ie=/\b/g;let Le=0;for(;Ie.test($)&&!($.length-Ie.lastIndex<ce);)Le=Ie.lastIndex,Ie.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=ee;const ae=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function W($){return $&&($=$.replace(ae,""),$=$.replace(ie,""),$=$.replace(O,"")),$}e.removeAnsiEscapeCodes=W,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function K($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=K;function Y($){return K($)?$.substr(1):$}e.stripUTF8BOM=Y;function de($,ce){if(!$||!ce||$.length<ce.length)return!1;const Ie=ce.length,Le=$.toLowerCase();let Be=0,xe=-1;for(;Be<Ie;){const Ze=Le.indexOf(ce[Be],xe+1);if(Ze<0)return!1;xe=Ze,Be++}return!0}e.fuzzyContains=de;function be($,ce=!1){return $?(ce&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=be;function Pe($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=Pe;function pe($,ce=1){if(ce===0)return"";let Ie=-1;do Ie=$.indexOf(`
`,Ie+1),ce--;while(ce>0&&Ie>=0);return Ie===-1?$:($[Ie-1]==="\r"&&Ie--,$.substr(0,Ie))}e.getNLines=pe;function De($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=De;function ke($){return et.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=ke;function je($,ce){return $===0?ce!==5&&ce!==7:$===2&&ce===3?!1:$===4||$===2||$===3||ce===4||ce===2||ce===3?!0:!($===8&&(ce===8||ce===9||ce===11||ce===12)||($===11||$===9)&&(ce===9||ce===10)||($===12||$===10)&&ce===10||ce===5||ce===13||ce===7||$===1||$===13&&ce===14||$===6&&ce===6)}var Ge;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=_e()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const Ie=this.d,Le=Ie.length/3;let Be=1;for(;Be<=Le;)if(ce<Ie[3*Be])Be=2*Be;else if(ce>Ie[3*Be+1])Be=2*Be+1;else return Ie[3*Be+2];return 0}}et.c=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,ce){if($===0)return 0;const Ie=st($,ce);if(Ie!==void 0)return Ie;const Le=new _(ce,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st($,ce){const Ie=new _(ce,$);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!ue(Le))return;let Be=Ie.offset;return Be>0&&Ie.prevCodePoint()===8205&&(Be=Ie.offset),Be}function ht($){return 127995<=$&&$<=127999}var Me;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class it{static getInstance(ce){return it.d.get(Array.from(ce))}static getLocales(){return it.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=it,k=it,it.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new c.LRUCachedFunction($=>{function ce(lt){const ot=new Map;for(let rt=0;rt<lt.length;rt+=2)ot.set(lt[rt],lt[rt+1]);return ot}function Ie(lt,ot){const rt=new Map(lt);for(const[kt,Tt]of ot)rt.set(kt,Tt);return rt}function Le(lt,ot){if(!lt)return ot;const rt=new Map;for(const[kt,Tt]of lt)ot.has(kt)&&rt.set(kt,Tt);return rt}const Be=k.c.getValue();let xe=$.filter(lt=>!lt.startsWith("_")&&lt in Be);xe.length===0&&(xe=["_default"]);let Ze;for(const lt of xe){const ot=ce(Be[lt]);Ze=Le(Ze,ot)}const gt=ce(Be._common),mt=Ie(gt,Ze);return new it(mt)}),it.e=new t.Lazy(()=>Object.keys(it.c.getValue()).filter($=>!$.startsWith("_")));class oe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(oe.c())),this.d}static isInvisibleCharacter(ce){return oe.e().has(ce)}static get codePoints(){return oe.e()}}e.InvisibleCharacters=oe,oe.d=void 0}),define(ye[32],Ce([1,0,9,12,8,11]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(s){return s===47||s===92}e.isPathSeparator=C;function T(s){return s.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=T;function S(s){return s.indexOf("/")===-1&&(s=T(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=S;function y(s,a=c.posix.sep){if(!s)return"";const n=s.length,r=s.charCodeAt(0);if(C(r)){if(C(s.charCodeAt(1))&&!C(s.charCodeAt(2))){let I=3;const R=I;for(;I<n&&!C(s.charCodeAt(I));I++);if(R!==I&&!C(s.charCodeAt(I+1))){for(I+=1;I<n;I++)if(C(s.charCodeAt(I)))return s.slice(0,I+1).replace(/[\\/]/g,a)}}return a}else if(h(r)&&s.charCodeAt(1)===58)return C(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let f=s.indexOf("://");if(f!==-1){for(f+=3;f<n;f++)if(C(s.charCodeAt(f)))return s.slice(0,f+1)}return""}e.getRoot=y;function L(s){if(!t.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let n=2;const r=n;for(;n<s.length&&(a=s.charCodeAt(n),a!==92);n++);return!(r===n||(a=s.charCodeAt(n+1),isNaN(a)||a===92))}e.isUNC=L;const P=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,D=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(s,a=t.isWindows){const n=a?P:v;return!(!s||s.length===0||/^\s+$/.test(s)||(n.lastIndex=0,n.test(s))||a&&D.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=E;function d(s,a,n){const r=s===a;return!n||r?r:!s||!a?!1:(0,k.equalsIgnoreCase)(s,a)}e.isEqual=d;function m(s,a,n,r=c.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(n){if(!(0,k.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let I=a.length;return a.charAt(a.length-1)===r&&I--,s.charAt(I)===r}return a.charAt(a.length-1)!==r&&(a+=r),s.indexOf(a)===0}e.isEqualOrParent=m;function h(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=h;function b(s,a){return t.isWindows&&s.endsWith(":")&&(s+=c.sep),(0,c.isAbsolute)(s)||(s=(0,c.join)(a,s)),s=(0,c.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,c.sep),s.endsWith(":")&&(s+=c.sep)):(s=(0,k.rtrim)(s,c.sep),s||(s=c.sep)),s}e.sanitizeFilePath=b;function p(s){const a=(0,c.normalize)(s);return t.isWindows?s.length>3?!1:g(a)&&(s.length===2||a.charCodeAt(2)===92):a===c.posix.sep}e.isRootOrDriveLetter=p;function g(s,a=t.isWindows){return a?h(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function w(s){return g(s)?s[0]:void 0}e.getDriveLetter=w;function i(s,a,n){return a.length>s.length?-1:s===a?0:(n&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=i;function o(s){const a=s.split(":");let n,r,f;for(const I of a){const R=Number(I);(0,A.isNumber)(R)?r===void 0?r=R:f===void 0&&(f=R):n=n?[n,I].join(":"):I}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:r!==void 0?r:void 0,column:f!==void 0?f:r!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(s,a,n=8){let r="";for(let I=0;I<n;I++)r+=u.charAt(Math.floor(Math.random()*u.length));let f;return a?f=`${a}-${r}`:f=r,s?(0,c.join)(s,f):f}e.randomPath=l}),define(ye[108],Ce([1,0,28,8]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...ie){return function(O,W){for(let K=0,Y=ie.length;K<Y;K++){const de=ie[K](O,W);if(de)return de}return null}}e.or=k,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ie,O,W){if(!W||W.length<O.length)return null;let K;return ie?K=t.startsWithIgnoreCase(W,O):K=W.indexOf(O)===0,K?O.length>0?[{start:0,end:O.length}]:[]:null}function C(ie,O){const W=O.toLowerCase().indexOf(ie.toLowerCase());return W===-1?null:[{start:W,end:W+ie.length}]}e.matchesContiguousSubString=C;function T(ie,O){return S(ie.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=T;function S(ie,O,W,K){if(W===ie.length)return[];if(K===O.length)return null;if(ie[W]===O[K]){let Y=null;return(Y=S(ie,O,W+1,K+1))?h({start:K,end:K+1},Y):null}return S(ie,O,W,K+1)}function y(ie){return 97<=ie&&ie<=122}function L(ie){return 65<=ie&&ie<=90}e.isUpper=L;function P(ie){return 48<=ie&&ie<=57}function v(ie){return ie===32||ie===9||ie===10||ie===13}const D=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>D.add(ie.charCodeAt(0)));function E(ie){return v(ie)||D.has(ie)}function d(ie,O){return ie===O||E(ie)&&E(O)}function m(ie){return y(ie)||L(ie)||P(ie)}function h(ie,O){return O.length===0?O=[ie]:ie.end===O[0].start?O[0].start=ie.start:O.unshift(ie),O}function b(ie,O){for(let W=O;W<ie.length;W++){const K=ie.charCodeAt(W);if(L(K)||P(K)||W>0&&!m(ie.charCodeAt(W-1)))return W}return ie.length}function p(ie,O,W,K){if(W===ie.length)return[];if(K===O.length)return null;if(ie[W]!==O[K].toLowerCase())return null;{let Y=null,de=K+1;for(Y=p(ie,O,W+1,K+1);!Y&&(de=b(O,de))<O.length;)Y=p(ie,O,W+1,de),de++;return Y===null?null:h({start:K,end:K+1},Y)}}function g(ie){let O=0,W=0,K=0,Y=0,de=0;for(let ke=0;ke<ie.length;ke++)de=ie.charCodeAt(ke),L(de)&&O++,y(de)&&W++,m(de)&&K++,P(de)&&Y++;const be=O/ie.length,Pe=W/ie.length,pe=K/ie.length,De=Y/ie.length;return{upperPercent:be,lowerPercent:Pe,alphaPercent:pe,numericPercent:De}}function w(ie){const{upperPercent:O,lowerPercent:W}=ie;return W===0&&O>.6}function i(ie){const{upperPercent:O,lowerPercent:W,alphaPercent:K,numericPercent:Y}=ie;return W>.2&&O<.8&&K>.6&&Y<.2}function o(ie){let O=0,W=0,K=0,Y=0;for(let de=0;de<ie.length;de++)K=ie.charCodeAt(de),L(K)&&O++,y(K)&&W++,v(K)&&Y++;return(O===0||W===0)&&Y===0?ie.length<=30:O<=5}function u(ie,O){if(!O||(O=O.trim(),O.length===0)||!o(ie)||O.length>60)return null;const W=g(O);if(!i(W)){if(!w(W))return null;O=O.toLowerCase()}let K=null,Y=0;for(ie=ie.toLowerCase();Y<O.length&&(K=p(ie,O,0,Y))===null;)Y=b(O,Y+1);return K}e.matchesCamelCase=u;function l(ie,O,W=!1){if(!O||O.length===0)return null;let K=null,Y=0;for(ie=ie.toLowerCase(),O=O.toLowerCase();Y<O.length&&(K=s(ie,O,0,Y,W))===null;)Y=a(O,Y+1);return K}e.matchesWords=l;function s(ie,O,W,K,Y){if(W===ie.length)return[];if(K===O.length)return null;if(d(ie.charCodeAt(W),O.charCodeAt(K))){let de=null,be=K+1;if(de=s(ie,O,W+1,K+1,Y),!Y)for(;!de&&(be=a(O,be))<O.length;)de=s(ie,O,W+1,be,Y),be++;return de?ie.charCodeAt(W)!==O.charCodeAt(K)?de:h({start:K,end:K+1},de):null}else return null}function a(ie,O){for(let W=O;W<ie.length;W++)if(E(ie.charCodeAt(W))||W>0&&E(ie.charCodeAt(W-1)))return W;return ie.length}const n=k(e.matchesPrefix,u,C),r=k(e.matchesPrefix,u,T),f=new c.LRUCache(1e4);function I(ie,O,W=!1){if(typeof ie!="string"||typeof O!="string")return null;let K=f.get(ie);K||(K=new RegExp(t.convertSimple2RegExpPattern(ie),"i"),f.set(ie,K));const Y=K.exec(O);return Y?[{start:Y.index,end:Y.index+Y[0].length}]:W?r(ie,O):n(ie,O)}e.matchesFuzzy=I;function R(ie,O){const W=Ae(ie,ie.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return W?X(W):null}e.matchesFuzzy2=R;function B(ie,O,W,K,Y,de){const be=Math.min(13,ie.length);for(;W<be;W++){const Pe=Ae(ie,O,W,K,Y,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Pe)return Pe}return[0,de]}e.anyScore=B;function X(ie){if(typeof ie>"u")return[];const O=[],W=ie[1];for(let K=ie.length-1;K>1;K--){const Y=ie[K]+W,de=O[O.length-1];de&&de.end===Y?de.end=Y+1:O.push({start:Y,end:Y+1})}return O}e.createMatches=X;const q=128;function N(){const ie=[],O=[];for(let W=0;W<=q;W++)O[W]=0;for(let W=0;W<=q;W++)ie.push(O.slice(0));return ie}function M(ie){const O=[];for(let W=0;W<=ie;W++)O[W]=0;return O}const F=M(2*q),z=M(2*q),U=N(),H=N(),x=N(),V=!1;function _(ie,O,W,K,Y){function de(Pe,pe,De=" "){for(;Pe.length<pe;)Pe=De+Pe;return Pe}let be=` |   |${K.split("").map(Pe=>de(Pe,3)).join("|")}
`;for(let Pe=0;Pe<=W;Pe++)Pe===0?be+=" |":be+=`${O[Pe-1]}|`,be+=ie[Pe].slice(0,Y+1).map(pe=>de(pe.toString(),3)).join("|")+`
`;return be}function Q(ie,O,W,K){ie=ie.substr(O),W=W.substr(K),console.log(_(H,ie,ie.length,W,W.length)),console.log(_(x,ie,ie.length,W,W.length)),console.log(_(U,ie,ie.length,W,W.length))}function Z(ie,O){if(O<0||O>=ie.length)return!1;const W=ie.codePointAt(O);switch(W){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(W)}}function ge(ie,O){if(O<0||O>=ie.length)return!1;switch(ie.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function te(ie,O,W){return O[ie]!==W[ie]}function J(ie,O,W,K,Y,de,be=!1){for(;O<W&&Y<de;)ie[O]===K[Y]&&(be&&(F[O]=Y),O+=1),Y+=1;return O===W}e.isPatternInWord=J;var fe;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(fe||(fe={}));var ve;(function(ie){ie.Default=[-100,0];function O(W){return!W||W.length===2&&W[0]===-100&&W[1]===0}ie.isDefault=O})(ve=e.FuzzyScore||(e.FuzzyScore={}));class Ee{constructor(O,W){this.firstMatchCanBeWeak=O,this.boostFullMatch=W}}e.FuzzyScoreOptions=Ee,Ee.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Ae(ie,O,W,K,Y,de,be=Ee.default){const Pe=ie.length>q?q:ie.length,pe=K.length>q?q:K.length;if(W>=Pe||de>=pe||Pe-W>pe-de||!J(O,W,Pe,Y,de,pe,!0))return;Fe(Pe,pe,W,de,O,Y);let De=1,ke=1,je=W,Ge=de;const et=[!1];for(De=1,je=W;je<Pe;De++,je++){const Me=F[je],it=z[je],oe=je+1<Pe?z[je+1]:pe;for(ke=Me-de+1,Ge=Me;Ge<oe;ke++,Ge++){let $=Number.MIN_SAFE_INTEGER,ce=!1;Ge<=it&&($=se(ie,O,je,W,K,Y,Ge,pe,de,U[De-1][ke-1]===0,et));let Ie=0;$!==Number.MAX_SAFE_INTEGER&&(ce=!0,Ie=$+H[De-1][ke-1]);const Le=Ge>Me,Be=Le?H[De][ke-1]+(U[De][ke-1]>0?-5:0):0,xe=Ge>Me+1&&U[De][ke-1]>0,Ze=xe?H[De][ke-2]+(U[De][ke-2]>0?-5:0):0;if(xe&&(!Le||Ze>=Be)&&(!ce||Ze>=Ie))H[De][ke]=Ze,x[De][ke]=3,U[De][ke]=0;else if(Le&&(!ce||Be>=Ie))H[De][ke]=Be,x[De][ke]=2,U[De][ke]=0;else if(ce)H[De][ke]=Ie,x[De][ke]=1,U[De][ke]=U[De-1][ke-1]+1;else throw new Error("not possible")}}if(V&&Q(ie,W,K,de),!et[0]&&!be.firstMatchCanBeWeak)return;De--,ke--;const _e=[H[De][ke],de];let nt=0,st=0;for(;De>=1;){let Me=ke;do{const it=x[De][Me];if(it===3)Me=Me-2;else if(it===2)Me=Me-1;else break}while(Me>=1);nt>1&&O[W+De-1]===Y[de+ke-1]&&!te(Me+de-1,K,Y)&&nt+1>U[De][Me]&&(Me=ke),Me===ke?nt++:nt=1,st||(st=Me),De--,ke=Me-1,_e.push(ke)}pe===Pe&&be.boostFullMatch&&(_e[0]+=2);const ht=st-Pe;return _e[0]-=ht,_e}e.fuzzyScore=Ae;function Fe(ie,O,W,K,Y,de){let be=ie-1,Pe=O-1;for(;be>=W&&Pe>=K;)Y[be]===de[Pe]&&(z[be]=Pe,be--),Pe--}function se(ie,O,W,K,Y,de,be,Pe,pe,De,ke){if(O[W]!==de[be])return Number.MIN_SAFE_INTEGER;let je=1,Ge=!1;return be===W-K?je=ie[W]===Y[be]?7:5:te(be,Y,de)&&(be===0||!te(be-1,Y,de))?(je=ie[W]===Y[be]?7:5,Ge=!0):Z(de,be)&&(be===0||!Z(de,be-1))?je=5:(Z(de,be-1)||ge(de,be-1))&&(je=5,Ge=!0),je>1&&W===K&&(ke[0]=!0),Ge||(Ge=te(be,Y,de)||Z(de,be-1)||ge(de,be-1)),W===K?be>pe&&(je-=Ge?3:5):De?je+=Ge?2:0:je+=Ge?0:1,be+1===Pe&&(je-=Ge?3:5),je}function le(ie,O,W,K,Y,de,be){return ee(ie,O,W,K,Y,de,!0,be)}e.fuzzyScoreGracefulAggressive=le;function ue(ie,O,W,K,Y,de,be){return ee(ie,O,W,K,Y,de,!1,be)}e.fuzzyScoreGraceful=ue;function ee(ie,O,W,K,Y,de,be,Pe){let pe=Ae(ie,O,W,K,Y,de,Pe);if(pe&&!be)return pe;if(ie.length>=3){const De=Math.min(7,ie.length-1);for(let ke=W+1;ke<De;ke++){const je=ae(ie,ke);if(je){const Ge=Ae(je,je.toLowerCase(),W,K,Y,de,Pe);Ge&&(Ge[0]-=3,(!pe||Ge[0]>pe[0])&&(pe=Ge))}}}return pe}function ae(ie,O){if(O+1>=ie.length)return;const W=ie[O],K=ie[O+1];if(W!==K)return ie.slice(0,O)+K+W+ie.slice(O+2)}}),define(ye[85],Ce([1,0,8]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(h){return k(h,0)}e.hash=t;function k(h,b){switch(typeof h){case"object":return h===null?A(349,b):Array.isArray(h)?S(h,b):y(h,b);case"string":return T(h,b);case"boolean":return C(h,b);case"number":return A(h,b);case"undefined":return A(937,b);default:return A(617,b)}}e.doHash=k;function A(h,b){return(b<<5)-b+h|0}e.numberHash=A;function C(h,b){return A(h?433:863,b)}function T(h,b){b=A(149417,b);for(let p=0,g=h.length;p<g;p++)b=A(h.charCodeAt(p),b);return b}e.stringHash=T;function S(h,b){return b=A(104579,b),h.reduce((p,g)=>k(g,p),b)}function y(h,b){return b=A(181387,b),Object.keys(h).sort().reduce((p,g)=>(p=T(g,p),k(h[g],p)),b)}class L{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=k(b,this.g),this.g}}e.Hasher=L;var P;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function v(h,b,p=32){const g=p-b,w=~((1<<g)-1);return(h<<b|(w&h)>>>g)>>>0}function D(h,b=0,p=h.byteLength,g=0){for(let w=0;w<p;w++)h[b+w]=g}function E(h,b,p="0"){for(;h.length<b;)h=p+h;return h}function d(h,b=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(p=>p.toString(16).padStart(2,"0")).join(""):E((h>>>0).toString(16),b/4)}e.toHexString=d;class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const p=b.length;if(p===0)return;const g=this.p;let w=this.r,i=this.u,o,u;for(i!==0?(o=i,u=-1,i=0):(o=b.charCodeAt(0),u=0);;){let l=o;if(c.isHighSurrogate(o))if(u+1<p){const s=b.charCodeAt(u+1);c.isLowSurrogate(s)?(u++,l=c.computeCodePoint(o,s)):l=65533}else{i=o;break}else c.isLowSurrogate(o)&&(l=65533);if(w=this.w(g,w,l),u++,u<p)o=b.charCodeAt(u);else break}this.r=w,this.u=i}w(b,p,g){return g<128?b[p++]=g:g<2048?(b[p++]=192|(g&1984)>>>6,b[p++]=128|(g&63)>>>0):g<65536?(b[p++]=224|(g&61440)>>>12,b[p++]=128|(g&4032)>>>6,b[p++]=128|(g&63)>>>0):(b[p++]=240|(g&1835008)>>>18,b[p++]=128|(g&258048)>>>12,b[p++]=128|(g&4032)>>>6,b[p++]=128|(g&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,D(this.p,this.r),this.r>56&&(this.y(),D(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=m.g,p=this.q;for(let n=0;n<64;n+=4)b.setUint32(n,p.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)b.setUint32(n,v(b.getUint32(n-12,!1)^b.getUint32(n-32,!1)^b.getUint32(n-56,!1)^b.getUint32(n-64,!1),1),!1);let g=this.h,w=this.l,i=this.m,o=this.n,u=this.o,l,s,a;for(let n=0;n<80;n++)n<20?(l=w&i|~w&o,s=1518500249):n<40?(l=w^i^o,s=1859775393):n<60?(l=w&i|w&o|i&o,s=2400959708):(l=w^i^o,s=3395469782),a=v(g,5)+l+u+s+b.getUint32(n*4,!1)&4294967295,u=o,o=i,i=v(w,30),w=g,g=a;this.h=this.h+g&4294967295,this.l=this.l+w&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+u&4294967295}}e.StringSHA1=m,m.g=new DataView(new ArrayBuffer(320))}),define(ye[160],Ce([1,0,80,108,8]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",C=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${C.source}`,"g");function S(m){return m.replace(T,(h,b)=>b?h:`\\${h}`)}e.escapeIcons=S;const y=new RegExp(`\\\\${C.source}`,"g");function L(m){return m.replace(y,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=L;const P=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function v(m){return m.indexOf(A)===-1?m:m.replace(P,(h,b,p,g)=>p?h:b||g||"")}e.stripIcons=v;const D=new RegExp(`\\$\\(${c.CSSIcon.iconNameCharacter}+\\)`,"g");function E(m){D.lastIndex=0;let h="";const b=[];let p=0;for(;;){const g=D.lastIndex,w=D.exec(m),i=m.substring(g,w?.index);if(i.length>0){h+=i;for(let o=0;o<i.length;o++)b.push(p)}if(!w)break;p+=w[0].length}return{text:h,iconOffsets:b}}e.parseLabelWithIcons=E;function d(m,h,b=!1){const{text:p,iconOffsets:g}=h;if(!g||g.length===0)return(0,t.matchesFuzzy)(m,p,b);const w=(0,k.ltrim)(p," "),i=p.length-w.length,o=(0,t.matchesFuzzy)(m,w,b);if(o)for(const u of o){const l=g[u.start+i]+i;u.start+=l,u.end+=l}return o}e.matchesFuzzyIconAware=d}),define(ye[43],Ce([1,0,8]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const A="error",C="warning",T="warn",S="info",y="ignore";function L(v){return v?c.equalsIgnoreCase(A,v)?k.Error:c.equalsIgnoreCase(C,v)||c.equalsIgnoreCase(T,v)?k.Warning:c.equalsIgnoreCase(S,v)?k.Info:k.Ignore:k.Ignore}k.fromValue=L;function P(v){switch(v){case k.Error:return A;case k.Warning:return C;case k.Info:return S;default:return y}}k.toString=P}(t||(t={})),e.default=t}),define(ye[64],Ce([1,0,17,8]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(D){return this.b=D,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(D){const E=D.charCodeAt(0),d=this.b.charCodeAt(this.c);return E-d}value(){return this.b[this.c]}}e.StringIterator=k;class A{constructor(D=!0){this.e=D}reset(D){return this.b=D,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let D=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(D)this.c++;else break;else D=!1;return this}cmp(D){return this.e?(0,t.compareSubstring)(D,this.b,0,D.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(D,this.b,0,D.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class C{constructor(D=!0,E=!0){this.f=D,this.g=E}reset(D){this.d=0,this.e=0,this.b=D,this.c=D.length;for(let E=D.length-1;E>=0;E--,this.c--){const d=this.b.charCodeAt(E);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let D=!0;for(;this.e<this.c;this.e++){const E=this.b.charCodeAt(this.e);if(E===47||this.f&&E===92)if(D)this.d++;else break;else D=!1}return this}cmp(D){return this.g?(0,t.compareSubstring)(D,this.b,0,D.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(D,this.b,0,D.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var T;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(D,E){this.f=D,this.g=E,this.d=[],this.e=0}reset(D){return this.c=D,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(D)),this.b.reset(D.path),this.b.value()&&this.d.push(3)),this.g(D)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(D){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(D,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(D,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(D);if(this.d[this.e]===4)return(0,t.compare)(D,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(D,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const D=this.right;return this.right=D.left,D.left=this,this.updateHeight(),D.updateHeight(),D}rotateRight(){const D=this.left;return this.left=D.right,D.right=this,this.updateHeight(),D.updateHeight(),D}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class P{static forUris(D=()=>!1,E=()=>!1){return new P(new S(D,E))}static forPaths(D=!1){return new P(new C(void 0,!D))}static forStrings(){return new P(new k)}static forConfigKeys(){return new P(new A)}constructor(D){this.b=D}clear(){this.c=void 0}fill(D,E){if(E){const d=E.slice(0);(0,c.shuffle)(d);for(const m of d)this.set(m,D)}else{const d=D.slice(0);(0,c.shuffle)(d);for(const m of d)this.set(m[0],m[1])}}set(D,E){const d=this.b.reset(D);let m;this.c||(this.c=new y,this.c.segment=d.value());const h=[];for(m=this.c;;){const p=d.cmp(m.segment);if(p>0)m.left||(m.left=new y,m.left.segment=d.value()),h.push([-1,m]),m=m.left;else if(p<0)m.right||(m.right=new y,m.right.segment=d.value()),h.push([1,m]),m=m.right;else if(d.hasNext())d.next(),m.mid||(m.mid=new y,m.mid.segment=d.value()),h.push([0,m]),m=m.mid;else break}const b=m.value;m.value=E,m.key=D;for(let p=h.length-1;p>=0;p--){const g=h[p][1];g.updateHeight();const w=g.balanceFactor();if(w<-1||w>1){const i=h[p][0],o=h[p+1][0];if(i===1&&o===1)h[p][1]=g.rotateLeft();else if(i===-1&&o===-1)h[p][1]=g.rotateRight();else if(i===1&&o===-1)g.right=h[p+1][1]=h[p+1][1].rotateRight(),h[p][1]=g.rotateLeft();else if(i===-1&&o===1)g.left=h[p+1][1]=h[p+1][1].rotateLeft(),h[p][1]=g.rotateRight();else throw new Error;if(p>0)switch(h[p-1][0]){case-1:h[p-1][1].left=h[p][1];break;case 1:h[p-1][1].right=h[p][1];break;case 0:h[p-1][1].mid=h[p][1];break}else this.c=h[0][1]}}return b}get(D){return this.d(D)?.value}d(D){const E=this.b.reset(D);let d=this.c;for(;d;){const m=E.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(E.hasNext())E.next(),d=d.mid;else break}return d}has(D){const E=this.d(D);return!(E?.value===void 0&&E?.mid===void 0)}delete(D){return this.e(D,!1)}deleteSuperstr(D){return this.e(D,!0)}e(D,E){const d=this.b.reset(D),m=[];let h=this.c;for(;h;){const b=d.cmp(h.segment);if(b>0)m.push([-1,h]),h=h.left;else if(b<0)m.push([1,h]),h=h.right;else if(d.hasNext())d.next(),m.push([0,h]),h=h.mid;else break}if(!!h){if(E?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const b=this.f(h.right);if(b.key){const{key:p,value:g,segment:w}=b;this.e(b.key,!1),h.key=p,h.value=g,h.segment=w}}else{const b=h.left??h.right;if(m.length>0){const[p,g]=m[m.length-1];switch(p){case-1:g.left=b;break;case 0:g.mid=b;break;case 1:g.right=b;break}}else this.c=b}for(let b=m.length-1;b>=0;b--){const p=m[b][1];p.updateHeight();const g=p.balanceFactor();if(g>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),m[b][1]=p.rotateLeft()):g<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),m[b][1]=p.rotateRight()),b>0)switch(m[b-1][0]){case-1:m[b-1][1].left=m[b][1];break;case 1:m[b-1][1].right=m[b][1];break;case 0:m[b-1][1].mid=m[b][1];break}else this.c=m[0][1]}}}f(D){for(;D.left;)D=D.left;return D}findSubstr(D){const E=this.b.reset(D);let d=this.c,m;for(;d;){const h=E.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(E.hasNext())E.next(),m=d.value||m,d=d.mid;else break}return d&&d.value||m}findSuperstr(D){const E=this.b.reset(D);let d=this.c;for(;d;){const m=E.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(E.hasNext())E.next(),d=d.mid;else return d.mid?this.g(d.mid):void 0}}forEach(D){for(const[E,d]of this)D(d,E)}*[Symbol.iterator](){yield*this.g(this.c)}g(D){const E=[];return this.h(D,E),E[Symbol.iterator]()}h(D,E){!D||(D.left&&this.h(D.left,E),D.value&&E.push([D.key,D.value]),D.mid&&this.h(D.mid,E),D.right&&this.h(D.right,E))}_isBalanced(){const D=E=>{if(!E)return!0;const d=E.balanceFactor();return d<-1||d>1?!1:D(E.left)&&D(E.right)};return D(this.c)}}e.TernarySearchTree=P}),define(ye[2],Ce([1,0,9,12]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,A=/^\//,C=/^\/\//;function T(u,l){if(!u.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!k.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!A.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(u,l){return!u&&!l?"file":u}function y(u,l){switch(u){case"https":case"http":case"file":l?l[0]!==P&&(l=P+l):l=P;break}return l}const L="",P="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{static isUri(l){return l instanceof D?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,s,a,n,r,f=!1){typeof l=="object"?(this.scheme=l.scheme||L,this.authority=l.authority||L,this.path=l.path||L,this.query=l.query||L,this.fragment=l.fragment||L):(this.scheme=S(l,f),this.authority=s||L,this.path=y(this.scheme,a||L),this.query=n||L,this.fragment=r||L,T(this,f))}get fsPath(){return p(this,!1)}with(l){if(!l)return this;let{scheme:s,authority:a,path:n,query:r,fragment:f}=l;return s===void 0?s=this.scheme:s===null&&(s=L),a===void 0?a=this.authority:a===null&&(a=L),n===void 0?n=this.path:n===null&&(n=L),r===void 0?r=this.query:r===null&&(r=L),f===void 0?f=this.fragment:f===null&&(f=L),s===this.scheme&&a===this.authority&&n===this.path&&r===this.query&&f===this.fragment?this:new d(s,a,n,r,f)}static parse(l,s=!1){const a=v.exec(l);return a?new d(a[2]||L,o(a[4]||L),o(a[5]||L),o(a[7]||L),o(a[9]||L),s):new d(L,L,L,L,L)}static file(l){let s=L;if(t.isWindows&&(l=l.replace(/\\/g,P)),l[0]===P&&l[1]===P){const a=l.indexOf(P,2);a===-1?(s=l.substring(2),l=P):(s=l.substring(2,a),l=l.substring(a)||P)}return new d("file",s,l,L,L)}static from(l){const s=new d(l.scheme,l.authority,l.path,l.query,l.fragment);return T(s,!0),s}static joinPath(l,...s){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&l.scheme==="file"?a=D.file(c.win32.join(p(l,!0),...s)).path:a=c.posix.join(l.path,...s),l.with({path:a})}toString(l=!1){return g(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof D)return l;{const s=new d(l);return s._formatted=l.external,s._fsPath=l._sep===E?l.fsPath:null,s}}else return l}}e.URI=D;const E=t.isWindows?1:void 0;class d extends D{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(l=!1){return l?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=E),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(u,l,s){let a,n=-1;for(let r=0;r<u.length;r++){const f=u.charCodeAt(r);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||l&&f===47||s&&f===91||s&&f===93||s&&f===58)n!==-1&&(a+=encodeURIComponent(u.substring(n,r)),n=-1),a!==void 0&&(a+=u.charAt(r));else{a===void 0&&(a=u.substr(0,r));const I=m[f];I!==void 0?(n!==-1&&(a+=encodeURIComponent(u.substring(n,r)),n=-1),a+=I):n===-1&&(n=r)}}return n!==-1&&(a+=encodeURIComponent(u.substring(n))),a!==void 0?a:u}function b(u){let l;for(let s=0;s<u.length;s++){const a=u.charCodeAt(s);a===35||a===63?(l===void 0&&(l=u.substr(0,s)),l+=m[a]):l!==void 0&&(l+=u[s])}return l!==void 0?l:u}function p(u,l){let s;return u.authority&&u.path.length>1&&u.scheme==="file"?s=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?l?s=u.path.substr(1):s=u.path[1].toLowerCase()+u.path.substr(2):s=u.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=p;function g(u,l){const s=l?b:h;let a="",{scheme:n,authority:r,path:f,query:I,fragment:R}=u;if(n&&(a+=n,a+=":"),(r||n==="file")&&(a+=P,a+=P),r){let B=r.indexOf("@");if(B!==-1){const X=r.substr(0,B);r=r.substr(B+1),B=X.lastIndexOf(":"),B===-1?a+=s(X,!1,!1):(a+=s(X.substr(0,B),!1,!1),a+=":",a+=s(X.substr(B+1),!1,!0)),a+="@"}r=r.toLowerCase(),B=r.lastIndexOf(":"),B===-1?a+=s(r,!1,!0):(a+=s(r.substr(0,B),!1,!0),a+=r.substr(B))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const B=f.charCodeAt(1);B>=65&&B<=90&&(f=`/${String.fromCharCode(B+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const B=f.charCodeAt(0);B>=65&&B<=90&&(f=`${String.fromCharCode(B+32)}:${f.substr(2)}`)}a+=s(f,!0,!1)}return I&&(a+="?",a+=s(I,!1,!1)),R&&(a+="#",a+=l?R:h(R,!1,!1)),a}function w(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+w(u.substr(3)):u}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(u){return u.match(i)?u.replace(i,l=>w(l)):u}}),define(ye[86],Ce([1,0,22,8,2]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(y){return JSON.stringify(y,T)}e.stringify=A;function C(y){let L=JSON.parse(y);return L=S(L),L}e.parse=C;function T(y,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function S(y,L=0){if(!y||L>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return k.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 16:return new Date(y.source)}if(y instanceof c.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let P=0;P<y.length;++P)y[P]=S(y[P],L+1);else for(const P in y)Object.hasOwnProperty.call(y,P)&&(y[P]=S(y[P],L+1))}return y}e.revive=S}),define(ye[15],Ce([1,0,12,2]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y){this.f=`${y}/${k.vscodeRemoteResource}`}set(y,L,P){this.a[y]=L,this.b[y]=P}setConnectionToken(y,L){this.c[y]=L}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)return this.e(y);const L=y.authority;let P=this.a[L];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const v=this.b[L],D=this.c[L];let E=`path=${encodeURIComponent(y.path)}`;return typeof D=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(D)}`),t.URI.from({scheme:c.isWeb?this.d:k.vscodeRemoteResource,authority:`${P}:${v}`,path:this.f,query:E})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class C{asBrowserUri(y){const L=this.b(y,ne);return this.uriToBrowserUri(L)}uriToBrowserUri(y){return y.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===k.file&&(c.isNative||c.isWebWorker&&c.globals.origin===`${k.vscodeFileResource}://${C.a}`)?y.with({scheme:k.vscodeFileResource,authority:y.authority||C.a,query:null,fragment:null}):y}asFileUri(y){const L=this.b(y,ne);return this.uriToFileUri(L)}uriToFileUri(y){return y.scheme===k.vscodeFileResource?y.with({scheme:k.file,authority:y.authority!==C.a?y.authority:null,query:null,fragment:null}):y}b(y,L){return t.URI.isUri(y)?y:t.URI.parse(L.toUrl(y))}}C.a="vscode-app",e.FileAccess=new C;var T;(function(S){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(y.get("3"));const L="vscode-coi";function P(D){let E;typeof D=="string"?E=new URL(D).searchParams:D instanceof URL?E=D.searchParams:t.URI.isUri(D)&&(E=new URL(D.toString(!0)).searchParams);const d=E?.get(L);if(!!d)return y.get(d)}S.getHeadersFromQuery=P;function v(D,E,d){if(!globalThis.crossOriginIsolated)return;const m=E&&d?"3":d?"2":"1";D instanceof URLSearchParams?D.set(L,m):D[L]=m}S.addSearchParam=v})(T=e.COI||(e.COI={}))}),define(ye[24],Ce([1,0,32,15,9,12,8,2]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(D){return(0,T.uriToFsPath)(D,!0)}e.originalFSPath=S;class y{constructor(E){this.a=E}compare(E,d,m=!1){return E===d?0:(0,C.compare)(this.getComparisonKey(E,m),this.getComparisonKey(d,m))}isEqual(E,d,m=!1){return E===d?!0:!E||!d?!1:this.getComparisonKey(E,m)===this.getComparisonKey(d,m)}getComparisonKey(E,d=!1){return E.with({path:this.a(E)?E.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(E){return this.a(E)}isEqualOrParent(E,d,m=!1){if(E.scheme===d.scheme){if(E.scheme===t.Schemas.file)return c.isEqualOrParent(S(E),S(d),this.a(E))&&E.query===d.query&&(m||E.fragment===d.fragment);if((0,e.isEqualAuthority)(E.authority,d.authority))return c.isEqualOrParent(E.path,d.path,this.a(E),"/")&&E.query===d.query&&(m||E.fragment===d.fragment)}return!1}joinPath(E,...d){return T.URI.joinPath(E,...d)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return k.posix.basename(E.path)}extname(E){return k.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let d;return E.scheme===t.Schemas.file?d=T.URI.file(k.dirname(S(E))).path:(d=k.posix.dirname(E.path),E.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),d="/")),E.with({path:d})}normalizePath(E){if(!E.path.length)return E;let d;return E.scheme===t.Schemas.file?d=T.URI.file(k.normalize(S(E))).path:d=k.posix.normalize(E.path),E.with({path:d})}relativePath(E,d){if(E.scheme!==d.scheme||!(0,e.isEqualAuthority)(E.authority,d.authority))return;if(E.scheme===t.Schemas.file){const b=k.relative(S(E),S(d));return A.isWindows?c.toSlashes(b):b}let m=E.path||"/";const h=d.path||"/";if(this.a(E)){let b=0;for(const p=Math.min(m.length,h.length);b<p&&!(m.charCodeAt(b)!==h.charCodeAt(b)&&m.charAt(b).toLowerCase()!==h.charAt(b).toLowerCase());b++);m=h.substr(0,b)+m.substr(b)}return k.posix.relative(m,h)}resolvePath(E,d){if(E.scheme===t.Schemas.file){const m=T.URI.file(k.resolve(S(E),d));return E.with({authority:m.authority,path:m.path})}return d=c.toPosixPath(d),E.with({path:k.posix.resolve(E.path,d)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,d){return E===d||E!==void 0&&d!==void 0&&(0,C.equalsIgnoreCase)(E,d)}hasTrailingPathSeparator(E,d=k.sep){if(E.scheme===t.Schemas.file){const m=S(E);return m.length>c.getRoot(m).length&&m[m.length-1]===d}else{const m=E.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,d=k.sep){return(0,e.hasTrailingPathSeparator)(E,d)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,d=k.sep){let m=!1;if(E.scheme===t.Schemas.file){const h=S(E);m=h!==void 0&&h.length===c.getRoot(h).length&&h[h.length-1]===d}else{d="/";const h=E.path;m=h.length===1&&h.charCodeAt(h.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(E,d)?E.with({path:E.path+"/"}):E}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(D=>D.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new y(D=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(D,E){const d=[];for(let m=0;m<D.length;m++){const h=E(D[m]);D.some((b,p)=>p===m?!1:(0,e.isEqualOrParent)(h,E(b)))||d.push(D[m])}return d}e.distinctParents=L;var P;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function E(d){const m=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(p=>{const[g,w]=p.split(":");g&&w&&m.set(g,w)});const b=d.path.substring(0,d.path.indexOf(";"));return b&&m.set(D.META_DATA_MIME,b),m}D.parseMetaData=E})(P=e.DataUri||(e.DataUri={}));function v(D,E,d){if(E){let m=D.path;return m&&m[0]!==k.posix.sep&&(m=k.posix.sep+m),D.with({scheme:d,authority:E,path:m})}return D.with({scheme:d})}e.toLocalResource=v}),define(ye[18],Ce([1,0,21,10,4,6,24,12]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(te){return!!te&&typeof te.then=="function"}e.isThenable=S;function y(te){const J=new c.CancellationTokenSource,fe=te(J.token),ve=new Promise((Ee,Ae)=>{const Fe=J.token.onCancellationRequested(()=>{Fe.dispose(),J.dispose(),Ae(new t.CancellationError)});Promise.resolve(fe).then(se=>{Fe.dispose(),J.dispose(),Ee(se)},se=>{Fe.dispose(),J.dispose(),Ae(se)})});return new class{cancel(){J.cancel()}then(Ee,Ae){return ve.then(Ee,Ae)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return ve.finally(Ee)}}}e.createCancelablePromise=y;function L(te,J,fe){return new Promise((ve,Ee)=>{const Ae=J.onCancellationRequested(()=>{Ae.dispose(),ve(fe)});te.then(ve,Ee).finally(()=>Ae.dispose())})}e.raceCancellation=L;function P(te,J){return new Promise((fe,ve)=>{const Ee=J.onCancellationRequested(()=>{Ee.dispose(),ve(new t.CancellationError)});te.then(fe,ve).finally(()=>Ee.dispose())})}e.raceCancellationError=P;async function v(te){let J=-1;const fe=te.map((Ee,Ae)=>Ee.then(Fe=>(J=Ae,Fe))),ve=await Promise.race(fe);return te.forEach((Ee,Ae)=>{Ae!==J&&Ee.cancel()}),ve}e.raceCancellablePromises=v;function D(te,J,fe){let ve;const Ee=setTimeout(()=>{ve?.(void 0),fe?.()},J);return Promise.race([te.finally(()=>clearTimeout(Ee)),new Promise(Ae=>ve=Ae)])}e.raceTimeout=D;function E(te){return new Promise((J,fe)=>{const ve=te();S(ve)?ve.then(J,fe):J(ve)})}e.asPromise=E;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(J){if(this.a){if(this.d=J,!this.b){const fe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(fe,fe).then(ve)})}return new Promise((fe,ve)=>{this.b.then(fe,ve)})}return this.a=J(),new Promise((fe,ve)=>{this.a.then(Ee=>{this.a=null,fe(Ee)},Ee=>{this.a=null,ve(Ee)})})}}e.Throttler=d;class m{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.Sequencer=m;class h{constructor(){this.a=new Map}queue(J,fe){const Ee=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(fe).finally(()=>{this.a.get(J)===Ee&&this.a.delete(J)});return this.a.set(J,Ee),Ee}}e.SequencerByKey=h;const b=(te,J)=>{let fe=!0;const ve=setTimeout(()=>{fe=!1,J()},te);return{isTriggered:()=>fe,dispose:()=>{clearTimeout(ve),fe=!1}}},p=te=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,te())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,fe=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((Ee,Ae)=>{this.d=Ee,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const Ee=this.g;return this.g=null,Ee()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=fe===e.MicrotaskDelay?p(ve):b(fe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=g;class w{constructor(J){this.a=new g(J),this.b=new d}trigger(J,fe){return this.a.trigger(()=>this.b.queue(J),fe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class i{constructor(){this.a=!1,this.b=new Promise((J,fe)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class o extends i{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=o;function u(te,J){return J?new Promise((fe,ve)=>{const Ee=setTimeout(()=>{Ae.dispose(),fe()},te),Ae=J.onCancellationRequested(()=>{clearTimeout(Ee),Ae.dispose(),ve(new t.CancellationError)})}):y(fe=>u(te,fe))}e.timeout=u;function l(te,J=0){const fe=setTimeout(te,J);return(0,A.toDisposable)(()=>clearTimeout(fe))}e.disposableTimeout=l;function s(te){const J=[];let fe=0;const ve=te.length;function Ee(){return fe<ve?te[fe++]():null}function Ae(Fe){Fe!=null&&J.push(Fe);const se=Ee();return se?se.then(Ae):Promise.resolve(J)}return Promise.resolve(null).then(Ae)}e.sequence=s;function a(te,J=ve=>!!ve,fe=null){let ve=0;const Ee=te.length,Ae=()=>{if(ve>=Ee)return Promise.resolve(fe);const Fe=te[ve++];return Promise.resolve(Fe()).then(le=>J(le)?Promise.resolve(le):Ae())};return Ae()}e.first=a;function n(te,J=ve=>!!ve,fe=null){if(te.length===0)return Promise.resolve(fe);let ve=te.length;const Ee=()=>{ve=-1;for(const Ae of te)Ae.cancel?.()};return new Promise((Ae,Fe)=>{for(const se of te)se.then(le=>{--ve>=0&&J(le)?(Ee(),Ae(le)):ve===0&&Ae(fe)}).catch(le=>{--ve>=0&&(Ee(),Fe(le))})})}e.firstParallel=n;class r{constructor(J){this.a=0,this.d=J,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(J){return this.a++,new Promise((fe,ve)=>{this.f.push({factory:J,c:fe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const J=this.f.shift();this.b++;const fe=J.factory();fe.then(J.c,J.e),fe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=r;class f extends r{constructor(){super(1)}}e.Queue=f;class I{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const J=new x;return this.b.add(J),J.p}d(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,fe=C.extUri){const ve=fe.getComparisonKey(J);let Ee=this.a.get(ve);return Ee||(Ee=new f,k.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,Ee)),Ee}f(){!this.d()||this.g()}g(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.g()}}e.ResourceQueue=I;class R{constructor(J,fe){this.a=-1,typeof J=="function"&&typeof fe=="number"&&this.setIfNotSet(J,fe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,fe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},fe)}setIfNotSet(J,fe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},fe))}}e.TimeoutTimer=R;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(J,fe){this.cancel(),this.a=setInterval(()=>{J()},fe)}}e.IntervalTimer=B;class X{constructor(J,fe){this.b=-1,this.a=J,this.d=fe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=X;class q{constructor(J,fe){fe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${fe}ms is not a multiple of 1000ms.`),this.a=J,this.b=fe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=q;class N extends X{constructor(J,fe){super(J,fe),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=N;class M extends A.Disposable{constructor(J,fe){super(),this.g=J,this.h=fe,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const fe of J)this.a.push(fe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=te=>{(0,T.setTimeout0)(()=>{if(J)return;const fe=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.runWhenIdle=(te,J)=>{const fe=requestIdleCallback(te,typeof J=="number"?{timeout:J}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(fe))}}}}();class F{constructor(J){this.d=!1,this.a=()=>{try{this.f=J()}catch(fe){this.g=fe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function z(te,J,fe){let ve;for(let Ee=0;Ee<fe;Ee++)try{return await te()}catch(Ae){ve=Ae,await u(J)}throw ve}e.retry=z;class U{hasPending(J){return this.a?typeof J=="number"?this.a.taskId===J:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(J,fe,ve){return this.a={taskId:J,cancel:()=>ve?.(),promise:fe},fe.then(()=>this.d(J),()=>this.d(J)),fe}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}setNext(J){if(this.b)this.b.run=J;else{let fe,ve;const Ee=new Promise((Ae,Fe)=>{fe=Ae,ve=Fe});this.b={run:J,promise:Ee,promiseResolve:fe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=U;class H{constructor(J,fe=()=>Date.now()){this.d=J,this.f=fe,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.IntervalCounter=H;class x{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((J,fe)=>{this.a=J,this.b=fe})}complete(J){return new Promise(fe=>{this.a(J),this.f=!0,fe()})}error(J){return new Promise(fe=>{this.b(J),this.d=!0,fe()})}cancel(){new Promise(J=>{this.b(new t.CancellationError),this.d=!0,J()})}}e.DeferredPromise=x;var V;(function(te){async function J(ve){let Ee;const Ae=await Promise.all(ve.map(Fe=>Fe.then(se=>se,se=>{Ee||(Ee=se)})));if(typeof Ee<"u")throw Ee;return Ae}te.settled=J;function fe(ve){return new Promise(async(Ee,Ae)=>{try{await ve(Ee,Ae)}catch(Fe){Ae(Fe)}})}te.withAsyncBody=fe})(V=e.Promises||(e.Promises={}));var _;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(_||(_={}));class Q{static fromArray(J){return new Q(fe=>{fe.emitMany(J)})}static fromPromise(J){return new Q(async fe=>{fe.emitMany(await J)})}static fromPromises(J){return new Q(async fe=>{await Promise.all(J.map(async ve=>fe.emitOne(await ve)))})}static merge(J){return new Q(async fe=>{await Promise.all(J.map(async ve=>{for await(const Ee of ve)fe.emitOne(Ee)}))})}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const fe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(J(fe)),this.j()}catch(ve){this.k(ve)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(J,fe){return new Q(async ve=>{for await(const Ee of J)ve.emitOne(fe(Ee))})}map(J){return Q.map(this,J)}static filter(J,fe){return new Q(async ve=>{for await(const Ee of J)fe(Ee)&&ve.emitOne(Ee)})}filter(J){return Q.filter(this,J)}static coalesce(J){return Q.filter(J,fe=>!!fe)}coalesce(){return Q.coalesce(this)}static async toPromise(J){const fe=[];for await(const ve of J)fe.push(ve);return fe}toPromise(){return Q.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.AsyncIterableObject=Q,Q.EMPTY=Q.fromArray([]);class Z extends Q{constructor(J,fe){super(fe),this.l=J}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Z;function ge(te){const J=new c.CancellationTokenSource,fe=te(J.token);return new Z(J,async ve=>{const Ee=J.token.onCancellationRequested(()=>{Ee.dispose(),J.dispose(),ve.reject(new t.CancellationError)});try{for await(const Ae of fe){if(J.token.isCancellationRequested)return;ve.emitOne(Ae)}Ee.dispose(),J.dispose()}catch(Ae){Ee.dispose(),J.dispose(),ve.reject(Ae)}})}e.createCancelableAsyncIterable=ge}),define(ye[109],Ce([1,0,18,9]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new c.IdleValue(()=>{const r=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:r,collatorIsNumeric:r.resolvedOptions().numeric}}),A=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(r,f,I=!1){const R=r||"",B=f||"",X=k.value.collator.compare(R,B);return k.value.collatorIsNumeric&&X===0&&R!==B?R<B?-1:1:X}e.compareFileNames=T;function S(r,f){const I=A.value.collator;return r=r||"",f=f||"",g(I,r,f)}e.compareFileNamesDefault=S;function y(r,f){const I=A.value.collator;return r=r||"",f=f||"",u(r,f)||g(I,r,f)}e.compareFileNamesUpper=y;function L(r,f){const I=A.value.collator;return r=r||"",f=f||"",o(r,f)||g(I,r,f)}e.compareFileNamesLower=L;function P(r,f){return r=r||"",f=f||"",r===f?0:r<f?-1:1}e.compareFileNamesUnicode=P;function v(r,f){const[I,R]=b(r),[B,X]=b(f);let q=k.value.collator.compare(R,X);if(q===0){if(k.value.collatorIsNumeric&&R!==X)return R<X?-1:1;if(q=k.value.collator.compare(I,B),k.value.collatorIsNumeric&&q===0&&I!==B)return I<B?-1:1}return q}e.compareFileExtensions=v;function D(r,f){r=r||"",f=f||"";const I=p(r),R=p(f),B=A.value.collator,X=C.value.collator;return g(X,I,R)||g(B,r,f)}e.compareFileExtensionsDefault=D;function E(r,f){r=r||"",f=f||"";const I=p(r),R=p(f),B=A.value.collator,X=C.value.collator;return g(X,I,R)||u(r,f)||g(B,r,f)}e.compareFileExtensionsUpper=E;function d(r,f){r=r||"",f=f||"";const I=p(r),R=p(f),B=A.value.collator,X=C.value.collator;return g(X,I,R)||o(r,f)||g(B,r,f)}e.compareFileExtensionsLower=d;function m(r,f){r=r||"",f=f||"";const I=p(r).toLowerCase(),R=p(f).toLowerCase();return I!==R?I<R?-1:1:r!==f?r<f?-1:1:0}e.compareFileExtensionsUnicode=m;const h=/^(.*?)(\.([^.]*))?$/;function b(r,f=!1){const I=r?h.exec(r):[];let R=[I&&I[1]||"",I&&I[3]||""];return f&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function p(r){const f=r?h.exec(r):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function g(r,f,I){const R=r.compare(f,I);return R!==0?R:f.length!==I.length?f.length<I.length?-1:1:0}function w(r){const f=r.charAt(0);return f.toLocaleUpperCase()!==f}function i(r){const f=r.charAt(0);return f.toLocaleLowerCase()!==f}function o(r,f){return w(r)&&i(f)?-1:i(r)&&w(f)?1:0}function u(r,f){return i(r)&&w(f)?-1:w(r)&&i(f)?1:0}function l(r,f,I=!1){return I||(r=r&&r.toLowerCase(),f=f&&f.toLowerCase()),r===f?0:r<f?-1:1}function s(r,f,I=!1){const R=r.split(t.sep),B=f.split(t.sep),X=R.length-1,q=B.length-1;let N,M;for(let F=0;;F++){if(N=X===F,M=q===F,N&&M)return T(R[F],B[F],I);if(N)return-1;if(M)return 1;const z=l(R[F],B[F],I);if(z!==0)return z}}e.comparePaths=s;function a(r,f,I){const R=r.toLowerCase(),B=f.toLowerCase(),X=n(r,f,I);if(X)return X;const q=R.endsWith(I),N=B.endsWith(I);if(q!==N)return q?-1:1;const M=T(R,B);return M!==0?M:R.localeCompare(B)}e.compareAnything=a;function n(r,f,I){const R=r.toLowerCase(),B=f.toLowerCase(),X=R.startsWith(I),q=B.startsWith(I);if(X!==q)return X?-1:1;if(X&&q){if(R.length<B.length)return-1;if(R.length>B.length)return 1}return 0}e.compareByPrefix=n}),define(ye[110],Ce([1,0,109,108,85,9,12,8]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,y=[S,[]];function L(U,H,x,V){if(!U||!H)return y;const _=U.length,Q=H.length;if(_<Q)return y;const Z=U.toLowerCase();return P(H,x,Q,U,Z,_,V)}e.scoreFuzzy=L;function P(U,H,x,V,_,Q,Z){const ge=[],te=[];for(let Ee=0;Ee<x;Ee++){const Ae=Ee*Q,Fe=Ae-Q,se=Ee>0,le=U[Ee],ue=H[Ee];for(let ee=0;ee<Q;ee++){const ae=ee>0,ie=Ae+ee,O=ie-1,W=Fe+ee-1,K=ae?ge[O]:0,Y=se&&ae?ge[W]:0,de=se&&ae?te[W]:0;let be;!Y&&se?be=0:be=v(le,ue,V,_,ee,de),be&&Y+be>=K&&(Z||se||_.startsWith(H,ee))?(te[ie]=de+1,ge[ie]=Y+be):(te[ie]=S,ge[ie]=K)}}const J=[];let fe=x-1,ve=Q-1;for(;fe>=0&&ve>=0;){const Ee=fe*Q+ve;te[Ee]===S||(J.push(ve),fe--),ve--}return[ge[x*Q-1],J.reverse()]}function v(U,H,x,V,_,Q){let Z=0;if(!D(H,V[_]))return Z;if(Z+=1,Q>0&&(Z+=Q*5),U===x[_]&&(Z+=1),_===0)Z+=8;else{const ge=E(x.charCodeAt(_-1));ge?Z+=ge:(0,t.isUpper)(x.charCodeAt(_))&&Q===0&&(Z+=2)}return Z}function D(U,H){return U===H?!0:U==="/"||U==="\\"?H==="/"||H==="\\":!1}function E(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function m(U,H,x=0,V=0){const _=H;return _.values&&_.values.length>1?h(U,_.values,x,V):b(U,H,x,V)}e.scoreFuzzy2=m;function h(U,H,x,V){let _=0;const Q=[];for(const Z of H){const[ge,te]=b(U,Z,x,V);if(typeof ge!="number")return d;_+=ge,Q.push(...te)}return[_,r(Q)]}function b(U,H,x,V){const _=(0,t.fuzzyScore)(H.original,H.originalLowercase,x,U,U.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?[_[0],(0,t.createMatches)(_)]:d}const p=Object.freeze({score:0}),g=1<<18,w=1<<17,i=1<<16;function o(U,H,x,V){const _=V.values?V.values:[V];return(0,k.hash)({[V.normalized]:{values:_.map(Z=>({value:Z.normalized,expectContiguousMatch:Z.expectContiguousMatch})),label:U,description:H,allowNonContiguousMatches:x}})}function u(U,H,x,V,_){if(!U||!H.normalized)return p;const Q=V.getItemLabel(U);if(!Q)return p;const Z=V.getItemDescription(U),ge=o(Q,Z,x,H),te=_[ge];if(te)return te;const J=l(Q,Z,V.getItemPath(U),H,x);return _[ge]=J,J}e.scoreItemFuzzy=u;function l(U,H,x,V,_){const Q=!x||!V.containsPathSeparator;return x&&(C.isLinux?V.pathNormalized===x:(0,T.equalsIgnoreCase)(V.pathNormalized,x))?{score:g,labelMatch:[{start:0,end:U.length}],descriptionMatch:H?[{start:0,end:H.length}]:void 0}:V.values&&V.values.length>1?s(U,H,x,V.values,Q,_):a(U,H,x,V,Q,_)}function s(U,H,x,V,_,Q){let Z=0;const ge=[],te=[];for(const J of V){const{score:fe,labelMatch:ve,descriptionMatch:Ee}=a(U,H,x,J,_,Q);if(fe===S)return p;Z+=fe,ve&&ge.push(...ve),Ee&&te.push(...Ee)}return{score:Z,labelMatch:r(ge),descriptionMatch:r(te)}}function a(U,H,x,V,_,Q){if(_||!H){const[Z,ge]=L(U,V.normalized,V.normalizedLowercase,Q&&!V.expectContiguousMatch);if(Z){const te=(0,t.matchesPrefix)(V.normalized,U);let J;return te?(J=w,J+=Math.round(V.normalized.length/U.length*100)):J=i,{score:J+Z,labelMatch:te||n(ge)}}}if(H){let Z=H;x&&(Z=`${H}${A.sep}`);const ge=Z.length,te=`${Z}${U}`,[J,fe]=L(te,V.normalized,V.normalizedLowercase,Q&&!V.expectContiguousMatch);if(J){const ve=n(fe),Ee=[],Ae=[];return ve.forEach(Fe=>{Fe.start<ge&&Fe.end>ge?(Ee.push({start:0,end:Fe.end-ge}),Ae.push({start:Fe.start,end:ge})):Fe.start>=ge?Ee.push({start:Fe.start-ge,end:Fe.end-ge}):Ae.push(Fe)}),{score:J,labelMatch:Ee,descriptionMatch:Ae}}}return p}function n(U){const H=[];if(!U)return H;let x;for(const V of U)x&&x.end===V?x.end+=1:(x={start:V,end:V+1},H.push(x));return H}function r(U){const H=U.sort((_,Q)=>_.start-Q.start),x=[];let V;for(const _ of H)!V||!f(V,_)?(V=_,x.push(_)):(V.start=Math.min(V.start,_.start),V.end=Math.max(V.end,_.end));return x}function f(U,H){return!(U.end<H.start||H.end<U.start)}function I(U,H,x,V,_,Q){const Z=u(U,x,V,_,Q),ge=u(H,x,V,_,Q),te=Z.score,J=ge.score;if((te===g||J===g)&&te!==J)return te===g?-1:1;if(te>i||J>i){if(te!==J)return te>J?-1:1;if(te<w&&J<w){const le=B(Z.labelMatch,ge.labelMatch);if(le!==0)return le}const Fe=_.getItemLabel(U)||"",se=_.getItemLabel(H)||"";if(Fe.length!==se.length)return Fe.length-se.length}if(te!==J)return te>J?-1:1;const fe=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0,ve=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(fe&&!ve)return-1;if(ve&&!fe)return 1;const Ee=R(U,Z,_),Ae=R(H,ge,_);return Ee&&Ae&&Ee!==Ae?Ae>Ee?-1:1:X(U,H,x,_)}e.compareItemsByFuzzyScore=I;function R(U,H,x){let V=-1,_=-1;if(H.descriptionMatch&&H.descriptionMatch.length?V=H.descriptionMatch[0].start:H.labelMatch&&H.labelMatch.length&&(V=H.labelMatch[0].start),H.labelMatch&&H.labelMatch.length){if(_=H.labelMatch[H.labelMatch.length-1].end,H.descriptionMatch&&H.descriptionMatch.length){const Q=x.getItemDescription(U);Q&&(_+=Q.length)}}else H.descriptionMatch&&H.descriptionMatch.length&&(_=H.descriptionMatch[H.descriptionMatch.length-1].end);return _-V}function B(U,H){if(!U&&!H||(!U||!U.length)&&(!H||!H.length))return 0;if(!H||!H.length)return-1;if(!U||!U.length)return 1;const x=U[0].start,_=U[U.length-1].end-x,Q=H[0].start,ge=H[H.length-1].end-Q;return _===ge?0:ge<_?1:-1}function X(U,H,x,V){const _=V.getItemLabel(U)||"",Q=V.getItemLabel(H)||"",Z=V.getItemDescription(U),ge=V.getItemDescription(H),te=_.length+(Z?Z.length:0),J=Q.length+(ge?ge.length:0);if(te!==J)return te-J;const fe=V.getItemPath(U),ve=V.getItemPath(H);return fe&&ve&&fe.length!==ve.length?fe.length-ve.length:_!==Q?(0,c.compareAnything)(_,Q,x.normalized):Z&&ge&&Z!==ge?(0,c.compareAnything)(Z,ge,x.normalized):fe&&ve&&fe!==ve?(0,c.compareAnything)(fe,ve,x.normalized):0}function q(U){return U.startsWith('"')&&U.endsWith('"')}const N=" ";function M(U){typeof U!="string"&&(U="");const H=U.toLowerCase(),{pathNormalized:x,normalized:V,normalizedLowercase:_}=F(U),Q=x.indexOf(A.sep)>=0,Z=q(U);let ge;const te=U.split(N);if(te.length>1)for(const J of te){const fe=q(J),{pathNormalized:ve,normalized:Ee,normalizedLowercase:Ae}=F(J);Ee&&(ge||(ge=[]),ge.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:ve,normalized:Ee,normalizedLowercase:Ae,expectContiguousMatch:fe}))}return{original:U,originalLowercase:H,pathNormalized:x,normalized:V,normalizedLowercase:_,values:ge,containsPathSeparator:Q,expectContiguousMatch:Z}}e.prepareQuery=M;function F(U){let H;C.isWindows?H=U.replace(/\//g,A.sep):H=U.replace(/\\/g,A.sep);const x=(0,T.stripWildcards)(H).replace(/\s|"/g,"");return{pathNormalized:H,normalized:x,normalizedLowercase:x.toLowerCase()}}function z(U){return Array.isArray(U)?M(U.map(H=>H.original).join(N)):M(U.original)}e.pieceToQuery=z}),define(ye[37],Ce([1,0,17,18,32,28,9,12,8]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",P="[^/\\\\]",v=/\//g;function D(x,V){switch(x){case 0:return"";case 1:return`${P}*?`;default:return`(?:${L}|${P}+${L}${V?`|${L}${P}+`:""})*?`}}function E(x,V){if(!x)return[];const _=[];let Q=!1,Z=!1,ge="";for(const te of x){switch(te){case V:if(!Q&&!Z){_.push(ge),ge="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}ge+=te}return ge&&_.push(ge),_}e.splitGlobAware=E;function d(x){if(!x)return"";let V="";const _=E(x,e.GLOB_SPLIT);if(_.every(Q=>Q===e.GLOBSTAR))V=".*";else{let Q=!1;_.forEach((Z,ge)=>{if(Z===e.GLOBSTAR){if(Q)return;V+=D(2,ge===_.length-1)}else{let te=!1,J="",fe=!1,ve="";for(const Ee of Z){if(Ee!=="}"&&te){J+=Ee;continue}if(fe&&(Ee!=="]"||!ve)){let Ae;Ee==="-"?Ae=Ee:(Ee==="^"||Ee==="!")&&!ve?Ae="^":Ee===e.GLOB_SPLIT?Ae="":Ae=(0,S.escapeRegExpCharacters)(Ee),ve+=Ae;continue}switch(Ee){case"{":te=!0;continue;case"[":fe=!0;continue;case"}":{V+=`(?:${E(J,",").map(se=>d(se)).join("|")})`,te=!1,J="";break}case"]":{V+="["+ve+"]",fe=!1,ve="";break}case"?":V+=P;continue;case"*":V+=D(1);continue;default:V+=(0,S.escapeRegExpCharacters)(Ee)}}ge<_.length-1&&(_[ge+1]!==e.GLOBSTAR||ge+2<_.length)&&(V+=L)}Q=Z===e.GLOBSTAR})}return V}const m=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.LRUCache(1e4),o=function(){return!1},u=function(){return null};function l(x,V){if(!x)return u;let _;typeof x!="string"?_=x.pattern:_=x,_=_.trim();const Q=`${_}_${!!V.trimForExclusions}`;let Z=i.get(Q);if(Z)return s(Z,x);let ge;return m.test(_)?Z=n(_.substr(4),_):(ge=h.exec(a(_,V)))?Z=r(ge[1],_):(V.trimForExclusions?p:b).test(_)?Z=f(_,V):(ge=g.exec(a(_,V)))?Z=I(ge[1].substr(1),_,!0):(ge=w.exec(a(_,V)))?Z=I(ge[1],_,!1):Z=R(_),i.set(Q,Z),s(Z,x)}function s(x,V){if(typeof V=="string")return x;const _=function(Q,Z){return(0,k.isEqualOrParent)(Q,V.base,!T.isLinux)?x((0,S.ltrim)(Q.substr(V.base.length),C.sep),Z):null};return _.allBasenames=x.allBasenames,_.allPaths=x.allPaths,_.basenames=x.basenames,_.patterns=x.patterns,_}function a(x,V){return V.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function n(x,V){return function(_,Q){return typeof _=="string"&&_.endsWith(x)?V:null}}function r(x,V){const _=`/${x}`,Q=`\\${x}`,Z=function(te,J){return typeof te!="string"?null:J?J===x?V:null:te===x||te.endsWith(_)||te.endsWith(Q)?V:null},ge=[x];return Z.basenames=ge,Z.patterns=[V],Z.allBasenames=ge,Z}function f(x,V){const _=U(x.slice(1,-1).split(",").map(J=>l(J,V)).filter(J=>J!==u),x),Q=_.length;if(!Q)return u;if(Q===1)return _[0];const Z=function(J,fe){for(let ve=0,Ee=_.length;ve<Ee;ve++)if(_[ve](J,fe))return x;return null},ge=_.find(J=>!!J.allBasenames);ge&&(Z.allBasenames=ge.allBasenames);const te=_.reduce((J,fe)=>fe.allPaths?J.concat(fe.allPaths):J,[]);return te.length&&(Z.allPaths=te),Z}function I(x,V,_){const Q=C.sep===C.posix.sep,Z=Q?x:x.replace(v,C.sep),ge=C.sep+Z,te=C.posix.sep+x;let J;return _?J=function(fe,ve){return typeof fe=="string"&&(fe===Z||fe.endsWith(ge)||!Q&&(fe===x||fe.endsWith(te)))?V:null}:J=function(fe,ve){return typeof fe=="string"&&(fe===Z||!Q&&fe===x)?V:null},J.allPaths=[(_?"*/":"./")+x],J}function R(x){try{const V=new RegExp(`^${d(x)}$`);return function(_){return V.lastIndex=0,typeof _=="string"&&V.test(_)?x:null}}catch{return u}}function B(x,V,_){return!x||typeof V!="string"?!1:X(x)(V,void 0,_)}e.match=B;function X(x,V={}){if(!x)return o;if(typeof x=="string"||q(x)){const _=l(x,V);if(_===u)return o;const Q=function(Z,ge){return!!_(Z,ge)};return _.allBasenames&&(Q.allBasenames=_.allBasenames),_.allPaths&&(Q.allPaths=_.allPaths),Q}return F(x,V)}e.parse=X;function q(x){const V=x;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=q;function N(x){return x.allBasenames||[]}e.getBasenameTerms=N;function M(x){return x.allPaths||[]}e.getPathTerms=M;function F(x,V){const _=U(Object.getOwnPropertyNames(x).map(J=>z(J,x[J],V)).filter(J=>J!==u)),Q=_.length;if(!Q)return u;if(!_.some(J=>!!J.requiresSiblings)){if(Q===1)return _[0];const J=function(Ee,Ae){let Fe;for(let se=0,le=_.length;se<le;se++){const ue=_[se](Ee,Ae);if(typeof ue=="string")return ue;(0,t.isThenable)(ue)&&(Fe||(Fe=[]),Fe.push(ue))}return Fe?(async()=>{for(const se of Fe){const le=await se;if(typeof le=="string")return le}return null})():null},fe=_.find(Ee=>!!Ee.allBasenames);fe&&(J.allBasenames=fe.allBasenames);const ve=_.reduce((Ee,Ae)=>Ae.allPaths?Ee.concat(Ae.allPaths):Ee,[]);return ve.length&&(J.allPaths=ve),J}const Z=function(J,fe,ve){let Ee,Ae;for(let Fe=0,se=_.length;Fe<se;Fe++){const le=_[Fe];le.requiresSiblings&&ve&&(fe||(fe=(0,C.basename)(J)),Ee||(Ee=fe.substr(0,fe.length-(0,C.extname)(J).length)));const ue=le(J,fe,Ee,ve);if(typeof ue=="string")return ue;(0,t.isThenable)(ue)&&(Ae||(Ae=[]),Ae.push(ue))}return Ae?(async()=>{for(const Fe of Ae){const se=await Fe;if(typeof se=="string")return se}return null})():null},ge=_.find(J=>!!J.allBasenames);ge&&(Z.allBasenames=ge.allBasenames);const te=_.reduce((J,fe)=>fe.allPaths?J.concat(fe.allPaths):J,[]);return te.length&&(Z.allPaths=te),Z}function z(x,V,_){if(V===!1)return u;const Q=l(x,_);if(Q===u)return u;if(typeof V=="boolean")return Q;if(V){const Z=V.when;if(typeof Z=="string"){const ge=(te,J,fe,ve)=>{if(!ve||!Q(te,J))return null;const Ee=Z.replace("$(basename)",()=>fe),Ae=ve(Ee);return(0,t.isThenable)(Ae)?Ae.then(Fe=>Fe?x:null):Ae?x:null};return ge.requiresSiblings=!0,ge}}return Q}function U(x,V){const _=x.filter(J=>!!J.basenames);if(_.length<2)return x;const Q=_.reduce((J,fe)=>{const ve=fe.basenames;return ve?J.concat(ve):J},[]);let Z;if(V){Z=[];for(let J=0,fe=Q.length;J<fe;J++)Z.push(V)}else Z=_.reduce((J,fe)=>{const ve=fe.patterns;return ve?J.concat(ve):J},[]);const ge=function(J,fe){if(typeof J!="string")return null;if(!fe){let Ee;for(Ee=J.length;Ee>0;Ee--){const Ae=J.charCodeAt(Ee-1);if(Ae===47||Ae===92)break}fe=J.substr(Ee)}const ve=Q.indexOf(fe);return ve!==-1?Z[ve]:null};ge.basenames=Q,ge.patterns=Z,ge.allBasenames=Q;const te=x.filter(J=>!J.basenames);return te.push(ge),te}function H(x,V){return(0,c.equals)(x,V,(_,Q)=>typeof _=="string"&&typeof Q=="string"?_===Q:typeof _!="string"&&typeof Q!="string"?_.base===Q.base&&_.pattern===Q.pattern:!1)}e.patternsEquals=H}),define(ye[111],Ce([1,0,10,160,24,8,2]),function(ne,e,c,t,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(h="",b=!1){if(this.value=h,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(h,b=0){return this.value+=v(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(p,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,b){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}appendLink(h,b,p){return this.value+="[",this.value+=this.c(b,"]"),this.value+="](",this.value+=this.c(String(h),")"),p&&(this.value+=` "${this.c(this.c(p,'"'),")")}"`),this.value+=")",this}c(h,b){const p=new RegExp((0,A.escapeRegExpCharacters)(b),"g");return h.replace(p,(g,w)=>h.charAt(w-1)!=="\\"?`\\${g}`:g)}}e.MarkdownString=S;function y(m){return L(m)?!m.value:Array.isArray(m)?m.every(y):!0}e.isEmptyMarkdownString=y;function L(m){return m instanceof S?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function P(m,h){return m===h?!0:!m||!h?!1:m.value===h.value&&m.isTrusted===h.isTrusted&&m.supportThemeIcons===h.supportThemeIcons&&m.supportHtml===h.supportHtml&&(m.baseUri===h.baseUri||!!m.baseUri&&!!h.baseUri&&(0,k.isEqual)(C.URI.from(m.baseUri),C.URI.from(h.baseUri)))}e.markdownStringEqual=P;function v(m){return m.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function D(m){return m.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=D;function E(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=E;function d(m){const h=[],b=m.split("|").map(g=>g.trim());m=b[0];const p=b[1];if(p){const g=/height=(\d+)/.exec(p),w=/width=(\d+)/.exec(p),i=g?g[1]:"",o=w?w[1]:"",u=isFinite(parseInt(o)),l=isFinite(parseInt(i));u&&h.push(`width="${o}"`),l&&h.push(`height="${i}"`)}return{href:m,dimensions:h}}e.parseHrefAndDimensions=d}),define(ye[112],Ce([1,0,17,32,9,12,24,8]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(u,l){const{os:s,tildify:a,relative:n}=l;if(n){const I=y(u,n,s);if(typeof I=="string")return I}let r=u.fsPath;if(s===1&&!A.isWindows?r=r.replace(/\//g,"\\"):s!==1&&A.isWindows&&(r=r.replace(/\\/g,"/")),s!==1&&a?.userHome){const I=a.userHome.fsPath;let R;u.scheme!==a.userHome.scheme&&u.path.startsWith(k.posix.sep)?R=a.userHome.with({path:u.path}).fsPath:R=u.fsPath,r=v(R,I,s)}return(s===1?k.win32:k.posix).normalize(L(r,s===1))}e.getPathLabel=S;function y(u,l,s){const a=s===1?k.win32:k.posix,n=s===3?C.extUri:C.extUriIgnorePathCase,r=l.getWorkspace(),f=(0,c.firstOrDefault)(r.folders);if(!f)return;u.scheme!==f.uri.scheme&&u.path.startsWith(k.posix.sep)&&(u=f.uri.with({path:u.path}));const I=l.getWorkspaceFolder(u);if(!I)return;let R;if(n.isEqual(I.uri,u)?R="":R=n.relativePath(I.uri,u)??"",R&&(R=a.normalize(R)),r.folders.length>1&&!l.noPrefix){const B=I.name?I.name:n.basenameOrAuthority(I.uri);R=R?`${B} \u2022 ${R}`:B}return R}function L(u,l=A.isWindows){return(0,t.hasDriveLetter)(u,l)?u.charAt(0).toUpperCase()+u.slice(1):u}e.normalizeDriveLetter=L;let P=Object.create(null);function v(u,l,s=A.OS){if(s===1||!u||!l)return u;let a=P.original===l?P.normalized:void 0;a||(a=l,A.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,T.rtrim)(a,k.posix.sep)}${k.posix.sep}`,P={original:l,normalized:a});let n=u;return A.isWindows&&(n=(0,t.toSlashes)(n)),(s===3?n.startsWith(a):(0,T.startsWithIgnoreCase)(n,a))?`~/${n.substr(a.length)}`:u}e.tildify=v;function D(u,l){return u.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=D;const E="\u2026",d="\\\\",m="~";function h(u,l=k.sep){const s=new Array(u.length);let a=!1;for(let n=0;n<u.length;n++){const r=u[n];if(r===""){s[n]=`.${l}`;continue}if(!r){s[n]=r;continue}a=!0;let f="",I=r;I.indexOf(d)===0?(f=I.substr(0,I.indexOf(d)+d.length),I=I.substr(I.indexOf(d)+d.length)):I.indexOf(l)===0?(f=I.substr(0,I.indexOf(l)+l.length),I=I.substr(I.indexOf(l)+l.length)):I.indexOf(m)===0&&(f=I.substr(0,I.indexOf(m)+m.length),I=I.substr(I.indexOf(m)+m.length));const R=I.split(l);for(let B=1;a&&B<=R.length;B++)for(let X=R.length-B;a&&X>=0;X--){a=!1;let q=R.slice(X,X+B).join(l);for(let N=0;!a&&N<u.length;N++)if(N!==n&&u[N]&&u[N].indexOf(q)>-1){const M=X+B===R.length,F=X>0&&u[N].indexOf(l)>-1?l+q:q,z=u[N].endsWith(F);a=!M||z}if(!a){let N="";(R[0].endsWith(":")||f!=="")&&(X===1&&(X=0,B++,q=R[0]+l+q),X>0&&(N=R[0]+l),N=f+N),X>0&&(N=N+E+l),N=N+q,X+B<R.length&&(N=N+l+E),s[n]=N}}a&&(s[n]=r)}return s}e.shorten=h;var b;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function p(u,l=Object.create(null)){const s=[];let a=!1,n="";for(const r of u)if(r==="$"||a&&r==="{")n&&s.push({value:n,type:b.TEXT}),n="",a=!0;else if(r==="}"&&a){const f=l[n];if(typeof f=="string")f.length&&s.push({value:f,type:b.VARIABLE});else if(f){const I=s[s.length-1];(!I||I.type!==b.SEPARATOR)&&s.push({value:f.label,type:b.SEPARATOR})}n="",a=!1}else n+=r;return n&&!a&&s.push({value:n,type:b.TEXT}),s.filter((r,f)=>{if(r.type===b.SEPARATOR){const I=s[f-1],R=s[f+1];return[I,R].every(B=>B&&(B.type===b.VARIABLE||B.type===b.TEXT)&&B.value.length>0)}return!0}).map(r=>r.value).join("")}e.template=p;function g(u,l){return A.isMacintosh||l?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):u.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function w(u,l){return A.isMacintosh||l?u.replace(/\(&&\w\)|&&/g,""):A.isWindows?u.replace(/&&|&/g,s=>s==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function i(u){return u.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(u){const l=u.indexOf("/")!==-1?k.posix:k.win32,s=l.basename(u),a=l.dirname(u);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=o}),define(ye[113],Ce([1,0,2]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class k{constructor(P){this.a=P}transformIncoming(P){const v=this.a.transformIncoming(P);return v===P?P:t(c.URI.from(v))}transformOutgoing(P){const v=this.a.transformOutgoing(P);return v===P?P:t(c.URI.from(v))}transformOutgoingURI(P){const v=this.a.transformOutgoing(P);return v===P?P:c.URI.from(v)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function A(L,P,v){if(!L||v>200)return null;if(typeof L=="object"){if(L instanceof c.URI)return P.transformOutgoing(L);for(const D in L)if(Object.hasOwnProperty.call(L,D)){const E=A(L[D],P,v+1);E!==null&&(L[D]=E)}}return null}function C(L,P){const v=A(L,P,0);return v===null?L:v}e.transformOutgoingURIs=C;function T(L,P,v,D){if(!L||D>200)return null;if(typeof L=="object"){if(L.$mid===1)return v?c.URI.revive(P.transformIncoming(L)):P.transformIncoming(L);for(const E in L)if(Object.hasOwnProperty.call(L,E)){const d=T(L[E],P,v,D+1);d!==null&&(L[E]=d)}}return null}function S(L,P){const v=T(L,P,!1,0);return v===null?L:v}e.transformIncomingURIs=S;function y(L,P){const v=T(L,P,!0,0);return v===null?L:v}e.transformAndReviveIncomingURIs=y}),define(ye[29],Ce([1,0,65,87,309,18,32,83,9,12,24,2]),function(ne,e,c,t,k,A,C,T,S,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function D(F,z=v.UNLINK){if((0,C.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return z===v.UNLINK?d(F):E(F)}async function E(F){try{const z=(0,C.randomPath)((0,t.tmpdir)());try{await c.promises.rename(F,z)}catch(U){return U.code==="ENOENT"?void 0:d(F)}d(z).catch(U=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function d(F){return(0,k.promisify)(c.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function m(F){if((0,C.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function h(F,z){return g(await(z?b(F):(0,k.promisify)(c.readdir)(F)))}async function b(F){try{return await(0,k.promisify)(c.readdir)(F,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const z=[],U=await h(F);for(const H of U){let x=!1,V=!1,_=!1;try{const Q=await e.Promises.lstat((0,S.join)(F,H));x=Q.isFile(),V=Q.isDirectory(),_=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}z.push({name:H,isFile:()=>x,isDirectory:()=>V,isSymbolicLink:()=>_})}return z}function p(F){return g(c.readdirSync(F))}e.readdirSync=p;function g(F){return F.map(z=>typeof z=="string"?y.isMacintosh?(0,T.normalizeNFC)(z):z:(z.name=y.isMacintosh?(0,T.normalizeNFC)(z.name):z.name,z))}async function w(F){const z=await h(F),U=[];for(const H of z)await o.existsDirectory((0,S.join)(F,H))&&U.push(H);return U}function i(F,z=1e3){return new Promise(U=>{let H=!1;const x=setInterval(()=>{H||(H=!0,c.access(F,V=>{H=!1,V&&(clearInterval(x),U(void 0))}))},z)})}e.whenDeleted=i;var o;(function(F){async function z(x){let V;try{if(V=await e.Promises.lstat(x),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(y.isWindows&&_.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw Q}throw _}}F.stat=z;async function U(x){try{const{stat:V,symbolicLink:_}=await F.stat(x);return V.isFile()&&_?.dangling!==!0}catch{}return!1}F.existsFile=U;async function H(x){try{const{stat:V,symbolicLink:_}=await F.stat(x);return V.isDirectory()&&_?.dangling!==!0}catch{}return!1}F.existsDirectory=H})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const u=new A.ResourceQueue;function l(F,z,U){return u.queueFor(P.URI.file(F),L.extUriBiasedIgnorePathCase).queue(()=>{const H=f(U);return new Promise((x,V)=>n(F,z,H,_=>_?V(_):x()))})}let s=!0;function a(F){s=F}e.configureFlushOnWrite=a;function n(F,z,U,H){if(!s)return c.writeFile(F,z,{mode:U.mode,flag:U.flag},H);c.open(F,U.flag,U.mode,(x,V)=>{if(x)return H(x);c.writeFile(V,z,_=>{if(_)return c.close(V,()=>H(_));c.fdatasync(V,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),a(!1)),c.close(V,Z=>H(Z))))})})}function r(F,z,U){const H=f(U);if(!s)return c.writeFileSync(F,z,{mode:H.mode,flag:H.flag});const x=c.openSync(F,H.flag,H.mode);try{c.writeFileSync(x,z);try{c.fdatasyncSync(x)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),a(!1)}}finally{c.closeSync(x)}}e.writeFileSync=r;function f(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function I(F,z){if(F!==z)try{await e.Promises.rename(F,z)}catch(U){if(F.toLowerCase()!==z.toLowerCase()&&U.code==="EXDEV"||F.endsWith("."))await R(F,z,{preserveSymlinks:!1}),await D(F,v.MOVE);else throw U}}async function R(F,z,U){return X(F,z,{root:{source:F,target:z},options:U,handledSourcePaths:new Set})}const B=511;async function X(F,z,U){if(U.handledSourcePaths.has(F))return;U.handledSourcePaths.add(F);const{stat:H,symbolicLink:x}=await o.stat(F);if(x){if(U.options.preserveSymlinks)try{return await M(F,z,U)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(x.dangling)return}return H.isDirectory()?q(F,z,H.mode&B,U):N(F,z,H.mode&B)}async function q(F,z,U,H){await e.Promises.mkdir(z,{recursive:!0,mode:U});const x=await h(F);for(const V of x)await X((0,S.join)(F,V),(0,S.join)(z,V),H)}async function N(F,z,U){await e.Promises.copyFile(F,z),await e.Promises.chmod(z,U)}async function M(F,z,U){let H=await e.Promises.readlink(F);(0,C.isEqualOrParent)(H,U.root.source,!y.isLinux)&&(H=(0,S.join)(U.root.target,H.substr(U.root.source.length+1))),await e.Promises.symlink(H,z)}e.Promises=new class{get access(){return(0,k.promisify)(c.access)}get stat(){return(0,k.promisify)(c.stat)}get lstat(){return(0,k.promisify)(c.lstat)}get utimes(){return(0,k.promisify)(c.utimes)}get read(){return(F,z,U,H,x)=>new Promise((V,_)=>{c.read(F,z,U,H,x,(Q,Z,ge)=>Q?_(Q):V({bytesRead:Z,buffer:ge}))})}get readFile(){return(0,k.promisify)(c.readFile)}get write(){return(F,z,U,H,x)=>new Promise((V,_)=>{c.write(F,z,U,H,x,(Q,Z,ge)=>Q?_(Q):V({bytesWritten:Z,buffer:ge}))})}get appendFile(){return(0,k.promisify)(c.appendFile)}get fdatasync(){return(0,k.promisify)(c.fdatasync)}get truncate(){return(0,k.promisify)(c.truncate)}get rename(){return(0,k.promisify)(c.rename)}get copyFile(){return(0,k.promisify)(c.copyFile)}get open(){return(0,k.promisify)(c.open)}get close(){return(0,k.promisify)(c.close)}get symlink(){return(0,k.promisify)(c.symlink)}get readlink(){return(0,k.promisify)(c.readlink)}get chmod(){return(0,k.promisify)(c.chmod)}get mkdir(){return(0,k.promisify)(c.mkdir)}get unlink(){return(0,k.promisify)(c.unlink)}get rmdir(){return(0,k.promisify)(c.rmdir)}get realpath(){return(0,k.promisify)(c.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return w}get writeFile(){return l}get rm(){return D}get move(){return I}get copy(){return R}}}),define(ye[114],Ce([1,0,65,9,12,8,29]),function(ne,e,c,t,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(v){if(k.isLinux)return v;const D=(0,t.dirname)(v);if(v===D)return v;const E=((0,t.basename)(v)||v).toLowerCase();try{const m=(0,C.readdirSync)(D).filter(h=>h.toLowerCase()===E);if(m.length===1){const h=T(D);if(h)return(0,t.join)(h,m[0])}else if(m.length>1){const h=m.indexOf(E);if(h>=0){const b=T(D);if(b)return(0,t.join)(b,m[h])}}}catch{}return null}e.realcaseSync=T;async function S(v){if(k.isLinux)return v;const D=(0,t.dirname)(v);if(v===D)return v;const E=((0,t.basename)(v)||v).toLowerCase();try{const m=(await C.Promises.readdir(D)).filter(h=>h.toLowerCase()===E);if(m.length===1){const h=await S(D);if(h)return(0,t.join)(h,m[0])}else if(m.length>1){const h=m.indexOf(E);if(h>=0){const b=await S(D);if(b)return(0,t.join)(b,m[h])}}}catch{}return null}e.realcase=S;async function y(v){try{return await C.Promises.realpath(v)}catch{const E=P(v);return await C.Promises.access(E,c.constants.R_OK),E}}e.realpath=y;function L(v){try{return c.realpathSync(v)}catch{const E=P(v);return c.accessSync(E,c.constants.R_OK),E}}e.realpathSync=L;function P(v){return(0,A.rtrim)((0,t.normalize)(v),t.sep)}}),define(ye[115],Ce([1,0,9,12,36,107,11,29]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(P=k.env){return P.comspec||"cmd.exe"}e.getWindowsShell=S;function y(P){let v=[],D=!1;const E=function(d){if(D){v.push(d);return}(!P.send(d,h=>{if(h&&console.error(h),D=!1,v.length>0){const b=v.slice(0);v=[],b.forEach(p=>E(p))}})||t.isWindows)&&(D=!0)};return{send:E}}e.createQueuedSender=y;var L;(function(P){async function v(D,E,d){if(c.isAbsolute(D))return D;if(E===void 0&&(E=k.cwd()),c.dirname(D)!=="."||(d===void 0&&C.isString(k.env.PATH)&&(d=k.env.PATH.split(c.delimiter)),d===void 0||d.length===0))return c.join(E,D);async function h(b){if(await T.Promises.exists(b)){let p;try{p=await T.Promises.stat(b)}catch(g){g.message.startsWith("EACCES")&&(p=await T.Promises.lstat(b))}return p?!p.isDirectory():!1}return!1}for(const b of d){let p;if(c.isAbsolute(b)?p=c.join(b,D):p=c.join(E,b,D),await h(p))return p;let g=p+".com";if(await h(g)||(g=p+".exe",await h(g)))return g}return c.join(E,D)}P.findExecutable=v})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(ne,e,c,t){var k=arguments.length,A=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,c):t,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ne,e,c,t);else for(var T=ne.length-1;T>=0;T--)(C=ne[T])&&(A=(k<3?C(A):k>3?C(e,c,A):C(e,c))||A);return k>3&&A&&Object.defineProperty(e,c,A),A};define(ye[116],Ce([1,0,17,18,22,21,60,10,4,6,86,8,11]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var D;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(D||(D={}));function E(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(d||(d={}));function m(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(h||(h={}));function b(V){let _=0;for(let Q=0;;Q+=7){const Z=V.read(1);if(_|=(Z.buffer[0]&127)<<Q,!(Z.buffer[0]&128))return _}}const p=u(0);function g(V,_){if(_===0){V.write(p);return}let Q=0;for(let ge=_;ge!==0;ge=ge>>>7)Q++;const Z=k.VSBuffer.alloc(Q);for(let ge=0;_!==0;ge++)Z.buffer[ge]=_&127,_=_>>>7,_>0&&(Z.buffer[ge]|=128);V.write(Z)}class w{constructor(_){this.b=_,this.a=0}read(_){const Q=this.b.slice(this.a,this.a+_);return this.a+=Q.byteLength,Q}}e.BufferReader=w;class i{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(_){this.a.push(_)}}e.BufferWriter=i;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function u(V){const _=k.VSBuffer.alloc(1);return _.writeUInt8(V,0),_}const l={Undefined:u(o.Undefined),String:u(o.String),Buffer:u(o.Buffer),VSBuffer:u(o.VSBuffer),Array:u(o.Array),Object:u(o.Object),Uint:u(o.Int)},s=typeof Buffer<"u";function a(V,_){if(typeof _>"u")V.write(l.Undefined);else if(typeof _=="string"){const Q=k.VSBuffer.fromString(_);V.write(l.String),g(V,Q.byteLength),V.write(Q)}else if(s&&Buffer.isBuffer(_)){const Q=k.VSBuffer.wrap(_);V.write(l.Buffer),g(V,Q.byteLength),V.write(Q)}else if(_ instanceof k.VSBuffer)V.write(l.VSBuffer),g(V,_.byteLength),V.write(_);else if(Array.isArray(_)){V.write(l.Array),g(V,_.length);for(const Q of _)a(V,Q)}else if(typeof _=="number"&&(_|0)===_)V.write(l.Uint),g(V,_);else{const Q=k.VSBuffer.fromString(JSON.stringify(_));V.write(l.Object),g(V,Q.byteLength),V.write(Q)}}e.serialize=a;function n(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(b(V)).toString();case o.Buffer:return V.read(b(V)).buffer;case o.VSBuffer:return V.read(b(V));case o.Array:{const Q=b(V),Z=[];for(let ge=0;ge<Q;ge++)Z.push(n(V));return Z}case o.Object:return JSON.parse(V.read(b(V)).toString());case o.Int:return b(V)}}e.deserialize=n;class r{constructor(_,Q,Z=null,ge=1e3){this.h=_,this.j=Q,this.k=Z,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(_,Q){this.b.set(_,Q),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const Q=this.o([_.type]);this.k?.logOutgoing(Q,0,1,m(_.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([_.type,_.id],_.data);this.k?.logOutgoing(Q,_.id,1,m(_.type),_.data);return}}}o(_,Q=void 0){const Z=new i;return a(Z,_),a(Z,Q),this.p(Z.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const Q=new w(_),Z=n(Q),ge=n(Q),te=Z[0];switch(te){case 100:return this.k?.logIncoming(_.byteLength,Z[1],1,`${E(te)}: ${Z[2]}.${Z[3]}`,ge),this.s({type:te,id:Z[1],channelName:Z[2],name:Z[3],arg:ge});case 102:return this.k?.logIncoming(_.byteLength,Z[1],1,`${E(te)}: ${Z[2]}.${Z[3]}`,ge),this.t({type:te,id:Z[1],channelName:Z[2],name:Z[3],arg:ge});case 101:return this.k?.logIncoming(_.byteLength,Z[1],1,`${E(te)}`),this.u({type:te,id:Z[1]});case 103:return this.k?.logIncoming(_.byteLength,Z[1],1,`${E(te)}`),this.u({type:te,id:Z[1]})}}s(_){const Q=this.b.get(_.channelName);if(!Q){this.v(_);return}const Z=new A.CancellationTokenSource;let ge;try{ge=Q.call(this.j,_.name,_.arg,Z.token)}catch(fe){ge=Promise.reject(fe)}const te=_.id;ge.then(fe=>{this.m({id:te,data:fe,type:201}),this.d.delete(_.id)},fe=>{fe instanceof Error?this.m({id:te,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.m({id:te,data:fe,type:203}),this.d.delete(_.id)});const J=(0,y.toDisposable)(()=>Z.cancel());this.d.set(_.id,J)}t(_){const Q=this.b.get(_.channelName);if(!Q){this.v(_);return}const Z=_.id,te=Q.listen(this.j,_.name,_.arg)(J=>this.m({id:Z,data:J,type:204}));this.d.set(_.id,te)}u(_){const Q=this.d.get(_.id);Q&&(Q.dispose(),this.d.delete(_.id))}v(_){let Q=this.g.get(_.channelName);Q||(Q=[],this.g.set(_.channelName,Q));const Z=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:_,timeoutTimer:Z})}w(_){const Q=this.g.get(_);if(Q){for(const Z of Q)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=r;var f;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class I{constructor(_,Q=null){this.l=_,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=Q}getChannel(_){const Q=this;return{call(Z,ge,te){return Q.a?Promise.reject(new T.CancellationError):Q.m(_,Z,ge,te)},listen(Z,ge){return Q.a?S.Event.None:Q.o(_,Z,ge)}}}m(_,Q,Z,ge=A.CancellationToken.None){const te=this.g++,fe={id:te,type:100,channelName:_,name:Q,arg:Z};if(ge.isCancellationRequested)return Promise.reject(new T.CancellationError);let ve;return new Promise((Ae,Fe)=>{if(ge.isCancellationRequested)return Fe(new T.CancellationError);const se=()=>{const ae=ie=>{switch(ie.type){case 201:this.f.delete(te),Ae(ie.data);break;case 202:{this.f.delete(te);const O=new Error(ie.data.message);O.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,O.name=ie.data.name,Fe(O);break}case 203:this.f.delete(te),Fe(ie.data);break}};this.f.set(te,ae),this.p(fe)};let le=null;this.b===h.Idle?se():(le=(0,t.createCancelablePromise)(ae=>this.u()),le.then(()=>{le=null,se()}));const ue=()=>{le?(le.cancel(),le=null):this.p({id:te,type:101}),Fe(new T.CancellationError)},ee=ge.onCancellationRequested(ue);ve=(0,y.combinedDisposable)((0,y.toDisposable)(ue),ee),this.d.add(ve)}).finally(()=>{this.d.delete(ve)})}o(_,Q,Z){const ge=this.g++,J={id:ge,type:102,channelName:_,name:Q,arg:Z};let fe=null;const ve=new S.Emitter({onWillAddFirstListener:()=>{fe=(0,t.createCancelablePromise)(Ae=>this.u()),fe.then(()=>{fe=null,this.d.add(ve),this.p(J)})},onDidRemoveLastListener:()=>{fe?(fe.cancel(),fe=null):(this.d.delete(ve),this.p({id:ge,type:103}))}}),Ee=Ae=>ve.fire(Ae.data);return this.f.set(ge,Ee),ve.event}p(_){switch(_.type){case 100:case 102:{const Q=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(Q,_.id,0,`${E(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const Q=this.q([_.type,_.id]);this.j?.logOutgoing(Q,_.id,0,E(_.type));return}}}q(_,Q=void 0){const Z=new i;return a(Z,_),a(Z,Q),this.r(Z.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const Q=new w(_),Z=n(Q),ge=n(Q),te=Z[0];switch(te){case 200:return this.j?.logIncoming(_.byteLength,0,0,m(te)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,Z[1],0,m(te),ge),this.t({type:Z[0],id:Z[1],data:ge})}}t(_){if(_.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.dispose)(this.d.values()),this.d.clear()}}qe([C.memoize],I.prototype,"onDidInitializePromise",null),e.ChannelClient=I;class R{get connections(){const _=[];return this.f.forEach(Q=>_.push(Q)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,_(({protocol:Q,onDidClientDisconnect:Z})=>{S.Event.once(Q.onMessage)(te=>{const J=new w(te),fe=n(J),ve=new r(Q,fe),Ee=new I(Q);this.a.forEach((Fe,se)=>ve.registerChannel(se,Fe));const Ae={channelServer:ve,channelClient:Ee,ctx:fe};this.f.add(Ae),this.g.fire(Ae),Z(()=>{ve.dispose(),Ee.dispose(),this.f.delete(Ae),this.h.fire(Ae)})})})}getChannel(_,Q){const Z=this;return{call(ge,te,J){let fe;if((0,v.isFunction)(Q)){const Ee=(0,c.getRandomElement)(Z.connections.filter(Q));fe=Ee?Promise.resolve(Ee):S.Event.toPromise(S.Event.filter(Z.onDidAddConnection,Q))}else fe=Q.routeCall(Z,ge,te);const ve=fe.then(Ee=>Ee.channelClient.getChannel(_));return X(ve).call(ge,te,J)},listen(ge,te){if((0,v.isFunction)(Q))return Z.j(_,Q,ge,te);const J=Q.routeEvent(Z,ge,te).then(fe=>fe.channelClient.getChannel(_));return X(J).listen(ge,te)}}}j(_,Q,Z,ge){const te=this;let J=new y.DisposableStore;const fe=new S.Emitter({onWillAddFirstListener:()=>{J=new y.DisposableStore;const ve=new S.EventMultiplexer,Ee=new Map,Ae=se=>{const ue=se.channelClient.getChannel(_).listen(Z,ge),ee=ve.add(ue);Ee.set(se,ee)},Fe=se=>{const le=Ee.get(se);!le||(le.dispose(),Ee.delete(se))};te.connections.filter(Q).forEach(Ae),S.Event.filter(te.onDidAddConnection,Q)(Ae,void 0,J),te.onDidRemoveConnection(Fe,void 0,J),ve.event(fe.fire,fe,J),J.add(ve)},onDidRemoveLastListener:()=>{J.dispose()}});return fe.event}registerChannel(_,Q){this.a.set(_,Q),this.f.forEach(Z=>{Z.channelServer.registerChannel(_,Q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=R;class B{constructor(_,Q,Z=null){const ge=new i;a(ge,Q),_.send(ge.buffer),this.a=new I(_,Z),this.d=new r(_,Q,Z)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,Q){this.d.registerChannel(_,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=B;function X(V){return{call(_,Q,Z){return V.then(ge=>ge.call(_,Q,Z))},listen(_,Q){const Z=new S.Relay;return V.then(ge=>Z.input=ge.listen(_,Q)),Z.event}}}e.getDelayedChannel=X;function q(V){let _=!1;return{call(Q,Z,ge){return _?V.call(Q,Z,ge):(0,t.timeout)(0).then(()=>_=!0).then(()=>V.call(Q,Z,ge))},listen(Q,Z){if(_)return V.listen(Q,Z);const ge=new S.Relay;return(0,t.timeout)(0).then(()=>_=!0).then(()=>ge.input=V.listen(Q,Z)),ge.event}}}e.getNextTickChannel=q;class N{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const Q of _.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(_.onDidAddConnection),await this.b(_)}}e.StaticRouter=N;var M;(function(V){function _(te,J){const fe=te,ve=J&&J.disableMarshalling,Ee=new Map;for(const Ae in fe)Z(Ae)&&Ee.set(Ae,S.Event.buffer(fe[Ae],!0));return new class{listen(Ae,Fe,se){const le=Ee.get(Fe);if(le)return le;if(ge(Fe)){const ue=fe[Fe];if(typeof ue=="function")return ue.call(fe,se)}throw new Error(`Event not found: ${Fe}`)}call(Ae,Fe,se){const le=fe[Fe];if(typeof le=="function"){if(!ve&&Array.isArray(se))for(let ue=0;ue<se.length;ue++)se[ue]=(0,L.revive)(se[ue]);return le.apply(fe,se)}throw new Error(`Method not found: ${Fe}`)}}}V.fromService=_;function Q(te,J){const fe=J&&J.disableMarshalling;return new Proxy({},{get(ve,Ee){if(typeof Ee=="string")return J?.properties?.has(Ee)?J.properties.get(Ee):ge(Ee)?function(Ae){return te.listen(Ee,Ae)}:Z(Ee)?te.listen(Ee):async function(...Ae){let Fe;J&&!(0,v.isUndefinedOrNull)(J.context)?Fe=[J.context,...Ae]:Fe=Ae;const se=await te.call(Ee,Fe);return fe?se:(0,L.revive)(se)};throw new Error(`Property not found: ${String(Ee)}`)}})}V.toService=Q;function Z(te){return te[0]==="o"&&te[1]==="n"&&P.isUpperAsciiLetter(te.charCodeAt(2))}function ge(te){return/^onDynamic/.test(te)&&P.isUpperAsciiLetter(te.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const _=V.toString();if(_!=="[object Object]")return _}return V}function U(V){return Array.isArray(V)?V.map(z):z(V)}function H(V,_,Q,Z,ge,te,J){J=U(J);const fe=F[ge],ve=fe[Z%fe.length];let Ee=[`%c[${V}]%c[${String(_).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(te)?(Ee=Ee.concat(J),Ee.push(")")):Ee.push(J),console.log.apply(console,Ee)}class x{constructor(_,Q){this.d=_,this.f=Q,this.a=0,this.b=0}logOutgoing(_,Q,Z,ge,te){this.b+=_,H(this.d,this.b,_,Q,Z,ge,te)}logIncoming(_,Q,Z,ge,te){this.a+=_,H(this.f,this.a,_,Q,Z,ge,te)}}e.IPCLogger=x}),define(ye[117],Ce([1,0,22,4,6,116]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(C=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var T;(function(l){l.enableDiagnostics=!1,l.records=[];const s=new WeakMap;let a=0;function n(f,I){if(!s.has(f)){const R=String(++a);s.set(f,R)}return s.get(f)}function r(f,I,R,B){if(!l.enableDiagnostics)return;const X=n(f,I);if(B instanceof c.VSBuffer||B instanceof Uint8Array||B instanceof ArrayBuffer||ArrayBuffer.isView(B)){const q=c.VSBuffer.alloc(B.byteLength);q.set(B),l.records.push({timestamp:Date.now(),id:X,label:I,type:R,buff:q})}else l.records.push({timestamp:Date.now(),id:X,label:I,type:R,data:B})}l.traceSocketEvent=r})(T=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function L(){return y||(y=c.VSBuffer.alloc(0)),y}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,a){if(s===0)return L();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const I=this.a[0];return a&&(this.a.shift(),this.b-=s),I}if(this.a[0].byteLength>s){const I=this.a[0].slice(0,s);return a&&(this.a[0]=this.a[0].slice(s),this.b-=s),I}const n=c.VSBuffer.alloc(s);let r=0,f=0;for(;s>0;){const I=this.a[f];if(I.byteLength>s){const R=I.slice(0,s);n.set(R,r),r+=s,a&&(this.a[f]=I.slice(s),this.b-=s),s-=s}else n.set(I,r),r+=I.byteLength,a?(this.a.shift(),this.b-=I.byteLength):f++,s-=I.byteLength}return n}}e.ChunkStream=P;var v;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(v||(v={}));function D(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var E;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(s,a,n,r){this.type=s,this.id=a,this.ack=n,this.data=r,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends k.Disposable{constructor(s){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new P,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:D(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const n=this.g.messageType,r=this.g.id,f=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new d(n,r,f,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=c.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:D(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(a,s.data)}g(s,a){const n=this.f===0;return this.d.push(s,a),this.f+=s.byteLength+a.byteLength,n}h(){const s=c.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,a){this.g(s,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class b extends k.Disposable{constructor(s){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new h(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new d(1,0,0,s))}}e.Protocol=b;class p extends A.IPCClient{static fromSocket(s,a){return new p(new b(s),a)}get onDidDispose(){return this.b.onDidDispose}constructor(s,a,n=null){super(s,a,n),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.Client=p;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.BufferedEmitter=g;class w{constructor(s){this.data=s,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let s=0,a=this.a;for(;a;)a=a.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let a=0,n=this.a;for(;n;)s[a++]=n.data,n=n.next;return s}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const a=new w(s);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class o{static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const s=Date.now();for(let a=0;a<o.a;a++)this.c[a]=s-1e3*a;setInterval(()=>{for(let a=o.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),a=(1+o.a)*1e3;let n=0;for(let r=0;r<o.a;r++)s-this.c[r]<=a&&n++;return 1-n/o.a}hasHighLoad(){return this.d()>=.5}}o.a=10,o.b=null;class u{get unacknowledgedCount(){return this.c-this.d}constructor(s,a=null,n=o.getInstance()){this.t=new g,this.onControlMessage=this.t.event,this.u=new g,this.onMessage=this.u.event,this.v=new g,this.onDidDispose=this.v.event,this.w=new g,this.onSocketClose=this.w.event,this.x=new g,this.onSocketTimeout=this.x.event,this.s=n,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=s,this.p=new h(this.o),this.r.push(this.p),this.q=new m(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(r=>this.y(r))),this.r.push(this.o.onClose(r=>this.w.fire(r))),a&&this.q.acceptChunk(a),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,k.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const s=new d(5,0,0,L());this.p.write(s),this.p.flush()}sendPause(){const s=new d(7,0,0,L());this.p.write(s)}sendResume(){const s=new d(8,0,0,L());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,a){this.a=!0,this.r=(0,k.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=new h(this.o),this.r.push(this.p),this.q=new m(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(n=>this.y(n))),this.r.push(this.o.onClose(n=>this.w.fire(n))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new d(3,0,this.h,L());this.p.write(s);const a=this.b.toArray();for(let n=0,r=a.length;n<r;n++)this.p.write(a[n]);this.A()}acceptDisconnect(){this.v.fire()}y(s){if(s.ack>this.d){this.d=s.ack;do{const a=this.b.peek();if(a&&a.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new d(6,0,0,L())))}else this.g=s.id,this.j=Date.now(),this.z(),this.u.fire(s.data);break}case 2:{this.t.fire(s.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const a=this.b.toArray();for(let n=0,r=a.length;n<r;n++)this.p.write(a[n]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const a=++this.c;this.h=this.g;const n=new d(1,a,this.h,s);this.b.push(n),this.a||(this.p.write(n),this.A())}sendControl(s){const a=new d(2,0,0,s);this.p.write(a)}z(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-s+5)}A(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),a=Date.now()-s.writtenTime,n=Date.now()-this.q.lastReadTime,r=Date.now()-this.n;if(a>=2e4&&n>=2e4&&r>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:n});return}const f=Math.max(2e4-a,2e4-n,2e4-r,500);this.f=setTimeout(()=>{this.f=null,this.A()},f)}B(){if(this.g<=this.h)return;this.h=this.g;const s=new d(3,0,this.h,L());this.p.write(s)}C(){const s=new d(9,0,0,L());this.p.write(s)}}e.PersistentProtocol=u}),define(ye[118],Ce([1,0,22,10,4,6,9,12,30,116,117]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(n,r){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,r)}constructor(n,r=""){this.f=!0,this.debugLabel=r,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=f=>{if(this.traceSocketEvent("error",{code:f?.code,message:f?.message}),f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}},this.socket.on("error",this.a),this.b=f=>{this.traceSocketEvent("close",{hadError:f}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const r=f=>{this.traceSocketEvent("read",f),n(c.VSBuffer.wrap(f))};return this.socket.on("data",r),{dispose:()=>this.socket.off("data",r)}}onClose(n){const r=f=>{n({type:0,hadError:f,error:void 0})};return this.socket.on("close",r),{dispose:()=>this.socket.off("close",r)}}onEnd(n){const r=()=>{n()};return this.socket.on("end",r),{dispose:()=>this.socket.off("end",r)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,r=>{if(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}})}catch(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,r)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=v;var D;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var E;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(E||(E={}));class d extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,r){this.socket.traceSocketEvent(n,r)}constructor(n,r,f,I){super(),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:r,inflateBytesLength:f?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new m(this,r,f,I,this.f,(R,B)=>this.k(R,B))),this.B(this.a.onError(R=>{console.error(R),(0,t.onUnexpectedError)(R),this.g.fire({type:0,hadError:!0,error:R})})),this.b=new L.ChunkStream,this.B(this.socket.onData(R=>this.l(R))),this.B(this.socket.onClose(R=>this.g.fire(R)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,r){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let f=2;n.byteLength<126?f+=0:n.byteLength<2**16?f+=2:f+=8;const I=c.VSBuffer.alloc(f);if(r?I.writeUInt8(194,0):I.writeUInt8(130,0),n.byteLength<126)I.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){I.writeUInt8(126,1);let R=1;I.writeUInt8(n.byteLength>>>8&255,++R),I.writeUInt8(n.byteLength>>>0&255,++R)}else{I.writeUInt8(127,1);let R=1;I.writeUInt8(0,++R),I.writeUInt8(0,++R),I.writeUInt8(0,++R),I.writeUInt8(0,++R),I.writeUInt8(n.byteLength>>>24&255,++R),I.writeUInt8(n.byteLength>>>16&255,++R),I.writeUInt8(n.byteLength>>>8&255,++R),I.writeUInt8(n.byteLength>>>0&255,++R)}this.socket.write(c.VSBuffer.concat([I,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const r=this.b.peek(this.j.readLen),f=r.readUInt8(0),I=(f&128)>>>7,R=(f&64)>>>6,B=r.readUInt8(1),X=(B&128)>>>7,q=B&127;this.j.state=2,this.j.readLen=2+(X?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(R)),this.j.firstFrameOfMessage=Boolean(I),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const r=this.b.read(this.j.readLen),f=r.readUInt8(1),I=(f&128)>>>7;let R=f&127,B=1;R===126?R=r.readUInt8(++B)*2**8+r.readUInt8(++B):R===127&&(R=r.readUInt8(++B)*0+r.readUInt8(++B)*0+r.readUInt8(++B)*0+r.readUInt8(++B)*0+r.readUInt8(++B)*2**24+r.readUInt8(++B)*2**16+r.readUInt8(++B)*2**8+r.readUInt8(++B));let X=0;I&&(X=r.readUInt8(++B)*2**24+r.readUInt8(++B)*2**16+r.readUInt8(++B)*2**8+r.readUInt8(++B)),this.j.state=3,this.j.readLen=R,this.j.mask=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const r=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",r),p(r,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",r),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(r,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class m extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(n,r,f,I,R,B){super(),this.k=n,this.l=R,this.m=B,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,r?(this.b=this.B(new h(this.k,I,f,{windowBits:15})),this.f=this.B(new b(this.k,{windowBits:15})),this.B(this.b.onError(X=>this.a.fire(X))),this.B(this.f.onError(X=>this.a.fire(X)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const r=await this.r(this.f,n);this.m(r,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,r){return new Promise((f,I)=>{n.write(r),n.flush(R=>f(R))})}acceptFrame(n,r,f){this.h.push({data:n,isCompressed:r,isLastFrameOfMessage:f}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const r=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(r)}else this.l.fire(n.data)}this.s=!1}}u(n,r,f){return new Promise((I,R)=>{n.write(r),f&&n.write(c.VSBuffer.fromByteArray([0,0,255,255])),n.flush(B=>I(B))})}}class h extends A.Disposable{get recordedInflateBytes(){return this.j?c.VSBuffer.concat(this.f):c.VSBuffer.alloc(0)}constructor(n,r,f,I){super(),this.h=n,this.j=r,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(I),this.b.on("error",R=>{this.h.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this.a.fire(R)}),this.b.on("data",R=>{this.h.traceSocketEvent("zlibInflateData",R),this.g.push(c.VSBuffer.wrap(R))}),f&&(this.h.traceSocketEvent("zlibInflateInitialWrite",f.buffer),this.b.write(f.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const r=c.VSBuffer.concat(this.g);this.g.length=0,n(r)})}}class b extends A.Disposable{constructor(n,r){super(),this.g=n,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",f=>{this.g.traceSocketEvent("zlibDeflateError",{message:f?.message,code:f?.code}),this.a.fire(f)}),this.b.on("data",f=>{this.g.traceSocketEvent("zlibDeflateData",f),this.f.push(c.VSBuffer.wrap(f))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let r=c.VSBuffer.concat(this.f);this.f.length=0,r=r.slice(0,r.byteLength-4),n(r)})}}function p(a,n){if(n===0)return;const r=a.byteLength>>>2;for(let q=0;q<r;q++){const N=a.readUInt32BE(q*4);a.writeUInt32BE(N^n,q*4)}const f=r*4,I=a.byteLength-f,R=n>>>24&255,B=n>>>16&255,X=n>>>8&255;I>=1&&a.writeUInt8(a.readUInt8(f)^R,f),I>=2&&a.writeUInt8(a.readUInt8(f+1)^B,f+1),I>=3&&a.writeUInt8(a.readUInt8(f+2)^X,f+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const g={[2]:107,[1]:103};function w(){const a=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):n=(0,C.join)(P().os.tmpdir(),`vscode-ipc-${a}.sock`),o(n),n}e.createRandomIPCHandle=w;function i(a,n,r){const f=P().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${r}-${n}-sock`;let I;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?I=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${r}-${n}.sock`):I=(0,C.join)(a,`${r}-${n}.sock`),o(I),I}e.createStaticIPCHandle=i;function o(a){const n=g[T.platform];typeof n=="number"&&a.length>=n&&console.warn(`WARNING: IPC handle "${a}" is longer than ${n} chars, try a shorter --user-data-dir`)}class u extends y.IPCServer{static b(n){const r=k.Event.fromNodeEventEmitter(n,"connection");return k.Event.map(r,f=>({protocol:new L.Protocol(new v(f,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(f,"close"))}))}constructor(n){super(u.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=u;function l(a){return new Promise((n,r)=>{const f=P().net.createServer();f.on("error",r),f.listen(a,()=>{f.removeListener("error",r),n(new u(f))})})}e.serve=l;function s(a,n){return new Promise((r,f)=>{const I=P().net.createConnection(a,()=>{I.removeListener("error",f),r(L.Client.fromSocket(new v(I,`ipc-client${n}`),n))});I.once("error",f)})}e.connect=s}),define(ye[161],Ce([1,0,37,9]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(A,C,T,S,y,L){if(Array.isArray(A)){let P=0;for(const v of A){const D=k(v,C,T,S,y,L);if(D===10)return D;D>P&&(P=D)}return P}else{if(typeof A=="string")return S?A==="*"?5:A===T?10:0:0;if(A){const{language:P,pattern:v,scheme:D,hasAccessToAllModels:E,notebookType:d}=A;if(!S&&!E)return 0;d&&y&&(C=y);let m=0;if(D)if(D===C.scheme)m=10;else if(D==="*")m=5;else return 0;if(P)if(P===T)m=10;else if(P==="*")m=Math.max(m,5);else return 0;if(d)if(d===L)m=10;else if(d==="*"&&L!==void 0)m=Math.max(m,5);else return 0;if(v){let h;if(typeof v=="string"?h=v:h={...v,base:(0,t.normalize)(v.base)},h===C.fsPath||(0,c.match)(h,C.fsPath))m=10;else return 0}return m}else return 0}}e.score=k}),define(ye[162],Ce([1,0,8,50,154]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(T,S,y,L){this.c=T,this.d=S,this.f=y,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(T){T.eol&&T.eol!==this.f&&(this.f=T.eol,this.h=null);const S=T.changes;for(const y of S)this.n(y.range),this.o(new t.Position(y.range.startLineNumber,y.range.startColumn),y.text);this.g=T.versionId,this.j=null}k(){if(!this.h){const T=this.f.length,S=this.d.length,y=new Uint32Array(S);for(let L=0;L<S;L++)y[L]=this.d[L].length+T;this.h=new k.PrefixSumComputer(y)}}l(T,S){this.d[T]=S,this.h&&this.h.setValue(T,this.d[T].length+this.f.length)}n(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.startLineNumber-1].substring(T.endColumn-1));return}this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.endLineNumber-1].substring(T.endColumn-1)),this.d.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.h&&this.h.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}o(T,S){if(S.length===0)return;const y=(0,c.splitLines)(S);if(y.length===1){this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+y[0]+this.d[T.lineNumber-1].substring(T.column-1));return}y[y.length-1]+=this.d[T.lineNumber-1].substring(T.column-1),this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+y[0]);const L=new Uint32Array(y.length-1);for(let P=1;P<y.length;P++)this.d.splice(T.lineNumber+P-1,0,y[P]),L[P-1]=y[P].length+this.f.length;this.h&&this.h.insertValues(T.lineNumber,L)}}e.MirrorTextModel=A}),define(ye[163],Ce([1,0,8,151,50,35,106]),function(ne,e,c,t,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class S{constructor(b,p,g,w){this.searchString=b,this.isRegex=p,this.matchCase=g,this.wordSeparators=w}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=y(this.searchString):b=this.searchString.indexOf(`
`)>=0;let p=null;try{p=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!p)return null;let g=!this.isRegex&&!b;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new C.SearchData(p,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=S;function y(h){if(!h||h.length===0)return!1;for(let b=0,p=h.length;b<p;b++){const g=h.charCodeAt(b);if(g===10)return!0;if(g===92){if(b++,b>=p)break;const w=h.charCodeAt(b);if(w===110||w===114||w===87)return!0}}return!1}e.isMultilineRegexSource=y;function L(h,b,p){if(!p)return new C.FindMatch(h,null);const g=[];for(let w=0,i=b.length;w<i;w++)g[w]=b[w];return new C.FindMatch(h,g)}e.createFindMatch=L;class P{constructor(b){const p=[];let g=0;for(let w=0,i=b.length;w<i;w++)b.charCodeAt(w)===10&&(p[g++]=w);this.a=p}findLineFeedCountBeforeOffset(b){const p=this.a;let g=0,w=p.length-1;if(w===-1||b<=p[0])return 0;for(;g<w;){const i=g+((w-g)/2>>0);p[i]>=b?w=i-1:p[i+1]>=b?(g=i,w=i):g=i+1}return g+1}}class v{static findMatches(b,p,g,w,i){const o=p.parseSearchRequest();return o?o.regex.multiline?this.b(b,g,new m(o.wordSeparators,o.regex),w,i):this.c(b,g,o,w,i):[]}static a(b,p,g,w,i,o){let u,l=0;w?(l=w.findLineFeedCountBeforeOffset(i),u=p+i+l):u=p+i;let s;if(w){const f=w.findLineFeedCountBeforeOffset(i+o.length)-l;s=u+o.length+f}else s=u+o.length;const a=b.getPositionAt(u),n=b.getPositionAt(s);return new A.Range(a.lineNumber,a.column,n.lineNumber,n.column)}static b(b,p,g,w,i){const o=b.getOffsetAt(p.getStartPosition()),u=b.getValueInRange(p,1),l=b.getEOL()===`\r
`?new P(u):null,s=[];let a=0,n;for(g.reset(0);n=g.next(u);)if(s[a++]=L(this.a(b,o,u,l,n.index,n[0]),n,w),a>=i)return s;return s}static c(b,p,g,w,i){const o=[];let u=0;if(p.startLineNumber===p.endLineNumber){const s=b.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return u=this.d(g,s,p.startLineNumber,p.startColumn-1,u,o,w,i),o}const l=b.getLineContent(p.startLineNumber).substring(p.startColumn-1);u=this.d(g,l,p.startLineNumber,p.startColumn-1,u,o,w,i);for(let s=p.startLineNumber+1;s<p.endLineNumber&&u<i;s++)u=this.d(g,b.getLineContent(s),s,0,u,o,w,i);if(u<i){const s=b.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);u=this.d(g,s,p.endLineNumber,0,u,o,w,i)}return o}static d(b,p,g,w,i,o,u,l){const s=b.wordSeparators;if(!u&&b.simpleSearch){const r=b.simpleSearch,f=r.length,I=p.length;let R=-f;for(;(R=p.indexOf(r,R+f))!==-1;)if((!s||d(s,p,I,R,f))&&(o[i++]=new C.FindMatch(new A.Range(g,R+1+w,g,R+1+f+w),null),i>=l))return i;return i}const a=new m(b.wordSeparators,b.regex);let n;a.reset(0);do if(n=a.next(p),n&&(o[i++]=L(new A.Range(g,n.index+1+w,g,n.index+1+n[0].length+w),n,u),i>=l))return i;while(n);return i}static findNextMatch(b,p,g,w){const i=p.parseSearchRequest();if(!i)return null;const o=new m(i.wordSeparators,i.regex);return i.regex.multiline?this.e(b,g,o,w):this.f(b,g,o,w)}static e(b,p,g,w){const i=new k.Position(p.lineNumber,1),o=b.getOffsetAt(i),u=b.getLineCount(),l=b.getValueInRange(new A.Range(i.lineNumber,i.column,u,b.getLineMaxColumn(u)),1),s=b.getEOL()===`\r
`?new P(l):null;g.reset(p.column-1);const a=g.next(l);return a?L(this.a(b,o,l,s,a.index,a[0]),a,w):p.lineNumber!==1||p.column!==1?this.e(b,new k.Position(1,1),g,w):null}static f(b,p,g,w){const i=b.getLineCount(),o=p.lineNumber,u=b.getLineContent(o),l=this.g(g,u,o,p.column,w);if(l)return l;for(let s=1;s<=i;s++){const a=(o+s-1)%i,n=b.getLineContent(a+1),r=this.g(g,n,a+1,1,w);if(r)return r}return null}static g(b,p,g,w,i){b.reset(w-1);const o=b.next(p);return o?L(new A.Range(g,o.index+1,g,o.index+1+o[0].length),o,i):null}static findPreviousMatch(b,p,g,w){const i=p.parseSearchRequest();if(!i)return null;const o=new m(i.wordSeparators,i.regex);return i.regex.multiline?this.h(b,g,o,w):this.j(b,g,o,w)}static h(b,p,g,w){const i=this.b(b,new A.Range(1,1,p.lineNumber,p.column),g,w,10*T);if(i.length>0)return i[i.length-1];const o=b.getLineCount();return p.lineNumber!==o||p.column!==b.getLineMaxColumn(o)?this.h(b,new k.Position(o,b.getLineMaxColumn(o)),g,w):null}static j(b,p,g,w){const i=b.getLineCount(),o=p.lineNumber,u=b.getLineContent(o).substring(0,p.column-1),l=this.k(g,u,o,w);if(l)return l;for(let s=1;s<=i;s++){const a=(i+o-s-1)%i,n=b.getLineContent(a+1),r=this.k(g,n,a+1,w);if(r)return r}return null}static k(b,p,g,w){let i=null,o;for(b.reset(0);o=b.next(p);)i=L(new A.Range(g,o.index+1,g,o.index+1+o[0].length),o,w);return i}}e.TextModelSearch=v;function D(h,b,p,g,w){if(g===0)return!0;const i=b.charCodeAt(g-1);if(h.get(i)!==0||i===13||i===10)return!0;if(w>0){const o=b.charCodeAt(g);if(h.get(o)!==0)return!0}return!1}function E(h,b,p,g,w){if(g+w===p)return!0;const i=b.charCodeAt(g+w);if(h.get(i)!==0||i===13||i===10)return!0;if(w>0){const o=b.charCodeAt(g+w-1);if(h.get(o)!==0)return!0}return!1}function d(h,b,p,g,w){return D(h,b,p,g,w)&&E(h,b,p,g,w)}e.isValidMatch=d;class m{constructor(b,p){this._wordSeparators=b,this.a=p,this.b=-1,this.c=0}reset(b){this.a.lastIndex=b,this.b=-1,this.c=0}next(b){const p=b.length;let g;do{if(this.b+this.c===p||(g=this.a.exec(b),!g))return null;const w=g.index,i=g[0].length;if(w===this.b&&i===this.c){if(i===0){c.getNextCodePoint(b,p,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=w,this.c=i,!this._wordSeparators||d(this._wordSeparators,b,p,w,i))return g}while(g);return null}}e.Searcher=m}),define(ye[119],Ce([1,0,22,12]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(k||(k={}));function A(P){for(let v=0,D=P.length;v<D;v+=4){const E=P[v+0],d=P[v+1],m=P[v+2],h=P[v+3];P[v+0]=h,P[v+1]=m,P[v+2]=d,P[v+3]=E}}function C(P){const v=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return t.isLittleEndian()||A(v),c.VSBuffer.wrap(v)}function T(P){const v=P.buffer;if(t.isLittleEndian()||A(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const D=new Uint8Array(v.byteLength);return D.set(v),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function S(P){const v=new Uint32Array(y(P));let D=0;if(v[D++]=P.id,P.type==="full")v[D++]=1,v[D++]=P.data.length,v.set(P.data,D),D+=P.data.length;else{v[D++]=2,v[D++]=P.deltas.length;for(const E of P.deltas)v[D++]=E.start,v[D++]=E.deleteCount,E.data?(v[D++]=E.data.length,v.set(E.data,D),D+=E.data.length):v[D++]=0}return C(v)}e.encodeSemanticTokensDto=S;function y(P){let v=0;if(v+=1+1,P.type==="full")v+=1+P.data.length;else{v+=1,v+=(1+1+1)*P.deltas.length;for(const D of P.deltas)D.data&&(v+=D.data.length)}return v}function L(P){const v=T(P);let D=0;const E=v[D++];if(v[D++]===1){const b=v[D++],p=v.subarray(D,D+b);return D+=b,{id:E,type:"full",data:p}}const m=v[D++],h=[];for(let b=0;b<m;b++){const p=v[D++],g=v[D++],w=v[D++];let i;w>0&&(i=v.subarray(D,D+w),D+=w),h[b]={start:p,deleteCount:g,data:i}}return{id:E,type:"delta",deltas:h}}e.decodeSemanticTokensDto=L}),define(ye[164],Ce([1,0,4,6]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this.a=new Map,this.b=new Map,this.c=new c.Emitter,this.onDidChange=this.c.event,this.d=null}fire(T){this.c.fire({changedLanguages:T,changedColorMap:!1})}register(T,S){return this.a.set(T,S),this.fire([T]),(0,t.toDisposable)(()=>{this.a.get(T)===S&&(this.a.delete(T),this.fire([T]))})}registerFactory(T,S){this.b.get(T)?.dispose();const y=new A(this,T,S);return this.b.set(T,y),(0,t.toDisposable)(()=>{const L=this.b.get(T);!L||L!==y||(this.b.delete(T),L.dispose())})}async getOrCreate(T){const S=this.get(T);if(S)return S;const y=this.b.get(T);return!y||y.isResolved?null:(await y.resolve(),this.get(T))}get(T){return this.a.get(T)||null}isResolved(T){if(this.get(T))return!0;const y=this.b.get(T);return!!(!y||y.isResolved)}setColorMap(T){this.d=T,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=k;class A extends t.Disposable{get isResolved(){return this.c}constructor(T,S,y){super(),this.f=T,this.g=S,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const T=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,T&&!this.a&&this.B(this.f.register(this.g,T))}}}),define(ye[66],Ce([1,0,80,2,35,164]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(f,I,R){this._tokenBrand=void 0,this.offset=f,this.type=I,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class T{constructor(f,I){this._tokenizationResultBrand=void 0,this.tokens=f,this.endState=I}}e.TokenizationResult=T;class S{constructor(f,I){this._encodedTokenizationResultBrand=void 0,this.tokens=f,this.endState=I}}e.EncodedTokenizationResult=S;var y;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(y=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(r){const f=new Map;f.set(0,c.Codicon.symbolMethod),f.set(1,c.Codicon.symbolFunction),f.set(2,c.Codicon.symbolConstructor),f.set(3,c.Codicon.symbolField),f.set(4,c.Codicon.symbolVariable),f.set(5,c.Codicon.symbolClass),f.set(6,c.Codicon.symbolStruct),f.set(7,c.Codicon.symbolInterface),f.set(8,c.Codicon.symbolModule),f.set(9,c.Codicon.symbolProperty),f.set(10,c.Codicon.symbolEvent),f.set(11,c.Codicon.symbolOperator),f.set(12,c.Codicon.symbolUnit),f.set(13,c.Codicon.symbolValue),f.set(15,c.Codicon.symbolEnum),f.set(14,c.Codicon.symbolConstant),f.set(15,c.Codicon.symbolEnum),f.set(16,c.Codicon.symbolEnumMember),f.set(17,c.Codicon.symbolKeyword),f.set(27,c.Codicon.symbolSnippet),f.set(18,c.Codicon.symbolText),f.set(19,c.Codicon.symbolColor),f.set(20,c.Codicon.symbolFile),f.set(21,c.Codicon.symbolReference),f.set(22,c.Codicon.symbolCustomColor),f.set(23,c.Codicon.symbolFolder),f.set(24,c.Codicon.symbolTypeParameter),f.set(25,c.Codicon.account),f.set(26,c.Codicon.issues);function I(X){let q=f.get(X);return q||(console.info("No codicon found for CompletionItemKind "+X),q=c.Codicon.symbolProperty),q}r.toIcon=I;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function B(X,q){let N=R.get(X);return typeof N>"u"&&!q&&(N=9),N}r.fromString=B})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(r){r[r.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(r){return r&&t.URI.isUri(r.uri)&&k.Range.isIRange(r.range)&&(k.Range.isIRange(r.originSelectionRange)||k.Range.isIRange(r.targetSelectionRange))}e.isLocationLink=b;var p;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(p=e.SymbolKind||(e.SymbolKind={}));var g;(function(r){r[r.Deprecated=1]="Deprecated"})(g=e.SymbolTag||(e.SymbolTag={}));var w;(function(r){const f=new Map;f.set(0,c.Codicon.symbolFile),f.set(1,c.Codicon.symbolModule),f.set(2,c.Codicon.symbolNamespace),f.set(3,c.Codicon.symbolPackage),f.set(4,c.Codicon.symbolClass),f.set(5,c.Codicon.symbolMethod),f.set(6,c.Codicon.symbolProperty),f.set(7,c.Codicon.symbolField),f.set(8,c.Codicon.symbolConstructor),f.set(9,c.Codicon.symbolEnum),f.set(10,c.Codicon.symbolInterface),f.set(11,c.Codicon.symbolFunction),f.set(12,c.Codicon.symbolVariable),f.set(13,c.Codicon.symbolConstant),f.set(14,c.Codicon.symbolString),f.set(15,c.Codicon.symbolNumber),f.set(16,c.Codicon.symbolBoolean),f.set(17,c.Codicon.symbolArray),f.set(18,c.Codicon.symbolObject),f.set(19,c.Codicon.symbolKey),f.set(20,c.Codicon.symbolNull),f.set(21,c.Codicon.symbolEnumMember),f.set(22,c.Codicon.symbolStruct),f.set(23,c.Codicon.symbolEvent),f.set(24,c.Codicon.symbolOperator),f.set(25,c.Codicon.symbolTypeParameter);function I(R){let B=f.get(R);return B||(console.info("No codicon found for SymbolKind "+R),B=c.Codicon.symbolProperty),B}r.toIcon=I})(w=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(f){this.value=f}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var o;(function(r){function f(I){return!I||typeof I!="object"?!1:typeof I.id=="string"&&typeof I.title=="string"}r.is=f})(o=e.Command||(e.Command={}));var u;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(r){r[r.Unresolved=0]="Unresolved",r[r.Resolved=1]="Resolved"})(l=e.CommentThreadState||(e.CommentThreadState={}));var s;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var a;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(a=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var n;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[165],Ce([19,20]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(ye[120],Ce([1,0,165,12,105,17,23,150]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor($){this.c=$}hasChanged($){return this.c[$]}}e.ConfigurationChangedEvent=y;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class P{constructor($,ce,Ie,Le){this.id=$,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ce){return D($,ce)}compute($,ce,Ie){return Ie}}class v{constructor($,ce){this.newValue=$,this.didChange=ce}}e.ApplyUpdateResult=v;function D(oe,$){if(typeof oe!="object"||typeof $!="object"||!oe||!$)return new v($,oe!==$);if(Array.isArray(oe)||Array.isArray($)){const Ie=Array.isArray(oe)&&Array.isArray($)&&A.equals(oe,$);return new v($,!Ie)}let ce=!1;for(const Ie in $)if($.hasOwnProperty(Ie)){const Le=D(oe[Ie],$[Ie]);Le.didChange&&(oe[Ie]=Le.newValue,ce=!0)}return new v(oe,ce)}class E{constructor($){this.schema=void 0,this.id=$,this.name="_never_",this.defaultValue=void 0}applyUpdate($,ce){return D($,ce)}validate($){return this.defaultValue}}class d{constructor($,ce,Ie,Le){this.id=$,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ce){return D($,ce)}validate($){return typeof $>"u"?this.defaultValue:$}compute($,ce,Ie){return Ie}}function m(oe,$){return typeof oe>"u"?$:oe==="false"?!1:Boolean(oe)}e.boolean=m;class h extends d{constructor($,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super($,ce,Ie,Le)}validate($){return m($,this.defaultValue)}}function b(oe,$,ce,Ie){if(typeof oe>"u")return $;let Le=parseInt(oe,10);return isNaN(Le)?$:(Le=Math.max(ce,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=b;class p extends d{static clampedInt($,ce,Ie,Le){return b($,ce,Ie,Le)}constructor($,ce,Ie,Le,Be,xe=void 0){typeof xe<"u"&&(xe.type="integer",xe.default=Ie,xe.minimum=Le,xe.maximum=Be),super($,ce,Ie,xe),this.minimum=Le,this.maximum=Be}validate($){return p.clampedInt($,this.defaultValue,this.minimum,this.maximum)}}class g extends d{static clamp($,ce,Ie){return $<ce?ce:$>Ie?Ie:$}static float($,ce){if(typeof $=="number")return $;if(typeof $>"u")return ce;const Ie=parseFloat($);return isNaN(Ie)?ce:Ie}constructor($,ce,Ie,Le,Be){typeof Be<"u"&&(Be.type="number",Be.default=Ie),super($,ce,Ie,Be),this.validationFn=Le}validate($){return this.validationFn(g.float($,this.defaultValue))}}class w extends d{static string($,ce){return typeof $!="string"?ce:$}constructor($,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super($,ce,Ie,Le)}validate($){return w.string($,this.defaultValue)}}function i(oe,$,ce){return typeof oe!="string"||ce.indexOf(oe)===-1?$:oe}e.stringSet=i;class o extends d{constructor($,ce,Ie,Le,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=Le,Be.default=Ie),super($,ce,Ie,Be),this.c=Le}validate($){return i($,this.defaultValue,this.c)}}class u extends P{constructor($,ce,Ie,Le,Be,xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le),super($,ce,Ie,Ze),this.c=Be,this.d=xe}validate($){return typeof $!="string"?this.defaultValue:this.c.indexOf($)===-1?this.defaultValue:this.d($)}}function l(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate($){switch($){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute($,ce,Ie){return Ie===0?$.accessibilitySupport:Ie}}class a extends P{constructor(){const $={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",$,{"editor.comments.insertSpace":{type:"boolean",default:$.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:$.ignoreEmptyLines,description:c.localize(5,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{insertSpace:m(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function I(oe){switch(oe){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=I;function R(oe){switch(oe){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class B extends E{constructor(){super(135)}compute($,ce,Ie){const Le=["monaco-editor"];return ce.get(36)&&Le.push(ce.get(36)),$.extraEditorClassName&&Le.push($.extraEditorClassName),ce.get(70)==="default"?Le.push("mouse-default"):ce.get(70)==="copy"&&Le.push("mouse-copy"),ce.get(105)&&Le.push("showUnused"),ce.get(133)&&Le.push("showDeprecated"),Le.join(" ")}}class X extends h{constructor(){super(34,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute($,ce,Ie){return Ie&&$.emptySelectionClipboard}}class q extends P{constructor(){const $={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",$,{"editor.find.cursorMoveOnType":{type:"boolean",default:$.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:$.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:$.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:$.globalFindClipboard,description:c.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:$.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:$.loop,description:c.localize(18,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{cursorMoveOnType:m(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof $.seedSearchStringFromSelection=="boolean"?$.seedSearchStringFromSelection?"always":"never":i(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof $.autoFindInSelection=="boolean"?$.autoFindInSelection?"always":"never":i(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(ce.loop,this.defaultValue.loop)}}}class N extends P{constructor(){super(48,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?N.OFF:$==="true"?N.ON:$:Boolean($)?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class M extends P{constructor(){super(51,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?M.OFF:$==="true"?M.TRANSLATE:$:Boolean($)?M.TRANSLATE:M.OFF}compute($,ce,Ie){return $.fontInfo.fontVariationSettings}}e.EditorFontVariations=M,M.OFF="normal",M.TRANSLATE="translate";class F extends E{constructor(){super(47)}compute($,ce,Ie){return $.fontInfo}}class z extends d{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate($){const ce=g.float($,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(ce,6,100)}compute($,ce,Ie){return $.fontInfo.fontSize}}class U extends P{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.d,maximum:U.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate($){return $==="normal"||$==="bold"?$:String(p.clampedInt($,e.EDITOR_FONT_DEFAULTS.fontWeight,U.d,U.e))}}U.c=["normal","bold","100","200","300","400","500","600","700","800","900"],U.d=1,U.e=1e3;class H extends P{constructor(){const $={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:$.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",$,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...ce},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...ce},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:$.alternativeDefinitionCommand,enum:Ie,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:$.alternativeTypeDefinitionCommand,enum:Ie,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:$.alternativeDeclarationCommand,enum:Ie,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:$.alternativeImplementationCommand,enum:Ie,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:$.alternativeReferenceCommand,enum:Ie,description:c.localize(41,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{multiple:i(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??i(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??i(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??i(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??i(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??i(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends P{constructor(){const $={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",$,{"editor.hover.enabled":{type:"boolean",default:$.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:$.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:$.sticky,description:c.localize(44,null)},"editor.hover.above":{type:"boolean",default:$.above,description:c.localize(45,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),delay:p.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:m(ce.sticky,this.defaultValue.sticky),above:m(ce.above,this.defaultValue.above)}}}var V;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class _ extends E{constructor(){super(138)}compute($,ce,Ie){return _.computeLayout(ce,{memory:$.memory,outerWidth:$.outerWidth,outerHeight:$.outerHeight,isDominatedByLongLines:$.isDominatedByLongLines,lineHeight:$.fontInfo.lineHeight,viewLineCount:$.viewLineCount,lineNumbersDigitCount:$.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:$.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:$.fontInfo.maxDigitWidth,pixelRatio:$.pixelRatio})}static computeContainedMinimapLineCount($){const ce=$.height/$.lineHeight,Ie=Math.floor($.paddingTop/$.lineHeight);let Le=Math.floor($.paddingBottom/$.lineHeight);$.scrollBeyondLastLine&&(Le=Math.max(Le,ce-1));const Be=(Ie+$.viewLineCount+Le)/($.pixelRatio*$.height),xe=Math.floor($.viewLineCount/Be);return{typicalViewportLineCount:ce,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:Be,minimapLineCount:xe}}static c($,ce){const Ie=$.outerWidth,Le=$.outerHeight,Be=$.pixelRatio;if(!$.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const xe=ce.stableMinimapLayoutInput,Ze=xe&&$.outerHeight===xe.outerHeight&&$.lineHeight===xe.lineHeight&&$.typicalHalfwidthCharacterWidth===xe.typicalHalfwidthCharacterWidth&&$.pixelRatio===xe.pixelRatio&&$.scrollBeyondLastLine===xe.scrollBeyondLastLine&&$.paddingTop===xe.paddingTop&&$.paddingBottom===xe.paddingBottom&&$.minimap.enabled===xe.minimap.enabled&&$.minimap.side===xe.minimap.side&&$.minimap.size===xe.minimap.size&&$.minimap.showSlider===xe.minimap.showSlider&&$.minimap.renderCharacters===xe.minimap.renderCharacters&&$.minimap.maxColumn===xe.minimap.maxColumn&&$.minimap.scale===xe.minimap.scale&&$.verticalScrollbarWidth===xe.verticalScrollbarWidth&&$.isViewportWrapping===xe.isViewportWrapping,gt=$.lineHeight,mt=$.typicalHalfwidthCharacterWidth,lt=$.scrollBeyondLastLine,ot=$.minimap.renderCharacters;let rt=Be>=2?Math.round($.minimap.scale*2):$.minimap.scale;const kt=$.minimap.maxColumn,Tt=$.minimap.size,Nt=$.minimap.side,pt=$.verticalScrollbarWidth,Dt=$.viewLineCount,zt=$.remainingWidth,Ft=$.isViewportWrapping,Xe=ot?2:3;let Mt=Math.floor(Be*Le);const Ut=Mt/Be;let Bt=!1,bt=!1,Pt=Xe*rt,Re=rt/Be,Oe=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeforeFirstLine:St,extraLinesBeyondLastLine:Et,desiredRatio:Lt,minimapLineCount:vt}=_.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:lt,paddingTop:$.paddingTop,paddingBottom:$.paddingBottom,height:Le,lineHeight:gt,pixelRatio:Be});if(Dt/vt>1)Bt=!0,bt=!0,rt=1,Pt=1,Re=rt/Be;else{let ft=!1,xt=rt+1;if(Tt==="fit"){const jt=Math.ceil((St+Dt+Et)*Pt);Ft&&Ze&&zt<=ce.stableFitRemainingWidth?(ft=!0,xt=ce.stableFitMaxMinimapScale):ft=jt>Mt}if(Tt==="fill"||ft){Bt=!0;const jt=rt;Pt=Math.min(gt*Be,Math.max(1,Math.floor(1/Lt))),Ft&&Ze&&zt<=ce.stableFitRemainingWidth&&(xt=ce.stableFitMaxMinimapScale),rt=Math.min(xt,Math.max(1,Math.floor(Pt/Xe))),rt>jt&&(Oe=Math.min(2,rt/jt)),Re=rt/Be/Oe,Mt=Math.ceil(Math.max(tt,St+Dt+Et)*Pt),Ft?(ce.stableMinimapLayoutInput=$,ce.stableFitRemainingWidth=zt,ce.stableFitMaxMinimapScale=rt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const Se=Math.floor(kt*Re),re=Math.min(Se,Math.max(0,Math.floor((zt-pt-2)*Re/(mt+Re)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Be*re);const $e=Ne/Be;Ne=Math.floor(Ne*Oe);const Qe=ot?1:2,Ve=Nt==="left"?0:Ie-re-pt;return{renderMinimap:Qe,minimapLeft:Ve,minimapWidth:re,minimapHeightIsEditorHeight:Bt,minimapIsSampling:bt,minimapScale:rt,minimapLineHeight:Pt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Ut}}static computeLayout($,ce){const Ie=ce.outerWidth|0,Le=ce.outerHeight|0,Be=ce.lineHeight|0,xe=ce.lineNumbersDigitCount|0,Ze=ce.typicalHalfwidthCharacterWidth,gt=ce.maxDigitWidth,mt=ce.pixelRatio,lt=ce.viewLineCount,ot=$.get(130),rt=ot==="inherit"?$.get(129):ot,kt=rt==="inherit"?$.get(125):rt,Tt=$.get(128),Nt=ce.isDominatedByLongLines,pt=$.get(54),Dt=$.get(64).renderType!==0,zt=$.get(65),Ft=$.get(99),Xe=$.get(80),Mt=$.get(69),Ut=$.get(97),Bt=Ut.verticalScrollbarSize,bt=Ut.verticalHasArrows,Pt=Ut.arrowSize,Re=Ut.horizontalScrollbarSize,Oe=$.get(40),Se=$.get(104)!=="never";let re=$.get(62);Oe&&Se&&(re+=16);let Ne=0;if(Dt){const _t=Math.max(xe,zt);Ne=Math.round(_t*gt)}let $e=0;pt&&($e=Be);let Qe=0,Ve=Qe+$e,tt=Ve+Ne,St=tt+re;const Et=Ie-$e-Ne-re;let Lt=!1,vt=!1,It=-1;rt==="inherit"&&Nt?(Lt=!0,vt=!0):kt==="on"||kt==="bounded"?vt=!0:kt==="wordWrapColumn"&&(It=Tt);const ft=_.c({outerWidth:Ie,outerHeight:Le,lineHeight:Be,typicalHalfwidthCharacterWidth:Ze,pixelRatio:mt,scrollBeyondLastLine:Ft,paddingTop:Xe.top,paddingBottom:Xe.bottom,minimap:Mt,verticalScrollbarWidth:Bt,viewLineCount:lt,remainingWidth:Et,isViewportWrapping:vt},ce.memory||new L);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Qe+=ft.minimapWidth,Ve+=ft.minimapWidth,tt+=ft.minimapWidth,St+=ft.minimapWidth);const xt=Et-ft.minimapWidth,jt=Math.max(1,Math.floor((xt-Bt-2)/Ze)),yt=bt?Pt:0;return vt&&(It=Math.max(1,jt),kt==="bounded"&&(It=Math.min(It,Tt))),{width:Ie,height:Le,glyphMarginLeft:Qe,glyphMarginWidth:$e,lineNumbersLeft:Ve,lineNumbersWidth:Ne,decorationsLeft:tt,decorationsWidth:re,contentLeft:St,contentWidth:xt,minimap:ft,viewportColumn:jt,isWordWrapMinified:Lt,isViewportWrapping:vt,wrappingColumn:It,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:Re,overviewRuler:{top:yt,width:Bt,height:Le-2*yt,right:0}}}}e.EditorLayoutInfoComputer=_;class Q extends P{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(46,null),c.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(48,null)}})}validate($){return i($,"simple",["simple","advanced"])}compute($,ce,Ie){return ce.get(2)===2?"advanced":Ie}}class Z extends P{constructor(){const $={enabled:!0};super(61,"lightbulb",$,{"editor.lightbulb.enabled":{type:"boolean",default:$.enabled,description:c.localize(49,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:m($.enabled,this.defaultValue.enabled)}}}class ge extends P{constructor(){const $={enabled:!1,maxLineCount:5};super(109,"stickyScroll",$,{"editor.stickyScroll.enabled":{type:"boolean",default:$.enabled,description:c.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:$.maxLineCount,minimum:1,maximum:10,description:c.localize(51,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),maxLineCount:p.clampedInt(ce.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class te extends P{constructor(){const $={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",$,{"editor.inlayHints.enabled":{type:"string",default:$.enabled,description:c.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(53,null),c.localize(54,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:$.fontSize,markdownDescription:c.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:$.fontFamily,markdownDescription:c.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:$.padding,description:c.localize(59,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return typeof ce.enabled=="boolean"&&(ce.enabled=ce.enabled?"on":"off"),{enabled:i(ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:p.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(ce.fontFamily,this.defaultValue.fontFamily),padding:m(ce.padding,this.defaultValue.padding)}}}class J extends P{constructor(){super(62,"lineDecorationsWidth",10)}validate($){return typeof $=="string"&&/^\d+(\.\d+)?ch$/.test($)?-parseFloat($.substring(0,$.length-2)):p.clampedInt($,this.defaultValue,0,1e3)}compute($,ce,Ie){return Ie<0?p.clampedInt(-Ie*$.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class fe extends g{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,$=>g.clamp($,0,150),{markdownDescription:c.localize(60,null)})}compute($,ce,Ie){return $.fontInfo.lineHeight}}class ve extends P{constructor(){const $={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",$,{"editor.minimap.enabled":{type:"boolean",default:$.enabled,description:c.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:$.autohide,description:c.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(63,null),c.localize(64,null),c.localize(65,null)],default:$.size,description:c.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:$.side,description:c.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:$.showSlider,description:c.localize(68,null)},"editor.minimap.scale":{type:"number",default:$.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:$.renderCharacters,description:c.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:$.maxColumn,description:c.localize(71,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),autohide:m(ce.autohide,this.defaultValue.autohide),size:i(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(ce.side,this.defaultValue.side,["right","left"]),showSlider:i(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(ce.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(ce.scale,1,1,3),maxColumn:p.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ee(oe){return oe==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ae extends P{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(73,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{top:p.clampedInt(ce.top,0,0,1e3),bottom:p.clampedInt(ce.bottom,0,0,1e3)}}}class Fe extends P{constructor(){const $={enabled:!0,cycle:!1};super(81,"parameterHints",$,{"editor.parameterHints.enabled":{type:"boolean",default:$.enabled,description:c.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:$.cycle,description:c.localize(75,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),cycle:m(ce.cycle,this.defaultValue.cycle)}}}class se extends E{constructor(){super(136)}compute($,ce,Ie){return $.pixelRatio}}class le extends P{constructor(){const $={other:"on",comments:"off",strings:"off"},ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(76,null),c.localize(77,null),c.localize(78,null)]}];super(84,"quickSuggestions",$,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ce,default:$.strings,description:c.localize(79,null)},comments:{anyOf:ce,default:$.comments,description:c.localize(80,null)},other:{anyOf:ce,default:$.other,description:c.localize(81,null)}},default:$,markdownDescription:c.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=$}validate($){if(typeof $=="boolean"){const mt=$?"on":"off";return{comments:mt,strings:mt,other:mt}}if(!$||typeof $!="object")return this.defaultValue;const{other:ce,comments:Ie,strings:Le}=$,Be=["on","inline","off"];let xe,Ze,gt;return typeof ce=="boolean"?xe=ce?"on":"off":xe=i(ce,this.defaultValue.other,Be),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=i(Ie,this.defaultValue.comments,Be),typeof Le=="boolean"?gt=Le?"on":"off":gt=i(Le,this.defaultValue.strings,Be),{other:xe,comments:Ze,strings:gt}}}var ue;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(ue=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends P{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(83,null),c.localize(84,null),c.localize(85,null),c.localize(86,null)],default:"on",description:c.localize(87,null)})}validate($){let ce=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof $<"u"&&(typeof $=="function"?(ce=4,Ie=$):$==="interval"?ce=3:$==="relative"?ce=2:$==="on"?ce=1:ce=0),{renderType:ce,renderFn:Ie}}}function ae(oe){const $=oe.get(92);return $==="editable"?oe.get(86):$!=="on"}e.filterValidationDecorations=ae;class ie extends P{constructor(){const $=[],ce={type:"number",description:c.localize(88,null)};super(96,"rulers",$,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:c.localize(89,null),format:"color-hex"}}}]},default:$,description:c.localize(90,null)})}validate($){if(Array.isArray($)){const ce=[];for(const Ie of $)if(typeof Ie=="number")ce.push({column:p.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;ce.push({column:p.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ce.sort((Ie,Le)=>Ie.column-Le.column),ce}return this.defaultValue}}function O(oe,$){if(typeof oe!="string")return $;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends P{constructor(){const $={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",$,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(91,null),c.localize(92,null),c.localize(93,null)],default:"auto",description:c.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(95,null),c.localize(96,null),c.localize(97,null)],default:"auto",description:c.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:$.verticalScrollbarSize,description:c.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:$.horizontalScrollbarSize,description:c.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:$.scrollByPage,description:c.localize(101,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$,Ie=p.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=p.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(ce.vertical,this.defaultValue.vertical),horizontal:O(ce.horizontal,this.defaultValue.horizontal),useShadows:m(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:p.clampedInt(ce.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:p.clampedInt(ce.verticalSliderSize,Le,0,1e3),scrollByPage:m(ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends P{constructor(){const $={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",$,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.nonBasicASCII,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:$.invisibleCharacters,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:$.ambiguousCharacters,description:c.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeComments,description:c.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeStrings,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:$.allowedCharacters,description:c.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:$.allowedLocales,description:c.localize(108,null)}})}applyUpdate($,ce){let Ie=!1;ce.allowedCharacters&&$&&(C.equals($.allowedCharacters,ce.allowedCharacters)||($={...$,allowedCharacters:ce.allowedCharacters},Ie=!0)),ce.allowedLocales&&$&&(C.equals($.allowedLocales,ce.allowedLocales)||($={...$,allowedLocales:ce.allowedLocales},Ie=!0));const Le=super.applyUpdate($,ce);return Ie?new v(Le.newValue,!0):Le}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{nonBasicASCII:Pe(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Pe(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Pe(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c($.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c($.allowedLocales,this.defaultValue.allowedLocales)}}c($,ce){if(typeof $!="object"||!$)return ce;const Ie={};for(const[Le,Be]of Object.entries($))Be===!0&&(Ie[Le]=!0);return Ie}}class Y extends P{constructor(){const $={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",$,{"editor.inlineSuggest.enabled":{type:"boolean",default:$.enabled,description:c.localize(109,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),mode:i(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class de extends P{constructor(){const $={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",$,{"editor.bracketPairColorization.enabled":{type:"boolean",default:$.enabled,markdownDescription:c.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:$.independentColorPoolPerBracketType,description:c.localize(111,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class be extends P{constructor(){const $={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",$,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(112,null),c.localize(113,null),c.localize(114,null)],default:$.bracketPairs,description:c.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(116,null),c.localize(117,null),c.localize(118,null)],default:$.bracketPairsHorizontal,description:c.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:$.highlightActiveBracketPair,description:c.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:$.indentation,description:c.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(122,null),c.localize(123,null),c.localize(124,null)],default:$.highlightActiveIndentation,description:c.localize(125,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{bracketPairs:Pe(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Pe(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Pe(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Pe(oe,$,ce){const Ie=ce.indexOf(oe);return Ie===-1?$:ce[Ie]}class pe extends P{constructor(){const $={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",$,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(126,null),c.localize(127,null)],default:$.insertMode,description:c.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:$.filterGraceful,description:c.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:$.localityBonus,description:c.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:$.shareSuggestSelections,markdownDescription:c.localize(131,null)},"editor.suggest.selectQuickSuggestions":{type:"boolean",default:$.selectQuickSuggestions,markdownDescription:c.localize(132,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:$.snippetsPreventQuickSuggestions,description:c.localize(133,null)},"editor.suggest.showIcons":{type:"boolean",default:$.showIcons,description:c.localize(134,null)},"editor.suggest.showStatusBar":{type:"boolean",default:$.showStatusBar,description:c.localize(135,null)},"editor.suggest.preview":{type:"boolean",default:$.preview,description:c.localize(136,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:$.showInlineDetails,description:c.localize(137,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(138,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(139,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(140,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(141,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(142,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(143,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(145,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(146,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{insertMode:i(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:m(ce.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:m(ce.showIcons,this.defaultValue.showIcons),showStatusBar:m(ce.showStatusBar,this.defaultValue.showStatusBar),preview:m(ce.preview,this.defaultValue.preview),previewMode:i(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(ce.showMethods,this.defaultValue.showMethods),showFunctions:m(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:m(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(ce.showFields,this.defaultValue.showFields),showVariables:m(ce.showVariables,this.defaultValue.showVariables),showClasses:m(ce.showClasses,this.defaultValue.showClasses),showStructs:m(ce.showStructs,this.defaultValue.showStructs),showInterfaces:m(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:m(ce.showModules,this.defaultValue.showModules),showProperties:m(ce.showProperties,this.defaultValue.showProperties),showEvents:m(ce.showEvents,this.defaultValue.showEvents),showOperators:m(ce.showOperators,this.defaultValue.showOperators),showUnits:m(ce.showUnits,this.defaultValue.showUnits),showValues:m(ce.showValues,this.defaultValue.showValues),showConstants:m(ce.showConstants,this.defaultValue.showConstants),showEnums:m(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:m(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(ce.showKeywords,this.defaultValue.showKeywords),showWords:m(ce.showWords,this.defaultValue.showWords),showColors:m(ce.showColors,this.defaultValue.showColors),showFiles:m(ce.showFiles,this.defaultValue.showFiles),showReferences:m(ce.showReferences,this.defaultValue.showReferences),showFolders:m(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:m(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(ce.showSnippets,this.defaultValue.showSnippets),showUsers:m(ce.showUsers,this.defaultValue.showUsers),showIssues:m(ce.showIssues,this.defaultValue.showIssues)}}}class De extends P{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(170,null),default:!0,type:"boolean"}})}validate($){return!$||typeof $!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m($.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends E{constructor(){super(137)}compute($,ce,Ie){return ce.get(86)?!0:$.tabFocusMode}}var je;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(je=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends P{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(171,null),c.localize(172,null),c.localize(173,null),c.localize(174,null)],description:c.localize(175,null),default:"same"}})}validate($){switch($){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute($,ce,Ie){return ce.get(2)===2?0:Ie}}class et extends E{constructor(){super(139)}compute($,ce,Ie){const Le=ce.get(138);return{isDominatedByLongLines:$.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class _e extends P{constructor(){const $={enabled:!0};super(33,"dropIntoEditor",$,{"editor.dropIntoEditor.enabled":{type:"boolean",default:$.enabled,markdownDescription:c.localize(176,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:m($.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var it;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.autoClosingBrackets=5]="autoClosingBrackets",oe[oe.autoClosingDelete=6]="autoClosingDelete",oe[oe.autoClosingOvertype=7]="autoClosingOvertype",oe[oe.autoClosingQuotes=8]="autoClosingQuotes",oe[oe.autoIndent=9]="autoIndent",oe[oe.automaticLayout=10]="automaticLayout",oe[oe.autoSurround=11]="autoSurround",oe[oe.bracketPairColorization=12]="bracketPairColorization",oe[oe.guides=13]="guides",oe[oe.codeLens=14]="codeLens",oe[oe.codeLensFontFamily=15]="codeLensFontFamily",oe[oe.codeLensFontSize=16]="codeLensFontSize",oe[oe.colorDecorators=17]="colorDecorators",oe[oe.colorDecoratorsLimit=18]="colorDecoratorsLimit",oe[oe.columnSelection=19]="columnSelection",oe[oe.comments=20]="comments",oe[oe.contextmenu=21]="contextmenu",oe[oe.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=23]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=25]="cursorStyle",oe[oe.cursorSurroundingLines=26]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=28]="cursorWidth",oe[oe.disableLayerHinting=29]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",oe[oe.domReadOnly=31]="domReadOnly",oe[oe.dragAndDrop=32]="dragAndDrop",oe[oe.dropIntoEditor=33]="dropIntoEditor",oe[oe.emptySelectionClipboard=34]="emptySelectionClipboard",oe[oe.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",oe[oe.extraEditorClassName=36]="extraEditorClassName",oe[oe.fastScrollSensitivity=37]="fastScrollSensitivity",oe[oe.find=38]="find",oe[oe.fixedOverflowWidgets=39]="fixedOverflowWidgets",oe[oe.folding=40]="folding",oe[oe.foldingStrategy=41]="foldingStrategy",oe[oe.foldingHighlight=42]="foldingHighlight",oe[oe.foldingImportsByDefault=43]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=44]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=46]="fontFamily",oe[oe.fontInfo=47]="fontInfo",oe[oe.fontLigatures=48]="fontLigatures",oe[oe.fontSize=49]="fontSize",oe[oe.fontWeight=50]="fontWeight",oe[oe.fontVariations=51]="fontVariations",oe[oe.formatOnPaste=52]="formatOnPaste",oe[oe.formatOnType=53]="formatOnType",oe[oe.glyphMargin=54]="glyphMargin",oe[oe.gotoLocation=55]="gotoLocation",oe[oe.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",oe[oe.hover=57]="hover",oe[oe.inDiffEditor=58]="inDiffEditor",oe[oe.inlineSuggest=59]="inlineSuggest",oe[oe.letterSpacing=60]="letterSpacing",oe[oe.lightbulb=61]="lightbulb",oe[oe.lineDecorationsWidth=62]="lineDecorationsWidth",oe[oe.lineHeight=63]="lineHeight",oe[oe.lineNumbers=64]="lineNumbers",oe[oe.lineNumbersMinChars=65]="lineNumbersMinChars",oe[oe.linkedEditing=66]="linkedEditing",oe[oe.links=67]="links",oe[oe.matchBrackets=68]="matchBrackets",oe[oe.minimap=69]="minimap",oe[oe.mouseStyle=70]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=72]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=74]="multiCursorModifier",oe[oe.multiCursorPaste=75]="multiCursorPaste",oe[oe.multiCursorLimit=76]="multiCursorLimit",oe[oe.occurrencesHighlight=77]="occurrencesHighlight",oe[oe.overviewRulerBorder=78]="overviewRulerBorder",oe[oe.overviewRulerLanes=79]="overviewRulerLanes",oe[oe.padding=80]="padding",oe[oe.parameterHints=81]="parameterHints",oe[oe.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=84]="quickSuggestions",oe[oe.quickSuggestionsDelay=85]="quickSuggestionsDelay",oe[oe.readOnly=86]="readOnly",oe[oe.renameOnType=87]="renameOnType",oe[oe.renderControlCharacters=88]="renderControlCharacters",oe[oe.renderFinalNewline=89]="renderFinalNewline",oe[oe.renderLineHighlight=90]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=92]="renderValidationDecorations",oe[oe.renderWhitespace=93]="renderWhitespace",oe[oe.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",oe[oe.roundedSelection=95]="roundedSelection",oe[oe.rulers=96]="rulers",oe[oe.scrollbar=97]="scrollbar",oe[oe.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=99]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=100]="scrollPredominantAxis",oe[oe.selectionClipboard=101]="selectionClipboard",oe[oe.selectionHighlight=102]="selectionHighlight",oe[oe.selectOnLineNumbers=103]="selectOnLineNumbers",oe[oe.showFoldingControls=104]="showFoldingControls",oe[oe.showUnused=105]="showUnused",oe[oe.snippetSuggestions=106]="snippetSuggestions",oe[oe.smartSelect=107]="smartSelect",oe[oe.smoothScrolling=108]="smoothScrolling",oe[oe.stickyScroll=109]="stickyScroll",oe[oe.stickyTabStops=110]="stickyTabStops",oe[oe.stopRenderingLineAfter=111]="stopRenderingLineAfter",oe[oe.suggest=112]="suggest",oe[oe.suggestFontSize=113]="suggestFontSize",oe[oe.suggestLineHeight=114]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",oe[oe.suggestSelection=116]="suggestSelection",oe[oe.tabCompletion=117]="tabCompletion",oe[oe.tabIndex=118]="tabIndex",oe[oe.unicodeHighlighting=119]="unicodeHighlighting",oe[oe.unusualLineTerminators=120]="unusualLineTerminators",oe[oe.useShadowDOM=121]="useShadowDOM",oe[oe.useTabStops=122]="useTabStops",oe[oe.wordBreak=123]="wordBreak",oe[oe.wordSeparators=124]="wordSeparators",oe[oe.wordWrap=125]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=128]="wordWrapColumn",oe[oe.wordWrapOverride1=129]="wordWrapOverride1",oe[oe.wordWrapOverride2=130]="wordWrapOverride2",oe[oe.wrappingIndent=131]="wrappingIndent",oe[oe.wrappingStrategy=132]="wrappingStrategy",oe[oe.showDeprecated=133]="showDeprecated",oe[oe.inlayHints=134]="inlayHints",oe[oe.editorClassName=135]="editorClassName",oe[oe.pixelRatio=136]="pixelRatio",oe[oe.tabFocusMode=137]="tabFocusMode",oe[oe.layoutInfo=138]="layoutInfo",oe[oe.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(177,null)})),acceptSuggestionOnEnter:Me(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(178,null),""],markdownDescription:c.localize(179,null)})),accessibilitySupport:Me(new s),accessibilityPageSize:Me(new p(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(180,null),tags:["accessibility"]})),ariaLabel:Me(new w(4,"ariaLabel",c.localize(181,null))),autoClosingBrackets:Me(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(182,null),c.localize(183,null),""],description:c.localize(184,null)})),autoClosingDelete:Me(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(185,null),""],description:c.localize(186,null)})),autoClosingOvertype:Me(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(187,null),""],description:c.localize(188,null)})),autoClosingQuotes:Me(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(189,null),c.localize(190,null),""],description:c.localize(191,null)})),autoIndent:Me(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[c.localize(192,null),c.localize(193,null),c.localize(194,null),c.localize(195,null),c.localize(196,null)],description:c.localize(197,null)})),automaticLayout:Me(new h(10,"automaticLayout",!1)),autoSurround:Me(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(198,null),c.localize(199,null),c.localize(200,null),""],description:c.localize(201,null)})),bracketPairColorization:Me(new de),bracketPairGuides:Me(new be),stickyTabStops:Me(new h(110,"stickyTabStops",!1,{description:c.localize(202,null)})),codeLens:Me(new h(14,"codeLens",!0,{description:c.localize(203,null)})),codeLensFontFamily:Me(new w(15,"codeLensFontFamily","",{description:c.localize(204,null)})),codeLensFontSize:Me(new p(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(205,null)})),colorDecorators:Me(new h(17,"colorDecorators",!0,{description:c.localize(206,null)})),colorDecoratorsLimit:Me(new p(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(207,null)})),columnSelection:Me(new h(19,"columnSelection",!1,{description:c.localize(208,null)})),comments:Me(new a),contextmenu:Me(new h(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new h(22,"copyWithSyntaxHighlighting",!0,{description:c.localize(209,null)})),cursorBlinking:Me(new u(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:c.localize(210,null)})),cursorSmoothCaretAnimation:Me(new o(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(211,null),c.localize(212,null),c.localize(213,null)],description:c.localize(214,null)})),cursorStyle:Me(new u(25,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:c.localize(215,null)})),cursorSurroundingLines:Me(new p(26,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(216,null)})),cursorSurroundingLinesStyle:Me(new o(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(217,null),c.localize(218,null)],description:c.localize(219,null)})),cursorWidth:Me(new p(28,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(220,null)})),disableLayerHinting:Me(new h(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new h(30,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new h(31,"domReadOnly",!1)),dragAndDrop:Me(new h(32,"dragAndDrop",!0,{description:c.localize(221,null)})),emptySelectionClipboard:Me(new X),dropIntoEditor:Me(new _e),stickyScroll:Me(new ge),experimentalWhitespaceRendering:Me(new o(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(222,null),c.localize(223,null),c.localize(224,null)],description:c.localize(225,null)})),extraEditorClassName:Me(new w(36,"extraEditorClassName","")),fastScrollSensitivity:Me(new g(37,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:c.localize(226,null)})),find:Me(new q),fixedOverflowWidgets:Me(new h(39,"fixedOverflowWidgets",!1)),folding:Me(new h(40,"folding",!0,{description:c.localize(227,null)})),foldingStrategy:Me(new o(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(228,null),c.localize(229,null)],description:c.localize(230,null)})),foldingHighlight:Me(new h(42,"foldingHighlight",!0,{description:c.localize(231,null)})),foldingImportsByDefault:Me(new h(43,"foldingImportsByDefault",!1,{description:c.localize(232,null)})),foldingMaximumRegions:Me(new p(44,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(233,null)})),unfoldOnClickAfterEndOfLine:Me(new h(45,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(234,null)})),fontFamily:Me(new w(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(235,null)})),fontInfo:Me(new F),fontLigatures2:Me(new N),fontSize:Me(new z),fontWeight:Me(new U),fontVariations:Me(new M),formatOnPaste:Me(new h(52,"formatOnPaste",!1,{description:c.localize(236,null)})),formatOnType:Me(new h(53,"formatOnType",!1,{description:c.localize(237,null)})),glyphMargin:Me(new h(54,"glyphMargin",!0,{description:c.localize(238,null)})),gotoLocation:Me(new H),hideCursorInOverviewRuler:Me(new h(56,"hideCursorInOverviewRuler",!1,{description:c.localize(239,null)})),hover:Me(new x),inDiffEditor:Me(new h(58,"inDiffEditor",!1)),letterSpacing:Me(new g(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>g.clamp(oe,-5,20),{description:c.localize(240,null)})),lightbulb:Me(new Z),lineDecorationsWidth:Me(new J),lineHeight:Me(new fe),lineNumbers:Me(new ee),lineNumbersMinChars:Me(new p(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new h(66,"linkedEditing",!1,{description:c.localize(241,null)})),links:Me(new h(67,"links",!0,{description:c.localize(242,null)})),matchBrackets:Me(new o(68,"matchBrackets","always",["always","near","never"],{description:c.localize(243,null)})),minimap:Me(new ve),mouseStyle:Me(new o(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new g(71,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:c.localize(244,null)})),mouseWheelZoom:Me(new h(72,"mouseWheelZoom",!1,{markdownDescription:c.localize(245,null)})),multiCursorMergeOverlapping:Me(new h(73,"multiCursorMergeOverlapping",!0,{description:c.localize(246,null)})),multiCursorModifier:Me(new u(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ee,{markdownEnumDescriptions:[c.localize(247,null),c.localize(248,null)],markdownDescription:c.localize(249,null)})),multiCursorPaste:Me(new o(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(250,null),c.localize(251,null)],markdownDescription:c.localize(252,null)})),multiCursorLimit:Me(new p(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(253,null)})),occurrencesHighlight:Me(new h(77,"occurrencesHighlight",!0,{description:c.localize(254,null)})),overviewRulerBorder:Me(new h(78,"overviewRulerBorder",!0,{description:c.localize(255,null)})),overviewRulerLanes:Me(new p(79,"overviewRulerLanes",3,0,3)),padding:Me(new Ae),parameterHints:Me(new Fe),peekWidgetDefaultFocus:Me(new o(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(256,null),c.localize(257,null)],description:c.localize(258,null)})),definitionLinkOpensInPeek:Me(new h(83,"definitionLinkOpensInPeek",!1,{description:c.localize(259,null)})),quickSuggestions:Me(new le),quickSuggestionsDelay:Me(new p(85,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(260,null)})),readOnly:Me(new h(86,"readOnly",!1)),renameOnType:Me(new h(87,"renameOnType",!1,{description:c.localize(261,null),markdownDeprecationMessage:c.localize(262,null)})),renderControlCharacters:Me(new h(88,"renderControlCharacters",!0,{description:c.localize(263,null),restricted:!0})),renderFinalNewline:Me(new o(89,"renderFinalNewline",t.isLinux?"dimmed":"on",["off","on","dimmed"],{description:c.localize(264,null)})),renderLineHighlight:Me(new o(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(265,null)],description:c.localize(266,null)})),renderLineHighlightOnlyWhenFocus:Me(new h(91,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(267,null)})),renderValidationDecorations:Me(new o(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new o(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(268,null),c.localize(269,null),c.localize(270,null),""],description:c.localize(271,null)})),revealHorizontalRightPadding:Me(new p(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new h(95,"roundedSelection",!0,{description:c.localize(272,null)})),rulers:Me(new ie),scrollbar:Me(new W),scrollBeyondLastColumn:Me(new p(98,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(273,null)})),scrollBeyondLastLine:Me(new h(99,"scrollBeyondLastLine",!0,{description:c.localize(274,null)})),scrollPredominantAxis:Me(new h(100,"scrollPredominantAxis",!0,{description:c.localize(275,null)})),selectionClipboard:Me(new h(101,"selectionClipboard",!0,{description:c.localize(276,null),included:t.isLinux})),selectionHighlight:Me(new h(102,"selectionHighlight",!0,{description:c.localize(277,null)})),selectOnLineNumbers:Me(new h(103,"selectOnLineNumbers",!0)),showFoldingControls:Me(new o(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(278,null),c.localize(279,null),c.localize(280,null)],description:c.localize(281,null)})),showUnused:Me(new h(105,"showUnused",!0,{description:c.localize(282,null)})),showDeprecated:Me(new h(133,"showDeprecated",!0,{description:c.localize(283,null)})),inlayHints:Me(new te),snippetSuggestions:Me(new o(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(284,null),c.localize(285,null),c.localize(286,null),c.localize(287,null)],description:c.localize(288,null)})),smartSelect:Me(new De),smoothScrolling:Me(new h(108,"smoothScrolling",!1,{description:c.localize(289,null)})),stopRenderingLineAfter:Me(new p(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new pe),inlineSuggest:Me(new Y),suggestFontSize:Me(new p(113,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(290,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new p(114,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(291,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new h(115,"suggestOnTriggerCharacters",!0,{description:c.localize(292,null)})),suggestSelection:Me(new o(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(293,null),c.localize(294,null),c.localize(295,null)],description:c.localize(296,null)})),tabCompletion:Me(new o(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(297,null),c.localize(298,null),c.localize(299,null)],description:c.localize(300,null)})),tabIndex:Me(new p(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new K),unusualLineTerminators:Me(new o(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],description:c.localize(304,null)})),useShadowDOM:Me(new h(121,"useShadowDOM",!0)),useTabStops:Me(new h(122,"useTabStops",!0,{description:c.localize(305,null)})),wordBreak:Me(new o(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),wordSeparators:Me(new w(124,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:c.localize(309,null)})),wordWrap:Me(new o(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(310,null),c.localize(311,null),c.localize(312,null),c.localize(313,null)],description:c.localize(314,null)})),wordWrapBreakAfterCharacters:Me(new w(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new w(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new p(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(315,null)})),wordWrapOverride1:Me(new o(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new o(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new B),pixelRatio:Me(new se),tabFocusMode:Me(new ke),layoutInfo:Me(new _),wrappingInfo:Me(new et),wrappingIndent:Me(new Ge),wrappingStrategy:Me(new Q)}}),define(ye[166],Ce([19,20]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[167],Ce([19,20]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[168],Ce([19,20]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[169],Ce([19,20]),function(ne,e){return ne.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[170],Ce([19,20]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ye[171],Ce([19,20]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(ye[172],Ce([19,20]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ye[173],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[174],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[175],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[176],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[177],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[178],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[179],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[180],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[181],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[182],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(ye[183],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[184],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[185],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[186],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[187],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[188],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[189],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[190],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[191],Ce([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(A,C){this.a.set(A,C)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const C in A.contributes){const T=this.a.get(C);if(!T)continue;const S=A.contributes[C],y=Array.isArray(S)?S:[S];try{T(y,A.activationEvents)}catch(L){(0,c.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ye[192],Ce([1,0,24,43,168,310]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function S(h){return h=h.trim(),h==="*"||C.test(h)}e.isValidVersionStr=S;function y(h){if(!S(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=h.match(C);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=y;function L(h){if(!h)return null;const b=h.majorBase,p=h.majorMustEqual,g=h.minorBase;let w=h.minorMustEqual;const i=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(b===0||(w=!1),o=!1);let u=0;if(h.preRelease){const l=T.exec(h.preRelease);if(l){const[,s,a,n]=l;u=Date.UTC(Number(s),Number(a)-1,Number(n))}}return{majorBase:b,majorMustEqual:p,minorBase:g,minorMustEqual:w,patchBase:i,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:u}}e.normalizeVersion=L;function P(h,b,p){let g;typeof h=="string"?g=L(y(h)):g=h;let w;b instanceof Date?w=b.getTime():typeof b=="string"&&(w=new Date(b).getTime());let i;if(typeof p=="string"?i=L(y(p)):i=p,!g||!i)return!1;const o=g.majorBase,u=g.minorBase,l=g.patchBase;let s=i.majorBase,a=i.minorBase,n=i.patchBase;const r=i.notBefore;let f=i.majorMustEqual,I=i.minorMustEqual,R=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:u>a?!0:u<a||w&&w<r?!1:l>=n:(o===1&&s===0&&(!f||!I||!R)&&(s=1,a=0,n=0,f=!0,I=!1,R=!1),o<s?!1:o>s?!f:u<a?!1:u>a?!I:l<n?!1:l>n?!R:!(w&&w<r))}e.isValidVersion=P;function v(h,b,p,g,w){const i=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof g.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof g.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!g.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof g.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof g.extensionDependencies<"u"&&!m(g.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof g.activationEvents<"u"){if(!m(g.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof g.main>"u"&&typeof g.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const l=(0,c.joinPath)(p,g.main);(0,c.isEqualOrParent)(l,p)||i.push([t.default.Warning,k.localize(10,null,l.path,p.path)])}if(typeof g.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof g.browser<"u"){if(typeof g.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const l=(0,c.joinPath)(p,g.browser);(0,c.isEqualOrParent)(l,p)||i.push([t.default.Warning,k.localize(13,null,l.path,p.path)])}if(typeof g.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!A.valid(g.version))return i.push([t.default.Error,k.localize(15,null)]),i;const o=[];if(!D(h,b,g,w,o))for(const l of o)i.push([t.default.Error,l]);return i}e.validateExtensionManifest=v;function D(h,b,p,g,w){return g||typeof p.main>"u"&&typeof p.browser>"u"?!0:d(h,b,p.engines.vscode,w)}e.isValidExtensionVersion=D;function E(h,b,p){return h==="*"||d(b,p,h)}e.isEngineValid=E;function d(h,b,p,g=[]){const w=L(y(p));if(!w)return g.push(k.localize(16,null,p)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return g.push(k.localize(17,null,p)),!1}else if(!w.majorMustEqual)return g.push(k.localize(18,null,p)),!1;return P(h,b,w)?!0:(g.push(k.localize(19,null,h,p)),!1)}function m(h){if(!Array.isArray(h))return!1;for(let b=0,p=h.length;b<p;b++)if(typeof h[b]!="string")return!1;return!0}}),define(ye[121],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(k,A=[],C=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=c}),define(ye[88],Ce([1,0,121]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function A(T,S,y){S instanceof c.SyncDescriptor||(S=new c.SyncDescriptor(S,[],Boolean(y))),t.push([T,S])}e.registerSingleton=A;function C(){return t}e.getSingletonServiceDescriptors=C}),define(ye[193],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(A,C){this.key=A,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class t{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const C of this.a.values())C.outgoing.size===0&&A.push(C);return A}insertEdge(A,C){const T=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(C);T.outgoing.set(S.key,S),S.incoming.set(T.key,T)}removeNode(A){const C=this.b(A);this.a.delete(C);for(const T of this.a.values())T.outgoing.delete(C),T.incoming.delete(C)}lookupOrInsertNode(A){const C=this.b(A);let T=this.a.get(C);return T||(T=new c(C,A),this.a.set(C,T)),T}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[C,T]of this.a)A.push(`${C}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,C]of this.a){const T=new Set([A]),S=this.c(C,T);if(S)return S}}c(A,C){for(const[T,S]of A.outgoing){if(C.has(T))return[...C,T].join(" -> ");C.add(T);const y=this.c(S,C);if(y)return y;C.delete(T)}}}e.Graph=t}),define(ye[3],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=T})(c=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(C,T,S){T[c.DI_TARGET]===T?T[c.DI_DEPENDENCIES].push({id:C,index:S}):(T[c.DI_DEPENDENCIES]=[{id:C,index:S}],T[c.DI_TARGET]=T)}function k(C){if(c.serviceIds.has(C))return c.serviceIds.get(C);const T=function(S,y,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(T,S,L)};return T.toString=()=>C,c.serviceIds.set(C,T),T}e.createDecorator=k;function A(C){return C}e.refineServiceDecorator=A}),define(ye[52],Ce([1,0,11,2,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationOverrides=A;function C(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=C;var T;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function y(h,b){const p=Object.create(null);for(const g in h)L(p,g,h[g],b);return p}e.toValuesTree=y;function L(h,b,p,g){const w=b.split("."),i=w.pop();let o=h;for(let u=0;u<w.length;u++){const l=w[u];let s=o[l];switch(typeof s){case"undefined":s=o[l]=Object.create(null);break;case"object":break;default:g(`Ignoring ${b} as ${w.slice(0,u+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[i]=p}catch{g(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=L;function P(h,b){const p=b.split(".");v(h,p)}e.removeFromValueTree=P;function v(h,b){const p=b.shift();if(b.length===0){delete h[p];return}if(Object.keys(h).indexOf(p)!==-1){const g=h[p];typeof g=="object"&&!Array.isArray(g)&&(v(g,b),Object.keys(g).length===0&&delete h[p])}}function D(h,b,p){function g(o,u){let l=o;for(const s of u){if(typeof l!="object"||l===null)return;l=l[s]}return l}const w=b.split("."),i=g(h,w);return typeof i>"u"?p:i}e.getConfigurationValue=D;function E(h,b,p){Object.keys(b).forEach(g=>{g!=="__proto__"&&(g in h?c.isObject(h[g])&&c.isObject(b[g])?E(h[g],b[g],p):p&&(h[g]=b[g]):h[g]=b[g])})}e.merge=E;function d(h,b,p){const g=h.inspect(b),w=h.inspect(p);return typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:g.defaultValue}e.getMigratedSettingValue=d;function m(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(ye[53],Ce([1,0,12,8,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",c.isMacintosh),A.set("isLinux",c.isLinux),A.set("isWindows",c.isWindows),A.set("isWeb",c.isWeb),A.set("isMacNative",c.isMacintosh&&!c.isWeb),A.set("isEdge",c.isEdge),A.set("isFirefox",c.isFirefox),A.set("isChrome",c.isChrome),A.set("isSafari",c.isSafari);const C=Object.prototype.hasOwnProperty;var T;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return P.INSTANCE}static true(){return v.INSTANCE}static has(N){return D.create(N)}static equals(N,M){return E.create(N,M)}static notEquals(N,M){return h.create(N,M)}static regex(N,M){return u.create(N,M)}static in(N,M){return d.create(N,M)}static notIn(N,M){return m.create(N,M)}static not(N){return b.create(N)}static and(...N){return a.create(N,null,!0)}static or(...N){return n.create(N,null,!0)}static greater(N,M){return g.create(N,M)}static greaterEquals(N,M){return w.create(N,M)}static smaller(N,M){return i.create(N,M)}static smallerEquals(N,M){return o.create(N,M)}static deserialize(N,M=!1){if(!!N)return this.c(N,M)}static c(N,M){const F=N.split("||");return n.create(F.map(z=>this.d(z,M)),null,!0)}static d(N,M){const F=N.split("&&");return a.create(F.map(z=>this.f(z,M)),null,!0)}static f(N,M){if(N=N.trim(),N.indexOf("!=")>=0){const F=N.split("!=");return h.create(F[0].trim(),this.g(F[1],M))}if(N.indexOf("==")>=0){const F=N.split("==");return E.create(F[0].trim(),this.g(F[1],M))}if(N.indexOf("=~")>=0){const F=N.split("=~");return u.create(F[0].trim(),this.h(F[1],M))}if(N.indexOf(" not in ")>=0){const F=N.split(" not in ");return m.create(F[0].trim(),this.g(F[1],M))}if(N.indexOf(" in ")>=0){const F=N.split(" in ");return d.create(F[0].trim(),this.g(F[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(N)){const F=N.split(">=");return w.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(N)){const F=N.split(">");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(N)){const F=N.split("<=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(N)){const F=N.split("<");return i.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(N)?b.create(N.substr(1).trim()):D.create(N)}static g(N,M){if(N=N.trim(),N==="true")return!0;if(N==="false")return!1;const F=/^'([^']*)'$/.exec(N);return F?F[1].trim():N}static h(N,M){if((0,t.isFalsyOrWhitespace)(N)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=N.indexOf("/"),z=N.lastIndexOf("/");if(F===z||F<0){if(M)throw new Error(`bad regexp-value '${N}', missing /-enclosure`);return console.warn(`bad regexp-value '${N}', missing /-enclosure`),null}const U=N.slice(F+1,z),H=N[z+1]==="i"?"i":"";try{return new RegExp(U,H)}catch(x){if(M)throw new Error(`bad regexp-value '${N}', parse error: ${x}`);return console.warn(`bad regexp-value '${N}', parse error: ${x}`),null}}}e.ContextKeyExpr=S;function y(q,N){const M=q?q.substituteConstants():void 0,F=N?N.substituteConstants():void 0;return!M&&!F?!0:!M||!F?!1:M.equals(F)}e.expressionsAreEqualWithConstantSubstitution=y;function L(q,N){return q.cmp(N)}class P{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class v{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class D{static create(N,M=null){const F=A.get(N);return typeof F=="boolean"?F?v.INSTANCE:P.INSTANCE:new D(N,M)}constructor(N,M){this.key=N,this.c=M,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:f(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=A.get(this.key);return typeof N=="boolean"?N?v.INSTANCE:P.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=b.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=D;class E{static create(N,M,F=null){if(typeof M=="boolean")return M?D.create(N,F):b.create(N,F);const z=A.get(N);return typeof z=="boolean"?M===(z?"true":"false")?v.INSTANCE:P.INSTANCE:new E(N,M,F)}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=A.get(this.c);if(typeof N=="boolean"){const M=N?"true":"false";return this.d===M?v.INSTANCE:P.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=E;class d{static create(N,M){return new d(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:I(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const M=N.getValue(this.f),F=N.getValue(this.d);return Array.isArray(M)?M.includes(F):typeof F=="string"&&typeof M=="object"&&M!==null?C.call(M,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=d;class m{static create(N,M){return new m(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=11,this.c=d.create(N,M)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=m;class h{static create(N,M,F=null){if(typeof M=="boolean")return M?b.create(N,F):D.create(N,F);const z=A.get(N);return typeof z=="boolean"?M===(z?"true":"false")?P.INSTANCE:v.INSTANCE:new h(N,M,F)}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=A.get(this.c);if(typeof N=="boolean"){const M=N?"true":"false";return this.d===M?P.INSTANCE:v.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=h;class b{static create(N,M=null){const F=A.get(N);return typeof F=="boolean"?F?P.INSTANCE:v.INSTANCE:new b(N,M)}constructor(N,M){this.c=N,this.d=M,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:f(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=A.get(this.c);return typeof N=="boolean"?N?P.INSTANCE:v.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.ContextKeyNotExpr=b;function p(q,N){if(typeof q=="string"){const M=parseFloat(q);isNaN(M)||(q=M)}return typeof q=="string"||typeof q=="number"?N(q):P.INSTANCE}class g{static create(N,M,F=null){return p(M,z=>new g(N,z,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=g;class w{static create(N,M,F=null){return p(M,z=>new w(N,z,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class i{static create(N,M,F=null){return p(M,z=>new i(N,z,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class o{static create(N,M,F=null){return p(M,z=>new o(N,z,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:I(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=o;class u{static create(N,M){return new u(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const M=this.f?this.f.source:"",F=N.f?N.f.source:"";return M<F?-1:M>F?1:0}equals(N){if(N.type===this.type){const M=this.f?this.f.source:"",F=N.f?N.f.source:"";return this.d===N.d&&M===F}return!1}substituteConstants(){return this}evaluate(N){const M=N.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=l.create(this)),this.c}}e.ContextKeyRegexExpr=u;class l{static create(N){return new l(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(N){return new l(this.c.map(N))}negate(){return this.c}}e.ContextKeyNotRegexExpr=l;function s(q){let N=null;for(let M=0,F=q.length;M<F;M++){const z=q[M].substituteConstants();if(q[M]!==z&&N===null){N=[];for(let U=0;U<M;U++)N[U]=q[U]}N!==null&&(N[M]=z)}return N===null?q:N}class a{static create(N,M,F){return a.d(N,M,F)}constructor(N,M){this.expr=N,this.c=M,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const z=L(this.expr[M],N.expr[M]);if(z!==0)return z}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(N.expr[M]))return!1;return!0}return!1}substituteConstants(){const N=s(this.expr);return N===this.expr?this:a.create(N,this.c,!1)}evaluate(N){for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].evaluate(N))return!1;return!0}static d(N,M,F){const z=[];let U=!1;for(const H of N)if(!!H){if(H.type===1){U=!0;continue}if(H.type===0)return P.INSTANCE;if(H.type===6){z.push(...H.expr);continue}z.push(H)}if(z.length===0&&U)return v.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(L);for(let H=1;H<z.length;H++)z[H-1].equals(z[H])&&(z.splice(H,1),H--);if(z.length===1)return z[0];for(;z.length>1;){const H=z[z.length-1];if(H.type!==9)break;z.pop();const x=z.pop(),V=z.length===0,_=n.create(H.expr.map(Q=>a.create([Q,x],null,F)),null,V);_&&(z.push(_),z.sort(L))}if(z.length===1)return z[0];if(F){for(let H=0;H<z.length;H++)for(let x=H+1;x<z.length;x++)if(z[H].negate().equals(z[x]))return P.INSTANCE;if(z.length===1)return z[0]}return new a(z,M)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const M of this.expr)N.push(...M.keys());return N}map(N){return new a(this.expr.map(M=>M.map(N)),null)}negate(){if(!this.c){const N=[];for(const M of this.expr)N.push(M.negate());this.c=n.create(N,this,!0)}return this.c}}class n{static create(N,M,F){return n.d(N,M,F)}constructor(N,M){this.expr=N,this.c=M,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const z=L(this.expr[M],N.expr[M]);if(z!==0)return z}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(N.expr[M]))return!1;return!0}return!1}substituteConstants(){const N=s(this.expr);return N===this.expr?this:n.create(N,this.c,!1)}evaluate(N){for(let M=0,F=this.expr.length;M<F;M++)if(this.expr[M].evaluate(N))return!0;return!1}static d(N,M,F){let z=[],U=!1;if(N){for(let H=0,x=N.length;H<x;H++){const V=N[H];if(!!V){if(V.type===0){U=!0;continue}if(V.type===1)return v.INSTANCE;if(V.type===9){z=z.concat(V.expr);continue}z.push(V)}}if(z.length===0&&U)return P.INSTANCE;z.sort(L)}if(z.length!==0){if(z.length===1)return z[0];for(let H=1;H<z.length;H++)z[H-1].equals(z[H])&&(z.splice(H,1),H--);if(z.length===1)return z[0];if(F){for(let H=0;H<z.length;H++)for(let x=H+1;x<z.length;x++)if(z[H].negate().equals(z[x]))return v.INSTANCE;if(z.length===1)return z[0]}return new n(z,M)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const M of this.expr)N.push(...M.keys());return N}map(N){return new n(this.expr.map(M=>M.map(N)),null)}negate(){if(!this.c){const N=[];for(const M of this.expr)N.push(M.negate());for(;N.length>1;){const M=N.shift(),F=N.shift(),z=[];for(const U of X(M))for(const H of X(F))z.push(a.create([U,H],null,!1));N.unshift(n.create(z,null,!1))}this.c=n.create(N,this,!0)}return this.c}}class r extends D{static all(){return r.d.values()}constructor(N,M,F){super(N,null),this.f=M,typeof F=="object"?r.d.push({...F,key:N}):F!==!0&&r.d.push({key:N,description:F,type:M!=null?typeof M:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return E.create(this.key,N)}notEqualsTo(N){return h.create(this.key,N)}}e.RawContextKey=r,r.d=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService");function f(q,N){return q<N?-1:q>N?1:0}function I(q,N,M,F){return q<M?-1:q>M?1:N<F?-1:N>F?1:0}function R(q,N){if(q.type===0||N.type===1)return!0;if(q.type===9)return N.type===9?B(q.expr,N.expr):!1;if(N.type===9){for(const M of N.expr)if(R(q,M))return!0;return!1}if(q.type===6){if(N.type===6)return B(N.expr,q.expr);for(const M of q.expr)if(R(M,N))return!0;return!1}return q.equals(N)}e.implies=R;function B(q,N){let M=0,F=0;for(;M<q.length&&F<N.length;){const z=q[M].cmp(N[F]);if(z<0)return!1;z===0&&M++,F++}return M===q.length}function X(q){return q.type===9?q.expr:[q]}}),define(ye[194],Ce([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[122],Ce([1,0,167,3]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function C(h,b){switch(h){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function T(h,b){return b==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function S(h,b,p){return T(b,p)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===p?!0:y(p).includes(h)}e.isTargetPlatformCompatible=S;function y(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function L(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=L;var P;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var D;(function(h){h.Install="install",h.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var E;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var d;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class m extends Error{constructor(b,p){super(b),this.code=p,this.name=p}}e.ExtensionManagementError=m,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,c.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ye[195],Ce([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(ye[196],Ce([1,0,45,15,9,12,107,29,115,169,195]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=y.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:D.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class D extends v{openTerminal(g,w){return this.spawnTerminal(c,g,S.getWindowsShell(),w)}spawnTerminal(g,w,i,o){const u=w.windowsExec||D.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const l=k.basename(u).toLowerCase();if(l==="cmder"||l==="cmder.exe")return g.spawn(u,o?[o]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return u.indexOf(" ")>=0&&s.push('""'),s.push(u),(l==="wt"||l==="wt.exe")&&s.push("-d ."),new Promise((a,n)=>{const r=m(process),f=g.spawn(i,s,{cwd:o,env:r});f.on("error",n),f.on("exit",()=>a())})}runInTerminal(g,w,i,o,u){const l="windowsExec"in u&&u.windowsExec?u.windowsExec:D.getDefaultTerminalWindows();return new Promise((s,a)=>{const n=`"${w} - ${P}"`,r=`""${i.join('" "')}" & pause"`,f=["/c","start",n,"/wait",l,"/c",r],I=Object.assign({},m(process),o);Object.keys(I).filter(X=>I[X]===null).forEach(X=>delete I[X]);const R={cwd:w,env:I,windowsVerbatimArguments:!0};c.spawn(D.b,f,R).on("error",X=>{a(h(X))}),s(void 0)})}static getDefaultTerminalWindows(){if(!D.d){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");D.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return D.d}}e.WindowsExternalTerminalService=D,D.b="cmd.exe";class E extends v{openTerminal(g,w){return this.spawnTerminal(c,g,w)}runInTerminal(g,w,i,o,u){const l=u.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{if(l===L.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const n=l===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",g||P,"-w",w];for(const B of i)f.push("-a"),f.push(B);if(o){const B=Object.assign({},m(process),o);for(const X in B){const q=B[X];q===null?(f.push("-u"),f.push(X)):(f.push("-e"),f.push(`${X}=${q}`))}}let I="";const R=c.spawn(E.b,f);R.on("error",B=>{a(h(B))}),R.stderr.on("data",B=>{I+=B.toString()}),R.on("exit",B=>{if(B===0)s(void 0);else if(I){const X=I.split(`
`,1);a(new Error(X[0]))}else a(new Error(y.localize(1,null,n,B)))})}else a(new Error(y.localize(2,null,l)))})}spawnTerminal(g,w,i){const o=w.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((u,l)=>{const s=["-a",o];i&&s.push(i);const a=m(process),n=g.spawn("/usr/bin/open",s,{cwd:i,env:a});n.on("error",l),n.on("exit",()=>u())})}}e.MacExternalTerminalService=E,E.b="/usr/bin/osascript";class d extends v{openTerminal(g,w){return this.spawnTerminal(c,g,w)}runInTerminal(g,w,i,o,u){const l=u.linuxExec?Promise.resolve(u.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{const n=[];l.then(r=>{r.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const f=`${b(i)}; echo; read -p "${d.b}" -n1;`;n.push(`''${f}''`);const I=Object.assign({},m(process),o);Object.keys(I).filter(q=>I[q]===null).forEach(q=>delete I[q]);const R={cwd:w,env:I};let B="";const X=c.spawn(r,n,R);X.on("error",q=>{a(h(q))}),X.stderr.on("data",q=>{B+=q.toString()}),X.on("exit",q=>{if(q===0)s(void 0);else if(B){const N=B.split(`
`,1);a(new Error(N[0]))}else a(new Error(y.localize(4,null,r,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!A.isLinux)d.d=Promise.resolve("xterm");else{const g=await T.Promises.exists("/etc/debian_version");d.d=new Promise(w=>{g?w("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?w("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?w("konsole"):process.env.COLORTERM?w(process.env.COLORTERM):process.env.TERM?w(process.env.TERM):w("xterm")})}return d.d}spawnTerminal(g,w,i){const o=w.linuxExec?Promise.resolve(w.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((u,l)=>{o.then(s=>{const a=m(process),n=g.spawn(s,[],{cwd:i,env:a});n.on("error",l),n.on("exit",()=>u())})})}}e.LinuxExternalTerminalService=d,d.b=y.localize(3,null);function m(p){const g={...p.env};return(0,C.sanitizeProcessEnvironment)(g),g}function h(p){return"errno"in p&&p.errno==="ENOENT"&&"path"in p&&typeof p.path=="string"?new Error(y.localize(5,null,p.path)):p}function b(p){let g="";for(const w of p)w.indexOf(" ")>=0?g+='"'+w+'"':g+=w,g+=" ";return g}}),define(ye[38],Ce([1,0,64,9,8,11,2,170,3]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function y(U){return U.create===!0}e.isFileOpenForWriteOptions=y;var L;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var P;(function(U){U[U.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var v;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function D(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=D;function E(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=E;function d(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=d;function m(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function h(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=h;function b(U){return D(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var p;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(H,x){super(H),this.code=x}}e.FileSystemProviderError=g;function w(U,H){const x=new g(U.toString(),H);return o(x,H),x}e.createFileSystemProviderError=w;function i(U){return U||w((0,T.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=i;function o(U,H){return U.name=H?`${H} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=o;function u(U){if(!U)return p.Unknown;if(U instanceof g)return U.code;const H=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!H)return p.Unknown;switch(H[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=u;function l(U){if(U instanceof I)return U.fileOperationResult;switch(u(U)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(H,x,V){this.resource=H,this.operation=x,this.target=V}isOperation(H){return this.operation===H}}e.FileOperationEvent=a;var n;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class r{constructor(H,x){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const V=new Map;for(const _ of H){const Q=V.get(_.type);switch(Q?Q.push([_.resource,_]):V.set(_.type,[[_.resource,_]]),_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}}for(const[_,Q]of V)switch(_){case 1:this.a=c.TernarySearchTree.forUris(()=>x),this.a.fill(Q);break;case 0:this.b=c.TernarySearchTree.forUris(()=>x),this.b.fill(Q);break;case 2:this.c=c.TernarySearchTree.forUris(()=>x),this.c.fill(Q);break}}contains(H,...x){return this.d(H,{includeChildren:!1},...x)}affects(H,...x){return this.d(H,{includeChildren:!0},...x)}d(H,x,...V){if(!H)return!1;const _=V.length>0;return!!((!_||V.includes(1))&&(this.a?.get(H)||x.includeChildren&&this.a?.findSuperstr(H))||(!_||V.includes(0))&&(this.b?.get(H)||x.includeChildren&&this.b?.findSuperstr(H))||(!_||V.includes(2))&&(this.c?.findSubstr(H)||x.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=r;function f(U,H,x){return!U||!H||U===H||H.length>U.length?!1:(H.charAt(H.length-1)!==t.sep&&(H+=t.sep),x?(0,k.startsWithIgnoreCase)(U,H):U.indexOf(H)===0)}e.isParent=f;class I extends Error{constructor(H,x,V){super(H),this.fileOperationResult=x,this.options=V}}e.FileOperationError=I;class R extends I{constructor(H,x,V){super(H,2,V),this.stat=x}}e.NotModifiedSinceFileOperationError=R;var B;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(B=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var X;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(X=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function q(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=q;async function N(U,H){if(!H.hasProvider(C.URI.from({scheme:U.scheme})))return new Promise(x=>{const V=H.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===U.scheme&&_.added&&(V.dispose(),x())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(H){return(0,A.isNumber)(H)||(H=0),H<M.KB?(0,T.localize)(1,null,H.toFixed(0)):H<M.MB?(0,T.localize)(2,null,(H/M.KB).toFixed(2)):H<M.GB?(0,T.localize)(3,null,(H/M.MB).toFixed(2)):H<M.TB?(0,T.localize)(4,null,(H/M.GB).toFixed(2)):(0,T.localize)(5,null,(H/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var F;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function z(U){return{maxFileSize:U===0?300*M.MB:16*M.GB,maxHeapSize:U===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=z}),define(ye[89],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...k){this.a=new Map;for(const[A,C]of k)this.set(A,C)}set(k,A){const C=this.a.get(k);return this.a.set(k,A),C}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=c}),define(ye[197],Ce([1,0,18,10,6,121,193,3,89,63]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class P extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class v{constructor(m=new S.ServiceCollection,h=!1,b,p=L){this.f=m,this.g=h,this.h=b,this.i=p,this.o=new Set,this.f.set(T.IInstantiationService,this),this._globalGraph=p?b?._globalGraph??new C.Graph(g=>g):void 0}createChild(m){return new v(m,this.g,this,this.i)}invokeFunction(m,...h){const b=E.traceInvocation(this.i,m);let p=!1;try{return m({get:w=>{if(p)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(w,b);if(!i)throw new Error(`[invokeFunction] unknown service '${w}'`);return i}},...h)}finally{p=!0,b.stop()}}createInstance(m,...h){let b,p;return m instanceof A.SyncDescriptor?(b=E.traceCreation(this.i,m.ctor),p=this.j(m.ctor,m.staticArguments.concat(h),b)):(b=E.traceCreation(this.i,m),p=this.j(m,h,b)),b.stop(),p}j(m,h=[],b){const p=T._util.getServiceDependencies(m).sort((i,o)=>i.index-o.index),g=[];for(const i of p){const o=this.m(i.id,b);o||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),g.push(o)}const w=p.length>0?p[0].index:h.length;if(h.length!==w){console.trace(`[createInstance] First service dependency of ${m.name} at position ${w+1} conflicts with ${h.length} static arguments`);const i=w-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,w)}return Reflect.construct(m,h.concat(g))}k(m,h){if(this.f.get(m)instanceof A.SyncDescriptor)this.f.set(m,h);else if(this.h)this.h.k(m,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const h=this.f.get(m);return!h&&this.h?this.h.l(m):h}m(m,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const b=this.l(m);return b instanceof A.SyncDescriptor?this.q(m,b,h.branch(m,!0)):(h.branch(m,!1),b)}q(m,h,b){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,h,b)}finally{this.o.delete(m)}}r(m,h,b){const p=new C.Graph(i=>i.id.toString());let g=0;const w=[{id:m,desc:h,_trace:b}];for(;w.length;){const i=w.pop();if(p.lookupOrInsertNode(i),g++>1e3)throw new P(p);for(const o of T._util.getServiceDependencies(i.desc.ctor)){const u=this.l(o.id);if(u||this.u(`[createInstance] ${m} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),u instanceof A.SyncDescriptor){const l={id:o.id,desc:u,_trace:i._trace.branch(o.id,!0)};p.insertEdge(i,l),w.push(l)}}}for(;;){const i=p.roots();if(i.length===0){if(!p.isEmpty())throw new P(p);break}for(const{data:o}of i){if(this.l(o.id)instanceof A.SyncDescriptor){const l=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,l)}p.removeNode(o)}}return this.l(m)}s(m,h,b=[],p,g){if(this.f.get(m)instanceof A.SyncDescriptor)return this.t(m,h,b,p,g);if(this.h)return this.h.s(m,h,b,p,g);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(m,h,b=[],p,g){if(p){const w=new v(void 0,this.g,this,this.i);w.c=String(m);const i=new Map,o=new c.IdleValue(()=>{const u=w.j(h,b,g);for(const[l,s]of i){const a=u[l];if(typeof a=="function")for(const n of s)a.apply(u,n)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,l){if(!o.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let n=i.get(l);return n||(n=new y.LinkedList,i.set(l,n)),(f,I,R)=>{const B=n.push([f,I,R]);return(0,k.toDisposable)(B)}}if(l in u)return u[l];const s=o.value;let a=s[l];return typeof a!="function"||(a=a.bind(s),u[l]=a),a},set(u,l,s){return o.value[l]=s,!0},getPrototypeOf(u){return h.prototype}})}else return this.j(h,b,g)}u(m,h){if(h&&console.warn(m),this.g)throw new Error(m)}}e.InstantiationService=v;var D;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(D||(D={}));class E{static traceInvocation(m,h){return m?new E(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(m,h){return m?new E(1,h.name):E.c}constructor(m,h){this.type=m,this.name=h,this.g=Date.now(),this.h=[]}branch(m,h){const b=new E(3,m.toString());return this.h.push([m,h,b]),b}stop(){const m=Date.now()-this.g;E.f+=m;let h=!1;function b(g,w){const i=[],o=new Array(g+1).join("	");for(const[u,l,s]of w.h)if(l&&s){h=!0,i.push(`${o}CREATES -> ${u}`);const a=b(g+1,s);a&&i.push(a)}else i.push(`${o}uses -> ${u}`);return i.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(m>2||h)&&E.all.add(p.join(`
`))}}e.Trace=E,E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0}),define(ye[13],Ce([1,0,51,4,6,28,12,2,3]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function y(){return new Date().toISOString()}var L;(function(a){a[a.Off=0]="Off",a[a.Trace=1]="Trace",a[a.Debug=2]="Debug",a[a.Info=3]="Info",a[a.Warning=4]="Warning",a[a.Error=5]="Error"})(L=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=L.Info;function P(a,n,r){switch(n){case L.Trace:a.trace(r);break;case L.Debug:a.debug(r);break;case L.Info:a.info(r);break;case L.Warning:a.warn(r);break;case L.Error:a.error(r);break;case L.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=P;function v(a){let n="";for(let r=0;r<a.length;r++){let f=a[r];if(typeof f=="object")try{f=JSON.stringify(f)}catch{}n+=(r>0?" ":"")+f}return n}e.format=v;class D extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==L.Off&&this.b<=n}}e.AbstractLogger=D;class E extends D{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...r){this.f(L.Trace)&&this.g(L.Trace,v([n,...r]))}debug(n,...r){this.f(L.Debug)&&this.g(L.Debug,v([n,...r]))}info(n,...r){this.f(L.Info)&&this.g(L.Info,v([n,...r]))}warn(n,...r){this.f(L.Warning)&&this.g(L.Warning,v([n,...r]))}error(n,...r){if(this.f(L.Error))if(n instanceof Error){const f=Array.prototype.slice.call(arguments);f[0]=n.stack,this.g(L.Error,v(f))}else this.g(L.Error,v([n,...r]))}flush(){}}e.AbstractMessageLogger=E;class d extends D{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!C.isWindows}trace(n,...r){this.f(L.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...r):console.log(`[main ${y()}]`,n,...r))}debug(n,...r){this.f(L.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...r):console.log(`[main ${y()}]`,n,...r))}info(n,...r){this.f(L.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...r):console.log(`[main ${y()}]`,n,...r))}warn(n,...r){this.f(L.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,n,...r):console.warn(`[main ${y()}]`,n,...r))}error(n,...r){this.f(L.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,n,...r):console.error(`[main ${y()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class m extends D{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.f(L.Trace)&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.f(L.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.f(L.Info)&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.f(L.Warning)&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.f(L.Error)&&console.log("%c  ERR","color: #f33",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=m;class h extends D{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(r)}trace(n,...r){this.f(L.Trace)&&this.g.log(L.Trace,[this.h(n),...r])}debug(n,...r){this.f(L.Debug)&&this.g.log(L.Debug,[this.h(n),...r])}info(n,...r){this.f(L.Info)&&this.g.log(L.Info,[this.h(n),...r])}warn(n,...r){this.f(L.Warning)&&this.g.log(L.Warning,[this.h(n),...r])}error(n,...r){this.f(L.Error)&&this.g.log(L.Error,[this.h(n),...r])}h(n){return typeof n=="string"?n:(0,c.toErrorMessage)(n,this.f(L.Trace))}dispose(){}flush(){}}e.AdapterLogger=h;class b extends D{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.g)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const f of this.g)f.trace(n,...r)}debug(n,...r){for(const f of this.g)f.debug(n,...r)}info(n,...r){for(const f of this.g)f.info(n,...r)}warn(n,...r){for(const f of this.g)f.warn(n,...r)}error(n,...r){for(const f of this.g)f.error(n,...r)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=b;class p extends k.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...r){this.b.trace(n,...r)}debug(n,...r){this.b.debug(n,...r)}info(n,...r){this.b.info(n,...r)}warn(n,...r){this.b.warn(n,...r)}error(n,...r){this.b.error(n,...r)}flush(){this.b.flush()}}e.LogService=p;class g extends k.Disposable{constructor(n,r){super(),this.c=n,this.b=new A.ResourceMap,this.B(r(f=>this.setLevel(f)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,r,f){let I=this.b.get(n)?.logger;return I||(f=r?.always?L.Trace:f,I=this.f(n,f??this.c,r),this.b.set(n,{logger:I,logLevel:f})),I}setLevel(n,r){const f=T.URI.isUri(n)?n:void 0,I=f?r:n;if(f){const R=this.b.get(f);R&&R.logLevel!==I&&(R.logLevel=I,R.logger.setLevel(I))}else this.c=I,this.b.forEach(({logLevel:R,logger:B})=>{R===void 0&&B.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=g;class w{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return L.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogger=w;class i extends w{}e.NullLogService=i;class o extends g{constructor(){super(L.Info,t.Event.None)}f(n,r,f){return new w}}e.NullLoggerService=o;function u(a){if(a.verbose)return L.Trace;if(typeof a.logLevel=="string"){const n=s(a.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function l(a){switch(a){case L.Trace:return"trace";case L.Debug:return"debug";case L.Info:return"info";case L.Warning:return"warn";case L.Error:return"error";case L.Off:return"off"}}e.LogLevelToString=l;function s(a){switch(a){case"trace":return L.Trace;case"debug":return L.Debug;case"info":return L.Info;case"warn":return L.Warning;case"error":return L.Error;case"critical":return L.Error;case"off":return L.Off}}e.parseLogLevel=s}),define(ye[198],Ce([1,0,38,13]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(k||(k={}));async function A(y,L,P,v,D){try{const E=await new Promise((m,h)=>{ne(["spdlog"],m,h)});E.setFlushOn(k.Trace);const d=await E.createAsyncRotatingLogger(y,L,P,v);return D?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(E){console.error(E)}return null}function C(y,L,P){switch(L){case t.LogLevel.Trace:y.trace(P);break;case t.LogLevel.Debug:y.debug(P);break;case t.LogLevel.Info:y.info(P);break;case t.LogLevel.Warning:y.warn(P);break;case t.LogLevel.Error:y.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function T(y,L){switch(L){case t.LogLevel.Trace:y.setLevel(k.Trace);break;case t.LogLevel.Debug:y.setLevel(k.Debug);break;case t.LogLevel.Info:y.setLevel(k.Info);break;case t.LogLevel.Warning:y.setLevel(k.Warning);break;case t.LogLevel.Error:y.setLevel(k.Error);break;case t.LogLevel.Off:y.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class S extends t.AbstractMessageLogger{constructor(L,P,v,D,E){super(),this.k=[],this.setLevel(E),this.l=this.n(L,P,v,D),this.B(this.onDidChangeLogLevel(d=>{this.m&&T(this.m,d)}))}async n(L,P,v,D){const E=v?6:1,d=30/E*c.ByteSize.MB,m=await A(L,P,d,E,D);if(m){this.m=m,T(this.m,this.getLevel());for(const{level:h,message:b}of this.k)C(this.m,h,b);this.k=[]}}g(L,P){this.m?C(this.m,L,P):this.getLevel()<=L&&this.k.push({level:L,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=S}),define(ye[123],Ce([1,0,43,171,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function y(E,d){return d-E}S.compare=y;const L=Object.create(null);L[S.Error]=(0,t.localize)(0,null),L[S.Warning]=(0,t.localize)(1,null),L[S.Info]=(0,t.localize)(2,null);function P(E){return L[E]||""}S.toString=P;function v(E){switch(E){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=v;function D(E){switch(E){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=D}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const y="";function L(v){return P(v,!0)}S.makeKey=L;function P(v,D){const E=[y];return v.source?E.push(v.source.replace("\xA6","\\\xA6")):E.push(y),v.code?typeof v.code=="string"?E.push(v.code.replace("\xA6","\\\xA6")):E.push(v.code.value.replace("\xA6","\\\xA6")):E.push(y),v.severity!==void 0&&v.severity!==null?E.push(C.toString(v.severity)):E.push(y),v.message&&D?E.push(v.message.replace("\xA6","\\\xA6")):E.push(y),v.startLineNumber!==void 0&&v.startLineNumber!==null?E.push(v.startLineNumber.toString()):E.push(y),v.startColumn!==void 0&&v.startColumn!==null?E.push(v.startColumn.toString()):E.push(y),v.endLineNumber!==void 0&&v.endLineNumber!==null?E.push(v.endLineNumber.toString()):E.push(y),v.endColumn!==void 0&&v.endColumn!==null?E.push(v.endColumn.toString()):E.push(y),E.push(y),E.join("\xA6")}S.makeKeyOptionalMessage=P})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(ye[199],Ce([1,0,4,43,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,k.createDecorator)("notificationService");var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(y){y[y.OFF=0]="OFF",y[y.SILENT=1]="SILENT",y[y.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=S}),define(ye[124],Ce([1,0,8,2,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService");function A(y,L){return t.URI.isUri(y)?(0,c.equalsIgnoreCase)(y.scheme,L):(0,c.startsWithIgnoreCase)(y,L+":")}e.matchesScheme=A;function C(y,...L){return L.some(P=>A(y,P))}e.matchesSomeScheme=C;function T(y,L){return y.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=T;function S(y){let L;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(y.fragment);return P&&(L={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},y=y.with({fragment:""})),{selection:L,uri:y}}e.extractSelection=S}),define(ye[200],Ce([1,0,12,36]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.context<"u"){const A=c.globals.vscode.context.configuration();if(A)k=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(k=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:A.version})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(ye[201],Ce([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__param||function(ne,e){return function(c,t){e(c,t,ne)}};define(ye[125],Ce([1,0,18,21,6,3]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var C;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=T,T.None=Object.freeze({report(){}});let S=class extends k.Disposable{constructor(P,v){super(),this.a=new c.DeferredPromise,v.withProgress(P,D=>(this.b=D,this.c&&D.report(this.c),this.a.p)),this.B((0,k.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};S=qe([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class y extends k.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new k.DisposableStore)}start(P){this.stop();const v=++this.a,D=new t.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,k.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,k.toDisposable)(()=>D.cancel())),this.b.add((0,k.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:D.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=y,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(ye[44],Ce([1,0,49,11]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(C,T){c.ok(t.isString(C)),c.ok(t.isObject(T)),c.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,T)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new k}),define(ye[126],Ce([1,0,4,44]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class A{constructor(){this.b=new c.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,y){this.a[k(S)]=y,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new A;t.Registry.add(e.Extensions.JSONContribution,C)}),define(ye[127],Ce([1,0,17,4,11,166,52,126,44]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=S.Registry.as(T.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const u=this.k(i,o);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const o=this.l(i);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const u=[];u.push(...this.l(o)),u.push(...this.k(i,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,c.distinct)(u)})}registerDefaultConfigurations(i){const o=[],u=[];for(const{overrides:l,source:s}of i)for(const a in l)if(o.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const n=this.a.get(a),r=n?.valuesSources??new Map;if(s)for(const B of Object.keys(l[a]))r.set(B,s);const f={...n?.value||{},...l[a]};this.a.set(a,{source:s,value:f,valuesSources:r});const I=(0,C.getLanguageTagSettingPlainKey)(a),R={type:"object",default:f,description:A.localize(1,null,I),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:k.isString(s)?void 0:s,defaultValueSource:s};u.push(...d(a)),this.d[a]=R,this.b.properties[a]=R}else{this.a.set(a,{value:l[a],source:s});const n=this.d[a];n&&(this.s(a,n),this.o(a,n))}this.registerOverrideIdentifiers(u),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const o=[];for(const{overrides:u,source:l}of i)for(const s in u){const a=this.a.get(s),n=k.isString(l)?l:l?.id,r=k.isString(a?.source)?a?.source:a?.source?.id;if(n===r)if(o.push(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const f=this.d[s];f&&(this.s(s,f),this.o(s,f))}}this.q(),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const o of i)this.h.add(o);this.q()}k(i,o){const u=[];return i.forEach(l=>{u.push(...this.m(l,o,l.extensionInfo,l.restrictedProperties)),this.c.push(l),this.n(l)}),u}l(i){const o=[],u=l=>{if(l.properties)for(const s in l.properties){o.push(s);const a=this.d[s];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[s],this.p(s,l.properties[s])}l.allOf?.forEach(s=>u(s))};for(const l of i){u(l);const s=this.c.indexOf(l);s!==-1&&this.c.splice(s,1)}return o}m(i,o=!0,u,l,s=3){s=k.isUndefinedOrNull(i.scope)?s:i.scope;const a=[],n=i.properties;if(n)for(const f in n){const I=n[f];if(o&&p(f,I)){delete n[f];continue}if(I.source=u,I.defaultDefaultValue=n[f].default,this.s(f,I),e.OVERRIDE_PROPERTY_REGEX.test(f)?I.scope=void 0:(I.scope=k.isUndefinedOrNull(I.scope)?s:I.scope,I.restricted=k.isUndefinedOrNull(I.restricted)?!!l?.includes(f):I.restricted),n[f].hasOwnProperty("included")&&!n[f].included){this.f[f]=n[f],delete n[f];continue}else this.d[f]=n[f],n[f].policy?.name&&this.e.set(n[f].policy.name,f);!n[f].deprecationMessage&&n[f].markdownDeprecationMessage&&(n[f].deprecationMessage=n[f].markdownDeprecationMessage),a.push(f)}const r=i.allOf;if(r)for(const f of r)a.push(...this.m(f,o,u,l,s));return a}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const o=u=>{const l=u.properties;if(l)for(const a in l)this.o(a,l[a]);u.allOf?.forEach(o)};o(i)}o(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.g.properties[i]=o;break}}p(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const o=`[${i}]`,u={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this.i.fire()}r(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,o){const u=this.a.get(i);let l=u?.value,s=u?.source;k.isUndefined(l)&&(l=o.defaultDefaultValue,s=void 0),k.isUndefined(l)&&(l=h(o.type)),o.default=l,o.defaultValueSource=s}}const D="\\[([^\\]]+)\\]",E=new RegExp(D,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${D})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(w){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let o=E.exec(w);for(;o?.length;){const u=o[1].trim();u&&i.push(u),o=E.exec(w)}}return(0,c.distinct)(i)}e.overrideIdentifiersFromKey=d;function m(w){return w.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=m;function h(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const b=new v;S.Registry.add(e.Extensions.Configuration,b);function p(w,i){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?A.localize(7,null,w):b.getConfigurationProperties()[w]!==void 0?A.localize(8,null,w):i.policy?.name&&b.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,w,i.policy?.name,b.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}e.validateProperty=p;function g(){const w=[],i=b.getConfigurationProperties();for(const o of Object.keys(i))w.push([o,i[o].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=g}),define(ye[202],Ce([1,0,17,4,146,6,28,23,11,2,52,127,44]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class D{constructor(o={},u=[],l=[],s){this.c=o,this.d=u,this.f=l,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const o=this.raw.map(u=>{if(u instanceof D)return u;const l=new E("");return l.parseRaw(u),l.configurationModel});this.g=o.reduce((u,l)=>l===u?l:u.merge(l),o[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(o){return o?(0,L.getConfigurationValue)(this.contents,o):this.contents}inspect(o,u){const l=this.rawConfiguration.getValue(o),s=u?this.rawConfiguration.getOverrideValue(o,u):void 0,a=u?this.rawConfiguration.override(u).getValue(o):l;return{value:l,override:s,merged:a}}getOverrideValue(o,u){const l=this.l(u);return l?o?(0,L.getConfigurationValue)(l,o):l:void 0}getKeysForOverrideIdentifier(o){const u=[];for(const l of this.overrides)l.identifiers.includes(o)&&u.push(...l.keys);return c.distinct(u)}getAllOverrideIdentifiers(){const o=[];for(const u of this.overrides)o.push(...u.identifiers);return c.distinct(o)}override(o){let u=this.b.get(o);return u||(u=this.h(o),this.b.set(o,u)),u}merge(...o){const u=T.deepClone(this.contents),l=T.deepClone(this.overrides),s=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const n of o)if(a.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(u,n.contents);for(const r of n.overrides){const[f]=l.filter(I=>c.equals(I.identifiers,r.identifiers));f?(this.j(f.contents,r.contents),f.keys.push(...r.keys),f.keys=c.distinct(f.keys)):l.push(T.deepClone(r))}for(const r of n.keys)s.indexOf(r)===-1&&s.push(r)}return new D(u,s,l,a.every(n=>n instanceof D)?void 0:a)}freeze(){return this.a=!0,this}clone(){return new D(T.deepClone(this.contents),[...this.keys],T.deepClone(this.overrides))}h(o){const u=this.l(o);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const l={};for(const s of c.distinct([...Object.keys(this.contents),...Object.keys(u)])){let a=this.contents[s];const n=u[s];n&&(typeof a=="object"&&typeof n=="object"?(a=T.deepClone(a),this.j(a,n)):a=n),l[s]=a}return new D(l,this.keys,this.overrides)}j(o,u){for(const l of Object.keys(u)){if(l in o&&S.isObject(o[l])&&S.isObject(u[l])){this.j(o[l],u[l]);continue}o[l]=T.deepClone(u[l])}}k(o){return this.a&&!Object.isFrozen(o)?T.deepFreeze(o):o}l(o){let u=null,l=null;const s=a=>{a&&(l?this.j(l,a):l=T.deepClone(a))};for(const a of this.overrides)c.equals(a.identifiers,[o])?u=a.contents:a.identifiers.includes(o)&&s(a.contents);return s(u),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,u){this.m(o),(0,L.addToValueTree)(this.contents,o,u,l=>{throw new Error(l)})}removeValue(o){this.n(o)&&(0,L.removeFromValueTree)(this.contents,o)}m(o){let u=this.keys.length;for(let l=0;l<u;l++)o.indexOf(this.keys[l])===0&&(u=l);this.keys.splice(u,1,o)}n(o){const u=this.keys.indexOf(o);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=D;class E{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,u){if(!S.isUndefinedOrNull(o)){const l=this.g(o);this.parseRaw(l,u)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,u){this.a=o;const{contents:l,keys:s,overrides:a,restricted:n,hasExcludedProperties:r}=this.h(o,u);this.b=new D(l,s,a,r?[o]:void 0),this.c=n||[]}g(o){let u={},l=null,s=[];const a=[],n=[];function r(I){Array.isArray(s)?s.push(I):l!==null&&(s[l]=I)}const f={onObjectBegin:()=>{const I={};r(I),a.push(s),s=I,l=null},onObjectProperty:I=>{l=I},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const I=[];r(I),a.push(s),s=I,l=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:r,onError:(I,R,B)=>{n.push({error:I,offset:R,length:B})}};if(o)try{k.visit(o,f),u=s[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return u}h(o,u){const l=v.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),s=this.j(o,l,!0,u);o=s.raw;const a=(0,L.toValuesTree)(o,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),n=Object.keys(o),r=this.l(o,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:a,keys:n,overrides:r,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(o,u,l,s){let a=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:o,restricted:[],hasExcludedProperties:a};const n={},r=[];for(const f in o)if(P.OVERRIDE_PROPERTY_REGEX.test(f)&&l){const I=this.j(o[f],u,!1,s);n[f]=I.raw,a=a||I.hasExcludedProperties,r.push(...I.restricted)}else{const I=u[f],R=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&r.push(f),(R===void 0||s.scopes===void 0||s.scopes.includes(R))&&!(s.skipRestricted&&I?.restricted)?n[f]=o[f]:a=!0}return{raw:n,restricted:r,hasExcludedProperties:a}}l(o,u){const l=[];for(const s of Object.keys(o))if(P.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const n in o[s])a[n]=o[s][n];l.push({identifiers:(0,P.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,L.toValuesTree)(a,u)})}return l}}e.ConfigurationModelParser=E;class d extends A.Disposable{constructor(o,u,l,s){super(),this.f=o,this.g=u,this.h=s,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new E(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(l.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&l.isEqual(a.resource,o)))(()=>this.c.fire()))}async loadConfiguration(){try{const o=await this.h.readFile(this.f);return this.a.parse(o.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new D}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class m{constructor(o,u,l,s,a,n,r,f,I,R,B,X,q){this.a=o,this.b=u,this.value=l,this.overrideIdentifiers=s,this.c=a,this.d=n,this.f=r,this.g=f,this.h=I,this.j=R,this.k=B,this.l=X,this.m=q}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class h{constructor(o,u,l,s,a=new D,n=new D,r=new C.ResourceMap,f=new D,I=new C.ResourceMap,R=!0){this.c=o,this.d=u,this.f=l,this.g=s,this.h=a,this.j=n,this.l=r,this.m=f,this.n=I,this.p=R,this.a=null,this.b=new C.ResourceMap,this.q=null}getValue(o,u,l){return this.s(o,u,l).getValue(o)}updateValue(o,u,l={}){let s;l.resource?(s=this.n.get(l.resource),s||(s=new D,this.n.set(l.resource,s))):s=this.m,u===void 0?s.removeValue(o):s.setValue(o,u),l.resource||(this.a=null)}inspect(o,u,l){const s=this.s(o,u,l),a=this.w(u.resource,l),n=u.resource?this.n.get(u.resource)||this.m:this.m,r=new Set;for(const f of s.overrides)for(const I of f.identifiers)s.getOverrideValue(o,I)!==void 0&&r.add(I);return new m(o,u,s.getValue(o),r.size?[...r]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),l?this.j.freeze():void 0,a?a.freeze():void 0,n.inspect(o,u.overrideIdentifier))}keys(o){const u=this.w(void 0,o);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.j=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,u){this.l.set(o,u),this.b.delete(o)}deleteFolderConfiguration(o){this.r.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,u){const l=[];if(!u){const{added:s,updated:a,removed:n}=g(this.c,o);u=[...s,...a,...n]}for(const s of u)for(const a of(0,P.overrideIdentifiersFromKey)(s)){const n=this.c.getKeysForOverrideIdentifier(a),r=o.getKeysForOverrideIdentifier(a),f=[...r.filter(I=>n.indexOf(I)===-1),...n.filter(I=>r.indexOf(I)===-1),...n.filter(I=>!T.equals(this.c.override(a).getValue(I),o.override(a).getValue(I)))];l.push([a,f])}return this.updateDefaultConfiguration(o),{keys:u,overrides:l}}compareAndUpdatePolicyConfiguration(o){const{added:u,updated:l,removed:s}=g(this.d,o),a=[...u,...l,...s];return a.length&&this.updatePolicyConfiguration(o),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:u,updated:l,removed:s,overrides:a}=g(this.applicationConfiguration,o),n=[...u,...l,...s];return n.length&&this.updateApplicationConfiguration(o),{keys:n,overrides:a}}compareAndUpdateLocalUserConfiguration(o){const{added:u,updated:l,removed:s,overrides:a}=g(this.localUserConfiguration,o),n=[...u,...l,...s];return n.length&&this.updateLocalUserConfiguration(o),{keys:n,overrides:a}}compareAndUpdateRemoteUserConfiguration(o){const{added:u,updated:l,removed:s,overrides:a}=g(this.remoteUserConfiguration,o),n=[...u,...l,...s];return n.length&&this.updateRemoteUserConfiguration(o),{keys:n,overrides:a}}compareAndUpdateWorkspaceConfiguration(o){const{added:u,updated:l,removed:s,overrides:a}=g(this.workspaceConfiguration,o),n=[...u,...l,...s];return n.length&&this.updateWorkspaceConfiguration(o),{keys:n,overrides:a}}compareAndUpdateFolderConfiguration(o,u){const l=this.r.get(o),{added:s,updated:a,removed:n,overrides:r}=g(l,u),f=[...s,...a,...n];return(f.length||!l)&&this.updateFolderConfiguration(o,u),{keys:f,overrides:r}}compareAndDeleteFolderConfiguration(o){const u=this.r.get(o);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:l,updated:s,removed:a,overrides:n}=g(u,void 0);return{keys:[...l,...s,...a],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(o,u,l){let s=this.t(u,l);return u.overrideIdentifier&&(s=s.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(s=s.merge(this.d)),s}t({resource:o},u){let l=this.u();if(u&&o){const s=u.getFolder(o);s&&(l=this.v(s.uri)||l);const a=this.n.get(o);a&&(l=l.merge(a))}return l}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(o){let u=this.b.get(o);if(!u){const l=this.u(),s=this.l.get(o);s?(u=l.merge(s),this.p&&(u=u.freeze()),this.b.set(o,u)):u=l}return u}w(o,u){if(u&&o){const l=u.getFolder(o);if(l)return this.l.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((o,u)=>{const{contents:l,overrides:s,keys:a}=this.l.get(u);return o.push([u,{contents:l,overrides:s,keys:a}]),o},[])}}allKeys(){const o=new Set;return this.c.freeze().keys.forEach(u=>o.add(u)),this.userConfiguration.freeze().keys.forEach(u=>o.add(u)),this.j.freeze().keys.forEach(u=>o.add(u)),this.l.forEach(u=>u.freeze().keys.forEach(l=>o.add(l))),[...o.values()]}x(){const o=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(u=>o.add(u)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>o.add(u)),this.j.freeze().getAllOverrideIdentifiers().forEach(u=>o.add(u)),this.l.forEach(u=>u.freeze().getAllOverrideIdentifiers().forEach(l=>o.add(l))),[...o.values()]}y(o){const u=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(l=>u.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(l=>u.add(l)),this.j.getKeysForOverrideIdentifier(o).forEach(l=>u.add(l)),this.l.forEach(l=>l.getKeysForOverrideIdentifier(o).forEach(s=>u.add(s))),[...u.values()]}static parse(o){const u=this.z(o.defaults),l=this.z(o.policy),s=this.z(o.application),a=this.z(o.user),n=this.z(o.workspace),r=o.folders.reduce((f,I)=>(f.set(y.URI.revive(I[0]),this.z(I[1])),f),new C.ResourceMap);return new h(u,l,s,a,new D,n,r,new D,new C.ResourceMap,!1)}static z(o){return new D(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=h;function b(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const o=new Set,u=new Map;for(const s of i)s.keys.forEach(a=>o.add(a)),s.overrides.forEach(([a,n])=>{const r=(0,C.getOrSet)(u,a,new Set);n.forEach(f=>r.add(f))});const l=[];return u.forEach((s,a)=>l.push([a,[...s.values()]])),{keys:[...o.values()],overrides:l}}e.mergeChanges=b;class p{constructor(o,u,l,s){this.change=o,this.b=u,this.c=l,this.d=s,this.f=void 0;const a=new Set;o.keys.forEach(r=>a.add(r)),o.overrides.forEach(([,r])=>r.forEach(f=>a.add(f))),this.affectedKeys=[...a.values()];const n=new D;this.affectedKeys.forEach(r=>n.setValue(r,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=h.parse(this.b.data)),this.f}affectsConfiguration(o,u){if(this.g(this.a,o)){if(u){const l=this.previousConfiguration?this.previousConfiguration.getValue(o,u,this.b?.workspace):void 0,s=this.c.getValue(o,u,this.d);return!T.equals(l,s)}return!0}return!1}g(o,u){let l=(0,L.toValuesTree)({[u]:!0},()=>{}),s;for(;typeof l=="object"&&(s=Object.keys(l)[0]);){if(o=o[s],!o)return!1;l=l[s]}return!0}}e.ConfigurationChangeEvent=p;function g(i,o){const{added:u,removed:l,updated:s}=w(o?.rawConfiguration,i?.rawConfiguration),a=[],n=i?.getAllOverrideIdentifiers()||[],r=o?.getAllOverrideIdentifiers()||[];if(o){const f=r.filter(I=>!n.includes(I));for(const I of f)a.push([I,o.getKeysForOverrideIdentifier(I)])}if(i){const f=n.filter(I=>!r.includes(I));for(const I of f)a.push([I,i.getKeysForOverrideIdentifier(I)])}if(o&&i){for(const f of n)if(r.includes(f)){const I=w({contents:i.getOverrideValue(void 0,f)||{},keys:i.getKeysForOverrideIdentifier(f)},{contents:o.getOverrideValue(void 0,f)||{},keys:o.getKeysForOverrideIdentifier(f)});a.push([f,[...I.added,...I.removed,...I.updated]])}}return{added:u,removed:l,updated:s,overrides:a}}function w(i,o){const u=i?o?i.keys.filter(a=>o.keys.indexOf(a)===-1):[...i.keys]:[],l=o?i?o.keys.filter(a=>i.keys.indexOf(a)===-1):[...o.keys]:[],s=[];if(i&&o){for(const a of o.keys)if(i.keys.indexOf(a)!==-1){const n=(0,L.getConfigurationValue)(o.contents,a),r=(0,L.getConfigurationValue)(i.contents,a);T.equals(n,r)||s.push(a)}}return{added:u,removed:l,updated:s}}}),define(ye[128],Ce([1,0,10,3]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends c.ErrorNoTelemetry{static isNotAvailable(T){return T instanceof A&&T._code===k.NotAvailable}static isTemporarilyNotAvailable(T){return T instanceof A&&T._code===k.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof A&&T._code===k.NoResolverFound}static isHandled(T){return T instanceof A&&T.isHandled}constructor(T,S=k.Unknown,y){super(T),this._message=T,this._code=S,this._detail=y,this.isHandled=S===k.NotAvailable&&y===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(ye[67],Ce([1,0,15]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(y){return y.scheme===c.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=t;function k(y){if(!y)return;const L=y.indexOf("+");return L<0?y:y.substr(0,L)}e.getRemoteName=k;function A(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.getRemoteServerRootPath=A;function C(y){const{host:L,port:P}=S(y);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:P}}e.parseAuthorityWithPort=C;function T(y,L){let{host:P,port:v}=S(y);return typeof v>"u"&&(v=L),{host:P,port:v}}e.parseAuthorityWithOptionalPort=T;function S(y){const L=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const P=y.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const v=y.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:y,port:void 0}}}),define(ye[27],Ce([1,0,8,3,67]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=A;function C(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var S;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(d){this.value=d,this.c=d.toLowerCase()}static equals(d,m){if(typeof d>"u"||d===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof d=="string"||typeof m=="string"){const h=typeof d=="string"?d:d.value,b=typeof m=="string"?m:m.value;return c.equalsIgnoreCase(h,b)}return d.c===m.c}static toKey(d){return typeof d=="string"?d.toLowerCase():d.c}}e.ExtensionIdentifier=y;function L(E){return P(E)}e.isApplicationScopedExtension=L;function P(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function v(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function D(E,d){if(d){const m=`onResolveRemoteAuthority:${(0,k.getRemoteName)(d)}`;return E.activationEvents?.indexOf(m)!==-1}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[203],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.b=new Map}c(){return new Promise((k,A)=>ne(["vsda"],k,A))}async createNewMessage(k){try{const A=await this.c(),C=new A.validator;if(C){const T=String(c.a++);return this.b.set(T,C),{id:T,data:C.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,A){if(!k.id)return!0;const C=this.b.get(k.id);if(!C)return!1;this.b.delete(k.id);try{return C.validate(A)==="ok"}catch{return!1}}async sign(k){try{const A=await this.c(),C=new A.signer;if(C)return C.sign(k)}catch{}return k}}e.SignService=c,c.a=1}),define(ye[204],Ce([1,0,12,36,2,30]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(y){if(c.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function T(y,L,P,v,D,E,d,m,h,b){const p=Object.create(null);p["common.machineId"]=d,p.sessionID=(0,A.generateUuid)()+Date.now(),p.commitHash=D,p.version=E,p["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,c.PlatformToString)(c.platform),p["common.nodePlatform"]=t.platform,p["common.nodeArch"]=v,p["common.product"]=b||"desktop",m&&(p["common.msftInternal"]=m);let g=0;const w=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),c.isLinuxSnap&&(p["common.snap"]="true");const i=C(P);i&&(p["common.platformDetail"]=i);try{const o=await y.readFile(k.URI.file(h));p["common.source"]=o.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=T;function S(y){const L=t.env.USERDNSDOMAIN;if(!L)return!1;const P=L.toLowerCase();return y.some(v=>P===v)}e.verifyMicrosoftInternalDomain=S}),define(ye[205],Ce([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[68],Ce([1,0,23,11,52,67,204,205]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(a){this.value=a}}e.TrustedTelemetryValue=S;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,n){return Promise.resolve(void 0)}publicLog2(a,n){return this.publicLog(a,n)}publicLogError(a,n){return Promise.resolve(void 0)}publicLogError2(a,n){return this.publicLogError(a,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class L{async publicLog(a,n,r){}async publicLogError(a,n,r){}}e.NullEndpointTelemetryService=L,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(s,a){return a.onDidChangeConfiguration(n=>{n.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(n.source),configurationKeys:p(n.sourceConfig)})})}e.configurationTelemetry=P;function v(s,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!s.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=v;function D(s,a){return!(a.isBuilt||a.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=D;function E(s){const a=s.getValue(T.TELEMETRY_SETTING_ID),n=s.getValue("telemetry.enableCrashReporter");if(s.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function d(s){const a={},n={},r={};b(s,r);for(let f in r){f=f.length>150?f.substr(f.length-149):f;const I=r[f];typeof I=="number"?n[f]=I:typeof I=="boolean"?n[f]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${I.length}`),a[f]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(a[f]=I)}return{properties:a,measurements:n}}e.validateTelemetryData=d;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function h(s){if(!s)return"none";const a=(0,A.getRemoteName)(s);return m.has(a)?a:"other"}e.cleanRemoteAuthority=h;function b(s,a,n=0,r){if(!!s)for(const f of Object.getOwnPropertyNames(s)){const I=s[f],R=r?r+f:f;Array.isArray(I)?a[R]=(0,c.safeStringify)(I):I instanceof Date?a[R]=I.toISOString():(0,t.isObject)(I)?n<2?b(I,a,n+1,R+"."):a[R]=(0,c.safeStringify)(I):a[R]=I}}function p(s){if(!s)return[];const a=[];return g(a,"",s),a}function g(s,a,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(r=>g(s,a?`${a}.${r}`:r,n[r])):s.push(a)}function w(s,a){const n=s.msftInternalDomains||[],r=a.getValue("telemetry.internalTesting");return(0,C.verifyMicrosoftInternalDomain)(n)||r}e.isInternalTelemetry=w;function i(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=i;function o(s,a){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let n=s;const r=[];for(const B of a)for(;;){const X=B.exec(s);if(!X)break;r.push([X.index,B.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let R=0;for(n="";;){const B=I.exec(s);if(!B)break;const X=r.some(([q,N])=>B.index<N&&q<I.lastIndex);!f.test(B[0])&&!X&&(n+=s.substring(R,B.index)+"<REDACTED: user-file-path>",R=I.lastIndex)}return R<s.length&&(n+=s.substr(R)),n}function u(s){if(!s)return s;const a=s.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(a))return`<REDACTED: ${r.label}>`;return s}function l(s,a){return(0,c.cloneAndChange)(s,n=>{if(n instanceof S)return n.value;if(typeof n=="string"){let r=n.replaceAll("%20"," ");r=o(r,a);for(const f of a)r=r.replace(f,"");return r=u(r),r}})}e.cleanData=l}),define(ye[206],Ce([1,0,8,122,27,12,2,10,36,68]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(u,l){return u.uuid&&l.uuid?u.uuid===l.uuid:u.id===l.id?!0:(0,c.compareIgnoreCase)(u.id,l.id)===0}e.areSameExtensions=L;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(l){const s=l.manifest?l.manifest.version:l.version,a=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new v(l.identifier,s,a)}static parse(l){const s=P.exec(l);return s&&s[1]&&s[2]?new v({id:s[1]},s[2],s[4]||void 0):null}constructor(l,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof v?L(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=v;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(u){const l=D.exec(u);return l&&l[1]?[m(l[1]),l[2]]:[m(u),void 0]}e.getIdAndVersion=E;function d(u,l){return`${u}.${l}`}e.getExtensionId=d;function m(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=m;function h(u,l){return m(d(u,l))}e.getGalleryExtensionId=h;function b(u,l){const s=[],a=n=>{for(const r of s)if(r.some(f=>L(l(f),l(n))))return r;return null};for(const n of u){const r=a(n);r?r.push(n):s.push([n])}return s}e.groupByExtension=b;function p(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function g(u){return{id:new y.TrustedTelemetryValue(u.identifier.id),name:new y.TrustedTelemetryValue(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function w(u,l){const s=[],a=l.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const n=a.shift();if(n&&s.every(r=>!L(r.identifier,{id:n}))){const r=u.filter(f=>L(f.identifier,{id:n}));r.length===1&&(s.push(r[0]),a.push(...r[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=w;async function i(u,l){if(!A.isLinux)return!1;let s;try{s=(await u.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await u.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){l.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(n))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function o(u,l){const s=await i(u,l),a=(0,t.getTargetPlatform)(s?"alpine":A.platform,S.arch);return l.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=o}),define(ye[207],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,A,C=5){const T=A(S=>{const y=typeof S=="string"?S:S.data;let L=this.a.get(k);if(L){L.data.push(y);return}const P=setTimeout(()=>this.flushBuffer(k),C);L={data:[y],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(k),T.dispose()}},this.a.set(k,L)});return T}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const A=this.a.get(k);A&&(this.a.delete(k),this.b(k,A.data.join("")))}}e.TerminalDataBufferer=c}),define(ye[208],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var c;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(c=e.ColorScheme||(e.ColorScheme={}));function t(A){return A===c.HIGH_CONTRAST_DARK||A===c.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(A){return A===c.DARK||A===c.HIGH_CONTRAST_DARK}e.isDark=k}),define(ye[90],Ce([1,0,80,4,6,3,44,208]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(m){function h(b){return b&&typeof b=="object"&&typeof b.id=="string"}m.isThemeColor=h})(S=e.ThemeColor||(e.ThemeColor={}));function y(m){return{id:m}}e.themeColorFromId=y;var L;(function(m){function h(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||S.isThemeColor(l.color))}m.isThemeIcon=h;const b=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function p(l){const s=b.exec(l);if(!s)return;const[,a]=s;return{id:a}}m.fromString=p;function g(l){return{id:l}}m.fromId=g;function w(l,s){let a=l.id;const n=a.lastIndexOf("~");return n!==-1&&(a=a.substring(0,n)),s&&(a=`${a}~${s}`),{id:a}}m.modify=w;function i(l){const s=l.id.lastIndexOf("~");if(s!==-1)return l.id.substring(s+1)}m.getModifier=i;function o(l,s){return l.id===s.id&&l.color?.id===s.color?.id}m.isEqual=o;function u(l,s){return{id:l.id,color:s?y(s):void 0}}m.asThemeIcon=u,m.asClassNameArray=c.CSSIcon.asClassNameArray,m.asClassName=c.CSSIcon.asClassName,m.asCSSSelector=c.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function P(m){switch(m){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case T.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(h){return this.a.push(h),this.b.fire(h),(0,k.toDisposable)(()=>{const b=this.a.indexOf(h);this.a.splice(b,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const D=new v;C.Registry.add(e.Extensions.ThemingContribution,D);function E(m){return D.onColorThemeChange(m)}e.registerThemingParticipant=E;class d extends k.Disposable{constructor(h){super(),this.k=h,this.h=h.getColorTheme(),this.B(this.k.onDidColorThemeChange(b=>this.n(b)))}n(h){this.h=h,this.updateStyles()}updateStyles(){}w(h,b){let p=this.h.getColor(h);return p&&b&&(p=b(p,this.h)),p?p.toString():null}}e.Themable=d}),define(ye[129],Ce([1,0,4,52,3,13]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var C;(function(d){d.Http="http",d.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function v(d,m,h,b){if(h===1)return!1;if(h===2&&P(m)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(p?.length===4&&parseInt(p[1])>=18)return!1}return d<1024}e.isPortPrivileged=v;class D{constructor(m,h,b){this.remoteAddress=m,this.localAddress=h,this.b=b,this.a=new c.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=D;let E=class{constructor(m,h){this.i=m,this.j=h,this.a=new c.Emitter,this.onTunnelOpened=this.a.event,this.b=new c.Emitter,this.onTunnelClosed=this.b.event,this.c=new c.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const m=this.j.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this.e=m,m?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this.f=m.elevation,this.g=m.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const m=[],h=Array.from(this.d.values());for(const b of h){const p=Array.from(b.values());for(const g of p){const w=await g.value;w&&m.push(w)}}return m}async dispose(){for(const m of this.d.values()){for(const{value:h}of m.values())await h.then(b=>b?.dispose());m.clear()}this.d.clear()}setEnvironmentTunnel(m,h,b,p,g){this.o(m,h,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:h,localAddress:b,privacy:p,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,h){(P(m)||L(m))&&(m=e.LOCALHOST_ADDRESSES[0]);const b=this.q(m,h);if(b)return++b.refcount,b.value}openTunnel(m,h,b,p,g=!1,w,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${b} on local port ${p}.`),!m)return;if(h||(h="localhost"),this.e&&this.h.has(b)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.r(m,h,b,p,g,w,i);return o?o.then(u=>{if(!u){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,b);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.m(u);return(u.tunnelRemoteHost!==h||u.tunnelRemotePort!==b)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(l),l}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}m(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const h=this.d.get(m.tunnelRemoteHost);if(h){const b=h.get(m.tunnelRemotePort);b&&(b.refcount--,await this.n(m.tunnelRemoteHost,m.tunnelRemotePort,b))}}}}async n(m,h,b){if(b.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${h}.`);const p=b.value.then(async g=>{g&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.d.has(m)&&this.d.get(m).delete(h),p}}async closeTunnel(m,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${h} `);const b=this.d.get(m);if(b&&b.has(h)){const p=b.get(h);p.refcount=0,await this.n(m,h,p)}}o(m,h,b){this.d.has(m)||this.d.set(m,new Map),this.d.get(m).set(h,{refcount:1,value:b})}async p(m,h){const b=this.d.get(m);b&&(await b.get(h)||b.delete(h),b.size===0&&this.d.delete(m))}q(m,h){const b=[m];L(m)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):P(m)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const p=b.map(g=>this.d.get(g));for(const g of p){const w=g?.get(h);if(w)return w}}canTunnel(m){return!!y(m)}s(m,h,b,p,g,w,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${b} on local port ${p}.`);const o=b;this.h.add(o);const u=p===void 0?b:p,l={elevationRequired:g?this.isPortPrivileged(u):!1},s={remoteAddress:{host:h,port:b},localAddressPort:p,privacy:w,public:w?w!==T.Private:void 0,protocol:i},a=m.forwardPort(s,l);return a?(this.o(h,b,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),a}};E=qe([He(0,A.ILogService),He(1,t.IConfigurationService)],E),e.AbstractTunnelService=E}),define(ye[209],Ce([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var t;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[210],Ce([1,0,15]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==c.Schemas.file&&S.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=t;function k(S){if(S.folders.length)return S.folders.every(y=>t(y.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=k;function A(S){return k(S)?.scheme}e.getVirtualWorkspaceScheme=A;function C(S){return k(S)?.authority}e.getVirtualWorkspaceAuthority=C;function T(S){return k(S)!==void 0}e.isVirtualWorkspace=T}),define(ye[46],Ce([1,0,172,9,64,24,2,3,15]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function y(u){const l=u;return typeof l?.id=="string"&&C.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=y;function L(u){return typeof u?.id=="string"&&!y(u)&&!v(u)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function P(u,l){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,t.basename)(u)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=u;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=P;function v(u){const l=u;return typeof l?.id=="string"&&C.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=v;function D(u){const l=u;if(l?.uri)return{id:l.id,uri:C.URI.revive(l.uri)};const s=u;if(s?.configPath)return{id:s.id,configPath:C.URI.revive(s.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=D;var E;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function d(u){const l=u;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=d;function m(u){const l=u;return!!(l&&typeof l=="object"&&C.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=m;class h{constructor(l,s,a,n,r){this.h=l,this.j=a,this.k=n,this.l=r,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=s}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class b{constructor(l,s){this.raw=s,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,A.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=b;function p(u){return new b({uri:u,index:0,name:(0,A.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(u,l){return A.extUriBiasedIgnorePathCase.isEqualOrParent(u,l.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function w(u){let l;return C.URI.isUri(u)?l=u:l=u.configuration,l?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=w;function i(u,l){return!g(u,l)&&!w(u)}e.isSavedWorkspace=i;function o(u){return(typeof u=="string"?(0,t.extname)(u):(0,A.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(ye[69],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(k){this.d=k,this.b=new Map,this.c=1}add(k){const A=this.c++;return this.b.set(A,k),this.e(),A}get(k,A){return this.b.has(k)?this.b.get(k)[A]:void 0}delete(k){this.b.delete(k),this.e()}e(){!c.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=c,c.a=!1}),define(ye[47],Ce([1,0,15,24,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this.a=new Set(Object.keys(c.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(T=>{const S=this.b.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this.b.delete(T.scheme):this.b.set(T.scheme,S)}isFreeScheme(T){return!this.b.has(T)&&!this.a.has(T)}getCapabilities(T){return this.b.get(T)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],Ce([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(ye[211],Ce([1,0,18]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(C,T,S){this.h=new Map,this.a=C,this.b=T,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new c.RunOnceScheduler(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of y.values())L.complete()}catch(L){for(const P of y.values())P.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,T){let S=this.f[C];return typeof S>"u"&&(S=T),S}update(C,T){this.f[C]=T;const S=this.h.get(C);if(S!==void 0)return S.p;const y=new c.DeferredPromise;return this.h.set(C,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class k extends t{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,T){super(C.identifier.value,!0,T),this.j=C}}e.ExtensionGlobalMemento=k}),define(ye[212],Ce([1,0,4,2]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class k{constructor(C){this.c=C,this.a=new c.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new c.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,T,S,y){const P=this.c.getNotebookDocument(t.URI.revive(C)).acceptModelChanged(T.value,S,y);this.b.fire(P)}$acceptDirtyStateChanged(C,T){this.c.getNotebookDocument(t.URI.revive(C)).acceptDirty(T)}$acceptModelSaved(C){const T=this.c.getNotebookDocument(t.URI.revive(C));this.a.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=k}),define(ye[16],Ce([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[213],Ce([1,0,27,4]),function(ne,e,c,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(T,S){k.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=c.ExtensionIdentifier.toKey(T.identifier),Je(this,k,S,"f"),Ue(this,k,"f").onDidChangePassword(y=>{y.extensionId===this.a&&this.b.fire({key:y.key})})}get(T){return Ue(this,k,"f").get(this.a,T)}store(T,S){return Ue(this,k,"f").store(this.a,T,S)}delete(T){return Ue(this,k,"f").delete(this.a,T)}}e.ExtensionSecrets=A,k=new WeakMap}),define(ye[54],Ce([1,0,3,129,4,16]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function y(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:P.protocol}}S.fromApiTunnel=y;function L(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==t.TunnelPrivacyId.ConstantPrivate&&P.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}S.fromServiceTunnel=L})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let T=class{constructor(y){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,L){}async getTunnels(){return[]}async setTunnelFactory(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,L){return{dispose:()=>{}}}async $providePortAttributes(y,L,P,v,D){return[]}async $forwardPort(y,L){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=qe([He(0,A.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(ye[55],Ce([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=t}),define(ye[214],Ce([1,0,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let y=this.buffers.indexOf(S);return y<0&&(y=this.buffers.length,this.buffers.push(S)),y}}function k(T,S){if(S.serializeBuffersForPostMessage){const y=new t,L=(D,E)=>{if(E instanceof ArrayBuffer){const d=y.add(E);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(E)){const d=A(E);if(d){const m=y.add(E.buffer);return{$$vscode_array_buffer_reference$$:!0,index:m,view:{type:d,byteLength:E.byteLength,byteOffset:E.byteOffset}}}}return E},P=JSON.stringify(T,L),v=y.buffers.map(D=>{const E=new Uint8Array(D);return c.VSBuffer.wrap(E)});return{message:P,buffers:v}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=k;function A(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(T,S){const y=S.map(v=>{const D=new ArrayBuffer(v.byteLength);return new Uint8Array(D).set(v.buffer),D}),L=S.length?(v,D)=>{if(D&&typeof D=="object"&&D.$$vscode_array_buffer_reference$$){const E=D,{index:d}=E,m=y[d];if(E.view)switch(E.view.type){case 1:return new Int8Array(m,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return D}:void 0;return{message:JSON.parse(T,L),arrayBuffers:y}}e.deserializeWebviewMessage=C}),define(ye[215],Ce([1,0,113]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(A){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:A,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function k(A){return new c.URITransformer(t(A))}e.createURITransformer=k}),define(ye[130],Ce([1,0,182,11,2,6,3,44,38,15]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var L;(function(x){x[x.PROGRAMMATIC=1]="PROGRAMMATIC",x[x.USER=2]="USER",x[x.EDIT=3]="EDIT",x[x.NAVIGATION=4]="NAVIGATION",x[x.JUMP=5]="JUMP"})(L=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var P;(function(x){x[x.IDENTICAL=1]="IDENTICAL",x[x.SIMILAR=2]="SIMILAR",x[x.DIFFERENT=3]="DIFFERENT"})(P=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function v(x){const V=x;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.isEditorPaneWithSelection=v;function D(x,V,_){for(const Q of _.visibleEditorPanes)if(Q.group.id===V&&x.matches(Q.input))return Q.getViewState()}e.findViewStateForEditor=D;function E(x){if(s(x))return!1;const V=x;return k.URI.isUri(V?.resource)}e.isResourceEditorInput=E;function d(x){if(s(x))return!1;const V=x;return V?.original!==void 0&&V.modified!==void 0}e.isResourceDiffEditorInput=d;function m(x){if(s(x)||d(x))return!1;const V=x;return V?.primary!==void 0&&V.secondary!==void 0}e.isResourceSideBySideEditorInput=m;function h(x){if(s(x))return!1;const V=x;return V?V.resource===void 0||V.resource.scheme===y.Schemas.untitled||V.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=h;const b=/Untitled-\d+/;function p(x){return x.scheme===y.Schemas.untitled&&x.path.length>1&&!b.test(x.path)}e.isUntitledWithAssociatedResource=p;function g(x){if(s(x))return!1;const V=x;return k.URI.isUri(V?.base?.resource)&&k.URI.isUri(V?.input1?.resource)&&k.URI.isUri(V?.input2?.resource)&&k.URI.isUri(V?.result?.resource)}e.isResourceMergeEditorInput=g;var w;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var i;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.a=new Map}registerSource(V,_){let Q=this.a.get(V);return Q||(Q={source:V,label:_},this.a.set(V,Q)),Q.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.SaveSourceRegistry=new o;var u;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription",x[x.CanDropIntoEditor=128]="CanDropIntoEditor",x[x.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends A.Disposable{}e.AbstractEditorInput=l;function s(x){return x instanceof l}e.isEditorInput=s;function a(x){const V=x;return k.URI.isUri(V?.preferredResource)}function n(x){const V=x;return s(V?.primary)&&s(V?.secondary)}e.isSideBySideEditorInput=n;function r(x){const V=x;return s(V?.modified)&&s(V?.original)}e.isDiffEditorInput=r;function f(x){return s(x?.editor)}e.isEditorInputWithOptions=f;function I(x){const V=x;return f(x)&&V?.group!==void 0}e.isEditorInputWithOptionsAndGroup=I;function R(x){const V=x;return typeof V?.groupId=="number"&&s(V.editor)}e.isEditorIdentifier=R;var B;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var X;(function(x){x[x.GROUP_ACTIVE=0]="GROUP_ACTIVE",x[x.GROUP_INDEX=1]="GROUP_INDEX",x[x.GROUP_LOCKED=2]="GROUP_LOCKED",x[x.EDITOR_OPEN=3]="EDITOR_OPEN",x[x.EDITOR_CLOSE=4]="EDITOR_CLOSE",x[x.EDITOR_MOVE=5]="EDITOR_MOVE",x[x.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",x[x.EDITOR_LABEL=7]="EDITOR_LABEL",x[x.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",x[x.EDITOR_PIN=9]="EDITOR_PIN",x[x.EDITOR_STICKY=10]="EDITOR_STICKY",x[x.EDITOR_DIRTY=11]="EDITOR_DIRTY",x[x.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(X=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var q;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(q=e.SideBySideEditor||(e.SideBySideEditor={}));class N{getOriginalUri(V,_){if(!V)return;if(g(V))return e.EditorResourceAccessor.getOriginalUri(V.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ge}=this.a(V);if(Z&&ge){if(_?.supportSideBySide===q.BOTH)return{primary:this.getOriginalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ge,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===q.ANY)return this.getOriginalUri(Z,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ge,{filterByScheme:_.filterByScheme});V=_.supportSideBySide===q.PRIMARY?Z:ge}}if(d(V)||m(V)||g(V))return;const Q=a(V)?V.preferredResource:V.resource;return!Q||!_||!_.filterByScheme?Q:this.b(Q,_.filterByScheme)}a(V){return n(V)||m(V)?{primary:V.primary,secondary:V.secondary}:r(V)||d(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,_){if(!V)return;if(g(V))return e.EditorResourceAccessor.getCanonicalUri(V.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ge}=this.a(V);if(Z&&ge){if(_?.supportSideBySide===q.BOTH)return{primary:this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ge,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===q.ANY)return this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ge,{filterByScheme:_.filterByScheme});V=_.supportSideBySide===q.PRIMARY?Z:ge}}if(d(V)||m(V)||g(V))return;const Q=V.resource;return!Q||!_||!_.filterByScheme?Q:this.b(Q,_.filterByScheme)}b(V,_){if(Array.isArray(_)){if(_.some(Q=>V.scheme===Q))return V}else if(_===V.scheme)return V}}e.EditorResourceAccessor=new N;var M;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(M=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(V){const _=this.a=V.get(C.IInstantiationService);for(const[Q,Z]of this.c)this.e(Q,Z,_);this.c.clear()}e(V,_,Q){const Z=Q.createInstance(_);this.d.set(V,Z)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(V,_){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,_,this.a):this.c.set(V,_),(0,A.toDisposable)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new F);async function z(x,V,_){return!x||!x.length?[]:await Promise.all(x.map(async Q=>{const Z=k.URI.revive(Q.fileUri);if(!Z){_.info("Cannot resolve the path because it is not valid.",Q);return}if(!await V.canHandleResource(Z)){_.info("Cannot resolve the path because it cannot be handled",Q);return}let te=Q.exists,J=Q.type;if(typeof te!="boolean"||typeof J!="number")try{J=(await V.stat(Z)).isDirectory?S.FileType.Directory:S.FileType.Unknown,te=!0}catch(ve){_.error(ve),te=!1}if(!te&&Q.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",Q);return}if(J===S.FileType.Directory){_.info("Cannot resolve the path because it is a directory",Q);return}const fe={...Q.options,pinned:!0};return te?{resource:Z,options:fe}:{resource:Z,options:fe,forceUntitled:!0}}))}e.pathsToEditors=z;var U;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function H(x){const V=x;if(!V)return!1;const _=V;if(_.modified)return H(_.modified);const Q=V;return!!(Q.contributionsState&&Q.viewState&&Array.isArray(Q.cursorState))}e.isTextEditorViewState=H}),define(ye[131],Ce([1,0,4,18,183]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new c.Emitter,this.n=new c.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(T){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=T}onEvent(T){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=T}onRequest(T){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.s("response",T)}sendRequest(T,S,y,L){const P={command:T};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.s("request",P),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const D=this.f.get(P.seq);if(D){this.f.delete(P.seq);const E={type:"response",seq:0,request_seq:P.seq,success:!1,command:T,message:(0,k.localize)(0,null,L,T)};D(E)}},L)}return y&&this.f.set(P.seq,y),P.seq}acceptMessage(T){this.j?this.j(T):(this.k.push(T),this.k.length===1&&this.q())}o(T,S){return T.type!=="event"||S.type!=="event"}async q(){let T;for(;this.k.length;){if((!T||this.o(this.k[0],T))&&await(0,t.timeout)(0),T=this.k.shift(),!T)return;switch(T.type){case"event":this.i?.(T);break;case"request":this.g?.(T);break;case"response":{const S=T,y=this.f.get(S.request_seq);y&&(this.f.delete(S.request_seq),y(S));break}}}}s(T,S){S.type=T,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((S,y)=>T.set(y,S)),await(0,t.timeout)(500),T.forEach((S,y)=>{S({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=A}),define(ye[216],Ce([1,0,184,53,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new t.RawContextKey("hasDebugged",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const A=v=>c.localize(51,null,v);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var C;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(C=e.State||(e.State={}));function T(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var S;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var y;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(y=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,k.createDecorator)("debugService");var P;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[217],Ce([1,0,8,2,9,23,15]),function(ne,e,c,t,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function S(u,l,s){return u.replace(T,function(a,n){return l&&n.length>0&&n[0]!=="_"?a:s&&s.hasOwnProperty(n)?s[n]:a})}e.formatPII=S;function y(u){const l={};for(const s of Object.keys(u))s.startsWith("!")||(l[s]=u[s]);return l}e.filterExceptionsFromTelemetry=y;function L(u){return u.configuration.request==="attach"&&!P(u)&&(!u.parentSession||L(u.parentSession))}e.isSessionAttach=L;function P(u){let l=u.configuration.type;if(!!l)return l==="vslsShare"&&(l=u.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(l,"extensionhost")||(0,c.equalsIgnoreCase)(l,"pwa-extensionhost")?u:u.parentSession?P(u.parentSession):void 0}e.getExtensionHostDebugSession=P;function v(u){return u.type&&(u.label||u.program||u.runtime)}e.isDebuggerMainContribution=v;function D(u,l,s){let a,n=0;const r=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=r.exec(u);){const I=f.index+1,R=I+f[0].length;if(I<=l&&R>=s){a=f[0],n=I;break}}if(a){const I=/\w+/g;let R=null;for(;(R=I.exec(a))&&!(R.index+1+n+R[0].length>=s););R&&(a=a.substring(0,I.lastIndex))}return a?{start:n,end:n+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=D;const E=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(u){return!!(u&&u.match(E))}e.isUri=d;function m(u){if(typeof u.path=="string"&&!(typeof u.sourceReference=="number"&&u.sourceReference>0)){if(d(u.path))return t.URI.parse(u.path);if((0,k.isAbsolute)(u.path))return t.URI.file(u.path)}return u.path}function h(u){if(typeof u.path=="object"){const l=t.URI.revive(u.path);if(l)return l.scheme===C.Schemas.file?l.fsPath:l.toString()}return u.path}function b(u,l){const s=l?m:h,a=(0,A.deepClone)(u);return g(a,(n,r)=>{n&&r&&(r.path=s(r))}),a}e.convertToDAPaths=b;function p(u,l){const s=l?m:h,a=(0,A.deepClone)(u);return g(a,(n,r)=>{!n&&r&&(r.path=s(r))}),a}e.convertToVSCPaths=p;function g(u,l){switch(u.type){case"event":{const s=u;switch(s.event){case"output":l(!1,s.body.source);break;case"loadedSource":l(!1,s.body.source);break;case"breakpoint":l(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=u;switch(s.command){case"setBreakpoints":l(!0,s.arguments.source);break;case"breakpointLocations":l(!0,s.arguments.source);break;case"source":l(!0,s.arguments.source);break;case"gotoTargets":l(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(a=>l(!1,a));break;default:break}break}case"response":{const s=u;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(a=>l(!1,a.source));break;case"loadedSources":s.body.sources.forEach(a=>l(!1,a));break;case"scopes":s.body.scopes.forEach(a=>l(!1,a.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(a=>l(!1,a.source));break;case"setBreakpoints":s.body.breakpoints.forEach(a=>l(!1,a.source));break;case"disassemble":s.body?.instructions.forEach(n=>l(!1,n.location));break;default:break}break}}}function w(u){return u.filter(l=>!l.presentation?.hidden).sort((l,s)=>l.presentation?s.presentation?l.presentation.group?s.presentation.group?l.presentation.group!==s.presentation.group?l.presentation.group.localeCompare(s.presentation.group):i(l.presentation.order,s.presentation.order):-1:s.presentation.group?1:i(l.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=w;function i(u,l){return typeof u!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:u-l}async function o(u,l){const s=u.getValue("debug.saveBeforeStart",{overrideIdentifier:l.activeTextEditorLanguageId});if(s!=="none"&&(await l.saveAll(),s==="allEditorsInActiveGroup")){const a=l.activeEditorPane;a&&a.input.resource?.scheme===C.Schemas.untitled&&await l.save({editor:a.input,groupId:a.group.id})}await u.reloadConfiguration()}e.saveAllBeforeDebugStart=o}),define(ye[218],Ce([1,0,45,219,23,9,12,8,29,185,131]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(h,b){this.p=b,this.r=Buffer.allocUnsafe(0),this.t=-1,h.on("data",p=>this.w(p))}sendMessage(h){if(this.p){const b=JSON.stringify(h);this.p.write(`Content-Length: ${Buffer.byteLength(b,"utf8")}${P.a}${b}`,"utf8")}}w(h){for(this.r=Buffer.concat([this.r,h]);;){if(this.t>=0){if(this.r.length>=this.t){const b=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,b.length>0)try{this.acceptMessage(JSON.parse(b))}catch(p){this.m.fire(new Error((p.message||p)+`
`+b))}continue}}else{const b=this.r.indexOf(P.a);if(b!==-1){const g=this.r.toString("utf8",0,b).split(P.b);for(const w of g){const i=w.split(P.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(b+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class v extends P{startSession(){return new Promise((h,b)=>{let p=!1;this.x=this.y(()=>{this.v(this.x,this.x),h(),p=!0}),this.x.on("close",()=>{p?this.m.fire(new Error("connection closed")):b(new Error("connection closed"))}),this.x.on("error",g=>{p?this.m.fire(g):b(g)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class D extends v{constructor(h){super(),this.z=h}y(h){return t.createConnection(this.z.port,this.z.host||"127.0.0.1",h)}}e.SocketDebugAdapter=D;class E extends v{constructor(h){super(),this.z=h}y(h){return t.createConnection(this.z.path,h)}}e.NamedPipeDebugAdapter=E;class d extends P{constructor(h,b){super(),this.y=h,this.z=b}async startSession(){const h=this.y.command,b=this.y.args,p=this.y.options||{};try{if(h)if(A.isAbsolute(h)){if(!await S.Promises.exists(h))throw new Error(y.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let g=process.env;if(p.env&&Object.keys(p.env).length>0&&(g=k.mixin(k.deepClone(process.env),p.env)),h==="node")if(Array.isArray(b)&&b.length>0){const w=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:g,execArgv:w?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};p.cwd&&(i.cwd=p.cwd);const o=c.fork(b[0],b.slice(1),i);if(!o.pid)throw new Error(y.localize(2,null,b[0]));this.x=o}else throw new Error(y.localize(3,null));else{const w={env:g};p.cwd&&(w.cwd=p.cwd),this.x=c.spawn(h,b,w)}this.x.on("error",w=>{this.m.fire(w)}),this.x.on("exit",(w,i)=>{this.n.fire(w)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",w=>{this.m.fire(w)}),this.x.stdin.on("error",w=>{this.m.fire(w)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(g){this.m.fire(g)}}async stopSession(){return this.x?(await this.u(),C.isWindows?new Promise((h,b)=>{const p=c.exec(`taskkill /F /T /PID ${this.x.pid}`,function(g,w,i){if(g)return b(g)});p.on("exit",h),p.on("error",b)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(h,b){if(!h)return;const p=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?p.runtime=A.join(b,h.runtime):p.runtime=h.runtime),h.runtimeArgs&&(p.runtimeArgs=h.runtimeArgs),h.program&&(A.isAbsolute(h.program)?p.program=h.program:p.program=A.join(b,h.program)),h.args&&(p.args=h.args);const g=h;return g.win&&(p.win=d.A(g.win,b)),g.winx86&&(p.winx86=d.A(g.winx86,b)),g.windows&&(p.windows=d.A(g.windows,b)),g.osx&&(p.osx=d.A(g.osx,b)),g.linux&&(p.linux=d.A(g.linux,b)),p}static platformAdapterExecutable(h,b){let p=Object.create(null);b=b.toLowerCase();for(const l of h)if(l.contributes){const s=l.contributes.debuggers;s&&s.length>0&&s.filter(a=>typeof a.type=="string"&&T.equalsIgnoreCase(a.type,b)).forEach(a=>{const n=d.A(a,l.extensionLocation.fsPath);p=k.mixin(p,n,l.isBuiltin)})}let g;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=p.winx86||p.win||p.windows:C.isWindows?g=p.win||p.windows:C.isMacintosh?g=p.osx:C.isLinux&&(g=p.linux),g=g||p;const w=g.program||p.program,i=g.args||p.args,o=g.runtime||p.runtime,u=g.runtimeArgs||p.runtimeArgs;if(o)return{type:"executable",command:o,args:(u||[]).concat(typeof w=="string"?[w]:[]).concat(i||[])};if(w)return{type:"executable",command:w,args:i||[]}}}e.ExecutableDebugAdapter=d}),define(ye[220],Ce([1,0,45,32,12]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(y,L){return new Promise((P,v)=>{let D="";const E=c.spawn(y,L);E.pid&&E.stdout.on("data",d=>{D+=d.toString()}),E.on("error",d=>{v(d)}),E.on("close",d=>{P(D)})})}async function C(y){if(y)if(k.isWindows){const L=await new Promise((P,v)=>{ne(["windows-process-tree"],P,v)});return new Promise(P=>{L.getProcessTree(y,v=>{P(!!v&&v.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(y)]).then(L=>{const P=L.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var T;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(T||(T={}));function S(y,L,P,v,D){y=y.trim().toLowerCase();let E;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?E=1:y.indexOf("cmd.exe")>=0?E=0:y.indexOf("bash")>=0?E=2:k.isWindows?E=0:E=2;let d,m=" ";switch(E){case 1:if(d=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),v){const h=(0,t.getDriveLetter)(v);h&&(m+=`${h}:; `),m+=`cd ${d(v)}; `}if(D)for(const h in D){const b=D[h];b===null?m+=`Remove-Item env:${h}; `:m+=`\${env:${h}}='${b}'; `}if(L.length>0){const h=L.shift(),b=P?h:d(h);m+=b[0]==="'"?`& ${b} `:`${b} `;for(const p of L)m+=p==="<"||p===">"||P?p:d(p),m+=" "}break;case 0:if(d=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(b=>h.includes(b))||h.length===0?`"${h}"`:h),v){const h=(0,t.getDriveLetter)(v);h&&(m+=`${h}: && `),m+=`cd ${d(v)} && `}if(D){m+='cmd /C "';for(const h in D){let b=D[h];b===null?m+=`set "${h}=" && `:(b=b.replace(/[&^|<>]/g,p=>`^${p}`),m+=`set "${h}=${b}" && `)}}for(const h of L)m+=h==="<"||h===">"||P?h:d(h),m+=" ";D&&(m+='"');break;case 2:{d=b=>(b=b.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),b.length===0?'""':b);const h=b=>/[^\w@%\/+=,.:^-]/.test(b)?`'${b.replace(/'/g,"'\\''")}'`:b;if(v&&(m+=`cd ${d(v)} ; `),D){m+="/usr/bin/env";for(const b in D){const p=D[b];p===null?m+=` -u ${h(b)}`:m+=` ${h(`${b}=${p}`)}`}m+=" "}for(const b of L)m+=b==="<"||b===">"||P?b:d(b),m+=" ";break}}return m}e.prepareCommand=S}),define(ye[91],Ce([1,0,22,37,62,84,15,9,12,53]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json",A.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var D;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(D=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var m;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(m=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var b;(function(z){z.scheme=C.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],H=new RegExp(`^[${U.join("")}]+`),x=7;function V(J,fe){const ve=fe.toString(x),Ae=`${ve.length<U.length?U[ve.length-1]:"z"}${ve}s${(0,c.encodeBase64)(c.VSBuffer.fromString(J.scheme),!0,!0)}`;return J.with({scheme:z.scheme,fragment:Ae})}z.generate=V;function _(J){if(J.scheme!==z.scheme)return;const fe=J.fragment.indexOf("s");if(fe<0)return;const ve=parseInt(J.fragment.substring(0,fe).replace(H,""),x),Ee=(0,c.decodeBase64)(J.fragment.substring(fe+1)).toString();if(!isNaN(ve))return{handle:ve,notebook:J.with({scheme:Ee,fragment:null})}}z.parse=_;function Q(J,fe){return J.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${fe??""},${J.scheme!==C.Schemas.file?J.scheme:""}`})}z.generateCellOutputUri=Q;function Z(J){if(J.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const fe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(J.fragment);if(!fe)return;const ve=fe[1]&&fe[1]!==""?fe[1]:void 0,Ee=fe[2];return{outputId:ve,notebook:J.with({scheme:Ee||C.Schemas.file,fragment:null})}}z.parseCellOutputUri=Z;function ge(J,fe,ve){return z.generate(J,fe).with({scheme:ve})}z.generateCellPropertyUri=ge;function te(J,fe){if(J.scheme===fe)return z.parse(J.with({scheme:z.scheme}))}z.parseCellPropertyUri=te})(b=e.CellUri||(e.CellUri={}));const p=z=>S.isWindows?z.replace(/\//g,"\\"):z;class g{constructor(U=[],H=e.NOTEBOOK_DISPLAY_ORDER){this.e=H,this.d=[...new Set(U)].map(x=>({pattern:x,matches:t.parse(p(x))}))}sort(U){const H=new Map(k.Iterable.map(U,V=>[V,p(V)]));let x=[];for(const{matches:V}of this.d)for(const[_,Q]of H)if(V(Q)){x.push(_),H.delete(_);break}return H.size&&(x=x.concat([...H.keys()].sort((V,_)=>this.e.indexOf(V)-this.e.indexOf(_)))),x}prioritize(U,H){const x=this.f(U);if(x===-1){this.d.unshift({pattern:U,matches:t.parse(p(U))});return}const V=new Set(H.map(Q=>this.f(Q,x)));V.delete(-1);const _=Array.from(V).sort();this.d.splice(x+1,0,..._.map(Q=>this.d[Q]));for(let Q=_.length-1;Q>=0;Q--)this.d.splice(_[Q],1)}toArray(){return this.d.map(U=>U.pattern)}f(U,H=this.d.length){const x=p(U);for(let V=0;V<H;V++)if(this.d[V].matches(x))return V;return-1}}e.MimeTypeDisplayOrder=g;function w(z,U,H,x=(V,_)=>V===_){const V=[];function _(ge,te,J){if(te===0&&J.length===0)return;const fe=V[V.length-1];fe&&fe.start+fe.deleteCount===ge?(fe.deleteCount+=te,fe.toInsert.push(...J)):V.push({start:ge,deleteCount:te,toInsert:J})}let Q=0,Z=0;for(;;){if(Q===z.length){_(Q,0,U.slice(Z));break}if(Z===U.length){_(Q,z.length-Q,[]);break}const ge=z[Q],te=U[Z];if(x(ge,te)){Q+=1,Z+=1;continue}H(te)?(_(Q,1,[]),Q+=1):(_(Q,0,[te]),Z+=1)}return V}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(z){z.default="default",z.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(z){const U=z;return!!((typeof U.include=="string"||t.isRelativePattern(U.include))&&(typeof U.exclude=="string"||t.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=o;function u(z,U,H){if(Array.isArray(z.viewType)&&z.viewType.indexOf(U)>=0||z.viewType===U)return!0;if(z.filenamePattern){const x=o(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,V=o(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(t.match(x,(0,T.basename)(H.fsPath).toLowerCase()))return!(V&&t.match(V,(0,T.basename)(H.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var l;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(U){return`${s.d}${U}`}static parse(U){if(U.startsWith(s.d))return U.substring(s.d.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s.d="notebook/";function a(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.isTextStreamMime=a;const n=new TextDecoder;function r(z){const U=[];let H=!1;for(const x of z)(U.length===0||H)&&(U.push(x),H=!0);return B(U),F(c.VSBuffer.concat(U.map(x=>c.VSBuffer.wrap(x))))}e.compressOutputItemStreams=r;const f=`${String.fromCharCode(27)}[A`,I=f.split("").map(z=>z.charCodeAt(0)),R=10;function B(z){z.forEach((U,H)=>{if(H===0||U.length<f.length)return;const x=z[H-1],V=U.subarray(0,f.length);if(V[0]===I[0]&&V[1]===I[1]&&V[2]===I[2]){const _=x.lastIndexOf(R);if(_===-1)return;z[H-1]=x.subarray(0,_),z[H]=U.subarray(f.length)}})}function X(z){let U=z;do z=U,U=z.replace(/[^\n]\x08/gm,"");while(U.length<z.length);return z}function q(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const U=z.match(/^(.*)\r+/m)[1];let H=z.match(/\r+(.*)$/m)[1];H=H+U.slice(H.length,U.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return z}const N="\b".charCodeAt(0),M="\r".charCodeAt(0);function F(z){return!z.buffer.includes(N)&&!z.buffer.includes(M)?z:c.VSBuffer.fromString(q(X(n.decode(z.buffer))))}}),define(ye[221],Ce([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(ye[222],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=c;function t(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=t;function k(C){return Array.from(C.entries()).map(T=>[T[0],c(T[1].map)])}e.serializeEnvironmentVariableCollections=k;function A(C){return new Map(C.map(T=>[T[0],{map:t(T[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(ye[56],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(A){A.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class k{static fromExtHostTestItem(C,T,S=C.parent){if(C._isRoot)return new k([T]);const y=[C.id];for(let L=S;L&&L.id!==T;L=L.parent)y.push(L.id);return y.push(T),new k(y.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const T=C.indexOf("\0");return T===-1?C:C.slice(0,T)}static fromString(C){return new k(C.split("\0"))}static join(C,T){return new k([...C.path,T])}static joinToString(C,T){return C.toString()+"\0"+T}static parentId(C){const T=C.lastIndexOf("\0");return T===-1?void 0:C.slice(0,T)}static compare(C,T){return C===T?0:T.startsWith(C+"\0")?2:C.startsWith(T+"\0")?3:1}constructor(C,T=C.length){if(this.path=C,this.d=T,C.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new k(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new k(this.path,C)}compare(C){if(typeof C=="string")return k.compare(this.toString(),C);for(let T=0;T<C.d&&T<this.d;T++)if(C.path[T]!==this.path[T])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=k}),define(ye[70],Ce([1,0,2,35,56]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var A;(function(a){a[a.Unset=0]="Unset",a[a.Queued=1]="Queued",a[a.Running=2]="Running",a[a.Passed=3]="Passed",a[a.Failed=4]="Failed",a[a.Skipped=5]="Skipped",a[a.Errored=6]="Errored"})(A=e.TestResultState||(e.TestResultState={}));var C;(function(a){a[a.Run=2]="Run",a[a.Debug=4]="Debug",a[a.Coverage=8]="Coverage",a[a.HasNonDefaultProfile=16]="HasNonDefaultProfile",a[a.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(a){a.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),a.deserialize=n=>({range:t.Range.lift(n.range),uri:c.URI.revive(n.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var S;(function(a){a[a.Error=0]="Error",a[a.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var y;(function(a){a.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&T.serialize(n.location)}),a.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&T.deserialize(n.location)})})(y=e.ITestErrorMessage||(e.ITestErrorMessage={}));const L=(a,n)=>`${n?"s":"e"}${a}`;e.getMarkId=L;var P;(function(a){a.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&T.serialize(n.location)}),a.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&T.deserialize(n.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var v;(function(a){a.serialize=n=>n.type===0?y.serialize(n):P.serialize(n),a.deserialize=n=>n.type===0?y.deserialize(n):P.deserialize(n)})(v=e.ITestMessage||(e.ITestMessage={}));var D;(function(a){a.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),a.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(v.serialize)}),a.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(v.deserialize)})})(D=e.ITestTaskState||(e.ITestTaskState={}));const E="\0",d=(a,n)=>a+E+n;e.namespaceTestTag=d;const m=a=>{const n=a.indexOf(E);return{ctrlId:a.slice(0,n),tagId:a.slice(n+1)}};e.denamespaceTestTag=m;var h;(function(a){a.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),a.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?c.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(h=e.ITestItem||(e.ITestItem={}));var b;(function(a){a[a.NotExpandable=0]="NotExpandable",a[a.Expandable=1]="Expandable",a[a.BusyExpanding=2]="BusyExpanding",a[a.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var p;(function(a){a.serialize=n=>({expand:n.expand,item:h.serialize(n.item)}),a.deserialize=n=>({controllerId:k.TestId.root(n.item.extId),expand:n.expand,item:h.deserialize(n.item)})})(p=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(a){a.serialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.uri!==void 0&&(r.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(r.range=n.item.range?.toJSON()),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}},a.deserialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.range!==void 0&&(r.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(a,n)=>{n.expand!==void 0&&(a.expand=n.expand),n.item!==void 0&&(a.item=a.item?Object.assign(a.item,n.item):n.item)};e.applyTestItemUpdate=w;var i;(function(a){a.serializeWithoutMessages=n=>({...p.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(D.serializeWithoutMessages),retired:n.retired}),a.serialize=n=>({...p.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(D.serialize),retired:n.retired}),a.deserialize=n=>({...p.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(D.deserialize),retired:!0})})(i=e.TestResultItem||(e.TestResultItem={}));var o;(function(a){a[a.Function=0]="Function",a[a.Statement=1]="Statement"})(o=e.DetailType||(e.DetailType={}));var u;(function(a){a[a.Add=0]="Add",a[a.Update=1]="Update",a[a.DocumentSynced=2]="DocumentSynced",a[a.Remove=3]="Remove",a[a.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",a[a.Retire=5]="Retire",a[a.AddTag=6]="AddTag",a[a.RemoveTag=7]="RemoveTag"})(u=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(a){a.deserialize=n=>n.op===0?{op:n.op,item:p.deserialize(n.item)}:n.op===1?{op:n.op,item:g.deserialize(n.item)}:n.op===2?{op:n.op,uri:c.URI.revive(n.uri),docv:n.docv}:n,a.serialize=n=>n.op===0?{op:n.op,item:p.serialize(n.item)}:n.op===1?{op:n.op,item:g.serialize(n.item)}:n})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class s{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const r=this.o();for(const f of n)switch(f.op){case 0:this.j(p.deserialize(f.item),r);break;case 1:this.k(g.deserialize(f.item),r);break;case 3:this.l(f.itemId,r);break;case 5:this.m(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this.c.set(f.tag.id,f.tag);break;case 7:this.c.delete(f.id);break}r.complete?.()}j(n,r){const f=k.TestId.parentId(n.item.extId)?.toString();let I;if(!f)I=this.p(n),this.f.add(I),this.d.set(n.item.extId,I);else if(this.d.has(f)){const R=this.d.get(f);R.children.add(n.item.extId),I=this.p(n,R),this.d.set(n.item.extId,I)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return r.add?.(I),n.expand===2&&this.g++,I}k(n,r){const f=this.d.get(n.extId);if(!!f)return n.expand!==void 0&&(f.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(f,n),r.update?.(f),f}l(n,r){const f=this.d.get(n);if(!f)return;const I=k.TestId.parentId(f.item.extId)?.toString();I?this.d.get(I).children.delete(f.item.extId):this.f.delete(f);const R=[[n]];for(;R.length;)for(const B of R.pop()){const X=this.d.get(B);X&&(R.push(X.children),this.d.delete(B),r.remove?.(X,X!==f),X.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=s}),define(ye[92],Ce([1,0,18,4,6,49,70,56]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(b){b[b.Upsert=0]="Upsert",b[b.SetTags=1]="SetTags",b[b.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",b[b.RemoveChild=3]="RemoveChild",b[b.SetProp=4]="SetProp",b[b.Bulk=5]="Bulk",b[b.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const y=(b,p)=>b===p,P=Object.entries({range:(b,p)=>b===p?!0:!b||!p?!1:b.equalsRange(p),busy:y,label:y,description:y,error:y,sortText:y,tags:(b,p)=>!(b.length!==p.length||b.some(g=>!p.includes(g)))}),v=(b,p)=>{let g;for(const[w,i]of P)i(b[w],p[w])||(g?g[w]=p[w]:g={[w]:p[w]});return g};class D extends k.Disposable{get root(){return this.m.root}constructor(p){super(),this.m=p,this.f=this.B(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(p){this.h=p;for(const g of this.tree.values())this.G(g)}collectDiff(){const p=this.k;return this.k=[],p}pushDiff(p){switch(p.op){case 2:{for(const g of this.k)if(g.op===2&&g.uri===p.uri){g.docv=p.docv;return}break}case 1:{const g=this.k[this.k.length-1];if(g){if(g.op===1&&g.item.extId===p.item.extId){(0,C.applyTestItemUpdate)(g.item,p.item);return}if(g.op===0&&g.item.item.extId===p.item.extId){(0,C.applyTestItemUpdate)(g.item,p.item);return}}break}}this.k.push(p),this.f.isScheduled()||this.f.schedule()}expand(p,g){const w=this.tree.get(p);if(!!w){if((w.expandLevels===void 0||g>w.expandLevels)&&(w.expandLevels=g),w.expand===1){const i=this.I(w);return i.isOpen()?this.H(w,g-1):i.wait().then(()=>this.H(w,g-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.H(w,g-1)):this.H(w,g-1)}}dispose(){for(const p of this.tree.values())this.m.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(p,g){switch(g.op){case 3:this.L(T.TestId.joinToString(p.fullId,g.id));break;case 0:this.u(g.item,p);break;case 5:for(const w of g.ops)this.p(p,w);break;case 1:this.w(g.new,g.old,p.fullId.toString());break;case 2:this.G(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:g.update}});break;case 6:this.s(p.actual.uri);break;default:(0,A.assertNever)(g)}}s(p){p&&this.pushDiff({op:2,uri:p,docv:this.m.getDocumentVersion(p)})}u(p,g){const w=T.TestId.fromExtHostTestItem(p,this.root.id,g?.actual),i=this.m.getApiFor(p);i.parent&&i.parent!==g?.actual&&this.m.getChildren(i.parent).delete(p.id);let o=this.tree.get(w.toString());if(!o){o={fullId:w,actual:p,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},p.tags.forEach(this.y,this),this.tree.set(o.fullId.toString(),o),this.C(p,g),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(p)}}),this.F(p,o,g);return}if(o.actual===p){this.D(p,o,g);return}if(o.actual.uri?.toString()!==p.uri?.toString())return this.L(w.toString()),this.u(p,g);const u=this.m.getChildren(o.actual),l=o.actual,s=v(this.m.toITestItem(l),this.m.toITestItem(p));this.m.getApiFor(l).listener=void 0,o.actual=p,o.expand=0,s&&(s.hasOwnProperty("tags")&&(this.w(p.tags,l.tags,w.toString()),delete s.tags),this.p(o,{op:4,update:s})),this.F(p,o,g);for(const[a,n]of u)this.m.getChildren(p).get(n.id)||this.L(T.TestId.joinToString(w,n.id));this.s(o.actual.uri)}w(p,g,w){const i=new Set(g.map(o=>o.id));for(const o of p)i.delete(o.id)||this.y(o);this.pushDiff({op:1,item:{extId:w,item:{tags:p.map(o=>(0,C.namespaceTestTag)(this.m.controllerId,o.id))}}}),i.forEach(this.z,this)}y(p){const g=this.j.get(p.id);g?g.refCount++:(this.j.set(p.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,p.id)}}))}z(p){const g=this.j.get(p);g&&!--g.refCount&&(this.j.delete(p),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,p)}))}C(p,g){this.m.getApiFor(p).parent=g&&g.actual!==this.root?g.actual:void 0}D(p,g,w){this.C(p,w);const i=this.m.getApiFor(p);i.parent=w?.actual,i.listener=o=>this.p(g,o),this.G(g)}F(p,g,w){this.D(p,g,w);for(const[i,o]of this.m.getChildren(p))this.u(o,g)}G(p){let g;this.h?p.resolveBarrier?g=p.resolveBarrier.isOpen()?3:2:g=p.actual.canResolveChildren?1:0:g=0,g!==p.expand&&(p.expand=g,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:g}}),g===1&&p.expandLevels!==void 0&&this.I(p))}H(p,g){if(g<0)return;const w=[];for(const[i,o]of this.m.getChildren(p.actual)){const u=this.expand(T.TestId.joinToString(p.fullId,o.id),g);(0,c.isThenable)(u)&&w.push(u)}if(w.length)return Promise.all(w).then(()=>{})}I(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this.h){const o=new c.Barrier;return o.open(),o}p.expand=2,this.J(p);const g=p.resolveBarrier=new c.Barrier,w=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let i;try{i=this.h(p.actual===this.root?void 0:p.actual)}catch(o){w(o)}return(0,c.isThenable)(i)?i.catch(w).then(()=>{g.open(),this.G(p)}):(g.open(),this.G(p)),p.resolveBarrier}J(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}L(p){const g=this.tree.get(p);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:p});const w=[g];for(;w.length;){const i=w.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const o of i.actual.tags)this.z(o.id);this.tree.delete(i.fullId.toString());for(const[o,u]of this.m.getChildren(i.actual))w.push(this.tree.get(T.TestId.joinToString(i.fullId,u.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.g.fire(p)}}e.TestItemCollection=D;class E extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.DuplicateTestItemError=E;class d extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class m extends Error{constructor(p,g,w){super(`TestItem with ID "${p}" is from controller "${g}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=m;const h=(b,p,g)=>{let w=new Map;return{get size(){return w.size},forEach(i,o){for(const u of w.values())i.call(o,u,this)},[Symbol.iterator](){return w.entries()},replace(i){const o=new Map,u=new Set(w.keys()),l={op:5,ops:[]};for(const s of i){if(!(s instanceof g))throw new d(s.id);const a=p(s).controllerId;if(a!==b.controllerId)throw new m(s.id,a,b.controllerId);if(o.has(s.id))throw new E(s.id);o.set(s.id,s),u.delete(s.id),l.ops.push({op:0,item:s})}for(const s of u.keys())l.ops.push({op:3,id:s});b.listener?.(l),w=o},add(i){if(!(i instanceof g))throw new d(i.id);w.set(i.id,i),b.listener?.({op:0,item:i})},delete(i){w.delete(i)&&b.listener?.({op:3,id:i})},get(i){return w.get(i)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=h}),define(ye[132],Ce([1,0,92]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,k=(C,T)=>{const S={controllerId:T};return t.set(C,S),S};e.createPrivateApiFor=k;const A=C=>{const T=t.get(C);if(!T)throw new c.InvalidTestItemError(C?.id||"<unknown>");return T};e.getPrivateApiFor=A}),define(ye[93],Ce([1,0,15,2]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function k(T,S){return T.scheme===c.Schemas.http||T.scheme===c.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===c.Schemas.file&&(T=t.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:T.path})),t.URI.from({scheme:c.Schemas.https,authority:`${T.scheme}+${A(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=k;function A(T){return T.replace(/./g,S=>{const y=S.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?S:"-"+y.toString(16).padStart(4,"0")})}function C(T){return T.replace(/-([0-9a-f]{4})/g,(S,y)=>String.fromCharCode(parseInt(y,16)))}e.decodeAuthority=C}),define(ye[223],Ce([1,0,4,6,93]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(T,S,y){this.d=T,this.e=S,this.f=y,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const L=S.getVisibleTextEditors();for(const P of this.c.values())L.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,S,y,L,P){let v;for(const p of this.e.getVisibleTextEditors(!0))if(p.value===T){v=p;break}if(!v)throw new Error("not a visible editor");const D=this,E=this.a++,d=new c.Emitter,m=new c.Emitter,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(p){return(0,k.asWebviewUri)(p,D.f)}get cspSource(){return k.webviewGenericCspSource}set options(p){this.b=p,D.d.$setOptions(E,p)}get options(){return this.b}set html(p){this.a=p,D.d.$setHtml(E,p)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(p){return D.d.$postMessage(E,p)}},b=new class{constructor(){this.editor=T,this.line=S,this.height=y,this.webview=h,this.onDidDispose=m.event}dispose(){D.c.has(E)&&(D.c.delete(E),D.d.$disposeEditorInset(E),m.fire(),m.dispose(),d.dispose())}};return this.d.$createEditorInset(E,v.id,v.value.document.uri,S+1,y,L||{},P.identifier,P.extensionLocation),this.c.set(E,{editor:T,inset:b,onDidReceiveMessage:d}),b}$onDidDispose(T){const S=this.c.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){this.c.get(T)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(ye[224],Ce([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var t;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class k extends Error{constructor(C,T){super(T),this.variable=C}}e.VariableError=k}),define(ye[225],Ce([1,0,9,36,11,23,12,112,188,224,8]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(D,E,d,m){this.g=new Map,this.a=D,this.b=E,this.d=d,m&&(this.c=m.then(h=>this.h(h)))}h(D){if(C.isWindows){const E=Object.create(null);return Object.keys(D).forEach(d=>{E[d.toLowerCase()]=D[d]}),E}return D}resolveWithEnvironment(D,E,d){return this.j({env:this.h(D),userHome:void 0},E?E.uri:void 0,d)}async resolveAsync(D,E){const d={env:await this.c,userHome:await this.d};return this.j(d,D?D.uri:void 0,E)}async i(D,E,d,m){const h=A.deepClone(E);C.isWindows&&h.windows?Object.keys(h.windows).forEach(p=>h[p]=h.windows[p]):C.isMacintosh&&h.osx?Object.keys(h.osx).forEach(p=>h[p]=h.osx[p]):C.isLinux&&h.linux&&Object.keys(h.linux).forEach(p=>h[p]=h.linux[p]),delete h.windows,delete h.osx,delete h.linux;const b={env:await this.c,userHome:await this.d};return this.j(b,D?D.uri:void 0,h,d,m)}async resolveAnyAsync(D,E,d){return this.i(D,E,d)}async resolveAnyMap(D,E,d){const m=new Map;return{newConfig:await this.i(D,E,d,m),resolvedVariables:m}}resolveWithInteractionReplace(D,E,d,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,E,d,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,E){if(this.g.has(D))throw new Error("Variable "+D+" is contributed twice.");this.g.set(D,E)}async j(D,E,d,m,h){if(k.isString(d))return this.l(D,E,d,m,h);if(Array.isArray(d))return Promise.all(d.map(b=>this.j(D,E,b,m,h)));if(k.isObject(d)){const b=Object.create(null),p=await Promise.all(Object.keys(d).map(async g=>[await this.l(D,E,g,m,h),await this.j(D,E,d[g],m,h)]));for(const[g,w]of p)b[g]=w;return b}return d}l(D,E,d,m,h){return(0,L.replaceAsync)(d,P.VARIABLE_REGEXP,async(b,p)=>{if(p.includes(P.VARIABLE_LHS))return b;let g=await this.n(D,b,p,E,m);return h?.set(p,g),g!==b&&k.isString(g)&&g.match(P.VARIABLE_REGEXP)&&(g=await this.l(D,E,g,m,h)),g})}m(D){return this.b?this.b.getUriLabel(D,{noPrefix:!0}):D.fsPath}async n(D,E,d,m,h){let b;const p=d.split(":");p.length>1&&(d=p[0],b=p[1]);const g=o=>{const u=this.a.getFilePath();if(u)return(0,T.normalizeDriveLetter)(u);throw new y.VariableError(o,(0,S.localize)(0,null,E))},w=o=>{const u=g(o);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,T.normalizeDriveLetter)(l)}throw new y.VariableError(o,(0,S.localize)(1,null,E,c.basename(u)))},i=o=>{if(b){const u=this.a.getFolderUri(b);if(u)return u;throw new y.VariableError(o,(0,S.localize)(2,null,E,b))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new y.VariableError(o,(0,S.localize)(3,null,E)):new y.VariableError(o,(0,S.localize)(4,null,E))};switch(d){case"env":if(b){if(D.env){const o=D.env[C.isWindows?b.toLowerCase():b];if(k.isString(o))return o}return""}throw new y.VariableError(y.VariableKind.Env,(0,S.localize)(5,null,E));case"config":if(b){const o=this.a.getConfigurationValue(m,b);if(k.isUndefinedOrNull(o))throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(6,null,E,b));if(k.isObject(o))throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(7,null,E,b));return o}throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(8,null,E));case"command":return this.o(y.VariableKind.Command,E,b,h,"command");case"input":return this.o(y.VariableKind.Input,E,b,h,"input");case"extensionInstallFolder":if(b){const o=await this.a.getExtension(b);if(!o)throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,E,b));return this.m(o.extensionLocation)}throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,E));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.m(i(y.VariableKind.WorkspaceFolder)));case"cwd":return m||b?(0,T.normalizeDriveLetter)(this.m(i(y.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.normalizeDriveLetter)(c.basename(this.m(i(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new y.VariableError(y.VariableKind.UserHome,(0,S.localize)(11,null,E))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new y.VariableError(y.VariableKind.LineNumber,(0,S.localize)(12,null,E))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new y.VariableError(y.VariableKind.SelectedText,(0,S.localize)(13,null,E))}case"file":return g(y.VariableKind.File);case"fileWorkspaceFolder":return w(y.VariableKind.FileWorkspaceFolder);case"relativeFile":return m||b?c.relative(this.m(i(y.VariableKind.RelativeFile)),g(y.VariableKind.RelativeFile)):g(y.VariableKind.RelativeFile);case"relativeFileDirname":{const o=c.dirname(g(y.VariableKind.RelativeFileDirname));if(m||b){const u=c.relative(this.m(i(y.VariableKind.RelativeFileDirname)),o);return u.length===0?".":u}return o}case"fileDirname":return c.dirname(g(y.VariableKind.FileDirname));case"fileExtname":return c.extname(g(y.VariableKind.FileExtname));case"fileBasename":return c.basename(g(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=c.basename(g(y.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-c.extname(o).length)}case"fileDirnameBasename":return c.basename(c.dirname(g(y.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||E}case"execInstallFolder":{const o=this.a.getAppRoot();return o||E}case"pathSeparator":return c.sep;default:try{const o=b?`${d}:${b}`:d;return this.o(y.VariableKind.Unknown,E,o,h,void 0)}catch{return E}}}}o(D,E,d,m,h){if(d&&m){const b=h===void 0?m[d]:m[h+":"+d];if(typeof b=="string")return b;throw new y.VariableError(D,(0,S.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[133],Ce([1,0,3,130]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var k;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var A;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var T;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function y(E){const d=E;return(0,t.isEditorInput)(d?.editor)&&(0,t.isEditorInput)(d?.replacement)}e.isEditorReplacement=y;var L;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function v(E){const d=E;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=v;function D(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=D}),define(ye[226],Ce([1,0,3,133]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(A){const C=A;return typeof A=="number"||(0,t.isEditorGroup)(C)}e.isPreferredGroup=k}),define(ye[227],Ce([1,0,3,194]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[134],Ce([1,0,27,4,9]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=A;class C{static isHostExtension(P,v,D){if(v.getExtensionDescription(P))return!1;const E=D.getExtensionDescription(P);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(P){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(c.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(c.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let v of P.activationEvents)v==="onUri"&&(v=`onUri:${c.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,v){this.d=y(this.d,v),this.d=this.d.concat(P);const D=C.j(this.d);return this.d=y(this.d,D.map(E=>E.identifier)),this.h(),this.c.fire(void 0),new A(D)}static j(P){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,b){this.addNode(h),this.addNode(b),this.c.has(h)?this.c.get(h).push(b):this.c.set(h,[b])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,b){const p=v.getArcs(h);for(let g=0;g<p.length;g++)if(!b.has(p[g]))return!1;return!0}getNodes(){return this.e}},D=new Map;for(const h of P){const b=c.ExtensionIdentifier.toKey(h.identifier);if(D.set(b,h),h.extensionDependencies)for(const p of h.extensionDependencies){const g=c.ExtensionIdentifier.toKey(p);v.addArc(b,g)}}const E=new Set;v.getNodes().filter(h=>v.getArcs(h).length===0).forEach(h=>E.add(h));const d=v.getNodes().filter(h=>!E.has(h));let m;do{m=!1;for(let h=0;h<d.length;h++){const b=d[h];v.hasOnlyGoodArcs(b,E)&&(d.splice(h,1),h--,E.add(b),m=!0)}}while(m);return d.map(h=>D.get(h))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(c.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const v=this.g.get(P);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const v=this.e.get(c.ExtensionIdentifier.toKey(P));return v||void 0}getExtensionDescriptionByUUID(P){for(const v of this.f)if(v.uuid===P)return v}getExtensionDescriptionByIdOrUUID(P,v){return this.getExtensionDescription(P)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=C;var T;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(T||(T={}));function S(L,P){const v=L.isBuiltin?0:L.isUnderDevelopment?2:1,D=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(v!==D)return v-D;const E=k.posix.basename(L.extensionLocation.path),d=k.posix.basename(P.extensionLocation.path);return E<d?-1:E>d?1:0}function y(L,P){const v=new Set;return P.forEach(D=>v.add(c.ExtensionIdentifier.toKey(D))),L.filter(D=>!v.has(c.ExtensionIdentifier.toKey(D.identifier)))}}),define(ye[228],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class k{constructor(){this.type=2}serialize(P){P[k.ENV_KEY]="1"}}e.SocketExtHostConnection=k,k.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(P){P[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function C(L){delete L[t.ENV_KEY],delete L[k.ENV_KEY],delete L[A.ENV_KEY]}function T(L,P){C(P),L.serialize(P)}e.writeExtHostConnection=T;function S(L){if(L[t.ENV_KEY])return y(L,new t(L[t.ENV_KEY]));if(L[k.ENV_KEY])return y(L,new k);if(L[A.ENV_KEY])return y(L,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function y(L,P){return C(L),P}}),define(ye[94],Ce([1,0,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var k;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function C(y){const L=c.VSBuffer.alloc(1);switch(y){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=C;function T(y,L){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=T;var S;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[95],Ce([1,0,3,4,13,25,94,67,68,23,2]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let P=class{constructor(d,m){this.i=d,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=m.createLogger(L.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(d,m,h){const b=this.getTelemetryDetails(),p=new v(m,h,d,this.g,this.f,this.getBuiltInCommonProperties(d),{isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled});return this.h.set(d.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(d,m,h){this.d=d,this.f=m,this.c=h??{usage:!0,error:!0}}getBuiltInCommonProperties(d){const m={};switch(m["common.extname"]=d.name,m["common.extversion"]=d.version,m["common.vscodemachineid"]=this.i.telemetryInfo.machineId,m["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,m["common.vscodeversion"]=this.i.version,m["common.isnewappinstall"]=D(this.i.telemetryInfo.firstSessionDate),m["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:m["common.uikind"]="web";break;case C.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,T.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),m}$onDidChangeTelemetryLevel(d){this.e=this.getTelemetryConfiguration(),this.d=d;const m=this.getTelemetryDetails();this.h.forEach(h=>{h.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(d,m){const h=this.h.get(d.value);return!h||h.ignoreUnhandledExtHostErrors?!1:(h.logError(m),!0)}};P=qe([He(0,A.IExtHostInitDataService),He(1,k.ILoggerService)],P),e.ExtHostTelemetry=P;class v{constructor(d,m,h,b,p,g,w){this.g=h,this.h=b,this.i=p,this.j=g,this.b=new t.Emitter,this.ignoreUnhandledExtHostErrors=m?.ignoreUnhandledErrors??!1,this.e=m?.ignoreBuiltInCommonProperties??!1,this.f=m?.additionalCommonProperties,this.a=d,this.c={isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}}updateTelemetryEnablements(d,m){this.d&&(this.c={isUsageEnabled:d,isErrorsEnabled:m},this.b.fire(this.d))}mixInCommonPropsAndCleanData(d){let m=d.properties??d;return m=(0,S.cleanData)(m,[]),this.f&&(m=(0,y.mixin)(m,this.f)),this.e||(m=(0,y.mixin)(m,this.j)),d.properties?d.properties=m:d=m,d}k(d,m){this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.a.logEvent(d,m),this.h.trace(d,m)}logUsage(d,m){!this.c.isUsageEnabled||this.k(d,m)}logError(d,m){!this.c.isErrorsEnabled||(typeof d=="string"?this.k(d,m):this.a.logError(d,m))}get apiTelemetryLogger(){if(!this.d){const d=this,m={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.c.isUsageEnabled},get isErrorsEnabled(){return d.c.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.b.event.bind(d)};this.d=Object.freeze(m)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=v;function D(E){const d=Date.now()-new Date(E).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=D,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(ye[26],Ce([1,0,4,2,3,27,206]),function(ne,e,c,t,k,A,C){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class S{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class y{constructor(a){this.affinity=a,this.kind=2}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=y;class L{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class P{constructor(a){this.dependency=a}}e.MissingExtensionDependency=P;var v;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function D(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=D;class E{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(a,n){const r=[],f=[],I=[],R=[],B=h(this.c),X=h(a),q=(z,U)=>z.extensionLocation.toString()===U.extensionLocation.toString()||z.isBuiltin===U.isBuiltin||z.isUserBuiltin===U.isUserBuiltin||z.isUnderDevelopment===U.isUnderDevelopment;for(const z of this.c){const U=X.get(A.ExtensionIdentifier.toKey(z.identifier));if(!U){r.push(z.identifier),B.delete(A.ExtensionIdentifier.toKey(z.identifier));continue}if(!q(z,U)){r.push(z.identifier),B.delete(A.ExtensionIdentifier.toKey(z.identifier));continue}}for(const z of a){const U=B.get(A.ExtensionIdentifier.toKey(z.identifier));if(!U){f.push(z);continue}if(!q(U,z)){r.push(U.identifier),B.delete(A.ExtensionIdentifier.toKey(U.identifier));continue}}const N=m(this.d),M=m(n);for(const z of this.d)M.has(A.ExtensionIdentifier.toKey(z))||I.push(z);for(const z of n)N.has(A.ExtensionIdentifier.toKey(z))||R.push(z);const F={toRemove:r,toAdd:f,myToRemove:I,myToAdd:R};return this.delta(F),F}delta(a){const{toRemove:n,toAdd:r,myToRemove:f,myToAdd:I}=a,R=m(n),B=m(f);for(let X=0;X<this.c.length;X++)R.has(A.ExtensionIdentifier.toKey(this.c[X].identifier))&&(this.c.splice(X,1),X--);for(let X=0;X<this.d.length;X++)B.has(A.ExtensionIdentifier.toKey(this.d[X]))&&(this.d.splice(X,1),X--);for(const X of r)this.c.push(X);for(const X of I)this.d.push(X)}containsExtension(a){for(const n of this.d)if(A.ExtensionIdentifier.equals(n,a))return!0;return!1}}e.ExtensionHostExtensions=E;class d{constructor(a){if(this[T]="ExtensionIdentifierSet",this.c=new Map,this.d=A.ExtensionIdentifier.toKey,a)for(const n of a)this.add(n)}get size(){return this.c.size}add(a){return this.c.set(this.d(a),a),this}clear(){this.c.clear()}delete(a){return this.c.delete(this.d(a))}has(a){return this.c.has(this.d(a))}forEach(a,n){this.c.forEach(r=>a.call(n,r,r,this))}*entries(){for(const[a,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=d;function m(s){const a=new Set;for(const n of s)a.add(A.ExtensionIdentifier.toKey(n));return a}e.extensionIdentifiersArrayToSet=m;function h(s){const a=new Map;for(const n of s)a.set(A.ExtensionIdentifier.toKey(n.identifier),n);return a}function b(s,a){return s.enabledApiProposals?s.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=b;function p(s,a){if(!b(s,a))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=p;class g{constructor(a,n,r,f){this.codeLoadingTime=a,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=f}}e.ActivationTimes=g;class w{constructor(a,n){this.description=a,this.value=n}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var i;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function o(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function u(s,a){return{identifier:new A.ExtensionIdentifier((0,C.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!a,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=u;class l{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,n){return Promise.resolve(0)}getInspectPorts(a,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=l}),define(ye[229],Ce([1,0,10,134,27,26,13,18]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(h,b,p,g){this.startup=h,this.codeLoadingTime=b,this.activateCallTime=p,this.activateResolvedTime=g}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class y{constructor(h){this.a=h,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(h,b){return h===-1||b===-1?-1:b-h}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=y;class L{constructor(h,b,p,g,w,i){this.activationFailed=h,this.activationFailedError=b,this.activationTimes=p,this.module=g,this.exports=w,this.subscriptions=i}}e.ActivatedExtension=L;class P extends L{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class v extends L{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class D extends L{constructor(h){super(!0,h,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(h,b,p,g){this.g=g,this.a=h,this.b=b,this.c=p,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[h,b]of this.d)b.dispose()}isActivated(h){const b=this.d.get(k.ExtensionIdentifier.toKey(h));return Boolean(b&&b.value)}getActivatedExtension(h){const b=this.d.get(k.ExtensionIdentifier.toKey(h));if(!b||!b.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return b.value}async activateByEvent(h,b){if(this.f[h])return;const p=this.a.getExtensionDescriptionsForActivationEvent(h);await this.h(p.map(g=>({id:g.identifier,reason:{startup:b,extensionId:g.identifier,activationEvent:h}}))),this.f[h]=!0}activateById(h,b){const p=this.a.getExtensionDescription(h);if(!p)throw new Error(`Extension '${h}' is not known`);return this.h([{id:p.identifier,reason:b}])}async h(h){const b=h.filter(p=>!this.isActivated(p.id)).map(p=>this.j(p));await Promise.all(b.map(p=>p.wait()))}j(h){if(this.d.has(k.ExtensionIdentifier.toKey(h.id)))return this.d.get(k.ExtensionIdentifier.toKey(h.id));if(this.l(h.id))return this.k(h,null,[],null);const b=this.a.getExtensionDescription(h.id);if(!b){const w=new Error(`Cannot activate unknown extension '${h.id.value}'`),i=this.k(h,null,[],new D(w));return this.c.onExtensionActivationError(h.id,w,new A.MissingExtensionDependency(h.id.value)),i}const p=[],g=typeof b.extensionDependencies>"u"?[]:b.extensionDependencies;for(const w of g){if(this.m(w))continue;const i=this.d.get(k.ExtensionIdentifier.toKey(w));if(i){p.push(i);continue}if(this.l(w)){p.push(this.j({id:this.b.getExtensionDescription(w).identifier,reason:h.reason}));continue}const o=this.a.getExtensionDescription(w);if(o){if(!o.main&&!o.browser)continue;p.push(this.j({id:o.identifier,reason:h.reason}));continue}const u=b.displayName||b.identifier.value,l=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${w}'`),s=this.k(h,b.displayName,[],new D(l));return this.c.onExtensionActivationError(b.identifier,l,new A.MissingExtensionDependency(w)),s}return this.k(h,b.displayName,p,null)}k(h,b,p,g){const w=new d(h.id,b,h.reason,p,g,this.c,this.g);return this.d.set(k.ExtensionIdentifier.toKey(h.id),w),w}l(h){return t.ExtensionDescriptionRegistry.isHostExtension(h,this.a,this.b)}m(h){const b=this.b.getExtensionDescription(h);return b?!b.main&&!b.browser:!1}};E=qe([He(3,C.ILogService)],E),e.ExtensionsActivator=E;let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(h,b,p,g,w,i,o){this.c=h,this.d=b,this.f=p,this.g=g,this.h=w,this.j=i,this.k=o,this.a=new T.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let h=0;h<this.g.length;h++){const b=this.g[h];if(b.value&&!b.value.activationFailed){this.g.splice(h,1),h--;continue}if(b.value&&b.value.activationFailed){const p=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${b.friendlyName}' failed to activate`);p.detail=b.value.activationFailedError,this.h=new D(p),this.j.onExtensionActivationError(this.c,p,null);return}}this.g.length>0&&await Promise.race(this.g.map(h=>h.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(h){const b=new Error;if(h&&h.name&&(b.name=h.name),h&&h.message?b.message=`Activating extension '${this.c.value}' failed: ${h.message}.`:b.message=`Activating extension '${this.c.value}' failed: ${h}.`,h&&h.stack&&(b.stack=h.stack),this.h=new D(b),this.b&&c.isCancellationError(h))return;this.j.onExtensionActivationError(this.c,b,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(h)}}};d=qe([He(6,C.ILogService)],d)}),define(ye[230],Ce([1,0,13,25,26]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends c.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:k.ExtensionHostLogFileName}))}};A=qe([He(0,c.ILoggerService),He(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[7],Ce([1,0,17,10,111,28,84,8,11,2,30,38,128,91,26]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E){"use strict";var d,m,h,b,p,g,w,i,o,u,l,s,a,n,r,f,I,R,B,X,q,N,M;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(G){return Object.assign(G,{apply:function(){const he=arguments.length===1?[]:arguments[1];return Reflect.construct(G,he,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[he,...Te]=arguments;return Reflect.construct(G,Te,he.constructor)}}})}var z;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(z=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var U;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})(U=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let H=g=class{static from(...j){let he=j;return new g(function(){if(he){for(const Te of he)Te&&typeof Te.dispose=="function"&&Te.dispose();he=void 0}})}constructor(j){d.set(this,void 0),Je(this,d,j,"f")}dispose(){typeof Ue(this,d,"f")=="function"&&(Ue(this,d,"f").call(this),Je(this,d,void 0,"f"))}};d=new WeakMap,H=g=qe([F],H),e.Disposable=H;let x=w=class{static Min(...j){if(j.length===0)throw new TypeError;let he=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isBefore(he)&&(he=Ke)}return he}static Max(...j){if(j.length===0)throw new TypeError;let he=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isAfter(he)&&(he=Ke)}return he}static isPosition(j){if(!j)return!1;if(j instanceof w)return!0;const{line:he,character:Te}=j;return typeof he=="number"&&typeof Te=="number"}static of(j){if(j instanceof w)return j;if(this.isPosition(j))return new w(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,he){if(j<0)throw(0,t.illegalArgument)("line must be non-negative");if(he<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=j,this.e=he}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,he=0){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=0:typeof j=="number"?Te=j:(Te=typeof j.lineDelta=="number"?j.lineDelta:0,he=typeof j.characterDelta=="number"?j.characterDelta:0),Te===0&&he===0?this:new w(this.line+Te,this.character+he)}with(j,he=this.character){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=this.line:typeof j=="number"?Te=j:(Te=typeof j.line=="number"?j.line:this.line,he=typeof j.character=="number"?j.character:this.character),Te===this.line&&he===this.character?this:new w(Te,he)}toJSON(){return{line:this.line,character:this.character}}};x=w=qe([F],x),e.Position=x;let V=i=class{static isRange(j){return j instanceof i?!0:j?x.isPosition(j.start)&&x.isPosition(j.end):!1}static of(j){if(j instanceof i)return j;if(this.isRange(j))return new i(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,he,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new x(j,he),ct=new x(Te,Ke)):x.isPosition(j)&&x.isPosition(he)&&(Ye=x.of(j),ct=x.of(he)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this.c=Ye,this.e=ct):(this.c=ct,this.e=Ye)}contains(j){return i.isRange(j)?this.contains(j.start)&&this.contains(j.end):x.isPosition(j)?!(x.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const he=x.Max(j.start,this.c),Te=x.Min(j.end,this.e);if(!he.isAfter(Te))return new i(he,Te)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const he=x.Min(j.start,this.c),Te=x.Max(j.end,this.end);return new i(he,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,he=this.end){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return j?x.isPosition(j)?Te=j:(Te=j.start||this.start,he=j.end||this.end):Te=this.start,Te.isEqual(this.c)&&he.isEqual(this.end)?this:new i(Te,he)}toJSON(){return[this.start,this.end]}};V=i=qe([F],V),e.Range=V;let _=o=class extends V{static isSelection(j){return j instanceof o?!0:j?V.isRange(j)&&x.isPosition(j.anchor)&&x.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,he,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new x(j,he),ct=new x(Te,Ke)):x.isPosition(j)&&x.isPosition(he)&&(Ye=x.of(j),ct=x.of(he)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this.f=Ye,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};_=o=qe([F],_),e.Selection=_;class Q{constructor(j,he,Te){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=j,this.port=Math.round(he),this.connectionToken=Te}}e.ResolvedAuthority=Q;class Z extends Error{static NotAvailable(j,he){return new Z(j,v.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(j){return new Z(j,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,he=v.RemoteAuthorityResolverErrorCode.Unknown,Te){super(j),this._message=j,this._code=he,this._detail=Te,Object.setPrototypeOf(this,Z.prototype)}}e.RemoteAuthorityResolverError=Z;var ge;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(ge=e.EndOfLine||(e.EndOfLine={}));var te;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(te=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=u=class{static isTextEdit(j){return j instanceof u?!0:j?V.isRange(j)&&typeof j.newText=="string":!1}static replace(j,he){return new u(j,he)}static insert(j,he){return u.replace(new V(j,j),he)}static delete(j){return u.replace(j,"")}static setEndOfLine(j){const he=new u(new V(new x(0,0),new x(0,0)),"");return he.newEol=j,he}get range(){return this.c}set range(j){if(j&&!V.isRange(j))throw(0,t.illegalArgument)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,t.illegalArgument)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,t.illegalArgument)("newEol");this.f=j}constructor(j,he){this.c=j,this.e=he}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};J=u=qe([F],J),e.TextEdit=J;let fe=l=class{static isNotebookCellEdit(j){return j instanceof l?!0:j?Gt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,he){return new l(j,he)}static insertCells(j,he){return new l(new Gt(j,j),he)}static deleteCells(j){return new l(j,[])}static updateCellMetadata(j,he){const Te=new l(new Gt(j,j),[]);return Te.newCellMetadata=he,Te}static updateNotebookMetadata(j){const he=new l(new Gt(0,0),[]);return he.newNotebookMetadata=j,he}constructor(j,he){this.range=j,this.newCells=he}};fe=l=qe([F],fe),e.NotebookEdit=fe;class ve{static isSnippetTextEdit(j){return j instanceof ve?!0:j?V.isRange(j.range)&&Fe.isSnippetString(j.snippet):!1}static replace(j,he){return new ve(j,he)}static insert(j,he){return ve.replace(new V(j,j),he)}constructor(j,he){this.range=j,this.snippet=he}}e.SnippetTextEdit=ve;var Ee;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let Ae=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,he,Te,Ke){this.c.push({_type:1,from:j,to:he,options:Te,metadata:Ke})}createFile(j,he,Te){this.c.push({_type:1,from:void 0,to:j,options:he,metadata:Te})}deleteFile(j,he,Te){this.c.push({_type:1,from:j,to:void 0,options:he,metadata:Te})}e(j,he,Te){this.c.push({_type:3,metadata:Te,uri:j,edit:{editType:5,metadata:he},notebookMetadata:he})}f(j,he,Te,Ke){const Ye=he.start,ct=he.end;(Ye!==ct||Te.length>0)&&this.c.push({_type:5,uri:j,index:Ye,count:ct-Ye,cells:Te,metadata:Ke})}g(j,he,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:j,edit:{editType:8,index:he,metadata:Te}})}replace(j,he,Te,Ke){this.c.push({_type:2,uri:j,edit:new J(he,Te),metadata:Ke})}insert(j,he,Te,Ke){this.replace(j,new V(he,he),Te,Ke)}delete(j,he,Te){this.replace(j,he,"",Te)}has(j){return this.c.some(he=>he._type===2&&he.uri.toString()===j.toString())}set(j,he){if(he)for(const Te of he){if(!Te)continue;let Ke,Ye;if(Array.isArray(Te)?(Ke=Te[0],Ye=Te[1]):Ke=Te,fe.isNotebookCellEdit(Ke)){if(j.scheme===D.CellUri.scheme)throw new Error("set must be called with a notebook document URI, not a cell URI.");Ke.newCellMetadata?this.g(j,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(j,Ke.newNotebookMetadata,Ye):this.f(j,Ke.range,Ke.newCells,Ye)}else ve.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:j,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:j,edit:Ke,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===j.toString()&&(this.c[Te]=void 0);break}}(0,c.coalesceInPlace)(this.c)}}get(j){const he=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===j.toString()&&he.push(Te.edit);return he}entries(){const j=new A.ResourceMap;for(const he of this.c)if(he._type===2){let Te=j.get(he.uri);Te||(Te=[he.uri,[]],j.set(he.uri,Te)),Te[1].push(he.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ae=qe([F],Ae),e.WorkspaceEdit=Ae;let Fe=s=class{static isSnippetString(j){return j instanceof s?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=s.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,he=this.e++){if(typeof j=="function"){const Te=new s;Te.e=this.e,j(Te),this.e=Te.e,j=Te.value}else j=s.c(j);return this.value+="${",this.value+=he,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,he=this.e++){const Te=j.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(j,he){if(typeof he=="function"){const Te=new s;Te.e=this.e,he(Te),this.e=Te.e,he=Te.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,he&&(this.value+=":",this.value+=he),this.value+="}",this}};Fe=s=qe([F],Fe),e.SnippetString=Fe;var se;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ue=a=class{static isLocation(j){return j instanceof a?!0:j?V.isRange(j.range)&&y.URI.isUri(j.uri):!1}constructor(j,he){if(this.uri=j,he)if(V.isRange(he))this.range=V.of(he);else if(x.isPosition(he))this.range=new V(he,he);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ue=a=qe([F],ue),e.Location=ue;let ee=class{static is(j){return j?typeof j.message=="string"&&j.location&&V.isRange(j.location.range)&&y.URI.isUri(j.location.uri):!1}constructor(j,he){this.location=j,this.message=he}static isEqual(j,he){return j===he?!0:!j||!he?!1:j.message===he.message&&j.location.range.isEqual(he.location.range)&&j.location.uri.toString()===he.location.uri.toString()}};ee=qe([F],ee),e.DiagnosticRelatedInformation=ee;let ae=class{constructor(j,he,Te=le.Error){if(!V.isRange(j))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=j,this.message=he,this.severity=Te}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,he){return j===he?!0:!j||!he?!1:j.message===he.message&&j.severity===he.severity&&j.code===he.code&&j.severity===he.severity&&j.source===he.source&&j.range.isEqual(he.range)&&(0,c.equals)(j.tags,he.tags)&&(0,c.equals)(j.relatedInformation,he.relatedInformation,ee.isEqual)}};ae=qe([F],ae),e.Diagnostic=ae;let ie=class{constructor(j,he){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=he}};ie=qe([F],ie),e.Hover=ie;var O;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(O=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let W=class{constructor(j,he=O.Text){this.range=j,this.kind=he}toJSON(){return{range:this.range,kind:O[this.kind]}}};W=qe([F],W),e.DocumentHighlight=W;var K;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(K=e.SymbolKind||(e.SymbolKind={}));var Y;(function(G){G[G.Deprecated=1]="Deprecated"})(Y=e.SymbolTag||(e.SymbolTag={}));let de=n=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,he,Te,Ke,Ye){this.name=j,this.kind=he,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ke instanceof ue?this.location=Ke:Te instanceof V&&(this.location=new ue(Ke,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:K[this.kind],location:this.location,containerName:this.containerName}}};de=n=qe([F],de),e.SymbolInformation=de;let be=r=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(r.validate)}constructor(j,he,Te,Ke,Ye){this.name=j,this.detail=he,this.kind=Te,this.range=Ke,this.selectionRange=Ye,this.children=[],r.validate(this)}};be=r=qe([F],be),e.DocumentSymbol=be;var Pe;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(j,he){this.title=j,this.kind=he}};pe=qe([F],pe),e.CodeAction=pe;let De=f=class{constructor(j){this.value=j}append(j){return new f(this.value?this.value+f.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+f.c)}};De.c=".",De=f=qe([F],De),e.CodeActionKind=De,De.Empty=new De(""),De.QuickFix=De.Empty.append("quickfix"),De.Refactor=De.Empty.append("refactor"),De.RefactorExtract=De.Refactor.append("extract"),De.RefactorInline=De.Refactor.append("inline"),De.RefactorMove=De.Refactor.append("move"),De.RefactorRewrite=De.Refactor.append("rewrite"),De.Source=De.Empty.append("source"),De.SourceOrganizeImports=De.Source.append("organizeImports"),De.SourceFixAll=De.Source.append("fixAll");let ke=class{constructor(j,he){if(this.range=j,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([F],ke),e.SelectionRange=ke;class je{constructor(j,he,Te,Ke,Ye,ct){this.kind=j,this.name=he,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=je;class Ge{constructor(j,he){this.fromRanges=he,this.from=j}}e.CallHierarchyIncomingCall=Ge;class et{constructor(j,he){this.fromRanges=he,this.to=j}}e.CallHierarchyOutgoingCall=et;var _e;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(_e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(j,he){this.range=j,this.command=he}get isResolved(){return!!this.command}};nt=qe([F],nt),e.CodeLens=nt;let st=I=class{static isMarkdownString(j){return j instanceof I?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,he=!1){m.set(this,void 0),Je(this,m,new k.MarkdownString(j,{supportThemeIcons:he}),"f")}get value(){return Ue(this,m,"f").value}set value(j){Ue(this,m,"f").value=j}get isTrusted(){return Ue(this,m,"f").isTrusted}set isTrusted(j){Ue(this,m,"f").isTrusted=j}get supportThemeIcons(){return Ue(this,m,"f").supportThemeIcons}set supportThemeIcons(j){Ue(this,m,"f").supportThemeIcons=j}get supportHtml(){return Ue(this,m,"f").supportHtml}set supportHtml(j){Ue(this,m,"f").supportHtml=j}get baseUri(){return Ue(this,m,"f").baseUri}set baseUri(j){Ue(this,m,"f").baseUri=j}appendText(j){return Ue(this,m,"f").appendText(j),this}appendMarkdown(j){return Ue(this,m,"f").appendMarkdown(j),this}appendCodeblock(j,he){return Ue(this,m,"f").appendCodeblock(he??"",j),this}};m=new WeakMap,st=I=qe([F],st),e.MarkdownString=st;let ht=class{constructor(j,he){this.label=j,this.documentation=he}};ht=qe([F],ht),e.ParameterInformation=ht;let Me=class{constructor(j,he){this.label=j,this.documentation=he,this.parameters=[]}};Me=qe([F],Me),e.SignatureInformation=Me;let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};it=qe([F],it),e.SignatureHelp=it;var oe;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})($=e.InlayHintKind||(e.InlayHintKind={}));let ce=class{constructor(j){this.value=j}};ce=qe([F],ce),e.InlayHintLabelPart=ce;let Ie=class{constructor(j,he,Te){this.position=j,this.label=he,this.kind=Te}};Ie=qe([F],Ie),e.InlayHint=Ie;var Le;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var xe;(function(G){G[G.Deprecated=1]="Deprecated"})(xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(j,he){this.label=j,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([F],Ze),e.CompletionItem=Ze;let gt=class{constructor(j=[],he=!1){this.items=j,this.isIncomplete=he}};gt=qe([F],gt),e.CompletionList=gt;let mt=class{constructor(j,he,Te){this.insertText=j,this.range=he,this.command=Te}};mt=qe([F],mt),e.InlineSuggestion=mt;let lt=class{constructor(j){this.commands=void 0,this.items=j}};lt=qe([F],lt),e.InlineSuggestionList=lt;var ot;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var rt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var kt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(kt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Tt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var zt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(zt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function j(he){switch(he){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=j}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(j,he){if(he&&!y.URI.isUri(he))throw(0,t.illegalArgument)("target");if(!V.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.target=he}};Ft=qe([F],Ft),e.DocumentLink=Ft;let Xe=class{constructor(j,he,Te,Ke){this.red=j,this.green=he,this.blue=Te,this.alpha=Ke}};Xe=qe([F],Xe),e.Color=Xe;let Mt=class{constructor(j,he){if(he&&!(he instanceof Xe))throw(0,t.illegalArgument)("color");if(!V.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.color=he}};Mt=qe([F],Mt),e.ColorInformation=Mt;let Ut=class{constructor(j){if(!j||typeof j!="string")throw(0,t.illegalArgument)("label");this.label=j}};Ut=qe([F],Ut),e.ColorPresentation=Ut;var Bt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Bt=e.ColorFormat||(e.ColorFormat={}));var bt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Pt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Pt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(j,he,Te){if(this.startIndex=j,this.length=he,this.tooltip=Te,typeof j!="number"||j<0)throw(0,t.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Oe{constructor(j){this.uri=j}}e.TerminalQuickFixOpener=Oe;class Se{constructor(j){this.terminalCommand=j}}e.TerminalQuickFixCommand=Se;var re;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class Ne{constructor(j){if(this.options=j,typeof j!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ne;var $e;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})($e=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=R=class{static from(j){switch(j){case"clean":return R.Clean;case"build":return R.Build;case"rebuild":return R.Rebuild;case"test":return R.Test;default:return}}constructor(j,he){if(this.label=he,typeof j!="string"||typeof he!="string")throw(0,t.illegalArgument)("name");this.c=j}get id(){return this.c}};Ve.Clean=new R("clean","Clean"),Ve.Build=new R("build","Build"),Ve.Rebuild=new R("rebuild","Rebuild"),Ve.Test=new R("test","Test"),Ve=R=qe([F],Ve),e.TaskGroup=Ve;function tt(G){let j="";for(let he=0;he<G.length;he++)j+=G[he].replace(/,/g,",,")+",";return j}let St=class{constructor(j,he,Te){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=j,he!==void 0&&(Array.isArray(he)?(this.e=he,this.f=Te):this.f=he)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const he of this.e)j.push(he);return tt(j)}};St=qe([F],St),e.ProcessExecution=St;let Et=class{constructor(j,he,Te){if(this.f=[],Array.isArray(he)){if(!j)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j,this.f=he,this.g=Te}else{if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j,this.g=he}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const he of this.f)j.push(typeof he=="string"?he:he.value);return tt(j)}};Et=qe([F],Et),e.ShellExecution=Et;var Lt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Lt=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class It{constructor(j){this.c=j}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(j){this.c=j}get callback(){return this.c}}e.CustomExecution=It;let ft=B=class{constructor(j,he,Te,Ke,Ye,ct){this.j=!1,this.k=this.definition=j;let dt;typeof he=="string"?(this.m=this.name=he,this.t=this.source=Te,this.execution=Ke,dt=Ye,this.j=!0):he===vt.Global||he===vt.Workspace?(this.target=he,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct):(this.target=he,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(j){this.h=j}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof St?this.k={type:B.e,id:this.n.computeId()}:this.n instanceof Et?this.k={type:B.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:B.c,id:this.n.computeId()}:this.k={type:B.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(j){if(j==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=j}get scope(){return this.l}set target(j){this.y(),this.l=j}get name(){return this.m}set name(j){if(typeof j!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=j}get execution(){return this.n}set execution(j){j===null&&(j=void 0),this.y(),this.n=j;const he=this.k.type;(B.g===he||B.e===he||B.f===he||B.c===he)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(j){if(Array.isArray(j))this.y(),this.o=j,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.y(),this.r=j}get source(){return this.t}set source(j){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=j}get group(){return this.u}set group(j){j===null&&(j=void 0),this.y(),this.u=j}get detail(){return this.x}set detail(j){j===null&&(j=void 0),this.x=j}get presentationOptions(){return this.v}set presentationOptions(j){j==null&&(j=Object.create(null)),this.y(),this.v=j}get runOptions(){return this.w}set runOptions(j){j==null&&(j=Object.create(null)),this.y(),this.w=j}};ft.c="customExecution",ft.e="process",ft.f="shell",ft.g="$empty",ft=B=qe([F],ft),e.Task=ft;var xt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(xt=e.ProgressLocation||(e.ProgressLocation={}));var jt;(function(G){function j(he){const Te=he;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}G.isViewBadge=j})(jt=e.ViewBadge||(e.ViewBadge={}));let yt=X=class{static isTreeItem(j,he){if(j instanceof X)return!0;const Te=j;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!y.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!y.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!y.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!y.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<_t.None&&Te.collapsibleState>_t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,E.checkProposedApiEnabled)(he,"treeItemCheckbox");const Ke=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==an.Checked&&Ke!==an.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(j,he=_t.None){this.collapsibleState=he,y.URI.isUri(j)?this.resourceUri=j:this.label=j}};yt=X=qe([F],yt),e.TreeItem=yt;var _t;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var an;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(an=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Zt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j,he){this.value=j,this.id=he??(0,L.generateUuid)()}};Zt=qe([F],Zt),e.DataTransferItem=Zt;let vn=class{constructor(j){h.set(this,new Map);for(const[he,Te]of j??[]){const Ke=Ue(this,h,"f").get(he);Ke?Ke.push(Te):Ue(this,h,"f").set(he,[Te])}}get(j){return Ue(this,h,"f").get(j)?.[0]}set(j,he){Ue(this,h,"f").set(j,[he])}forEach(j,he){for(const[Te,Ke]of Ue(this,h,"f"))for(const Ye of Ke)j.call(he,Ye,Te,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[j,he]of Ue(this,h,"f"))for(const Te of he)yield[j,Te]}};vn=qe([F],vn),e.DataTransfer=vn;let At=class{constructor(j){this.insertText=j}};At=qe([F],At),e.DocumentDropEdit=At;let cn=class{constructor(j){this.insertText=j}};cn=qe([F],cn),e.DocumentPasteEdit=cn;let Vt=class{constructor(j,he){this.id=j,this.color=he}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};Vt=qe([F],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let en=class{constructor(j){this.id=j}};en=qe([F],en),e.ThemeColor=en;var ln;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(ln=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ut=class{get base(){return this.c}set base(j){this.c=j,this.e=y.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,he){if(typeof j!="string"&&(!j||!y.URI.isUri(j)&&!y.URI.isUri(j.uri)))throw(0,t.illegalArgument)("base");if(typeof he!="string")throw(0,t.illegalArgument)("pattern");typeof j=="string"?this.baseUri=y.URI.file(j):y.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=he}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ut=qe([F],ut),e.RelativePattern=ut;let tn=class{constructor(j,he,Te,Ke){this.enabled=typeof j=="boolean"?j:!0,typeof he=="string"&&(this.condition=he),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,L.generateUuid)()),this.c}};tn=qe([F],tn),e.Breakpoint=tn;let qt=class extends tn{constructor(j,he,Te,Ke,Ye){if(super(he,Te,Ke,Ye),j===null)throw(0,t.illegalArgument)("location");this.location=j}};qt=qe([F],qt),e.SourceBreakpoint=qt;let Qt=class extends tn{constructor(j,he,Te,Ke,Ye){super(he,Te,Ke,Ye),this.functionName=j}};Qt=qe([F],Qt),e.FunctionBreakpoint=Qt;let un=class extends tn{constructor(j,he,Te,Ke,Ye,ct,dt){if(super(Ke,Ye,ct,dt),!he)throw(0,t.illegalArgument)("dataId");this.label=j,this.dataId=he,this.canPersist=Te}};un=qe([F],un),e.DataBreakpoint=un;let En=class{constructor(j,he,Te){this.command=j,this.args=he||[],this.options=Te}};En=qe([F],En),e.DebugAdapterExecutable=En;let dn=class{constructor(j,he){this.port=j,this.host=he}};dn=qe([F],dn),e.DebugAdapterServer=dn;let Sn=class{constructor(j){this.path=j}};Sn=qe([F],Sn),e.DebugAdapterNamedPipeServer=Sn;let hn=class{constructor(j){this.implementation=j}};hn=qe([F],hn),e.DebugAdapterInlineImplementation=hn;let nn=class{constructor(j,he){this.range=j,this.expression=he}};nn=qe([F],nn),e.EvaluatableExpression=nn;var Un;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Un=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let rn=class{constructor(j,he){this.range=j,this.text=he}};rn=qe([F],rn),e.InlineValueText=rn;let sn=class{constructor(j,he,Te=!0){this.range=j,this.variableName=he,this.caseSensitiveLookup=Te}};sn=qe([F],sn),e.InlineValueVariableLookup=sn;let yn=class{constructor(j,he){this.range=j,this.expression=he}};yn=qe([F],yn),e.InlineValueEvaluatableExpression=yn;let Cn=class{constructor(j,he){this.frameId=j,this.stoppedLocation=he}};Cn=qe([F],Cn),e.InlineValueContext=Cn;var on;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(on=e.FileChangeType||(e.FileChangeType={}));let Dn=q=class extends Error{static FileExists(j){return new q(j,P.FileSystemProviderErrorCode.FileExists,q.FileExists)}static FileNotFound(j){return new q(j,P.FileSystemProviderErrorCode.FileNotFound,q.FileNotFound)}static FileNotADirectory(j){return new q(j,P.FileSystemProviderErrorCode.FileNotADirectory,q.FileNotADirectory)}static FileIsADirectory(j){return new q(j,P.FileSystemProviderErrorCode.FileIsADirectory,q.FileIsADirectory)}static NoPermissions(j){return new q(j,P.FileSystemProviderErrorCode.NoPermissions,q.NoPermissions)}static Unavailable(j){return new q(j,P.FileSystemProviderErrorCode.Unavailable,q.Unavailable)}constructor(j,he=P.FileSystemProviderErrorCode.Unknown,Te){super(y.URI.isUri(j)?j.toString(!0):j),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,he),Object.setPrototypeOf(this,q.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Dn=q=qe([F],Dn),e.FileSystemError=Dn;let In=class{constructor(j,he,Te){this.start=j,this.end=he,this.kind=Te}};In=qe([F],In),e.FoldingRange=In;var Bn;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Bn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var zn;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(zn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var $n;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})($n=e.CommentMode||(e.CommentMode={}));var kn;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(kn=e.CommentThreadState||(e.CommentThreadState={}));class Rn{constructor(j,he=[]){this.tokenTypes=j,this.tokenModifiers=he}}e.SemanticTokensLegend=Rn;function Ln(G){return typeof G>"u"||(0,S.isStringArray)(G)}class We{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,j){this.l=!0;for(let he=0,Te=j.tokenTypes.length;he<Te;he++)this.j.set(j.tokenTypes[he],he);for(let he=0,Te=j.tokenModifiers.length;he<Te;he++)this.k.set(j.tokenModifiers[he],he)}}push(j,he,Te,Ke,Ye){if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(j,he,Te,Ke,Ye);if(V.isRange(j)&&typeof he=="string"&&Ln(Te))return this.m(j,he,Te);throw(0,t.illegalArgument)()}m(j,he,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(he))throw new Error("`tokenType` is not in the provided legend");const Ke=j.start.line,Ye=j.start.character,ct=j.end.character-j.start.character,dt=this.j.get(he);let Ot=0;if(Te)for(const Ht of Te){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const Kt=this.k.get(Ht);Ot|=1<<Kt>>>0}this.n(Ke,Ye,ct,dt,Ot)}n(j,he,Te,Ke,Ye){if(this.f&&(j<this.c||j===this.c&&he<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Ht=0,Kt=0;for(let Xt=0;Xt<Ot;Xt++){let Yt=this.g[5*Xt],Pn=this.g[5*Xt+1];Yt===0?(Yt=Ht,Pn+=Kt):Yt+=Ht,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Pn,Ht=Yt,Kt=Pn}}let ct=j,dt=he;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=j,this.e=he}static o(j){const he=[],Te=j.length/5|0;for(let dt=0;dt<Te;dt++)he[dt]=dt;he.sort((dt,Ot)=>{const Ht=j[5*dt],Kt=j[5*Ot];if(Ht===Kt){const Xt=j[5*dt+1],Yt=j[5*Ot+1];return Xt-Yt}return Ht-Kt});const Ke=new Uint32Array(j.length);let Ye=0,ct=0;for(let dt=0;dt<Te;dt++){const Ot=5*he[dt],Ht=j[Ot+0],Kt=j[Ot+1],Xt=j[Ot+2],Yt=j[Ot+3],Pn=j[Ot+4],ni=Ht-Ye,Ti=ni===0?Kt-ct:Kt,An=5*dt;Ke[An+0]=ni,Ke[An+1]=Ti,Ke[An+2]=Xt,Ke[An+3]=Yt,Ke[An+4]=Pn,Ye=Ht,ct=Kt}return Ke}build(j){return this.f?new Wt(new Uint32Array(this.g),j):new Wt(We.o(this.g),j)}}e.SemanticTokensBuilder=We;class Wt{constructor(j,he){this.resultId=he,this.data=j}}e.SemanticTokens=Wt;class On{constructor(j,he,Te){this.start=j,this.deleteCount=he,this.data=Te}}e.SemanticTokensEdit=On;class wt{constructor(j,he){this.resultId=he,this.edits=j}}e.SemanticTokensEdits=wt;var Wn;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Wn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let fn=class{constructor(){}};fn.Back={iconPath:new Vt("arrow-left")},fn=qe([F],fn),e.QuickInputButtons=fn;var Nn;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Nn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Hn;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Hn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var mn;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(mn=e.ExtensionKind||(e.ExtensionKind={}));class jn{static validate(j){if(typeof j.badge=="string"){let he=(0,T.nextCharLength)(j.badge,0);if(he<j.badge.length&&(he+=(0,T.nextCharLength)(j.badge,he)),j.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!Vt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,he,Te){this.badge=j,this.tooltip=he,this.color=Te}}e.FileDecoration=jn;let Tn=class{constructor(j){this.kind=j}};Tn=qe([F],Tn),e.ColorTheme=Tn;var Vn;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Vn=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{static isNotebookRange(j){return j instanceof Gt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,he){if(j<0)throw(0,t.illegalArgument)("start must be positive");if(he<0)throw(0,t.illegalArgument)("end must be positive");j<=he?(this.c=j,this.e=he):(this.c=he,this.e=j)}with(j){let he=this.c,Te=this.e;return j.start!==void 0&&(he=j.start),j.end!==void 0&&(Te=j.end),he===this.c&&Te===this.e?this:new Gt(he,Te)}}e.NotebookRange=Gt;class gn{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(he=>gn.isNotebookCellData(he))}static isNotebookCellData(j){return!0}constructor(j,he,Te,Ke,Ye,ct,dt){this.kind=j,this.value=he,this.languageId=Te,this.mime=Ke,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=dt,gn.validate(this)}}e.NotebookCellData=gn;class qn{constructor(j){this.cells=j}}e.NotebookData=qn;class $t{static isNotebookCellOutputItem(j){return j instanceof $t?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const he={name:j.name,message:j.message,stack:j.stack};return $t.json(he,"application/vnd.code.notebook.error")}static stdout(j){return $t.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return $t.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,he="application/octet-stream"){return new $t(j,he)}static text(j,he=C.Mimes.text){const Te=Ue($t,b,"f",p).encode(String(j));return new $t(Te,he)}static json(j,he="text/x-json"){const Te=JSON.stringify(j,void 0,"	");return $t.text(Te,he)}constructor(j,he){this.data=j,this.mime=he;const Te=(0,C.normalizeMimeType)(he,!0);if(!Te)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=$t,b=$t,p={value:new TextEncoder};class pn{static isNotebookCellOutput(j){return j instanceof pn?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,he=!1){const Te=new Set,Ke=new Set;for(let Ye=0;Ye<j.length;Ye++){const ct=j[Ye],dt=(0,C.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,D.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Ye),he&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?j:j.filter((Ye,ct)=>!Ke.has(ct))}constructor(j,he,Te){this.items=pn.ensureUniqueMimeTypes(j,!0),typeof he=="string"?(this.id=he,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=he??Te)}}e.NotebookCellOutput=pn;var Gn;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Gn=e.NotebookCellKind||(e.NotebookCellKind={}));var Kn;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(Kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var me;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(me=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var we;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(we=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ze{constructor(j,he){this.text=j,this.alignment=he}}e.NotebookCellStatusBarItem=ze;var at;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(at=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Ct;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(Ct=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Rt{constructor(j,he=[]){this.uri=j,this.provides=(0,c.asArray)(he)}}e.NotebookRendererScript=Rt;class oi{constructor(j){this.label=j}}e.NotebookKernelSourceAction=oi;let xn=class{constructor(j,he){this.label=j,this.timestamp=he}};xn=qe([F],xn),e.TimelineItem=xn;var ai;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(ai=e.ExtensionMode||(e.ExtensionMode={}));var ci;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ci=e.ExtensionRuntime||(e.ExtensionRuntime={}));var li;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(li=e.StandardTokenType||(e.StandardTokenType={}));class ui{constructor(j,he){this.ranges=j,this.wordPattern=he}}e.LinkedEditingRanges=ui;class di{constructor(j,he){this.c=j,this.e=he}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=di;var hi;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(hi=e.TestResultState||(e.TestResultState={}));var fi;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(fi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Xn=class{constructor(j=void 0,he=void 0,Te=void 0){this.include=j,this.exclude=he,this.profile=Te}};Xn=qe([F],Xn),e.TestRunRequest=Xn;let _n=N=class{static diff(j,he,Te){const Ke=new N(j);return Ke.expectedOutput=he,Ke.actualOutput=Te,Ke}constructor(j){this.message=j}};_n=N=qe([F],_n),e.TestMessage=_n;let Qn=class{constructor(j){this.id=j}};Qn=qe([F],Qn),e.TestTag=Qn;let bn=class{constructor(j,he){this.covered=j,this.total=he}};bn=qe([F],bn),e.CoveredCount=bn;let Yn=M=class{static fromDetails(j,he){const Te=new bn(0,0),Ke=new bn(0,0),Ye=new bn(0,0);for(const dt of he)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Ot of dt.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ct=new M(j,Te,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=he,ct}constructor(j,he,Te,Ke){this.uri=j,this.statementCoverage=he,this.branchCoverage=Te,this.functionCoverage=Ke}};Yn=M=qe([F],Yn),e.FileCoverage=Yn;let Jn=class{constructor(j,he,Te=[]){this.executionCount=j,this.location=he,this.branches=Te}};Jn=qe([F],Jn),e.StatementCoverage=Jn;let Zn=class{constructor(j,he){this.executionCount=j,this.location=he}};Zn=qe([F],Zn),e.BranchCoverage=Zn;let ei=class{constructor(j,he){this.executionCount=j,this.location=he}};ei=qe([F],ei),e.FunctionCoverage=ei;var mi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(mi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var gi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var pi;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(pi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class bi{constructor(j,he,Te,Ke,Ye,ct){this.kind=j,this.name=he,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=bi;class wi{constructor(j){this.uri=j}}e.TextTabInput=wi;class vi{constructor(j,he){this.original=j,this.modified=he}}e.TextDiffTabInput=vi;class Ei{constructor(j,he,Te,Ke){this.base=j,this.input1=he,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=Ei;class Si{constructor(j,he){this.uri=j,this.viewType=he}}e.CustomEditorTabInput=Si;class yi{constructor(j){this.viewType=j}}e.WebviewEditorTabInput=yi;class Ci{constructor(j,he){this.uri=j,this.notebookType=he}}e.NotebookEditorTabInput=Ci;class Di{constructor(j,he,Te){this.original=j,this.modified=he,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Di;class Ii{constructor(){}}e.TerminalEditorTabInput=Ii;class ki{constructor(j,he){this.uri=j,this.inputBoxUri=he}}e.InteractiveWindowInput=ki}),define(ye[135],Ce([1,0,49,15,8,162,105,7,17]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const y=new Map;function L(E,d){d?y.set(E,d):y.delete(E)}e.setWordDefinitionFor=L;function P(E){return y.get(E)}class v extends A.MirrorTextModel{constructor(d,m,h,b,p,g,w,i){super(m,h,b,p),this.m=d,this.p=g,this.q=w,this.notebook=i,this.b=!1}dispose(){(0,c.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,S.equals)(this.d,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.c},get fileName(){return d.c.fsPath},get isUntitled(){return d.c.scheme===t.Schemas.untitled},get languageId(){return d.p},get version(){return d.g},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(m){return m?d.s(m):d.getText()},get eol(){return d.f===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return d.d.length},lineAt(m){return d.t(m)},offsetAt(m){return d.u(m)},positionAt(m){return d.v(m)},validateRange(m){return d.w(m)},validatePosition(m){return d.x(m)},getWordRangeAtPosition(m,h){return d.y(m,h)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,c.ok)(!this.b),this.p=d}_acceptIsDirty(d){(0,c.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(d){const m=this.w(d);if(m.isEmpty)return"";if(m.isSingleLine)return this.d[m.start.line].substring(m.start.character,m.end.character);const h=this.f,b=m.start.line,p=m.end.line,g=[];g.push(this.d[b].substring(m.start.character));for(let w=b+1;w<p;w++)g.push(this.d[w]);return g.push(this.d[p].substring(0,m.end.character)),g.join(h)}t(d){let m;if(d instanceof T.Position?m=d.line:typeof d=="number"&&(m=d),typeof m!="number"||m<0||m>=this.d.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new D(m,this.d[m],m===this.d.length-1)}u(d){return d=this.x(d),this.k(),this.h.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.k();const m=this.h.getIndexOf(d),h=this.d[m.index].length;return new T.Position(m.index,Math.min(m.remainder,h))}w(d){if(!(d instanceof T.Range))throw new Error("Invalid argument");const m=this.x(d.start),h=this.x(d.end);return m===d.start&&h===d.end?d:new T.Range(m.line,m.character,h.line,h.character)}x(d){if(!(d instanceof T.Position))throw new Error("Invalid argument");if(this.d.length===0)return d.with(0,0);let{line:m,character:h}=d,b=!1;if(m<0)m=0,h=0,b=!0;else if(m>=this.d.length)m=this.d.length-1,h=this.d[m].length,b=!0;else{const p=this.d[m].length;h<0?(h=0,b=!0):h>p&&(h=p,b=!0)}return b?new T.Position(m,h):d}y(d,m){const h=this.x(d);if(!m)m=P(this.p);else if((0,k.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const b=(0,C.getWordAtText)(h.character+1,(0,C.ensureValidWordDefinition)(m),this.d[h.line],0);if(b)return new T.Range(h.line,b.startColumn-1,h.line,b.endColumn-1)}}e.ExtHostDocumentData=v;class D{constructor(d,m,h){this.a=d,this.b=m,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=D}),define(ye[231],Ce([1,0,7,16,4]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(T){this.a=new c.ColorTheme(c.ColorThemeKind.Dark),this.b=new k.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(T){let S;switch(T){case"light":S=c.ColorThemeKind.Light;break;case"hcDark":S=c.ColorThemeKind.HighContrast;break;case"hcLight":S=c.ColorThemeKind.HighContrastLight;break;default:S=c.ColorThemeKind.Dark}this.a=new c.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};A=qe([He(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ye[14],Ce([1,0,17,22,148,61,111,28,147,86,84,23,11,2,35,66,123,132,130,91,56,70,226,7]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p,g,w,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Re){function Oe(re){const{selectionStartLineNumber:Ne,selectionStartColumn:$e,positionLineNumber:Qe,positionColumn:Ve}=re,tt=new o.Position(Ne-1,$e-1),St=new o.Position(Qe-1,Ve-1);return new o.Selection(tt,St)}Re.to=Oe;function Se(re){const{anchor:Ne,active:$e}=re;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Re.from=Se})(u=e.Selection||(e.Selection={}));var l;(function(Re){function Oe(re){if(!re)return;const{start:Ne,end:$e}=re;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Re.from=Oe;function Se(re){if(!re)return;const{startLineNumber:Ne,startColumn:$e,endLineNumber:Qe,endColumn:Ve}=re;return new o.Range(Ne-1,$e-1,Qe-1,Ve-1)}Re.to=Se})(l=e.Range||(e.Range={}));var s;(function(Re){function Oe(Se){switch(Se){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Re.to=Oe})(s=e.TokenType||(e.TokenType={}));var a;(function(Re){function Oe(re){return new o.Position(re.lineNumber-1,re.column-1)}Re.to=Oe;function Se(re){return{lineNumber:re.line+1,column:re.character+1}}Re.from=Se})(a=e.Position||(e.Position={}));var n;(function(Re){function Oe(Ne,$e){return(0,c.coalesce)((0,c.asArray)(Ne).map(Qe=>Se(Qe,$e)))}Re.from=Oe;function Se(Ne,$e){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:re(Ne.scheme,$e),pattern:$.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function re(Ne,$e){return $e&&typeof Ne=="string"?$e.transformOutgoingScheme(Ne):Ne}})(n=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(Re){function Oe(re){switch(re){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Re.from=Oe;function Se(re){switch(re){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(Re){function Oe(re){let Ne;return re.code&&((0,v.isString)(re.code)||(0,v.isNumber)(re.code)?Ne=String(re.code):Ne={value:String(re.code.value),target:re.code.target}),{...l.from(re.range),message:re.message,source:re.source,code:Ne,severity:R.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(I.from),tags:Array.isArray(re.tags)?(0,c.coalesce)(re.tags.map(r.from)):void 0}}Re.from=Oe;function Se(re){const Ne=new o.Diagnostic(l.to(re),re.message,R.to(re.severity));return Ne.source=re.source,Ne.code=(0,v.isString)(re.code)?re.code:re.code?.value,Ne.relatedInformation=re.relatedInformation&&re.relatedInformation.map(I.to),Ne.tags=re.tags&&(0,c.coalesce)(re.tags.map(r.to)),Ne}Re.to=Se})(f=e.Diagnostic||(e.Diagnostic={}));var I;(function(Re){function Oe(re){return{...l.from(re.location.range),message:re.message,resource:re.location.uri}}Re.from=Oe;function Se(re){return new o.DiagnosticRelatedInformation(new o.Location(re.resource,l.to(re)),re.message)}Re.to=Se})(I=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var R;(function(Re){function Oe(re){switch(re){case o.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}Re.from=Oe;function Se(re){switch(re){case m.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Re.to=Se})(R=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var B;(function(Re){function Oe(re){return typeof re=="number"&&re>=o.ViewColumn.One?re-1:re===o.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Re.from=Oe;function Se(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(B=e.ViewColumn||(e.ViewColumn={}));function X(Re){return typeof Re.range<"u"}function q(Re){return Re.length===0?!0:!!X(Re[0])}e.isDecorationOptionsArr=q;var N;(function(Re){function Oe(Ve){return Ve.map(Re.from)}Re.fromMany=Oe;function Se(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function re(Ve){let tt;if(Se(Ve)){const{language:vt,value:It}=Ve;tt={value:"```"+vt+`
`+It+"\n```\n"}}else o.MarkdownString.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const St=Object.create(null);tt.uris=St;const Et=vt=>{try{let It=D.URI.parse(vt,!0);It=It.with({query:Ne(It.query,St)}),St[vt]=It}catch{}return""},Lt=new S.marked.Renderer;return Lt.link=Et,Lt.image=vt=>typeof vt=="string"?Et(C.parseHrefAndDimensions(vt).href):"",(0,S.marked)(tt.value,{renderer:Lt}),tt}Re.from=re;function Ne(Ve,tt){if(!Ve)return Ve;let St;try{St=(0,y.parse)(Ve)}catch{}if(!St)return Ve;let Et=!1;return St=(0,P.cloneAndChange)(St,Lt=>{if(D.URI.isUri(Lt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[vt]=Lt,Et=!0,vt}else return}),Et?JSON.stringify(St):Ve}function $e(Ve){const tt=new o.MarkdownString(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?D.URI.from(Ve.baseUri):void 0,tt}Re.to=$e;function Qe(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Re.from(Ve)}Re.fromStrict=Qe})(N=e.MarkdownString||(e.MarkdownString={}));function M(Re){return q(Re)?Re.map(Oe=>({range:l.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?N.fromMany(Oe.hoverMessage):Oe.hoverMessage?N.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Re.map(Oe=>({range:l.from(Oe)}))}e.fromRangeOrRangeWithMessage=M;function F(Re){return typeof Re>"u"?Re:typeof Re=="string"?D.URI.file(Re):Re}e.pathOrURIToURI=F;var z;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?F(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Oe})(z=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?F(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?z.from(Se.before):void 0,after:Se.after?z.from(Se.after):void 0}}Re.from=Oe})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var H;(function(Re){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Oe})(H=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(Re){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?H.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?U.from(Se.light):void 0,dark:Se.dark?U.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?F(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?z.from(Se.before):void 0,after:Se.after?z.from(Se.after):void 0}}Re.from=Oe})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Re){function Oe(re){return{text:re.newText,eol:re.newEol&&st.from(re.newEol),range:l.from(re.range)}}Re.from=Oe;function Se(re){const Ne=new o.TextEdit(l.to(re.range),re.text);return Ne.newEol=typeof re.eol>"u"?void 0:st.to(re.eol),Ne}Re.to=Se})(V=e.TextEdit||(e.TextEdit={}));var _;(function(Re){function Oe(re,Ne){const $e={edits:[]};if(re instanceof o.WorkspaceEdit){const Qe=new T.ResourceSet;for(const Ve of re._allEntries())Ve._type===1&&D.URI.isUri(Ve.to)&&Ve.from===void 0&&Qe.add(Ve.to);for(const Ve of re._allEntries())Ve._type===1?$e.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?$e.edits.push({resource:Ve.uri,textEdit:V.from(Ve.edit),versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?$e.edits.push({resource:Ve.uri,textEdit:{range:l.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(gt.from)}})}return $e}Re.from=Oe;function Se(re){const Ne=new o.WorkspaceEdit;for(const $e of re.edits)$e.textEdit?Ne.replace(D.URI.revive($e.resource),l.to($e.textEdit.range),$e.textEdit.text):Ne.renameFile(D.URI.revive($e.oldResource),D.URI.revive($e.newResource),$e.options);return Ne}Re.to=Se})(_=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(Re){const Oe=Object.create(null);Oe[o.SymbolKind.File]=0,Oe[o.SymbolKind.Module]=1,Oe[o.SymbolKind.Namespace]=2,Oe[o.SymbolKind.Package]=3,Oe[o.SymbolKind.Class]=4,Oe[o.SymbolKind.Method]=5,Oe[o.SymbolKind.Property]=6,Oe[o.SymbolKind.Field]=7,Oe[o.SymbolKind.Constructor]=8,Oe[o.SymbolKind.Enum]=9,Oe[o.SymbolKind.Interface]=10,Oe[o.SymbolKind.Function]=11,Oe[o.SymbolKind.Variable]=12,Oe[o.SymbolKind.Constant]=13,Oe[o.SymbolKind.String]=14,Oe[o.SymbolKind.Number]=15,Oe[o.SymbolKind.Boolean]=16,Oe[o.SymbolKind.Array]=17,Oe[o.SymbolKind.Object]=18,Oe[o.SymbolKind.Key]=19,Oe[o.SymbolKind.Null]=20,Oe[o.SymbolKind.EnumMember]=21,Oe[o.SymbolKind.Struct]=22,Oe[o.SymbolKind.Event]=23,Oe[o.SymbolKind.Operator]=24,Oe[o.SymbolKind.TypeParameter]=25;function Se(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Re.from=Se;function re(Ne){for(const $e in Oe)if(Oe[$e]===Ne)return Number($e);return o.SymbolKind.Property}Re.to=re})(Q=e.SymbolKind||(e.SymbolKind={}));var Z;(function(Re){function Oe(re){switch(re){case o.SymbolTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return o.SymbolTag.Deprecated}}Re.to=Se})(Z=e.SymbolTag||(e.SymbolTag={}));var ge;(function(Re){function Oe(re){return{name:re.name,kind:Q.from(re.kind),tags:re.tags&&re.tags.map(Z.from),containerName:re.containerName,location:Ee.from(re.location)}}Re.from=Oe;function Se(re){const Ne=new o.SymbolInformation(re.name,Q.to(re.kind),re.containerName,Ee.to(re.location));return Ne.tags=re.tags&&re.tags.map(Z.to),Ne}Re.to=Se})(ge=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var te;(function(Re){function Oe(re){const Ne={name:re.name||"!!MISSING: name!!",detail:re.detail,range:l.from(re.range),selectionRange:l.from(re.selectionRange),kind:Q.from(re.kind),tags:re.tags?.map(Z.from)??[]};return re.children&&(Ne.children=re.children.map(Oe)),Ne}Re.from=Oe;function Se(re){const Ne=new o.DocumentSymbol(re.name,re.detail,Q.to(re.kind),l.to(re.range),l.to(re.selectionRange));return(0,c.isNonEmptyArray)(re.tags)&&(Ne.tags=re.tags.map(Z.to)),re.children&&(Ne.children=re.children.map(Se)),Ne}Re.to=Se})(te=e.DocumentSymbol||(e.DocumentSymbol={}));var J;(function(Re){function Oe(re){const Ne=new o.CallHierarchyItem(Q.to(re.kind),re.name,re.detail||"",D.URI.revive(re.uri),l.to(re.range),l.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,$e){if(Ne=Ne??re._sessionId,$e=$e??re._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,name:re.name,detail:re.detail,kind:Q.from(re.kind),uri:re.uri,range:l.from(re.range),selectionRange:l.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Re.from=Se})(J=e.CallHierarchyItem||(e.CallHierarchyItem={}));var fe;(function(Re){function Oe(Se){return new o.CallHierarchyIncomingCall(J.to(Se.from),Se.fromRanges.map(re=>l.to(re)))}Re.to=Oe})(fe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(Re){function Oe(Se){return new o.CallHierarchyOutgoingCall(J.to(Se.to),Se.fromRanges.map(re=>l.to(re)))}Re.to=Oe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ee;(function(Re){function Oe(re){return{range:re.range&&l.from(re.range),uri:re.uri}}Re.from=Oe;function Se(re){return new o.Location(D.URI.revive(re.uri),l.to(re.range))}Re.to=Se})(Ee=e.location||(e.location={}));var Ae;(function(Re){function Oe(re){const Ne=re,$e=re;return{originSelectionRange:Ne.originSelectionRange?l.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:$e.uri,range:l.from(Ne.targetRange?Ne.targetRange:$e.range),targetSelectionRange:Ne.targetSelectionRange?l.from(Ne.targetSelectionRange):void 0}}Re.from=Oe;function Se(re){return{targetUri:D.URI.revive(re.uri),targetRange:l.to(re.range),targetSelectionRange:re.targetSelectionRange?l.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?l.to(re.originSelectionRange):void 0}}Re.to=Se})(Ae=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Re){function Oe(re){return{range:l.from(re.range),contents:N.fromMany(re.contents)}}Re.from=Oe;function Se(re){return new o.Hover(re.contents.map(N.to),l.to(re.range))}Re.to=Se})(Fe=e.Hover||(e.Hover={}));var se;(function(Re){function Oe(re){return{range:l.from(re.range),expression:re.expression}}Re.from=Oe;function Se(re){return new o.EvaluatableExpression(l.to(re.range),re.expression)}Re.to=Se})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(Re){function Oe(re){if(re instanceof o.InlineValueText)return{type:"text",range:l.from(re.range),text:re.text};if(re instanceof o.InlineValueVariableLookup)return{type:"variable",range:l.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Oe;function Se(re){switch(re.type){case"text":return{range:l.to(re.range),text:re.text};case"variable":return{range:l.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:l.to(re.range),expression:re.expression}}}Re.to=Se})(le=e.InlineValue||(e.InlineValue={}));var ue;(function(Re){function Oe(re){return{frameId:re.frameId,stoppedLocation:l.from(re.stoppedLocation)}}Re.from=Oe;function Se(re){return new o.InlineValueContext(re.frameId,l.to(re.stoppedLocation))}Re.to=Se})(ue=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Re){function Oe(re){return{range:l.from(re.range),kind:re.kind}}Re.from=Oe;function Se(re){return new o.DocumentHighlight(l.to(re.range),re.kind)}Re.to=Se})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(Re){function Oe(Se){switch(Se){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Re.to=Oe})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ie;(function(Re){function Oe(Se){return{triggerKind:ae.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Oe})(ie=e.CompletionContext||(e.CompletionContext={}));var O;(function(Re){function Oe(re){switch(re){case o.CompletionItemTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return o.CompletionItemTag.Deprecated}}Re.to=Se})(O=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(Re){const Oe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Se($e){return Oe.get($e)??9}Re.from=Se;const re=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Ne($e){return re.get($e)??o.CompletionItemKind.Property}Re.to=Ne})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(Re){function Oe(Se,re){const Ne=new o.CompletionItem(Se.label);return Ne.insertText=Se.insertText,Ne.kind=W.to(Se.kind),Ne.tags=Se.tags?.map(O.to),Ne.detail=Se.detail,Ne.documentation=C.isMarkdownString(Se.documentation)?N.to(Se.documentation):Se.documentation,Ne.sortText=Se.sortText,Ne.filterText=Se.filterText,Ne.preselect=Se.preselect,Ne.commitCharacters=Se.commitCharacters,E.Range.isIRange(Se.range)?Ne.range=l.to(Se.range):typeof Se.range=="object"&&(Ne.range={inserting:l.to(Se.range.insert),replacing:l.to(Se.range.replace)}),Ne.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Ne.insertText=new o.SnippetString(Se.insertText):(Ne.insertText=Se.insertText,Ne.textEdit=Ne.range instanceof o.Range?new o.TextEdit(Ne.range,Ne.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Se.additionalTextEdits.map($e=>V.to($e))),Ne.command=re&&Se.command?re.fromInternal(Se.command):void 0,Ne}Re.to=Oe})(K=e.CompletionItem||(e.CompletionItem={}));var Y;(function(Re){function Oe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:N.fromStrict(re.documentation)}}Re.from=Oe;function Se(re){return{label:re.label,documentation:C.isMarkdownString(re.documentation)?N.to(re.documentation):re.documentation}}Re.to=Se})(Y=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(Re){function Oe(re){return{label:re.label,documentation:N.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Y.from):[],activeParameter:re.activeParameter}}Re.from=Oe;function Se(re){return{label:re.label,documentation:C.isMarkdownString(re.documentation)?N.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Y.to):[],activeParameter:re.activeParameter}}Re.to=Se})(de=e.SignatureInformation||(e.SignatureInformation={}));var be;(function(Re){function Oe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.from):[]}}Re.from=Oe;function Se(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.to):[]}}Re.to=Se})(be=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(Re){function Oe(Se,re){const Ne=new o.InlayHint(a.to(re.position),typeof re.label=="string"?re.label:re.label.map(pe.to.bind(void 0,Se)),re.kind&&De.to(re.kind));return Ne.textEdits=re.textEdits&&re.textEdits.map(V.to),Ne.tooltip=C.isMarkdownString(re.tooltip)?N.to(re.tooltip):re.tooltip,Ne.paddingLeft=re.paddingLeft,Ne.paddingRight=re.paddingRight,Ne}Re.to=Oe})(Pe=e.InlayHint||(e.InlayHint={}));var pe;(function(Re){function Oe(Se,re){const Ne=new o.InlayHintLabelPart(re.label);return Ne.tooltip=C.isMarkdownString(re.tooltip)?N.to(re.tooltip):re.tooltip,d.Command.is(re.command)&&(Ne.command=Se.fromInternal(re.command)),re.location&&(Ne.location=Ee.to(re.location)),Ne}Re.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var De;(function(Re){function Oe(re){return re}Re.from=Oe;function Se(re){return re}Re.to=Se})(De=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Re){function Oe(re){return{range:l.from(re.range),url:re.target,tooltip:re.tooltip}}Re.from=Oe;function Se(re){let Ne;if(re.url)try{Ne=typeof re.url=="string"?D.URI.parse(re.url,!0):D.URI.revive(re.url)}catch{}return new o.DocumentLink(l.to(re.range),Ne)}Re.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var je;(function(Re){function Oe(re){const Ne=new o.ColorPresentation(re.label);return re.textEdit&&(Ne.textEdit=V.to(re.textEdit)),re.additionalTextEdits&&(Ne.additionalTextEdits=re.additionalTextEdits.map($e=>V.to($e))),Ne}Re.to=Oe;function Se(re){return{label:re.label,textEdit:re.textEdit?V.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Ne=>V.from(Ne)):void 0}}Re.from=Se})(je=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Re){function Oe(re){return new o.Color(re[0],re[1],re[2],re[3])}Re.to=Oe;function Se(re){return[re.red,re.green,re.blue,re.alpha]}Re.from=Se})(Ge=e.Color||(e.Color={}));var et;(function(Re){function Oe(re){return{range:l.from(re.range)}}Re.from=Oe;function Se(re){return new o.SelectionRange(l.to(re.range))}Re.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var _e;(function(Re){function Oe(Se){switch(Se){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Re.to=Oe})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Re){function Oe(re){switch(re){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Oe;function Se(re){switch(re){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Re.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Re){function Oe(re){if(re===o.EndOfLine.CRLF)return 1;if(re===o.EndOfLine.LF)return 0}Re.from=Oe;function Se(re){if(re===1)return o.EndOfLine.CRLF;if(re===0)return o.EndOfLine.LF}Re.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Re){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(Re){function Oe(Se){const re={start:Se.start+1,end:Se.end+1};return Se.kind&&(re.kind=it.from(Se.kind)),re}Re.from=Oe})(Me=e.FoldingRange||(e.FoldingRange={}));var it;(function(Re){function Oe(Se){if(Se)switch(Se){case o.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Re.from=Oe})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var oe;(function(Re){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?l.from(Se.selection):void 0,override:typeof Se.override=="boolean"?b.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Oe})(oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $;(function(Re){function Oe($e){return $e instanceof o.RelativePattern?$e.toJSON():typeof $e=="string"?$e:Se($e)||re($e)?new o.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Re.from=Oe;function Se($e){const Qe=$e;return Qe?D.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function re($e){const Qe=$e;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ne($e){return typeof $e=="string"?$e:new o.RelativePattern(D.URI.revive($e.baseUri),$e.pattern)}Re.to=Ne})($=e.GlobPattern||(e.GlobPattern={}));var ce;(function(Re){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const re=Se;return{language:re.language,scheme:re.scheme,pattern:$.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Re.from=Oe})(ce=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Re){function Oe(re){return{start:re.start,end:re.end}}Re.from=Oe;function Se(re){return new o.NotebookRange(re.start,re.end)}Re.to=Se})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Re){function Oe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Re.to=Oe;function Se(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Re.from=Se})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Re){function Oe(Se){if(Se===p.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Se===p.NotebookCellExecutionState.Pending)return;if(Se===p.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xe;(function(Re){function Oe(re){switch(re){case o.NotebookCellKind.Markup:return p.CellKind.Markup;case o.NotebookCellKind.Code:default:return p.CellKind.Code}}Re.from=Oe;function Se(re){switch(re){case p.CellKind.Markup:return o.NotebookCellKind.Markup;case p.CellKind.Code:default:return o.NotebookCellKind.Code}}Re.to=Se})(xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Re){function Oe(re){const Ne={metadata:re.metadata??Object.create(null),cells:[]};for(const $e of re.cells)o.NotebookCellData.validate($e),Ne.cells.push(gt.from($e));return Ne}Re.from=Oe;function Se(re){const Ne=new o.NotebookData(re.cells.map(gt.to));return(0,v.isEmptyObject)(re.metadata)||(Ne.metadata=re.metadata),Ne}Re.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var gt;(function(Re){function Oe(re){return{cellKind:xe.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Le.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(lt.from):[]}}Re.from=Oe;function Se(re){return new o.NotebookCellData(xe.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(lt.to):void 0,re.metadata,re.internalMetadata?Le.to(re.internalMetadata):void 0)}Re.to=Se})(gt=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Re){function Oe(re){return{mime:re.mime,valueBytes:t.VSBuffer.wrap(re.data)}}Re.from=Oe;function Se(re){return new o.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Re.to=Se})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(Re){function Oe(re){return{outputId:re.id,items:re.items.map(mt.from),metadata:re.metadata}}Re.from=Oe;function Se(re){const Ne=re.items.map(mt.to);return new o.NotebookCellOutput(Ne,re.outputId,re.metadata)}Re.to=Se})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Re){function Oe(Ne){return re(Ne)?{include:(0,v.withNullAsUndefined)($.from(Ne.include)),exclude:(0,v.withNullAsUndefined)($.from(Ne.exclude))}:(0,v.withNullAsUndefined)($.from(Ne))}Re.from=Oe;function Se(Ne){return re(Ne)?{include:$.to(Ne.include),exclude:$.to(Ne.exclude)}:$.to(Ne)}Re.to=Se;function re(Ne){const $e=Ne;return $e?!(0,v.isUndefinedOrNull)($e.include)&&!(0,v.isUndefinedOrNull)($e.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Re){function Oe(Se,re,Ne){const $e=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal($e,Ne),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Oe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var kt;(function(Re){function Oe(Se,re,Ne){const $e=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:re.toInternal($e,Ne),label:Se.label,description:Se.description,detail:Se.detail}}Re.from=Oe})(kt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Tt;(function(Re){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Oe})(Tt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Nt;(function(Re){function Oe(re){return{uri:re.uri,provides:re.provides}}Re.from=Oe;function Se(re){return new o.NotebookRendererScript(D.URI.revive(re.uri),re.provides)}Re.to=Se})(Nt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var pt;(function(Re){function Oe(re){return{message:N.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:l.from(re.location.range),uri:re.location.uri}}}Re.from=Oe;function Se(re){const Ne=new o.TestMessage(typeof re.message=="string"?re.message:N.to(re.message));return Ne.actualOutput=re.actual,Ne.expectedOutput=re.expected,Ne.location=re.location?Ee.to(re.location):void 0,Ne}Re.to=Se})(pt=e.TestMessage||(e.TestMessage={}));var Dt;(function(Re){Re.namespace=w.namespaceTestTag,Re.denamespace=w.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var zt;(function(Re){function Oe(re){const Ne=(0,h.getPrivateApiFor)(re).controllerId;return{extId:g.TestId.fromExtHostTestItem(re,Ne).toString(),label:re.label,uri:D.URI.revive(re.uri),busy:re.busy,tags:re.tags.map($e=>Dt.namespace(Ne,$e.id)),range:E.Range.lift(l.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&N.fromStrict(re.error)||null}}Re.from=Oe;function Se(re){return{parent:void 0,error:void 0,id:g.TestId.fromString(re.extId).localId,label:re.label,uri:D.URI.revive(re.uri),tags:(re.tags||[]).map(Ne=>{const{tagId:$e}=Dt.denamespace(Ne);return new o.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Re.toPlain=Se})(zt=e.TestItem||(e.TestItem={})),function(Re){function Oe(re){return{id:re.id}}Re.from=Oe;function Se(re){return new o.TestTag(re.id)}Re.to=Se}(Dt=e.TestTag||(e.TestTag={}));var Ft;(function(Re){const Oe=(re,Ne)=>{const $e=[];for(const[Ve,tt]of Ne)g.TestId.compare(tt.item.extId,Ve)===2&&(Ne.delete(Ve),$e.push(tt));const Qe={...zt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(pt.to)})),children:$e.map(Ve=>Oe(Ve,Ne))};for(const Ve of Qe.children)Ve.parent=Qe;return Qe};function Se(re){const Ne=[],$e=new Map;for(const Qe of re.items){$e.set(Qe.item.extId,Qe);const Ve=g.TestId.root(Qe.item.extId);re.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(Qe.item.extId))&&Ne.push(Qe)}return{completedAt:re.completedAt,results:Ne.map(Qe=>Oe(Qe,$e))}}Re.to=Se})(Ft=e.TestResults||(e.TestResults={}));var Xe;(function(Re){function Oe($e){return{covered:$e.covered,total:$e.covered}}function Se($e){return"line"in $e?a.from($e):l.from($e)}function re($e){return"branches"in $e?{count:$e.executionCount,location:Se($e.location),type:1,branches:$e.branches.length?$e.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Se(Qe.location)})):void 0}:{type:0,count:$e.executionCount,location:Se($e.location)}}Re.fromDetailed=re;function Ne($e){return{uri:$e.uri,statement:Oe($e.statementCoverage),branch:$e.branchCoverage&&Oe($e.branchCoverage),function:$e.functionCoverage&&Oe($e.functionCoverage),details:$e.detailedCoverage?.map(re)}}Re.fromFile=Ne})(Xe=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(Re){function Oe(Se){switch(Se){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Re.to=Oe})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ut;(function(Re){function Oe(re){const Ne=new o.TypeHierarchyItem(Q.to(re.kind),re.name,re.detail||"",D.URI.revive(re.uri),l.to(re.range),l.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,$e){if(Ne=Ne??re._sessionId,$e=$e??re._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,kind:Q.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:l.from(re.range),selectionRange:l.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Re.from=Se})(Ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Bt;(function(Re){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Oe})(Bt=e.ViewBadge||(e.ViewBadge={}));var bt;(function(Re){function Oe($e,Qe,Ve){const tt=Qe.fileData;return tt?new class extends o.DataTransferItem{asFile(){return{name:tt.name,uri:D.URI.revive(tt.uri),data:(0,A.once)(()=>Ve())}}}("",Qe.id):$e===L.Mimes.uriList&&Qe.uriListData?new o.DataTransferItem(Ne(Qe.uriListData)):new o.DataTransferItem(Qe.asString)}Re.to=Oe;async function Se($e,Qe){const Ve=await Qe.asString();if($e===L.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:re(Ve)};const tt=Qe.asFile();return{id:Qe.id,asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Re.from=Se;function re($e){return k.UriList.split($e).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return D.URI.parse(Qe)}catch{}return Qe})}function Ne($e){return k.UriList.create($e.map(Qe=>typeof Qe=="string"?Qe:D.URI.revive(Qe)))}})(bt=e.DataTransferItem||(e.DataTransferItem={}));var Pt;(function(Re){function Oe(re,Ne){const $e=re.items.map(([Qe,Ve])=>[Qe,bt.to(Qe,Ve,()=>Ne(Ve.id))]);return new o.DataTransfer($e)}Re.toDataTransfer=Oe;async function Se(re){const Ne={items:[]},$e=[];return re.forEach((Qe,Ve)=>{$e.push((async()=>{Ne.items.push([Ve,await bt.from(Ve,Qe)])})())}),await Promise.all($e),Ne}Re.toDataTransferDTO=Se})(Pt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[232],Ce([1,0,2,10,7,14,63]),function(ne,e,c,t,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(y,L,P,v={timeout:1500,errors:3}){this.c=y,this.d=L,this.f=P,this.g=v,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(L,P,v)=>{const E={dispose:this.a.push([L,P,y])};return Array.isArray(v)&&v.push(E),E}}async $participateInSave(y,L){const P=c.URI.revive(y);let v=!1;const D=setTimeout(()=>v=!0,this.g.timeout),E=[];try{for(const d of[...this.a]){if(v)break;const m=this.d.getDocument(P),h=await this.h(d,{document:m,reason:A.TextDocumentSaveReason.to(L)});E.push(h)}}finally{clearTimeout(D)}return E}h([y,L,P],v){const D=this.b.get(y);return typeof D=="number"&&D>this.g.errors?Promise.resolve(!1):this.i(P,y,L,v).then(()=>!0,E=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const d=this.b.get(y);this.b.set(y,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,L,P,v){const D=[],E=Date.now(),{document:d,reason:m}=v,{version:h}=d,b=Object.freeze({document:d,reason:m,waitUntil(p){if(Object.isFrozen(D))throw(0,t.illegalState)("waitUntil can not be called async");D.push(Promise.resolve(p))}});try{L.apply(P,[b])}catch(p){return Promise.reject(p)}return Object.freeze(D),new Promise((p,g)=>{const w=setTimeout(()=>g(new Error("timeout")),this.g.timeout);return Promise.all(D).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(w),p(i)}).catch(i=>{clearTimeout(w),g(i)})}).then(p=>{const g={edits:[]};for(const w of p)if(Array.isArray(w)&&w.every(i=>i instanceof k.TextEdit))for(const{newText:i,newEol:o,range:u}of w)g.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:u&&A.Range.from(u),text:i,eol:o&&A.EndOfLine.from(o)}});if(g.edits.length!==0)return h===d.version?this.f.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(ye[233],Ce([1,0,15,2,14,7,91]),function(ne,e,c,t,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(P,v,D,E){this.start=P,this.deletedCount=v,this.deletedItems=D,this.items=E}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(P,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,v,D){this.notebook=P,this.h=v,this.j=D,this.handle=D.handle,this.uri=t.URI.revive(D.uri),this.cellKind=D.cellKind,this.a=D.outputs.map(k.NotebookCellOutput.to),this.e=D.internalMetadata??{},this.b=Object.freeze(D.metadata??{}),this.d=Object.freeze(k.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:k.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return P.g},set mime(E){P.g=E},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(D)}return this.f}setOutputs(P){this.a=P.map(k.NotebookCellOutput.to)}setOutputItems(P,v,D){const E=D.map(k.NotebookCellOutputItem.to),d=this.a.find(m=>m.id===P);if(d&&(v||(d.items.length=0),d.items.push(...E),d.items.length>1&&d.items.every(m=>C.isTextStreamMime(m.mime)))){const m=new Map,h=[];d.items.forEach(b=>{let p;m.has(b.mime)?p=m.get(b.mime):(p=[],m.set(b.mime,p),h.push(b.mime)),p.push(b.data)}),d.items.length=0,h.forEach(b=>{const p=C.compressOutputItemStreams(m.get(b));d.items.push({mime:b,data:p.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(k.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=S;class y{constructor(P,v,D,E,d){this.k=P,this.l=v,this.m=D,this.uri=E,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,v={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===c.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(D){return D=P.n(D),P.b[D].apiCell},getCells(D){return(D?P.p(D):P.b).map(d=>d.apiCell)},save(){return P.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,v,D){this.g=P.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:D});const E={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},d=[];for(const h of P.rawEvents)h.kind===C.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,E.contentChanges):h.kind===C.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,E.contentChanges):h.kind===C.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),d.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===C.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),d.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),d.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===C.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),d.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),d.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const m=new Map;for(let h=0;h<d.length;h++){const b=d[h],p=m.get(b.cell);if(p===void 0){const g=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});m.set(b.cell,g-1)}else E.cellChanges[p]={...E.cellChanges[p],...b}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let v=P.start|0,D=P.end|0;return v<0&&(v=0),D>this.b.length&&(D=this.b.length),P.with({start:v,end:D})}p(P){P=this.o(P);const v=[];for(let D=P.start;D<P.end;D++)v.push(this.b[D]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,v,D){if(this.j)return;const E=[],d=[],m=[];if(P.reverse().forEach(h=>{const p=h[2].map(i=>{const o=new S(this,this.l,i);return v||d.push(S.asModelAddData(this.apiNotebook,i)),o}),g=new T(h[0],h[1],[],p),w=this.b.splice(h[0],h[1],...p);for(const i of w)m.push(i.uri),g.deletedItems.push(i.apiCell);E.push(g)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:m}),D)for(const h of E)D.push(h.asApiEvent())}s(P,v,D,E){const d=this.b.splice(P,v);this.b.splice(D,0,...d);const m=[new T(P,v,d.map(h=>h.apiCell),[]),new T(D,0,[],d)];for(const h of m)E.push(h.asApiEvent())}t(P,v){this.b[P].setOutputs(v)}u(P,v,D,E){this.b[P].setOutputItems(v,D,E)}v(P,v){const D=this.b[P];D.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(D.uri,v)}w(P,v){const D=this.b[P];D.apiCell.mime=v}x(P,v){this.b[P].setMetadata(v)}y(P,v){this.b[P].setInternalMetadata(v)}getCellFromApiCell(P){return this.b.find(v=>v.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(v=>v.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=y,y.a=0}),define(ye[136],Ce([1,0,10,14,7]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(T,S,y,L,P,v){this.id=T,this.f=S,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=L,this.c=v}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(S){this.selections=[S]},get selections(){return T.a},set selections(S){if(!Array.isArray(S)||!S.every(k.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");T.a=S,T.g(S)},get visibleRanges(){return T.b},revealRange(S,y){T.f.$tryRevealRange(T.id,t.NotebookRange.from(S),y??k.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(t.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(ye[234],Ce([1,0,4,13,14]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(T,S){this.c=T,this.d=S,this.a=new c.Emitter,this.b=new c.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const y=this.d.getEditorById(T);S.visibleRanges&&y._acceptVisibleRanges(S.visibleRanges.ranges.map(k.NotebookRange.to)),S.selections&&y._acceptSelections(S.selections.selections.map(k.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this.d.getEditorById(S)._acceptViewColumn(k.ViewColumn.to(T[S]))}};A=qe([He(0,t.ILogService)],A),e.ExtHostNotebookEditors=A}),define(ye[235],Ce([1,0,14,125,175,21,60,10]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,D,E){const d=this.b++,{title:m,location:h,cancellable:b}=D,p={label:(0,k.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(d,{location:c.ProgressLocation.from(h),title:m,source:p,cancellable:b},v.isUnderDevelopment?void 0:v.identifier.value).catch(T.onUnexpectedExternalError),this.d(d,E,!!b)}d(v,D,E){let d;E&&(d=new A.CancellationTokenSource,this.c.set(v,d));const m=b=>{this.a.$progressEnd(b),this.c.delete(b),d?.dispose()};let h;try{h=D(new L(this.a,v),E&&d?d.token:A.CancellationToken.None)}catch(b){throw m(v),b}return h.then(b=>m(v),b=>m(v)),h}$acceptProgressCanceled(v){const D=this.c.get(v);D&&(D.cancel(),this.c.delete(v))}}e.ExtHostProgress=S;function y(P,v){return P.message=v.message,typeof v.increment=="number"&&(typeof P.increment=="number"?P.increment+=v.increment:P.increment=v.increment),P}class L extends t.Progress{constructor(v,D){super(E=>this.throttledReport(E)),this.c=v,this.d=D}throttledReport(v){this.c.$progressReport(this.d,v)}}qe([(0,C.throttle)(100,(P,v)=>y(P,v),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[137],Ce([1,0,35,132,56,92,70,14,2]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const y=(p,g,w,i)=>{let o=g;return{enumerable:!0,configurable:!1,get(){return o},set(u){if(!w(o,u)){const l=o;o=u,p.listener?.(i(u,l))}}}},L=(p,g)=>p===g,P={range:(p,g)=>p===g?!0:!p||!g?!1:p.isEqual(g),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(p,g)=>!(p.length!==g.length||p.some(w=>!g.find(i=>w.id===i.id)))},v=p=>g=>({op:4,update:p(g)}),D=(p,g)=>({range:(()=>{let w;const i=v(o=>({range:c.Range.lift(T.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return w},set(o){p.listener?.({op:6}),P.range(w,o)||(w=o,p.listener?.(i(o)))}}})(),label:y(p,g,P.label,v(w=>({label:w}))),description:y(p,void 0,P.description,v(w=>({description:w}))),sortText:y(p,void 0,P.sortText,v(w=>({sortText:w}))),canResolveChildren:y(p,!1,P.canResolveChildren,w=>({op:2,state:w})),busy:y(p,!1,P.busy,v(w=>({busy:w}))),error:y(p,void 0,P.error,v(w=>({error:T.MarkdownString.fromStrict(w)||null}))),tags:y(p,[],P.tags,(w,i)=>({op:1,new:w.map(T.TestTag.from),old:i.map(T.TestTag.from)}))}),E=p=>{const g=k.TestId.fromString(p.extId),w=new m(g.controllerId,g.localId,p.label,S.URI.revive(p.uri)||void 0);return w.range=T.Range.to(p.range||void 0),w.description=p.description||void 0,w.sortText=p.sortText||void 0,w.tags=p.tags.map(i=>T.TestTag.to({id:(0,C.denamespaceTestTag)(i).tagId})),w},d=p=>{let g;for(const w of p.tests){const i=E(w.item);(0,t.getPrivateApiFor)(i).parent=g,g=i}return g};e.toItemFromContext=d;class m{constructor(g,w,i,o){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const u=(0,t.createPrivateApiFor)(this,g);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof h?void 0:u.parent}},children:{value:(0,A.createTestItemChildren)(u,t.getPrivateApiFor,m),enumerable:!0,writable:!1},...D(u,i)})}}e.TestItemImpl=m;class h extends m{constructor(g,w){super(g,g,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class b extends A.TestItemCollection{constructor(g,w,i){super({controllerId:g,getDocumentVersion:o=>o&&i.getDocument(o)?.version,getApiFor:t.getPrivateApiFor,getChildren:o=>o.children,root:new h(g,w),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(ye[138],Ce([1,0,49,10,100,14,7]),function(ne,e,c,t,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class T{constructor(v,D,E){const d=T.c.nextId();v.$registerTextEditorDecorationType(D.identifier,d,A.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:d,dispose(){v.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=T,T.c=new k.IdGenerator("TextEditorDecorationType");class S{constructor(v,D){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=D.undoStopBefore,this.f=D.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,D){this.k();let E=null;if(v instanceof C.Position)E=new C.Range(v,v);else if(v instanceof C.Range)E=v;else throw new Error("Unrecognized location");this.l(E,D,!1)}insert(v,D){this.k(),this.l(new C.Range(v,v),D,!0)}delete(v){this.k();let D=null;if(v instanceof C.Range)D=v;else throw new Error("Unrecognized location");this.l(D,null,!0)}l(v,D,E){const d=this.c.validateRange(v);this.g.push({range:d,text:D,forceMoveMarkers:E})}setEndOfLine(v){if(this.k(),v!==C.EndOfLine.LF&&v!==C.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=v}}class y{constructor(v,D,E,d){this.c=v,this.d=D,this._accept(E),this.e=d;const m=this;this.value={get tabSize(){return m.f},set tabSize(h){m.m(h)},get indentSize(){return m.g},set indentSize(h){m.o(h)},get insertSpaces(){return m.h},set insertSpaces(h){m.q(h)},get cursorStyle(){return m.j},set cursorStyle(h){m.s(h)},get lineNumbers(){return m.k},set lineNumbers(h){m.t(h)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=A.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const D=Math.floor(v);return D>0?D:null}if(typeof v=="string"){const D=parseInt(v,10);return isNaN(D)?null:D>0?D:null}return null}m(v){const D=this.l(v);if(D!==null){if(typeof D=="number"){if(this.f===D)return;this.f=D}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:D}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const D=Math.floor(v);return D>0?D:null}if(typeof v=="string"){const D=parseInt(v,10);return isNaN(D)?null:D>0?D:null}return null}o(v){const D=this.n(v);if(D!==null){if(typeof D=="number"){if(this.g===D)return;this.g=D}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:D}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const D=this.p(v);if(typeof D=="boolean"){if(this.h===D)return;this.h=D}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:D}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(v)})))}assign(v){const D={};let E=!1;if(typeof v.tabSize<"u"){const d=this.l(v.tabSize);d==="auto"?(E=!0,D.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,E=!0,D.tabSize=d)}if(typeof v.indentSize<"u"){const d=this.n(v.indentSize);d==="tabSize"?(E=!0,D.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,E=!0,D.indentSize=d)}if(typeof v.insertSpaces<"u"){const d=this.p(v.insertSpaces);d==="auto"?(E=!0,D.insertSpaces=d):this.h!==d&&(this.h=d,E=!0,D.insertSpaces=d)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,E=!0,D.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,E=!0,D.lineNumbers=A.TextEditorLineNumbersStyle.from(v.lineNumbers)),E&&this.u("setOptions",this.c.$trySetOptions(this.d,D))}u(v,D){D.catch(E=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(E)})}}e.ExtHostTextEditorOptions=y;class L{constructor(v,D,E,d,m,h,b,p){this.id=v,this.j=D,this.k=E,this.g=!1,this.h=new Set,this.c=m,this.d=new y(this.j,this.id,h,E),this.e=b,this.f=p;const g=this;this.value=Object.freeze({get document(){return d.getValue()},set document(w){throw(0,t.readonly)("document")},get selection(){return g.c&&g.c[0]},set selection(w){if(!(w instanceof C.Selection))throw(0,t.illegalArgument)("selection");g.c=[w],g.l()},get selections(){return g.c},set selections(w){if(!Array.isArray(w)||w.some(i=>!(i instanceof C.Selection)))throw(0,t.illegalArgument)("selections");g.c=w,g.l()},get visibleRanges(){return g.e},set visibleRanges(w){throw(0,t.readonly)("visibleRanges")},get options(){return g.d.value},set options(w){g.g||g.d.assign(w)},get viewColumn(){return g.f},set viewColumn(w){throw(0,t.readonly)("viewColumn")},edit(w,i={undoStopBefore:!0,undoStopAfter:!0}){if(g.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new S(d.getValue(),i);return w(o),g.m(o)},insertSnippet(w,i,o={undoStopBefore:!0,undoStopAfter:!0}){if(g.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=g.c.map(l=>A.Range.from(l));else if(i instanceof C.Position){const{lineNumber:l,column:s}=A.Position.from(i);u=[{startLineNumber:l,startColumn:s,endLineNumber:l,endColumn:s}]}else if(i instanceof C.Range)u=[A.Range.from(i)];else{u=[];for(const l of i)if(l instanceof C.Range)u.push(A.Range.from(l));else{const{lineNumber:s,column:a}=A.Position.from(l);u.push({startLineNumber:s,startColumn:a,endLineNumber:s,endColumn:a})}}return D.$tryInsertSnippet(v,d.getValue().version,w.value,u,o)},setDecorations(w,i){const o=i.length===0;o&&!g.h.has(w.key)||(o?g.h.delete(w.key):g.h.add(w.key),g.n(()=>{if(A.isDecorationOptionsArr(i))return D.$trySetDecorations(v,w.key,A.fromRangeOrRangeWithMessage(i));{const u=new Array(4*i.length);for(let l=0,s=i.length;l<s;l++){const a=i[l];u[4*l]=a.start.line+1,u[4*l+1]=a.start.character+1,u[4*l+2]=a.end.line+1,u[4*l+3]=a.end.character+1}return D.$trySetDecorationsFast(v,w.key,u)}}))},revealRange(w,i){g.n(()=>D.$tryRevealRange(v,A.Range.from(w),i||C.TextEditorRevealType.Default))},show(w){D.$tryShowEditor(v,A.ViewColumn.from(w))},hide(){D.$tryHideEditor(v)}})}dispose(){(0,c.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,c.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,c.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,c.ok)(!this.g),this.f=v}_acceptSelections(v){(0,c.ok)(!this.g),this.c=v}async l(){const v=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const D=v.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const E=D.edits.map(m=>m.range);E.sort((m,h)=>m.end.line===h.end.line?m.end.character===h.end.character?m.start.line===h.start.line?m.start.character-h.start.character:m.start.line-h.start.line:m.end.character-h.end.character:m.end.line-h.end.line);for(let m=0,h=E.length-1;m<h;m++){const b=E[m].end;if(E[m+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=D.edits.map(m=>({range:A.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,D.documentVersionId,d,{setEndOfLine:typeof D.setEndOfLine=="number"?A.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this.k.warn(D),null))}}e.ExtHostTextEditor=L}),define(ye[236],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[237],Ce([1,0,189,10,43,122,126,44,27,236,201,191]),function(ne,e,c,t,k,A,C,T,S,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=T.Registry.as(C.Extensions.JSONContribution);class D{constructor(w,i,o){this.a=w,this.b=i,this.c=o}d(w,i){this.a({type:w,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(k.default.Error,w)}warn(w){this.d(k.default.Warning,w)}info(w){this.d(k.default.Info,w)}}e.ExtensionMessageCollector=D;class E{static a(w){const i=new Set;for(let o=0,u=w.length;o<u;o++)i.add(S.ExtensionIdentifier.toKey(w[o].description.identifier));return i}static compute(w,i){if(!w||!w.length)return new E(i,[]);if(!i||!i.length)return new E([],w);const o=this.a(w),u=this.a(i),l=i.filter(a=>!o.has(S.ExtensionIdentifier.toKey(a.description.identifier))),s=w.filter(a=>!u.has(S.ExtensionIdentifier.toKey(a.description.identifier)));return new E(l,s)}constructor(w,i){this.added=w,this.removed=i}}e.ExtensionPointUserDelta=E;class d{constructor(w,i){this.name=w,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=E.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,t.onUnexpectedError)(w)}}}e.ExtensionPoint=d;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:c.localize(15,null),type:"string",enum:["none"],enumDescriptions:[c.localize(16,null)]},activationEvents:{description:c.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(32,null)},{label:"onUri",body:"onUri",description:c.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(37,null)},{label:"onRenderer",description:c.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(41,null)},{label:"*",description:c.localize(42,null),body:"*"}]}},badges:{type:"array",description:c.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(44,null)},href:{type:"string",description:c.localize(45,null)},description:{type:"string",description:c.localize(46,null)}}}},markdown:{type:"string",description:c.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(51,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(52,null)},{body:["workspace"],description:c.localize(53,null)},{body:["ui","workspace"],description:c.localize(54,null)},{body:["workspace","ui"],description:c.localize(55,null)},{body:[],description:c.localize(56,null)}]},capabilities:{description:c.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)]},description:{type:"string",markdownDescription:c.localize(63,null)}}},untrustedWorkspaces:{description:c.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null)]},restrictedConfigurations:{description:c.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(70,null)}}}}},sponsor:{description:c.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(73,null),type:"string"},"vscode:uninstall":{description:c.localize(74,null),type:"string"}}},icon:{type:"string",description:c.localize(75,null)},l10n:{type:"string",description:c.localize(76,null)}}};class b{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const i=new d(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,i),w.activationEventsGenerator&&P.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,v.registerSchema(h,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=b;const p={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(p.ExtensionsRegistry,new b),e.ExtensionsRegistry=T.Registry.as(p.ExtensionsRegistry),v.registerSchema(h,e.schema),v.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(ye[238],Ce([1,0,186,11,23,237,53,4]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var y;(function(v){function D(E,d,m){if(!E)return;const h=t.isString(E.type)?E.type:void 0;if(!h||h.length===0){m.error(c.localize(3,null));return}const b=[];if(Array.isArray(E.required))for(const p of E.required)t.isString(p)&&b.push(p);return{extensionId:d.value,taskType:h,required:b,properties:E.properties?k.deepClone(E.properties):{},when:E.when?C.ContextKeyExpr.deserialize(E.when):void 0}}v.from=D})(y||(y={}));const L=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:S}});class P{constructor(){this.d=new T.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((D,E)=>{L.setHandler((d,m)=>{this.c=void 0;try{for(const h of m.removed){const b=h.value;for(const p of b)this.a&&p.type&&this.a[p.type]&&delete this.a[p.type]}for(const h of m.added){const b=h.value;for(const p of b){const g=y.from(p,h.description.identifier,h.collector);g&&(this.a[g.taskType]=g)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}D(void 0)})})}onReady(){return this.b}get(D){return this.a[D]}all(){return Object.keys(this.a).map(D=>this.a[D])}getJsonSchema(){if(this.c===void 0){const D=[];for(const E of this.all()){const d={type:"object",additionalProperties:!1};E.required.length>0&&(d.required=E.required.slice(0)),E.properties!==void 0?d.properties=k.deepClone(E.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[E.taskType]},D.push(d)}this.c={oneOf:D}}return this.c}}e.TaskDefinitionRegistry=new P}),define(ye[239],Ce([1,0,187,11,24,23,53,238]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function z(U){if(!U)return F.Strong;switch(U.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=z}(S=e.ShellQuoting||(e.ShellQuoting={}));var y;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(y=e.CommandOptions||(e.CommandOptions={}));var L;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(F){function z(U){switch(U.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=z}(L=e.RevealKind||(e.RevealKind={}));var P;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function z(U){switch(U.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=z}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(F){function z(U){switch(U.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=z}(v=e.PanelKind||(e.PanelKind={}));var D;(function(F){F.defaults={echo:!0,reveal:L.Always,revealProblems:P.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(D=e.PresentationOptions||(e.PresentationOptions={}));var E;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(E=e.RuntimeType||(e.RuntimeType={})),function(F){function z(H){switch(H.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=z;function U(H){switch(H){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=U}(E=e.RuntimeType||(e.RuntimeType={}));var d;(function(F){function z(U){return t.isString(U)?U:U.value}F.value=z})(d=e.CommandString||(e.CommandString={}));var m;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function z(H){return H===F.Clean._id||H===F.Build._id||H===F.Rebuild._id||H===F.Test._id}F.is=z;function U(H){if(H!==void 0)return t.isString(H)?z(H)?{_id:H,isDefault:!1}:void 0:H}F.from=U})(m=e.TaskGroup||(e.TaskGroup={}));var h;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var b;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function z(U){switch(U){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=z})(b=e.TaskSourceKind||(e.TaskSourceKind={}));var p;(function(F){F.parallel="parallel",F.sequence="sequence"})(p=e.DependsOrder||(e.DependsOrder={}));var g;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(g=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:g.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class i{constructor(z,U,H,x,V,_){this._label="",this._id=z,U&&(this._label=U),H&&(this.type=H),this.runOptions=x,this.configurationProperties=V,this._source=_}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,U=!1){if(z===void 0)return!1;if(t.isString(z))return z===this._label||z===this.configurationProperties.identifier||U&&z===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class o extends i{constructor(z,U,H,x,V,_,Q,Z){super(z,H,void 0,Q,Z,U),this.command={},this._source=U,this.hasDefinedMatchers=_,V&&(this.command=V)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case E.Shell:U="shell";break;case E.Process:U="process";break;case E.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(z){return z instanceof o}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let U=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(U+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:U};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new o(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.CustomTask=o;class u extends i{constructor(z,U,H,x,V,_,Q){super(z,H,x,_,Q,U),this._source=U,this.configures=V}static is(z){return z instanceof u}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let U=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(U+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:U};return JSON.stringify(H)}}e.ConfiguringTask=u;class l extends i{constructor(z,U,H,x,V,_,Q,Z,ge){super(z,H,x,Z,ge,U),this.defines=V,this.hasDefinedMatchers=Q,this.command=_,this.icon=ge.icon,this.hide=ge.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof l}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new l(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.ContributedTask=l;class s extends i{constructor(z,U,H,x,V,_){super(z,H,x,V,_,U),this._source=U}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new s(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.InMemoryTask=s;var a;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(a=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(a=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class r{constructor(z){this.c=new Map;for(let U=0;U<z.length;U++)this.c.set(z[U].uri.toString(),U)}compare(z,U){const H=z.getWorkspaceFolder(),x=U.getWorkspaceFolder();if(H&&x){let V=this.c.get(H.uri.toString());V=V===void 0?0:V+1;let _=this.c.get(x.uri.toString());return _=_===void 0?0:_+1,V===_?z._label.localeCompare(U._label):V-_}else return!H&&x?-1:H&&!x?1:0}}e.TaskSorter=r;var f;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var I;(function(F){F.SingleRun="singleRun",F.Background="background"})(I=e.TaskRunType||(e.TaskRunType={}));var R;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(R=e.TaskRunSource||(e.TaskRunSource={}));var B;(function(F){function z(U,H,x,V){if(H){const _={kind:U,taskId:H._id,taskName:H.configurationProperties.name,runType:H.configurationProperties.isBackground?"background":"singleRun",group:H.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:x,__task:H};return U==="start"?_.resolvedVariables=V:U==="processStarted"?_.processId=V:U==="processEnded"&&(_.exitCode=V),Object.freeze(_)}else return Object.freeze({kind:"changed"})}F.create=z})(B=e.TaskEvent||(e.TaskEvent={}));var X;(function(F){function z(H){const x=Object.keys(H).sort();let V="";for(const _ of x){let Q=H[_];Q instanceof Object?Q=z(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),V+=_+","+Q+","}return V}function U(H){const V={_key:z(H),type:H.taskType};return Object.assign(V,H),V}F.create=U})(X=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var q;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(q=e.TaskSettingId||(e.TaskSettingId={}));var N;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(N=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var M;(function(F){function z(U,H){const x=T.TaskDefinitionRegistry.get(U.type);if(x===void 0){const Z=A.deepClone(U);return delete Z._key,X.create(Z)}const V=Object.create(null);V.type=x.taskType;const _=new Set;x.required.forEach(Z=>_.add(Z));const Q=x.properties;for(const Z of Object.keys(Q)){const ge=U[Z];if(ge!=null)V[Z]=ge;else if(_.has(Z)){const te=Q[Z];if(te.default!==void 0)V[Z]=A.deepClone(te.default);else switch(te.type){case"boolean":V[Z]=!1;break;case"number":case"integer":V[Z]=0;break;case"string":V[Z]="";break;default:H.error(c.localize(2,null,JSON.stringify(U,void 0,0),Z));return}}}return X.create(V)}F.createTaskIdentifier=z})(M=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[240],Ce([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,T)=>{this.b=C,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,c.onUnexpectedError)(C))}then(C,T){return this.j().then(C,T)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=t;class k extends t{constructor(){super(),this.h=!0,this.i=new c.CancellationError}}e.CanceledLazyPromise=k}),define(ye[57],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const t=[];function k(T){const S=new c(T);return t[S.nid]=S,S}e.createProxyIdentifier=k;function A(T){return t[T].sid}e.getStringIdentifierForProxy=A;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(ye[5],Ce([1,0,57]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var A;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(A=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var y;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(y=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(m){return m._id=P.a++,m}}e.IdObject=P,P.a=0;var v;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var D;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(D=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[71],Ce([1,0,3,13,5,16]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,y){this.c=y,this.a=new Set,this.b=S.getProxy(k.MainContext.MainThreadTelemetry)}report(S,y,L){const P=this.d(S,y);this.a.has(P)||(this.a.add(P),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:S}))}d(S,y){return`${S}-${y.identifier.value}`}};C=qe([He(0,A.IExtHostRpcService),He(1,t.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,y){}})}),define(ye[241],Ce([1,0,4,5,7,27]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new c.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,y,L,P={}){const v=A.ExtensionIdentifier.toKey(S.identifier),D=this.f.get(v)||[],E=[...L].sort().join(" ");let d=D.find(m=>m.providerId===y&&m.scopes===E);if(d)return d.result;{const m=this.g(S,v,y,L,P);d={providerId:y,scopes:E,result:m},D.push(d),this.f.set(v,D);try{await m}finally{const h=D.findIndex(b=>b.providerId===y&&b.scopes===E);h>-1&&(D.splice(h),this.f.set(v,D))}return m}}async g(S,y,L,P,v={}){await this.a.$ensureProvider(L);const D=S.displayName||S.name;return this.a.$getSession(L,P,y,D,v)}async removeSession(S,y){const L=this.b.get(S);return L?L.provider.removeSession(y):this.a.$removeSession(S,y)}registerAuthenticationProvider(S,y,L,P){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:y,provider:L,options:P??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===S)||this.c.push({id:S,label:y});const v=L.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(S,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(S,y,P?.supportsMultipleAccounts??!1),new k.Disposable(()=>{v.dispose(),this.b.delete(S);const D=this.c.findIndex(E=>E.id===S);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,y){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.createSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,y){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,y){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,y){return this.d.fire({provider:{id:S,label:y}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(ye[242],Ce([1,0,5,16,14]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(T,S){this.a=T.getProxy(c.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>S.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,S,y){const L=k.WorkspaceEdit.from(T,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,y?.isRefactoring??!1)}};A=qe([He(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ye[243],Ce([1,0,5]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const C=A.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(T){return C.$writeText(T)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[39],Ce([1,0,11,7,14,23,5,17,13,86,35,50,2,6,3,16,137,22,57,51,42,68]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p,g,w){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=class{constructor(f,I){i.set(this,void 0),this.b=new Map,this.c=new Map,o.set(this,void 0),Je(this,i,f.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=I,Je(this,o,f.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,R=>{const B=this.c.get(R);return B?.result===a.Void?B:void 0},I),this.f=[{processArgument(R){return(0,y.revive)(R)}},{processArgument(R){return(0,A.cloneAndChange)(R,function(B){if(L.Range.isIRange(B))return k.Range.to(B);if(P.Position.isIPosition(B))return k.Position.to(B);if(L.Range.isIRange(B.range)&&v.URI.isUri(B.uri))return k.location.to(B);if(B instanceof h.VSBuffer)return B.buffer.buffer;if(!Array.isArray(B))return B})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const I=this.registerCommand(!1,f.id,async(...R)=>{const B=f.args.map((q,N)=>{if(!q.validate(R[N]))throw new Error(`Invalid argument '${q.name}' when running '${f.id}', received: ${R[N]}`);return q.convert(R[N])}),X=await this.executeCommand(f.internalId,...B);return f.result.convert(X,R,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new t.Disposable(()=>{I.dispose(),this.c.delete(f.id)})}registerCommand(f,I,R,B,X,q){if(this.d.trace("ExtHostCommands#registerCommand",I),!I.trim().length)throw new Error("invalid id");if(this.b.has(I))throw new Error(`command '${I}' already exists`);return this.b.set(I,{callback:R,thisArg:B,description:X,extension:q}),f&&Ue(this,i,"f").$registerCommand(I),new t.Disposable(()=>{this.b.delete(I)&&f&&Ue(this,i,"f").$unregisterCommand(I)})}executeCommand(f,...I){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,I,!0)}async g(f,I,R){if(this.b.has(f))return Ue(this,i,"f").$fireCommandActivationEvent(f),this.h(f,I,!1);{let B=!1;const X=(0,A.cloneAndChange)(I,function(q){if(q instanceof t.Position)return k.Position.from(q);if(q instanceof t.Range)return k.Range.from(q);if(q instanceof t.Location)return k.location.from(q);if(t.NotebookRange.isNotebookRange(q))return k.NotebookRange.from(q);if(q instanceof ArrayBuffer)return B=!0,h.VSBuffer.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return B=!0,h.VSBuffer.wrap(q);if(q instanceof h.VSBuffer)return B=!0,q;if(!Array.isArray(q))return q});try{const q=await Ue(this,i,"f").$executeCommand(f,B?new b.SerializableObjectWithBuffers(X):X,R);return(0,y.revive)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this.g(f,I,!1);throw q}}}async h(f,I,R){const B=this.b.get(f);if(!B)throw new Error("Unknown command");const{callback:X,thisArg:q,description:N}=B;if(N)for(let F=0;F<N.args.length;F++)try{(0,c.validateConstraint)(I[F],N.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${N.args[F].name}' - ${N.args[F].description}`)}const M=g.StopWatch.create();try{return await X.apply(q,I)}catch(F){if(f===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...I);z&&(f=z.command)}throw this.d.error(F,f,B.extension?.identifier),R?new class extends Error{constructor(){super((0,p.toErrorMessage)(F)),this.id=f,this.source=B.extension?.displayName??B.extension?.name}}:F}finally{this.j(B,f,M.elapsed())}}j(f,I,R){!f.extension||Ue(this,o,"f").$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new w.TrustedTelemetryValue(I),duration:R})}$executeContributedCommand(f,...I){return this.d.trace("ExtHostCommands#$executeContributedCommand",f),this.b.has(f)?(I=I.map(R=>this.f.reduce((B,X)=>X.processArgument(B),R)),this.h(f,I,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),Ue(this,i,"f").$getCommands().then(I=>(f&&(I=I.filter(R=>R[0]!=="_")),I))}$getContributedCommandHandlerDescriptions(){const f=Object.create(null);for(const[I,R]of this.b){const{description:B}=R;B&&(f[I]=B)}return Promise.resolve(f)}};i=new WeakMap,o=new WeakMap,u=qe([He(0,d.IExtHostRpcService),He(1,S.ILogService)],u),e.ExtHostCommands=u,e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class l{constructor(f,I,R){this.d=f,this.f=I,this.g=R,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,I){if(!f)return;const R={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return R;const B=this.f(f.command);if(B)R.id=B.internalId,R.arguments=B.args.map((X,q)=>X.convert(f.arguments&&f.arguments[q]));else if((0,T.isNonEmptyArray)(f.arguments)){const X=`${f.command}/${++this.c}`;this.b.set(X,f),I.add((0,D.toDisposable)(()=>{this.b.delete(X),this.g.trace("CommandsConverter#DISPOSE",X)})),R.$ident=X,R.id=this.delegatingCommandId,R.arguments=[X],this.g.trace("CommandsConverter#CREATE",f.command,X)}return R}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const I=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],I?I.command:"MISSING"),I?this.d.executeCommand(I.command,...I.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.CommandsConverter=l;class s{constructor(f,I,R,B){this.name=f,this.description=I,this.validate=R,this.convert=B}optional(){return new s(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,I){return new s(f??this.name,I??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",r=>v.URI.isUri(r),r=>r),s.Position=new s("position","A position in a text document",r=>t.Position.isPosition(r),k.Position.from),s.Range=new s("range","A range in a text document",r=>t.Range.isRange(r),k.Range.from),s.Selection=new s("selection","A selection in a text document",r=>t.Selection.isSelection(r),k.Selection.from),s.Number=new s("number","",r=>typeof r=="number",r=>r),s.String=new s("string","",r=>typeof r=="string",r=>r),s.CallHierarchyItem=new s("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,k.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,k.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",r=>r instanceof m.TestItemImpl,k.TestItem.from);class a{constructor(f,I){this.description=f,this.convert=I}}e.ApiCommandResult=a,a.Void=new a("no result",r=>r);class n{constructor(f,I,R,B,X){this.id=f,this.internalId=I,this.description=R,this.args=B,this.result=X}}e.ApiCommand=n}),define(ye[244],Ce([1,0,2,14,7,66,39,17,119,124,15]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",D(t.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,m)=>{if((0,T.isFalsyOrEmpty)(d))return;class h extends k.SymbolInformation{static to(p){const g=new h(p.name,t.SymbolKind.to(p.kind),p.containerName||"",new k.Location(m[0],t.Range.to(p.range)));return g.detail=p.detail,g.range=g.location.range,g.selectionRange=t.Range.to(p.selectionRange),g.children=p.children?p.children.map(h.to):[],g}}return d.map(h.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",D(t.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",D(t.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(m=>k.Position.isPosition(m)),d=>d.map(t.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(m=>{let h;for(const b of m.reverse())h=new k.SelectionRange(t.Range.to(b),h);return h}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(t.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",d=>d.map(t.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",d=>d.map(t.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",d=>d.map(t.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:t.Range.to(d.range),placeholder:d.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return t.WorkspaceEdit.to(d)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(t.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new k.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const m=(0,S.decodeSemanticTokensDto)(d);if(m.type==="full")return new k.SemanticTokens(m.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new k.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const m=(0,S.decodeSemanticTokensDto)(d);if(m.type==="full")return new k.SemanticTokens(m.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,m,h)=>{if(!d)return new k.CompletionList([]);const b=d.suggestions.map(p=>t.CompletionItem.to(p,h));return new k.CompletionList(b,d.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return t.SignatureHelp.to(d)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,m,h)=>D(b=>new k.CodeLens(t.Range.to(b.range),b.command&&h.fromInternal(b.command)))(d))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>k.Range.isRange(d),d=>k.Selection.isSelection(d)?t.Selection.from(d):t.Range.from(d)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,m,h)=>D(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(b.command)}else{const p=new k.CodeAction(b.title,b.kind?new k.CodeActionKind(b.kind):void 0);return b.edit&&(p.edit=t.WorkspaceEdit.to(b.edit)),b.command&&(p.command=h.fromInternal(b.command)),p.isPreferred=b.isPreferred,p}})(d))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(m=>new k.ColorInformation(t.Range.to(m.range),t.Color.to(m.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",d=>d instanceof k.Color,t.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:t.Range.from(d.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(t.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,m,h)=>d.map(t.InlayHint.to.bind(void 0,h)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",D(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(m=>t.NotebookExclusiveDocumentPattern.to(m))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(t.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>c.URI.isUri(d)||typeof d=="string"&&(0,y.matchesSomeScheme)(d,L.Schemas.http,L.Schemas.https),d=>d),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,d=>d)],C.ApiCommandResult.Void)];class v{static register(m){P.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=v;function D(d){return m=>{if(Array.isArray(m))return m.map(d)}}function E(d){if(!Array.isArray(d))return;const m=[];for(const h of d)A.isLocationLink(h)?m.push(t.DefinitionLink.to(h)):m.push(t.location.to(h));return m}}),define(ye[245],Ce([1,0,18,60,4,6,2,66,27,14,7,26,5]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function D(E,d,m){const h=E.getProxy(v.MainContext.MainThreadComments);class b{constructor(){this.b=new Map,this.c=new Map,d.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===6){const n=this.b.get(a.handle);return n?n.value:a}else if(a&&a.$mid===7){const n=this.b.get(a.commentControlHandle);if(!n)return a;const r=n.getCommentThread(a.commentThreadHandle);return r?r.value:a}else if(a&&(a.$mid===9||a.$mid===8)){const n=this.b.get(a.thread.commentControlHandle);if(!n)return a;const r=n.getCommentThread(a.thread.commentThreadHandle);return r?a.$mid===8?r.value:{thread:r.value,text:a.text}:a}else if(a&&a.$mid===10){const n=this.b.get(a.thread.commentControlHandle);if(!n)return a;const r=n.getCommentThread(a.thread.commentThreadHandle);if(!r)return a;const f=a.commentUniqueId,I=r.getCommentByUniqueId(f);return I||a}else if(a&&a.$mid===11){const n=this.b.get(a.thread.commentControlHandle);if(!n)return a;const r=n.getCommentThread(a.thread.commentThreadHandle);if(!r)return a;const f=a.text,I=a.commentUniqueId,R=r.getCommentByUniqueId(I);return R?(typeof R.body=="string"?R.body=f:R.body=new L.MarkdownString(f),R):a}return a}})}createCommentController(a,n,r){const f=b.a++,I=new g(a,f,n,r);this.b.set(I.handle,I);const R=this.c.get(S.ExtensionIdentifier.toKey(a.identifier))||[];return R.push(I),this.c.set(S.ExtensionIdentifier.toKey(a.identifier),R),I.value}$createCommentThreadTemplate(a,n,r){const f=this.b.get(a);!f||f.$createCommentThreadTemplate(n,r)}async $updateCommentThreadTemplate(a,n,r){const f=this.b.get(a);!f||f.$updateCommentThreadTemplate(n,r)}$deleteCommentThread(a,n){this.b.get(a)?.$deleteCommentThread(n)}$provideCommentingRanges(a,n,r){const f=this.b.get(a);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const I=m.getDocument(C.URI.revive(n));return(0,c.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(I,r)).then(R=>R?R.map(B=>y.Range.from(B)):void 0)}$toggleReaction(a,n,r,f,I){const R=this.b.get(a);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const B=R.getCommentThread(n);if(B){const X=B.getCommentByUniqueId(f.uniqueIdInThread);if(R!==void 0&&X&&R.reactionHandler)return R.reactionHandler(X,o(I))}return Promise.resolve(void 0)})}dispose(){}}b.a=0;class p{set threadId(a){this.n=a}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(a){a.isEqual(this.p)||(this.p=a,this.b.range=a,this.c.fire())}get range(){return this.p}set canReply(a){this.d!==a&&(this.d=a,this.b.canReply=a,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(a){this.e=a,this.b.label=a,this.c.fire()}get contextValue(){return this.f}set contextValue(a){this.f=a,this.b.contextValue=a,this.c.fire()}get comments(){return this.q}set comments(a){this.q=a,this.b.comments=a,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(a){this.g=a,this.b.collapsibleState=a,this.c.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(a){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=a,this.b.state=a,this.c.fire()}get isDisposed(){return this.j}constructor(a,n,r,f,I,R,B,X){this.m=n,this.n=r,this.o=f,this.p=I,this.q=R,this.extensionDescription=B,this.r=X,this.handle=p.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new k.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.MutableDisposable,this.l.value=new A.DisposableStore,this.n===void 0&&(this.n=`${a}.${this.handle}`),h.$createCommentThread(n,this.handle,this.n,this.o,y.Range.from(this.p),B.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this.i.push({dispose:()=>{h.$deleteCommentThread(n,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(N){q.range=N},get comments(){return q.comments},set comments(N){q.comments=N},get collapsibleState(){return q.collapsibleState},set collapsibleState(N){q.collapsibleState=N},get canReply(){return q.canReply},set canReply(N){q.canReply=N},get contextValue(){return q.contextValue},set contextValue(N){q.contextValue=N},get label(){return q.label},set label(N){q.label=N},get state(){return q.state},set state(N){q.state=N},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.DisposableStore);const a=r=>Object.prototype.hasOwnProperty.call(this.b,r),n={};a("range")&&(n.range=y.Range.from(this.p)),a("label")&&(n.label=this.label),a("contextValue")&&(n.contextValue=this.contextValue??null),a("comments")&&(n.comments=this.q.map(r=>w(this,r,this.k))),a("collapsibleState")&&(n.collapseState=u(this.g)),a("canReply")&&(n.canReply=this.canReply),a("state")&&(n.state=l(this.h)),a("isTemplate")&&(n.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(a){for(const n of this.k){const r=n[0],f=n[1];if(a===f)return r}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(a=>a.dispose())}}p.a=0,qe([(0,t.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class g{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(a){this.b=a,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(a){this.c=a,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this.d}set options(a){this.d=a,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(a,n,r,f){this.f=a,this.g=n,this.h=r,this.i=f,this.a=new Map,h.$registerCommentController(this.handle,r,f);const I=this;this.value=Object.freeze({id:I.id,label:I.label,get options(){return I.options},set options(R){I.options=R},get commentingRangeProvider(){return I.commentingRangeProvider},set commentingRangeProvider(R){I.commentingRangeProvider=R},get reactionHandler(){return I.reactionHandler},set reactionHandler(R){I.reactionHandler=R},createCommentThread(R,B,X){return I.createCommentThread(R,B,X).value},dispose:()=>{I.dispose()}}),this.e=[],this.e.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(a,n,r,f){if(typeof a=="string"){const I=new p(this.id,this.handle,a,n,r,f,this.f,!1);return this.a.set(I.handle,I),I}else{const I=new p(this.id,this.handle,void 0,a,n,r,this.f,!1);return this.a.set(I.handle,I),I}}$createCommentThreadTemplate(a,n){const r=new p(this.id,this.handle,void 0,C.URI.revive(a),y.Range.to(n),[],this.f,!0);return r.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this.a.set(r.handle,r),r}$updateCommentThreadTemplate(a,n){const r=this.a.get(a);r&&(r.range=y.Range.to(n))}$deleteCommentThread(a){this.a.get(a)?.dispose(),this.a.delete(a)}getCommentThread(a){return this.a.get(a)}dispose(){this.a.forEach(a=>{a.dispose()}),this.e.forEach(a=>a.dispose())}}function w(s,a,n){let r=n.get(a);r||(r=++s.commentHandle,n.set(a,r));const f=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:r,body:typeof a.body=="string"?a.body:y.MarkdownString.from(a.body),userName:a.author.name,userIconPath:f,label:a.label,commentReactions:a.reactions?a.reactions.map(I=>i(I)):void 0,timestamp:a.timestamp?.toJSON()}}function i(s){return{label:s.label,iconPath:s.iconPath?y.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function o(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?C.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function u(s){if(s!==void 0)switch(s){case L.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function l(s){if(s!==void 0)switch(s){case L.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new b}e.createExtHostComments=D}),define(ye[246],Ce([1,0,23,5,25,16]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(L,P){this.a=L.getProxy(t.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,P){const v=this,D=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v.e(L,P,D,arguments)}})}e(L,P,v,D){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:S(D,this.b)}),this.c&&this.f(L,v,D)}};C=qe([He(0,A.IExtHostRpcService),He(1,k.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const T=1e5;function S(y,L){const P=[];if(y.length)for(let v=0;v<y.length;v++){let D=y[v];if(typeof D>"u")D="undefined";else if(D instanceof Error){const E=D;E.stack?D=E.stack:D=E.toString()}P.push(D)}if(L){const v=new Error().stack;v&&P.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,c.safeStringify)(P);return v.length>T?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[139],Ce([1,0,2,5,7,3,16,13,17,8,9,26]),function(ne,e,c,t,k,A,C,T,S,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Fn{constructor(E,d){this.h=d,this.f=new Map,this.g=E.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,d){const m=Fn.c++;this.f.set(m,{provider:E,extensionDescription:d}),this.g.$registerDecorationProvider(m,d.identifier.value);const h=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(m,null);return}const p=(0,S.asArray)(b);if(p.length<=Fn.d){this.g.$onDidChange(m,p);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,p.length);const g=p.map(o=>({uri:o,rank:(0,y.count)(o.path,"/")})),w=(0,S.groupBy)(g,(o,u)=>o.rank-u.rank||(0,y.compare)(o.uri.path,u.uri.path)),i=[];e:for(const o of w){let u;for(const l of o){const s=(0,L.dirname)(l.uri.path);if(u!==s&&(u=s,i.push(l.uri)>=Fn.d))break e}}this.g.$onDidChange(m,i)});return new k.Disposable(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(m),this.f.delete(m)})}async $provideDecorations(E,d,m){if(!this.f.has(E))return Object.create(null);const h=Object.create(null),{provider:b,extensionDescription:p}=this.f.get(E);return await Promise.all(d.map(async g=>{try{const{uri:w,id:i}=g,o=await Promise.resolve(b.provideFileDecoration(c.URI.revive(w),m));if(!o)return;try{k.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,P.checkProposedApiEnabled)(p,"codiconDecoration"),h[i]=[o.propagate,o.tooltip,o.badge,o.color]}catch(u){this.h.warn(`INVALID decoration from extension '${p}': ${u}`)}}catch(w){this.h.error(w)}})),h}};v.c=0,v.d=250,v=qe([He(0,C.IExtHostRpcService),He(1,T.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[247],Ce([1,0,173,123,2,5,7,14,4,13,28,47]),function(ne,e,c,t,k,A,C,T,S,y,L,P){"use strict";var v,D,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(b,p,g,w,i,o,u){this.d=b,this.e=p,this.f=g,this.g=w,v.set(this,void 0),D.set(this,void 0),E.set(this,void 0),this.c=!1,Je(this,E,new L.ResourceMap(l=>i.getComparisonKey(l)),"f"),Je(this,v,o,"f"),Je(this,D,u,"f")}dispose(){this.c||(Ue(this,D,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,v,"f")?.$clear(this.e),Ue(this,E,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(b,p){if(!b){this.clear();return}this.h();let g=[];if(k.URI.isUri(b)){if(!p){this.delete(b);return}Ue(this,E,"f").set(b,p.slice()),g=[b]}else if(Array.isArray(b)){g=[];let i;b=[...b].sort(d.j);for(const o of b){const[u,l]=o;if((!i||u.toString()!==i.toString())&&(i&&Ue(this,E,"f").get(i).length===0&&Ue(this,E,"f").delete(i),i=u,g.push(u),Ue(this,E,"f").set(u,[])),l)Ue(this,E,"f").get(u)?.push(...l);else{const s=Ue(this,E,"f").get(u);s&&(s.length=0)}}}if(Ue(this,D,"f").fire(g),!Ue(this,v,"f"))return;const w=[];for(const i of g){let o=[];const u=Ue(this,E,"f").get(i);if(u)if(u.length>this.f){o=[];const l=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const a of u)if(a.severity===l[s]&&o.push({...T.Diagnostic.from(a),modelVersionId:this.g(i)})===this.f)break e;o.push({severity:t.MarkerSeverity.Info,message:(0,c.localize)(0,null,u.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=u.map(l=>({...T.Diagnostic.from(l),modelVersionId:this.g(i)}));w.push([i,o])}Ue(this,v,"f").$changeMany(this.e,w)}delete(b){this.h(),Ue(this,D,"f").fire([b]),Ue(this,E,"f").delete(b),Ue(this,v,"f")?.$changeMany(this.e,[[b,void 0]])}clear(){this.h(),Ue(this,D,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,E,"f").clear(),Ue(this,v,"f")?.$clear(this.e)}forEach(b,p){this.h();for(const[g,w]of this)b.call(p,g,w,this)}*[(v=new WeakMap,D=new WeakMap,E=new WeakMap,Symbol.iterator)](){this.h();for(const b of Ue(this,E,"f").keys())yield[b,this.get(b)]}get(b){this.h();const p=Ue(this,E,"f").get(b);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(b){return this.h(),Array.isArray(Ue(this,E,"f").get(b))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(b,p){return b[0].toString()<p[0].toString()?-1:b[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=d;let m=class wn{static _mapper(b){const p=new L.ResourceMap;for(const g of b)p.set(g,g);return{uris:Object.freeze(Array.from(p.values()))}}constructor(b,p,g,w){this.h=p,this.j=g,this.k=w,this.f=new Map,this.g=new S.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,wn._mapper),this.e=b.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,p){const{f:g,e:w,g:i,h:o,j:u,k:l}=this,s=new class{$changeMany(r,f){w.$changeMany(r,f),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,r,f.length===0?"CLEARING":f)}$clear(r){w.$clear(r),o.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,r)}dispose(){w.dispose()}};let a;if(!p)p="_generated_diagnostic_collection_name_#"+wn.c++,a=p;else if(!g.has(p))a=p;else{this.h.warn(`DiagnosticCollection with name '${p}' does already exist.`);do a=p+wn.c++;while(g.has(a))}return new class extends d{constructor(){super(p,a,wn.d,r=>l.getDocument(r)?.version,u.extUri,s,i),g.set(a,this)}dispose(){super.dispose(),g.delete(a)}}}getDiagnostics(b){if(b)return this.l(b);{const p=new Map,g=[];for(const w of this.f.values())w.forEach((i,o)=>{let u=p.get(i.toString());typeof u>"u"&&(u=g.length,p.set(i.toString(),u),g.push([i,[]])),g[u][1]=g[u][1].concat(...o)});return g}}l(b){let p=[];for(const g of this.f.values())g.has(b)&&(p=p.concat(g.get(b)));return p}$acceptMarkersChange(b){if(!this.m){const p="_generated_mirror",g=new d(p,p,wn.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(p,g),this.m=g}for(const[p,g]of b)this.m.set(k.URI.revive(p),g.map(T.Diagnostic.to))}};m.c=0,m.d=1e3,m=qe([He(1,y.ILogService),He(2,P.IExtHostFileSystemInfo)],m),e.ExtHostDiagnostics=m}),define(ye[248],Ce([1,0,2,5]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(C){this.a=C.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(T=>T?T.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(T=>T?c.URI.revive(T):void 0)}}e.ExtHostDialogs=k}),define(ye[249],Ce([1,0,10,2,7,5,15,21,8]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class y{constructor(P,v,D){this.d=v,this.e=D,this.b=new Map,this.c=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,v){if(Object.keys(C.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const D=y.a++;this.b.set(D,v),this.c.$registerTextContentProvider(D,P);let E;return typeof v.onDidChange=="function"&&(E=v.onDidChange(d=>{if(d.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(D,d).then(m=>{if(!m&&typeof m!="string")return;const h=this.d.getDocument(d);if(!h)return;const b=(0,S.splitLines)(m);if(!h.equalLines(b))return this.c.$onVirtualDocumentChange(d,m)},c.onUnexpectedError)})),new k.Disposable(()=>{this.b.delete(D)&&this.c.$unregisterTextContentProvider(D),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(P,v){const D=this.b.get(P);return D?Promise.resolve(D.provideTextDocumentContent(t.URI.revive(v),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=y,y.a=0}),define(ye[250],Ce([1,0,4,6,2,5,135,14,11,23,7]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(D,E){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=D.getProxy(A.MainContext.MainThreadDocuments),this.g=E,this.g.onDidRemoveDocuments(d=>{for(const m of d)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const m of d)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const E=this.g.getDocument(D);if(E)return E}getDocument(D){const E=this.getDocumentData(D);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return E.document}ensureDocumentData(D){const E=this.g.getDocument(D);if(E)return Promise.resolve(E);let d=this.h.get(D.toString());return d||(d=this.f.$tryOpenDocument(D).then(m=>{this.h.delete(D.toString());const h=k.URI.revive(m);return(0,S.assertIsDefined)(this.g.getDocument(h))},m=>(this.h.delete(D.toString()),Promise.reject(m))),this.h.set(D.toString(),d)),d}createDocumentData(D){return this.f.$tryCreateDocument(D).then(E=>k.URI.revive(E))}$acceptModelLanguageChanged(D,E){const d=k.URI.revive(D),m=this.g.getDocument(d);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(E),this.a.fire(m.document)}$acceptModelSaved(D){const E=k.URI.revive(D),d=this.g.getDocument(E);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(D,E){const d=k.URI.revive(D),m=this.g.getDocument(d);if(!m)throw new Error("unknown document");m._acceptIsDirty(E),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,E,d){const m=k.URI.revive(D),h=this.g.getDocument(m);if(!h)throw new Error("unknown document");h._acceptIsDirty(d),h.onEvents(E);let b;E.isUndoing?b=L.TextDocumentChangeReason.Undo:E.isRedoing&&(b=L.TextDocumentChangeReason.Redo),this.c.fire((0,y.deepFreeze)({document:h.document,contentChanges:E.changes.map(p=>({range:T.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text})),reason:b}))}setWordDefinitionFor(D,E){(0,C.setWordDefinitionFor)(D,E)}}e.ExtHostDocuments=P}),define(ye[58],Ce([1,0,49,4,6,2,3,5,135,16,138,14,13,28,15,62,82]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(g){this.value=g,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let b=class{constructor(g,w){this.h=g,this.i=w,this.a=null,this.b=new Map,this.c=new D.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const w=[],i=[],o=[];if(g.removedDocuments)for(const u of g.removedDocuments){const l=A.URI.revive(u),s=this.c.get(l);s?.unref()&&(this.c.delete(l),w.push(s.value))}if(g.addedDocuments)for(const u of g.addedDocuments){const l=A.URI.revive(u.uri);let s=this.c.get(l);if(s&&l.scheme!==E.Schemas.vscodeNotebookCell&&l.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);s||(s=new h(new S.ExtHostDocumentData(this.h.getProxy(T.MainContext.MainThreadDocuments),l,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(l,s),i.push(s.value)),s.ref()}if(g.removedEditors)for(const u of g.removedEditors){const l=this.b.get(u);this.b.delete(u),l&&o.push(l)}if(g.addedEditors)for(const u of g.addedEditors){const l=A.URI.revive(u.documentUri);c.ok(this.c.has(l),`document '${l}' does not exist`),c.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const s=this.c.get(l).value,a=new L.ExtHostTextEditor(u.id,this.h.getProxy(T.MainContext.MainThreadTextEditors),this.i,new m.Lazy(()=>s.document),u.selections.map(P.Selection.to),u.options,u.visibleRanges.map(n=>P.Range.to(n)),typeof u.editorPosition=="number"?P.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,a)}g.newActiveEditor!==void 0&&(c.ok(g.newActiveEditor===null||this.b.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this.a=g.newActiveEditor),(0,k.dispose)(w),(0,k.dispose)(o),g.removedDocuments&&this.e.fire(w),g.addedDocuments&&this.d.fire(i),(g.removedEditors||g.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),g.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(g){return this.c.get(g)?.value}allDocuments(){return d.Iterable.map(this.c.values(),g=>g.value)}getEditor(g){return this.b.get(g)}activeEditor(g){if(!this.a)return;const w=this.b.get(this.a);return g?w:w?.value}allEditors(){return[...this.b.values()]}};b=qe([He(0,y.IExtHostRpcService),He(1,v.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[59],Ce([1,0,14,5,2,4,3,7,16,11,81]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class P{constructor(m,h,b){this.e=b,this.d=h,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,h={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.TextTabInput(k.URI.revive(this.b.input.uri));case 2:return new T.TextDiffTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified));case 3:return new T.TextMergeTabInput(k.URI.revive(this.b.input.base),k.URI.revive(this.b.input.input1),k.URI.revive(this.b.input.input2),k.URI.revive(this.b.input.result));case 6:return new T.CustomEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.WebviewEditorTabInput(this.b.input.viewType);case 4:return new T.NotebookEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(k.URI.revive(this.b.input.uri),k.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(m,h){this.c=[],this.d="",this.b=m,this.e=h;for(const b of m.tabs)b.isActive&&(this.d=b.id),this.c.push(new P(b,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,h={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return c.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(b=>b.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(b=>b.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const b=new P(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,b),m.tabDto.isActive&&(this.d=b.tabId),b}else if(m.kind===1){const b=this.c.splice(m.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return b.tabId===this.d&&(this.d=""),b}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this.c.splice(m.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,b),b}const h=this.c.find(b=>b.tabId===m.tabDto.id);if(!h)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(m.tabDto),h}activeTabId(){return this.d}}let D=class{constructor(m){this.b=new A.Emitter,this.c=new A.Emitter,this.e=[],this.a=m.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,h={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(b=>b.apiObject))},get activeTabGroup(){const b=m.d;return(0,y.assertIsDefined)(m.e.find(g=>g.groupId===b)?.apiObject)},close:async(b,p)=>{const g=Array.isArray(b)?b:[b];return g.length?E(g[0])?this.j(g,p):this.i(g,p):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(m){const h=new Set(this.e.map(u=>u.groupId)),b=new Set(m.map(u=>u.groupId)),p=(0,L.diffSets)(h,b),g=this.e.filter(u=>p.removed.includes(u.groupId)).map(u=>u.apiObject),w=[],i=[];this.e=m.map(u=>{const l=new v(u,()=>this.d);return p.added.includes(l.groupId)?w.push(l.apiObject):i.push(l.apiObject),l});const o=(0,y.assertIsDefined)(m.find(u=>u.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:w,closed:g,changed:i}))}$acceptTabGroupUpdate(m){const h=this.e.find(b=>b.groupId===m.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const h=this.e.find(p=>p.groupId===m.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const b=h.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}g(m){for(const h of this.e)for(const b of h.tabs)if(b.apiObject===m)return b}h(m){return this.e.find(h=>h.apiObject===m)}async i(m,h){const b=[];for(const p of m){const g=this.g(p);if(!g)throw new Error("Tab close: Invalid tab not found!");b.push(g.tabId)}return this.a.$closeTab(b,h)}async j(m,h){const b=[];for(const p of m){const g=this.h(p);if(!g)throw new Error("Group close: Invalid group not found!");b.push(g.groupId)}return this.a.$closeGroup(b,h)}};D=qe([He(0,S.IExtHostRpcService)],D),e.ExtHostEditorTabs=D;function E(d){return d.tabs!==void 0}}),define(ye[251],Ce([1,0,2,5,6,7,14,153,8,22,26]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(E){this.b=void 0,this.a.push(E)}delete(E){const d=this.a.indexOf(E);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const E=this.a.sort(),d=[];let m,h,b=14,p=14;for(const g of E){let w=m?(0,S.commonPrefixLength)(m,g):0;for(w===0?h=1:h=p;w<g.length;w++)w+1===g.length?(b=p,p=9):p+=1,d.push([h,g.toUpperCase().charCodeAt(w),p]),d.push([h,g.toLowerCase().charCodeAt(w),p]),h=p;m=g,p=b}d.push([9,58,10]),d.push([10,47,12]),this.b=new T.StateMachine(d)}}provideDocumentLinks(E){this.c();const d=[],m=T.LinkComputer.computeLinks({getLineContent(h){return E.lineAt(h-1).text},getLineCount(){return E.lineCount}},this.b);for(const h of m){const b=C.DocumentLink.to(h);b.target&&d.push(b)}return d}}class v{constructor(E,d){this.i=d,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=E.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(E,d,m,h={}){if(this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(E,"*",this.b));const b=this.h++;this.b.add(d),this.d.add(d),this.c.set(b,m);let p=2;h.isCaseSensitive&&(p+=1024),h.isReadonly&&(p+=2048),typeof m.copy=="function"&&(p+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&((0,L.checkProposedApiEnabled)(E,"fsChunks"),p+=4),this.a.$registerFileSystemProvider(b,d,p).catch(w=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${d}`),console.error(w)});const g=m.onDidChangeFile(w=>{const i=[];for(const o of w){const{uri:u,type:l}=o;if(u.scheme!==d)continue;let s;switch(l){case A.FileChangeType.Changed:s=0;break;case A.FileChangeType.Created:s=1;break;case A.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:u,type:s})}this.a.$onFileSystemChange(b,i)});return(0,k.toDisposable)(()=>{g.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(E){const{type:d,ctime:m,mtime:h,size:b,permissions:p}=E;return{type:d,ctime:m,mtime:h,size:b,permissions:p}}$stat(E,d){return Promise.resolve(this.k(E).stat(c.URI.revive(d))).then(m=>v.j(m))}$readdir(E,d){return Promise.resolve(this.k(E).readDirectory(c.URI.revive(d)))}$readFile(E,d){return Promise.resolve(this.k(E).readFile(c.URI.revive(d))).then(m=>y.VSBuffer.wrap(m))}$writeFile(E,d,m,h){return Promise.resolve(this.k(E).writeFile(c.URI.revive(d),m.buffer,h))}$delete(E,d,m){return Promise.resolve(this.k(E).delete(c.URI.revive(d),m))}$rename(E,d,m,h){return Promise.resolve(this.k(E).rename(c.URI.revive(d),c.URI.revive(m),h))}$copy(E,d,m,h){const b=this.k(E);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(c.URI.revive(d),c.URI.revive(m),h))}$mkdir(E,d){return Promise.resolve(this.k(E).createDirectory(c.URI.revive(d)))}$watch(E,d,m,h){const b=this.k(E).watch(c.URI.revive(m),h);this.f.set(d,b)}$unwatch(E,d){const m=this.f.get(d);m&&(m.dispose(),this.f.delete(d))}$open(E,d,m){const h=this.k(E);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(c.URI.revive(d),m))}$close(E,d){const m=this.k(E);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(d))}$read(E,d,m,h){const b=this.k(E);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const p=y.VSBuffer.alloc(h);return Promise.resolve(b.read(d,m,p.buffer,0,h)).then(g=>p.slice(0,g))}$write(E,d,m,h){const b=this.k(E);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(d,m,h.buffer,0,h.byteLength))}k(E){const d=this.c.get(E);if(!d){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return d}}e.ExtHostFileSystem=v}),define(ye[72],Ce([1,0,5,38,7,22,3,16,47,6]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Jt{constructor(v,D){this.b=new Map,this.a=v.getProxy(c.MainContext.MainThreadFileSystem);const E=this;this.value=Object.freeze({async stat(d){try{const m=E.b.get(d.scheme);if(!m)return await E.a.$stat(d);await E.a.$ensureActivation(d.scheme);const h=await m.stat(d);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(m){Jt.c(m)}},async readDirectory(d){try{const m=E.b.get(d.scheme);return m?(await E.a.$ensureActivation(d.scheme),(await m.readDirectory(d)).slice()):await E.a.$readdir(d)}catch(m){return Jt.c(m)}},async createDirectory(d){try{return await E.a.$mkdir(d)}catch(m){return Jt.c(m)}},async readFile(d){try{const m=E.b.get(d.scheme);return m?(await E.a.$ensureActivation(d.scheme),(await m.readFile(d)).slice()):(await E.a.$readFile(d)).buffer}catch(m){return Jt.c(m)}},async writeFile(d,m){try{return await E.a.$writeFile(d,A.VSBuffer.wrap(m))}catch(h){return Jt.c(h)}},async delete(d,m){try{const h=E.b.get(d.scheme);return h?(await E.a.$ensureActivation(d.scheme),await h.delete(d,{recursive:!1,...m})):await E.a.$delete(d,{recursive:!1,useTrash:!1,...m})}catch(h){return Jt.c(h)}},async rename(d,m,h){try{return await E.a.$rename(d,m,{overwrite:!1,...h})}catch(b){return Jt.c(b)}},async copy(d,m,h){try{return await E.a.$copy(d,m,{overwrite:!1,...h})}catch(b){return Jt.c(b)}},isWritableFileSystem(d){const m=D.getCapabilities(d);if(typeof m=="number")return!(m&2048)}})}static c(v){if(v instanceof k.FileSystemError)throw v;if(!(v instanceof Error))throw new k.FileSystemError(String(v));if(v.name==="ENOPRO")throw k.FileSystemError.Unavailable(v.message);switch(v.name){case t.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(v.message);case t.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(v.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(v.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(v.message);case t.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(v.message);case t.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(v.message);default:throw new k.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,D){return this.b.set(v,D),(0,y.toDisposable)(()=>this.b.delete(v))}};L=qe([He(0,T.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[252],Ce([1,0,4,37,2,5,14,7]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,v,D,E,d,m,h,b){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter;const p=this.h(P,D,d);this.g=0,m&&(this.g+=1),h&&(this.g+=2),b&&(this.g+=4);const g=(0,t.parse)(d),w=typeof d=="string",i=E(o=>{if(!m)for(const u of o.created){const l=k.URI.revive(u);g(l.fsPath)&&(!w||v.getWorkspaceFolder(l))&&this.a.fire(l)}if(!h)for(const u of o.changed){const l=k.URI.revive(u);g(l.fsPath)&&(!w||v.getWorkspaceFolder(l))&&this.b.fire(l)}if(!b)for(const u of o.deleted){const l=k.URI.revive(u);g(l.fsPath)&&(!w||v.getWorkspaceFolder(l))&&this.c.fire(l)}});this.d=T.Disposable.from(p,this.a,this.b,this.c,i)}h(P,v,D){const E=T.Disposable.from();if(typeof D=="string")return E;const d=P.getProxy(A.MainContext.MainThreadFileSystem);let m=!1;(D.pattern.includes(t.GLOBSTAR)||D.pattern.includes(t.GLOB_SPLIT))&&(m=!0);const h=Math.random();return d.$watch(v.identifier.value,h,D.baseUri,{recursive:m,excludes:[]}),T.Disposable.from({dispose:()=>d.$unwatch(h)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class y{constructor(P,v,D){this.j=P,this.k=v,this.l=D,this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.g=new c.AsyncEmitter,this.h=new c.AsyncEmitter,this.i=new c.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,v,D,E,d,m){return new S(this.j,P,v,this.a.event,C.GlobPattern.from(D),E,d,m)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,v){switch(P){case 2:this.b.fire(Object.freeze({files:v.map(D=>({oldUri:k.URI.revive(D.source),newUri:k.URI.revive(D.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(D=>k.URI.revive(D.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(D=>k.URI.revive(D.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,v){return(D,E,d)=>{const m=function(b){D.call(E,b)};return m.extension=P,v.event(m,void 0,d)}}async $onWillRunFileOperation(P,v,D,E){switch(P){case 2:return await this.n(this.g,{files:v.map(d=>({oldUri:k.URI.revive(d.source),newUri:k.URI.revive(d.target)}))},D,E);case 1:return await this.n(this.i,{files:v.map(d=>k.URI.revive(d.target))},D,E);case 0:case 3:return await this.n(this.h,{files:v.map(d=>k.URI.revive(d.target))},D,E)}}async n(P,v,D,E){const d=new Set,m=[];if(await P.fireAsync(v,E,async(b,p)=>{const g=Date.now(),w=await Promise.resolve(b);w instanceof T.WorkspaceEdit&&(m.push([p.extension,w]),d.add(p.extension.displayName??p.extension.identifier.value)),Date.now()-g>D&&this.k.warn("SLOW file-participant",p.extension.identifier)}),E.isCancellationRequested||m.length===0)return;const h={edits:[]};for(const[,b]of m){const{edits:p}=C.WorkspaceEdit.from(b,{getTextDocumentVersion:g=>this.l.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(p)}return{edit:h,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=y}),define(ye[253],Ce([1,0,2,39]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(C,T,S,y,L){this.a=T,this.b=S,this.c=y;const P=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new t.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new t.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new t.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new t.ApiCommandResult("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const D=this.a.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:c.URI.revive(v.notebookUri),inputUri:c.URI.revive(v.inputUri),notebookEditor:D.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:c.URI.revive(v.notebookUri),inputUri:c.URI.revive(v.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(C,T,S,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(c.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=k}),define(ye[254],Ce([1,0,6,5]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(C){this.b=0,this.a=C.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,C),(0,c.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=k}),define(ye[255],Ce([1,0,2,23,14,7,66,5,8,35,17,11,149,21,6,119,100,69,42,10,18,26]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(O,W){this.d=O,this.e=W}async provideDocumentSymbols(O,W){const K=this.d.getDocument(O),Y=await this.e.provideDocumentSymbols(K,W);if(!(0,L.isFalsyOrEmpty)(Y))return Y[0]instanceof A.DocumentSymbol?Y.map(k.DocumentSymbol.from):i.f(Y)}static f(O){O=O.slice(0).sort((Y,de)=>{let be=Y.location.range.start.compareTo(de.location.range.start);return be===0&&(be=de.location.range.end.compareTo(Y.location.range.end)),be});const W=[],K=[];for(const Y of O){const de={name:Y.name||"!!MISSING: name!!",kind:k.SymbolKind.from(Y.kind),tags:Y.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:k.Range.from(Y.location.range),selectionRange:k.Range.from(Y.location.range),children:[]};for(;;){if(K.length===0){K.push(de),W.push(de);break}const be=K[K.length-1];if(y.Range.containsRange(be.range,de.range)&&!y.Range.equalsRange(be.range,de.range)){be.children?.push(de),K.push(de);break}K.pop()}}return W}}class o{constructor(O,W,K){this.g=O,this.h=W,this.j=K,this.e=new h.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(O,W){const K=this.g.getDocument(O),Y=await this.j.provideCodeLenses(K,W);if(!Y||W.isCancellationRequested)return;const de=this.e.add(Y),be=new E.DisposableStore;this.f.set(de,be);const Pe={cacheId:de,lenses:[]};for(let pe=0;pe<Y.length;pe++)Pe.lenses.push({cacheId:[de,pe],range:k.Range.from(Y[pe].range),command:this.h.toInternal(Y[pe].command,be)});return Pe}async resolveCodeLens(O,W){const K=O.cacheId&&this.e.get(...O.cacheId);if(!K)return;let Y;if(typeof this.j.resolveCodeLens!="function"||K.isResolved?Y=K:Y=await this.j.resolveCodeLens(K,W),Y||(Y=K),W.isCancellationRequested)return;const de=O.cacheId&&this.f.get(O.cacheId[0]);if(!!de)return O.command=this.h.toInternal(Y.command??o.d,de),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}o.d={command:"missing",title:"!!MISSING: command!!"};function u(ie){return Array.isArray(ie)?ie.map(k.DefinitionLink.from):ie?[k.DefinitionLink.from(ie)]:[]}class l{constructor(O,W){this.d=O,this.e=W}async provideDefinition(O,W,K){const Y=this.d.getDocument(O),de=k.Position.to(W),be=await this.e.provideDefinition(Y,de,K);return u(be)}}class s{constructor(O,W){this.d=O,this.e=W}async provideDeclaration(O,W,K){const Y=this.d.getDocument(O),de=k.Position.to(W),be=await this.e.provideDeclaration(Y,de,K);return u(be)}}class a{constructor(O,W){this.d=O,this.e=W}async provideImplementation(O,W,K){const Y=this.d.getDocument(O),de=k.Position.to(W),be=await this.e.provideImplementation(Y,de,K);return u(be)}}class n{constructor(O,W){this.d=O,this.e=W}async provideTypeDefinition(O,W,K){const Y=this.d.getDocument(O),de=k.Position.to(W),be=await this.e.provideTypeDefinition(Y,de,K);return u(be)}}class r{constructor(O,W){this.d=O,this.e=W}async provideHover(O,W,K){const Y=this.d.getDocument(O),de=k.Position.to(W),be=await this.e.provideHover(Y,de,K);if(!(!be||(0,L.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=Y.getWordRangeAtPosition(de)),be.range||(be.range=new A.Range(de,de)),k.Hover.from(be)}}class f{constructor(O,W){this.d=O,this.e=W}async provideEvaluatableExpression(O,W,K){const Y=this.d.getDocument(O),de=k.Position.to(W),be=await this.e.provideEvaluatableExpression(Y,de,K);if(be)return k.EvaluatableExpression.from(be)}}class I{constructor(O,W){this.d=O,this.e=W}async provideInlineValues(O,W,K,Y){const de=this.d.getDocument(O),be=await this.e.provideInlineValues(de,k.Range.to(W),k.InlineValueContext.to(K),Y);if(Array.isArray(be))return be.map(Pe=>k.InlineValue.from(Pe))}}class R{constructor(O,W){this.d=O,this.e=W}async provideDocumentHighlights(O,W,K){const Y=this.d.getDocument(O),de=k.Position.to(W),be=await this.e.provideDocumentHighlights(Y,de,K);if(Array.isArray(be))return be.map(k.DocumentHighlight.from)}}class B{constructor(O,W){this.d=O,this.e=W}async provideLinkedEditingRanges(O,W,K){const Y=this.d.getDocument(O),de=k.Position.to(W),be=await this.e.provideLinkedEditingRanges(Y,de,K);if(be&&Array.isArray(be.ranges))return{ranges:(0,L.coalesce)(be.ranges.map(k.Range.from)),wordPattern:be.wordPattern}}}class X{constructor(O,W){this.d=O,this.e=W}async provideReferences(O,W,K,Y){const de=this.d.getDocument(O),be=k.Position.to(W),Pe=await this.e.provideReferences(de,be,K,Y);if(Array.isArray(Pe))return Pe.map(k.location.from)}}class q{constructor(O,W,K,Y,de,be,Pe){this.g=O,this.h=W,this.j=K,this.k=Y,this.l=de,this.m=be,this.n=Pe,this.e=new h.Cache("CodeAction"),this.f=new Map}async provideCodeActions(O,W,K,Y){const de=this.g.getDocument(O),be=v.Selection.isISelection(W)?k.Selection.to(W):k.Range.to(W),Pe=[];for(const et of this.j.getDiagnostics(O))if(be.intersection(et.range)&&Pe.push(et)>q.d)break;const pe={diagnostics:Pe,only:K.only?new A.CodeActionKind(K.only):void 0,triggerKind:k.CodeActionTriggerKind.to(K.trigger)},De=await this.k.provideCodeActions(de,be,pe,Y);if(!(0,L.isNonEmptyArray)(De)||Y.isCancellationRequested)return;const ke=this.e.add(De),je=new E.DisposableStore;this.f.set(ke,je);const Ge=[];for(let et=0;et<De.length;et++){const _e=De[et];!_e||(q.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,je)})):(pe.only&&(_e.kind?pe.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,et],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,je),diagnostics:_e.diagnostics&&_e.diagnostics.map(k.Diagnostic.from),edit:_e.edit&&k.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(O,W){const[K,Y]=O,de=this.e.get(K,Y);if(!de||q.o(de)||!this.k.resolveCodeAction)return;const be=await this.k.resolveCodeAction(de,W)??de;return be?.edit?k.WorkspaceEdit.from(be.edit,void 0):void 0}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}q.d=1e3;class N{constructor(O,W,K,Y){this.d=O,this.e=W,this.f=K,this.g=Y}async prepareDocumentPaste(O,W,K,Y){if(!this.f.prepareDocumentPaste)return;const de=this.e.getDocument(O),be=W.map(pe=>k.Range.to(pe)),Pe=k.DataTransfer.toDataTransfer(K,()=>{throw new p.NotImplementedError});return await this.f.prepareDocumentPaste(de,be,Pe,Y),k.DataTransfer.toDataTransferDTO(Pe)}async providePasteEdits(O,W,K,Y,de){const be=this.e.getDocument(W),Pe=K.map(ke=>k.Range.to(ke)),pe=k.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolvePasteFileData(this.g,O,ke)).buffer),De=await this.f.provideDocumentPasteEdits(be,Pe,pe,de);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?k.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class M{constructor(O,W){this.d=O,this.e=W}async provideDocumentFormattingEdits(O,W,K){const Y=this.d.getDocument(O),de=await this.e.provideDocumentFormattingEdits(Y,W,K);if(Array.isArray(de))return de.map(k.TextEdit.from)}}class F{constructor(O,W){this.d=O,this.e=W}async provideDocumentRangeFormattingEdits(O,W,K,Y){const de=this.d.getDocument(O),be=k.Range.to(W),Pe=await this.e.provideDocumentRangeFormattingEdits(de,be,K,Y);if(Array.isArray(Pe))return Pe.map(k.TextEdit.from)}}class z{constructor(O,W){this.d=O,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,W,K,Y,de){const be=this.d.getDocument(O),Pe=k.Position.to(W),pe=await this.e.provideOnTypeFormattingEdits(be,Pe,K,Y,de);if(Array.isArray(pe))return pe.map(k.TextEdit.from)}}class U{constructor(O,W){this.e=O,this.f=W,this.d=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,W){const K=await this.e.provideWorkspaceSymbols(O,W);if(!(0,L.isNonEmptyArray)(K))return{symbols:[]};const Y=this.d.add(K),de={cacheId:Y,symbols:[]};for(let be=0;be<K.length;be++){const Pe=K[be];if(!Pe||!Pe.name){this.f.warn("INVALID SymbolInformation",Pe);continue}de.symbols.push({...k.WorkspaceSymbol.from(Pe),cacheId:[Y,be]})}return de}async resolveWorkspaceSymbol(O,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const K=this.d.get(...O.cacheId);if(K){const Y=await this.e.resolveWorkspaceSymbol(K,W);return Y&&(0,t.mixin)(O,k.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class H{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,W,K){this.d=O,this.e=W,this.f=K}async provideRenameEdits(O,W,K,Y){const de=this.d.getDocument(O),be=k.Position.to(W);try{const Pe=await this.e.provideRenameEdits(de,be,K,Y);return Pe?k.WorkspaceEdit.from(Pe):void 0}catch(Pe){const pe=H.g(Pe);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Pe)}}async resolveRenameLocation(O,W,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(O),de=k.Position.to(W);try{const be=await this.e.prepareRename(Y,de,K);let Pe,pe;if(A.Range.isRange(be)?(Pe=be,pe=Y.getText(be)):(0,P.isObject)(be)&&(Pe=be.range,pe=be.placeholder),!Pe||!pe)return;if(Pe.start.line>de.line||Pe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(Pe),text:pe}}catch(be){const Pe=H.g(be);return Pe?{rejectReason:Pe,range:void 0,text:void 0}:Promise.reject(be)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class x{constructor(O,W){this.resultId=O,this.tokens=W}}class V{constructor(O,W){this.f=O,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,W,K){const Y=this.f.getDocument(O),de=W!==0?this.d.get(W):null;let be=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,de.resultId,K):await this.g.provideDocumentSemanticTokens(Y,K);return de&&this.d.delete(W),be?(be=V.h(be),this.o(V.n(de,be),be)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return V.j(O)?V.k(O)?O:new A.SemanticTokens(new Uint32Array(O.data),O.resultId):V.l(O)?V.m(O)?O:new A.SemanticTokensEdits(O.edits.map(W=>new A.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const W of O.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(O,W){if(!V.j(W)||!O||!O.tokens)return W;const K=O.tokens,Y=K.length,de=W.data,be=de.length;let Pe=0;const pe=Math.min(Y,be);for(;Pe<pe&&K[Pe]===de[Pe];)Pe++;if(Pe===Y&&Pe===be)return new A.SemanticTokensEdits([],W.resultId);let De=0;const ke=pe-Pe;for(;De<ke&&K[Y-De-1]===de[be-De-1];)De++;return new A.SemanticTokensEdits([{start:Pe,deleteCount:Y-Pe-De,data:de.subarray(Pe,be-De)}],W.resultId)}o(O,W){if(V.j(O)){const K=this.e++;return this.d.set(K,new x(O.resultId,O.data)),(0,d.encodeSemanticTokensDto)({id:K,type:"full",data:O.data})}if(V.l(O)){const K=this.e++;return V.j(W)?this.d.set(K,new x(W.resultId,W.data)):this.d.set(K,new x(O.resultId)),(0,d.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(O.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class _{constructor(O,W){this.d=O,this.e=W}async provideDocumentRangeSemanticTokens(O,W,K){const Y=this.d.getDocument(O),de=await this.e.provideDocumentRangeSemanticTokens(Y,k.Range.to(W),K);return de?this.f(de):null}f(O){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class Q{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,W,K,Y,de){this.f=O,this.g=W,this.h=K,this.j=Y,this.k=de,this.d=new h.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(O,W,K,Y){const de=this.f.getDocument(O),be=k.Position.to(W),Pe=de.getWordRangeAtPosition(be)||new A.Range(be,be),pe=Pe.with({end:be}),De=new b.StopWatch(!0),ke=await this.h.provideCompletionItems(de,be,Y,k.CompletionContext.to(K));if(!ke||Y.isCancellationRequested)return;const je=Array.isArray(ke)?new A.CompletionList(ke):ke,Ge=Q.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),et=new E.DisposableStore;this.e.set(Ge,et);const _e=[],nt={x:Ge,b:_e,a:{replace:k.Range.from(Pe),insert:k.Range.from(pe)},c:je.isIncomplete||void 0,d:De.elapsed()};for(let st=0;st<je.items.length;st++){const ht=je.items[st],Me=this.l(ht,[Ge,st],pe,Pe);_e.push(Me)}return nt}async resolveCompletionItem(O,W){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...O);if(!K)return;const Y=await this.h.resolveCompletionItem(K,W);if(!!Y)return this.l(Y,O)}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,W,K,Y){const de=this.e.get(W[0]);if(!de)throw Error("DisposableStore is missing...");const be=this.g.toInternal(O.command,de),Pe={x:W,a:O.label,b:O.kind!==void 0?k.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(k.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:k.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(k.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Pe.h=O.textEdit.newText):typeof O.insertText=="string"?Pe.h=O.insertText:O.insertText instanceof A.SnippetString&&(Pe.h=O.insertText.value,Pe.i|=4);let pe;return O.textEdit?pe=O.textEdit.range:O.range&&(pe=O.range),A.Range.isRange(pe)?Pe.j=k.Range.from(pe):pe&&(!K?.isEqual(pe.inserting)||!Y?.isEqual(pe.replacing))&&(Pe.j={insert:k.Range.from(pe.inserting),replace:k.Range.from(pe.replacing)}),Pe}}class Z{async provideInlineCompletions(O,W,K,Y){}disposeCompletions(O){}handleDidShowCompletionItem(O,W){}}class ge extends Z{constructor(O,W,K,Y){super(),this.f=O,this.g=W,this.h=K,this.j=Y,this.d=new te,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,W,K,Y){const de=this.g.getDocument(O),be=k.Position.to(W),Pe=await this.h.provideInlineCompletionItems(de,be,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:k.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},Y);if(!Pe||Y.isCancellationRequested)return;const pe=Array.isArray(Pe)?Pe:Pe.items,De=this.e?Array.isArray(Pe)?[]:Pe.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:pe}),items:pe.map((Ge,et)=>{let _e;Ge.command&&(ke||(ke=new E.DisposableStore),_e=this.j.toInternal(Ge.command,ke));const nt=Ge.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ge.filterText,range:Ge.range?k.Range.from(Ge.range):void 0,command:_e,idx:et,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:De.map(Ge=>(ke||(ke=new E.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,W){const K=this.d.get(O)?.items[W];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K)}}class te{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const W=this.e++;return this.d.set(W,O),W}disposeReferenceId(O){const W=this.d.get(O);return this.d.delete(O),W}get(O){return this.d.get(O)}}class J{constructor(O,W){this.e=O,this.f=W,this.d=new h.Cache("SignatureHelp")}async provideSignatureHelp(O,W,K,Y){const de=this.e.getDocument(O),be=k.Position.to(W),Pe=this.g(K),pe=await this.f.provideSignatureHelp(de,be,Y,Pe);if(pe){const De=this.d.add([pe]);return{...k.SignatureHelp.from(pe),id:De}}}g(O){let W;if(O.activeSignatureHelp){const K=k.SignatureHelp.to(O.activeSignatureHelp),Y=this.d.get(O.activeSignatureHelp.id,0);Y?(W=Y,W.activeSignature=K.activeSignature,W.activeParameter=K.activeParameter):W=K}return{...O,activeSignatureHelp:W}}releaseSignatureHelp(O){this.d.delete(O)}}class fe{constructor(O,W,K,Y,de){this.f=O,this.g=W,this.h=K,this.j=Y,this.k=de,this.d=new h.Cache("InlayHints"),this.e=new Map}async provideInlayHints(O,W,K){const Y=this.f.getDocument(O),de=k.Range.to(W),be=await this.h.provideInlayHints(Y,de,K);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${W}`);return}if(K.isCancellationRequested)return;const Pe=this.d.add(be);this.e.set(Pe,new E.DisposableStore);const pe={hints:[],cacheId:Pe};for(let De=0;De<be.length;De++)this.l(be[De],de)&&pe.hints.push(this.m(be[De],[Pe,De]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${W}`),pe}async resolveInlayHint(O,W){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...O);if(!K)return;const Y=await this.h.resolveInlayHint(K,W);if(!!Y&&!!this.l(Y))return this.m(Y,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,W){return O.label.length===0||Array.isArray(O.label)&&O.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(W&&!W.contains(O.position))}m(O,W){const K=this.e.get(W[0]);if(!K)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:W,tooltip:k.MarkdownString.fromStrict(O.tooltip),position:k.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(k.TextEdit.from),kind:O.kind&&k.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?Y.label=O.label:Y.label=O.label.map(de=>{const be={label:de.value};return be.tooltip=k.MarkdownString.fromStrict(de.tooltip),A.Location.isLocation(de.location)&&(be.location=k.location.from(de.location)),de.command&&(be.command=this.g.toInternal(de.command,K)),be}),Y}}class ve{constructor(O,W){this.e=O,this.f=W,this.d=new h.Cache("DocumentLink")}async provideLinks(O,W){const K=this.e.getDocument(O),Y=await this.f.provideDocumentLinks(K,W);if(!(!Array.isArray(Y)||Y.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(ve.g).map(k.DocumentLink.from)};{const de=this.d.add(Y),be={links:[],cacheId:de};for(let Pe=0;Pe<Y.length;Pe++){if(!ve.g(Y[Pe]))continue;const pe=k.DocumentLink.from(Y[Pe]);pe.cacheId=[de,Pe],be.links.push(pe)}return be}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,W){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...O);if(!K)return;const Y=await this.f.resolveDocumentLink(K,W);if(!(!Y||!ve.g(Y)))return k.DocumentLink.from(Y)}releaseLinks(O){this.d.delete(O)}}class Ee{constructor(O,W){this.d=O,this.e=W}async provideColors(O,W){const K=this.d.getDocument(O),Y=await this.e.provideDocumentColors(K,W);return Array.isArray(Y)?Y.map(be=>({color:k.Color.from(be.color),range:k.Range.from(be.range)})):[]}async provideColorPresentations(O,W,K){const Y=this.d.getDocument(O),de=k.Range.to(W.range),be=k.Color.to(W.color),Pe=await this.e.provideColorPresentations(be,{document:Y,range:de},K);if(!!Array.isArray(Pe))return Pe.map(k.ColorPresentation.from)}}class Ae{constructor(O,W){this.d=O,this.e=W}async provideFoldingRanges(O,W,K){const Y=this.d.getDocument(O),de=await this.e.provideFoldingRanges(Y,W,K);if(!!Array.isArray(de))return de.map(k.FoldingRange.from)}}class Fe{constructor(O,W,K){this.d=O,this.e=W,this.f=K}async provideSelectionRanges(O,W,K){const Y=this.d.getDocument(O),de=W.map(k.Position.to),be=await this.e.provideSelectionRanges(Y,de,K);if(!(0,L.isNonEmptyArray)(be))return[];if(be.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Pe=[];for(let pe=0;pe<de.length;pe++){const De=[];Pe.push(De);let ke=de[pe],je=be[pe];for(;;){if(!je.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(De.push(k.SelectionRange.from(je)),!je.parent)break;ke=je.range,je=je.parent}}return Pe}}class se{constructor(O,W){this.f=O,this.g=W,this.d=new m.IdGenerator(""),this.e=new Map}async prepareSession(O,W,K){const Y=this.f.getDocument(O),de=k.Position.to(W),be=await this.g.prepareCallHierarchy(Y,de,K);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(pe=>this.h(Pe,pe)):[this.h(Pe,be)]}async provideCallsTo(O,W,K){const Y=this.j(O,W);if(!Y)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(Y,K);if(!!de)return de.map(be=>({from:this.h(O,be.from),fromRanges:be.fromRanges.map(Pe=>k.Range.from(Pe))}))}async provideCallsFrom(O,W,K){const Y=this.j(O,W);if(!Y)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(Y,K);if(!!de)return de.map(be=>({to:this.h(O,be.to),fromRanges:be.fromRanges.map(Pe=>k.Range.from(Pe))}))}releaseSession(O){this.e.delete(O)}h(O,W){const K=this.e.get(O),Y=k.CallHierarchyItem.from(W,O,K.size.toString(36));return K.set(Y._itemId,W),Y}j(O,W){return this.e.get(O)?.get(W)}}class le{constructor(O,W){this.f=O,this.g=W,this.d=new m.IdGenerator(""),this.e=new Map}async prepareSession(O,W,K){const Y=this.f.getDocument(O),de=k.Position.to(W),be=await this.g.prepareTypeHierarchy(Y,de,K);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(pe=>this.h(Pe,pe)):[this.h(Pe,be)]}async provideSupertypes(O,W,K){const Y=this.j(O,W);if(!Y)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(Y,K);if(!!de)return de.map(be=>this.h(O,be))}async provideSubtypes(O,W,K){const Y=this.j(O,W);if(!Y)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(Y,K);if(!!de)return de.map(be=>this.h(O,be))}releaseSession(O){this.e.delete(O)}h(O,W){const K=this.e.get(O),Y=k.TypeHierarchyItem.from(W,O,K.size.toString(36));return K.set(Y._itemId,W),Y}j(O,W){return this.e.get(O)?.get(W)}}class ue{constructor(O,W,K,Y){this.d=O,this.e=W,this.f=K,this.g=Y}async provideDocumentOnDropEdits(O,W,K,Y,de){const be=this.e.getDocument(W),Pe=k.Position.to(K),pe=k.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,ke)).buffer),De=await this.f.provideDocumentDropEdits(be,Pe,pe,de);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?k.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class ee{constructor(O,W){this.adapter=O,this.extension=W}}class ae{constructor(O,W,K,Y,de,be,Pe,pe){this.g=W,this.h=K,this.j=Y,this.k=de,this.l=be,this.m=Pe,this.n=pe,this.f=new Map,this.e=O.getProxy(T.MainContext.MainThreadLanguageFeatures)}o(O){return k.DocumentSelector.from(O,this.g)}p(O){return new A.Disposable(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return ae.d++}async s(O,W,K,Y,de,be=!1){const Pe=this.f.get(O);if(!Pe||!(Pe.adapter instanceof W))return Y;const pe=Date.now();be||this.l.trace(`[${Pe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const De=K(Pe.adapter,Pe.extension);return Promise.resolve(De).catch(ke=>{(0,p.isCancellationError)(ke)||(this.l.error(`[${Pe.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Pe.extension.identifier,ke))}).finally(()=>{be||this.l.trace(`[${Pe.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),D.CancellationToken.isCancellationToken(de)?(0,g.raceCancellationError)(De,de):De}t(O,W){const K=this.q();return this.f.set(K,new ee(O,W)),K}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,W,K,Y){const de=this.t(new i(this.h,K),O),be=Y&&Y.label||ae.u(O);return this.e.$registerDocumentSymbolProvider(de,this.o(W),be),this.p(de)}$provideDocumentSymbols(O,W,K){return this.s(O,i,Y=>Y.provideDocumentSymbols(c.URI.revive(W),K),void 0,K)}registerCodeLensProvider(O,W,K){const Y=this.q(),de=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new ee(new o(this.h,this.j.converter,K),O)),this.e.$registerCodeLensSupport(Y,this.o(W),de);let be=this.p(Y);if(de!==void 0){const Pe=K.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(de));be=A.Disposable.from(be,Pe)}return be}$provideCodeLenses(O,W,K){return this.s(O,o,Y=>Y.provideCodeLenses(c.URI.revive(W),K),void 0,K)}$resolveCodeLens(O,W,K){return this.s(O,o,Y=>Y.resolveCodeLens(W,K),void 0,void 0)}$releaseCodeLenses(O,W){this.s(O,o,K=>Promise.resolve(K.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(O,W,K){const Y=this.t(new l(this.h,K),O);return this.e.$registerDefinitionSupport(Y,this.o(W)),this.p(Y)}$provideDefinition(O,W,K,Y){return this.s(O,l,de=>de.provideDefinition(c.URI.revive(W),K,Y),[],Y)}registerDeclarationProvider(O,W,K){const Y=this.t(new s(this.h,K),O);return this.e.$registerDeclarationSupport(Y,this.o(W)),this.p(Y)}$provideDeclaration(O,W,K,Y){return this.s(O,s,de=>de.provideDeclaration(c.URI.revive(W),K,Y),[],Y)}registerImplementationProvider(O,W,K){const Y=this.t(new a(this.h,K),O);return this.e.$registerImplementationSupport(Y,this.o(W)),this.p(Y)}$provideImplementation(O,W,K,Y){return this.s(O,a,de=>de.provideImplementation(c.URI.revive(W),K,Y),[],Y)}registerTypeDefinitionProvider(O,W,K){const Y=this.t(new n(this.h,K),O);return this.e.$registerTypeDefinitionSupport(Y,this.o(W)),this.p(Y)}$provideTypeDefinition(O,W,K,Y){return this.s(O,n,de=>de.provideTypeDefinition(c.URI.revive(W),K,Y),[],Y)}registerHoverProvider(O,W,K,Y){const de=this.t(new r(this.h,K),O);return this.e.$registerHoverProvider(de,this.o(W)),this.p(de)}$provideHover(O,W,K,Y){return this.s(O,r,de=>de.provideHover(c.URI.revive(W),K,Y),void 0,Y)}registerEvaluatableExpressionProvider(O,W,K,Y){const de=this.t(new f(this.h,K),O);return this.e.$registerEvaluatableExpressionProvider(de,this.o(W)),this.p(de)}$provideEvaluatableExpression(O,W,K,Y){return this.s(O,f,de=>de.provideEvaluatableExpression(c.URI.revive(W),K,Y),void 0,Y)}registerInlineValuesProvider(O,W,K,Y){const de=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new I(this.h,K),O);this.e.$registerInlineValuesProvider(be,this.o(W),de);let Pe=this.p(be);if(de!==void 0){const pe=K.onDidChangeInlineValues(De=>this.e.$emitInlineValuesEvent(de));Pe=A.Disposable.from(Pe,pe)}return Pe}$provideInlineValues(O,W,K,Y,de){return this.s(O,I,be=>be.provideInlineValues(c.URI.revive(W),K,Y,de),void 0,de)}registerDocumentHighlightProvider(O,W,K){const Y=this.t(new R(this.h,K),O);return this.e.$registerDocumentHighlightProvider(Y,this.o(W)),this.p(Y)}$provideDocumentHighlights(O,W,K,Y){return this.s(O,R,de=>de.provideDocumentHighlights(c.URI.revive(W),K,Y),void 0,Y)}registerLinkedEditingRangeProvider(O,W,K){const Y=this.t(new B(this.h,K),O);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(W)),this.p(Y)}$provideLinkedEditingRanges(O,W,K,Y){return this.s(O,B,async de=>{const be=await de.provideLinkedEditingRanges(c.URI.revive(W),K,Y);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?ae.w(be.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(O,W,K){const Y=this.t(new X(this.h,K),O);return this.e.$registerReferenceSupport(Y,this.o(W)),this.p(Y)}$provideReferences(O,W,K,Y,de){return this.s(O,X,be=>be.provideReferences(c.URI.revive(W),K,Y,de),void 0,de)}registerCodeActionProvider(O,W,K,Y){const de=new E.DisposableStore,be=this.t(new q(this.h,this.j.converter,this.k,K,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(be,this.o(W),{providedKinds:Y?.providedCodeActionKinds?.map(Pe=>Pe.value),documentation:Y?.documentation?.map(Pe=>({kind:Pe.kind.value,command:this.j.converter.toInternal(Pe.command,de)}))},ae.u(O),Boolean(K.resolveCodeAction)),de.add(this.p(be)),de}$provideCodeActions(O,W,K,Y,de){return this.s(O,q,be=>be.provideCodeActions(c.URI.revive(W),K,Y,de),void 0,de)}$resolveCodeAction(O,W,K){return this.s(O,q,Y=>Y.resolveCodeAction(W,K),void 0,void 0)}$releaseCodeActions(O,W){this.s(O,q,K=>Promise.resolve(K.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(O,W,K){const Y=this.t(new M(this.h,K),O);return this.e.$registerDocumentFormattingSupport(Y,this.o(W),O.identifier,O.displayName||O.name),this.p(Y)}$provideDocumentFormattingEdits(O,W,K,Y){return this.s(O,M,de=>de.provideDocumentFormattingEdits(c.URI.revive(W),K,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(O,W,K){const Y=this.t(new F(this.h,K),O);return this.e.$registerRangeFormattingSupport(Y,this.o(W),O.identifier,O.displayName||O.name),this.p(Y)}$provideDocumentRangeFormattingEdits(O,W,K,Y,de){return this.s(O,F,be=>be.provideDocumentRangeFormattingEdits(c.URI.revive(W),K,Y,de),void 0,de)}registerOnTypeFormattingEditProvider(O,W,K,Y){const de=this.t(new z(this.h,K),O);return this.e.$registerOnTypeFormattingSupport(de,this.o(W),Y,O.identifier),this.p(de)}$provideOnTypeFormattingEdits(O,W,K,Y,de,be){return this.s(O,z,Pe=>Pe.provideOnTypeFormattingEdits(c.URI.revive(W),K,Y,de,be),void 0,be)}registerWorkspaceSymbolProvider(O,W){const K=this.t(new U(W,this.l),O);return this.e.$registerNavigateTypeSupport(K,typeof W.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(O,W,K){return this.s(O,U,Y=>Y.provideWorkspaceSymbols(W,K),{symbols:[]},K)}$resolveWorkspaceSymbol(O,W,K){return this.s(O,U,Y=>Y.resolveWorkspaceSymbol(W,K),void 0,void 0)}$releaseWorkspaceSymbols(O,W){this.s(O,U,K=>K.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(O,W,K){const Y=this.t(new H(this.h,K,this.l),O);return this.e.$registerRenameSupport(Y,this.o(W),H.supportsResolving(K)),this.p(Y)}$provideRenameEdits(O,W,K,Y,de){return this.s(O,H,be=>be.provideRenameEdits(c.URI.revive(W),K,Y,de),void 0,de)}$resolveRenameLocation(O,W,K,Y){return this.s(O,H,de=>de.resolveRenameLocation(c.URI.revive(W),K,Y),void 0,Y)}registerDocumentSemanticTokensProvider(O,W,K,Y){const de=this.t(new V(this.h,K),O),be=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(W),Y,be);let Pe=this.p(de);if(be){const pe=K.onDidChangeSemanticTokens(De=>this.e.$emitDocumentSemanticTokensEvent(be));Pe=A.Disposable.from(Pe,pe)}return Pe}$provideDocumentSemanticTokens(O,W,K,Y){return this.s(O,V,de=>de.provideDocumentSemanticTokens(c.URI.revive(W),K,Y),null,Y)}$releaseDocumentSemanticTokens(O,W){this.s(O,V,K=>K.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,W,K,Y){const de=this.t(new _(this.h,K),O);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(W),Y),this.p(de)}$provideDocumentRangeSemanticTokens(O,W,K,Y){return this.s(O,_,de=>de.provideDocumentRangeSemanticTokens(c.URI.revive(W),K,Y),null,Y)}registerCompletionItemProvider(O,W,K,Y){const de=this.t(new Q(this.h,this.j.converter,K,this.m,O),O);return this.e.$registerCompletionsProvider(de,this.o(W),Y,Q.supportsResolving(K),`${O.identifier.value}(${Y.join("")})`),this.p(de)}$provideCompletionItems(O,W,K,Y,de){return this.s(O,Q,be=>be.provideCompletionItems(c.URI.revive(W),K,Y,de),void 0,de)}$resolveCompletionItem(O,W,K){return this.s(O,Q,Y=>Y.resolveCompletionItem(W,K),void 0,K)}$releaseCompletionItems(O,W){this.s(O,Q,K=>K.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(O,W,K){const Y=new ge(O,this.h,K,this.j.converter),de=this.t(Y,O);return this.e.$registerInlineCompletionsSupport(de,this.o(W),Y.supportsHandleDidShowCompletionItem),this.p(de)}$provideInlineCompletions(O,W,K,Y,de){return this.s(O,Z,be=>be.provideInlineCompletions(c.URI.revive(W),K,Y,de),void 0,de)}$handleInlineCompletionDidShow(O,W,K){this.s(O,Z,async Y=>{Y.handleDidShowCompletionItem(W,K)},void 0,void 0)}$freeInlineCompletionsList(O,W){this.s(O,Z,async K=>{K.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(O,W,K,Y){const de=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,be=this.t(new J(this.h,K),O);return this.e.$registerSignatureHelpProvider(be,this.o(W),de),this.p(be)}$provideSignatureHelp(O,W,K,Y,de){return this.s(O,J,be=>be.provideSignatureHelp(c.URI.revive(W),K,Y,de),void 0,de)}$releaseSignatureHelp(O,W){this.s(O,J,K=>K.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(O,W,K){const Y=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new fe(this.h,this.j.converter,K,this.l,O),O);this.e.$registerInlayHintsProvider(de,this.o(W),typeof K.resolveInlayHint=="function",Y,ae.u(O));let be=this.p(de);if(Y!==void 0){const Pe=K.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(Y));be=A.Disposable.from(be,Pe)}return be}$provideInlayHints(O,W,K,Y){return this.s(O,fe,de=>de.provideInlayHints(c.URI.revive(W),K,Y),void 0,Y)}$resolveInlayHint(O,W,K){return this.s(O,fe,Y=>Y.resolveInlayHint(W,K),void 0,K)}$releaseInlayHints(O,W){this.s(O,fe,K=>K.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(O,W,K){const Y=this.t(new ve(this.h,K),O);return this.e.$registerDocumentLinkProvider(Y,this.o(W),typeof K.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(O,W,K){return this.s(O,ve,Y=>Y.provideLinks(c.URI.revive(W),K),void 0,K,W.scheme==="output")}$resolveDocumentLink(O,W,K){return this.s(O,ve,Y=>Y.resolveLink(W,K),void 0,void 0,!0)}$releaseDocumentLinks(O,W){this.s(O,ve,K=>K.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(O,W,K){const Y=this.t(new Ee(this.h,K),O);return this.e.$registerDocumentColorProvider(Y,this.o(W)),this.p(Y)}$provideDocumentColors(O,W,K){return this.s(O,Ee,Y=>Y.provideColors(c.URI.revive(W),K),[],K)}$provideColorPresentations(O,W,K,Y){return this.s(O,Ee,de=>de.provideColorPresentations(c.URI.revive(W),K,Y),void 0,Y)}registerFoldingRangeProvider(O,W,K){const Y=this.q(),de=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new ee(new Ae(this.h,K),O)),this.e.$registerFoldingRangeProvider(Y,this.o(W),O.identifier,de);let be=this.p(Y);if(de!==void 0){const Pe=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));be=A.Disposable.from(be,Pe)}return be}$provideFoldingRanges(O,W,K,Y){return this.s(O,Ae,de=>de.provideFoldingRanges(c.URI.revive(W),K,Y),void 0,Y)}registerSelectionRangeProvider(O,W,K){const Y=this.t(new Fe(this.h,K,this.l),O);return this.e.$registerSelectionRangeProvider(Y,this.o(W)),this.p(Y)}$provideSelectionRanges(O,W,K,Y){return this.s(O,Fe,de=>de.provideSelectionRanges(c.URI.revive(W),K,Y),[],Y)}registerCallHierarchyProvider(O,W,K){const Y=this.t(new se(this.h,K),O);return this.e.$registerCallHierarchyProvider(Y,this.o(W)),this.p(Y)}$prepareCallHierarchy(O,W,K,Y){return this.s(O,se,de=>Promise.resolve(de.prepareSession(c.URI.revive(W),K,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(O,W,K,Y){return this.s(O,se,de=>de.provideCallsTo(W,K,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(O,W,K,Y){return this.s(O,se,de=>de.provideCallsFrom(W,K,Y),void 0,Y)}$releaseCallHierarchy(O,W){this.s(O,se,K=>Promise.resolve(K.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(O,W,K){const Y=this.t(new le(this.h,K),O);return this.e.$registerTypeHierarchyProvider(Y,this.o(W)),this.p(Y)}$prepareTypeHierarchy(O,W,K,Y){return this.s(O,le,de=>Promise.resolve(de.prepareSession(c.URI.revive(W),K,Y)),void 0,Y)}$provideTypeHierarchySupertypes(O,W,K,Y){return this.s(O,le,de=>de.provideSupertypes(W,K,Y),void 0,Y)}$provideTypeHierarchySubtypes(O,W,K,Y){return this.s(O,le,de=>de.provideSubtypes(W,K,Y),void 0,Y)}$releaseTypeHierarchy(O,W){this.s(O,le,K=>Promise.resolve(K.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(O,W,K){const Y=this.q();return this.f.set(Y,new ee(new ue(this.e,this.h,K,Y),O)),this.e.$registerDocumentOnDropEditProvider(Y,this.o(W)),this.p(Y)}$provideDocumentOnDropEdits(O,W,K,Y,de,be){return this.s(O,ue,Pe=>Promise.resolve(Pe.provideDocumentOnDropEdits(W,c.URI.revive(K),Y,de,be)),void 0,void 0)}registerDocumentPasteEditProvider(O,W,K,Y){const de=this.q();return this.f.set(de,new ee(new N(this.e,this.h,K,de),O)),this.e.$registerPasteEditProvider(de,this.o(W),!!K.prepareDocumentPaste,Y.pasteMimeTypes),this.p(de)}$prepareDocumentPaste(O,W,K,Y,de){return this.s(O,N,be=>be.prepareDocumentPaste(c.URI.revive(W),K,Y,de),void 0,de)}$providePasteEdits(O,W,K,Y,de,be){return this.s(O,N,Pe=>Pe.providePasteEdits(W,c.URI.revive(K),Y,de,be),void 0,be)}static w(O){return{pattern:O.source,flags:(0,S.regExpFlags)(O)}}static y(O){return{decreaseIndentPattern:ae.w(O.decreaseIndentPattern),increaseIndentPattern:ae.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ae.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ae.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:ae.w(O.beforeText),afterText:O.afterText?ae.w(O.afterText):void 0,previousLineText:O.previousLineText?ae.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(ae.z)}setLanguageConfiguration(O,W,K){const{wordPattern:Y}=K;if(Y&&(0,S.regExpLeadsToEndlessLoop)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(W,Y):this.h.setWordDefinitionFor(W,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const de=this.q(),be={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?ae.w(K.wordPattern):void 0,indentationRules:K.indentationRules?ae.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?ae.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this.e.$setLanguageConfiguration(de,W,be),this.p(de)}$setWordDefinitions(O){for(const W of O)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=ae,ae.d=0}),define(ye[256],Ce([1,0,5,14,7,43,18,6]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(L,P,v,D){this.c=P,this.d=v,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,P){await this.a.$changeLanguage(L,P);const v=this.c.getDocumentData(L);if(!v)throw new Error(`document '${L.toString()}' NOT found`);return v.document}async tokenAtPosition(L,P){const v=L.version,D=t.Position.from(P),E=await this.a.$tokensAtPosition(L.uri,D),d={type:k.StandardTokenType.Other,range:L.getWordRangeAtPosition(P)??new k.Range(P.line,P.character,P.line,P.character)};if(!E)return d;const m={range:t.Range.to(E.range),type:t.TokenType.to(E.type)};return!m.range.contains(P)||v!==L.version?d:m}createLanguageStatusItem(L,P,v){const D=this.f++,E=this.a,d=this.g,m=`${L.identifier.value}/${P}`;if(d.has(m))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);d.add(m);const h={selector:v,id:P,name:L.displayName??L.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const p=new T.DisposableStore,g=()=>{b?.dispose(),b=(0,C.disposableTimeout)(()=>{p.clear(),this.a.$setLanguageStatus(D,{id:m,name:h.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===k.LanguageStatusSeverity.Error?A.default.Error:h.severity===k.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:h.command&&this.d.toInternal(h.command,p),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},w={dispose(){p.dispose(),b?.dispose(),E.$removeLanguageStatus(D),d.delete(m)},get id(){return h.id},get name(){return h.name},set name(i){h.name=i,g()},get selector(){return h.selector},set selector(i){h.selector=i,g()},get text(){return h.text},set text(i){h.text=i,g()},get detail(){return h.detail},set detail(i){h.detail=i,g()},get severity(){return h.severity},set severity(i){h.severity=i,g()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(i){h.accessibilityInformation=i,g()},get command(){return h.command},set command(i){h.command=i,g()},get busy(){return h.busy},set busy(i){h.busy=i,g()}};return g(),w}}e.ExtHostLanguages=S}),define(ye[96],Ce([1,0,12,8,2,3,13,5,25,16]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(v,D,E){this.f=E,this.d=new Map,this.a=D.getProxy(T.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===c.LANGUAGE_DEFAULT}getMessage(v,D){const{message:E,args:d,comment:m}=D;if(this.c)return(0,t.format2)(E,d??{});let h=E;m&&m.length>0&&(h+=`/${Array.isArray(m)?m.join():m}`);const b=this.d.get(v)?.contents[h];return b||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,t.format2)(b??E,d??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let D;const E=await this.g(v);if(!E){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(E),m=JSON.parse(d);D=v.isBuiltin?m.contents?.bundle:m}catch(d){this.f.error(`Failed to load translations for ${v.identifier.value} from ${E}: ${d.message}`);return}D&&this.d.set(v.identifier.value,{contents:D,uri:E})}async g(v){if(v.isBuiltin){const D=await this.a.$fetchBuiltInBundleUri(v.identifier.value);return k.URI.revive(D)}return v.l10n?k.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([He(0,S.IExtHostInitDataService),He(1,y.IExtHostRpcService),He(2,C.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(ye[140],Ce([1,0,13,5,25,16,2,4,11]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends c.AbstractLoggerService{constructor(v,D){super(D.logLevel,T.Event.None),this.g=v.getProxy(t.MainContext.MainThreadLogger)}$setLevel(v,D){D?this.setLevel(C.URI.revive(D),v):(0,S.isUndefined)(v)||this.setLevel(v)}f(v,D,E){return new L(this.g,v,D,E)}};y=qe([He(0,A.IExtHostRpcService),He(1,k.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class L extends c.AbstractMessageLogger{constructor(v,D,E,d){super(d?.always),this.m=v,this.n=D,this.k=!1,this.l=[],this.setLevel(E),this.m.$createLogger(D,d).then(()=>{this.r(this.l),this.k=!0})}g(v,D){const E=[[v,D]];this.k?this.r(E):this.l.push(...E)}r(v){this.m.$log(this.n,v)}}}),define(ye[257],Ce([1,0,5,13,26]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(T){return T&&T.title}let C=class{constructor(S,y){this.b=y,this.a=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,y,L,P,v){const D={source:{identifier:S.identifier,label:S.displayName||S.name}};let E;typeof P=="string"||A(P)?E=[P,...v]:(D.modal=P?.modal,D.useCustom=P?.useCustom,D.detail=P?.detail,E=v),D.useCustom&&(0,k.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let m=0;m<E.length;m++){const h=E[m];if(typeof h=="string")d.push({title:h,handle:m,isCloseAffordance:!1});else if(typeof h=="object"){const{title:b,isCloseAffordance:p}=h;d.push({title:b,isCloseAffordance:!!p,handle:m})}else this.b.warn("Invalid message item:",h)}return this.a.$showMessage(y,L,D,d).then(m=>{if(typeof m=="number")return E[m]})}};C=qe([He(1,t.ILogService)],C),e.ExtHostMessageService=C}),define(ye[258],Ce([1,0,22,4,6,28,8,11,2,69,5,39,14,7,57,233,136]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(p=>p.apiEditor)}constructor(p,g,w,i){this.q=w,this.r=i,this.f=new Map,this.g=new A.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=p.getProxy(L.MainContext.MainThreadNotebook),this.c=p.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=p.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=g.converter,g.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===13){const u=o.notebookEditor?.notebookUri,l=o.cell.handle,a=this.g.get(u)?.getCell(l);if(a)return a.apiCell}if(o&&o.$mid===14){const u=o.uri,l=this.g.get(u);if(l)return l.apiNotebook}return o}}),h.x(g)}getEditorById(p){const g=this.h.get(p);if(!g)throw new Error(`unknown text editor: ${p}. known editors: ${[...this.h.keys()]} `);return g}getIdByEditor(p){for(const[g,w]of this.h)if(w.apiEditor===p)return g}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(p,g){const w=this.g.get(p);if(!w&&!g)throw new Error(`NO notebook document for '${p}'`);return w}static s(p,g){if(!g)return;const w=g.filenamePattern.map(i=>v.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(g.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:p.identifier,providerDisplayName:p.displayName||p.name,displayName:g.displayName,filenamePattern:w,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(p,g,w){const i=h.a++,o=typeof w.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(i,w),this.b.$registerNotebookCellStatusBarItemProvider(i,o,g);let u;return o!==void 0&&(u=w.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(o))),new D.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,o),u?.dispose()})}async createNotebookDocument(p){const g=await this.c.$tryCreateNotebook({viewType:p.viewType,content:p.content&&v.NotebookData.from(p.content)});return S.URI.revive(g)}async openNotebookDocument(p){const g=this.g.get(p);if(g)return g.apiNotebook;const w=await this.c.$tryOpenNotebook(p),i=this.g.get(S.URI.revive(w));return(0,T.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(p,g){S.URI.isUri(p)&&(p=await this.openNotebookDocument(p));let w;typeof g=="object"?w={position:v.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(v.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:w={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(p.uri,p.notebookType,w),o=i&&this.h.get(i)?.apiEditor;if(o)return o;throw i?new Error(`Could NOT open editor for "${p.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${p.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(p,g,w,i){const o=this.f.get(p),u=S.URI.revive(g),l=this.g.get(u);if(!l||!o)return;const s=l.getCellFromIndex(w);if(!s)return;const a=await o.provideCellStatusBarItems(s.apiCell,i);if(!a)return;const n=new k.DisposableStore,r=this.p.add([n]),I=(Array.isArray(a)?a:[a]).map(R=>v.NotebookStatusBarItem.from(R,this.i,n));return{cacheId:r,items:I}}$releaseNotebookCellStatusBarItems(p){this.p.delete(p)}registerNotebookSerializer(p,g,w,i,o){if((0,C.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const u=this.t++;return this.u.set(u,w),this.b.$registerNotebookSerializer(u,{id:p.identifier,location:p.extensionLocation},g,v.NotebookDocumentContentOptions.from(i),h.s(p,o)),(0,k.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(u)})}async $dataToNotebook(p,g,w){const i=this.u.get(p);if(!i)throw new Error("NO serializer found");const o=await i.deserializeNotebook(g.buffer,w);return new E.SerializableObjectWithBuffers(v.NotebookData.from(o))}async $notebookToData(p,g,w){const i=this.u.get(p);if(!i)throw new Error("NO serializer found");const o=await i.serializeNotebook(v.NotebookData.to(g.value),w);return c.VSBuffer.wrap(o)}w(p,g,w){if(this.h.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const i=new m.ExtHostNotebookEditor(g,this.d,p,w.visibleRanges.map(v.NotebookRange.to),w.selections.map(v.NotebookRange.to),typeof w.viewColumn=="number"?v.ViewColumn.to(w.viewColumn):void 0);this.h.set(g,i)}$acceptDocumentAndEditorsDelta(p){if(p.value.removedDocuments)for(const w of p.value.removedDocuments){const i=S.URI.revive(w),o=this.g.get(i);o&&(o.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(u=>u.document.uri)}),this.n.fire(o.apiNotebook));for(const u of this.h.values())u.notebookData.uri.toString()===i.toString()&&this.h.delete(u.id)}if(p.value.addedDocuments){const w=[];for(const i of p.value.addedDocuments){const o=S.URI.revive(i.uri);if(this.g.has(o))throw new Error(`adding EXISTING notebook ${o} `);const u=new d.ExtHostNotebookDocument(this.c,this.q,this.r,o,i);w.push(...i.cells.map(l=>d.ExtHostCell.asModelAddData(u.apiNotebook,l))),this.g.get(o)?.dispose(),this.g.set(o,u),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(u.apiNotebook)}}if(p.value.addedEditors)for(const w of p.value.addedEditors){if(this.h.has(w.id))return;const i=S.URI.revive(w.documentUri),o=this.g.get(i);o&&this.w(o,w.id,w)}const g=[];if(p.value.removedEditors)for(const w of p.value.removedEditors){const i=this.h.get(w);i&&(this.h.delete(w),this.k?.id===i.id&&(this.k=void 0),g.push(i))}if(p.value.visibleEditors){this.l=p.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const w=new Set;this.l.forEach(i=>w.add(i.id));for(const i of this.h.values()){const o=w.has(i.id);i._acceptVisibility(o)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}p.value.newActiveEditor===null?this.k=void 0:p.value.newActiveEditor&&(this.k=this.h.get(p.value.newActiveEditor)),p.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(p){const g=P.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new P.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>c.VSBuffer.wrap(o))],new P.ApiCommandResult("Notebook Data",o=>v.NotebookData.to(o.value))),i=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new E.SerializableObjectWithBuffers(v.NotebookData.from(o)))],new P.ApiCommandResult("Bytes",o=>o.buffer));p.registerApiCommand(w),p.registerApiCommand(i)}}e.ExtHostNotebookController=h,h.a=0}),define(ye[259],Ce([1,0,17,18,21,4,6,28,2,27,13,69,5,39,14,7,93,221,26,57]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let g=class{constructor(s,a,n,r,f){this.k=a,this.l=n,this.m=r,this.n=f,this.b=new T.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=s.getProxy(v.MainContext.MainThreadNotebookKernels);const I=new D.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new D.ApiCommandArgument("options","Select kernel options",R=>!0,R=>{if(R&&"notebookEditor"in R&&"id"in R){const B=this.l.getIdByEditor(R.notebookEditor);return{id:R.id,extension:R.extension,notebookEditorId:B}}else if(R&&"notebookEditor"in R){const B=this.l.getIdByEditor(R.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${R.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return R})],D.ApiCommandResult.Void);this.m.registerApiCommand(I)}createNotebookController(s,a,n,r,f,I){for(const Z of this.h.values())if(Z.controller.id===a&&y.ExtensionIdentifier.equals(s.identifier,Z.extensionId))throw new Error(`notebook controller with id '${a}' ALREADY exist`);const R=this.i++,B=this;this.n.trace(`NotebookController[${R}], CREATED by ${s.identifier.value}, ${a}`);const X=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${s.identifier}'`);let q=!1;const N=new C.DisposableStore,M=new A.Emitter,F=new A.Emitter,z={id:u(s.identifier,a),notebookType:n,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:r||s.identifier.value,preloads:I?I.map(E.NotebookRendererScript.from):[]};let U=f??X,H;this.a.$addKernel(R,z).catch(Z=>{console.log(Z),q=!0});let x=0;const V=()=>{if(q)return;const Z=++x;Promise.resolve().then(()=>{Z===x&&this.a.$updateKernel(R,z)})},_=new T.ResourceMap,Q={get id(){return a},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return z.label},set label(Z){z.label=Z??s.displayName??s.name,V()},get detail(){return z.detail??""},set detail(Z){z.detail=Z,V()},get description(){return z.description??""},set description(Z){z.description=Z,V()},get kind(){return(0,b.checkProposedApiEnabled)(s,"notebookControllerKind"),z.kind??""},set kind(Z){(0,b.checkProposedApiEnabled)(s,"notebookControllerKind"),z.kind=Z,V()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(Z){z.supportedLanguages=Z,V()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){z.supportsExecutionOrder=Z,V()},get rendererScripts(){return z.preloads?z.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(Z){U=Z??X},get interruptHandler(){return H},set interruptHandler(Z){H=Z,z.supportsInterrupt=Boolean(Z),V()},createNotebookCellExecution(Z){if(q)throw new Error("notebook controller is DISPOSED");if(!_.has(Z.notebook.uri))throw B.n.trace(`NotebookController[${R}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ge=>ge.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return B._createNotebookCellExecution(Z,u(s.identifier,this.id))},dispose:()=>{q||(this.n.trace(`NotebookController[${R}], DISPOSED`),q=!0,this.h.delete(R),N.dispose(),M.dispose(),F.dispose(),this.a.$removeKernel(R))},updateNotebookAffinity(Z,ge){ge===d.NotebookControllerAffinity2.Hidden&&(0,b.checkProposedApiEnabled)(s,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(R,Z.uri,ge)},onDidReceiveMessage:F.event,postMessage(Z,ge){return(0,b.checkProposedApiEnabled)(s,"notebookMessaging"),B.a.$postMessage(R,ge&&B.l.getIdByEditor(ge),Z)},asWebviewUri(Z){return(0,b.checkProposedApiEnabled)(s,"notebookMessaging"),(0,m.asWebviewUri)(Z,B.k.remote)}};return this.h.set(R,{extensionId:s.identifier,controller:Q,onDidReceiveMessage:F,onDidChangeSelection:M,associatedNotebooks:_}),Q}getIdByController(s){for(const[a,n]of this.h)if(n.controller===s)return u(n.extensionId,s.id);return null}createNotebookControllerDetectionTask(s,a){const n=this.d++,r=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${s.identifier.value}`),this.a.$addKernelDetectionTask(n,a);const f={dispose:()=>{this.c.delete(n),r.a.$removeKernelDetectionTask(n)}};return this.c.set(n,f),f}registerKernelSourceActionProvider(s,a,n){const r=this.f++,f=this;return this.e.set(r,n),this.n.trace(`NotebookKernelSourceActionProvider[${r}], CREATED by ${s.identifier.value}`),this.a.$addKernelSourceActionProvider(r,a),{dispose:()=>{this.e.delete(r),f.a.$removeKernelSourceActionProvider(r)}}}async $provideKernelSourceActions(s,a){const n=this.e.get(s);if(n){const r=new C.DisposableStore;return this.g.add([r]),(await n.provideNotebookKernelSourceActions(a)??[]).map(I=>E.NotebookKernelSourceAction.from(I,this.m.converter,r))}return[]}$acceptNotebookAssociation(s,a,n){const r=this.h.get(s);if(r){const f=this.l.getNotebookDocument(S.URI.revive(a));n?r.associatedNotebooks.set(f.uri,!0):r.associatedNotebooks.delete(f.uri),this.n.trace(`NotebookController[${s}] ASSOCIATE notebook`,f.uri.toString(),n),r.onDidChangeSelection.fire({selected:n,notebook:f.apiNotebook})}}async $executeCells(s,a,n){const r=this.h.get(s);if(!r)return;const f=this.l.getNotebookDocument(S.URI.revive(a)),I=[];for(const R of n){const B=f.getCell(R);B&&I.push(B.apiCell)}try{this.n.trace(`NotebookController[${s}] EXECUTE cells`,f.uri.toString(),I.length),await r.controller.executeHandler.call(r.controller,I,f.apiNotebook,r.controller)}catch(R){this.n.error(`NotebookController[${s}] execute cells FAILED`,R),console.error(R)}}async $cancelCells(s,a,n){const r=this.h.get(s);if(!r)return;const f=this.l.getNotebookDocument(S.URI.revive(a));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,f.apiNotebook);else for(const I of n){const R=f.getCell(I);R&&this.b.get(R.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,a,n){const r=this.h.get(s);if(!r)return;const f=this.l.getEditorById(a);r.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:n}))}$cellExecutionChanged(s,a,n){const f=this.l.getNotebookDocument(S.URI.revive(s)).getCell(a);if(f){const I=n?E.NotebookCellExecutionState.to(n):d.NotebookCellExecutionState.Idle;I!==void 0&&this.j.fire({cell:f.apiCell,state:I})}}_createNotebookCellExecution(s,a){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this.l.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!r)throw new Error("invalid cell");if(this.b.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const f=new i(a,r,this.a);this.b.set(r.uri,f);const I=f.onDidChangeState(()=>{f.state===w.Resolved&&(f.dispose(),I.dispose(),this.b.delete(r.uri))});return f.asApiObject()}};g=qe([He(4,L.ILogService)],g),e.ExtHostNotebookKernels=g;var w;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(w||(w={}));class i extends C.Disposable{get state(){return this.f}constructor(s,a,n){super(),this.j=a,this.k=n,this.b=i.a++,this.c=new A.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new k.CancellationTokenSource),this.h=new o(10,r=>this.m(r)),this.i=a.internalMetadata.executionOrder,this.k.$createExecution(this.b,s,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(s){await this.h.addItem(s)}async m(s){const a=Array.isArray(s)?s:[s];return this.k.$updateExecution(this.b,new p.SerializableObjectWithBuffers(a))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(s){let a=this.j;if(s&&(a=this.j.notebook.getCellFromApiCell(s)),!a)throw new Error("INVALID cell");return a.handle}s(s){return s.map(a=>{const n=d.NotebookCellOutput.ensureUniqueMimeTypes(a.items,!0);return n===a.items?E.NotebookCellOutput.from(a):E.NotebookCellOutput.from({items:n,id:a.id,metadata:a.metadata})})}async t(s,a,n){const r=this.r(a),f=this.s((0,c.asArray)(s));return this.l({editType:h.CellExecutionUpdateType.Output,cellHandle:r,append:n,outputs:f})}async w(s,a,n){return s=d.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(s),!0),this.l({editType:h.CellExecutionUpdateType.OutputItems,items:s.map(E.NotebookCellOutputItem.from),outputId:a.id,append:n})}asApiObject(){const s=this;return Object.freeze({get token(){return s.g.token},get cell(){return s.j.apiCell},get executionOrder(){return s.i},set executionOrder(n){s.i=n,s.m([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:s.i}])},start(n){if(s.f===w.Resolved||s.f===w.Started)throw new Error("Cannot call start again");s.f=w.Started,s.c.fire(),s.m({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,r){if(s.f===w.Resolved)throw new Error("Cannot call resolve twice");s.f=w.Resolved,s.c.fire(),s.h.flush(),s.k.$completeExecution(s.b,new p.SerializableObjectWithBuffers({runEndTime:r,lastRunSuccess:n}))},clearOutput(n){return s.n(),s.t([],n,!1)},appendOutput(n,r){return s.n(),s.t(n,r,!0)},replaceOutput(n,r){return s.n(),s.t(n,r,!1)},appendOutputItems(n,r){return s.n(),s.w(n,r,!0)},replaceOutputItems(n,r){return s.n(),s.w(n,r,!1)}})}}i.a=0;class o{constructor(s,a){this.d=s,this.e=a,this.a=[],this.b=Date.now()}addItem(s){return this.a.push(s),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const s=this.c;this.c=void 0;const a=this.a;return this.a=[],this.e(a).finally(()=>s.complete())}}function u(l,s){return`${l.value}/${s}`}e.createKernelId=u}),define(ye[260],Ce([1,0,4,5,136]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(T,S){this.c=S,this.a=new Map,this.b=T.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,S,y){const L=this.c.getEditorById(T);this.a.get(S)?.fire({editor:L.apiEditor,message:y})}createRendererMessaging(T,S){if(!T.contributes?.notebookRenderer?.some(L=>L.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(L,P,v)=>this.d(S).event(L,P,v),postMessage:(L,P)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,P]=[P,L]);const v=P&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(v?.id,S,L)}}}d(T){let S=this.a.get(T);return S||(S=new c.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(T)}}),this.a.set(T,S),S)}}e.ExtHostNotebookRenderers=A}),define(ye[261],Ce([1,0,6,2,26,5]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class C{constructor(S){this.b=new Map,this.a=S.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,y,L){if((0,k.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(y))throw new Error(`Handler with id '${y}' already registered`);return this.b.set(y,L),this.a.$registerProfileContentHandler(y,L.name,S.identifier.value),(0,c.toDisposable)(()=>{this.b.delete(y),this.a.$unregisterProfileContentHandler(y)})}async $saveProfile(S,y,L,P){const v=this.b.get(S);if(!v)throw new Error(`Unknown handler with id: ${S}`);return v.saveProfile(y,L,P)}async $readProfile(S,y,L){const P=this.b.get(S);if(!P)throw new Error(`Unknown handler with id: ${S}`);return P.readProfile(t.URI.revive(y),L)}}e.ExtHostProfileContentHandlers=C}),define(ye[262],Ce([1,0,21,4,6,5,2,7,10,17,43,90]),function(ne,e,c,t,k,A,C,T,S,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(D,E,d){const m=D.getProxy(A.MainContext.MainThreadQuickOpen);class h{constructor(s,a){this.e=new Map,this.f=0,this.a=s,this.b=a}showQuickPick(s,a,n=c.CancellationToken.None){this.c=void 0;const r=Promise.resolve(s),f=++this.f,I=m.$show(f,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},n),R={},B=I.then(()=>R);return Promise.race([B,r]).then(X=>{if(X!==R)return r.then(q=>{const N=[];for(let M=0;M<q.length;M++){const F=q[M];typeof F=="string"?N.push({label:F,handle:M}):F.kind===T.QuickPickItemKind.Separator?N.push({type:"separator",label:F.label}):N.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:M})}return a&&typeof a.onDidSelectItem=="function"&&(this.c=M=>{a.onDidSelectItem(q[M])}),m.$setItems(f,N),I.then(M=>{if(typeof M=="number")return q[M];if(Array.isArray(M))return M.map(F=>q[F])})})}).then(void 0,X=>{if(!(0,S.isCancellationError)(X))return m.$setError(f,X),Promise.reject(X)})}$onItemSelected(s){this.c?.(s)}showInput(s,a=c.CancellationToken.None){return this.d=s?.validateInput,m.$input(s,typeof this.d=="function",a).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(s){if(!this.d)return;const a=await this.d(s);if(!a||typeof a=="string")return a;let n;switch(a.severity){case T.InputBoxValidationSeverity.Info:n=L.default.Info;break;case T.InputBoxValidationSeverity.Warning:n=L.default.Warning;break;case T.InputBoxValidationSeverity.Error:n=L.default.Error;break;default:n=a.message?L.default.Error:L.default.Ignore;break}return{content:a.message,severity:n}}async showWorkspaceFolderPick(s,a=c.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!n)return;const r=await this.a.getWorkspaceFolders2();if(!!r)return r.find(f=>f.uri.toString()===n.uri.toString())}createQuickPick(s){const a=new o(s,()=>this.e.delete(a._id));return this.e.set(a._id,a),a}createInputBox(s){const a=new u(s,()=>this.e.delete(a._id));return this.e.set(a._id,a),a}$onDidChangeValue(s,a){this.e.get(s)?._fireDidChangeValue(a)}$onDidAccept(s){this.e.get(s)?._fireDidAccept()}$onDidChangeActive(s,a){const n=this.e.get(s);n instanceof o&&n._fireDidChangeActive(a)}$onDidChangeSelection(s,a){const n=this.e.get(s);n instanceof o&&n._fireDidChangeSelection(a)}$onDidTriggerButton(s,a){this.e.get(s)?._fireDidTriggerButton(a)}$onDidTriggerItemButton(s,a,n){const r=this.e.get(s);r instanceof o&&r._fireDidTriggerItemButton(a,n)}$onDidHide(s){this.e.get(s)?._fireDidHide()}}class b{constructor(s,a){this.x=s,this.y=a,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(s){this.b=s,this.z({title:s})}get step(){return this.c}set step(s){this.c=s,this.z({step:s})}get totalSteps(){return this.d}set totalSteps(s){this.d=s,this.z({totalSteps:s})}get enabled(){return this.g}set enabled(s){this.g=s,this.z({enabled:s})}get busy(){return this.j}set busy(s){this.j=s,this.z({busy:s})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(s){this.k=s,this.z({ignoreFocusOut:s})}get value(){return this.l}set value(s){this.l=s,this.z({value:s})}get placeholder(){return this.m}set placeholder(s){this.m=s,this.z({placeholder:s})}get buttons(){return this.n}set buttons(s){this.n=s.slice(),this.o.clear(),s.forEach((a,n)=>{const r=a===T.QuickInputButtons.Back?-1:n;this.o.set(r,a)}),this.z({buttons:s.map((a,n)=>({...i(a),tooltip:a.tooltip,handle:a===T.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(s){this.l=s,this.q.fire(s)}_fireDidTriggerButton(s){const a=this.o.get(s);a&&this.r.fire(a)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,k.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(s){if(!this.v){for(const a of Object.keys(s)){const n=s[a];this.u[a]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}b.a=1;function p(l){if(l instanceof T.ThemeIcon)return{id:l.id};const s=w(l),a=g(l);return{dark:typeof s=="string"?C.URI.file(s):s,light:typeof a=="string"?C.URI.file(a):a}}function g(l){return typeof l=="object"&&"light"in l?l.light:l}function w(l){return typeof l=="object"&&"dark"in l?l.dark:l}function i(l){const s=p(l.iconPath);let a,n;return"id"in s?n=P.ThemeIcon.asClassName(s):a=s,{iconPath:a,iconClass:n}}class o extends b{constructor(s,a){super(s.identifier,a),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new t.Emitter,this.L=[],this.M=new t.Emitter,this.N=new t.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(s){this.B=s.slice(),this.C.clear(),this.D.clear(),s.forEach((n,r)=>{this.C.set(r,n),this.D.set(n,r)});const a=[];for(let n=0;n<s.length;n++){const r=s[n];r.kind===T.QuickPickItemKind.Separator?a.push({type:"separator",label:r.label}):a.push({handle:n,label:r.label,description:r.description,detail:r.detail,picked:r.picked,alwaysShow:r.alwaysShow,buttons:r.buttons?.map((f,I)=>({...i(f),tooltip:f.tooltip,handle:I}))})}this.z({items:a})}get canSelectMany(){return this.E}set canSelectMany(s){this.E=s,this.z({canSelectMany:s})}get matchOnDescription(){return this.F}set matchOnDescription(s){this.F=s,this.z({matchOnDescription:s})}get matchOnDetail(){return this.G}set matchOnDetail(s){this.G=s,this.z({matchOnDetail:s})}get sortByLabel(){return this.H}set sortByLabel(s){this.H=s,this.z({sortByLabel:s})}get keepScrollPosition(){return this.I}set keepScrollPosition(s){this.I=s,this.z({keepScrollPosition:s})}get activeItems(){return this.J}set activeItems(s){this.J=s.filter(a=>this.D.has(a)),this.z({activeItems:this.J.map(a=>this.D.get(a))})}get selectedItems(){return this.L}set selectedItems(s){this.L=s.filter(a=>this.D.has(a)),this.z({selectedItems:this.L.map(a=>this.D.get(a))})}_fireDidChangeActive(s){const a=(0,y.coalesce)(s.map(n=>this.C.get(n)));this.J=a,this.K.fire(a)}_fireDidChangeSelection(s){const a=(0,y.coalesce)(s.map(n=>this.C.get(n)));this.L=a,this.M.fire(a)}_fireDidTriggerItemButton(s,a){const n=this.C.get(s);if(!n||!n.buttons||!n.buttons.length)return;const r=n.buttons[a];r&&this.N.fire({button:r,item:n})}}class u extends b{constructor(s,a){super(s.identifier,a),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(s){this.B=s,this.z({password:s})}get prompt(){return this.C}set prompt(s){this.C=s,this.z({prompt:s})}get valueSelection(){return this.D}set valueSelection(s){this.D=s,this.z({valueSelection:s})}get validationMessage(){return this.E}set validationMessage(s){this.E=s,s?typeof s=="string"?this.z({validationMessage:s,severity:L.default.Error}):this.z({validationMessage:s.message,severity:s.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new h(E,d)}e.createExtHostQuickOpen=v});var Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c};define(ye[263],Ce([1,0,2,4,60,6,18,5,17,109,13,27,90,14,26]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E){"use strict";var d,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(r){if(r)return typeof r.iconPath=="string"?c.URI.file(r.iconPath):c.URI.isUri(r.iconPath)||v.ThemeIcon.isThemeIcon(r.iconPath)?r.iconPath:void 0}function b(r,f){if(!r.iconPath&&!f.iconPath)return 0;if(r.iconPath){if(!f.iconPath)return 1}else return-1;const I=typeof r.iconPath=="string"?r.iconPath:c.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id,R=typeof f.iconPath=="string"?f.iconPath:c.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,y.comparePaths)(I,R)}function p(r,f){let I=0;if(r.strikeThrough!==f.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==f.faded)return r.faded?1:-1;if(r.tooltip!==f.tooltip)return(r.tooltip||"").localeCompare(f.tooltip||"");if(I=b(r,f),I!==0)return I;if(r.light&&f.light)I=b(r.light,f.light);else{if(r.light)return 1;if(f.light)return-1}if(I!==0)return I;if(r.dark&&f.dark)I=b(r.dark,f.dark);else{if(r.dark)return 1;if(f.dark)return-1}return I}function g(r,f){if(r.command!==f.command)return r.command<f.command?-1:1;if(r.title!==f.title)return r.title<f.title?-1:1;if(r.tooltip!==f.tooltip){if(r.tooltip!==void 0&&f.tooltip!==void 0)return r.tooltip<f.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(r.arguments===f.arguments)return 0;if(r.arguments)if(f.arguments){if(r.arguments.length!==f.arguments.length)return r.arguments.length-f.arguments.length}else return 1;else return-1;for(let I=0;I<r.arguments.length;I++){const R=r.arguments[I],B=f.arguments[I];if(R!==B)return R<B?-1:1}return 0}function w(r,f){let I=(0,y.comparePaths)(r.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(I!==0)return I;if(r.command&&f.command)I=g(r.command,f.command);else{if(r.command)return 1;if(f.command)return-1}if(I!==0)return I;if(r.decorations&&f.decorations)I=p(r.decorations,f.decorations);else{if(r.decorations)return 1;if(f.decorations)return-1}return I}function i(r,f){for(let I=0;I<r.length;I++)if(r[I]!==f[I])return!1;return!0}function o(r,f){return r.command===f.command&&r.title===f.title&&r.tooltip===f.tooltip&&(r.arguments&&f.arguments?i(r.arguments,f.arguments):r.arguments===f.arguments)}function u(r,f){return(0,S.equals)(r,f,o)}class l{get value(){return this.d}set value(f){f=f??"",Ue(this,d,"f").$setInputBoxValue(this.l,f),this.m(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){Ue(this,d,"f").$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,E.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,E.checkProposedApiEnabled)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,Ue(this,d,"f").$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,Ue(this,d,"f").$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,Ue(this,d,"f").$setInputBoxVisibility(this.l,f))}constructor(f,I,R){this.k=f,this.l=R,d.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,d,I,"f")}showValidationMessage(f,I){(0,E.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,d,"f").$showValidationMessage(this.l,f,I)}$onInputBoxValueChange(f){this.m(f)}m(f){this.d=f,this.e.fire(f)}}e.ExtHostSCMInputBox=l,d=new WeakMap;class s{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,I,R,B,X){this.q=f,this.s=I,this.t=R,this.u=B,this.v=X,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=s.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,I){const R=this.h.get(f);return R?(0,C.asPromise)(()=>this.s.executeCommand(R.command,...R.arguments||[],I)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(w),R=(0,S.sortedDiff)(this.o,f,w).map(q=>{const N=q.toInsert.map(M=>{const F=this.e++;this.g.set(F,M);const z=M.resourceUri;let U;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const fe=new A.DisposableStore;U=this.s.converter.toInternal(M.command,fe),this.j.set(F,fe)}else this.h.set(F,M.command);const H=h(M.decorations),x=M.decorations&&h(M.decorations.light)||H,V=M.decorations&&h(M.decorations.dark)||H,_=[x,V],Q=M.decorations&&M.decorations.tooltip||"",Z=M.decorations&&!!M.decorations.strikeThrough,ge=M.decorations&&!!M.decorations.faded,te=M.contextValue||"";return{rawResource:[F,z,_,Q,Z,ge,te,U],handle:F}});return{start:q.start,deleteCount:q.deleteCount,toInsert:N}}),B=R.map(({start:q,deleteCount:N,toInsert:M})=>[q,N,M.map(F=>F.rawResource)]),X=R.reverse();for(const{start:q,deleteCount:N,toInsert:M}of X){const F=M.map(U=>U.handle),z=this.n.splice(q,N,...F);for(const U of z)this.g.delete(U),this.h.delete(U),this.j.get(U)?.dispose(),this.j.delete(U)}return this.o=f,B}dispose(){this.l=!0,this.m.fire()}}s.d=0;class a{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,Ue(this,m,"f").$updateSourceControl(this.t,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f,Ue(this,m,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this.j}set commitTemplate(f){f!==this.j&&(this.j=f,Ue(this,m,"f").$updateSourceControl(this.t,{commitTemplate:f}))}get acceptInputCommand(){return this.l}set acceptInputCommand(f){this.k.value=new A.DisposableStore,this.l=f;const I=this.v.converter.toInternal(f,this.k.value);Ue(this,m,"f").$updateSourceControl(this.t,{acceptInputCommand:I})}get actionButton(){return(0,E.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(f){(0,E.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new A.DisposableStore,this.n=f;const I=f!==void 0?{command:this.v.converter.toInternal(f.command,this.m.value),secondaryCommands:f.secondaryCommands?.map(R=>R.map(B=>this.v.converter.toInternal(B,this.m.value))),description:f.description,enabled:f.enabled}:void 0;Ue(this,m,"f").$updateSourceControl(this.t,{actionButton:I??null})}get statusBarCommands(){return this.p}set statusBarCommands(f){if(this.p&&f&&u(this.p,f))return;this.o.value=new A.DisposableStore,this.p=f;const I=(f||[]).map(R=>this.v.converter.toInternal(R,this.o.value));Ue(this,m,"f").$updateSourceControl(this.t,{statusBarCommands:I})}get selected(){return this.q}constructor(f,I,R,B,X,q){this.u=f,this.v=R,this.w=B,this.x=X,this.y=q,m.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new A.MutableDisposable,this.l=void 0,this.m=new A.MutableDisposable,this.o=new A.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=a.d++,this.z=new Map,this.A=new Set,Je(this,m,I,"f"),this.f=new l(f,Ue(this,m,"f"),this.t),Ue(this,m,"f").$registerSourceControl(this.t,B,X,q)}createResourceGroup(f,I){const R=new s(Ue(this,m,"f"),this.v,this.t,f,I),B=t.Event.once(R.onDidDispose)(()=>this.z.delete(R));return this.z.set(R,B),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const f=[],I=[];for(const[R,B]of this.z){B.dispose();const X=R.onDidUpdateResourceStates(()=>{this.A.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.A.delete(R),X.dispose(),this.e.delete(R.handle),Ue(this,m,"f").$unregisterGroup(this.t,R.handle)}),f.push([R.handle,R.id,R.label,R.features]);const q=R._takeResourceStateSnapshot();q.length>0&&I.push([R.handle,q]),this.e.set(R.handle,R)}Ue(this,m,"f").$registerGroups(this.t,f,I),this.z.clear()}eventuallyUpdateResourceStates(){const f=[];this.A.forEach(I=>{const R=I._takeResourceStateSnapshot();R.length!==0&&f.push([I.handle,R])}),f.length>0&&Ue(this,m,"f").$spliceResourceStates(this.t,f),this.A.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.q=f,this.s.fire(f)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(f=>f.dispose()),Ue(this,m,"f").$unregisterSourceControl(this.t)}}m=new WeakMap,a.d=0,qe([(0,k.debounce)(100)],a.prototype,"eventuallyAddResourceGroups",null),qe([(0,k.debounce)(100)],a.prototype,"eventuallyUpdateResourceStates",null);let n=class ii{get onDidChangeActiveProvider(){return this.j.event}constructor(f,I,R){this.l=I,this.m=R,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=f.getProxy(T.MainContext.MainThreadSCM),this.f=f.getProxy(T.MainContext.MainThreadTelemetry),I.registerArgumentProcessor({processArgument:B=>{if(B&&B.$mid===3){const X=this.g.get(B.sourceControlHandle);if(!X)return B;const q=X.getResourceGroup(B.groupHandle);return q?q.getResourceState(B.handle):B}else if(B&&B.$mid===4){const X=this.g.get(B.sourceControlHandle);return X?X.getResourceGroup(B.groupHandle):B}else if(B&&B.$mid===5){const X=this.g.get(B.handle);return X||B}return B}})}createSourceControl(f,I,R,B){this.m.trace("ExtHostSCM#createSourceControl",f.identifier.value,I,R,B),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const X=ii.d++,q=new a(f,this.e,this.l,I,R,B);this.g.set(X,q);const N=this.h.get(P.ExtensionIdentifier.toKey(f.identifier))||[];return N.push(q),this.h.set(P.ExtensionIdentifier.toKey(f.identifier),N),q}getLastInputBox(f){this.m.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const I=this.h.get(P.ExtensionIdentifier.toKey(f.identifier)),R=I&&I[I.length-1];return R&&R.inputBox}$provideOriginalResource(f,I,R){const B=c.URI.revive(I);this.m.trace("ExtHostSCM#$provideOriginalResource",f,B.toString());const X=this.g.get(f);return!X||!X.quickDiffProvider||!X.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>X.quickDiffProvider.provideOriginalResource(B,R)).then(q=>q||null)}$onInputBoxValueChange(f,I){this.m.trace("ExtHostSCM#$onInputBoxValueChange",f);const R=this.g.get(f);return R&&R.inputBox.$onInputBoxValueChange(I),Promise.resolve(void 0)}$executeResourceCommand(f,I,R,B){this.m.trace("ExtHostSCM#$executeResourceCommand",f,I,R);const X=this.g.get(f);if(!X)return Promise.resolve(void 0);const q=X.getResourceGroup(I);return q?q.$executeResourceCommand(R,B):Promise.resolve(void 0)}$validateInput(f,I,R){this.m.trace("ExtHostSCM#$validateInput",f);const B=this.g.get(f);return!B||!B.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>B.inputBox.validateInput(I,R)).then(X=>{if(!X)return Promise.resolve(void 0);const q=D.MarkdownString.fromStrict(X.message);return q?Promise.resolve([q,X.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}};n.d=0,n=qe([He(2,L.ILogService)],n),e.ExtHostSCM=n}),define(ye[97],Ce([1,0,5,4,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(T){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=T.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,S){return this.a.$getPassword(T,S)}store(T,S,y){return this.a.$setPassword(T,S,y)}delete(T,S){return this.a.$deletePassword(T,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[264],Ce([1,0,7,5,176,6,14,11]),function(ne,e,c,t,k,A,C,T){"use strict";var S,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(E,d,m,h,b=c.StatusBarAlignment.Left,p){S.set(this,void 0),y.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new A.DisposableStore,Je(this,S,E,"f"),Je(this,y,d,"f"),this.c=L.a++,this.e=m,this.f=h,this.g=b,this.h=this.t(p)}t(E){if(!!(0,T.isNumber)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(E){this.k=E,this.u()}set name(E){this.m=E,this.u()}set tooltip(E){this.l=E,this.u()}set color(E){this.n=E,this.u()}set backgroundColor(E){E&&!L.b.has(E.id)&&(E=void 0),this.o=E,this.u()}set command(E){this.q?.fromApi!==E&&(this.p.clear(),typeof E=="string"?this.q={fromApi:E,internal:Ue(this,y,"f").toInternal({title:"",command:E},this.p)}:E?this.q={fromApi:E,internal:Ue(this,y,"f").toInternal(E,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(E){this.s=E,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Ue(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let E;this.e?this.f?E=`${this.e.identifier.value}.${this.f}`:E=this.e.identifier.value:E=this.f;let d;this.m?d=this.m:d=(0,k.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=L.b.get(this.o.id));const h=C.MarkdownString.fromStrict(this.l);Ue(this,S,"f").$setEntry(this.c,E,d,this.k,h,this.q?.internal,m,this.o,this.g===c.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=L,S=new WeakMap,y=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(E){this.b=[],this.a=E.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,k.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(E){const d={message:E};return this.b.unshift(d),this.c(),new c.Disposable(()=>{const m=this.b.indexOf(d);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(E,d){this.a=E.getProxy(t.MainContext.MainThreadStatusBar),this.b=d,this.c=new P(this)}createStatusBarEntry(E,d,m,h){return new L(this.a,this.b,E,d,m,h)}setStatusBarMessage(E,d){const m=this.c.setMessage(E);let h;return typeof d=="number"?h=setTimeout(()=>m.dispose(),d):typeof d<"u"&&d.then(()=>m.dispose(),()=>m.dispose()),new c.Disposable(()=>{m.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=v}),define(ye[98],Ce([1,0,5,4,3]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(T,S){this.c=S,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this.a.$registerExtensionStorageKeysToSync(T,S)}async initializeExtensionStorage(T,S,y){const L=await this.a.$initializeExtensionStorage(T,S);let P;return L&&(P=this.d(T,S,L)),P||y}setValue(T,S,y){return this.a.$setValue(T,S,y)}$acceptValue(T,S,y){const L=this.d(T,S,y);L&&this.b.fire({shared:T,key:S,value:L})}d(T,S,y){try{return JSON.parse(y)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${T}): ${L}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(ye[73],Ce([1,0,3,25,13,72,2]),function(ne,e,c,t,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let T=class{constructor(y,L,P){this.d=L,this.f=P,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(y){return C.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,L=await this.g(y);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(C.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(y){if(this.c)return C.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return C.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=qe([He(0,t.IExtHostInitDataService),He(1,k.ILogService),He(2,A.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(ye[40],Ce([1,0,4,5,3,2,16,6,7,177,10,222,21,30,207,90,11,18,14]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class p{constructor(n,r,f,I){this.k=n,this._id=r,this.l=f,this.m=I,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(B=>this.f=B);const R=this;this.value={get name(){return R.m||""},get processId(){return R.b},get creationOptions(){return R.l},get exitStatus(){return R.h},get state(){return R.j},sendText(B,X=!0){R.o(),R.k.$sendText(R._id,B,X)},show(B){R.o(),R.k.$show(R._id,B)},hide(){R.o(),R.k.$hide(R._id)},dispose(){R.a||(R.a=!0,R.k.$dispose(R._id))},get dimensions(){if(!(R.d===void 0||R.g===void 0))return{columns:R.d,rows:R.g}}}}async create(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,m.withNullAsUndefined)(n.shellPath),shellArgs:(0,m.withNullAsUndefined)(n.shellArgs),cwd:(0,m.withNullAsUndefined)(n.cwd),env:(0,m.withNullAsUndefined)(n.env),icon:(0,m.withNullAsUndefined)(l(n.iconPath)),color:d.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,m.withNullAsUndefined)(n.message),strictEnv:(0,m.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,m.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,m.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,m.withNullAsUndefined)(r?.useShellEnvironment),location:r?.location||this.n(n.location,r?.resolvedExtHostIdentifier),isTransient:(0,m.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,r,f,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:f,color:d.ThemeColor.isThemeColor(I)?I.id:void 0,location:this.n(n,r),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,r){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&r?{parentTerminal:r}:"viewColumn"in n?{viewColumn:b.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,r){this.h=Object.freeze({code:n,reason:r})}setDimensions(n,r){return n===this.d&&r===this.g||n===0||r===0?!1:(this.d=n,this.g=r,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(r=>{r!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=p;class g{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new c.Emitter,this.onProcessData=this.a.event,this.b=new c.Emitter,this.d=new c.Emitter,this.onDidChangeProperty=this.d.event,this.f=new c.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,r){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${r}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,r){this.g.setDimensions?.({columns:n,rows:r})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(r=>this.a.fire(r)),this.g.onDidClose?.((r=void 0)=>{this.f.fire(r===void 0?void 0:r)}),this.g.onDidOverrideDimensions?.(r=>{r&&this.d.fire({type:"overrideDimensions",value:{cols:r.columns,rows:r.rows}})}),this.g.onDidChangeName?.(r=>{this.d.fire({type:"title",value:r})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let w=1,i=class extends T.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,r){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new c.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new c.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new c.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new c.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new c.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new c.Emitter,this.onDidChangeShell=this.J.event,this.a=r.getProxy(t.MainContext.MainThreadTerminalService),this.s=new E.TerminalDataBufferer(this.a.$sendProcessData),this.I=new c.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[f,I]of this.g)I.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,r){const f=new p(this.a,(0,D.generateUuid)(),n,n.name),I=new g(n.pty);return f.createExtensionTerminal(n.location,this.L(n,r).resolvedExtHostIdentifier,l(n.iconPath),s(n.color)).then(R=>{const B=this.M(R,I);this.h[R]=B}),this.f.push(f),f.value}L(n,r){if(r=r||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const f=n.location.parentTerminal;if(f){const I=this.f.find(R=>R.value===f);I&&(r.resolvedExtHostIdentifier=I._id)}}else n.location&&typeof n.location!="object"?r.location=n.location:r.location&&typeof r.location=="object"&&"splitActiveTerminal"in r.location&&(r.location={splitActiveTerminal:!0});return r}attachPtyToTerminal(n,r){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const I=new g(r),R=this.M(n,I);this.h[n]=R}async $acceptActiveTerminalChanged(n){const r=this.b;if(n===null){this.b=void 0,r!==this.b&&this.F.fire(this.b);return}const f=this.O(n);f&&(this.b=f,r!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,r){const f=this.O(n);f&&this.I.fire({terminal:f.value,data:r})}async $acceptTerminalDimensions(n,r,f){const I=this.O(n);I&&I.setDimensions(r,f)&&this.G.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptTerminalMaximumDimensions(n,r,f){this.g.get(n)?.resize(r,f)}async $acceptTerminalTitleChange(n,r){const f=this.O(n);f&&(f.name=r)}async $acceptTerminalClosed(n,r,f){const I=this.Q(this.f,n);if(I!==null){const R=this.f.splice(I,1)[0];R.setExitStatus(r,f),this.C.fire(R.value)}}$acceptTerminalOpened(n,r,f,I){if(r){const X=this.Q(this.f,r);if(X!==null){this.f[X]._id=n,this.D.fire(this.terminals[X]),this.f[X].isOpen=!0;return}}const R={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:A.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},B=new p(this.a,n,R,f);this.f.push(B),this.D.fire(B.value),B.isOpen=!0}async $acceptTerminalProcessId(n,r){this.O(n)?._setProcessId(r)}async $startExtensionTerminal(n,r){const f=this.O(n);if(!f)return{message:(0,y.localize)(0,null,n)};f.isOpen||await new Promise(R=>{const B=this.onDidOpenTerminal(async X=>{X===f.value&&(B.dispose(),R())})});const I=this.g.get(n);I?I.startSendingEvents(r):this.j[n]={initialDimensions:r}}M(n,r){const f=new T.DisposableStore;f.add(r.onProcessReady(R=>this.a.$sendProcessReady(n,R.pid,R.cwd))),f.add(r.onDidChangeProperty(R=>this.a.$sendProcessProperty(n,R))),this.s.startBuffering(n,r.onProcessData),f.add(r.onProcessExit(R=>this.N(n,R))),this.g.set(n,r);const I=this.j[n];return I&&r instanceof g&&(r.startSendingEvents(I.initialDimensions),delete this.j[n]),f}$acceptProcessAckDataEvent(n,r){this.g.get(n)?.acknowledgeDataEvent(r)}$acceptProcessInput(n,r){this.g.get(n)?.input(r)}$acceptTerminalInteraction(n){const r=this.O(n);r?.setInteractedWith()&&this.H.fire(r.value)}$acceptProcessResize(n,r,f){try{this.g.get(n)?.resize(r,f)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(n,r){this.g.get(n)?.shutdown(r)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(r=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:r}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(r=>this.a.$sendProcessProperty(n,{type:"cwd",value:r}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,r,f){if(this.v.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this.v.set(r,f),this.a.$registerProfileProvider(r,n.identifier.value),new S.Disposable(()=>{this.v.delete(r),this.a.$unregisterProfileProvider(r)})}registerTerminalQuickFixProvider(n,r,f){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,f),this.a.$registerQuickFixProvider(n,r),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,r){const f=new v.CancellationTokenSource().token;if(f.isCancellationRequested)return;const I=this.w.get(n);if(!I)return;const R=await I.provideTerminalQuickFixes(r,f);if(R!==null)return R}async $createContributedProfileTerminal(n,r){const f=new v.CancellationTokenSource().token;let I=await this.v.get(n)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,r);return}this.createTerminalFromOptions(I.options,r)}}async $provideLinks(n,r){const f=this.O(n);if(!f)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const R=new v.CancellationTokenSource;this.z.set(n,R);const B=[],X={terminal:f.value,line:r},q=[];for(const F of this.u)q.push(h.Promises.withAsyncBody(async z=>{R.token.onCancellationRequested(()=>z({provider:F,links:[]}));const U=await F.provideTerminalLinks(X,R.token)||[];R.token.isCancellationRequested||z({provider:F,links:U})}));const N=await Promise.all(q);if(R.token.isCancellationRequested)return[];const M=new Map;for(const F of N)F&&F.links.length>0&&B.push(...F.links.map(z=>{const U={id:w++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return M.set(U.id,{provider:F.provider,link:z}),U}));return this.y.set(n,M),B}$activateLink(n,r){const f=this.y.get(n)?.get(r);!f||f.provider.handleTerminalLink(f.link)}N(n,r){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const f=this.h[n];f&&(f.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,r)}O(n){return this.P(this.f,n)}P(n,r){const f=this.Q(n,r);return f!==null?n[f]:null}Q(n,r){let f=null;return n.some((I,R)=>I._id===r?(f=R,!0):!1),f}getEnvironmentVariableCollection(n){let r=this.l.get(n.identifier.value);return r||(r=new o,this.S(n.identifier.value,r)),r}R(n,r){const f=(0,P.serializeEnvironmentVariableCollection)(r.map);this.a.$setEnvironmentVariableCollection(n,r.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(n){n.forEach(r=>{const f=r[0],I=new o(r[1]);this.S(f,I)})}$acceptDefaultProfile(n,r){const f=this.m;this.m=n,this.n=r,f?.path!==n.path&&this.J.fire(n.path)}S(n,r){this.l.set(n,r),r.onDidChangeCollection(()=>{this.R(n,r)})}};i=qe([He(1,C.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class o{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new c.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,r){this.d(n,{value:r,type:S.EnvironmentVariableMutatorType.Replace})}append(n,r){this.d(n,{value:r,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,r){this.d(n,{value:r,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,r){const f=this.map.get(n);(!f||f.value!==r.value||f.type!==r.type)&&(this.map.set(n,r),this.b.fire())}get(n){return this.map.get(n)}forEach(n,r){this.map.forEach((f,I)=>n.call(r,I,f,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let u=class extends i{constructor(n){super(!1,n)}createTerminal(n,r,f){throw new L.NotSupportedError}createTerminalFromOptions(n,r){throw new L.NotSupportedError}};u=qe([He(0,C.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u;function l(a){if(!(!a||typeof a=="string"))return"id"in a?{id:a.id,color:a.color}:a}function s(a){return d.ThemeColor.isThemeColor(a)?a:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c};define(ye[265],Ce([1,0,17,18,22,21,4,61,85,6,23,11,30,5,16,137,14,7,56,92,70]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p,g){"use strict";var w,i;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(M,F,z){this.j=z,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=M.getProxy(D.MainContext.MainThreadTesting),this.h=new B(this.f),this.g=new a(this.f),F.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==15)return U;const H=U,x=H.tests[H.tests.length-1].item.extId;return this.d.get(b.TestId.root(x))?.collection.tree.get(x)?.actual??(0,d.toItemFromContext)(U)}})}createTestController(M,F,z){if(this.d.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const U=new y.DisposableStore,H=U.add(new d.ExtHostTestItemCollection(M,F,this.j));H.root.label=F;const x=new Map,V=this.f,_={items:H.root.children,get label(){return F},set label(Z){F=Z,H.root.label=Z,V.$updateController(M,{label:F})},get refreshHandler(){return z},set refreshHandler(Z){z=Z,V.$updateController(M,{canRefresh:!!Z})},get id(){return M},createRunProfile:(Z,ge,te,J,fe)=>{let ve=(0,S.hash)(Z);for(;x.has(ve);)ve++;return new X(this.f,x,M,ve,Z,ge,te,J,fe)},createTestItem(Z,ge,te){return new d.TestItemImpl(M,Z,ge,te)},createTestRun:(Z,ge,te=!0)=>this.g.createTestRun(M,H,Z,ge,te),set resolveHandler(Z){H.resolveHandler=Z},get resolveHandler(){return H.resolveHandler},dispose:()=>{U.dispose()}};V.$registerTestController(M,F,!!z),U.add((0,y.toDisposable)(()=>V.$unregisterTestController(M)));const Q={controller:_,collection:H,profiles:x};return this.d.set(M,Q),U.add((0,y.toDisposable)(()=>this.d.delete(M))),U.add(H.onDidGenerateDiff(Z=>V.$publishDiff(M,Z.map(g.TestsDiffOp.serialize)))),_}createTestObserver(){return this.h.checkout()}async runTests(M,F=A.CancellationToken.None){const z=n(M);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.d.get(z.controllerId);if(!U)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(H=>b.TestId.fromExtHostTestItem(H,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:q[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:M.exclude?.map(H=>H.id)},F)}$syncTests(){for(const{collection:M}of this.d.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,F,z){return(0,c.mapFind)(this.g.trackers,H=>H.id===M?H.getCoverage(F):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(M,F,z,U){return(0,c.mapFind)(this.g.trackers,x=>x.id===M?x.getCoverage(F):void 0)?.resolveFileCoverage(z,U)??Promise.resolve([])}$configureRunProfile(M,F){this.d.get(M)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(M,F){await this.d.get(M)?.controller.refreshHandler?.(F)}$publishTestResults(M){this.results=Object.freeze(M.map(F=>(0,L.deepFreeze)(m.TestResults.to(F))).concat(this.results).sort((F,z)=>z.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(M,F){const z=this.d.get(b.TestId.fromString(M).controllerId)?.collection;z&&(await z.expand(M,F<0?1/0:F),z.flushDiff())}$acceptDiff(M){this.h.applyDiff(M.map(g.TestsDiffOp.deserialize))}async $runControllerTests(M,F){return Promise.all(M.map(z=>this.runControllerTestRequest(z,F)))}async runControllerTestRequest(M,F){const z=this.d.get(M.controllerId);if(!z)return{};const{collection:U,profiles:H}=z,x=H.get(M.profileId);if(!x)return{};const V=M.testIds.map(ge=>U.tree.get(ge)).filter(P.isDefined),_=M.excludeExtIds.map(ge=>z.collection.tree.get(ge)).filter(P.isDefined).filter(ge=>V.some(te=>te.fullId.compare(ge.fullId)===2));if(!V.length)return{};const Q=new h.TestRunRequest(V.some(ge=>ge.actual instanceof d.TestItemRootImpl)?void 0:V.map(ge=>ge.actual),_.map(ge=>ge.actual),x),Z=this.g.prepareForMainThreadTestRun(Q,r.fromInternal(M,z.collection),F);try{return await x.runHandler(Q,F),{}}catch(ge){return{error:String(ge)}}finally{Z.hasRunningTasks&&!F.isCancellationRequested&&await C.Event.toPromise(Z.onEnd),Z.dispose()}}$cancelExtensionTestRun(M){M===void 0?this.g.cancelAllRuns():this.g.cancelRunById(M)}};o=qe([He(0,E.IExtHostRpcService)],o),e.ExtHostTesting=o;const u=1e4;var l;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(l||(l={}));class s extends y.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(M,F,z){super(),this.k=M,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new A.CancellationTokenSource(z));const U=this.B(new t.RunOnceScheduler(()=>this.m(),u));this.B(this.h.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const F=this.k.id,z=this.k.controllerId,U=(0,v.generateUuid)(),H=new f(this.l,F,U),x=Z=>(ge,...te)=>{if(_){console.warn(`Setting the state of test "${ge.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(ge)||(this.s(ge),Z(ge,...te))},V=(Z,ge)=>{const te=ge instanceof Array?ge.map(m.TestMessage.from):[m.TestMessage.from(ge)];if(Z.uri&&Z.range){const J={range:m.Range.from(Z.range),uri:Z.uri};for(const fe of te)fe.location=fe.location||J}this.l.$appendTestMessagesInRun(F,U,b.TestId.fromExtHostTestItem(Z,z).toString(),te)};let _=!1;const Q={isPersisted:this.k.isPersisted,token:this.h.token,name:M,get coverageProvider(){return H.coverageProvider},set coverageProvider(Z){H.coverageProvider=Z},enqueued:x(Z=>{this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(Z,z).toString(),1)}),skipped:x(Z=>{this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(Z,z).toString(),5)}),started:x(Z=>{this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(Z,z).toString(),2)}),errored:x((Z,ge,te)=>{V(Z,ge),this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(Z,z).toString(),6,te)}),failed:x((Z,ge,te)=>{V(Z,ge),this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(Z,z).toString(),4,te)}),passed:x((Z,ge)=>{this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(Z,this.k.controllerId).toString(),3,ge)}),appendOutput:(Z,ge,te)=>{_||(te&&(this.k.isIncluded(te)?this.s(te):te=void 0),this.l.$appendOutputToRun(F,U,k.VSBuffer.fromString(Z),ge&&m.location.from(ge),te&&b.TestId.fromExtHostTestItem(te,z).toString()))},end:()=>{_||(_=!0,this.l.$finishedTestRunTask(F,U),this.f.delete(U),this.f.size||this.p())}};return this.f.set(U,{run:Q,coverage:H}),this.l.$startedTestRunTask(F,{id:U,name:M,running:!0}),Q}m(){for(const{run:M}of this.f.values())M.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(M){if(!(M instanceof d.TestItemImpl))throw new p.InvalidTestItemError(M.id);if(this.g.has(b.TestId.fromExtHostTestItem(M,this.k.controllerId).toString()))return;const F=[],z=this.k.colllection.root;for(;;){const U=m.TestItem.from(M);if(F.unshift(U),this.g.has(U.extId)||(this.g.add(U.extId),M===z))break;M=M.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class a{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,F,z){return this.f(M,F,z)}cancelRunById(M){for(const F of this.c.values())if(F.id===M){F.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,F,z,U,H){const x=this.c.get(z);if(x)return x.createRun(U);const V=r.fromPublic(M,F,z,H),_=n(z);this.d.$startedExtensionTestRun({controllerId:M,profile:_&&{group:q[_.kind],id:_.profileId},exclude:z.exclude?.map(Z=>b.TestId.fromExtHostTestItem(Z,F.root.id).toString())??[],id:V.id,include:z.include?.map(Z=>b.TestId.fromExtHostTestItem(Z,F.root.id).toString())??[F.root.id],persist:H});const Q=this.f(z,V);return Q.onEnd(()=>{this.d.$finishedExtensionTestRun(V.id),Q.dispose()}),Q.createRun(U)}f(M,F,z){const U=new s(F,this.d,z);return this.c.set(M,U),U.onEnd(()=>this.c.delete(M)),U}}e.TestRunCoordinator=a;const n=N=>{if(!!N.profile){if(!(N.profile instanceof X))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class r{static fromPublic(M,F,z,U){return new r(M,(0,v.generateUuid)(),z.include?.map(H=>b.TestId.fromExtHostTestItem(H,M).toString())??[M],z.exclude?.map(H=>b.TestId.fromExtHostTestItem(H,M).toString())??[],U,F)}static fromInternal(M,F){return new r(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,F)}constructor(M,F,z,U,H,x){this.controllerId=M,this.id=F,this.isPersisted=H,this.colllection=x,this.c=z.map(V=>V+"\0"),this.d=U.map(V=>V+"\0")}isIncluded(M){const F=b.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const z of this.d)if(F===z||F.startsWith(z))return!1;for(const z of this.c)if(F===z||F.startsWith(z))return!0;return!1}}e.TestRunDto=r;class f{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,F,z){this.f=M,this.g=F,this.h=z}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(m.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(M,F){const z=await this.d;let U=z?.[M];return!this.c||!z||!U?[]:(U.detailedCoverage||(U=z[M]=await this.c.resolveFileCoverage?.(U,F)??U),U.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class I{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,m.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const F=b.TestId.parentId(M.item.extId);if(F&&this.g.has(F.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:F,f:z}=this;return{get added(){return[...M].map(U=>U.revived)},get updated(){return[...F].map(U=>U.revived)},get removed(){return[...z].map(U=>U.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class R extends g.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,F){return{...M,revived:m.TestItem.toPlain(M.item),depth:F?F.depth+1:0,children:new Set}}o(){return new I(this.q)}}e.MirroredTestCollection=R;class B{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(F=>F.revived)},dispose:(0,T.once)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new R;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class X{get label(){return this.d}set label(M){M!==this.d&&(this.d=M,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?m.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,F,z,U,H,x,V,_=!1,Q=void 0){this.controllerId=z,this.profileId=U,this.d=H,this.kind=x,this.runHandler=V,this.f=_,this._tag=Q,w.set(this,void 0),i.set(this,void 0),Je(this,w,M,"f"),Je(this,i,F,"f"),F.set(U,this);const Z=q[x];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Ue(this,w,"f").$publishTestRunProfile({profileId:U,controllerId:z,tag:Q?m.TestTag.namespace(this.controllerId,Q.id):null,label:H,group:Z,isDefault:_,hasConfigurationHandler:!1})}dispose(){Ue(this,i,"f")?.delete(this.profileId)&&(Je(this,i,void 0,"f"),Ue(this,w,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=X,w=new WeakMap,i=new WeakMap;const q={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(ye[266],Ce([1,0,17,4,5,138,14,7]),function(ne,e,c,t,k,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(L,P){this.i=P,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(k.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const P=this.i.allEditors();return L?P:P.map(v=>v.value)}async showTextDocument(L,P,v){let D;typeof P=="number"?D={position:C.ViewColumn.from(P),preserveFocus:v}:typeof P=="object"?D={position:C.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?C.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:D={preserveFocus:!1};const E=await this.h.$tryShowTextDocument(L.uri,D),d=E&&this.i.getEditor(E);if(d)return d.value;throw E?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,P){return new A.TextEditorDecorationType(this.h,L,P).value}$acceptEditorPropertiesChanged(L,P){const v=this.i.getEditor(L);if(!v)throw new Error("unknown text editor");if(P.options&&v._acceptOptions(P.options),P.selections){const D=P.selections.selections.map(C.Selection.to);v._acceptSelections(D)}if(P.visibleRanges){const D=c.coalesce(P.visibleRanges.map(C.Range.to));v._acceptVisibleRanges(D)}if(P.options&&this.b.fire({textEditor:v.value,options:{...P.options,lineNumbers:C.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const D=T.TextEditorSelectionChangeKind.fromValue(P.selections.source),E=P.selections.selections.map(C.Selection.to);this.a.fire({textEditor:v.value,selections:E,kind:D})}if(P.visibleRanges){const D=c.coalesce(P.visibleRanges.map(C.Range.to));this.c.fire({textEditor:v.value,visibleRanges:D})}}$acceptEditorPositionData(L){for(const P in L){const v=this.i.getEditor(P);if(!v)throw new Error("Unknown text editor");const D=C.ViewColumn.to(L[P]);v.value.viewColumn!==D&&(v._acceptViewColumn(D),this.d.fire({textEditor:v.value,viewColumn:D}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=S}),define(ye[267],Ce([1,0,2,3,5,6,7,14,11]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class y{constructor(v,D){this.b=new Map,this.c=new Map,this.a=v.getProxy(k.MainContext.MainThreadTimeline),D.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===12){const d=E.uri===void 0?void 0:c.URI.revive(E.uri);return this.c.get(E.source)?.get(L(d))?.get(E.handle)}return E}})}async $getTimeline(v,D,E,d){return this.b.get(v)?.provideTimeline(c.URI.revive(D),E,d)}registerTimelineProvider(v,D,E,d){const m=new A.DisposableStore,h=this.d(D.id,d,m).bind(this);let b;D.onDidChange&&(b=D.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:D.id}),this));const p=this.c;return this.f({...D,scheme:v,onDidChange:void 0,async provideTimeline(g,w,i){w?.resetCache&&(m.clear(),p.get(D.id)?.clear());const o=await D.provideTimeline(g,w,i);if(o==null)return;const u=h(g,w);return{...o,source:D.id,items:o.items.map(u)}},dispose(){for(const g of p.values())g.get(D.id)?.clear();b?.dispose(),m.dispose()}})}d(v,D,E){return(d,m)=>{let h;if(m?.cacheResults){let b=this.c.get(v);b===void 0&&(b=new Map,this.c.set(v,b));const p=L(d);h=b.get(p),h===void 0&&(h=new Map,b.set(p,h))}return b=>{const{iconPath:p,...g}=b,w=`${v}|${b.id??b.timestamp}`;h?.set(w,b);let i,o,u;b.iconPath&&(p instanceof C.ThemeIcon?u={id:p.id,color:p.color}:c.URI.isUri(p)?(i=p,o=p):{light:i,dark:o}=p);let l;return C.MarkdownString.isMarkdownString(g.tooltip)?l=T.MarkdownString.from(g.tooltip):(0,S.isString)(g.tooltip)?l=g.tooltip:C.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=T.MarkdownString.from(g.detail)):(0,S.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=g.detail),{...g,id:g.id??void 0,handle:w,source:v,command:b.command?D.toInternal(b.command,E):void 0,icon:i,iconDark:o,themeIcon:u,tooltip:l,accessibilityInformation:b.accessibilityInformation}}}}f(v){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,v),(0,A.toDisposable)(()=>{for(const E of this.c.values())E.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.ExtHostTimeline=y;function L(P){return P?.toString()}}),define(ye[268],Ce([1,0,6,15,2,5]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,y,L,P){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const v=P.schemes.find(D=>!C.a.has(D));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(y,L),this.b.$registerUriOpener(y,P.schemes,S,P.label),(0,c.toDisposable)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri(S,y,L){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const v=k.URI.revive(y);return P.canOpenExternalUri(v,L)}async $openUri(S,y,L){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(k.URI.revive(y.resolvedUri),{sourceUri:k.URI.revive(y.sourceUri)},L)}}e.ExtHostUriOpeners=C,C.a=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[269],Ce([1,0,5,2,6,10,27]),function(ne,e,c,t,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(y){this.c=new Set,this.d=new Map,this.b=y.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(y,L){if(this.c.has(C.ExtensionIdentifier.toKey(y)))throw new Error(`Protocol handler already registered for extension ${y}`);const P=T.a++;return this.c.add(C.ExtensionIdentifier.toKey(y)),this.d.set(P,L),this.b.$registerUriHandler(P,y),(0,k.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(y)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(y,L){const P=this.d.get(y);if(!P)return Promise.resolve(void 0);try{P.handleUri(t.URI.revive(L))}catch(v){(0,A.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(y){return t.URI.revive(await this.b.$createAppUri(y))}}e.ExtHostUrls=T,T.a=0});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[74],Ce([1,0,4,15,23,2,192,214,93,5]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";var L,P,v,D,E,d,m,h,b,p,g,w,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(R,B,X,q,N,M,F){L.set(this,void 0),P.set(this,void 0),v.set(this,void 0),D.set(this,void 0),E.set(this,void 0),d.set(this,void 0),m.set(this,""),h.set(this,void 0),b.set(this,!1),p.set(this,!1),g.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new c.Emitter),this._onDidDispose=Ue(this,i,"f").event,Je(this,L,R,"f"),Je(this,P,B,"f"),Je(this,h,X,"f"),Je(this,D,q,"f"),Je(this,E,N,"f"),Je(this,d,M,"f"),Je(this,g,u(M),"f"),Je(this,w,l(M),"f"),Je(this,v,F,"f")}dispose(){Je(this,b,!0,"f"),Ue(this,i,"f").fire(),Ue(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(R){return Je(this,p,!0,"f"),(0,S.asWebviewUri)(R,Ue(this,D,"f"))}get cspSource(){const R=Ue(this,d,"f").extensionLocation;if(R.scheme===t.Schemas.https||R.scheme===t.Schemas.http){let B=R.toString();return B.endsWith("/")||(B+="/"),B+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Ue(this,m,"f")}set html(R){this.a(),Ue(this,m,"f")!==R&&(Je(this,m,R,"f"),Ue(this,w,"f")&&!Ue(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(R)&&(Je(this,p,!0,"f"),Ue(this,v,"f").report("Webview vscode-resource: uris",Ue(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,P,"f").$setHtml(Ue(this,L,"f"),this.b(R)))}get options(){return this.a(),Ue(this,h,"f")}set options(R){this.a(),k.equals(Ue(this,h,"f"),R)||Ue(this,P,"f").$setOptions(Ue(this,L,"f"),n(Ue(this,d,"f"),Ue(this,E,"f"),R)),Je(this,h,R,"f")}async postMessage(R){if(Ue(this,b,"f"))return!1;const B=(0,T.serializeWebviewMessage)(R,{serializeBuffersForPostMessage:Ue(this,g,"f")});return Ue(this,P,"f").$postMessage(Ue(this,L,"f"),B.message,...B.buffers)}a(){if(Ue(this,b,"f"))throw new Error("Webview is disposed")}b(R){if(!Ue(this,w,"f"))return R;const B=Ue(this,d,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,X=Ue(this,d,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Ue(this,d,"f").extensionLocation.authority:void 0;return R.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,N,M,F,z,U)=>{const H=A.URI.from({scheme:F||"file",path:decodeURIComponent(z)}),x=(0,S.asWebviewUri)(H,{isRemote:B,authority:X}).toString();return`${N}${x}${U}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,N,M,F,z,U)=>{const H=A.URI.from({scheme:F||"file",path:decodeURIComponent(z)}),x=(0,S.asWebviewUri)(H,{isRemote:B,authority:X}).toString();return`${N}${x}${U}`})}}e.ExtHostWebview=o,L=new WeakMap,P=new WeakMap,v=new WeakMap,D=new WeakMap,E=new WeakMap,d=new WeakMap,m=new WeakMap,h=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,w=new WeakMap,i=new WeakMap;function u(I){try{const R=(0,C.normalizeVersion)((0,C.parseVersion)(I.engines.vscode));return!!R&&R.majorBase>=1&&R.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=u;function l(I){try{const R=(0,C.normalizeVersion)((0,C.parseVersion)(I.engines.vscode));return R?R.majorBase<1||R.majorBase===1&&R.minorBase<60:!1}catch{return!1}}class s{constructor(R,B,X,q,N){this.c=B,this.d=X,this.e=q,this.f=N,this.b=new Map,this.a=R.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(R,B,X){const q=this.g(R);if(q){const{message:N}=(0,T.deserializeWebviewMessage)(B,X.value);q._onMessageEmitter.fire(N)}}$onMissingCsp(R,B){this.e.warn(`${B} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(R,B,X){const q=new o(R,this.a,r(B),this.c,this.d,X,this.f);return this.b.set(R,q),q._onDidDispose(()=>{this.b.delete(R)}),q}deleteWebview(R){this.b.delete(R)}g(R){return this.b.get(R)}}e.ExtHostWebviews=s;function a(I){return{id:I.identifier,location:I.extensionLocation}}e.toExtensionData=a;function n(I,R,B){return{enableCommandUris:B.enableCommandUris,enableScripts:B.enableScripts,enableForms:B.enableForms,portMapping:B.portMapping,localResourceRoots:B.localResourceRoots||f(I,R)}}e.serializeWebviewOptions=n;function r(I){return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,enableForms:I.enableForms,portMapping:I.portMapping,localResourceRoots:I.localResourceRoots?.map(R=>A.URI.from(R))}}function f(I,R){return[...(R?.getWorkspaceFolders()||[]).map(B=>B.uri),I.extensionLocation]}}),define(ye[270],Ce([1,0,21,85,6,15,24,2,14,74,69,5,7]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class D{constructor(o,u){this.document=o,this.b=u,this.a=1,this.c=new L.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,u){await this.f(o).undo(),u||this.disposeBackup()}async redo(o,u){await this.f(o).redo(),u||this.disposeBackup()}disposeEdits(o){for(const u of o)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=w(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const u=this.c.get(o,0);if(!u)throw new Error("No edit found");return u}}class E{constructor(){this.a=new Map}get(o,u){return this.a.get(this.b(o,u))}add(o,u,l){const s=this.b(o,u.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${o} resource:${u.uri}`);const a=new D(u,l);return this.a.set(s,a),a}delete(o,u){const l=this.b(o,u.uri);this.a.delete(l)}b(o,u){return`${o}@@@${u}`}}var d;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(d||(d={}));class m{constructor(){this.a=new Map}addTextProvider(o,u,l){return this.b(0,o,u,l)}addCustomProvider(o,u,l){return this.b(1,o,u,l)}get(o){return this.a.get(o)}b(o,u,l,s){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:o,extension:l,provider:s}),new v.Disposable(()=>this.a.delete(u))}}class h{constructor(o,u,l,s,a){this.d=u,this.f=l,this.g=s,this.h=a,this.b=new m,this.c=new E,this.a=o.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,u,l,s){const a=new k.DisposableStore;return p(l)?(a.add(this.b.addTextProvider(u,o,l)),this.a.$registerTextEditorProvider((0,y.toExtensionData)(o),u,s.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,y.shouldSerializeBuffersForPostMessage)(o))):(a.add(this.b.addCustomProvider(u,o,l)),b(l)&&a.add(l.onDidChangeCustomDocument(n=>{const r=this.i(u,n.document.uri);if(g(n)){const f=r.addEdit(n);this.a.$onDidEdit(n.document.uri,u,f,n.label)}else this.a.$onContentChange(n.document.uri,u)})),this.a.$registerCustomEditorProvider((0,y.toExtensionData)(o),u,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,y.shouldSerializeBuffersForPostMessage)(o))),v.Disposable.from(a,new v.Disposable(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(o,u,l,s,a){const n=this.b.get(u);if(!n)throw new Error(`No provider found for '${u}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${u}'`);const r=T.URI.revive(o),f=await n.provider.openCustomDocument(r,{backupId:l,untitledDocumentData:s?.buffer},a);let I;return b(n.provider)&&this.f&&(I=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(u,f,I),{editable:b(n.provider)}}async $disposeCustomDocument(o,u){const l=this.b.get(u);if(!l)throw new Error(`No provider found for '${u}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${u}'`);const s=T.URI.revive(o),{document:a}=this.i(u,s);this.c.delete(u,a),a.dispose()}async $resolveCustomEditor(o,u,l,s,a,n){console.log("xxxx");const r=this.b.get(l);if(!r)throw new Error(`No provider found for '${l}'`);const f=S.ViewColumn.to(a),I=this.g.createNewWebview(u,s.contentOptions,r.extension),R=this.h.createNewWebviewPanel(u,l,s.title,f,s.options,I,!0),B=T.URI.revive(o);switch(r.type){case 1:{const{document:X}=this.i(l,B);return r.provider.resolveCustomEditor(X,R,n)}case 0:{const X=this.d.getDocument(B);return r.provider.resolveCustomTextEditor(X,R,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,u,l){this.i(u,o).disposeEdits(l)}async $onMoveCustomEditor(o,u,l){const s=this.b.get(l);if(!s)throw new Error(`No provider found for '${l}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const a=this.h.getWebviewPanel(o);if(!a)throw new Error("No webview found");const n=T.URI.revive(u),r=this.d.getDocument(n);await s.provider.moveCustomTextEditor(r,a,c.CancellationToken.None)}async $undo(o,u,l,s){return this.i(u,o).undo(l,s)}async $redo(o,u,l,s){return this.i(u,o).redo(l,s)}async $revert(o,u,l){const s=this.i(u,o);await this.j(u).revertCustomDocument(s.document,l),s.disposeBackup()}async $onSave(o,u,l){const s=this.i(u,o);await this.j(u).saveCustomDocument(s.document,l),s.disposeBackup()}async $onSaveAs(o,u,l,s){const a=this.i(u,o);return this.j(u).saveCustomDocumentAs(a.document,T.URI.revive(l),s)}async $backup(o,u,l){const s=this.i(u,o),n=await this.j(u).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},l);return s.updateBackup(n),n.id}i(o,u){const l=this.c.get(o,T.URI.revive(u));if(!l)throw new Error("No custom document found");return l}j(o){const l=this.b.get(o)?.provider;if(!l||!b(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=h;function b(i){return!!i.onDidChangeCustomDocument}function p(i){return typeof i.resolveCustomTextEditor=="function"}function g(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function w(i){const o=i.scheme===A.Schemas.file||i.scheme===A.Schemas.untitled?i.fsPath:i.toString();return(0,t.hash)(o)+""}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[271],Ce([1,0,4,6,2,30,14,74,5,7]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";var L,P,v,D,E,d,m,h,b,p,g,w,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends t.Disposable{constructor(a,n,r,f){super(),L.set(this,void 0),P.set(this,void 0),v.set(this,void 0),D.set(this,void 0),E.set(this,void 0),d.set(this,void 0),m.set(this,void 0),h.set(this,void 0),b.set(this,!0),p.set(this,void 0),g.set(this,!1),w.set(this,this.B(new c.Emitter)),this.onDidDispose=Ue(this,w,"f").event,i.set(this,this.B(new c.Emitter)),this.onDidChangeViewState=Ue(this,i,"f").event,Je(this,L,a,"f"),Je(this,P,n,"f"),Je(this,D,r,"f"),Je(this,v,f.viewType,"f"),Je(this,E,f.panelOptions,"f"),Je(this,h,f.viewColumn,"f"),Je(this,d,f.title,"f"),Je(this,p,f.active,"f")}dispose(){Ue(this,g,"f")||(Je(this,g,!0,"f"),Ue(this,w,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,D,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,D,"f")}get viewType(){return this.c(),Ue(this,v,"f")}get title(){return this.c(),Ue(this,d,"f")}set title(a){this.c(),Ue(this,d,"f")!==a&&(Je(this,d,a,"f"),Ue(this,P,"f").$setTitle(Ue(this,L,"f"),a))}get iconPath(){return this.c(),Ue(this,m,"f")}set iconPath(a){this.c(),Ue(this,m,"f")!==a&&(Je(this,m,a,"f"),Ue(this,P,"f").$setIconPath(Ue(this,L,"f"),k.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Ue(this,E,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,h,"f")=="number"&&Ue(this,h,"f")<0))return Ue(this,h,"f")}get active(){return this.c(),Ue(this,p,"f")}get visible(){return this.c(),Ue(this,b,"f")}_updateViewState(a){Ue(this,g,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(Je(this,p,a.active,"f"),Je(this,b,a.visible,"f"),Je(this,h,a.viewColumn,"f"),Ue(this,i,"f").fire({webviewPanel:this}))}reveal(a,n){this.c(),Ue(this,P,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof a>"u"?void 0:C.ViewColumn.from(a),preserveFocus:!!n})}c(){if(Ue(this,g,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,P=new WeakMap,v=new WeakMap,D=new WeakMap,E=new WeakMap,d=new WeakMap,m=new WeakMap,h=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,w=new WeakMap,i=new WeakMap;class u{static c(){return(0,A.generateUuid)()}constructor(a,n,r){this.g=n,this.h=r,this.e=new Map,this.f=new Map,this.d=a.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(a,n,r,f,I={}){const R=typeof f=="object"?f.viewColumn:f,B={viewColumn:C.ViewColumn.from(R),preserveFocus:typeof f=="object"&&!!f.preserveFocus},X=(0,T.shouldSerializeBuffersForPostMessage)(a),q=u.c();this.d.$createWebviewPanel((0,T.toExtensionData)(a),q,n,{title:r,panelOptions:l(I),webviewOptions:(0,T.serializeWebviewOptions)(a,this.h,I),serializeBuffersForPostMessage:X},B);const N=this.g.createNewWebview(q,I,a);return this.createNewWebviewPanel(q,n,r,R,I,N,!0)}$onDidChangeWebviewPanelViewStates(a){const n=Object.keys(a);n.sort((r,f)=>{const I=a[r],R=a[f];return I.active?1:R.active?-1:+I.visible-+R.visible});for(const r of n){const f=this.getWebviewPanel(r);if(!f)continue;const I=a[r];f._updateViewState({active:I.active,visible:I.visible,viewColumn:C.ViewColumn.to(I.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this.e.delete(a),this.g.deleteWebview(a)}registerWebviewPanelSerializer(a,n,r){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:r,extension:a}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(a)}),new y.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(a,n,r,f){const I=this.f.get(n);if(!I)throw new Error(`No serializer found for '${n}'`);const{serializer:R,extension:B}=I,X=this.g.createNewWebview(a,r.webviewOptions,B),q=this.createNewWebviewPanel(a,n,r.title,f,r.panelOptions,X,r.active);await R.deserializeWebviewPanel(q,r.state)}createNewWebviewPanel(a,n,r,f,I,R,B){const X=new o(a,this.d,R,{viewType:n,title:r,viewColumn:f,panelOptions:I,active:B});return this.e.set(a,X),X}getWebviewPanel(a){return this.e.get(a)}}e.ExtHostWebviewPanels=u;function l(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[272],Ce([1,0,4,6,74,14,5,7]),function(ne,e,c,t,k,A,C,T){"use strict";var S,y,L,P,v,D,E,d,m,h,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends t.Disposable{constructor(i,o,u,l,s,a){super(),S.set(this,void 0),y.set(this,void 0),L.set(this,void 0),P.set(this,void 0),v.set(this,!1),D.set(this,void 0),E.set(this,void 0),d.set(this,void 0),m.set(this,void 0),h.set(this,this.B(new c.Emitter)),this.onDidChangeVisibility=Ue(this,h,"f").event,b.set(this,this.B(new c.Emitter)),this.onDidDispose=Ue(this,b,"f").event,Je(this,L,u,"f"),Je(this,E,l,"f"),Je(this,S,i,"f"),Je(this,y,o,"f"),Je(this,P,s,"f"),Je(this,D,a,"f")}dispose(){Ue(this,v,"f")||(Je(this,v,!0,"f"),Ue(this,b,"f").fire(),Ue(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,E,"f")}set title(i){this.a(),Ue(this,E,"f")!==i&&(Je(this,E,i,"f"),Ue(this,y,"f").$setWebviewViewTitle(Ue(this,S,"f"),i))}get description(){return this.a(),Ue(this,d,"f")}set description(i){this.a(),Ue(this,d,"f")!==i&&(Je(this,d,i,"f"),Ue(this,y,"f").$setWebviewViewDescription(Ue(this,S,"f"),i))}get visible(){return Ue(this,D,"f")}get webview(){return Ue(this,P,"f")}get viewType(){return Ue(this,L,"f")}_setVisible(i){i===Ue(this,D,"f")||Ue(this,v,"f")||(Je(this,D,i,"f"),Ue(this,h,"f").fire())}get badge(){return this.a(),Ue(this,m,"f")}set badge(i){this.a(),!(i?.value===Ue(this,m,"f")?.value&&i?.tooltip===Ue(this,m,"f")?.tooltip)&&(Je(this,m,A.ViewBadge.from(i),"f"),Ue(this,y,"f").$setWebviewViewBadge(Ue(this,S,"f"),i))}show(i){this.a(),Ue(this,y,"f").$show(Ue(this,S,"f"),!!i)}a(){if(Ue(this,v,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,y=new WeakMap,L=new WeakMap,P=new WeakMap,v=new WeakMap,D=new WeakMap,E=new WeakMap,d=new WeakMap,m=new WeakMap,h=new WeakMap,b=new WeakMap;class g{constructor(i,o){this.d=o,this.b=new Map,this.c=new Map,this.a=i.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,o,u,l){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:u,extension:i}),this.a.$registerWebviewViewProvider((0,k.toExtensionData)(i),o,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(i)}),new T.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(i,o,u,l,s){const a=this.b.get(o);if(!a)throw new Error(`No view provider found for '${o}'`);const{provider:n,extension:r}=a,f=this.d.createNewWebview(i,{},r),I=new p(i,this.a,o,u,f,!0);this.c.set(i,I),await n.resolveWebviewView(I,{state:l},s)}async $onDidChangeWebviewViewVisibility(i,o){this.e(i)._setVisible(o)}async $disposeWebviewView(i){const o=this.e(i);this.c.delete(i),o.dispose(),this.d.deleteWebview(i)}e(i){const o=this.c.get(i);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=g}),define(ye[141],Ce([1,0,4,5,2,15,8,3,16]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let y=class ri{get state(){return this.d}constructor(P){this.c=new c.Emitter,this.onDidChangeWindowState=this.c.event,this.d=ri.a,this.b=P.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,v){let D;if(typeof P=="string"){D=P;try{P=k.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,C.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,D,v)}async asExternalUri(P,v){if((0,C.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const D=await this.b.$asExternalUri(P,v);return k.URI.from(D)}};y.a={focused:!0},y=qe([He(0,S.IExtHostRpcService)],y),e.ExtHostWindow=y,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(ye[273],Ce([1,0,118,274,65,39,2,13,46]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(v,D,E){this.b=v,this.c=D,this.f=E,this.a=t.createServer((d,m)=>this.h(d,m)),this.g().catch(d=>(D.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,D){const E=(m,h)=>{D.writeHead(m,{"content-type":"application/json"}),D.end(JSON.stringify(h||null),b=>b&&this.c.error(b))},d=[];v.setEncoding("utf8"),v.on("data",m=>d.push(m)),v.on("end",async()=>{try{const m=JSON.parse(d.join(""));let h;switch(m.type){case"open":h=await this.i(m);break;case"openExternal":h=await this.j(m);break;case"status":h=await this.l(m);break;case"extensionManagement":h=await this.k(m);break;default:E(404,`Unknown message type: ${m.type}`);break}E(200,h)}catch(m){const h=m instanceof Error?m.message:JSON.stringify(m);E(500,h),this.c.error("Error while processing pipe request",m)}})}async i(v){const{fileURIs:D,folderURIs:E,forceNewWindow:d,diffMode:m,mergeMode:h,addMode:b,forceReuseWindow:p,gotoLineMode:g,waitMarkerFilePath:w,remoteAuthority:i}=v,o=[];if(Array.isArray(E))for(const a of E)try{o.push({folderUri:C.URI.parse(a)})}catch{}if(Array.isArray(D))for(const a of D)try{(0,S.hasWorkspaceFileExtension)(a)?o.push({workspaceUri:C.URI.parse(a)}):o.push({fileUri:C.URI.parse(a)})}catch{}const u=w?C.URI.file(w):void 0,s={forceNewWindow:d,diffMode:m,mergeMode:h,addMode:b,gotoLineMode:g,forceReuseWindow:p,preferNewWindow:!p&&!u&&!b,waitMarkerFileURI:u,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",o,s),""}async j(v){for(const D of v.uris){const E=C.URI.parse(D),d=E.scheme==="file"?E:D;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(v){const D=d=>d?.map(m=>/\.vsix$/i.test(m)?C.URI.parse(m):m),E={list:v.list,install:D(v.install),uninstall:D(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",E)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&k.existsSync(this.f)&&k.unlinkSync(this.f)}}e.CLIServerBase=y;let L=class extends y{constructor(v,D){super(v,D,(0,c.createRandomIPCHandle)())}};L=qe([He(0,A.IExtHostCommands),He(1,T.ILogService)],L),e.CLIServer=L}),define(ye[275],Ce([1,0,246,25,16]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let C=class extends c.AbstractExtHostConsoleForwarder{constructor(S,y){super(S,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,y,L){const P=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),y.apply(console,L),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,y){const L=process[S],P=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(D,E,d)=>{if(!this.g){v+=D.toString(E);const m=v.length>A?v.length:v.lastIndexOf(`
`);m!==-1&&(console[y](v.slice(0,m)),v=v.slice(m+1))}P.call(L,D,E,d)}})}};C=qe([He(0,k.IExtHostRpcService),He(1,t.IExtHostInitDataService)],C),e.ExtHostConsoleForwarder=C}),define(ye[276],Ce([1,0,9,87,30,39,6,5,2,16]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends C.Disposable{constructor(v,D){super();const E=v.getProxy(T.MainContext.MainThreadDownloadService);D.registerCommand(!1,"_workbench.downloadResource",async d=>{const m=S.URI.file((0,c.join)((0,t.tmpdir)(),(0,k.generateUuid)()));return await E.$download(d,m),m})}};L=qe([He(0,y.IExtHostRpcService),He(1,A.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[277],Ce([1,0,140,15,198,30]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends c.ExtHostLoggerService{f(S,y,L){return S.scheme===t.Schemas.file?new k.SpdLogLogger(L?.name||(0,A.generateUuid)(),S.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,y):super.f(S,y,L)}}e.ExtHostLoggerService=C}),define(ye[278],Ce([1,0,65,9,2,73,6,15,18,29]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends A.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(i){const o=await super.g(i);if(o.scheme!==T.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const u=o.fsPath;let l=0;do{let s;l===0?s=u:s=/[/\\]$/.test(u)?`${u.substr(0,u.length-1)}-${l}`:`${u}-${l}`,await P(s);const a=t.join(s,"vscode.lock"),n=await d(this.d,a,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),k.URI.file(s);l++}while(l<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function P(w){try{await y.Promises.stat(w);return}catch{}try{await y.Promises.mkdir(w,{recursive:!0})}catch{}}const v=1e3,D=10*60*1e3;class E extends C.Disposable{constructor(i,o){super(),this.b=i,this.c=o,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const u=await m(i,o);(!u||u.pid!==process.pid)&&(i.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(o,new Date,new Date)}catch(l){i.error(l),i.info(`Lock '${o}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{c.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+i};await y.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function d(w,i,o){try{const l={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(i,JSON.stringify(l),{flag:"wx"})}catch(l){w.error(l)}const u=await m(w,i);return!u||u.pid!==process.pid?o?(w.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(w.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),p(w,i)):(w.info(`Lock '${i}': Lock acquired.`),new E(w,i))}async function m(w,i){let o;try{o=await y.Promises.readFile(i)}catch(u){return w.error(u),null}try{return JSON.parse(String(o))}catch(u){return w.error(u),null}}async function h(w,i){let o;try{o=await y.Promises.stat(i)}catch(u){return w.error(u),0}return o.mtime.getTime()}function b(w){try{return process.kill(w,0),!0}catch{return!1}}async function p(w,i){const o=await m(w,i);if(!o)return w.info(`Lock '${i}': Could not read pid of lock holder.`),g(w,i);if(o.willReleaseAt){let n=o.willReleaseAt-Date.now();if(n<5e3){for(n>0?w.info(`Lock '${i}': The lockfile is scheduled to be released in ${n} ms.`):w.info(`Lock '${i}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await h(w,i)===0)return g(w,i);n=o.willReleaseAt-Date.now()}return g(w,i)}}if(!b(o.pid))return w.info(`Lock '${i}': The pid ${o.pid} appears to be gone.`),g(w,i);const u=await h(w,i),l=Date.now()-u;if(l<=D)return w.info(`Lock '${i}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;w.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const s=await h(w,i),a=Date.now()-s;return a<=D?(w.info(`Lock '${i}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(w.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),g(w,i))}async function g(w,i){w.info(`Lock '${i}': Deleting a stale lock.`);try{await y.Promises.unlink(i)}catch{}return d(w,i,!0)}}),define(ye[279],Ce([1,0,30,16,40]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends k.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,S,y){return this.createTerminalFromOptions({name:T,shellPath:S,shellArgs:y})}createTerminalFromOptions(T,S){const y=new k.ExtHostTerminal(this.a,(0,c.generateUuid)(),T,T.name);return this.f.push(y),y.create(T,this.L(T,S)),y.value}};A=qe([He(0,t.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(ye[280],Ce([1,0,5,16,181,6,25,2,45,24,29,7,12,54,4,129,101,13]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class b extends d.DisposableTunnel{}function p(n){const r=n.trim().split(`
`),f=[];return r.forEach(R=>{const B=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);B&&B.length>=3&&f.push({pid:parseInt(B[1],10),socket:parseInt(B[2],10)})}),f.reduce((R,B)=>(R[B.socket]=B,R),{})}e.getSockets=p;function g(...n){const r=[].concat(...n.map(i));return[...new Map(r.filter(f=>f.st==="0A").map(f=>{const I=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:w(I[0]),port:parseInt(I[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=g;function w(n){let r="";if(n.length===8)for(let f=n.length-2;f>=0;f-=2)r+=parseInt(n.substr(f,2),16),f!==0&&(r+=".");else for(let f=n.length-4;f>=0;f-=4)r+=parseInt(n.substr(f,4),16).toString(16),f!==0&&(r+=":");return r}function i(n){const r=n.trim().split(`
`),f=r.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return r.map(R=>R.trim().split(/\s+/).reduce((B,X,q)=>(B[f[q]||q]=X,B),{}))}e.loadConnectionTable=i;function o(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function u(n){const r=n.trim().split(`
`),f=[];return r.forEach(I=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);R&&R.length>=4&&f.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),f}e.getRootProcesses=u;async function l(n,r,f){const I=f.reduce((B,X)=>(B[X.pid]=X,B),{}),R=[];return n.forEach(({socket:B,ip:X,port:q})=>{const N=r[B]?r[B].pid:void 0,M=N?I[N]?.cmd:void 0;N&&M&&!o(M)&&R.push({host:X,port:q,detail:M,pid:N})}),R}e.findPorts=l;function s(n,r,f){const I=new Map,R=u(r);for(const B of n){const X=f.get(B.port);if(X){I.set(B.port,X);continue}const q=R.find(N=>N.cmd.includes(`${B.port}`));if(q){let N=q,M;do M=R.find(F=>F.ppid===N.pid),M&&(N=M);while(M);I.set(B.port,{host:B.ip,port:B.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else I.set(B.port,{host:B.ip,port:B.port,ppid:Number.MAX_VALUE})}return I}e.tryFindRootPorts=s;let a=class extends A.Disposable{constructor(r,f,I){super(),this.n=I,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new E.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=r.getProxy(c.MainContext.MainThreadTunnelService),v.isLinux&&f.remote.isRemote&&f.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(r,f){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const I=await this.a.$openTunnel(f,r.displayName);if(I){const R=new b(I.remoteAddress,I.localAddress,()=>this.a.$closeTunnel(I.remoteAddress));return this.B(R),R}}async getTunnels(){return this.a.$getTunnels()}p(r){return Math.max(r*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(r,f){const I=this.r();return this.l.set(I,{selector:r,provider:f}),this.a.$registerPortsAttributesProvider(r,I),new P.Disposable(()=>{this.l.delete(I),this.a.$unregisterPortsAttributesProvider(I)})}async $providePortAttributes(r,f,I,R,B){const X=[];for(const N of r){const M=this.l.get(N);if(!M)return[];X.push(...await Promise.all(f.map(async F=>M.provider.providePortAttributes(F,I,R,B))))}const q=X.filter(N=>!!N);return q.length>0?q.map(N=>({autoForwardAction:N.autoForwardAction,port:N.port})):[]}async $registerCandidateFinder(r){if(r&&this.h)return;this.h=r;const f=new m.MovingAverage;let I;for(;this.h;){const R=new Date().getTime(),B=(await this.findCandidatePorts()).filter(q=>(0,d.isLocalhost)(q.host)||(0,d.isAllInterfaces)(q.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${B.map(q=>q.port).join(", ")}`);const X=new Date().getTime()-R;f.update(X),(!I||JSON.stringify(I)!==JSON.stringify(B))&&(I=B,await this.a.$onFoundNewCandidates(I)),await new Promise(q=>setTimeout(()=>q(),this.p(f.value)))}}async setTunnelFactory(r){if(r){if(r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.c=r.showCandidatePort,this.a.$setCandidateFilter()),r.tunnelFactory){this.b=r.tunnelFactory;let f=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]);const I=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:f}:void 0;this.a.$setTunnelProvider(I)}}else this.b=void 0;return(0,A.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(r,f){if(this.f.has(r.host)){const I=this.f.get(r.host);I.has(r.port)&&(f&&I.get(r.port).disposeListener.dispose(),await I.get(r.port).tunnel.dispose(),I.delete(r.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(r,f){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const I=this.b(r,f);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),I!==void 0){const R=await I;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(r.remoteAddress.host)||this.f.set(r.remoteAddress.host,new Map);const B=this.B(R.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(R.remoteAddress))));return this.f.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:R,disposeListener:B}),D.TunnelDtoConverter.fromApiTunnel(R)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(r){const f=await Promise.all(r.map(R=>this.c(R.host,R.port,R.detail??""))),I=r.filter((R,B)=>f[B]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(R=>R.port).join(", ")} to ${I.map(R=>R.port).join(", ")}`),I}async findCandidatePorts(){let r="",f="";try{r=await L.Promises.readFile("/proc/net/tcp","utf8"),f=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=g(r,f),R=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(H,x,V)=>{U(x)})}),B=p(R),X=await L.Promises.readdir("/proc"),q=[];for(const U of X)try{const H=Number(U),x=y.joinPath(T.URI.file("/proc"),U);if((await L.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(H)){const _=await L.Promises.readlink(y.joinPath(x,"cwd").fsPath),Q=await L.Promises.readFile(y.joinPath(x,"cmdline").fsPath,"utf8");q.push({pid:H,cwd:_,cmd:Q})}}catch{}const N=[],M=I.filter(U=>{const H=B[U.socket];return H||N.push(U),H}),F=l(M,B,q);let z;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const U=await new Promise(H=>{(0,S.exec)("ps -F -A -l | grep root",(x,V,_)=>{H(V)})});this.j=s(N,U,this.j),z=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.map(H=>H.port).join(", ")}`)}return F.then(U=>z?U.concat(z):U)}};a=qe([He(0,t.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,h.ILogService)],a),e.ExtHostTunnelService=a}),define(ye[281],Ce([1,0,18,22,21,10,4,6,113,240,57]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(I,R){try{return JSON.stringify(I,R)}catch{return"null"}}const D="$$ref$$",E={[D]:-1};class d{constructor(R,B){this.jsonString=R,this.referencedBuffers=B}}function m(I,R=null,B=!1){const X=[];return{jsonString:(B?v:JSON.stringify)(I,(N,M)=>{if(typeof M>"u")return E;if(typeof M=="object"){if(M instanceof t.VSBuffer){const F=X.push(M)-1;return{[D]:F}}if(R)return R(N,M)}return M}),referencedBuffers:X}}e.stringifyJsonWithBufferRefs=m;function h(I,R,B){return JSON.parse(I,(X,q)=>{if(q){const N=q[D];if(typeof N=="number")return R[N];if(B&&q.$mid===1)return B.transformIncoming(q)}return q})}e.parseJsonAndRestoreBufferRefs=h;function b(I,R){return JSON.stringify(I,R)}function p(I){return I?(R,B)=>B&&B.$mid===1?I.transformOutgoing(B):B:null}var g;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(I){I[I.Responsive=0]="Responsive",I[I.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},o=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class l extends T.Disposable{constructor(R,B=null,X=null){super(),this[P]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=R,this.f=B,this.g=X,this.h=p(this.g),this.j=!1,this.k=[],this.l=[];for(let q=0,N=L.ProxyIdentifier.count;q<N;q++)this.k[q]=null,this.l[q]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new c.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(q=>this.G(q))}dispose(){this.j=!0,Object.keys(this.s).forEach(R=>{this.s[R].resolveErr(A.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(R){this.u===0&&(this.v=Date.now()+l.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(R){this.v=Date.now()+l.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(R){this.t!==R&&(this.t=R,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(R){return this.g?(0,S.transformIncomingURIs)(R,this.g):R}getProxy(R){const{nid:B,sid:X}=R;return this.l[B]||(this.l[B]=this.F(B,X)),this.l[B]}F(R,B){const X={get:(q,N)=>(typeof N=="string"&&!q[N]&&N.charCodeAt(0)===36&&(q[N]=(...M)=>this.O(R,N,M)),N===u?B:q[N])};return new Proxy(Object.create(null),X)}set(R,B){return this.k[R.nid]=B,B}assertRegistered(R){for(let B=0,X=R.length;B<X;B++){const q=R[B];if(!this.k[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}G(R){if(this.j)return;const B=R.byteLength,X=s.read(R,0),q=X.readUInt8(),N=X.readUInt32();switch(q){case 1:case 2:{let{rpcId:M,method:F,args:z}=n.deserializeRequestJSONArgs(X);this.g&&(z=(0,S.transformIncomingURIs)(z,this.g)),this.H(B,N,M,F,z,q===2);break}case 3:case 4:{let{rpcId:M,method:F,args:z}=n.deserializeRequestMixedArgs(X);this.g&&(z=(0,S.transformIncomingURIs)(z,this.g)),this.H(B,N,M,F,z,q===4);break}case 5:{this.f?.logIncoming(B,N,0,"ack"),this.z(N);break}case 6:{this.I(B,N);break}case 7:{this.J(B,N,void 0);break}case 9:{let M=n.deserializeReplyOKJSON(X);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.J(B,N,M);break}case 10:{const M=n.deserializeReplyOKJSONWithBuffers(X,this.g);this.J(B,N,M);break}case 8:{const M=n.deserializeReplyOKVSBuffer(X);this.J(B,N,M);break}case 11:{let M=n.deserializeReplyErrError(X);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.L(B,N,M);break}case 12:{this.L(B,N,void 0);break}default:console.error("received unexpected message"),console.error(R)}}H(R,B,X,q,N,M){this.f?.logIncoming(R,B,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(X)}.${q}(`,N);const F=String(B);let z,U;if(M){const x=new k.CancellationTokenSource;N.push(x.token),z=this.M(X,q,N),U=()=>x.cancel()}else z=this.M(X,q,N),U=i;this.p[F]=U;const H=n.serializeAcknowledged(B);this.f?.logOutgoing(H.byteLength,B,1,"ack"),this.c.send(H),z.then(x=>{delete this.p[F];const V=n.serializeReplyOK(B,x,this.h);this.f?.logOutgoing(V.byteLength,B,1,"reply:",x),this.c.send(V)},x=>{delete this.p[F];const V=n.serializeReplyErr(B,x);this.f?.logOutgoing(V.byteLength,B,1,"replyErr:",x),this.c.send(V)})}I(R,B){this.f?.logIncoming(R,B,1,"receiveCancel");const X=String(B);this.p[X]?.()}J(R,B,X){this.f?.logIncoming(R,B,0,"receiveReply:",X);const q=String(B);if(!this.s.hasOwnProperty(q))return;const N=this.s[q];delete this.s[q],N.resolveOk(X)}L(R,B,X){this.f?.logIncoming(R,B,0,"receiveReplyErr:",X);const q=String(B);if(!this.s.hasOwnProperty(q))return;const N=this.s[q];delete this.s[q];let M;X&&(X.$isError?(M=new Error,M.name=X.name,M.message=X.message,M.stack=X.stack):M=X),N.resolveErr(M)}M(R,B,X){try{return Promise.resolve(this.N(R,B,X))}catch(q){return Promise.reject(q)}}N(R,B,X){const q=this.k[R];if(!q)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(R));const N=q[B];if(typeof N!="function")throw new Error("Unknown method "+B+" on actor "+(0,L.getStringIdentifierForProxy)(R));return N.apply(q,X)}O(R,B,X){if(this.j)return new y.CanceledLazyPromise;let q=null;if(X.length>0&&k.CancellationToken.isCancellationToken(X[X.length-1])&&(q=X.pop()),q&&q.isCancellationRequested)return Promise.reject(A.canceled());const N=n.serializeRequestArguments(X,this.h),M=++this.m,F=String(M),z=new y.LazyPromise;q&&q.onCancellationRequested(()=>{const H=n.serializeCancel(M);this.f?.logOutgoing(H.byteLength,M,0,"cancel"),this.c.send(n.serializeCancel(M))}),this.s[F]=z,this.y(M);const U=n.serializeRequest(M,R,B,N,!!q);return this.f?.logOutgoing(U.byteLength,M,0,`request: ${(0,L.getStringIdentifierForProxy)(R)}.${B}(`,X),this.c.send(U),z}}e.RPCProtocol=l,P=o,l.a=3*1e3;class s{static alloc(R,B,X){const q=new s(t.VSBuffer.alloc(X+1+4),0);return q.writeUInt8(R),q.writeUInt32(B),q}static read(R,B){return new s(R,B)}get buffer(){return this.a}constructor(R,B){this.a=R,this.b=B}static sizeUInt8(){return 1}writeUInt8(R){this.a.writeUInt8(R,this.b),this.b+=1}readUInt8(){const R=this.a.readUInt8(this.b);return this.b+=1,R}writeUInt32(R){this.a.writeUInt32BE(R,this.b),this.b+=4}readUInt32(){const R=this.a.readUInt32BE(this.b);return this.b+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this.a.writeUInt8(R.byteLength,this.b),this.b+=1,this.a.set(R,this.b),this.b+=R.byteLength}readShortString(){const R=this.a.readUInt8(this.b);this.b+=1;const X=this.a.slice(this.b,this.b+R).toString();return this.b+=R,X}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readLongString(){const R=this.a.readUInt32BE(this.b);this.b+=4;const X=this.a.slice(this.b,this.b+R).toString();return this.b+=R,X}writeBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readVSBuffer(){const R=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+R);return this.b+=R,B}static sizeMixedArray(R){let B=0;B+=1;for(let X=0,q=R.length;X<q;X++){const N=R[X];switch(B+=1,N.type){case 1:B+=this.sizeLongString(N.value);break;case 2:B+=this.sizeVSBuffer(N.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(N.value);for(let M=0;M<N.buffers.length;++M)B+=this.sizeVSBuffer(N.buffers[M]);break;case 4:break}}return B}writeMixedArray(R){this.a.writeUInt8(R.length,this.b),this.b+=1;for(let B=0,X=R.length;B<X;B++){const q=R[B];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let N=0;N<q.buffers.length;++N)this.writeBuffer(q.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this.a.readUInt8(this.b);this.b+=1;const B=new Array(R);for(let X=0;X<R;X++)switch(this.readUInt8()){case 1:B[X]=this.readLongString();break;case 2:B[X]=this.readVSBuffer();break;case 3:{const N=this.readUInt32(),M=this.readLongString(),F=[];for(let z=0;z<N;++z)F.push(this.readVSBuffer());B[X]=new L.SerializableObjectWithBuffers(h(M,F,null));break}case 4:B[X]=void 0;break}return B}}s.sizeUInt32=4;var a;(function(I){I[I.Simple=0]="Simple",I[I.Mixed=1]="Mixed"})(a||(a={}));class n{static a(R){for(let B=0,X=R.length;B<X;B++)if(R[B]instanceof t.VSBuffer||R[B]instanceof L.SerializableObjectWithBuffers||typeof R[B]>"u")return!0;return!1}static serializeRequestArguments(R,B){if(this.a(R)){const X=[];for(let q=0,N=R.length;q<N;q++){const M=R[q];if(M instanceof t.VSBuffer)X[q]={type:2,value:M};else if(typeof M>"u")X[q]={type:4};else if(M instanceof L.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:z}=m(M.value,B);X[q]={type:3,value:t.VSBuffer.fromString(F),buffers:z}}else X[q]={type:1,value:t.VSBuffer.fromString(b(M,B))}}return{type:1,args:X}}return{type:0,args:b(R,B)}}static serializeRequest(R,B,X,q,N){switch(q.type){case 0:return this.b(R,B,X,q.args,N);case 1:return this.c(R,B,X,q.args,N)}}static b(R,B,X,q,N){const M=t.VSBuffer.fromString(X),F=t.VSBuffer.fromString(q);let z=0;z+=s.sizeUInt8(),z+=s.sizeShortString(M),z+=s.sizeLongString(F);const U=s.alloc(N?2:1,R,z);return U.writeUInt8(B),U.writeShortString(M),U.writeLongString(F),U.buffer}static deserializeRequestJSONArgs(R){const B=R.readUInt8(),X=R.readShortString(),q=R.readLongString();return{rpcId:B,method:X,args:JSON.parse(q)}}static c(R,B,X,q,N){const M=t.VSBuffer.fromString(X);let F=0;F+=s.sizeUInt8(),F+=s.sizeShortString(M),F+=s.sizeMixedArray(q);const z=s.alloc(N?4:3,R,F);return z.writeUInt8(B),z.writeShortString(M),z.writeMixedArray(q),z.buffer}static deserializeRequestMixedArgs(R){const B=R.readUInt8(),X=R.readShortString(),q=R.readMixedArray(),N=new Array(q.length);for(let M=0,F=q.length;M<F;M++){const z=q[M];typeof z=="string"?N[M]=JSON.parse(z):N[M]=z}return{rpcId:B,method:X,args:N}}static serializeAcknowledged(R){return s.alloc(5,R,0).buffer}static serializeCancel(R){return s.alloc(6,R,0).buffer}static serializeReplyOK(R,B,X){if(typeof B>"u")return this.d(R);if(B instanceof t.VSBuffer)return this.e(R,B);if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:N}=m(B.value,X,!0);return this.g(R,q,N)}else return this.f(R,v(B,X))}static d(R){return s.alloc(7,R,0).buffer}static e(R,B){let X=0;X+=s.sizeVSBuffer(B);const q=s.alloc(8,R,X);return q.writeVSBuffer(B),q.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static f(R,B){const X=t.VSBuffer.fromString(B);let q=0;q+=s.sizeLongString(X);const N=s.alloc(9,R,q);return N.writeLongString(X),N.buffer}static g(R,B,X){const q=t.VSBuffer.fromString(B);let N=0;N+=s.sizeUInt32,N+=s.sizeLongString(q);for(const F of X)N+=s.sizeVSBuffer(F);const M=s.alloc(10,R,N);M.writeUInt32(X.length),M.writeLongString(q);for(const F of X)M.writeBuffer(F);return M.buffer}static deserializeReplyOKJSON(R){const B=R.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(R,B){const X=R.readUInt32(),q=R.readLongString(),N=[];for(let M=0;M<X;++M)N.push(R.readVSBuffer());return new L.SerializableObjectWithBuffers(h(q,N,B))}static serializeReplyErr(R,B){const X=B?v(A.transformErrorForSerialization(B),null):void 0;if(typeof X!="string")return this.h(R);const q=t.VSBuffer.fromString(X);let N=0;N+=s.sizeLongString(q);const M=s.alloc(11,R,N);return M.writeLongString(q),M.buffer}static deserializeReplyErrError(R){const B=R.readLongString();return JSON.parse(B)}static h(R){return s.alloc(12,R,0).buffer}}var r;(function(I){I[I.RequestJSONArgs=1]="RequestJSONArgs",I[I.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",I[I.RequestMixedArgs=3]="RequestMixedArgs",I[I.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",I[I.Acknowledged=5]="Acknowledged",I[I.Cancel=6]="Cancel",I[I.ReplyOKEmpty=7]="ReplyOKEmpty",I[I.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",I[I.ReplyOKJSON=9]="ReplyOKJSON",I[I.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",I[I.ReplyErrError=11]="ReplyErrError",I[I.ReplyErrEmpty=12]="ReplyErrEmpty"})(r||(r={}));var f;(function(I){I[I.String=1]="String",I[I.VSBuffer=2]="VSBuffer",I[I.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",I[I.Undefined=4]="Undefined"})(f||(f={}))}),define(ye[282],Ce([1,0,4,44,53,3,38,10,18]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.a=new Map,this.b=new c.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new c.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(d=>E.push(d)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}t.Registry.add(e.Extensions.OutputChannels,new L);function P(D,E,d,m,h){return(0,S.createCancelablePromise)(async b=>{await(0,C.whenProviderRegistered)(d,m);const p=t.Registry.as(e.Extensions.OutputChannels);try{await v(d,1,m,h,b),p.registerChannel({id:D,label:E,file:d,log:!0})}catch(g){(0,T.isCancellationError)(g)||h.error("Error while registering log channel",d.toString(),(0,T.getErrorMessage)(g))}})}e.registerLogChannel=P;async function v(D,E,d,m,h){if(!await d.exists(D)){if(h.isCancellationRequested)throw new T.CancellationError;if(E>10)throw new Error("Timed out while waiting for file to be created");m.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",D.toString()),await(0,S.timeout)(1e3,h),await v(D,E+1,d,m,h)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new k.RawContextKey("activeOutputChannel","")}),define(ye[142],Ce([1,0,5,3,16,27,13,282,72,25,47,156,22,11,38,4,6]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(w,i,o,u,l){super(),this.id=w,this.name=i,this.m=o,this.n=u,this.extension=l,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.k;this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Clear,w)}replace(w){const i=this.k;this.info(w),this.n.$update(this.id,T.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(w,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof w=="boolean"?w:i))}hide(){this.n.$close(this.id)}g(w,i){this.k+=v.VSBuffer.fromString(i).byteLength,(0,C.log)(this.m,w,i),this.visible&&(this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class b extends h{appendLine(w){this.append(w)}}let p=class{constructor(w,i,o,u,l,s){this.i=i,this.j=o,this.k=u,this.l=l,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(c.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[i,o]of this.g)o.visible=i===this.h}createOutputChannel(w,i,o){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,l=(0,D.isString)(i)?i:void 0;if((0,D.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const a=this.i.environment.extensionLogLevel?.find(([r])=>A.ExtensionIdentifier.equals(o.identifier,r))?.[1];a&&(s=(0,C.parseLogLevel)(a));const n=u?this.o(w,s,o):this.n(w,l,o);return n.then(r=>{this.g.set(r.id,r),r.visible=r.id===this.h}),u?this.r(w,s??this.m.getLevel(),n):this.q(w,n)}async n(w,i,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,l=this.k.extUri.joinPath(u,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(l,{always:!0,donotRotate:!0,donotUseFormatters:!0}),a=await this.a.$register(w,l,!1,i,o.identifier.value);return new h(a,w,s,this.a,o)}async o(w,i,o){const u=await this.p(o),l=this.k.extUri.joinPath(u,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(l,{name:w},i),a=await this.a.$register(w,l,!0,void 0,o.identifier.value);return new b(a,w,s,this.a,o)}p(w){let i=this.d.get(w.identifier.value);if(!i){const o=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(o)}catch(u){if((0,E.toFileSystemProviderErrorCode)(u)!==E.FileSystemProviderErrorCode.FileExists)throw u}return o})())}return i}q(w,i){let o=!1;const u=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return w},append(l){u(),i.then(s=>s.append(l))},appendLine(l){u(),i.then(s=>s.appendLine(l))},clear(){u(),i.then(l=>l.clear())},replace(l){u(),i.then(s=>s.replace(l))},show(l,s){u(),i.then(a=>a.show(l,s))},hide(){u(),i.then(l=>l.hide())},dispose(){o=!0,i.then(l=>l.dispose())}}}r(w,i,o){const u=new m.DisposableStore,l=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},s=u.add(new d.Emitter);return o.then(a=>{u.add(a),u.add(a.onDidChangeLogLevel(n=>{i=n,s.fire(n)}))}),{...this.q(w,o),get logLevel(){return i},onDidChangeLogLevel:s.event,trace(a,...n){l(),o.then(r=>r.trace(a,...n))},debug(a,...n){l(),o.then(r=>r.debug(a,...n))},info(a,...n){l(),o.then(r=>r.info(a,...n))},warn(a,...n){l(),o.then(r=>r.warn(a,...n))},error(a,...n){l(),o.then(r=>r.error(a,...n))},dispose(){u.dispose()}}}};p=qe([He(0,k.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,S.IExtHostConsumerFileSystem),He(3,L.IExtHostFileSystemInfo),He(4,C.ILoggerService),He(5,C.ILogService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(ye[283],Ce([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(ye[284],Ce([1,0,32,15,9,12,24,2,3,210,46,227,283]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let D=class si{constructor(d,m,h,b){this.d=d,this.e=m,this.f=h,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const p=await this.e.getEnvironment();return this.c=p?.userHome??d})()}hasValidBasename(d,m,h){return typeof m=="string"||typeof m>"u"?this.a.then(b=>this.h(d,b,m)):this.h(d,m,h)}h(d,m,h){return d.scheme===t.Schemas.file||d.scheme===t.Schemas.vscodeRemote?(0,c.isValidBasename)(h??(0,C.basename)(d),m===1):!0}get defaultUriScheme(){return si.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,m){if(d.remoteAuthority)return t.Schemas.vscodeRemote;const h=(0,y.getVirtualWorkspaceScheme)(m.getWorkspace());if(h)return h;const b=m.getWorkspace().folders[0];if(b)return b.uri.scheme;const p=m.getWorkspace().configuration;return p?p.scheme:t.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?k.win32:k.posix)}async fileURI(d){let m="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const b=d.indexOf("/",2);b===-1?(m=d.substring(2),d="/"):(m=d.substring(2,b),d=d.substring(b)||"/")}return T.URI.from({scheme:t.Schemas.file,authority:m,path:d,query:"",fragment:""})}};D=qe([He(1,v.IRemoteAgentService),He(2,P.IWorkbenchEnvironmentService),He(3,L.IWorkspaceContextService)],D),e.AbstractPathService=D}),define(ye[75],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(C,T){this.line=C,this.character=T}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,T){return new c(0,0)}with(C){return new c(0,0)}}e.Position=c;class t{constructor(C,T,S,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(C,T),this.end=new c(S,y)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new t(0,0,0,0)}with(C){return new t(0,0,0,0)}}e.Range=t;var k;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],Ce([1,0,17,37,23,32,8,3,9,10,75,18]),function(ne,e,c,t,k,A,C,T,S,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",D=" characters skipped \u27EB",E=(v.length+D.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var d;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var m;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(m=e.QueryType||(e.QueryType={}));function h(Q){return!!Q.preview}e.resultIsMatch=h;function b(Q){return!!Q.resource}e.isFileMatch=b;function p(Q){return!!Q.message}e.isProgressMessage=p;var g;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(g=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(Z){this.resource=Z,this.results=[]}}e.FileMatch=w;class i{constructor(Z,ge,te){this.ranges=ge;const J=Array.isArray(ge)?ge:[ge];if(te&&te.matchLines===1&&o(J)){Z=(0,C.getNLines)(Z,te.matchLines);let fe="",ve=0,Ee=0;const Ae=Math.floor(te.charsPerLine/5),Fe=[];for(const se of J){const le=Math.max(se.startColumn-Ae,0),ue=se.startColumn+te.charsPerLine;if(le>Ee+Ae+E){const ee=v+(le-Ee)+D;fe+=ee+Z.slice(le,ue),ve+=le-(Ee+ee.length)}else fe+=Z.slice(Ee,ue);Fe.push(new l(0,se.startColumn-ve,se.endColumn-ve)),Ee=ue}this.preview={text:fe,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const fe=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:Z,matches:(0,c.mapArrayOrNot)(ge,ve=>new u(ve.startLineNumber-fe,ve.startColumn,ve.endLineNumber-fe,ve.endColumn))}}}}e.TextSearchMatch=i;function o(Q){const Z=Q[0].startLineNumber;for(const ge of Q)if(ge.startLineNumber!==Z||ge.endLineNumber!==Z)return!1;return!0}class u{constructor(Z,ge,te,J){this.startLineNumber=Z,this.startColumn=ge,this.endLineNumber=te,this.endColumn=J}}e.SearchRange=u;class l extends u{constructor(Z,ge,te){super(Z,ge,Z,te)}}e.OneLineRange=l;var s;(function(Q){Q.List="list",Q.Tree="tree"})(s=e.ViewMode||(e.ViewMode={}));var a;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(a=e.SearchSortOrder||(e.SearchSortOrder={}));function n(Q,Z=!0){const ge=Q&&Q.files&&Q.files.exclude,te=Z&&Q&&Q.search&&Q.search.exclude;if(!ge&&!te)return;if(!ge||!te)return ge||te;let J=Object.create(null);return J=k.mixin(J,k.deepClone(ge)),J=k.mixin(J,k.deepClone(te),!0),J}e.getExcludes=n;function r(Q,Z){return Q.excludePattern&&t.match(Q.excludePattern,Z)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&t.match(Q.includePattern,Z)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(ge=>{const te=ge.folder.fsPath;if(A.isEqualOrParent(Z,te)){const J=S.relative(te,Z);return!ge.includePattern||!!t.match(ge.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=r;var f;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class I extends Error{constructor(Z,ge){super(Z),this.code=ge}}e.SearchError=I;function R(Q){const Z=Q.message;if((0,y.isCancellationError)(Q))return new I(Z,f.canceled);try{const ge=JSON.parse(Z);return new I(ge.message,ge.code)}catch{return new I(Z,f.other)}}e.deserializeSearchError=R;function B(Q){const Z={message:Q.message,code:Q.code};return new Error(JSON.stringify(Z))}e.serializeSearchError=B;function X(Q){return Q.type==="error"?!0:Q.type==="success"}e.isSerializedSearchComplete=X;function q(Q){return Q.type==="success"}e.isSerializedSearchSuccess=q;function N(Q){return!!Q.path}e.isSerializedFileMatch=N;function M(Q,Z){const ge=Q.searchPath?Q.searchPath:Q.relativePath;return(0,C.fuzzyContains)(ge,Z)}e.isFilePatternMatch=M;class F{constructor(Z){this.path=Z,this.results=[]}addMatch(Z){this.results.push(Z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function z(Q,Z){const ge={...Q||{},...Z||{}};return Object.keys(ge).filter(te=>{const J=ge[te];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=z;class U{constructor(Z,ge){this.c=null,this.a={...Z.excludePattern||{},...ge.excludePattern||{}},this.b=t.parse(this.a);let te=Z.includePattern;ge.includePattern&&(te?te={...te,...ge.includePattern}:te=ge.includePattern),te&&(this.c=t.parse(te))}matchesExcludesSync(Z,ge,te){return!!(this.b&&this.b(Z,ge,te))}includedInQuerySync(Z,ge,te){return!(this.b&&this.b(Z,ge,te)||this.c&&!this.c(Z,ge,te))}includedInQuery(Z,ge,te){const J=this.b(Z,ge,te),fe=()=>this.c?!!this.c(Z,ge,te):!0;return(0,P.isThenable)(J)?J.then(ve=>ve?!1:fe()):fe()}hasSiblingExcludeClauses(){return H(this.a)}}e.QueryGlobTester=U;function H(Q){for(const Z in Q)if(typeof Q[Z]!="boolean")return!0;return!1}function x(Q){if(!Q)return;let Z;return ge=>(Z||(Z=(Q()||Promise.resolve([])).then(te=>te?_(te):{})),Z.then(te=>!!te[ge]))}e.hasSiblingPromiseFn=x;function V(Q){if(!Q)return;let Z;return ge=>{if(!Z){const te=Q();Z=te?_(te):{}}return!!Z[ge]}}e.hasSiblingFn=V;function _(Q){const Z={};for(const ge of Q)Z[ge]=!0;return Z}}),define(ye[33],Ce([1,0,17,18,21,4,6,64,15,101,24,8,11,2,179,3,13,199,46,47,25,16,14,7,55,31,5]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p,g,w,i,o,u,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(q,N,M){return new L.ExtUri(F=>I(F,M)).isEqual(q,N)}function n(q,N,M){return a(q.uri,N.uri,M)?0:(0,P.compare)(q.uri.toString(),N.uri.toString())}function r(q,N,M){return q.index!==N.index?q.index<N.index?-1:1:a(q.uri,N.uri,M)?(0,P.compare)(q.name,N.name):(0,P.compare)(q.uri.toString(),N.uri.toString())}function f(q,N,M,F){const z=q.slice(0).sort((H,x)=>M(H,x,F)),U=N.slice(0).sort((H,x)=>M(H,x,F));return(0,c.delta)(z,U,(H,x)=>M(H,x,F))}function I(q,N){const M=N.getCapabilities(q.scheme);return!(M&&M&1024)}class R extends b.Workspace{static toExtHostWorkspace(N,M,F,z){if(!N)return{workspace:null,added:[],removed:[]};const{id:U,name:H,folders:x,configuration:V,transient:_,isUntitled:Q}=N,Z=[],ge=M;M?x.forEach((ve,Ee)=>{const Ae=D.URI.revive(ve.uri),Fe=R.e(F||M,Ae,z);Fe?(Fe.name=ve.name,Fe.index=ve.index,Z.push(Fe)):Z.push({uri:Ae,name:ve.name,index:Ee})}):Z.push(...x.map(({uri:ve,name:Ee,index:Ae})=>({uri:D.URI.revive(ve),name:Ee,index:Ae}))),Z.sort((ve,Ee)=>ve.index<Ee.index?-1:1);const te=new R(U,H,Z,!!_,V?D.URI.revive(V):null,!!Q,ve=>I(ve,z)),{added:J,removed:fe}=f(ge?ge.workspaceFolders:[],te.workspaceFolders,n,z);return{workspace:te,added:J,removed:fe}}static e(N,M,F){for(let z=0;z<N.folders.length;z++){const U=N.workspaceFolders[z];if(a(U.uri,M,F))return U}}constructor(N,M,F,z,U,H,x){super(N,F.map(V=>new b.WorkspaceFolder(V)),z,U,x),this.s=M,this.t=H,this.o=[],this.q=T.TernarySearchTree.forUris(x),F.forEach(V=>{this.o.push(V),this.q.set(V.uri,V)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(N,M){return M&&this.q.get(N)&&(N=(0,L.dirname)(N)),this.q.findSubstr(N)}resolveWorkspaceFolder(N){return this.q.get(N)}}let B=class{constructor(N,M,F,z,U){this.c=new A.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new A.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=z,this.q=F,this.s=U,this.h=new y.Counter,this.j=new t.Barrier,this.n=N.getProxy(s.MainContext.MainThreadWorkspace),this.o=N.getProxy(s.MainContext.MainThreadMessageService);const H=M.workspace;this.k=H?new R(H.id,H.name,[],!!H.transient,H.configuration?D.URI.revive(H.configuration):null,!!H.isUntitled,x=>I(x,F)):void 0}$initializeWorkspace(N,M){this.u=M,this.$acceptWorkspaceData(N),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?D.URI.from({scheme:S.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(N,M,F,...z){const U=[];if(Array.isArray(z)&&z.forEach(Q=>{D.URI.isUri(Q.uri)&&!U.some(Z=>a(Z.uri,Q.uri,this.q))&&U.push({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri)})}),this.l||[M,F].some(Q=>typeof Q!="number"||Q<0)||F===0&&U.length===0)return!1;const H=this.w?this.w.workspaceFolders:[];if(M+F>H.length)return!1;const x=H.slice(0);x.splice(M,F,...U.map(Q=>({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<x.length;Q++){const Z=x[Q];if(x.some((ge,te)=>te!==Q&&a(Z.uri,ge.uri,this.q)))return!1}x.forEach((Q,Z)=>Q.index=Z);const{added:V,removed:_}=f(H,x,r,this.q);if(V.length===0&&_.length===0)return!1;if(this.n){const Q=N.displayName||N.name;this.n.$updateWorkspaceFolders(Q,M,F,U).then(void 0,Z=>{this.l=void 0;const ge={source:{identifier:N.identifier,label:N.displayName||N.name}};this.o.$showMessage(h.Severity.Error,(0,E.localize)(0,null,Q,Z.toString()),ge,[])})}return this.x(x),!0}getWorkspaceFolder(N,M){if(!!this.w)return this.w.getWorkspaceFolder(N,M)}async getWorkspaceFolder2(N,M){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(N,M)}async resolveWorkspaceFolder(N){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(N)}getPath(){if(!this.w)return;const{folders:N}=this.w;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,M){let F,z="";if(typeof N=="string"?(F=D.URI.file(N),z=N):typeof N<"u"&&(F=N,z=N.fsPath),!F)return z;const U=this.getWorkspaceFolder(F,!0);if(!U)return z;typeof M>"u"&&this.w&&(M=this.w.folders.length>1);let H=(0,L.relativePath)(U.uri,F);return M&&U.name&&(H=`${U.name}/${H}`),H}x(N){this.w&&(this.l=R.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:N,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:M,added:F,removed:z}=R.toExtHostWorkspace(N,this.k,this.l,this.q);this.k=M||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:z}))}findFiles(N,M,F,z,U=k.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let H;if(M===null?H=!1:M&&(typeof M=="string"?H=M:H=M.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:V}=X(i.GlobPattern.from(N));return this.n.$startFileSearch((0,v.withUndefinedAsNull)(x),(0,v.withUndefinedAsNull)(V),(0,v.withUndefinedAsNull)(H),(0,v.withUndefinedAsNull)(F),U).then(_=>Array.isArray(_)?_.map(Q=>D.URI.revive(Q)):[])}async findTextInFiles(N,M,F,z,U=k.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const H=this.h.getNext(),x=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:V,folder:_}=X(i.GlobPattern.from(M.include)),Q=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,Z={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:x,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:V,excludePattern:Q},ge=!1;if(this.t[H]=te=>{if(ge)return;const J=D.URI.revive(te.resource);te.results.forEach(fe=>{(0,l.resultIsMatch)(fe)?F({uri:J,preview:{text:fe.preview.text,matches:(0,c.mapArrayOrNot)(fe.preview.matches,ve=>new o.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,c.mapArrayOrNot)(fe.ranges,ve=>new o.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):F({uri:J,text:fe.text,lineNumber:fe.lineNumber})})},U.isCancellationRequested)return{};try{const te=await this.n.$startTextSearch(N,(0,v.withUndefinedAsNull)(_),Z,H,U);return delete this.t[H],te||{}}catch(te){throw delete this.t[H],te}}$handleTextSearchResult(N,M){this.t[M]?.(N)}saveAll(N){return this.n.$saveAll(N)}resolveProxy(N){return this.n.$resolveProxy(N)}get trusted(){return this.u}requestWorkspaceTrust(N){return this.n.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(N,M){if(this.v.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.v.set(N,M);const F=this.s.transformOutgoingScheme(N),z=this.y++;return this.n.$registerEditSessionIdentityProvider(z,F),(0,C.toDisposable)(()=>{this.v.delete(N),this.n.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(N,M){this.g.info("Getting edit session identifier for workspaceFolder",N);const F=await this.resolveWorkspaceFolder(D.URI.revive(N));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const z=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!z),!z)return;const U=await z.provideEditSessionIdentity(F,M);if(this.g.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(N,M,F,z){this.g.info("Getting edit session identifier for workspaceFolder",N);const U=await this.resolveWorkspaceFolder(D.URI.revive(N));if(!U){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const H=this.v.get(U.uri.scheme);if(this.g.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!H),!H)return;const x=await H.provideEditSessionIdentityMatch?.(M,F,z);if(this.g.info("Provider returned edit session identifier match result: ",x),!!x)return x}};B=qe([He(0,w.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,p.IExtHostFileSystemInfo),He(3,m.ILogService),He(4,u.IURITransformerService)],B),e.ExtHostWorkspace=B,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function X(q){let N,M;return q&&(typeof q=="string"?N=q:(N=q.pattern,M=D.URI.revive(q.baseUri))),{includePattern:N,folder:M}}}),define(ye[34],Ce([1,0,23,4,33,5,7,202,127,11,18,3,16,13,2]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(o,u){if(u){const l=u.split(".");let s=o;for(let a=0;s&&a<l.length;a++)s=s[l[a]];return s}}function m(o){return o instanceof E.URI}function h(o){return o&&o.uri instanceof E.URI&&o.languageId&&typeof o.languageId=="string"}function b(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function p(o){return o&&o.uri instanceof E.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function g(o){if(m(o))return{resource:o};if(h(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(b(o))return{overrideIdentifier:o.languageId};if(p(o))return{resource:o.uri};if(o===null)return{resource:null}}let w=class{constructor(u,l,s){this.a=u.getProxy(A.MainContext.MainThreadConfiguration),this.c=l,this.b=s,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,l){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(u,l))}};w=qe([He(0,v.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,D.ILogService)],w),e.ExtHostConfiguration=w;class i{constructor(u,l,s,a){this.a=new t.Emitter,this.b=u,this.f=a,this.c=l,this.e=T.Configuration.parse(s),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,l){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=T.Configuration.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(l,s))}getConfiguration(u,l,s){const a=g(l)||{},n=this.g(u?d(this.e.getValue(void 0,a,this.c.workspace),u):this.e.getValue(void 0,a,this.c.workspace));u&&this.h(u,a,s?.identifier);function r(I){if(I==null)return null;if(typeof I=="boolean")return I?2:5;switch(I){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(I){return typeof d(n,I)<"u"},get:(I,R)=>{this.h(u?`${u}.${I}`:I,a,s?.identifier);let B=d(n,I);if(typeof B>"u")B=R;else{let X;const q=(N,M)=>{let F;const z=()=>{X=X||(0,c.deepClone)(n),F=F||d(X,M)};return(0,y.isObject)(N)?new Proxy(N,{get:(U,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return z(),()=>F;if(X)return F=F||d(X,M),F[H];const x=U[H];return typeof H=="string"?q(x,`${M}.${H}`):x},set:(U,H,x)=>(z(),F&&(F[H]=x),!0),deleteProperty:(U,H)=>(z(),F&&delete F[H],!0),defineProperty:(U,H,x)=>(z(),F&&Object.defineProperty(F,H,x),!0)}):N};B=q(B,I)}return B},update:(I,R,B,X)=>{I=u?`${u}.${I}`:I;const q=r(B);return R!==void 0?this.b.$updateConfigurationOption(q,I,R,a,X):this.b.$removeConfigurationOption(q,I,a,X)},inspect:I=>{I=u?`${u}.${I}`:I;const R=this.e.inspect(I,a,this.c.workspace);if(R)return{key:I,defaultValue:(0,c.deepClone)(R.policy?.value??R.default?.value),globalValue:(0,c.deepClone)(R.user?.value??R.application?.value),workspaceValue:(0,c.deepClone)(R.workspace?.value),workspaceFolderValue:(0,c.deepClone)(R.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(R.default?.override),globalLanguageValue:(0,c.deepClone)(R.user?.override??R.application?.override),workspaceLanguageValue:(0,c.deepClone)(R.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(R.workspaceFolder?.override),languageIds:(0,c.deepClone)(R.overrideIdentifiers)}}};return typeof n=="object"&&(0,c.mixin)(f,n,!1),Object.freeze(f)}g(u){const l=s=>(0,y.isObject)(s)?new Proxy(s,{get:(a,n)=>l(a[n]),set:(a,n,r)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(a,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(a,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return l(u)}h(u,l,s){const a=S.OVERRIDE_PROPERTY_REGEX.test(u)?4:this.d.get(u),n=s?`[${s.value}] `:"";if(a===4){typeof l?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){l?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,l){const s=new T.ConfigurationChangeEvent(u,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(a,n)=>s.affectsConfiguration(a,g(n))})}k(u){return u.reduce((l,s)=>(l.set(s[0],s[1]),l),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[76],Ce([1,0,2,18,4,5,7,33,58,34,21,40,16,25,3,15,12,13,71,239,10]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p,g){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(N){function M(z){if(z!=null)return z}N.from=M;function F(z){if(z!=null)return z}N.to=F})(i||(i={}));var o;(function(N){function M(z){if(z!=null)return z}N.from=M;function F(z){if(z!=null)return z}N.to=F})(o||(o={}));var u;(function(N){function M(z){if(z!=null)return z}N.from=M;function F(z){if(z!=null)return z}N.to=F})(u||(u={}));var l;(function(N){function M(U){if(U){const H=U;return H&&!!H.process}else return!1}N.is=M;function F(U){if(U==null)return;const H={process:U.process,args:U.args};return U.options&&(H.options=u.from(U.options)),H}N.from=F;function z(U){if(U!=null)return new C.ProcessExecution(U.process,U.args,U.options)}N.to=z})(l||(l={}));var s;(function(N){function M(z){if(z!=null)return z}N.from=M;function F(z){if(z!=null)return z}N.to=F})(s||(s={}));var a;(function(N){function M(U){if(U){const H=U;return H&&(!!H.commandLine||!!H.command)}else return!1}N.is=M;function F(U){if(U==null)return;const H={};return U.commandLine!==void 0?H.commandLine=U.commandLine:(H.command=U.command,H.args=U.args),U.options&&(H.options=s.from(U.options)),H}N.from=F;function z(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new C.ShellExecution(U.commandLine,U.options):new C.ShellExecution(U.command,U.args?U.args:[],U.options)}N.to=z})(a||(a={}));var n;(function(N){function M(U){if(U){const H=U;return H&&H.customExecution==="customExecution"}else return!1}N.is=M;function F(U){return{customExecution:"customExecution"}}N.from=F;function z(U,H){return H.get(U)}N.to=z})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var r;(function(N){function M(F,z){let U;return F.scope!==void 0&&typeof F.scope!="number"?U=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===C.TaskScope.Workspace&&z&&z.workspaceFile?U=z.workspaceFile:U=p.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:U}}N.from=M})(r=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(N){function M(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}N.from=M})(f||(f={}));var I;(function(N){function M(U,H){if(U==null)return[];const x=[];for(const V of U){const _=F(V,H);_&&x.push(_)}return x}N.fromMany=M;function F(U,H){if(U==null)return;let x;U.execution instanceof C.ProcessExecution?x=l.from(U.execution):U.execution instanceof C.ShellExecution?x=a.from(U.execution):U.execution&&U.execution instanceof C.CustomExecution&&(x=n.from(U.execution));const V=i.from(U.definition);let _;return U.scope?typeof U.scope=="number"?_=U.scope:_=U.scope.uri:_=C.TaskScope.Workspace,!V||!_?void 0:{_id:U._id,definition:V,name:U.name,source:{extensionId:H.identifier.value,label:U.source,scope:_},execution:x,isBackground:U.isBackground,group:f.from(U.group),presentationOptions:o.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}N.from=F;async function z(U,H,x){if(U==null)return;let V;l.is(U.execution)?V=l.to(U.execution):a.is(U.execution)?V=a.to(U.execution):n.is(U.execution)&&(V=n.to(U._id,x));const _=i.to(U.definition);let Q;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Q=U.source.scope:Q=await H.resolveWorkspaceFolder(c.URI.revive(U.source.scope)):Q=C.TaskScope.Workspace),!_||!Q)return;const Z=new C.Task(_,Q,U.name,U.source.label,V,U.problemMatchers);return U.isBackground!==void 0&&(Z.isBackground=U.isBackground),U.group!==void 0&&(Z.group=C.TaskGroup.from(U.group._id),Z.group&&U.group.isDefault&&(Z.group=new C.TaskGroup(Z.group.id,Z.group.label),U.group.isDefault===!0&&(Z.group.isDefault=U.group.isDefault))),U.presentationOptions&&(Z.presentationOptions=o.to(U.presentationOptions)),U._id&&(Z._id=U._id),U.detail&&(Z.detail=U.detail),Z}N.to=z})(I=e.TaskDTO||(e.TaskDTO={}));var R;(function(N){function M(z){return z}N.from=M;function F(z){if(!!z)return Object.assign(Object.create(null),z)}N.to=F})(R||(R={}));class B{constructor(M,F,z){this._id=F,this.a=z,w.set(this,void 0),Je(this,w,M,"f")}get task(){return this.a}terminate(){Ue(this,w,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}w=new WeakMap;let X=class{constructor(M,F,z,U,H,x,V,_){this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.t=new k.Emitter,this.a=M.getProxy(A.MainContext.MainThreadTask),this.b=z,this.c=U,this.d=H,this.e=x,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=V,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,F,z){if(!z)return new C.Disposable(()=>{});const U=this.w();return this.j.set(U,{type:F,provider:z,extension:M}),this.a.$registerTaskProvider(U,F),new C.Disposable(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(M,F){this.a.$registerTaskSystem(M,F)}fetchTasks(M){return this.a.$fetchTasks(R.from(M)).then(async F=>{const z=[];for(const U of F){const H=await I.to(U,this.b,this.m);H&&z.push(H)}return z})}get taskExecutions(){const M=[];return this.k.forEach(F=>M.push(F)),M}terminateTask(M){if(!(M instanceof B))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,F,z){const U=this.m.get(M.id);U&&(this.o.set(M.id,U),this.e.attachPtyToTerminal(F,await U.callback(z))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const F=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const F=await this.y(M.id);this.s.fire({execution:F,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const F=await this.y(M.id);this.t.fire({execution:F,exitCode:M.exitCode})}$provideTasks(M,F){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));const U=[],H=(0,t.asPromise)(()=>z.provider.provideTasks(L.CancellationToken.None)).then(x=>this.u(F,U,z,x));return new Promise(x=>{H.then(V=>{Promise.all(U).then(()=>{x(V)})})})}async $resolveTask(M,F){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));if(F.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${z.type}].`);const U=await I.to(F,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const H=await z.provider.resolveTask(U,L.CancellationToken.None);if(!H)return;this.z(H,z);const x=I.from(H,z.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(x.execution)&&await this.x(x,H,!0),await this.v(x)}w(){return this.h++}async x(M,F,z){const U=await this.a.$createTaskId(M);!z&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,F.execution)),this.m.set(U,F.execution)}async y(M,F){if(typeof M=="string"){const H=this.l.get(M);if(!H)throw new g.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return H}const z=this.l.get(M.id);if(z)return z;const U=new Promise((H,x)=>{function V(_,Q,Z){Z?H(new B(_,Q.id,Z)):x("Unexpected: Task does not exist.")}F?V(this,M,F):I.to(M.task,this.b,this.m).then(_=>V(this,M,_))});return this.l.set(M.id,U),U.then(H=>(this.k.set(M.id,H),H),H=>Promise.reject(H))}z(M,F){M._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const z=this.n.values();let U=z.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=z.next()}};X=qe([He(0,v.IExtHostRpcService),He(1,D.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,h.ILogService),He(7,b.IExtHostApiDeprecationService)],X),e.ExtHostTaskBase=X;let q=class extends X{constructor(M,F,z,U,H,x,V,_){super(M,F,z,U,H,x,V,_),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(0)})}async executeTask(M,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const z=I.from(F,M);if(z===void 0)throw new Error("Task is not valid");if(n.is(z.execution))await this.x(z,F,!1);else throw new g.NotSupportedError;const U=await this.y(await this.a.$getTaskExecution(z),F);return this.a.$executeTask(z).catch(H=>{throw new Error(H)}),U}u(M,F,z,U){const H=[];if(U)for(const x of U){this.z(x,z),(!x.definition||!M[x.definition.type])&&this.f.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const V=I.from(x,z.extension);V&&n.is(V.execution)?(H.push(V),F.push(this.x(V,x,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:H,extension:z.extension}}async v(M){if(n.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,F,z){}};q=qe([He(0,v.IExtHostRpcService),He(1,D.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,h.ILogService),He(7,b.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(ye[285],Ce([1,0,9,21,51,37,24,42,31]),function(ne,e,c,t,k,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class y{constructor(v,D,E){this.k=v,this.l=D,this.o=E,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&A.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&A.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const D=this.k.folderQueries||[];return new Promise((E,d)=>{const m=h=>{this.f++,v(h)};if(this.g)return E({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(h=>{const b=h.toString(),p=c.basename(b);this.j&&this.j(b,p)||this.v(m,{base:h,basename:p})}),Promise.all(D.map(h=>this.p(h,m))).then(h=>{E({limitHit:this.e,stats:h[0]||void 0})},h=>{d(new Error((0,k.toErrorMessage)(h)))})})}async p(v,D){const E=new t.CancellationTokenSource,d=this.q(v),m=this.r(),h=new S.QueryGlobTester(this.k,v),b=!h.hasSiblingExcludeClauses();let p;try{this.h.add(E),p=T.StopWatch.create();const g=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,E.token),w=p.elapsed(),i=T.StopWatch.create();return this.g&&!this.e||(g&&g.forEach(o=>{const u=c.posix.relative(v.folder.path,o.path);if(b){const l=c.basename(o.path);this.v(D,{base:v.folder,relativePath:u,basename:l});return}this.s(m,v.folder,u,D)}),this.g&&!this.e)?null:(this.u(m,h,D),{providerTime:w,postProcessTime:i.elapsed()})}finally{E.dispose(),this.h.delete(E)}}q(v){const D=(0,S.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),E=(0,S.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:E,includes:D,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},D,E,d){if(E===this.a){const h=c.basename(this.a);this.v(d,{base:D,relativePath:this.a,basename:h})}function m(h){const b=c.basename(h),p=c.dirname(h);let g=v[p];g||(g=v[p]=[],m(p)),g.push({base:D,relativePath:h,basename:b})}m(E)}u({rootEntries:v,pathToEntries:D},E,d){const m=this,h=this.a;function b(p){const g=(0,S.hasSiblingFn)(()=>p.map(w=>w.basename));for(let w=0,i=p.length;w<i;w++){const o=p[w],{relativePath:u,basename:l}=o;if(E.matchesExcludesSync(u,l,h!==l?g:void 0))continue;const s=D[u];if(s)b(s);else{if(u===h)continue;m.v(d,o)}if(m.e)break}}b(v)}v(v,D){(!this.b||D.relativePath&&this.b(D.relativePath,D.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(D))}}class L{constructor(){this.b=new Map}fileSearch(v,D,E,d){const m=this.c(v.cacheKey),h=new y(v,D,m&&m.token);let b=0;const p=g=>{b+=g.length,E(g.map(w=>this.d(w)))};return this.e(h,L.a,p,d).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:g.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new t.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:C.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,D,E,d){d.onCancellationRequested(()=>{v.cancel()});const m=b=>{b&&(h.push(b),D>0&&h.length>=D&&(E(h),h=[]))};let h=[];return v.search(m).then(b=>(h.length&&E(h),b),b=>(h.length&&E(h),Promise.reject(b)))}}e.FileSearchManager=L,L.a=512}),define(ye[286],Ce([1,0,17,81,37,112,28,15,9,24,8,11,2,163,190,52,13,46,133,284,31]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(f,I,R,B,X){this.a=f,this.b=I,this.c=R,this.d=B,this.e=X}text(f,I,R={}){f=this.f(f,R);const B=this.a.getValue(),X=I&&I.some(N=>!this.a.getValue({resource:N}).search.useRipgrep);return{...this.h(I?.map(h.toWorkspaceFolder),R),type:2,contentPattern:f,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:B.search.usePCRE2||X||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(f,I){const R=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const B={...f,wordSeparators:R.editor.wordSeparators};return this.j(f,I)&&(B.isCaseSensitive=!0),this.k(f)&&(B.isMultiline=!0),B}file(f,I={}){return{...this.h(f,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}g(f,I){return f?(f=Array.isArray(f)?f.map(s):s(f),I?this.parseSearchPaths(f):{pattern:o(...Array.isArray(f)?f:[f])}):{}}h(f=[],I={}){const R=this.g(I.includePattern,I.expandPatterns),B=this.g(I.excludePattern,I.expandPatterns),X=f.length>1,q=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(F=>this.q(F,I,B)):f.map(F=>this.r(F,I,B,X))).filter(F=>!!F),N={_reason:I._reason,folderQueries:q,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:B.pattern,includePattern:R.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const F=c.coalesce(c.flatten(this.c.groups.map(H=>H.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const z=F.filter(H=>(0,g.pathIncludedInQuery)(N,H.fsPath)),U=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...N,...U}}const M=I.extraFileResources&&I.extraFileResources.filter(F=>(0,g.pathIncludedInQuery)(N,F.fsPath));return N.extraFileResources=M&&M.length?M:void 0,N}i(f){const I=[],R=new C.ResourceMap,B={};let X=!1;return f.forEach(q=>{if(q.scheme===T.Schemas.walkThrough)return;if((0,y.isAbsolutePath)(q)){const M=this.b.getWorkspaceFolder(q)?.uri??q.with({path:S.dirname(q.fsPath)});let F=R.get(M);F||(X=!0,F={folder:M,includePattern:{}},I.push(F),R.set(M,F));const z=S.relative(M.fsPath,q.fsPath);(0,P.assertIsDefined)(F.includePattern)[z.replace(/\\/g,"/")]=!0}else q.fsPath&&(X=!0,B[q.fsPath]=!0)}),{folderQueries:I,includePattern:B,usingSearchPaths:!0,excludePattern:X?void 0:{"**/*":!0}}}j(f,I){if(I.isSmartCase){if(f.isRegExp){if(L.containsUppercaseCharacter(f.pattern,!0))return!0}else if(L.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,D.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const I=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),B=(Array.isArray(f)?f:u(f)).map(U=>{const H=this.e.resolvedUserHome;return H?(0,A.untildify)(U,H.scheme===T.Schemas.file?H.fsPath:H.path):U}),X=t.groupBy(B,U=>I(U)?"searchPaths":"exprSegments"),q=(X.exprSegments||[]).map(U=>L.rtrim(U,"/")).map(U=>L.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),l(U))),N={},M=this.m(X.searchPaths||[]);M&&M.length&&(N.searchPaths=M);const F=c.flatten(q),z=o(...F);return z&&(N.pattern=z),N}l(f,I){return I.disregardExcludeSettings?void 0:(0,g.getExcludes)(f,!I.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const I=f.flatMap(B=>{let{pathPortion:X,globPortion:q}=i(B);return q&&(q=a(q)),this.n(X).flatMap(M=>this.o(M,q))}),R=new Map;return I.forEach(B=>{const X=B.searchPath.toString(),q=R.get(X);q?B.pattern&&(q.pattern=q.pattern||{},q.pattern[B.pattern]=!0):R.set(X,{searchPath:B.searchPath,pattern:B.pattern?o(B.pattern):void 0})}),Array.from(R.values())}n(f){if(S.isAbsolute(f)){const I=this.b.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==T.Schemas.file?[{searchPath:I[0].uri.with({path:f})}]:[{searchPath:v.URI.file(S.normalize(f))}]}if(this.b.getWorkbenchState()===2){const I=this.b.getWorkspace().folders[0].uri;if(f=s(f),f.startsWith("../")||f===".."){const B=S.posix.resolve(I.path,f);return[{searchPath:I.with({path:B})}]}const R=a(f);return[{searchPath:I,pattern:R}]}else{if(f==="./"||f===".\\")return[];{const I=f.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(X=>{const q=I.match(new RegExp(`^${L.escapeRegExpCharacters(X.name)}(?:/(.*)|$)`));return q?{match:q,folder:X}:null}).filter(P.isDefined);if(B.length)return B.map(X=>{const q=X.match[1];return{searchPath:X.folder.uri,pattern:q&&a(q)}});{const X=f.match(/\.[\/\\](.+)[\/\\]?/),q=X?X[1]:f,N=E.localize(0,null,q);throw new Error(N)}}}}o(f,I){const R=f.pattern&&I?`${f.pattern}/${I}`:f.pattern||I,B=[{searchPath:f.searchPath,pattern:R}];return R&&!R.endsWith("**")&&B.push({searchPath:f.searchPath,pattern:R+"/**"}),B}q(f,I,R){const B=this.r((0,h.toWorkspaceFolder)(f.searchPath),I,R,!1);return B?{...B,includePattern:f.pattern}:null}r(f,I,R,B){let X;const q=v.URI.isUri(f)?f:f.uri;if(R.searchPaths){const U=R.searchPaths.filter(H=>(0,y.isEqual)(H.searchPath,q))[0];if(U&&!U.pattern)return null;U&&(X=U.pattern)}const N=this.a.getValue({resource:q}),F={...this.l(N,I)||{},...X||{}},z=v.URI.isUri(f)?(0,y.basename)(f):f.name;return{folder:q,folderName:B?z:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof I.disregardParentIgnoreFiles=="boolean"?I.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!N.search.followSymlinks}}};w=qe([He(0,d.IConfigurationService),He(1,h.IWorkspaceContextService),He(2,b.IEditorGroupsService),He(3,m.ILogService),He(4,p.IPathService)],w),e.QueryBuilder=w;function i(r){const f=r.match(/[\*\{\}\(\)\[\]\?]/);if(f){const I=f.index,R=r.substr(0,I).match(/[/|\\][^/\\]*$/);if(R){let B=r.substr(0,R.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:r.substr((R.index||0)+1)}}}return{pathPortion:r}}function o(...r){return r.length?r.reduce((f,I)=>(f[I]=!0,f),Object.create(null)):void 0}function u(r){return k.splitGlobAware(r,",").map(f=>f.trim()).filter(f=>!!f.length)}function l(r){return[`**/${r}/**`,`**/${r}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function s(r){return r.replace(/\\/g,"/")}function a(r){return s(r).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(r,f){r=c.distinct(r,B=>B.toString());const I=[],R=f.getWorkspace();return r&&r.forEach(B=>{let X;if(f.getWorkbenchState()===2)X=(0,y.relativePath)(R.folders[0].uri,B),X&&X!=="."&&(X="./"+X);else{const q=f.getWorkspaceFolder(B);if(q){const N=q.name;if(R.folders.filter(F=>F.name===N).length===1){const F=(0,y.relativePath)(q.uri,B);F===""?X=`./${q.name}`:X=`./${q.name}/${F}`}else X=B.fsPath}}X&&I.push(X)}),I}e.resolveResourcesForSearchIncludes=n}),define(ye[287],Ce([1,0,24,2,21,10,3,286,31,46]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function P(d,m){const h=m.activationEvents;if(!h)return Promise.resolve(void 0);const b=[],p=[];for(const l of h)if(/^workspaceContains:/.test(l)){const s=l.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||d.forceUsingSearch?p.push(s):b.push(s)}if(b.length===0&&p.length===0)return Promise.resolve(void 0);let g;const w=new Promise((l,s)=>{g=l}),i=l=>g({activationEvent:l}),o=Promise.all(b.map(l=>v(d,l,i))).then(()=>{}),u=D(d,m.identifier,p,i);return Promise.all([o,u]).then(()=>{g(void 0)}),w}e.checkActivateWorkspaceContainsExtension=P;async function v(d,m,h){for(const b of d.folders)if(await d.exists(c.joinPath(t.URI.revive(b),m))){h(`workspaceContains:${m}`);return}}async function D(d,m,h,b){if(h.length===0)return Promise.resolve(void 0);const p=new k.CancellationTokenSource,g=d.checkExists(d.folders,h,p.token),w=setTimeout(async()=>{p.cancel(),d.logService.info(`Not activating extension '${m.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},L);let i=!1;try{i=await g}catch(o){A.isCancellationError(o)||A.onUnexpectedError(o)}p.dispose(),clearTimeout(w),i&&b(`workspaceContains:${h.join(",")}`)}function E(d,m,h,b){const p=d.get(C.IInstantiationService),g=d.get(S.ISearchService),i=p.createInstance(T.QueryBuilder).file(m.map(o=>(0,y.toWorkspaceFolder)(t.URI.revive(o))),{_reason:"checkExists",includePattern:h,exists:!0});return g.fileSearch(i,b).then(o=>!!o.limitHit,o=>A.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=E});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,c):k?k.value=c:e.set(ne,c),c},Ue=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[41],Ce([1,0,174,9,77,24,18,6,64,2,13,5,34,229,98,33,26,134,10,27,22,211,7,128,3,25,73,16,89,54,40,4,287,97,213,15,96,42]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p,g,w,i,o,u,l,s,a,n,r,f,I,R,B,X,q,N,M){"use strict";var F,z,U;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,u.createDecorator)("IHostUtils");let H=class Mn extends T.Disposable{constructor(te,J,fe,ve,Ee,Ae,Fe,se,le,ue,ee){super(),this.a=this.B(new I.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=J,this.g=fe,this.f=Fe,this.j=ve,this.k=Ee,this.l=Ae,this.m=le,this.p=ue,this.s=ee,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new h.ExtensionDescriptionRegistry(this.f.allExtensions);const ae=(0,m.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new h.ExtensionDescriptionRegistry(_(this.F,ae)),this.G=new E.ExtHostStorage(this.g,this.l),this.H=new B.ExtHostSecretState(this.g),this.I=se,this.h=te.createChild(new n.ServiceCollection([E.IExtHostStorage,this.G],[B.IExtHostSecretState,this.H])),this.J=this.B(new D.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ie,O,W)=>{this.v.$onExtensionActivationError(ie,b.transformErrorForSerialization(O),W)},actualActivateExtension:async(ie,O)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(ie,this.D,this.F))return await this.v.$activateExtension(ie,O),new D.HostExtension;const W=this.D.getExtensionDescription(ie);return this.Y(W,O)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),k.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(te){b.onUnexpectedError(te)}}async Q(){this.I.onWillDeactivateAll();let te=[];try{te=this.D.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.X(Ee))}catch{}await Promise.all(te)}terminate(te,J=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${te}`),this.l.flush(),this.p.dispose(),this.J.dispose(),b.setUnexpectedErrorHandler(ve=>{this.l.error(ve)}),this.g.dispose();const fe=this.Q();Promise.race([(0,C.timeout)(5e3),fe]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${J}`):this.l.info(`Extension host exiting with code ${J}`),this.l.flush(),this.l.dispose(),this.c.exit(J)})}isActivated(te){return this.z.isOpen()?this.J.isActivated(te):!1}async getExtension(te){const J=await this.v.$getExtension(te);let fe;if(J?.browserNlsBundleUris){fe={};for(const ve of Object.keys(J.browserNlsBundleUris))fe[ve]=y.URI.revive(J.browserNlsBundleUris[ve])}return J&&{...J,identifier:new p.ExtensionIdentifier(J.identifier.value),extensionLocation:y.URI.revive(J.extensionLocation),browserNlsBundleUris:fe}}R(te,J){return this.J.activateByEvent(te,J)}S(te,J){return this.J.activateById(te,J)}activateByIdWithErrors(te,J){return this.S(te,J).then(()=>{const fe=this.J.getActivatedExtension(te);if(fe.activationFailed)return Promise.reject(fe.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(te=>this.D)}getExtensionExports(te){return this.z.isOpen()?this.J.getActivatedExtension(te).exports:null}async U(te){if(te.scheme!==q.Schemas.file)return te;const J=await this.c.realpath(te.fsPath);return y.URI.file(J)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(te=>new Z(te))),this.L}async W(te){const J=S.TernarySearchTree.forUris(fe=>A.extUriBiasedIgnorePathCase.ignorePathCasing(fe));return await Promise.all(te.map(async fe=>{if(this.ob(fe)){const ve=await this.U(fe.extensionLocation);J.set(ve,fe)}})),J}X(te){let J=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(te))return J;const fe=this.J.getActivatedExtension(te);if(!fe)return J;try{typeof fe.module.deactivate=="function"&&(J=Promise.resolve(fe.module.deactivate()).then(void 0,ve=>(this.l.error(ve),Promise.resolve(void 0))))}catch(ve){this.l.error(`An error occurred when deactivating the extension '${te.value}':`),this.l.error(ve)}try{(0,T.dispose)(fe.subscriptions)}catch(ve){this.l.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this.l.error(ve)}return J}async Y(te,J){return this.f.remote.isRemote?this.v.$onWillActivateExtension(te.identifier):await this.v.$onWillActivateExtension(te.identifier),this.ab(te,J).then(fe=>{const ve=fe.activationTimes;return this.v.$onDidActivateExtension(te.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,J),this.Z(te,J,"success",ve),fe},fe=>{throw this.Z(te,J,"failure"),fe})}Z(te,J,fe,ve){const Ee=x(te,J);this.u.$publicLog2("extensionActivationTimes",{...Ee,...ve||{},outcome:fe})}ab(te,J){const fe=x(te,J);this.u.$publicLog2("activatePlugin",fe);const ve=this.ob(te);if(!ve)return Promise.resolve(new D.EmptyExtension(D.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${te.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this.l.flush();const Ee=new D.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this.pb(te,(0,A.joinPath)(te.extensionLocation,ve),Ee),this.bb(te)]).then(Ae=>(k.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Mn.cb(this.l,te.identifier,Ae[0],Ae[1],Ee))).then(Ae=>(k.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),Ae))}bb(te){const J=new w.ExtensionGlobalMemento(te,this.G),fe=new w.ExtensionMemento(te.identifier.value,!1,this.G),ve=new X.ExtensionSecrets(te,this.H),Ee=te.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ae=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([J.whenReady,fe.whenReady,this.I.whenReady]).then(()=>{const Fe=this;let se,le;const ue=(0,m.isProposedApiEnabled)(te,"ipc")?this.f.messagePorts?.get(p.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:fe,secrets:ve,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(ee){return t.join(te.extensionLocation.fsPath,ee)},get storagePath(){return Fe.I.workspaceValue(te)?.fsPath},get globalStoragePath(){return Fe.I.globalValue(te).fsPath},get logPath(){return t.join(Fe.f.logsLocation.fsPath,te.identifier.value)},get logUri(){return y.URI.joinPath(Fe.f.logsLocation,te.identifier.value)},get storageUri(){return Fe.I.workspaceValue(te)},get globalStorageUri(){return Fe.I.globalValue(te)},get extensionMode(){return Ee},get extension(){return se===void 0&&(se=new V(Fe,te.identifier,te,Ae,!1)),se},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(te,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe.p.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!le){if(!ue)return;const ee=I.Event.buffer(I.Event.fromDOMEventEmitter(ue,"message",ae=>ae.data));ue.start(),le={onDidReceiveMessage:ee,postMessage:ue.postMessage.bind(ue)}}return le}})})}static cb(te,J,fe,ve,Ee){return fe=fe||{activate:void 0,deactivate:void 0},this.db(te,J,fe,ve,Ee).then(Ae=>new D.ActivatedExtension(!1,null,Ee.build(),fe,Ae,ve.subscriptions))}static db(te,J,fe,ve,Ee){if(typeof fe.activate=="function")try{Ee.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Ae=typeof global=="object"?global:self,Fe=fe.activate.apply(Ae,[ve]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(Fe).then(se=>(Ee.activateResolveStop(),se))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(fe)}eb(te,J){this.S(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:J}).then(void 0,fe=>{this.l.error(fe)})}fb(){this.v.$setPerformanceMarks(k.getMarks());for(const te of this.D.getAllExtensionDescriptions())if(te.activationEvents)for(const J of te.activationEvents)J==="onStartupFinished"&&this.eb(te,J)}gb(){const te=this.R("*",!0).then(void 0,Ee=>{this.l.error(Ee)});this.B(this.j.onDidChangeWorkspace(Ee=>this.hb(Ee.added)));const J=this.j.workspace?this.j.workspace.folders:[],fe=this.hb(J),ve=Promise.all([te,fe]).then(()=>{});return Promise.race([ve,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),ve}hb(te){return te.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(J=>this.ib(te,J))).then(()=>{})}async ib(te,J){if(this.isActivated(J.identifier))return;const fe=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.l,folders:te.map(Ae=>Ae.uri),forceUsingSearch:fe,exists:Ae=>this.c.exists(Ae.fsPath),checkExists:(Ae,Fe,se)=>this.t.$checkExists(Ae,Fe,se)},Ee=await(0,R.checkActivateWorkspaceContainsExtension)(ve,J);if(!!Ee)return this.S(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:Ee.activationEvent}).then(void 0,Ae=>this.l.error(Ae))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(te){throw console.error(te),te}}async jb(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:J}=this.f.environment;if(!te||!J)throw new Error(c.localize(0,null));const fe=await this.pb(null,J,new D.ExtensionActivationTimesBuilder(!1));if(!fe||typeof fe.run!="function")throw new Error(c.localize(1,null,J.toString()));return new Promise((ve,Ee)=>{const Ae=(le,ue)=>{le?Ee(le):ve(typeof ue=="number"&&ue>0?1:0)},Fe=(0,A.originalFSPath)(J),se=fe.run(Fe,Ae);se&&se.then&&se.then(()=>{ve(0)}).catch(le=>{Ee(le instanceof Error&&le.stack?le.stack:String(le))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,J){return this.M[te]=J,(0,T.toDisposable)(()=>{delete this.M[te]})}async lb(te){const J=te.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const fe=te.substr(0,J);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${fe}`,!1),{authorityPrefix:fe,resolver:this.M[fe]}}async $resolveAuthority(te,J){const fe=M.StopWatch.create(!1),ve=()=>`[resolveAuthority(${Q(te)},${J})][${fe.elapsed()}ms] `,Ee=ue=>this.l.info(`${ve()}${ue}`),Ae=(ue,ee=void 0)=>this.l.error(`${ve()}${ue}`,ee);Ee("activating resolver...");const{authorityPrefix:Fe,resolver:se}=await this.lb(te);if(!se)return Ae("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Fe}.`,detail:void 0}};const le=new C.IntervalTimer;try{Ee("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(se)),le.cancelAndSet(()=>Ee("waiting..."),1e3),Ee("invoking resolve()..."),k.mark(`code/extHost/willResolveAuthority/${Fe}`);const ue=await se.resolve(te,{resolveAttempt:J});k.mark(`code/extHost/didResolveAuthorityOK/${Fe}`),le.dispose(),Ee(`returned ${ue.host}:${ue.port}`);const ee={authority:te,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},ae={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ee,options:ae,tunnelInformation:{environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures}}}}catch(ue){if(k.mark(`code/extHost/didResolveAuthorityError/${Fe}`),le.dispose(),Ae("returned an error",ue),ue instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(te,J){this.l.info(`$getCanonicalURI invoked for authority (${Q(te)})`);const{resolver:fe}=await this.lb(te);if(!fe)return null;const ve=y.URI.revive(J);if(typeof fe.getCanonicalURI>"u")return ve;const Ee=await(0,C.asPromise)(()=>fe.getCanonicalURI(ve));return Ee||ve}static mb(te,J,fe){const ve=new h.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ve.deltaExtensions(fe.toAdd,fe.toRemove);const Ee=(0,m.extensionIdentifiersArrayToSet)(J.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of fe.myToRemove)Ee.delete(p.ExtensionIdentifier.toKey(Fe));for(const Fe of fe.myToAdd)Ee.add(p.ExtensionIdentifier.toKey(Fe));const Ae=_(ve,Ee);return{globalRegistry:ve,myExtensions:Ae}}$startExtensionHost(te){te.toAdd.forEach(ve=>ve.extensionLocation=y.URI.revive(ve.extensionLocation));const{globalRegistry:J,myExtensions:fe}=Mn.mb(this.F,this.D,te);return this.F.set(J.getAllExtensionDescriptions()),this.D.set(fe),this.kb()}$activateByEvent(te,J){return J===1?this.R(te,!1):this.z.wait().then(fe=>this.R(te,!1))}async $activate(te,J){return await this.z.wait(),this.D.getExtensionDescription(te)?(await this.S(te,J),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(Ae=>Ae.extensionLocation=y.URI.revive(Ae.extensionLocation));const{globalRegistry:J,myExtensions:fe}=Mn.mb(this.F,this.D,te),ve=await this.W(fe);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.F.set(J.getAllExtensionDescriptions()),this.D.set(fe),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const J=g.VSBuffer.alloc(te),fe=Math.random()%256;for(let ve=0;ve<te;ve++)J.writeUInt8(fe,ve);return J}async $updateRemoteConnectionData(te){this.P=te,this.a.fire()}};H=qe([He(0,u.IInstantiationService),He(1,e.IHostUtils),He(2,a.IExtHostRpcService),He(3,d.IExtHostWorkspace),He(4,v.IExtHostConfiguration),He(5,L.ILogService),He(6,l.IExtHostInitDataService),He(7,s.IExtensionStoragePaths),He(8,r.IExtHostTunnelService),He(9,f.IExtHostTerminalService),He(10,N.IExtHostLocalizationService)],H),e.AbstractExtHostExtensionService=H;function x(ge,te){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,u.createDecorator)("IExtHostExtensionService");class V{constructor(te,J,fe,ve,Ee){F.set(this,void 0),z.set(this,void 0),U.set(this,void 0),Je(this,F,te,"f"),Je(this,z,J,"f"),Je(this,U,fe.identifier,"f"),this.id=fe.identifier.value,this.extensionUri=fe.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(fe.extensionLocation)),this.packageJSON=fe,this.extensionKind=ve,this.isFromDifferentExtensionHost=Ee}get isActive(){return Ue(this,F,"f").isActivated(Ue(this,U,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,F,"f").getExtensionExports(Ue(this,U,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,F,"f").activateByIdWithErrors(Ue(this,U,"f"),{startup:!1,extensionId:Ue(this,z,"f"),activationEvent:"api"}),this.exports}}e.Extension=V,F=new WeakMap,z=new WeakMap,U=new WeakMap;function _(ge,te){return ge.getAllExtensionDescriptions().filter(J=>te.has(p.ExtensionIdentifier.toKey(J.identifier)))}function Q(ge){const te=ge.indexOf("+");return te===-1?ge:ge.substring(0,te)}class Z{constructor(te){this.a=te}setSearchTree(te){this.a=te}findSubstr(te){return this.a.findSubstr(te)}forEach(te){return this.a.forEach(te)}}e.ExtensionPaths=Z}),define(ye[288],Ce([1,0,77,2,5,34,26,27,16,25,3,41,36,13,8]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(w,i,o,u,l,s,a){this.c=w,this.d=i,this.e=o,this.f=u,this.g=l,this.h=s,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),c.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new h(this.c,i,this.d,w,this.i)),this.register(this.e.createInstance(b,i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(p,i,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const i of w.nodeModuleName)this.a.set(i,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(i=>w.alternativeModuleName(i))}};d=qe([He(2,L.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,P.IExtHostExtensionService),He(5,y.IExtHostInitDataService),He(6,D.ILogService)],d),e.RequireInterceptor=d;let m=class ti{constructor(w){if(w.environment.appRoot&&ti.a.size){const i=(0,E.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),o="[a-z0-9_.-]",u=`@${o}+\\/${o}+|${o}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${l}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const i=this.b.exec(this.c(w));if(!i)return;const[,o,u,l]=i,s=ti.a.get(u);if(s!==void 0)return console.warn(`${u} as been renamed to ${s}, please update your imports`),o+s+l}c(w){return w.replace(/\\/g,"/")}};m.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),m=qe([He(0,y.IExtHostInitDataService)],m);class h{constructor(w,i,o,u,l){this.c=w,this.d=i,this.e=o,this.f=u,this.g=l,this.nodeModuleName="vscode",this.a=new Map}load(w,i){const o=this.d.findSubstr(i);if(o){let u=this.a.get(T.ExtensionIdentifier.toKey(o.identifier));return u||(u=this.c(o,this.e,this.f),this.a.set(T.ExtensionIdentifier.toKey(o.identifier),u)),u}if(!this.b){let u="";this.d.forEach((l,s)=>u+=`	${s} -> ${l.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${u}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let b=class{constructor(w,i,o){this.d=w,this.nodeModuleName="keytar",this.a=i.getProxy(k.MainContext.MainThreadTelemetry);const{environment:u}=o,l=i.getProxy(k.MainContext.MainThreadKeytar);if(u.appRoot){let s=u.appRoot.fsPath;v.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.b=new Set,this.b.add(`${s}/node_modules.asar/keytar`),this.b.add(`${s}/node_modules/keytar`)}this.c={getPassword:(s,a)=>l.$getPassword(s,a),setPassword:(s,a,n)=>l.$setPassword(s,a,n),deletePassword:(s,a)=>l.$deletePassword(s,a),findPassword:s=>l.$findPassword(s),findCredentials(s){return l.$findCredentials(s)}}}load(w,i){const o=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const i=w.length;if(i<=7||!this.b)return;const o=i-7;if((w.charAt(o)==="/"||w.charAt(o)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};b=qe([He(1,S.IExtHostRpcService),He(2,y.IExtHostInitDataService)],b);let p=class{constructor(w,i,o){this.e=w,this.f=i,this.nodeModuleName=["open","opn"],this.d=o.getProxy(k.MainContext.MainThreadTelemetry);const u=o.getProxy(k.MainContext.MainThreadWindow);this.c=(l,s)=>{const a=t.URI.parse(l);return s?this.g(l,s):a.scheme==="http"||a.scheme==="https"?u.$openUri(a,l,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?u.$openUri(a,l,{}):this.g(l,s)}}load(w,i,o){const u=this.e.findSubstr(i);return u&&(this.a=u.identifier.value,this.h()),this.b=o(w),this.c}g(w,i){return this.i(),this.b(w,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};p=qe([He(2,S.IExtHostRpcService)],p)}),define(ye[48],Ce([1,0,82,6,9,36,3,58,59,41,7,33,225,34]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class E extends v.AbstractVariableResolverService{constructor(h,b,p,g,w,i,o){function u(){if(p){const l=p.activeEditor();if(l)return l.document.uri;const s=g.tabGroups.all.find(a=>a.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof L.TextDiffTabInput||s.input instanceof L.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof L.TextTabInput||s.input instanceof L.NotebookEditorTabInput||s.input instanceof L.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:l=>{const s=i.folders.filter(a=>a.name===l);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(l,s)=>w.getConfiguration(void 0,l).get(s),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=u();if(l)return k.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const l=u();if(l){const s=b.getWorkspaceFolder(l);if(s)return k.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(p){const l=p.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(p){const l=p.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>h.getExtension(l)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(A.env))}}let d=class extends t.Disposable{constructor(h,b,p,g,w){super(),this.b=h,this.c=b,this.g=p,this.h=g,this.i=w,this.a=new c.Lazy(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new E(this.b,this.c,this.g,this.i,i,u,this.j())})}getResolver(){return this.a.getValue()}j(){}};d=qe([He(0,y.IExtHostExtensionService),He(1,P.IExtHostWorkspace),He(2,T.IExtHostDocumentsAndEditors),He(3,D.IExtHostConfiguration),He(4,S.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(ye[78],Ce([1,0,18,4,11,2,3,5,59,41,16,7,33,131,217,34,48]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(u,l,s,a,n,r){this.D=l,this.E=s,this.F=a,this.G=n,this.H=r,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=u.getProxy(T.MainContext.MainThreadDebugService),this.z=new t.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new p(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(f=>{f.onDidChange(I=>{this.I(f)}),this.I(f)})}asDebugSourceUri(u,l){const s=u;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let a=`debug:${encodeURIComponent(s.path||"")}`,n="?";return l&&(a+=`${n}session=${encodeURIComponent(l.id)}`,n="&"),a+=`${n}ref=${s.sourceReference}`,A.URI.parse(a)}else{if(s.path)return A.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(u){const l=[];for(const s of u.getAllExtensionDescriptions())if(s.contributes){const a=s.contributes.debuggers;if(a&&a.length>0)for(const n of a)(0,E.isDebuggerMainContribution)(n)&&l.push(n.type)}this.k.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const u=[];return this.w.forEach(l=>u.push(l)),u}addBreakpoints(u){this.T();const l=u.filter(n=>{const r=n.id;return this.w.has(r)?!1:(this.w.set(r,n),!0)});this.U(l,[],[]);const s=[],a=new Map;for(const n of l)if(n instanceof P.SourceBreakpoint){let r=a.get(n.location.uri.toString());r||(r={type:"sourceMulti",uri:n.location.uri,lines:[]},a.set(n.location.uri.toString(),r),s.push(r)),r.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof P.FunctionBreakpoint&&s.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(s)}removeBreakpoints(u){this.T();const l=u.filter(r=>this.w.delete(r.id));this.U([],l,[]);const s=l.filter(r=>r instanceof P.SourceBreakpoint).map(r=>r.id),a=l.filter(r=>r instanceof P.FunctionBreakpoint).map(r=>r.id),n=l.filter(r=>r instanceof P.DataBreakpoint).map(r=>r.id);return this.k.$unregisterBreakpoints(s,a,n)}startDebugging(u,l,s){return this.k.$startDebugging(u?u.uri:void 0,l,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,suppressSaveBeforeStart:s.suppressSaveBeforeStart,suppressDebugStatusbar:s.suppressDebugStatusbar??s.debugUI?.simple,suppressDebugToolbar:s.suppressDebugToolbar??s.debugUI?.simple,suppressDebugView:s.suppressDebugView??s.debugUI?.simple})}stopDebugging(u){return this.k.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,l,s){if(!l)return new P.Disposable(()=>{});const a=this.d++;return this.f.push({type:u,handle:a,provider:l}),this.k.$registerDebugConfigurationProvider(u,s,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,a),new P.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==l),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(u,l,s){if(!s)return new P.Disposable(()=>{});if(!this.P(u,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.M(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:l,handle:a,factory:s}),this.k.$registerDebugAdapterDescriptorFactory(l,a),new P.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==s),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(u,l){if(!l)return new P.Disposable(()=>{});const s=this.i++;return this.j.push({type:u,handle:s,factory:l}),new P.Disposable(()=>{this.j=this.j.filter(a=>a.factory!==l)})}async $runInTerminal(u,l){return Promise.resolve(void 0)}async $substituteVariables(u,l){let s;const a=await this.W(u);return a&&(s={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(s,l)}J(u,l){if(u.type==="implementation")return new w(u.implementation)}K(){}async $startDASession(u,l){const s=this,a=await this.V(l);return this.R(this.M(a.type),a).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const r=this.L(n),f=this.J(r,a);if(!f)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const I=f;return this.A.set(u,I),this.Q(a).then(R=>(R&&this.B.set(u,R),I.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const X=B,q={type:"response",seq:0,command:X.command,request_seq:X.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const N=await this.C.sign(X.arguments.value);q.body={signature:N},I.sendResponse(q)}else throw new Error("no signer")}catch(N){q.success=!1,q.message=N.message,I.sendResponse(q)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(B),B=(0,E.convertToVSCPaths)(B,!0),s.k.$acceptDAMessage(u,B)}),I.onError(B=>{R&&R.onError&&R.onError(B),this.k.$acceptDAError(u,B.name,B.message,B.stack)}),I.onExit(B=>{R&&R.onExit&&R.onExit((0,k.withNullAsUndefined)(B),void 0),this.k.$acceptDAExit(u,(0,k.withNullAsUndefined)(B),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),I.startSession()))})}$sendDAMessage(u,l){l=(0,E.convertToDAPaths)(l,!1);const s=this.B.get(u);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(l),this.A.get(u)?.sendMessage(l)}$stopDASession(u){const l=this.B.get(u);this.B.delete(u),l&&l.onWillStopSession&&l.onWillStopSession();const s=this.A.get(u);return this.A.delete(u),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const l=[],s=[],a=[];if(u.added)for(const n of u.added){const r=n.id;if(r&&!this.w.has(r)){let f;if(n.type==="function")f=new P.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")f=new P.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const I=A.URI.revive(n.uri);f=new P.SourceBreakpoint(new P.Location(I,new P.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}f._id=r,this.w.set(r,f),l.push(f)}}if(u.removed)for(const n of u.removed){const r=this.w.get(n);r&&(this.w.delete(n),s.push(r))}if(u.changed){for(const n of u.changed)if(n.id){const r=this.w.get(n.id);if(r){if(r instanceof P.FunctionBreakpoint&&n.type==="function"){const f=r;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.functionName=n.functionName}else if(r instanceof P.SourceBreakpoint&&n.type==="source"){const f=r;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.location=new P.Location(A.URI.revive(n.uri),new P.Position(n.line,n.character))}a.push(r)}}}this.U(l,s,a)}$provideDebugConfigurations(u,l,s){return(0,c.asPromise)(async()=>{const a=this.O(u);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(l);return a.provideDebugConfigurations(n,s)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(u,l,s,a){return(0,c.asPromise)(async()=>{const n=this.O(u);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const r=await this.W(l);return n.resolveDebugConfiguration(r,s,a)})}$resolveDebugConfigurationWithSubstitutedVariables(u,l,s,a){return(0,c.asPromise)(async()=>{const n=this.O(u);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const r=await this.W(l);return n.resolveDebugConfigurationWithSubstitutedVariables(r,s,a)})}async $provideDebugAdapter(u,l){const s=this.N(u);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(l);return this.R(s,a).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(u){const l=await this.V(u);this.m.fire(l)}async $acceptDebugSessionTerminated(u){const l=await this.V(u);l&&(this.n.fire(l),this.l.delete(l.id))}async $acceptDebugSessionActiveChanged(u){this.q=u?await this.V(u):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(u,l){(await this.V(u))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(u,l){const a={session:await this.V(u),event:l.event,body:l.body};this.u.fire(a)}L(u){if(u instanceof P.DebugAdapterExecutable)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof P.DebugAdapterServer)return{type:"server",port:u.port,host:u.host};if(u instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:u.path};if(u instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}M(u){const l=this.h.filter(s=>s.type===u);if(l.length>0)return l[0].factory}N(u){const l=this.h.filter(s=>s.handle===u);if(l.length>0)return l[0].factory}O(u){const l=this.f.filter(s=>s.handle===u);if(l.length>0)return l[0].provider}P(u,l){if(u.contributes){const s=u.contributes.debuggers;if(s&&s.length>0){for(const a of s)if(a.label&&a.type&&a.type===l)return!0}}return!1}Q(u){const s=u.configuration.type,a=this.j.filter(n=>n.type===s||n.type==="*").map(n=>(0,c.asPromise)(()=>n.factory.createDebugAdapterTracker(u)).then(r=>r,r=>null));return Promise.race([Promise.all(a).then(n=>{const r=n.filter(f=>!!f);if(r.length>0)return new g(r)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(u,l){const s=l.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new P.DebugAdapterServer(s));if(u){const n=await this.E.getExtensionRegistry();return(0,c.asPromise)(()=>u.createDebugAdapterDescriptor(l,this.S(l,n))).then(r=>{if(r)return r})}const a=await this.E.getExtensionRegistry();return Promise.resolve(this.S(l,a))}S(u,l){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(u,l,s){(u.length>0||l.length>0||s.length>0)&&this.z.fire(Object.freeze({added:u,removed:l,changed:s}))}async V(u){if(u)if(typeof u=="string"){const l=this.l.get(u);if(l)return l}else{let l=this.l.get(u.id);if(!l){const s=await this.W(u.folderUri),a=u.parent?this.l.get(u.parent):void 0;l=new b(this.k,u.id,u.type,u.name,s,u.configuration,a),this.l.set(l.id,l),this.k.$sessionCached(l.id)}return l}throw new Error("cannot find session")}W(u){if(u){const l=A.URI.revive(u);return this.D.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};h=qe([He(0,L.IExtHostRpcService),He(1,v.IExtHostWorkspace),He(2,y.IExtHostExtensionService),He(3,d.IExtHostConfiguration),He(4,S.IExtHostEditorTabs),He(5,m.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class b{constructor(u,l,s,a,n,r,f){this.d=u,this.f=l,this.g=s,this.h=a,this.i=n,this.j=r,this.k=f}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(u){this.h=u,this.d.$setDebugSessionName(this.f,u)}get parentSession(){return this.k}_acceptNameChanged(u){this.h=u}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(u,l){return this.d.$customDebugAdapterRequest(this.f,u,l)}getDebugProtocolBreakpoint(u){return this.d.$getDebugProtocolBreakpoint(this.f,u.id)}}e.ExtHostDebugSession=b;class p{constructor(u){this.value=Object.freeze({append(l){u.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=p;class g{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(l=>l.onError?l.onError(u):void 0)}onExit(u,l){this.d.forEach(s=>s.onExit?s.onExit(u,l):void 0)}}class w extends D.AbstractDebugAdapter{constructor(u){super(),this.h=u,u.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends h{constructor(u,l,s,a,n,r){super(u,l,s,a,n,r)}};i=qe([He(0,L.IExtHostRpcService),He(1,v.IExtHostWorkspace),He(2,y.IExtHostExtensionService),He(3,d.IExtHostConfiguration),He(4,S.IExtHostEditorTabs),He(5,m.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(ye[289],Ce([1,0,10,77,2,5,281,13,88,89,25,197,16,55,41,95]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class m{static async installEarlyHandler(p){const g=p.get(T.ILogService),i=p.get(v.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(o=>{g.error(o);const u=c.transformErrorForSerialization(o);i.$onUnexpectedError(u)})}static async installFullHandler(p){const g=p.get(T.ILogService),w=p.get(v.IExtHostRpcService),i=p.get(E.IExtHostExtensionService),o=p.get(d.IExtHostTelemetry),u=w.getProxy(A.MainContext.MainThreadExtensionService),l=w.getProxy(A.MainContext.MainThreadErrors),s=await i.getExtensionPathIndex(),a=new WeakMap;Error.prepareStackTrace=(n,r)=>{let f="",I,R;for(const B of r)f+=`
	at ${B.toString()}`,R=B.getFileName(),!I&&R&&(I=s.findSubstr(k.URI.file(R)));return a.set(n,I?.identifier),`${n.name||"Error"}: ${n.message||""}${f}`},c.setUnexpectedErrorHandler(n=>{g.error(n);const r=c.transformErrorForSerialization(n),f=a.get(n);if(!f){l.$onUnexpectedError(r);return}u.$onExtensionRuntimeError(f,r);const I=o.onExtensionError(f,n);g.trace("forwarded error to extension?",I,f)})}}Error.stackTraceLimit=100;class h{constructor(p,g,w,i,o){this.a=w,this.b=new C.RPCProtocol(p,null,i),g=h.e(g,this.b);const u=new y.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());u.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:o}),u.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),u.set(D.IURITransformerService,new D.URITransformerService(i)),u.set(E.IHostUtils,w);const l=new P.InstantiationService(u,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(s=>s.get(T.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",g),this.c=l.invokeFunction(s=>s.get(E.IExtHostExtensionService)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(p){const g=this.b.getProxy(A.MainContext.MainThreadExtensionService);return k.URI.revive(await g.$asBrowserUri(p))}terminate(p){this.c.terminate(p)}static e(p,g){p.allExtensions.forEach(i=>{i.extensionLocation=k.URI.revive(g.transformIncomingURIs(i.extensionLocation));const o={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(u=>o[u]=k.URI.revive(g.transformIncomingURIs(i.browserNlsBundleUris[u]))),i.browserNlsBundleUris=o)}),p.environment.appRoot=k.URI.revive(g.transformIncomingURIs(p.environment.appRoot));const w=p.environment.extensionDevelopmentLocationURI;return w&&(p.environment.extensionDevelopmentLocationURI=w.map(i=>k.URI.revive(g.transformIncomingURIs(i)))),p.environment.extensionTestsLocationURI=k.URI.revive(g.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=k.URI.revive(g.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=k.URI.revive(g.transformIncomingURIs(p.environment.workspaceStorageHome)),p.environment.extensionTelemetryLogResource=k.URI.revive(g.transformIncomingURIs(p.environment.extensionTelemetryLogResource)),p.nlsBaseUrl=k.URI.revive(g.transformIncomingURIs(p.nlsBaseUrl)),p.logsLocation=k.URI.revive(g.transformIncomingURIs(p.logsLocation)),p.logFile=k.URI.revive(g.transformIncomingURIs(p.logFile)),p.workspace=g.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=h}),define(ye[290],Ce([1,0,18,12,180,196,203,78,59,41,16,40,7,48,33,218,220,34]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends T.ExtHostDebugServiceBase{constructor(o,u,l,s,a,n,r){super(o,u,l,s,n,r),this.Z=a,this.X=new w}J(o,u){switch(o.type){case"server":return new d.SocketDebugAdapter(o);case"pipeServer":return new d.NamedPipeDebugAdapter(o);case"executable":return new d.ExecutableDebugAdapter(o,u.type)}return super.J(o,u)}S(o,u){const l=d.ExecutableDebugAdapter.platformAdapterExecutable(u.getAllExtensionDescriptions(),o.type);if(l)return new v.DebugAdapterExecutable(l.command,l.args,l.options)}K(){return new C.SignService}async $runInTerminal(o,u){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(N=>{this.X.onTerminalClosed(N)}));const l=await this.F.getConfigProvider(),s=this.Z.getDefaultShell(!0),a=this.Z.getDefaultShellArgs(!0),n=o.title||k.localize(0,null),r=JSON.stringify({shell:s,shellArgs:a});let f=await this.X.checkout(r,n),I,R=!1;if(f)I=o.cwd;else{const N={shellPath:s,shellArgs:a,cwd:o.cwd,name:n,iconPath:new v.ThemeIcon("debug")};R=!0,f=this.Z.createTerminalFromOptions(N,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(f,r)}f.show(!0);const B=await f.processId;R?await new Promise(N=>setTimeout(N,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?f.sendText("cls"):s.indexOf("bash")>=0?f.sendText("clear"):t.isWindows?f.sendText("cls"):f.sendText("clear"));const X=(0,m.prepareCommand)(s,o.args,!!o.argsCanBeInterpretedByShell,I,o.env);f.sendText(X);const q=this.onDidTerminateDebugSession(N=>{N.id===u&&(this.X.free(f),q.dispose())});return B}else if(o.kind==="external")return g(o,await this.F.getConfigProvider());return super.$runInTerminal(o,u)}};b=qe([He(0,L.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,y.IExtHostExtensionService),He(3,h.IExtHostConfiguration),He(4,P.IExtHostTerminalService),He(5,S.IExtHostEditorTabs),He(6,D.IExtHostVariableResolverProvider)],b),e.ExtHostDebugService=b;let p;function g(i,o){if(!p)if(t.isWindows)p=new A.WindowsExternalTerminalService;else if(t.isMacintosh)p=new A.MacExternalTerminalService;else if(t.isLinux)p=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const u=o.getConfiguration("terminal");return p.runInTerminal(i.title,i.cwd,i.args,i.env||{},u.external||{})}class w{constructor(){this.b=new Map}async checkout(o,u){const s=[...this.b.entries()].map(([a,n])=>(0,c.createCancelablePromise)(async r=>{if(a.name!==u||n.lastUsedAt!==-1&&await(0,m.hasChildProcesses)(await a.processId))return null;const f=Date.now();return n.lastUsedAt+w.a>f||r.isCancellationRequested||n.config!==o?null:(n.lastUsedAt=f,a)}));return await(0,c.firstParallel)(s,a=>!!a)}insert(o,u){this.b.set(o,{lastUsedAt:Date.now(),config:u})}free(o){const u=this.b.get(o);u&&(u.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}w.a=1e3}),define(ye[291],Ce([1,0,9,2,115,33,58,34,46,40,16,25,76,15,13,71,24,87,48]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let p=class extends v.ExtHostTaskBase{constructor(w,i,o,u,l,s,a,n,r){super(w,i,o,u,l,s,a,n),this.B=o,this.C=r,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(D.Schemas.vscodeRemote,{scheme:D.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(D.Schemas.file,{scheme:D.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(w,i){const o=i;if(!i.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const u=v.TaskHandleDTO.from(o,this.B),l=await this.a.$getTaskExecution(u);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.y(l,i);return this.a.$executeTask(u).catch(()=>{}),s}else{const u=v.TaskDTO.from(i,w);if(u===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(u.execution)&&await this.x(u,i,!1);const l=await this.y(await this.a.$getTaskExecution(u),i);return this.a.$executeTask(u).catch(()=>{}),l}}u(w,i,o,u){const l=[];if(u)for(const s of u){this.z(s,o),(!s.definition||!w[s.definition.type])&&this.f.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const a=v.TaskDTO.from(s,o.extension);a&&(l.push(a),v.CustomExecutionDTO.is(a.execution)&&i.push(this.x(a,s,!0)))}return{tasks:l,extension:o.extension}}async v(w){return w}async F(w){let i=w&&w.length>0?w[0]:void 0;if(!i){const o=t.URI.file((0,h.homedir)());i=new S.WorkspaceFolder({uri:o,name:m.basename(o),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(w,i){const o=t.URI.revive(w),u={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(o),s=await this.b.getWorkspaceFolders2()??[],a=await this.C.getResolver(),n=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(s);for(const r of i.variables)u.variables[r]=await a.resolveAsync(n,r);if(i.process!==void 0){let r;if(i.process.path!==void 0){r=i.process.path.split(c.delimiter);for(let f=0;f<r.length;f++)r[f]=await a.resolveAsync(n,r[f])}u.process=await k.win32.findExecutable(await a.resolveAsync(n,i.process.name),i.process.cwd!==void 0?await a.resolveAsync(n,i.process.cwd):void 0,r)}return u}async $jsonTasksSupported(){return!0}async $findExecutable(w,i,o){return k.win32.findExecutable(w,i,o)}};p=qe([He(0,L.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,T.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,E.ILogService),He(7,d.IExtHostApiDeprecationService),He(8,b.IExtHostVariableResolverProvider)],p),e.ExtHostTask=p}),define(ye[292],Ce([1,0,87,48]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class k extends t.ExtHostVariableResolverProviderService{j(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=k}),define(ye[143],Ce([1,0,17,18,21,51,15,9,24,2,31]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(b,p,g,w){this.d=b,this.e=p,this.f=g,this.g=w,this.a=null,this.b=!1,this.c=0}search(b,p){const g=this.d.folderQueries||[],w=new k.CancellationTokenSource;return p.onCancellationRequested(()=>w.cancel()),new Promise((i,o)=>{this.a=new D(b);let u=!1;const l=(s,a)=>{if(!u&&!this.b){const n=this.h(s);d(s)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,u=!0,w.cancel(),s=this.j(s,this.d.maxResults-this.c));const r=this.h(s);this.c+=r,(r>0||!d(s))&&this.a.add(s,a)}};Promise.all(g.map((s,a)=>this.k(s,n=>l(n,a),w.token))).then(s=>{w.dispose(),this.a.flush();const a=s.some(n=>!!n&&!!n.limitHit);i({limitHit:this.b||a,messages:(0,c.flatten)(s.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},s=>{w.dispose();const a=(0,A.toErrorMessage)(s);o(new Error(a))})})}h(b){return d(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}j(b,p){const g=Array.isArray(b.ranges)?b.ranges:[b.ranges],w=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:g.slice(0,p),preview:{matches:w.slice(0,p),text:b.preview.text},uri:b.uri}}async k(b,p,g){const w=new L.QueryGlobTester(this.d,b),i=[],o={report:s=>{if(!this.l(s))return;const a=b.folder.scheme===C.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(s.uri))):void 0,n=S.relativePath(b.folder,s.uri);if(n){const r=w.includedInQuery(n,T.basename(n),a);(0,t.isThenable)(r)?i.push(r.then(f=>{f&&p(s)})):r&&p(s)}}},u=this.n(b),l=await this.e.provideTextSearchResults(v(this.d.contentPattern),u,o,g);return i.length&&await Promise.all(i),l}l(b){if(d(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(b){const p=(0,L.resolvePatternsForProvider)(this.d.includePattern,b.includePattern),g=(0,L.resolvePatternsForProvider)(this.d.excludePattern,b.excludePattern),w={folder:y.URI.from(b.folder),excludes:g,includes:p,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.f.toCanonicalName(b.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=P;function v(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class D{constructor(b){this.e=b,this.b=-1,this.d=null,this.a=new m(512,p=>this.g(p))}add(b,p){this.d&&(this.b!==p||!S.isEqual(this.c,b.uri))&&(this.f(),this.d=null),this.d||(this.b=p,this.d={resource:b.uri,results:[]}),this.d.results.push(E(b))}f(){const b=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,b)}flush(){this.f(),this.a.flush()}g(b){this.e(b)}}e.TextSearchResultsCollector=D;function E(h){return d(h)?{preview:{matches:(0,c.mapArrayOrNot)(h.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:h.preview.text},ranges:(0,c.mapArrayOrNot)(h.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function d(h){return!!h.preview}e.extensionResultIsMatch=d;class m{constructor(b,p){this.g=b,this.h=p,this.c=0,this.d=[],this.e=0}addItem(b,p){!b||this.j(b,p)}addItems(b,p){!b||this.k(b,p)}j(b,p){this.d.push(b),this.e+=p,this.l()}k(b,p){this.d=this.d.concat(b),this.e+=p,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=m,m.a=4e3,m.b=50}),define(ye[79],Ce([1,0,6,5,3,285,16,55,13,2,143]),function(ne,e,c,t,k,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let P=class{constructor(d,m,h){this.k=d,this.l=m,this.n=h,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,m){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const h=this.d++;return this.e.set(h,m),this.c.$registerTextSearchProvider(h,this.o(d)),(0,c.toDisposable)(()=>{this.g.delete(d),this.e.delete(h),this.c.$unregisterProvider(h)})}registerFileSearchProvider(d,m){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const h=this.d++;return this.h.set(h,m),this.c.$registerFileSearchProvider(h,this.o(d)),(0,c.toDisposable)(()=>{this.i.delete(d),this.h.delete(h),this.c.$unregisterProvider(h)})}$provideFileSearchResults(d,m,h,b){const p=v(h),g=this.h.get(d);if(g)return this.j.fileSearch(p,g,w=>{this.c.$handleFileMatch(d,m,w.map(i=>i.resource))},b);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,m,h,b){const p=this.e.get(d);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const g=v(h);return this.q(g,p).search(i=>this.c.$handleTextMatch(d,m,i),b)}$enableExtensionHostSearch(){}q(d,m){return new L.TextSearchManager(d,m,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};P=qe([He(0,C.IExtHostRpcService),He(1,T.IURITransformerService),He(2,S.ILogService)],P),e.ExtHostSearch=P;function v(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(D),extraFileResources:E.extraFileResources&&E.extraFileResources.map(d=>y.URI.revive(d))}}e.reviveQuery=v;function D(E){return{...E,folder:y.URI.revive(E.folder)}}}),define(ye[293],Ce([1,0,88,142,33,139,34,39,58,40,76,78,79,98,54,71,141,72,47,97,95,59,140,13,230,48,96]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p,g,w,i,o,u,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,c.registerSingleton)(o.ILoggerService,i.ExtHostLoggerService,1),(0,c.registerSingleton)(o.ILogService,u.ExtHostLogService,1),(0,c.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,c.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,c.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,c.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,c.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,c.registerSingleton)(D.IExtHostStorage,D.ExtHostStorage,0),(0,c.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,c.registerSingleton)(y.IExtHostTerminalService,y.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,0),(0,c.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow,0),(0,c.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace,0),(0,c.registerSingleton)(p.IExtHostSecretState,p.ExtHostSecretState,0),(0,c.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry,0),(0,c.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,c.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(ye[99],Ce([1,0,17,13,31,75]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=C;function T(P,v,D,E){const d=(0,c.mapArrayOrNot)(D,S),m=new k.TextSearchMatch(v,d,E),h=m.preview.matches;return{ranges:(0,c.mapArrayOrNot)(d,y),uri:P,preview:{text:m.preview.text,matches:(0,c.mapArrayOrNot)(h,y)}}}e.createTextSearchResult=T;function S(P){return new k.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function y(P){return new A.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let L=class{constructor(v,D){this.a=v,this.b=D}appendLine(v){this.b.debug(`${this.a}#search`,v)}};L=qe([He(1,t.ILogService)],L),e.OutputChannel=L}),define(ye[294],Ce([1,0,45,9,83,32,12,8,99,295]),function(ne,e,c,t,k,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(p,g,w,i){const o=v(p,g,w,i),u=g.folder.fsPath;return{cmd:c.spawn(L,o.args,{cwd:u}),rgDiskPath:L,siblingClauses:o.siblingClauses,rgArgs:o,cwd:u}}e.spawnRipgrepCmd=P;function v(p,g,w,i){const o=["--files","--hidden","--case-sensitive"];E([g],w,!1).forEach(l=>{const s=(0,S.anchorGlob)(l);if(o.push("-g",s),C.isMacintosh){const a=(0,k.normalizeNFD)(s);a!==s&&o.push("-g",a)}});const u=D([g],i,void 0,!1);return u.globArgs.forEach(l=>{const s=`!${(0,S.anchorGlob)(l)}`;if(o.push("-g",s),C.isMacintosh){const a=(0,k.normalizeNFD)(s);a!==s&&o.push("-g",a)}}),g.disregardIgnoreFiles!==!1?o.push("--no-ignore"):g.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),g.ignoreSymlinks||o.push("--follow"),p.exists&&o.push("--quiet"),o.push("--no-config"),g.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:u.siblingClauses}}function D(p,g,w,i=!0){const o=[];let u={};return p.forEach(l=>{const s=Object.assign({},l.excludePattern||{},g||{}),a=d(s,i?l.folder.fsPath:void 0,w);o.push(...a.globArgs),a.siblingClauses&&(u=Object.assign(u,a.siblingClauses))}),{globArgs:o,siblingClauses:u}}function E(p,g,w=!0){const i=[];return p.forEach(o=>{const u=Object.assign({},g||{},o.includePattern||{}),l=d(u,w?o.folder.fsPath:void 0);i.push(...l.globArgs)}),i}function d(p,g,w){const i=[],o={};return Object.keys(p).forEach(u=>{if(w&&w.has(u)||!u)return;const l=p[u];u=h(g?m(g,u):u),u.startsWith("\\\\")?u="\\\\"+u.substr(2).replace(/\\/g,"/"):u=u.replace(/\\/g,"/"),typeof l=="boolean"&&l?(u.startsWith("\\\\")&&(u+="**"),i.push(b(u))):l&&l.when&&(o[u]=l)}),{globArgs:i,siblingClauses:o}}function m(p,g){return t.isAbsolute(g)?g:t.join(p,g)}e.getAbsoluteGlob=m;function h(p){return p=T.rtrim(p,"\\"),T.rtrim(p,"/")}function b(p){return A.getRoot(p).toLowerCase()==="c:/"?p.replace(/^c:[/\\]/i,"/"):p}e.fixDriveC=b}),define(ye[296],Ce([1,0,45,65,9,297,17,51,37,83,32,12,42,8,11,29,31,294,110]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const p=new Set;process.on("exit",()=>{p.forEach(u=>u())});class g{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&S.parse(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,b.prepareQuery)(this.b).normalizedLowercase),this.u=l.excludePattern&&S.parse(l.excludePattern),this.t=new Map,l.folderQueries.forEach(s=>{const a=Object.assign({},s.excludePattern||{},this.a.excludePattern||{}),n=s.folder.fsPath;l.folderQueries.map(r=>r.folder.fsPath).filter(r=>r!==n).forEach(r=>{(0,L.isEqualOrParent)(r,n)&&(a[k.relative(n,r)]=!0)}),this.t.set(n,new i(a,n))})}cancel(){this.l=!0,p.forEach(l=>l())}walk(l,s,a,n,r){if(this.m=v.StopWatch.create(!1),this.l)return r(null,this.j);s.forEach(f=>{const I=k.basename(f.fsPath);this.u&&this.u(f.fsPath,I)||this.J(a,{relativePath:f.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(l,(f,I)=>{this.x(this.y,this,f,a,n,R=>{if(R){const B=(0,T.toErrorMessage)(R);console.error(B),this.q.push(B),I(R,void 0)}else I(null,void 0)})},(f,I)=>{this.m.stop();const R=f?C.coalesce(f)[0]:null;r(R,this.j)})}w(l,s,a){const n=new Array(l.length),r=new Array(l.length);let f=!1,I=0;if(l.length===0)return a(null,[]);l.forEach((R,B)=>{s(R,(X,q)=>{if(X?(f=!0,n[B]=null,r[B]=X):(n[B]=q,r[B]=null),++I===l.length)return a(f?r:null,n)})})}x(l,s,...a){try{l.apply(s,a)}catch(n){a[a.length-1](n)}}y(l,s,a,n){const r=l.folder.fsPath,f=P.isMacintosh,I=()=>N&&N.kill();p.add(I);let R=U=>{p.delete(I),R=()=>{},n(U)},B="";const X=this.D(),q=(0,h.spawnRipgrepCmd)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),N=q.cmd,M=!Object.keys(q.siblingClauses).length,F=q.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let z=`${q.rgDiskPath} ${F}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),a({message:z}),this.s=0,this.z(N,"utf8",a,(U,H,x)=>{if(U){R(U);return}if(this.j){R();return}const _=(B+(f?y.normalizeNFC(H||""):H)).split(`
`);if(x){const Q=_.length;_[Q-1]=_[Q-1].trim(),_[Q-1]||_.pop()}else B=_.pop()||"";if(_.length&&_[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.s+=_.length,M){for(const Q of _)if(this.J(s,{base:r,relativePath:Q,searchPath:this.N(l,Q)}),this.j){I();break}(x||this.j)&&R();return}this.G(l,X,r,_,s),x&&(this.H(X,r,s),R())})}spawnFindCmd(l){const s=this.t.get(l.folder.fsPath),a=s.getBasenameTerms(),n=s.getPathTerms(),r=["-L","."];if(a.length||n.length){r.push("-not","(","(");for(const f of a)r.push("-name",f),r.push("-o");for(const f of n)r.push("-path",f),r.push("-o");r.pop(),r.push(")","-prune",")")}return r.push("-type","f"),c.spawn("find",r,{cwd:l.folder.fsPath})}readStdout(l,s,a){let n="";this.z(l,s,()=>{},(r,f,I)=>{if(r){a(r);return}n+=f,I&&a(null,n)})}z(l,s,a,n){let r=(R,B,X)=>{(R||X)&&(r=()=>{},this.r?.stop()),n(R,B,X)},f=!1;l.stdout?(this.A(l.stdout,s,r),l.stdout.once("data",()=>f=!0)):a({message:"stdout is null"});let I;l.stderr?I=this.B(l.stderr):a({message:"stderr is null"}),l.on("error",R=>{r(R)}),l.on("close",R=>{let B;!f&&(B=this.C(I,s))&&o(B)?r(new Error(`command failed with error code ${R}: ${this.C(I,s)}`)):(this.g&&R===0&&(this.j=!0),r(null,"",!0))})}A(l,s,a){const n=new A.StringDecoder(s);return l.on("data",r=>{a(null,n.write(r))}),n}B(l){const s=[];return l.on("data",a=>{s.push(a)}),s}C(l,s){const a=new A.StringDecoder(s);return l.map(n=>a.write(n)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:s},a,n,r){n.indexOf(this.b)!==-1&&this.J(r,{base:a,relativePath:this.b,searchPath:this.N(l,this.b)});const f=I=>{const R=k.basename(I),B=k.dirname(I);let X=s[B];X||(X=s[B]=[],f(B)),X.push({base:a,relativePath:I,basename:R,searchPath:this.N(l,I)})};n.forEach(f)}H({rootEntries:l,pathToEntries:s},a,n){const r=this,f=this.t.get(a),I=this.b;function R(B){r.o++;const X=(0,m.hasSiblingFn)(()=>B.map(q=>q.basename));for(let q=0,N=B.length;q<N;q++){const M=B[q],{relativePath:F,basename:z}=M;if(f.test(F,z,I!==z?X:void 0))continue;const U=s[F];if(U)R(U);else{if(r.p++,F===I)continue;r.J(n,M)}if(r.j)break}}R(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,s,a,n,r){const f=l.folder,I=(0,m.hasSiblingFn)(()=>a);this.w(a,(R,B)=>{if(this.l||this.j)return B(null);const X=s?[s,R].join(k.sep):R;if(this.t.get(l.folder.fsPath).test(X,R,this.a.filePattern!==R?I:void 0))return B(null);const q=[f.fsPath,X].join(k.sep);t.lstat(q,(N,M)=>{if(N||this.l||this.j)return B(null);this.L(q,M,(F,z)=>F||this.l||this.j?B(null):z.isDirectory()?(this.o++,this.M(q,M,(U,H)=>U||this.l||this.j||(H=H||"",this.v[H])?B(null):(this.v[H]=!0,d.Promises.readdir(q).then(x=>{if(this.l||this.j)return B(null);this.I(l,X,x,n,V=>B(V||null))},x=>{B(null)})))):(this.p++,X===this.b||this.h&&E.isNumber(z.size)&&z.size>this.h||this.J(n,{base:f.fsPath,relativePath:X,searchPath:this.N(l,X)}),B(null,void 0)))})},R=>{const B=R&&C.coalesce(R);return r(B&&B.length>0?B[0]:void 0)})}J(l,s){this.K(s)&&(!this.d||this.d(s.relativePath,k.basename(s.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(s))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.isFilePatternMatch)(l,this.c)}return!0}L(l,s,a){return s.isSymbolicLink()?t.stat(l,a):a(null,s)}M(l,s,a){return s.isSymbolicLink()?t.realpath(l,(n,r)=>n?a(n):a(null,r)):a(null,l)}N(l,s){return l.folderName?k.join(l.folderName,s):s}}e.FileWalker=g;class w{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new g(l)}search(l,s,a){this.c.walk(this.a,this.b,l,s,(n,r)=>{a(n,{limitHit:r,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=w;class i{constructor(l,s){this.expression=l,this.c=s,this.d(l)}d(l){let s,a;Object.keys(l).filter(n=>l[n]).forEach(n=>{k.isAbsolute(n)?(s=s||S.getEmptyExpression(),s[n]=l[n]):(a=a||S.getEmptyExpression(),a[n]=l[n])}),this.a=s&&S.parse(s,{trimForExclusions:!0}),this.b=a&&S.parse(a,{trimForExclusions:!0})}test(l,s,a){return this.b&&this.b(l,s,a)||this.a&&this.a(k.join(this.c,l),s,a)}getBasenameTerms(){const l=[];return this.a&&l.push(...S.getBasenameTerms(this.a)),this.b&&l.push(...S.getBasenameTerms(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...S.getPathTerms(this.a)),this.b&&l.push(...S.getPathTerms(this.b)),l}}function o(u){const l=u.trim().split(`
`),s=l[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return D.uppercaseFirstLetter(l[l.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}}),define(ye[298],Ce([1,0,102,22]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(u){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(l=>l===u)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,C=512,T=512*8,S=512*128;var y;(function(u){u[u.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(y=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(l,s){super(l),this.decodeStreamErrorKind=s}}e.DecodeStreamError=L;class P{static async create(l){let s;if(l!==e.UTF8)s=(await new Promise((n,r)=>{ne(["@vscode/iconv-lite-umd"],n,r)})).getDecoder(d(l));else{const a=new TextDecoder;s={write(n){return a.decode(n,{stream:!0})},end(){return a.decode()}}}return new P(s)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function v(u,l){const s=l.minBytesRequiredForDetection??l.guessEncoding?T:C;return new Promise((a,n)=>{const r=(0,c.newWriteableStream)(q=>q.join("")),f=[];let I=0,R,B;const X=async()=>{try{const q=await o({buffer:t.VSBuffer.concat(f),bytesRead:I},l.guessEncoding);if(q.seemsBinary&&l.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);q.encoding=await l.overwriteEncoding(q.encoding),R=await P.create(q.encoding);const N=R.write(t.VSBuffer.concat(f).buffer);r.write(N),f.length=0,I=0,a({stream:r,detected:q})}catch(q){B?.dispose(),r.destroy(),n(q)}};B=(0,c.listenStream)(u,{onData:async q=>{R?r.write(R.write(q.buffer)):(f.push(q),I+=q.byteLength,I>=s&&(u.pause(),await X(),setTimeout(()=>u.resume())))},onError:q=>r.error(q),onEnd:async()=>{R||await X(),r.end(R?.end())}})})}e.toDecodeStream=v;async function D(u,l,s){const n=(await new Promise((I,R)=>{ne(["@vscode/iconv-lite-umd"],I,R)})).getEncoder(d(l),s);let r=!1,f=!1;return{read(){if(f)return null;const I=u.read();if(typeof I!="string"){if(f=!0,!r&&s?.addBOM)switch(l){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=n.end();return R&&R.length>0?(r=!0,t.VSBuffer.wrap(R)):null}return r=!0,t.VSBuffer.wrap(n.write(I))}}}e.toEncodeReadable=D;async function E(u){return(await new Promise((s,a)=>{ne(["@vscode/iconv-lite-umd"],s,a)})).encodingExists(d(u))}e.encodingExists=E;function d(u){return u===e.UTF8_with_bom||u===null?e.UTF8:u}e.toNodeEncoding=d;function m(u,l){if(!u||l<e.UTF16be_BOM.length)return null;const s=u.readUInt8(0),a=u.readUInt8(1);if(s===e.UTF16be_BOM[0]&&a===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&a===e.UTF16le_BOM[1])return e.UTF16le;if(l<e.UTF8_BOM.length)return null;const n=u.readUInt8(2);return s===e.UTF8_BOM[0]&&a===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=m;const h=["ascii","utf-16","utf-32"];async function b(u){const l=await new Promise((f,I)=>{ne(["jschardet"],f,I)}),s=u.slice(0,S),a=w(s.buffer),n=l.detect(a);if(!n||!n.encoding)return null;const r=n.encoding.toLowerCase();return 0<=h.indexOf(r)?null:g(n.encoding)}const p={ibm866:"cp866",big5:"cp950"};function g(u){const l=u.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return p[l]||l}function w(u){let l="";for(let s=0;s<u.length;s++)l+=String.fromCharCode(u[s]);return l}function i(u){switch(u){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=u.match(/windows(\d+)/);return l?"windows-"+l[1]:u}}}e.toCanonicalName=i;function o({buffer:u,bytesRead:l},s){let a=m(u,l),n=!1;if(a!==e.UTF16be&&a!==e.UTF16le&&u){let r=!0,f=!0,I=!1;for(let R=0;R<l&&R<A;R++){const B=R%2===1,X=u.readUInt8(R)===0;if(X&&(I=!0),r&&(B&&!X||!B&&X)&&(r=!1),f&&(B&&X||!B&&!X)&&(f=!1),X&&!r&&!f)break}I&&(r?a=e.UTF16le:f?a=e.UTF16be:n=!0)}return s&&!n&&!a&&u?b(u.slice(0,l)).then(r=>({seemsBinary:!1,encoding:r})):{seemsBinary:n,encoding:a}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],Ce([1,0,298,29,143]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends k.TextSearchManager{constructor(T,S,y=t,L="searchProcess"){super(T,S,{readdir:P=>y.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,c.toCanonicalName)(P)},L)}}e.NativeTextSearchManager=A}),define(ye[299],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(k){if(k&&this.a.has(k)){const A=this.a.get(k);return this.a.delete(k),A}}addDragOperationTransfer(k,A){this.a.set(k,A)}getRenderedTreeElement(k){if(this.b.has(k))return this.b.get(k)}addRenderedTreeItemElement(k,A){this.b.set(k,A)}removeRenderedTreeItemElement(k){this.b.has(k)&&this.b.delete(k)}}e.TreeviewsService=c}),define(ye[300],Ce([1,0,178,7,24,2,4,6,18,7,11,17,14,21,299,26]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(p,g){if((0,L.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let w;return Array.isArray(p.highlights)&&(w=p.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),w=w.length?w:void 0),{label:p.label,highlights:w}}}class h{constructor(g,w,i){this.d=g,this.e=w,this.f=i,this.a=new Map,this.b=new E.TreeviewsService;function o(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:u=>o(u)?this.i(u):Array.isArray(u)&&u.length>0?u.map(l=>o(l)?this.i(l):l):u})}registerTreeDataProvider(g,w,i){const o=this.createTreeView(g,{treeDataProvider:w},i);return{dispose:()=>o.dispose()}}createTreeView(g,w,i){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=w.dragAndDropController?.dropMimeTypes??[],u=w.dragAndDropController?.dragMimeTypes??[],l=!!w.dragAndDropController?.handleDrag,s=!!w.dragAndDropController?.handleDrop,a=this.h(g,w,i),n=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:o,dragMimeTypes:u,hasHandleDrag:l,hasHandleDrop:s});return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(i,"treeItemCheckbox"),a.onDidChangeCheckboxState},get message(){return a.message},set message(r){a.message=r},get title(){return a.title},set title(r){a.title=r},get description(){return a.description},set description(r){a.description=r},get badge(){return a.badge},set badge(r){r!==void 0&&y.ViewBadge.isViewBadge(r)?a.badge={value:Math.floor(Math.abs(r.value)),tooltip:r.tooltip}:r===void 0&&(a.badge=void 0)},reveal:(r,f)=>a.reveal(r,f),dispose:async()=>{await n,this.a.delete(g),a.dispose()}}}$getChildren(g,w){const i=this.a.get(g);return i?i.getChildren(w):Promise.reject(new Error((0,c.localize)(0,null,g)))}async $handleDrop(g,w,i,o,u,l,s,a){const n=this.a.get(g);if(!n)return Promise.reject(new Error((0,c.localize)(1,null,g)));const r=v.DataTransfer.toDataTransfer(i,async f=>(await this.d.$resolveDropFileData(g,w,f)).buffer);return s===g&&a&&await this.g(r,n,a,u,l),n.onDrop(r,o,u)}async g(g,w,i,o,u){const l=this.b.removeDragOperationTransfer(u);if(l)(await l)?.forEach((s,a)=>{s&&g.set(a,s)});else if(u&&w.handleDrag){const s=w.handleDrag(i,g,o);this.b.addDragOperationTransfer(u,s),await s}return g}async $handleDrag(g,w,i,o){const u=this.a.get(g);if(!u)return Promise.reject(new Error((0,c.localize)(2,null,g)));const l=await this.g(new t.DataTransfer,u,w,o,i);if(!!l)return v.DataTransfer.toDataTransferDTO(l)}async $hasResolve(g){const w=this.a.get(g);if(!w)throw new Error((0,c.localize)(3,null,g));return w.hasResolve}$resolve(g,w,i){const o=this.a.get(g);if(!o)throw new Error((0,c.localize)(4,null,g));return o.resolveTreeItem(w,i)}$setExpanded(g,w,i){const o=this.a.get(g);if(!o)throw new Error((0,c.localize)(5,null,g));o.setExpanded(w,i)}$setSelection(g,w){const i=this.a.get(g);if(!i)throw new Error((0,c.localize)(6,null,g));i.setSelection(w)}$setFocus(g,w){const i=this.a.get(g);if(!i)throw new Error((0,c.localize)(7,null,g));i.setFocus(w)}$setVisible(g,w){const i=this.a.get(g);if(!i)throw new Error((0,c.localize)(8,null,g));i.setVisible(w)}$changeCheckboxState(g,w){const i=this.a.get(g);if(!i)throw new Error((0,c.localize)(9,null,g));i.setCheckboxState(w)}h(g,w,i){const o=new b(g,w,this.d,this.e.converter,this.f,i);return this.a.set(g,o),o}i(g){const w=this.a.get(g.$treeViewId);return w&&"$treeItemHandle"in g?w.getExtensionElement(g.$treeItemHandle):w&&"$focusedTreeItem"in g&&g.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=h;class b extends T.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,L.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,w,i,o,u,l){if(super(),this.C=g,this.D=i,this.F=o,this.G=u,this.H=l,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new D.CancellationTokenSource,l.contributes&&l.contributes.views)for(const n in l.contributes.views)for(const r of l.contributes.views[n])r.id===g&&(this.J=r.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let s,a;this.B(C.Event.debounce(this.w.event,(n,r)=>(n||(n={message:!1,elements:[]}),r.element!==!1&&(s||(s=new Promise(f=>a=f),this.y=this.y.then(()=>s)),Array.isArray(r.element)?n.elements.push(...r.element):n.elements.push(r.element)),r.message&&(n.message=!0),n),200,!0)(({message:n,elements:r})=>{r.length&&(this.z=this.z.then(()=>{const f=a;return s=null,this.U(r).then(()=>f())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(g){const w=g?this.getExtensionElement(g):void 0;if(g&&!w)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let i=this.Q(g);return i||(i=await this.R(w)),i?i.map(o=>o.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,w){w=w||{select:!0,focus:!1};const i=(0,L.isUndefinedOrNull)(w.select)?!0:w.select,o=(0,L.isUndefinedOrNull)(w.focus)?!1:w.focus,u=(0,L.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.y.then(()=>this.N(g)).then(l=>this.P(g,l[l.length-1]).then(s=>this.D.$reveal(this.C,{item:s.item,parentChain:l.map(a=>a.item)},{select:i,focus:o,expand:u})),l=>this.G.error(l)):this.D.$reveal(this.C,void 0,{select:i,focus:o,expand:u})}get message(){return this.I}set message(g){this.I=g,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.D.$setTitle(this.C,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.D.$setTitle(this.C,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=v.ViewBadge.from(g),this.D.$setBadge(this.C,g))}setExpanded(g,w){const i=this.getExtensionElement(g);i&&(w?this.r.fire(Object.freeze({element:i})):this.s.fire(Object.freeze({element:i})))}setSelection(g){(0,P.equals)(this.l,g)||(this.l=g,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const w=(await Promise.all(g.map(async i=>{const o=this.getExtensionElement(i.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:i.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);w.forEach(i=>{i.treeItem.checkboxState=i.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(i=>[i.extensionItem,i.newState])})}async handleDrag(g,w,i){const o=[];for(const u of g){const l=this.getExtensionElement(u);l&&o.push(l)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,w,i),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,w,i){const o=w?this.getExtensionElement(w):void 0;if(!(!o&&w||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(o,g,i):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,w){if(!this.f.resolveTreeItem)return;const i=this.i.get(g);if(i){const o=this.j.get(i);if(o){const u=await this.f.resolveTreeItem(o.extensionItem,i,w)??o.extensionItem;return this.db(u),o.item.tooltip=this.ab(u.tooltip),o.item.command=this.bb(o.disposableStore,u.command),o.item}}}N(g){return this.O(g).then(w=>w?this.N(w).then(i=>this.P(w,i[i.length-1]).then(o=>(i.push(o),i))):Promise.resolve([]))}O(g){const w=this.j.get(g);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(g))}P(g,w){const i=this.j.get(g);return i?Promise.resolve(i):(0,S.asPromise)(()=>this.f.getTreeItem(g)).then(o=>this.gb(g,o,w,!0)).then(o=>this.getChildren(w?w.item.handle:void 0).then(()=>{const u=this.getExtensionElement(o);if(u){const l=this.j.get(u);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}Q(g){if(g){let w;if(typeof g=="string"){const i=this.getExtensionElement(g);w=i?this.j.get(i):void 0}else w=g;return w&&w.children||void 0}return this.h}async R(g){this.nb(g);const w=new D.CancellationTokenSource(this.S.token);try{const i=g?this.j.get(g):void 0,o=await this.f.getChildren(g);if(w.token.isCancellationRequested)return;const u=await Promise.all((0,P.coalesce)(o||[]).map(async l=>{const s=await this.f.getTreeItem(l);return s&&!w.token.isCancellationRequested?this.Z(l,s,i):null}));return w.token.isCancellationRequested?void 0:(0,P.coalesce)(u)}finally{w.dispose()}}U(g){if(g.some(i=>!i))return this.S.dispose(!0),this.S=new D.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const i=this.W(g);if(i.length)return this.X(i)}return Promise.resolve(void 0)}W(g){const w=new Set,i=g.map(u=>this.j.get(u));for(const u of i)if(u&&!w.has(u.item.handle)){let l=u;for(;l&&l.parent&&i.findIndex(s=>l&&l.parent&&s&&s.item.handle===l.parent.item.handle)===-1;){const s=this.i.get(l.parent.item.handle);l=s?this.j.get(s):void 0}l&&!l.parent&&w.add(u.item.handle)}const o=[];return w.forEach(u=>{const l=this.i.get(u);if(l){const s=this.j.get(l);s&&(!s.parent||!w.has(s.parent.item.handle))&&o.push(u)}}),o}X(g){const w={};return Promise.all(g.map(i=>this.Y(i).then(o=>{o&&(w[i]=o.item)}))).then(()=>Object.keys(w).length?this.D.$refresh(this.C,w):void 0)}Y(g){const w=this.getExtensionElement(g);if(w){const i=this.j.get(w);if(i)return this.nb(w),(0,S.asPromise)(()=>this.f.getTreeItem(w)).then(o=>{if(o){const u=this.eb(w,o,i.parent);return this.lb(w,u,i,i.parent),i.dispose(),u}return null})}return Promise.resolve(null)}Z(g,w,i){const o=this.eb(g,w,i);if(w.id&&this.i.has(o.item.handle))throw new Error((0,c.localize)(10,null,w.id));return this.kb(g,o),this.mb(o,i),o}ab(g){return y.MarkdownString.isMarkdownString(g)?v.MarkdownString.from(g):g}bb(g,w){return w?{...this.F.toInternal(w,g),originalId:w.command}:void 0}cb(g){if(!g.checkboxState)return;let w,i;return typeof g.checkboxState=="number"?w=g.checkboxState:(w=g.checkboxState.state,i=g.checkboxState.tooltip),{isChecked:w===y.TreeItemCheckboxState.Checked,tooltip:i}}db(g){if(!y.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,w,i){this.db(w);const o=new T.DisposableStore,u=this.gb(g,w,i),l=this.hb(w);return{item:{handle:u,parentHandle:i?i.item.handle:void 0,label:m(w.label,this.H),description:w.description,resourceUri:w.resourceUri,tooltip:this.ab(w.tooltip),command:this.bb(o,w.command),contextValue:w.contextValue,icon:l,iconDark:this.ib(w)||l,themeIcon:this.fb(w),collapsibleState:(0,L.isUndefinedOrNull)(w.collapsibleState)?y.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.cb(w)},extensionItem:w,parent:i,children:void 0,disposableStore:o,dispose(){o.dispose()}}}fb(g){return g.iconPath instanceof y.ThemeIcon?g.iconPath:void 0}gb(g,{id:w,label:i,resourceUri:o},u,l){if(w)return`${b.b}/${w}`;const s=m(i,this.H),a=u?u.item.handle:b.a;let n=s?s.label:o?(0,k.basename)(o):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const r=this.j.has(g)?this.j.get(g).item.handle:void 0,f=this.Q(u)||[];let I,R=0;do{if(I=`${a}/${R}:${n}`,l||!this.i.has(I)||r===I)break;R++}while(R<=f.length);return I}hb(g){if(g.iconPath&&!(g.iconPath instanceof y.ThemeIcon))return typeof g.iconPath=="string"||A.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof y.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return A.URI.isUri(g)?g:A.URI.file(g)}kb(g,w){this.i.set(w.item.handle,g),this.j.set(g,w)}lb(g,w,i,o){this.i.delete(w.item.handle),this.j.delete(g),w.item.handle!==i.item.handle&&this.i.delete(i.item.handle),this.kb(g,w);const u=this.Q(o)||[],l=u.filter(s=>s.item.handle===i.item.handle)[0];l&&u.splice(u.indexOf(l),1,w)}mb(g,w){w?(w.children||(w.children=[]),w.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const w=this.j.get(g);if(w){if(w.children)for(const i of w.children){const o=this.i.get(i.item.handle);o&&this.ob(o)}w.children=void 0}}else this.pb()}ob(g){const w=this.j.get(g);if(w){if(w.children)for(const i of w.children){const o=this.i.get(i.item.handle);o&&this.ob(o)}this.j.delete(g),this.i.delete(w.item.handle),w.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[301],Ce([1,0,21,10,4,43,2,120,106,152,161,38,5,94,244,243,39,245,34,247,248,249,232,250,58,41,251,252,255,256,257,142,235,262,263,264,98,40,266,300,14,7,68,269,74,141,33,223,254,67,139,76,78,79,13,55,16,25,258,231,54,71,241,267,73,72,272,270,271,242,47,265,268,97,59,95,259,75,260,15,124,234,212,253,6,26,216,96,209,261]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p,g,w,i,o,u,l,s,a,n,r,f,I,R,B,X,q,N,M,F,z,U,H,x,V,_,Q,Z,ge,te,J,fe,ve,Ee,Ae,Fe,se,le,ue,ee,ae,ie,O,W,K,Y,de,be,Pe,pe,De,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe,$,ce,Ie,Le,Be,xe,Ze,gt,mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(ot){const rt=ot.get(ue.IExtHostInitDataService),kt=ot.get(ke.IExtHostFileSystemInfo),Tt=ot.get(de.IExtHostConsumerFileSystem),Nt=ot.get(l.IExtHostExtensionService),pt=ot.get(Z.IExtHostWorkspace),Dt=ot.get(nt.IExtHostTelemetry),zt=ot.get(b.IExtHostConfiguration),Ft=ot.get(se.IURITransformerService),Xe=ot.get(le.IExtHostRpcService),Mt=ot.get(N.IExtHostStorage),Ut=ot.get(Y.IExtensionStoragePaths),Bt=ot.get(Fe.ILoggerService),bt=ot.get(Fe.ILogService),Pt=ot.get(ie.IExtHostTunnelService),Re=ot.get(O.IExtHostApiDeprecationService),Oe=ot.get(Q.IExtHostWindow),Se=ot.get(et.IExtHostSecretState),re=ot.get(_e.IExtHostEditorTabs);Xe.set(v.ExtHostContext.ExtHostFileSystemInfo,kt),Xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Bt),Xe.set(v.ExtHostContext.ExtHostWorkspace,pt),Xe.set(v.ExtHostContext.ExtHostConfiguration,zt),Xe.set(v.ExtHostContext.ExtHostExtensionService,Nt),Xe.set(v.ExtHostContext.ExtHostStorage,Mt),Xe.set(v.ExtHostContext.ExtHostTunnelService,Pt),Xe.set(v.ExtHostContext.ExtHostWindow,Oe),Xe.set(v.ExtHostContext.ExtHostSecretState,Se),Xe.set(v.ExtHostContext.ExtHostTelemetry,Dt),Xe.set(v.ExtHostContext.ExtHostEditorTabs,re);const Ne=Xe.set(v.ExtHostContext.ExtHostDecorations,ot.get(fe.IExtHostDecorations)),$e=Xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(u.IExtHostDocumentsAndEditors)),Qe=Xe.set(v.ExtHostContext.ExtHostCommands,ot.get(m.IExtHostCommands)),Ve=Xe.set(v.ExtHostContext.ExtHostTerminalService,ot.get(M.IExtHostTerminalService)),tt=Xe.set(v.ExtHostContext.ExtHostDebugService,ot.get(Ee.IExtHostDebugService)),St=Xe.set(v.ExtHostContext.ExtHostSearch,ot.get(Ae.IExtHostSearch)),Et=Xe.set(v.ExtHostContext.ExtHostTask,ot.get(ve.IExtHostTask)),Lt=Xe.set(v.ExtHostContext.ExtHostOutputService,ot.get(I.IExtHostOutputService)),vt=Xe.set(v.ExtHostContext.ExtHostLocalization,ot.get(Ze.IExtHostLocalizationService)),It=Xe.set(v.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(Xe)),ft=Xe.set(v.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Xe,$e)),xt=Xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Xe,$e,bt)),jt=Xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(bt,ft,Xe.getProxy(v.MainContext.MainThreadBulkEdits))),yt=Xe.set(v.ExtHostContext.ExtHostNotebook,new ee.ExtHostNotebookController(Xe,Qe,$e,ft)),_t=Xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new ce.ExtHostNotebookDocuments(yt)),an=Xe.set(v.ExtHostContext.ExtHostNotebookEditors,new $.ExtHostNotebookEditors(bt,yt)),Zt=Xe.set(v.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Xe,rt,yt,Qe,bt)),vn=Xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new Me.ExtHostNotebookRenderers(Xe,yt)),At=Xe.set(v.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Xe,$e)),cn=Xe.set(v.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(Xe.getProxy(v.MainContext.MainThreadTreeViews),Qe,bt)),Vt=Xe.set(v.ExtHostContext.ExtHostEditorInsets,new ge.ExtHostEditorInsets(Xe.getProxy(v.MainContext.MainThreadEditorInsets),At,rt.remote)),en=Xe.set(v.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(Xe,bt,kt,$e)),ln=Xe.set(v.ExtHostContext.ExtHostLanguages,new r.ExtHostLanguages(Xe,ft,Qe.converter,Ft)),ut=Xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Ft,ft,Qe,en,bt,Re,Dt)),tn=Xe.set(v.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Xe,ut)),qt=Xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(Xe,bt,$e)),Qt=Xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,B.createExtHostQuickOpen)(Xe,pt,Qe)),un=Xe.set(v.ExtHostContext.ExtHostSCM,new X.ExtHostSCM(Xe,Qe,bt)),En=Xe.set(v.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Xe,Qe,ft)),dn=Xe.set(v.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Xe.getProxy(v.MainContext.MainThreadProgress))),Sn=Xe.set(v.ExtHostContext.ExtHosLabelService,new te.ExtHostLabelService(Xe)),hn=Xe.set(v.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Xe)),nn=Xe.set(v.ExtHostContext.ExtHostAuthentication,new W.ExtHostAuthentication(Xe)),Un=Xe.set(v.ExtHostContext.ExtHostTimeline,new K.ExtHostTimeline(Xe,Qe)),rn=Xe.set(v.ExtHostContext.ExtHostWebviews,new _.ExtHostWebviews(Xe,rt.remote,pt,bt,Re)),sn=Xe.set(v.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(Xe,rn,pt)),yn=Xe.set(v.ExtHostContext.ExtHostCustomEditors,new Pe.ExtHostCustomEditors(Xe,ft,Ut,rn,sn)),Cn=Xe.set(v.ExtHostContext.ExtHostWebviewViews,new be.ExtHostWebviewViews(Xe,rn)),on=Xe.set(v.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(Xe,Qe,$e)),Dn=Xe.set(v.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(Xe)),In=Xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(Xe));Xe.set(v.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Xe,yt,$e,Qe,bt));const Bn=Object.values(v.ExtHostContext);Xe.assertRegistered(Bn);const zn=new De.ExtHostBulkEdits(Xe,$e),$n=new d.ExtHostClipboard(Xe),kn=new f.ExtHostMessageService(Xe,bt),Rn=new g.ExtHostDialogs(Xe),Ln=new q.ExtHostStatusBar(Xe,Qe.converter);return E.ExtHostApiCommands.register(Qe),function(We,Wt,On){const wt=function(){let me=!We.isUnderDevelopment;function we(){me||(bt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function ze(at){if(Array.isArray(at))at.forEach(ze);else if(typeof at=="string")we();else{const Ct=at;typeof Ct.scheme>"u"&&we(),typeof Ct.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(We,"documentFiltersExclusive")}return at}}(),Wn={getSession(me,we,ze){return nn.getSession(We,me,we,ze)},async hasSession(me,we){return(0,Be.checkProposedApiEnabled)(We,"authSession"),!!await nn.getSession(We,me,we,{silent:!0})},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(me,we,ze,at){return nn.registerAuthenticationProvider(me,we,ze,at)}},fn={registerCommand(me,we,ze){return Qe.registerCommand(!0,me,we,ze,void 0,We)},registerTextEditorCommand(me,we,ze){return Qe.registerCommand(!0,me,(...at)=>{const Ct=At.getActiveTextEditor();if(!Ct){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}return Ct.edit(Rt=>{we.apply(ze,[Ct,Rt,...at])}).then(Rt=>{Rt||bt.warn("Edits from command "+me+" were not applied.")},Rt=>{bt.warn("An error occurred while running command "+me,Rt)})},void 0,void 0,We)},registerDiffInformationCommand:(me,we,ze)=>((0,Be.checkProposedApiEnabled)(We,"diffCommand"),Qe.registerCommand(!0,me,async(...at)=>{const Ct=$e.activeEditor(!0);if(!Ct){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Ct.id);we.apply(ze,[Rt,...at])},void 0,void 0,We)),executeCommand(me,...we){return Qe.executeCommand(me,...we)},getCommands(me=!1){return Qe.getCommands(me)}},Nn={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return Ve.getDefaultShell(!1)},get onDidChangeShell(){return(0,Be.checkProposedApiEnabled)(We,"envShellEvent"),Ve.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(We,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(We,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return(0,Be.checkProposedApiEnabled)(We,"telemetryLogger"),Dt.instantiateLogger(We,me)},openExternal(me,we){return Oe.openUri(me,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===rt.environment.appUriScheme)return It.createAppUri(me);try{return await Oe.asExternalUri(me,{allowTunneling:!!rt.remote.authority})}catch(we){if((0,oe.matchesScheme)(me,it.Schemas.http)||(0,oe.matchesScheme)(me,it.Schemas.https))return me;throw we}},get remoteName(){return(0,J.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(We,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Nn);const Hn={createTestController(me,we,ze){return on.createTestController(me,we,ze)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),on.createTestObserver()},runTests(me){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),on.runTests(me)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),on.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),on.results}},mn=rt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,jn={getExtension(me,we){(0,Be.isProposedApiEnabled)(We,"extensionsAny")||(we=!1);const ze=Wt.mine.getExtensionDescription(me);if(ze)return new l.Extension(Nt,We.identifier,ze,mn,!1);if(we){const at=Wt.all.getExtensionDescription(me);if(at)return new l.Extension(Nt,We.identifier,at,mn,!0)}},get all(){const me=[];for(const we of Wt.mine.getAllExtensionDescriptions())me.push(new l.Extension(Nt,We.identifier,we,mn,!1));return me},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(We,"extensionsAny");const me=new Be.ExtensionIdentifierSet(Wt.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),we=[];for(const ze of Wt.all.getAllExtensionDescriptions()){const at=!me.has(ze.identifier);we.push(new l.Extension(Nt,We.identifier,ze,mn,at))}return we},get onDidChange(){return(0,Be.isProposedApiEnabled)(We,"extensionsAny")?k.Event.any(Wt.mine.onDidChange,Wt.all.onDidChange):Wt.mine.onDidChange}},Tn={createDiagnosticCollection(me){return en.createDiagnosticCollection(We.identifier,me)},get onDidChangeDiagnostics(){return en.onDidChangeDiagnostics},getDiagnostics:me=>en.getDiagnostics(me),getLanguages(){return ln.getLanguages()},setTextDocumentLanguage(me,we){return ln.changeLanguage(me.uri,we)},match(me,we){const ze=ft.getDocumentData(we.uri)?.notebook;return(0,L.score)(U.LanguageSelector.from(me),we.uri,we.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(me,we,ze){return ut.registerCodeActionProvider(We,wt(me),we,ze)},registerDocumentPasteEditProvider(me,we,ze){return(0,Be.checkProposedApiEnabled)(We,"documentPaste"),ut.registerDocumentPasteEditProvider(We,wt(me),we,ze)},registerCodeLensProvider(me,we){return ut.registerCodeLensProvider(We,wt(me),we)},registerDefinitionProvider(me,we){return ut.registerDefinitionProvider(We,wt(me),we)},registerDeclarationProvider(me,we){return ut.registerDeclarationProvider(We,wt(me),we)},registerImplementationProvider(me,we){return ut.registerImplementationProvider(We,wt(me),we)},registerTypeDefinitionProvider(me,we){return ut.registerTypeDefinitionProvider(We,wt(me),we)},registerHoverProvider(me,we){return ut.registerHoverProvider(We,wt(me),we,We.identifier)},registerEvaluatableExpressionProvider(me,we){return ut.registerEvaluatableExpressionProvider(We,wt(me),we,We.identifier)},registerInlineValuesProvider(me,we){return ut.registerInlineValuesProvider(We,wt(me),we,We.identifier)},registerDocumentHighlightProvider(me,we){return ut.registerDocumentHighlightProvider(We,wt(me),we)},registerLinkedEditingRangeProvider(me,we){return ut.registerLinkedEditingRangeProvider(We,wt(me),we)},registerReferenceProvider(me,we){return ut.registerReferenceProvider(We,wt(me),we)},registerRenameProvider(me,we){return ut.registerRenameProvider(We,wt(me),we)},registerDocumentSymbolProvider(me,we,ze){return ut.registerDocumentSymbolProvider(We,wt(me),we,ze)},registerWorkspaceSymbolProvider(me){return ut.registerWorkspaceSymbolProvider(We,me)},registerDocumentFormattingEditProvider(me,we){return ut.registerDocumentFormattingEditProvider(We,wt(me),we)},registerDocumentRangeFormattingEditProvider(me,we){return ut.registerDocumentRangeFormattingEditProvider(We,wt(me),we)},registerOnTypeFormattingEditProvider(me,we,ze,...at){return ut.registerOnTypeFormattingEditProvider(We,wt(me),we,[ze].concat(at))},registerDocumentSemanticTokensProvider(me,we,ze){return ut.registerDocumentSemanticTokensProvider(We,wt(me),we,ze)},registerDocumentRangeSemanticTokensProvider(me,we,ze){return ut.registerDocumentRangeSemanticTokensProvider(We,wt(me),we,ze)},registerSignatureHelpProvider(me,we,ze,...at){return typeof ze=="object"?ut.registerSignatureHelpProvider(We,wt(me),we,ze):ut.registerSignatureHelpProvider(We,wt(me),we,typeof ze>"u"?[]:[ze,...at])},registerCompletionItemProvider(me,we,...ze){return ut.registerCompletionItemProvider(We,wt(me),we,ze)},registerInlineCompletionItemProvider(me,we){return we.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(We,wt(me),we)},registerDocumentLinkProvider(me,we){return ut.registerDocumentLinkProvider(We,wt(me),we)},registerColorProvider(me,we){return ut.registerColorProvider(We,wt(me),we)},registerFoldingRangeProvider(me,we){return ut.registerFoldingRangeProvider(We,wt(me),we)},registerSelectionRangeProvider(me,we){return ut.registerSelectionRangeProvider(We,me,we)},registerCallHierarchyProvider(me,we){return ut.registerCallHierarchyProvider(We,me,we)},registerTypeHierarchyProvider(me,we){return ut.registerTypeHierarchyProvider(We,me,we)},setLanguageConfiguration:(me,we)=>ut.setLanguageConfiguration(We,me,we),getTokenInformationAtPosition(me,we){return(0,Be.checkProposedApiEnabled)(We,"tokenInformation"),ln.tokenAtPosition(me,we)},registerInlayHintsProvider(me,we){return ut.registerInlayHintsProvider(We,me,we)},createLanguageStatusItem(me,we){return ln.createLanguageStatusItem(We,me,we)},registerDocumentDropEditProvider(me,we){return ut.registerDocumentOnDropEditProvider(We,me,we)}},Vn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ve.activeTerminal},get terminals(){return Ve.terminals},async showTextDocument(me,we,ze){const at=await(C.URI.isUri(me)?Promise.resolve(Gt.openTextDocument(me)):Promise.resolve(me));return At.showTextDocument(at,we,ze)},createTextEditorDecorationType(me){return At.createTextEditorDecorationType(We,me)},onDidChangeActiveTextEditor(me,we,ze){return At.onDidChangeActiveTextEditor(me,we,ze)},onDidChangeVisibleTextEditors(me,we,ze){return At.onDidChangeVisibleTextEditors(me,we,ze)},onDidChangeTextEditorSelection(me,we,ze){return At.onDidChangeTextEditorSelection(me,we,ze)},onDidChangeTextEditorOptions(me,we,ze){return At.onDidChangeTextEditorOptions(me,we,ze)},onDidChangeTextEditorVisibleRanges(me,we,ze){return At.onDidChangeTextEditorVisibleRanges(me,we,ze)},onDidChangeTextEditorViewColumn(me,we,ze){return At.onDidChangeTextEditorViewColumn(me,we,ze)},onDidCloseTerminal(me,we,ze){return Ve.onDidCloseTerminal(me,we,ze)},onDidOpenTerminal(me,we,ze){return Ve.onDidOpenTerminal(me,we,ze)},onDidChangeActiveTerminal(me,we,ze){return Ve.onDidChangeActiveTerminal(me,we,ze)},onDidChangeTerminalDimensions(me,we,ze){return(0,Be.checkProposedApiEnabled)(We,"terminalDimensions"),Ve.onDidChangeTerminalDimensions(me,we,ze)},onDidChangeTerminalState(me,we,ze){return Ve.onDidChangeTerminalState(me,we,ze)},onDidWriteTerminalData(me,we,ze){return(0,Be.checkProposedApiEnabled)(We,"terminalDataWriteEvent"),Ve.onDidWriteTerminalData(me,we,ze)},get state(){return Oe.state},onDidChangeWindowState(me,we,ze){return Oe.onDidChangeWindowState(me,we,ze)},showInformationMessage(me,...we){return kn.showMessage(We,A.default.Info,me,we[0],we.slice(1))},showWarningMessage(me,...we){return kn.showMessage(We,A.default.Warning,me,we[0],we.slice(1))},showErrorMessage(me,...we){return kn.showMessage(We,A.default.Error,me,we[0],we.slice(1))},showQuickPick(me,we,ze){return Qt.showQuickPick(me,we,ze)},showWorkspaceFolderPick(me){return Qt.showWorkspaceFolderPick(me)},showInputBox(me,we){return Qt.showInput(me,we)},showOpenDialog(me){return Rn.showOpenDialog(me)},showSaveDialog(me){return Rn.showSaveDialog(me)},createStatusBarItem(me,we,ze){let at,Ct,Rt;return typeof me=="string"?(at=me,Ct=we,Rt=ze):(Ct=me,Rt=we),Ln.createStatusBarEntry(We,at,Ct,Rt)},setStatusBarMessage(me,we){return Ln.setStatusBarMessage(me,we)},withScmProgress(me){return Re.report("window.withScmProgress",We,"Use 'withProgress' instead."),dn.withProgress(We,{location:H.ProgressLocation.SourceControl},(we,ze)=>me({report(at){}}))},withProgress(me,we){return dn.withProgress(We,me,we)},createOutputChannel(me,we){return Lt.createOutputChannel(me,we,We)},createWebviewPanel(me,we,ze,at){return sn.createWebviewPanel(We,me,we,ze,at)},createWebviewTextEditorInset(me,we,ze,at){return(0,Be.checkProposedApiEnabled)(We,"editorInsets"),Vt.createWebviewEditorInset(me,we,ze,at,We)},createTerminal(me,we,ze){return typeof me=="object"?"pty"in me?Ve.createExtensionTerminal(me):Ve.createTerminalFromOptions(me):Ve.createTerminal(me,we,ze)},registerTerminalLinkProvider(me){return Ve.registerLinkProvider(me)},registerTerminalProfileProvider(me,we){return Ve.registerProfileProvider(We,me,we)},registerTerminalQuickFixProvider(me,we){return(0,Be.checkProposedApiEnabled)(We,"terminalQuickFixProvider"),Ve.registerTerminalQuickFixProvider(me,We.identifier.value,we)},registerTreeDataProvider(me,we){return cn.registerTreeDataProvider(me,we,We)},createTreeView(me,we){return cn.createTreeView(me,we,We)},registerWebviewPanelSerializer:(me,we)=>sn.registerWebviewPanelSerializer(We,me,we),registerCustomEditorProvider:(me,we,ze={})=>yn.registerCustomEditorProvider(We,me,we,ze),registerFileDecorationProvider(me){return Ne.registerFileDecorationProvider(me,We)},registerUriHandler(me){return It.registerUriHandler(We.identifier,me)},createQuickPick(){return Qt.createQuickPick(We)},createInputBox(){return Qt.createInputBox(We)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(me,we,ze){return hn.onDidChangeActiveColorTheme(me,we,ze)},registerWebviewViewProvider(me,we,ze){return Cn.registerWebviewViewProvider(We,me,we,ze?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,we,ze){return yt.onDidChangeActiveNotebookEditor(me,we,ze)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,we,ze){return an.onDidChangeNotebookEditorSelection(me,we,ze)},onDidChangeNotebookEditorVisibleRanges(me,we,ze){return an.onDidChangeNotebookEditorVisibleRanges(me,we,ze)},showNotebookDocument(me,we){return yt.showNotebookDocument(me,we)},registerExternalUriOpener(me,we,ze){return(0,Be.checkProposedApiEnabled)(We,"externalUriOpener"),Dn.registerExternalUriOpener(We.identifier,me,we,ze)},registerProfileContentHandler(me,we){return(0,Be.checkProposedApiEnabled)(We,"profileContentHandlers"),In.registrProfileContentHandler(We,me,we)},get tabGroups(){return re.tabGroups}},Gt={get rootPath(){return Re.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(me){throw t.readonly()},getWorkspaceFolder(me){return pt.getWorkspaceFolder(me)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(me){throw t.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(me){throw t.readonly()},updateWorkspaceFolders:(me,we,...ze)=>pt.updateWorkspaceFolders(We,me,we||0,...ze),onDidChangeWorkspaceFolders:function(me,we,ze){return pt.onDidChangeWorkspace(me,we,ze)},asRelativePath:(me,we)=>pt.getRelativePath(me,we),findFiles:(me,we,ze,at)=>pt.findFiles(me,we,ze,We.identifier,at),findTextInFiles:(me,we,ze,at)=>{(0,Be.checkProposedApiEnabled)(We,"findTextInFiles");let Ct,Rt;return typeof we=="object"?(Ct=we,Rt=ze):(Ct={},Rt=we,at=ze),pt.findTextInFiles(me,Ct||{},Rt,We.identifier,at)},saveAll:me=>pt.saveAll(me),applyEdit(me,we){return zn.applyWorkspaceEdit(me,We,we)},createFileSystemWatcher:(me,we,ze,at)=>qt.createFileSystemWatcher(pt,We,me,we,ze,at),get textDocuments(){return ft.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw t.readonly()},openTextDocument(me){let we;const ze=me;if(typeof me=="string")we=Promise.resolve(C.URI.file(me));else if(C.URI.isUri(me))we=Promise.resolve(me);else if(!ze||typeof ze=="object")we=ft.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(at=>ft.ensureDocumentData(at).then(Ct=>Ct.document))},onDidOpenTextDocument:(me,we,ze)=>ft.onDidAddDocument(me,we,ze),onDidCloseTextDocument:(me,we,ze)=>ft.onDidRemoveDocument(me,we,ze),onDidChangeTextDocument:(me,we,ze)=>ft.onDidChangeDocument(me,we,ze),onDidSaveTextDocument:(me,we,ze)=>ft.onDidSaveDocument(me,we,ze),onWillSaveTextDocument:(me,we,ze)=>jt.getOnWillSaveTextDocumentEvent(We)(me,we,ze),get notebookDocuments(){return yt.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,we){let ze;if(C.URI.isUri(me))ze=me,await yt.openNotebookDocument(me);else if(typeof me=="string")ze=C.URI.revive(await yt.createNotebookDocument({viewType:me,content:we}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(me,we,ze){return _t.onDidSaveNotebookDocument(me,we,ze)},onDidChangeNotebookDocument(me,we,ze){return _t.onDidChangeNotebookDocument(me,we,ze)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(me,we,ze,at){return yt.registerNotebookSerializer(We,me,we,ze,(0,Be.isProposedApiEnabled)(We,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,we,ze)=>On.onDidChangeConfiguration(me,we,ze),getConfiguration(me,we){return we=arguments.length===1?void 0:we,On.getConfiguration(me,we,We)},registerTextDocumentContentProvider(me,we){return xt.registerTextDocumentContentProvider(me,we)},registerTaskProvider:(me,we)=>(Re.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(We,me,we)),registerFileSystemProvider(me,we,ze){return(0,Le.combinedDisposable)(tn.registerFileSystemProvider(We,me,we,ze),Tt.addFileSystemProvider(me,we))},get fs(){return Tt.value},registerFileSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"fileSearchProvider"),St.registerFileSearchProvider(me,we)),registerTextSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"textSearchProvider"),St.registerTextSearchProvider(me,we)),registerRemoteAuthorityResolver:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"resolvers"),Nt.registerRemoteAuthorityResolver(me,we)),registerResourceLabelFormatter:me=>((0,Be.checkProposedApiEnabled)(We,"resolvers"),Sn.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,we,ze)=>qt.onDidCreateFile(me,we,ze),onDidDeleteFiles:(me,we,ze)=>qt.onDidDeleteFile(me,we,ze),onDidRenameFiles:(me,we,ze)=>qt.onDidRenameFile(me,we,ze),onWillCreateFiles:(me,we,ze)=>qt.getOnWillCreateFileEvent(We)(me,we,ze),onWillDeleteFiles:(me,we,ze)=>qt.getOnWillDeleteFileEvent(We)(me,we,ze),onWillRenameFiles:(me,we,ze)=>qt.getOnWillRenameFileEvent(We)(me,we,ze),openTunnel:me=>((0,Be.checkProposedApiEnabled)(We,"tunnels"),Pt.openTunnel(We,me).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,Be.checkProposedApiEnabled)(We,"tunnels"),Pt.getTunnels()},onDidChangeTunnels:(me,we,ze)=>((0,Be.checkProposedApiEnabled)(We,"tunnels"),Pt.onDidChangeTunnels(me,we,ze)),registerPortAttributesProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"portsAttributes"),Pt.registerPortsAttributesProvider(me,we)),registerTimelineProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"timeline"),Un.registerTimelineProvider(me,we,We.identifier,Qe.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:me=>((0,Be.checkProposedApiEnabled)(We,"workspaceTrust"),pt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,we,ze)=>pt.onDidGrantWorkspaceTrust(me,we,ze),registerEditSessionIdentityProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(me,we))},gn={get inputBox(){return Re.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),un.getLastInputBox(We)},createSourceControl(me,we,ze){return un.createSourceControl(We,me,we,ze)}},qn={createCommentController(me,we){return En.createCommentController(We,me,we)}},$t={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(me,we,ze){return tt.onDidStartDebugSession(me,we,ze)},onDidTerminateDebugSession(me,we,ze){return tt.onDidTerminateDebugSession(me,we,ze)},onDidChangeActiveDebugSession(me,we,ze){return tt.onDidChangeActiveDebugSession(me,we,ze)},onDidReceiveDebugSessionCustomEvent(me,we,ze){return tt.onDidReceiveDebugSessionCustomEvent(me,we,ze)},onDidChangeBreakpoints(me,we,ze){return tt.onDidChangeBreakpoints(me,we,ze)},registerDebugConfigurationProvider(me,we,ze){return tt.registerDebugConfigurationProvider(me,we,ze||xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,we){return tt.registerDebugAdapterDescriptorFactory(We,me,we)},registerDebugAdapterTrackerFactory(me,we){return tt.registerDebugAdapterTrackerFactory(me,we)},startDebugging(me,we,ze){return!ze||typeof ze=="object"&&"configuration"in ze?tt.startDebugging(me,we,{parentSession:ze}):tt.startDebugging(me,we,ze||{})},stopDebugging(me){return tt.stopDebugging(me)},addBreakpoints(me){return tt.addBreakpoints(me)},removeBreakpoints(me){return tt.removeBreakpoints(me)},asDebugSourceUri(me,we){return tt.asDebugSourceUri(me,we)}},pn={registerTaskProvider:(me,we)=>Et.registerTaskProvider(We,me,we),fetchTasks:me=>Et.fetchTasks(me),executeTask:me=>Et.executeTask(We,me),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(me,we,ze)=>Et.onDidStartTask(me,we,ze),onDidEndTask:(me,we,ze)=>Et.onDidEndTask(me,we,ze),onDidStartTaskProcess:(me,we,ze)=>Et.onDidStartTaskProcess(me,we,ze),onDidEndTaskProcess:(me,we,ze)=>Et.onDidEndTaskProcess(me,we,ze)},Gn={createNotebookController(me,we,ze,at,Ct){return Zt.createNotebookController(We,me,we,ze,at,(0,Be.isProposedApiEnabled)(We,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(me,we)=>yt.registerNotebookCellStatusBarItemProvider(We,me,we),createRendererMessaging(me){return vn.createRendererMessaging(We,me)},createNotebookControllerDetectionTask(me){return(0,Be.checkProposedApiEnabled)(We,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(We,me)},registerKernelSourceActionProvider(me,we){return(0,Be.checkProposedApiEnabled)(We,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(We,me,we)},onDidChangeNotebookCellExecutionState(me,we,ze){return(0,Be.checkProposedApiEnabled)(We,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(me,we,ze)}},Kn={t(...me){if(typeof me[0]=="string"){const we=me.shift(),ze=!me||typeof me[0]!="object"?me:me[0];return vt.getMessage(We.identifier.value,{message:we,args:ze})}return vt.getMessage(We.identifier.value,me[0])},get bundle(){return vt.getBundle(We.identifier.value)},get uri(){return vt.getBundleUri(We.identifier.value)}};return{version:rt.version,authentication:Wn,commands:fn,comments:qn,debug:$t,env:Nn,extensions:jn,l10n:Kn,languages:Tn,notebooks:Gn,scm:gn,tasks:pn,tests:Hn,window:Vn,workspace:Gt,Breakpoint:H.Breakpoint,TerminalOutputAnchor:H.TerminalOutputAnchor,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileDecoration2:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestionList,Hover:H.Hover,IndentAction:y.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalQuickFixCommand:H.TerminalQuickFixCommand,TerminalQuickFixOpener:H.TerminalQuickFixOpener,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TerminalExitReason:H.TerminalExitReason,TerminalQuickFixType:H.TerminalQuickFixType,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,SnippetTextEdit:H.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItem2:H.TreeItem,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:D.UIKind,Uri:C.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,DocumentDropEdit:H.DocumentDropEdit,DocumentPasteEdit:H.DocumentPasteEdit,InlayHint:H.InlayHint,InlayHintLabelPart:H.InlayHintLabelPart,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.NotebookEdit,NotebookKernelSourceAction:H.NotebookKernelSourceAction,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:H.DataTransfer,DataTransferItem:H.DataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.TextTabInput,TabInputTextDiff:H.TextDiffTabInput,TabInputTextMerge:H.TextMergeTabInput,TabInputCustom:H.CustomEditorTabInput,TabInputNotebook:H.NotebookEditorTabInput,TabInputNotebookDiff:H.NotebookDiffEditorTabInput,TabInputWebview:H.WebviewEditorTabInput,TabInputTerminal:H.TerminalEditorTabInput,TabInputInteractiveWindow:H.InteractiveWindowInput,TrustedTelemetryValue:x.TrustedTelemetryValue,LogLevel:Fe.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=lt}),define(ye[302],Ce([1,0,274,311,312,2,313]),function(ne,e,c,t,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(P,v,D,E,d,m){const h=m.environment.useHostProxy,b=typeof h=="boolean"?h:!m.remote.isRemote,p=(0,C.createProxyResolver)({resolveProxy:w=>P.resolveProxy(w),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(w,i,...o)=>{switch(w){case C.LogLevel.Trace:E.trace(i,...o);break;case C.LogLevel.Debug:E.debug(i,...o);break;case C.LogLevel.Info:E.info(i,...o);break;case C.LogLevel.Warning:E.warn(i,...o);break;case C.LogLevel.Error:E.error(i,...o);break;case C.LogLevel.Critical:E.error(i,...o);break;case C.LogLevel.Off:break;default:u(w,i,o);break}function u(l,s,...a){E.error("Unknown log level",l),E.error(s,...a)}},getLogLevel:()=>E.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:b,env:process.env}),g=S(v,p);return L(D,g)}e.connectProxyResolver=T;function S(P,v){const D={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(d=>{D.config=P.getConfiguration("http").get("proxySupport")||"off"});const E={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(d=>{E.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,C.createHttpPatch)(c,v,{config:"off"},E,!0)),on:Object.assign({},c,(0,C.createHttpPatch)(c,v,{config:"on"},E,!0)),override:Object.assign({},c,(0,C.createHttpPatch)(c,v,{config:"override"},E,!0)),onRequest:Object.assign({},c,(0,C.createHttpPatch)(c,v,D,E,!0)),default:Object.assign(c,(0,C.createHttpPatch)(c,v,D,E,!1))},https:{off:Object.assign({},t,(0,C.createHttpPatch)(t,v,{config:"off"},E,!0)),on:Object.assign({},t,(0,C.createHttpPatch)(t,v,{config:"on"},E,!0)),override:Object.assign({},t,(0,C.createHttpPatch)(t,v,{config:"override"},E,!0)),onRequest:Object.assign({},t,(0,C.createHttpPatch)(t,v,D,E,!0)),default:Object.assign(t,(0,C.createHttpPatch)(t,v,D,E,!1))},tls:Object.assign(k,(0,C.createTlsPatch)(k))}}const y=new Map;function L(P,v){return P.getExtensionPathIndex().then(D=>{const E=globalThis._VSCODE_NODE_MODULES.module,d=E._load;E._load=function(h,b,p){if(h==="tls")return v.tls;if(h!=="http"&&h!=="https")return d.apply(this,arguments);const g=v[h],w=D.findSubstr(A.URI.file(b.filename));let i=y.get(w);if(i||y.set(w,i={}),!i[h]){const o=g.default;i[h]={...o}}return i[h]}})}}),define(ye[303],Ce([1,0,77,301,288,302,41,276,2,15,7,273,114,275]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class E extends k.RequireInterceptor{j(){const h=this,b=globalThis._VSCODE_NODE_MODULES.module,p=b._load;b._load=function(o,u,l){return o=w(o),h.a.has(o)?h.a.get(o).load(o,S.URI.file((0,v.realpathSync)(u.filename)),s=>p.apply(this,[s,u,l])):p.apply(this,arguments)};const g=b._resolveLookupPaths;b._resolveLookupPaths=(i,o)=>g.call(this,w(i),o);const w=i=>{for(const o of h.b){const u=o(i);if(u){i=u;break}}return i}}}class d extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async nb(){this.h.createInstance(D.ExtHostConsoleForwarder);const h=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(T.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const g=this.h.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=g.ipcHandlePath}await this.h.createInstance(E,h,{mine:this.D,all:this.F}).install(),c.mark("code/extHost/didInitAPI");const p=await this.k.getConfigProvider();await(0,A.connectProxyResolver)(this.j,p,this,this.l,this.u,this.f),c.mark("code/extHost/didInitProxyResolver")}ob(h){return h.main}async pb(h,b,p){if(b.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let g=null;p.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this.l.flush();const w=h?.identifier.value;h&&await this.s.initializeLocalizedMessages(h);try{w&&c.mark(`code/extHost/willLoadExtensionCode/${w}`),g=ne.__$__nodeRequire(b.fsPath)}finally{w&&c.mark(`code/extHost/didLoadExtensionCode/${w}`),p.codeLoadingStop()}return g}async $setRemoteEnvironment(h){if(!!this.f.remote.isRemote)for(const b in h){const p=h[b];p===null?delete process.env[b]:process.env[b]=p}}}e.ExtHostExtensionService=d}),define(ye[145],Ce([1,0,45,314,297,17,81,37,9,8,2,31,75,315,295,99]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const m=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(f){this.a=f}provideTextSearchResults(f,I,R,B){return this.a.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...I,folder:I.folder.toString()})}`),new Promise((X,q)=>{B.onCancellationRequested(()=>V());const N=o(f,I),M=I.folder.fsPath,F=N.map(te=>te.match(/^-/)?te:`'${te}'`).join(" ");this.a.appendLine(`${m} ${F}
 - cwd: ${M}`);let z=c.spawn(m,N,{cwd:M});z.on("error",te=>{console.error(te),this.a.appendLine("Error: "+(te&&te.message)),q((0,P.serializeSearchError)(new P.SearchError(te&&te.message,P.SearchErrorCode.rgProcessError)))});let U=!1;const H=new g(I.maxResults,M,I.previewOptions);H.on("result",te=>{U=!0,Q="",R.report(te)});let x=!1;const V=()=>{x=!0,z?.kill(),H?.cancel()};let _=!1;H.on("hitLimit",()=>{_=!0,V()});let Q="";z.stdout.on("data",te=>{H.handleData(te),U||(Q+=te)});let Z=!1;z.stdout.once("data",()=>Z=!0);let ge="";z.stderr.on("data",te=>{const J=te.toString();this.a.appendLine(J),ge.length+J.length<1e6&&(ge+=J)}),z.on("close",()=>{if(this.a.appendLine(Z?"Got data from stdout":"No data from stdout"),this.a.appendLine(U?"Got result from parser":"No result from parser"),Q&&this.a.appendLine(`Got data without result: ${Q}`),this.a.appendLine(""),x)X({limitHit:_});else{H.flush(),z=null;let te;ge&&!Z&&(te=b(ge))?q((0,P.serializeSearchError)(new P.SearchError(te.message,te.code))):X({limitHit:_})}})})}}e.RipgrepTextSearchEngine=h;function b(r){const f=r.split(`
`),I=f[0].trim();if(f.some(B=>B.startsWith("regex parse error")))return new P.SearchError(p(f),P.SearchErrorCode.regexParseError);const R=I.match(/grep config error: unknown encoding: (.*)/);if(R)return new P.SearchError(`Unknown encoding: ${R[1]}`,P.SearchErrorCode.unknownEncoding);if(I.startsWith("error parsing glob"))return new P.SearchError(I.charAt(0).toUpperCase()+I.substr(1),P.SearchErrorCode.globParseError);if(I.startsWith("the literal"))return new P.SearchError(I.charAt(0).toUpperCase()+I.substr(1),P.SearchErrorCode.invalidLiteral);if(I.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(I,P.SearchErrorCode.regexParseError)}function p(r){const f=["Regex parse error"],I=r.filter(R=>R.startsWith("PCRE2:"));if(I.length>=1){const R=I[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const B=R.split(":")[1];f.push(":"+B)}}return f.join("")}class g extends t.EventEmitter{constructor(f,I,R){super(),this.g=f,this.h=I,this.j=R,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new k.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(f,I){return super.on(f,I),this}handleData(f){if(this.b)return;const I=typeof f=="string"?f:this.d.write(f);this.k(I)}k(f){let I=f.indexOf(`
`);const R=this.a+f;if(I>=0)I+=this.a.length;else{this.a=R;return}let B=0;for(;I>=0;)this.m(R.substring(B,I).trim()),B=I+1,I=R.indexOf(`
`,B);this.a=R.substring(B)}m(f){if(this.b||!f)return;let I;try{I=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(I.type==="match"){const R=w(I.data.path),B=L.URI.file(S.join(this.h,R)),X=this.n(I.data,B);this.p(X),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(I.type==="context"){const R=w(I.data.path),B=L.URI.file(S.join(this.h,R));this.o(I.data,B).forEach(q=>this.p(q))}}n(f,I){const R=f.line_number-1,B=w(f.lines),X=Buffer.from(B);let q=0,N=0,M=R;f.submatches.length===0&&f.submatches.push(B.length?{start:0,end:1,match:{text:B[0]}}:{start:0,end:0,match:{text:""}});const F=(0,A.coalesce)(f.submatches.map((z,U)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const H=w(z.match),x=X.slice(q,z.start).toString(),V=i(x),_=V.numLines>0?V.lastLineLength:V.lastLineLength+N,Q=i(H),Z=V.numLines+M,ge=Q.numLines+Z,te=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+_;return q=z.end,N=te,M=ge,new v.Range(Z,_,ge,te)}));return(0,d.createTextSearchResult)(I,B,F,this.j)}o(f,I){const R=w(f.lines),B=f.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((X,q)=>({text:X,uri:I,lineNumber:B+q}))}p(f){this.emit("result",f)}}e.RipgrepParser=g;function w(r){return r.bytes?Buffer.from(r.bytes,"base64").toString():r.text}function i(r){const f=/\n/g;let I=0,R=-1,B;for(;B=f.exec(r);)I++,R=B.index;const X=R>=0?r.length-R-1:r.length;return{numLines:I,lastLineLength:X}}function o(r,f){const I=["--hidden"];I.push(r.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:B}=(0,C.groupBy)(f.includes,q=>q.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(B&&B.length){const q=new Set;B.forEach(N=>{q.add(N)}),I.push("-g","!*"),q.forEach(N=>{u(N).map(d.anchorGlob).forEach(M=>{I.push("-g",M)})})}R&&R.length&&R.forEach(q=>{I.push("-g",q)}),f.excludes.map(d.anchorGlob).forEach(q=>I.push("-g",`!${q}`)),f.maxFileSize&&I.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||I.push("--no-ignore-parent"):I.push("--no-ignore"),f.followSymlinks&&I.push("--follow"),f.encoding&&f.encoding!=="utf8"&&I.push("--encoding",f.encoding),r.pattern==="--"&&(r.isRegExp=!0,r.pattern="\\-\\-"),r.isMultiline&&!r.isRegExp&&(r.pattern=(0,y.escapeRegExpCharacters)(r.pattern),r.isRegExp=!0),f.usePCRE2&&I.push("--pcre2"),I.push("--crlf"),r.isRegExp&&(r.pattern=l(r.pattern),I.push("--engine","auto"));let X;if(r.isWordMatch){const N=(0,y.createRegExp)(r.pattern,!!r.isRegExp,{wholeWord:r.isWordMatch}).source.replace(/\\\//g,"/");I.push("--regexp",N)}else if(r.isRegExp){let q=a(r.pattern);q=n(q),I.push("--regexp",q)}else X=r.pattern,I.push("--fixed-strings");return I.push("--no-config"),f.useGlobalIgnoreFiles||I.push("--no-ignore-global"),I.push("--json"),r.isMultiline&&I.push("--multiline"),f.beforeContext&&I.push("--before-context",f.beforeContext+""),f.afterContext&&I.push("--after-context",f.afterContext+""),I.push("--"),X&&I.push(X),I.push("."),I}function u(r){const f=(0,T.splitGlobAware)(r,"/");return f.map((I,R)=>f.slice(0,R+1).join("/"))}function l(r){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;r.match(f);)r=r.replace(f,"$1\\x{$2}");const I=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;r.match(I);)r=r.replace(I,"$1\\x{$2}");return r}e.unicodeEscapesToPCRE2=l;const s=r=>r.type==="Assertion"&&r.kind==="lookbehind";function a(r){let f;try{f=new D.RegExpParser().parsePattern(r)}catch{return r}let I="",R=0;const B=(N,M,F)=>{I+=r.slice(R,N)+F,R=M},X=[];return new D.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const M=X[0];if(!M)B(N.start,N.end,"\\r?\\n");else if(!X.some(s))if(M.type==="CharacterClass")if(M.negate){const F=r.slice(M.start+2,N.start)+r.slice(N.end,M.end-1);M.parent?.type==="Quantifier"?B(M.start,M.end,F?`[^${F}]`:"."):B(M.start,M.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=r.slice(M.start+1,N.start)+r.slice(N.end,M.end-1);B(M.start,M.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else M.type==="Quantifier"&&B(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){X.unshift(N)},onQuantifierLeave(){X.shift()},onCharacterClassRangeEnter(N){X.unshift(N)},onCharacterClassRangeLeave(){X.shift()},onCharacterClassEnter(N){X.unshift(N)},onCharacterClassLeave(){X.shift()},onAssertionEnter(N){s(N)&&X.push(N)},onAssertionLeave(N){X[0]===N&&X.shift()}}).visit(f),I+=r.slice(R),I}e.fixRegexNewline=a;function n(r){return r.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(ye[304],Ce([1,0,21,145,125,15]),function(ne,e,c,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,L,P,v){const D=new t.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===A.Schemas.vscodeUserData){const E={...L,folder:L.folder.with({scheme:A.Schemas.file})},d=new k.Progress(m=>P.report({...m,uri:m.uri.with({scheme:L.folder.scheme})}));return this.c(v,m=>D.provideTextSearchResults(y,E,d,m))}else return this.c(v,E=>D.provideTextSearchResults(y,L,P,E))}async c(y,L){const P=T(y);this.a.add(P);const v=await L(P.token);return this.a.delete(P),v}d(){this.a.forEach(y=>y.cancel())}}e.RipgrepSearchProvider=C;function T(S){const y=new c.CancellationTokenSource;return S.onCancellationRequested(()=>y.cancel()),y}}),define(ye[305],Ce([1,0,29,145,144]),function(ne,e,c,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(S){this.a=S}search(S,y,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(D){L({message:D})}},v=new k.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(P),c);return new Promise((D,E)=>v.search(d=>{y(d.map(C))},S).then(d=>D({limitHit:d.limitHit,type:"success",stats:d.stats}),E))}}e.TextSearchEngineAdapter=A;function C(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((S,y)=>{if(y.ranges){const L=y;return S+(Array.isArray(L.ranges)?L.ranges.length:1)}else return S+1},0)}}}),define(ye[306],Ce([1,0,17,18,10,4,110,9,42,2,38,31,296,305]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{constructor(g="searchProcess"){this.d=g,this.b=Object.create(null)}fileSearch(g){let w;const i=h(g),o=new A.Emitter({onDidAddFirstListener:()=>{w=(0,t.createCancelablePromise)(u=>this.doFileSearchWithEngine(v.Engine,i,l=>o.fire(l),u)),w.then(u=>o.fire(u),u=>o.fire({type:"error",error:{message:u.message,stack:u.stack}}))},onDidRemoveLastListener:()=>{w.cancel()}});return o.event}textSearch(g){let w;const i=h(g),o=new A.Emitter({onDidAddFirstListener:()=>{w=(0,t.createCancelablePromise)(u=>this.f(i,l=>o.fire(l),u)),w.then(u=>o.fire(u),u=>o.fire({type:"error",error:{message:u.message,stack:u.stack}}))},onDidRemoveLastListener:()=>{w.cancel()}});return o.event}f(g,w,i){return g.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new D.TextSearchEngineAdapter(g).search(i,w,w)}doFileSearch(g,w,i){return this.doFileSearchWithEngine(v.Engine,g,w,i)}doFileSearchWithEngine(g,w,i,o,u=E.a){let l=0;const s=n=>{Array.isArray(n)?(l+=n.length,i(n.map(r=>this.g(r)))):n.relativePath?(l++,i(this.g(n))):i(n)};if(w.sortByScore){let n=this.k(w,s,o);if(!n){const r=w.maxResults?Object.assign({},w,{maxResults:null}):w,f=new g(r);n=this.h(f,w,i,s,o)}return new Promise((r,f)=>{n.then(([I,R])=>{const B=R.map(X=>this.g(X));this.n(B,i,u),r(I)},f)})}const a=new g(w);return this.q(a,s,u,o).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}g(g){return{path:g.base?(0,T.join)(g.base,g.relativePath):g.relativePath}}h(g,w,i,o,u){const l=new A.Emitter;let s=(0,t.createCancelablePromise)(n=>{let r=[];const f=I=>{Array.isArray(I)?r=I:(o(I),l.fire(I))};return this.q(g,f,-1,n).then(I=>[I,r])}),a;if(w.cacheKey){a=this.j(w.cacheKey);const n={promise:s,event:l.event,resolved:!1};a.resultsToSearchCache[w.filePattern||""]=n,s.then(()=>{n.resolved=!0},r=>{delete a.resultsToSearchCache[w.filePattern||""]}),s=this.r(s)}return s.then(([n,r])=>{const f=a?a.scorerCache:Object.create(null),I=(typeof w.maxResults!="number"||w.maxResults>0)&&S.StopWatch.create(!1);return this.l(w,r,f,u).then(R=>{const B=I?I.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:B,fromCache:!1,type:this.d,workspaceFolderCount:w.folderQueries.length,resultCount:R.length},messages:n.messages,limitHit:n.limitHit||typeof w.maxResults=="number"&&r.length>w.maxResults},R]})})}j(g){const w=this.b[g];return w||(this.b[g]=new d)}k(g,w,i){const o=g.cacheKey&&this.b[g.cacheKey];if(!o)return;const u=this.o(o,g.filePattern||"",w,i);if(u)return u.then(([l,s,a])=>{const n=S.StopWatch.create(!1);return this.l(g,s,o.scorerCache,i).then(r=>{const f=n.elapsed(),I={fromCache:!0,detailStats:a,type:this.d,resultCount:s.length,sortingTime:f};return[{type:"success",limitHit:l.limitHit||typeof g.maxResults=="number"&&s.length>g.maxResults,stats:I},r]})})}l(g,w,i,o){const u=(0,C.prepareQuery)(g.filePattern||""),l=(a,n)=>(0,C.compareItemsByFuzzyScore)(a,n,u,!0,m,i),s=typeof g.maxResults=="number"?g.maxResults:Number.MAX_VALUE;return c.topAsync(w,l,s,1e4,o)}n(g,w,i){if(i&&i>0)for(let o=0;o<g.length;o+=i)w(g.slice(o,o+i));else w(g)}o(g,w,i,o){const u=S.StopWatch.create(!1),l=w.indexOf(T.sep)>=0;let s;for(const f in g.resultsToSearchCache)if(w.startsWith(f)){if(l&&f.indexOf(T.sep)<0&&f!=="")continue;const I=g.resultsToSearchCache[f];s={promise:this.r(I.promise),event:I.event,resolved:I.resolved};break}if(!s)return null;const a=u.elapsed(),n=S.StopWatch.create(!1),r=s.event(i);return o&&o.onCancellationRequested(()=>{r.dispose()}),s.promise.then(([f,I])=>{if(o&&o.isCancellationRequested)throw(0,k.canceled)();const R=[],B=(0,C.prepareQuery)(w).normalizedLowercase;for(const X of I)!(0,P.isFilePatternMatch)(X,B)||R.push(X);return[f,R,{cacheWasResolved:s.resolved,cacheLookupTime:a,cacheFilterTime:n.elapsed(),cacheEntryCount:I.length}]})}q(g,w,i,o){return new Promise((u,l)=>{let s=[];o?.onCancellationRequested(()=>g.cancel()),g.search(a=>{a&&(i?(s.push(a),i>0&&s.length>=i&&(w(s),s=[])):w(a))},a=>{w(a)},(a,n)=>{s.length&&w(s),a?l(a):u(n)})})}clearCache(g){return delete this.b[g],Promise.resolve(void 0)}r(g){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(w,i){return g.then(w,i)}catch(w){return this.then(void 0,w)}finally(w){return g.finally(w)}}}}e.SearchService=E,E.a=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(p){return(0,T.basename)(p.relativePath)}getItemDescription(p){return(0,T.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function h(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(g=>y.URI.revive(g))}}function b(p){return{...p,folder:y.URI.revive(p.folder)}}}),define(ye[307],Ce([1,0,6,15,2,29,13,25,16,79,55,31,306,304,99,144]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let m=class extends y.ExtHostSearch{constructor(b,p,g,w){super(b,g,w),this.s=A,this.t=-1,this.v=null,this.w=!1;const i=new E.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new D.RipgrepSearchProvider(i)),p.remote.isRemote&&p.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const b=new E.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new D.RipgrepSearchProvider(b)),this.y(t.Schemas.file,new v.SearchService("fileSearchProvider"))}y(b,p){const g=this.d++;return this.v=p,this.t=g,this.c.$registerFileSearchProvider(g,this.o(b)),(0,c.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(g)})}$provideFileSearchResults(b,p,g,w){const i=(0,y.reviveQuery)(g);return b===this.t?this.z(b,p,i,w):super.$provideFileSearchResults(b,p,g,w)}z(b,p,g,w){const i=o=>{if((0,P.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(b,p,o.map(u=>k.URI.file(u.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(g,i,w)}$clearCache(b){return this.v?.clearCache(b),super.$clearCache(b)}q(b,p){return new d.NativeTextSearchManager(b,p,void 0,"textSearchProvider")}};m=qe([He(0,S.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,L.IURITransformerService),He(3,C.ILogService)],m),e.NativeExtHostSearch=m}),define(ye[308],Ce([1,0,88,279,291,290,307,303,280,78,41,79,76,40,54,73,278,277,13,292,48]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(L.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,c.registerSingleton)(b.ILoggerService,h.ExtHostLoggerService,1),(0,c.registerSingleton)(d.IExtensionStoragePaths,m.ExtensionStoragePaths,0),(0,c.registerSingleton)(y.IExtHostDebugService,A.ExtHostDebugService,0),(0,c.registerSingleton)(P.IExtHostSearch,C.NativeExtHostSearch,0),(0,c.registerSingleton)(v.IExtHostTask,k.ExtHostTask,0),(0,c.registerSingleton)(D.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,c.registerSingleton)(E.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,c.registerSingleton)(g.IExtHostVariableResolverProvider,p.NodeExtHostVariableResolverProviderService,0)}),define(ye[316],Ce([1,0,219,317,77,10,117,118,200,94,289,22,29,114,18,120,215,228,293,308]),function(ne,e,c,t,k,A,C,T,S,y,L,P,v,D,E,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let a=0;a<process.execArgv.length;a++)process.execArgv[a]==="--inspect-port=0"&&(process.execArgv.splice(a,1),a--)}();const b=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const s=globalThis._VSCODE_NODE_MODULES.module,a=s._load;s._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return a.apply(this,arguments)}})();const p=process.exit.bind(process);function g(s){process.exit=function(a){if(s)p(a);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const a=new Error("An extension called process.crash() and this was prevented.");console.warn(a.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let w=function(s){p()};function i(){const s=(0,h.readExtHostConnection)(process.env);if(s.type===3)return new Promise((a,n)=>{const r=f=>{const I=f[0],R=new C.BufferedEmitter;I.on("message",B=>R.fire(P.VSBuffer.wrap(B.data))),I.on("close",()=>{w("renderer closed the MessagePort")}),I.start(),a({onMessage:R.event,send:B=>I.postMessage(B.buffer)})};process?.parentPort.on("message",f=>r(f.ports))});if(s.type===2)return new Promise((a,n)=>{let r=null;const f=setTimeout(()=>{w("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),I=108e5,R=3e5,B=new E.ProcessTimeRunOnceScheduler(()=>w("renderer disconnected for too long (1)"),I),X=new E.ProcessTimeRunOnceScheduler(()=>w("renderer disconnected for too long (2)"),R);process.on("message",(N,M)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const F=P.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let z;if(N.skipWebSocketFrames)z=new T.NodeSocket(M,"extHost-socket");else{const U=P.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));z=new T.WebSocketNodeSocket(new T.NodeSocket(M,"extHost-socket"),N.permessageDeflate,U,!1)}r?(B.cancel(),X.cancel(),r.beginAcceptReconnection(z,F),r.endAcceptReconnection(),r.sendResume()):(clearTimeout(f),r=new C.PersistentProtocol(z,F),r.sendResume(),r.onDidDispose(()=>w("renderer disconnected")),a(r),r.onSocketClose(()=>{B.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(X.isScheduled())return;B.isScheduled()&&X.schedule()}});const q={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(q)});{const a=s.pipeName;return new Promise((n,r)=>{const f=c.createConnection(a,()=>{f.removeListener("error",r);const I=new C.PersistentProtocol(new T.NodeSocket(f,"extHost-renderer"));I.sendResume(),n(I)});f.once("error",r),f.on("close",()=>{w("renderer closed the socket")})})}}async function o(){const s=await i();return new class{constructor(){this.a=new C.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,s.onMessage(a=>{(0,y.isMessageOfType)(a,2)?(this.b=!0,w("received terminate message from renderer")):this.a.fire(a)})}send(a){this.b||s.send(a)}async drain(){if(s.drain)return s.drain()}}}function u(s){return new Promise(a=>{const n=s.onMessage(r=>{n.dispose();const f=JSON.parse(r.toString()),I=f.commit,R=S.default.commit;if(I&&R&&I!==R&&p(55),f.parentPid){let B=0;setInterval(function(){try{process.kill(f.parentPid,0),B=0}catch(q){q&&q.code==="EPERM"?(B++,B>=3&&w(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${q.message} (code: ${q.code}) (errno: ${q.errno})`)):w(`parent process ${f.parentPid} does not exist anymore: ${q.message} (code: ${q.code}) (errno: ${q.errno})`)}},1e3);let X;try{X=globalThis._VSCODE_NODE_MODULES["native-watchdog"],X.start(f.parentPid)}catch(q){(0,A.onUnexpectedError)(q)}}s.send((0,y.createMessageOfType)(0)),a({protocol:s,initData:f})});s.send((0,y.createMessageOfType)(1))})}async function l(){const s=[];process.on("unhandledRejection",(B,X)=>{s.push(X),setTimeout(()=>{const q=s.indexOf(X);q>=0&&X.catch(N=>{s.splice(q,1),(0,A.isCancellationError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),B&&(0,A.onUnexpectedError)(B))})},1e3)}),process.on("rejectionHandled",B=>{const X=s.indexOf(B);X>=0&&s.splice(X,1)}),process.on("uncaughtException",function(B){(0,A.onUnexpectedError)(B)}),k.mark("code/extHost/willConnectToRenderer");const a=await o();k.mark("code/extHost/didConnectToRenderer");const n=await u(a);k.mark("code/extHost/didWaitForInitData");const{initData:r}=n;g(!!r.environment.extensionTestsLocationURI),r.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,r.environment.skipWorkspaceStorageLock=(0,d.boolean)(b.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(X){p(X)}exists(X){return v.Promises.exists(X)}realpath(X){return(0,D.realpath)(X)}};let I=null;r.remote.authority&&b.transformURIs&&(I=(0,m.createURITransformer)(r.remote.authority));const R=new L.ExtensionHostMain(n.protocol,r,f,I);w=B=>R.terminate(B)}l().catch(s=>console.log(s))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c437ec2497ccd6b5ff5b2f6da86a8042e1ed951a/core/vs/workbench/api/node/extensionHostProcess.js.map
